/* DUPLICATOR MYSQL SCRIPT CREATED ON : 2017-06-15 12:07:53 */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `act_ab_appointments` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `series_id` int(10) unsigned DEFAULT NULL,
  `staff_id` int(10) unsigned NOT NULL,
  `service_id` int(10) unsigned DEFAULT NULL,
  `start_date` datetime NOT NULL,
  `end_date` datetime NOT NULL,
  `google_event_id` varchar(255) DEFAULT NULL,
  `extras_duration` int(11) NOT NULL DEFAULT '0',
  `internal_note` text,
  PRIMARY KEY (`id`),
  KEY `series_id` (`series_id`),
  KEY `staff_id` (`staff_id`),
  KEY `service_id` (`service_id`),
  CONSTRAINT `act_ab_appointments_ibfk_1` FOREIGN KEY (`series_id`) REFERENCES `act_ab_series` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_appointments_ibfk_2` FOREIGN KEY (`staff_id`) REFERENCES `act_ab_staff` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_appointments_ibfk_3` FOREIGN KEY (`service_id`) REFERENCES `act_ab_services` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_categories` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `position` int(11) NOT NULL DEFAULT '9999',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_coupon_services` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `coupon_id` int(10) unsigned NOT NULL,
  `service_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `service_id` (`service_id`),
  CONSTRAINT `act_ab_coupon_services_ibfk_1` FOREIGN KEY (`coupon_id`) REFERENCES `act_ab_coupons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_coupon_services_ibfk_2` FOREIGN KEY (`service_id`) REFERENCES `act_ab_services` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_coupons` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `code` varchar(255) NOT NULL DEFAULT '',
  `discount` decimal(3,0) NOT NULL DEFAULT '0',
  `deduction` decimal(10,2) NOT NULL DEFAULT '0.00',
  `usage_limit` int(10) unsigned NOT NULL DEFAULT '1',
  `used` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_customer_appointments` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `customer_id` int(10) unsigned NOT NULL,
  `appointment_id` int(10) unsigned NOT NULL,
  `location_id` int(10) unsigned DEFAULT NULL,
  `payment_id` int(10) unsigned DEFAULT NULL,
  `number_of_persons` int(10) unsigned NOT NULL DEFAULT '1',
  `extras` text,
  `custom_fields` text,
  `status` enum('pending','approved','cancelled','rejected') NOT NULL DEFAULT 'approved',
  `token` varchar(255) DEFAULT NULL,
  `time_zone_offset` int(11) DEFAULT NULL,
  `locale` varchar(8) DEFAULT NULL,
  `compound_service_id` int(10) unsigned DEFAULT NULL,
  `compound_token` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`),
  KEY `appointment_id` (`appointment_id`),
  KEY `payment_id` (`payment_id`),
  CONSTRAINT `act_ab_customer_appointments_ibfk_1` FOREIGN KEY (`customer_id`) REFERENCES `act_ab_customers` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_customer_appointments_ibfk_2` FOREIGN KEY (`appointment_id`) REFERENCES `act_ab_appointments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_customer_appointments_ibfk_3` FOREIGN KEY (`payment_id`) REFERENCES `act_ab_payments` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_customers` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `wp_user_id` bigint(20) unsigned DEFAULT NULL,
  `name` varchar(255) NOT NULL DEFAULT '',
  `phone` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `notes` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_holidays` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `staff_id` int(10) unsigned DEFAULT NULL,
  `parent_id` int(10) unsigned DEFAULT NULL,
  `date` date NOT NULL,
  `repeat_event` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `staff_id` (`staff_id`),
  CONSTRAINT `act_ab_holidays_ibfk_1` FOREIGN KEY (`staff_id`) REFERENCES `act_ab_staff` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_notifications` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `gateway` enum('email','sms') NOT NULL DEFAULT 'email',
  `type` varchar(255) NOT NULL DEFAULT '',
  `active` tinyint(1) NOT NULL DEFAULT '0',
  `copy` tinyint(1) NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_payments` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `created` datetime NOT NULL,
  `type` enum('local','coupon','paypal','authorize_net','stripe','2checkout','payu_latam','payson','mollie','woocommerce') NOT NULL DEFAULT 'local',
  `total` decimal(10,2) NOT NULL DEFAULT '0.00',
  `paid` decimal(10,2) NOT NULL DEFAULT '0.00',
  `status` enum('pending','completed') NOT NULL DEFAULT 'completed',
  `details` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_schedule_item_breaks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `staff_schedule_item_id` int(10) unsigned NOT NULL,
  `start_time` time DEFAULT NULL,
  `end_time` time DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `staff_schedule_item_id` (`staff_schedule_item_id`),
  CONSTRAINT `act_ab_schedule_item_breaks_ibfk_1` FOREIGN KEY (`staff_schedule_item_id`) REFERENCES `act_ab_staff_schedule_items` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_sent_notifications` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `customer_appointment_id` int(10) unsigned DEFAULT NULL,
  `staff_id` int(10) unsigned DEFAULT NULL,
  `gateway` enum('email','sms') NOT NULL DEFAULT 'email',
  `type` varchar(60) NOT NULL,
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_appointment_id` (`customer_appointment_id`),
  KEY `staff_id` (`staff_id`),
  CONSTRAINT `act_ab_sent_notifications_ibfk_1` FOREIGN KEY (`customer_appointment_id`) REFERENCES `act_ab_customer_appointments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_sent_notifications_ibfk_2` FOREIGN KEY (`staff_id`) REFERENCES `act_ab_staff` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_series` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `repeat` varchar(255) DEFAULT NULL,
  `token` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_services` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `category_id` int(10) unsigned DEFAULT NULL,
  `title` varchar(255) DEFAULT '',
  `duration` int(11) NOT NULL DEFAULT '900',
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `color` varchar(255) NOT NULL DEFAULT '#FFFFFF',
  `capacity` int(11) NOT NULL DEFAULT '1',
  `padding_left` int(11) NOT NULL DEFAULT '0',
  `padding_right` int(11) NOT NULL DEFAULT '0',
  `info` text,
  `type` enum('simple','compound') NOT NULL DEFAULT 'simple',
  `sub_services` text NOT NULL,
  `start_time` time DEFAULT NULL,
  `end_time` time DEFAULT NULL,
  `visibility` enum('public','private') NOT NULL DEFAULT 'public',
  `position` int(11) NOT NULL DEFAULT '9999',
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`),
  CONSTRAINT `act_ab_services_ibfk_1` FOREIGN KEY (`category_id`) REFERENCES `act_ab_categories` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_staff` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `wp_user_id` bigint(20) unsigned DEFAULT NULL,
  `attachment_id` int(10) unsigned DEFAULT NULL,
  `full_name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phone` varchar(255) DEFAULT NULL,
  `info` text,
  `google_data` text,
  `google_calendar_id` varchar(255) DEFAULT NULL,
  `visibility` enum('public','private') NOT NULL DEFAULT 'public',
  `position` int(11) NOT NULL DEFAULT '9999',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_staff_schedule_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `staff_id` int(10) unsigned NOT NULL,
  `day_index` int(10) unsigned NOT NULL,
  `start_time` time DEFAULT NULL,
  `end_time` time DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_ids_idx` (`staff_id`,`day_index`),
  CONSTRAINT `act_ab_staff_schedule_items_ibfk_1` FOREIGN KEY (`staff_id`) REFERENCES `act_ab_staff` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

CREATE TABLE `act_ab_staff_services` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `staff_id` int(10) unsigned NOT NULL,
  `service_id` int(10) unsigned NOT NULL,
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `deposit` varchar(100) NOT NULL DEFAULT '100%',
  `capacity` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_ids_idx` (`staff_id`,`service_id`),
  KEY `service_id` (`service_id`),
  CONSTRAINT `act_ab_staff_services_ibfk_1` FOREIGN KEY (`staff_id`) REFERENCES `act_ab_staff` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `act_ab_staff_services_ibfk_2` FOREIGN KEY (`service_id`) REFERENCES `act_ab_services` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_appearence` (
  `id` bigint(11) NOT NULL AUTO_INCREMENT,
  `ap_bg_color` varchar(10) NOT NULL,
  `ap_progress_bar` varchar(10) NOT NULL,
  `ap_show_logo` varchar(10) NOT NULL,
  `ap_logo` text NOT NULL,
  `ap_logo_width` varchar(5) NOT NULL,
  `ap_logo_height` varchar(5) NOT NULL,
  `ap_show_phone_no` varchar(30) NOT NULL,
  `ap_phone_no` varchar(30) NOT NULL,
  `ap_phone_icon` varchar(100) NOT NULL,
  `ap_show_email` varchar(100) NOT NULL,
  `ap_email` varchar(100) NOT NULL,
  `ap_email_icon` varchar(100) NOT NULL,
  `ap_social_link1` varchar(100) NOT NULL,
  `ap_social_link2` varchar(100) NOT NULL,
  `ap_social_link3` varchar(100) NOT NULL,
  `ap_social_link4` varchar(100) NOT NULL,
  `ap_social_link5` varchar(100) NOT NULL,
  `ap_social_icon1` varchar(100) NOT NULL,
  `ap_social_icon2` varchar(100) NOT NULL,
  `ap_social_icon3` varchar(100) NOT NULL,
  `ap_social_icon4` varchar(100) NOT NULL,
  `ap_social_icon5` varchar(100) NOT NULL,
  `service_navigation_text` varchar(100) NOT NULL,
  `time_navigation_text_backward` varchar(100) NOT NULL,
  `time_navigation_text_forward` varchar(100) NOT NULL,
  `details_navigation_text_backward` varchar(100) NOT NULL,
  `details_navigation_text_forward` varchar(100) NOT NULL,
  `confirm_navigation_text_backward` varchar(100) NOT NULL,
  `confirm_navigation_text_forward` varchar(100) NOT NULL,
  `payment_navigation_text_forward` varchar(100) NOT NULL,
  `done_page_icon` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_appointments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `client_name` varchar(500) NOT NULL,
  `staff_member` varchar(500) NOT NULL,
  `service_type` varchar(500) NOT NULL,
  `contact` varchar(500) NOT NULL,
  `booking_date` varchar(100) NOT NULL,
  `start_time` varchar(100) NOT NULL,
  `end_time` varchar(100) NOT NULL,
  `status` varchar(100) NOT NULL,
  `payment_status` varchar(100) NOT NULL,
  `client_email` varchar(100) NOT NULL,
  `staff_email` varchar(100) NOT NULL,
  `appt_unique_id` varchar(100) NOT NULL,
  `repeat_appointment` varchar(100) NOT NULL,
  `re_days` varchar(100) NOT NULL,
  `re_weeks` varchar(100) NOT NULL,
  `re_months` varchar(100) NOT NULL,
  `re_start_date` varchar(100) NOT NULL,
  `re_end_date` varchar(100) NOT NULL,
  `appt_booked_by` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `icon` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `first_name` varchar(100) NOT NULL,
  `last_name` varchar(100) NOT NULL,
  `phone` varchar(30) NOT NULL,
  `skype_id` varchar(30) NOT NULL,
  `email` varchar(100) NOT NULL,
  `notes` varchar(3000) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_coupons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `coupon_code` varchar(100) NOT NULL,
  `service_name` varchar(500) NOT NULL,
  `time_limit` varchar(100) NOT NULL,
  `per_user_limit` varchar(30) NOT NULL,
  `discount_type` varchar(100) NOT NULL,
  `discount_method` varchar(100) NOT NULL,
  `coupon_start_date` varchar(30) NOT NULL,
  `coupon_end_date` varchar(30) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_holidays` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `all_off` varchar(30) NOT NULL,
  `name` varchar(100) NOT NULL,
  `start_time` varchar(100) NOT NULL,
  `end_time` varchar(100) NOT NULL,
  `holiday_date` varchar(100) NOT NULL,
  `repeat_value` varchar(100) NOT NULL,
  `repeat_days` varchar(100) NOT NULL,
  `repeat_weeks` varchar(100) NOT NULL,
  `repeat_bi_weeks` varchar(100) NOT NULL,
  `repeat_month` varchar(100) NOT NULL,
  `start_date` varchar(100) NOT NULL,
  `end_date` varchar(100) NOT NULL,
  `notes` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_payment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `payment_type` varchar(1000) NOT NULL,
  `customer` varchar(500) NOT NULL,
  `customer_email` varchar(1000) NOT NULL,
  `staff` varchar(1000) NOT NULL,
  `appointment_date` varchar(1000) NOT NULL,
  `service` varchar(1000) NOT NULL,
  `coupon_code_applied` varchar(1000) NOT NULL,
  `amount_after_discount` varchar(1000) NOT NULL,
  `amount` varchar(1000) NOT NULL,
  `status` varchar(1000) NOT NULL,
  `appt_unique_id` varchar(1000) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_services` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `icon` varchar(100) NOT NULL,
  `color` varchar(100) NOT NULL,
  `duration` varchar(100) NOT NULL,
  `p_before` varchar(100) NOT NULL,
  `p_after` varchar(100) NOT NULL,
  `service_type` varchar(100) NOT NULL,
  `price` varchar(100) NOT NULL,
  `capacity` varchar(100) NOT NULL,
  `category` varchar(100) NOT NULL,
  `info_message` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_settings` (
  `id` int(11) NOT NULL,
  `time_zone` varchar(300) NOT NULL,
  `currency` varchar(30) NOT NULL,
  `ap_theme_color` varchar(30) NOT NULL,
  `time_slots` varchar(30) NOT NULL,
  `custom_slot` varchar(30) NOT NULL,
  `service_duration_type` varchar(30) NOT NULL,
  `appt_status` varchar(30) NOT NULL,
  `ap_mintime` varchar(30) NOT NULL,
  `b_name` varchar(30) NOT NULL,
  `b_owner` varchar(30) NOT NULL,
  `b_phone` varchar(30) NOT NULL,
  `b_fax` varchar(30) NOT NULL,
  `b_email` varchar(30) NOT NULL,
  `b_blog_url` varchar(30) NOT NULL,
  `b_postal_code` varchar(30) NOT NULL,
  `b_address` varchar(30) NOT NULL,
  `b_website` varchar(30) NOT NULL,
  `bh_sunday` varchar(1000) NOT NULL,
  `bh_monday` varchar(1000) NOT NULL,
  `bh_tuesday` varchar(1000) NOT NULL,
  `bh_wednesday` varchar(1000) NOT NULL,
  `bh_thursday` varchar(1000) NOT NULL,
  `bh_friday` varchar(1000) NOT NULL,
  `bh_saturday` varchar(1000) NOT NULL,
  `staff_weekly_off` varchar(1000) NOT NULL,
  `payment_currency` varchar(30) NOT NULL,
  `checkout` varchar(30) NOT NULL,
  `api_username` varchar(30) NOT NULL,
  `api_password` varchar(30) NOT NULL,
  `api_signature` varchar(30) NOT NULL,
  `checkout_sandbox_mode` varchar(30) NOT NULL,
  `paypal_checkout` varchar(30) NOT NULL,
  `paypal_email` varchar(30) NOT NULL,
  `payment_mode` varchar(30) NOT NULL,
  `cal_theme_style` varchar(100) NOT NULL,
  `cal_date_format` varchar(30) NOT NULL,
  `cal_time_format` varchar(30) NOT NULL,
  `cal_view` varchar(30) NOT NULL,
  `cal_first_day` varchar(30) NOT NULL,
  `cal_pending_color` varchar(30) NOT NULL,
  `cal_approved_color` varchar(30) NOT NULL,
  `cal_cancelled_color` varchar(30) NOT NULL,
  `cal_completed_color` varchar(30) NOT NULL,
  `cal_off_time_color` varchar(30) NOT NULL,
  `cal_font_style` varchar(30) NOT NULL,
  `advance_booking_time` varchar(30) NOT NULL,
  `advance_cancel_time` varchar(30) NOT NULL,
  `reminder_time` varchar(30) NOT NULL,
  `subject_reminder` varchar(500) NOT NULL,
  `body_reminder` varchar(1000) NOT NULL,
  `staff_service` varchar(500) NOT NULL,
  `staff_id` varchar(500) NOT NULL,
  `staff_date` varchar(500) NOT NULL,
  `custom_css` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_apt_staff` (
  `id` int(30) NOT NULL AUTO_INCREMENT,
  `staff_member_name` varchar(500) NOT NULL,
  `staff_icon` varchar(100) NOT NULL,
  `staff_member_image` varchar(1000) NOT NULL,
  `staff_email` varchar(50) NOT NULL,
  `staff_skype_id` varchar(50) NOT NULL,
  `staff_contact` varchar(50) NOT NULL,
  `staff_info` varchar(500) NOT NULL,
  `staff_services` varchar(5000) NOT NULL,
  `staff_service_category` varchar(1000) NOT NULL,
  `schedule_sunday` varchar(1000) NOT NULL,
  `schedule_monday` varchar(1000) NOT NULL,
  `schedule_tuesday` varchar(1000) NOT NULL,
  `schedule_wednesday` varchar(1000) NOT NULL,
  `schedule_thursday` varchar(1000) NOT NULL,
  `schedule_friday` varchar(1000) NOT NULL,
  `schedule_saturday` varchar(1000) NOT NULL,
  `sun_all_off` varchar(100) NOT NULL,
  `mon_all_off` varchar(100) NOT NULL,
  `tue_all_off` varchar(100) NOT NULL,
  `wed_all_off` varchar(100) NOT NULL,
  `thu_all_off` varchar(100) NOT NULL,
  `fri_all_off` varchar(100) NOT NULL,
  `sat_all_off` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `act_booking` (
  `booking_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `trash` bigint(10) NOT NULL DEFAULT '0',
  `sync_gid` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `is_new` bigint(10) NOT NULL DEFAULT '1',
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `sort_date` datetime DEFAULT NULL,
  `modification_date` datetime DEFAULT NULL,
  `form` text COLLATE utf8mb4_unicode_520_ci,
  `booking_type` bigint(10) NOT NULL DEFAULT '1',
  PRIMARY KEY (`booking_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_bookingdates` (
  `booking_id` bigint(20) unsigned NOT NULL,
  `booking_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `approved` bigint(20) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `booking_id_dates` (`booking_id`,`booking_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

CREATE TABLE `act_ea_error_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `error_type` varchar(50) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `errors` text COLLATE utf8mb4_unicode_520_ci,
  `errors_data` text COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_itsec_lockouts` (
  `lockout_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `lockout_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `lockout_start` datetime NOT NULL,
  `lockout_start_gmt` datetime NOT NULL,
  `lockout_expire` datetime NOT NULL,
  `lockout_expire_gmt` datetime NOT NULL,
  `lockout_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_user` bigint(20) unsigned DEFAULT NULL,
  `lockout_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_active` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`lockout_id`),
  KEY `lockout_expire_gmt` (`lockout_expire_gmt`),
  KEY `lockout_host` (`lockout_host`),
  KEY `lockout_user` (`lockout_user`),
  KEY `lockout_username` (`lockout_username`),
  KEY `lockout_active` (`lockout_active`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_itsec_log` (
  `log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `log_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `log_function` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `log_priority` int(2) NOT NULL DEFAULT '1',
  `log_date` datetime NOT NULL DEFAULT '1000-01-01 00:00:00',
  `log_date_gmt` datetime NOT NULL DEFAULT '1000-01-01 00:00:00',
  `log_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `log_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `log_user` bigint(20) unsigned DEFAULT NULL,
  `log_url` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `log_referrer` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `log_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`log_id`),
  KEY `log_type` (`log_type`),
  KEY `log_date_gmt` (`log_date_gmt`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_itsec_temp` (
  `temp_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `temp_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `temp_date` datetime NOT NULL,
  `temp_date_gmt` datetime NOT NULL,
  `temp_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `temp_user` bigint(20) unsigned DEFAULT NULL,
  `temp_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`temp_id`),
  KEY `temp_date_gmt` (`temp_date_gmt`),
  KEY `temp_host` (`temp_host`),
  KEY `temp_user` (`temp_user`),
  KEY `temp_username` (`temp_username`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_m_communications` (
  `id` bigint(11) NOT NULL AUTO_INCREMENT,
  `subject` varchar(250) DEFAULT NULL,
  `message` text,
  `periodunit` int(11) DEFAULT NULL,
  `periodtype` varchar(5) DEFAULT NULL,
  `periodprepost` varchar(5) DEFAULT NULL,
  `lastupdated` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  `active` int(11) DEFAULT '0',
  `periodstamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_coupons` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `site_id` bigint(20) DEFAULT '0',
  `couponcode` varchar(250) DEFAULT NULL,
  `discount` decimal(11,2) DEFAULT '0.00',
  `discount_type` varchar(5) DEFAULT NULL,
  `discount_currency` varchar(5) DEFAULT NULL,
  `coupon_startdate` datetime DEFAULT NULL,
  `coupon_enddate` datetime DEFAULT NULL,
  `coupon_sub_id` bigint(20) DEFAULT '0',
  `coupon_uses` int(11) DEFAULT '0',
  `coupon_used` int(11) DEFAULT '0',
  `coupon_apply_to` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `couponcode` (`couponcode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_levelmeta` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `level_id` bigint(20) DEFAULT NULL,
  `meta_key` varchar(250) DEFAULT NULL,
  `meta_value` text,
  `meta_stamp` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `level_id` (`level_id`,`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_member_payments` (
  `id` bigint(11) NOT NULL AUTO_INCREMENT,
  `member_id` bigint(20) DEFAULT NULL,
  `sub_id` bigint(20) DEFAULT NULL,
  `level_id` bigint(20) DEFAULT NULL,
  `level_order` int(11) DEFAULT NULL,
  `paymentmade` datetime DEFAULT NULL,
  `paymentexpires` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_membership_levels` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `level_title` varchar(250) DEFAULT NULL,
  `level_slug` varchar(250) DEFAULT NULL,
  `level_active` int(11) DEFAULT '0',
  `level_count` bigint(20) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_membership_news` (
  `id` bigint(11) NOT NULL AUTO_INCREMENT,
  `newsitem` text,
  `newsdate` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_membership_relationships` (
  `rel_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) DEFAULT '0',
  `sub_id` bigint(20) DEFAULT '0',
  `level_id` bigint(20) DEFAULT '0',
  `startdate` datetime DEFAULT NULL,
  `updateddate` datetime DEFAULT NULL,
  `expirydate` datetime DEFAULT NULL,
  `order_instance` bigint(20) DEFAULT '0',
  `usinggateway` varchar(50) DEFAULT 'admin',
  PRIMARY KEY (`rel_id`),
  KEY `user_id` (`user_id`),
  KEY `sub_id` (`sub_id`),
  KEY `usinggateway` (`usinggateway`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_membership_rules` (
  `level_id` bigint(20) NOT NULL DEFAULT '0',
  `rule_ive` varchar(20) NOT NULL DEFAULT '',
  `rule_area` varchar(20) NOT NULL DEFAULT '',
  `rule_value` text,
  `rule_order` int(11) DEFAULT '0',
  PRIMARY KEY (`level_id`,`rule_ive`,`rule_area`),
  KEY `rule_area` (`rule_area`),
  KEY `rule_ive` (`rule_ive`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_ping_history` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `ping_id` bigint(20) DEFAULT NULL,
  `ping_sent` timestamp NULL DEFAULT NULL,
  `ping_info` text,
  `ping_return` text,
  PRIMARY KEY (`id`),
  KEY `ping_id` (`ping_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_pings` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `pingname` varchar(250) DEFAULT NULL,
  `pingurl` varchar(250) DEFAULT NULL,
  `pinginfo` text,
  `pingtype` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_subscription_transaction` (
  `transaction_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `transaction_subscription_ID` bigint(20) NOT NULL DEFAULT '0',
  `transaction_user_ID` bigint(20) NOT NULL DEFAULT '0',
  `transaction_sub_ID` bigint(20) DEFAULT '0',
  `transaction_paypal_ID` varchar(30) DEFAULT NULL,
  `transaction_payment_type` varchar(20) DEFAULT NULL,
  `transaction_stamp` bigint(35) NOT NULL DEFAULT '0',
  `transaction_total_amount` bigint(20) DEFAULT NULL,
  `transaction_currency` varchar(35) DEFAULT NULL,
  `transaction_status` varchar(35) DEFAULT NULL,
  `transaction_duedate` date DEFAULT NULL,
  `transaction_gateway` varchar(50) DEFAULT NULL,
  `transaction_note` text,
  `transaction_expires` datetime DEFAULT NULL,
  PRIMARY KEY (`transaction_ID`),
  KEY `transaction_gateway` (`transaction_gateway`),
  KEY `transaction_subscription_ID` (`transaction_subscription_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_subscriptionmeta` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `sub_id` bigint(20) DEFAULT NULL,
  `meta_key` varchar(250) DEFAULT NULL,
  `meta_value` text,
  `meta_stamp` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `sub_id` (`sub_id`,`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_subscriptions` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `sub_name` varchar(200) DEFAULT NULL,
  `sub_active` int(11) DEFAULT '0',
  `sub_public` int(11) DEFAULT '0',
  `sub_count` bigint(20) DEFAULT '0',
  `sub_description` text,
  `sub_pricetext` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_subscriptions_levels` (
  `sub_id` bigint(20) DEFAULT NULL,
  `level_id` bigint(20) DEFAULT NULL,
  `level_period` int(11) DEFAULT NULL,
  `sub_type` varchar(20) DEFAULT NULL,
  `level_price` decimal(11,2) DEFAULT '0.00',
  `level_currency` varchar(5) DEFAULT NULL,
  `level_order` bigint(20) DEFAULT '0',
  `level_period_unit` varchar(1) DEFAULT 'd',
  KEY `sub_id` (`sub_id`),
  KEY `level_id` (`level_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_m_urlgroups` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `groupname` varchar(250) DEFAULT NULL,
  `groupurls` text,
  `isregexp` int(11) DEFAULT '0',
  `stripquerystring` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_msbdt_booking` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `loc_id` int(10) unsigned NOT NULL,
  `pro_id` int(10) unsigned NOT NULL,
  `name` varchar(10) NOT NULL,
  `email` varchar(100) NOT NULL,
  `phone` varchar(10) NOT NULL,
  `date` date NOT NULL,
  `start_time` time NOT NULL,
  `end_time` time NOT NULL,
  `message` varchar(255) NOT NULL,
  `status` varchar(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `loc_id` (`loc_id`),
  KEY `pro_id` (`pro_id`),
  CONSTRAINT `act_msbdt_booking_ibfk_1` FOREIGN KEY (`loc_id`) REFERENCES `act_msbdt_location` (`loc_id`),
  CONSTRAINT `act_msbdt_booking_ibfk_2` FOREIGN KEY (`pro_id`) REFERENCES `act_msbdt_professional` (`pro_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_msbdt_location` (
  `loc_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `address` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `state` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `city` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `zip` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `status` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`loc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_msbdt_organization` (
  `org_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `contact_no` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `website` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`org_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_msbdt_professional` (
  `pro_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fname` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `lname` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `sex` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `contact_no` varchar(20) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `website` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `biographical_info` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `status` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`pro_id`),
  UNIQUE KEY `email` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_msbdt_template` (
  `temp_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `temp_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `template` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `status` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`temp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_msbdt_time_slote` (
  `slot_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `loc_id` int(10) unsigned NOT NULL,
  `pro_id` int(10) unsigned NOT NULL,
  `work_date` date NOT NULL,
  `start_time` time NOT NULL,
  `end_time` time NOT NULL,
  `int_val` int(10) NOT NULL,
  `status` varchar(10) NOT NULL,
  PRIMARY KEY (`slot_id`),
  KEY `loc_id` (`loc_id`),
  KEY `pro_id` (`pro_id`),
  CONSTRAINT `act_msbdt_time_slote_ibfk_1` FOREIGN KEY (`loc_id`) REFERENCES `act_msbdt_location` (`loc_id`),
  CONSTRAINT `act_msbdt_time_slote_ibfk_2` FOREIGN KEY (`pro_id`) REFERENCES `act_msbdt_professional` (`pro_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `act_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=2167 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_pms_member_subscriptions` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `subscription_plan_id` int(10) NOT NULL,
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `expiration_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `payment_profile_id` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `subscription_plan_id` (`subscription_plan_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_pms_payments` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `subscription_plan_id` bigint(20) NOT NULL,
  `status` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `amount` float NOT NULL,
  `currency` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `type` varchar(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `transaction_id` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `profile_id` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `logs` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `ip_address` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `discount_code` varchar(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  UNIQUE KEY `id` (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=1603 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=515 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_rc_booking_meta` (
  `booking_meta_id` int(11) NOT NULL AUTO_INCREMENT,
  `booking_id` int(11) NOT NULL,
  `group` varchar(255) NOT NULL,
  `key` varchar(255) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`booking_meta_id`,`booking_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_bookings` (
  `booking_id` int(11) NOT NULL AUTO_INCREMENT,
  `customer_id` int(11) NOT NULL DEFAULT '0',
  `vehicle_id` int(11) NOT NULL,
  `currency_id` int(11) NOT NULL,
  `pickup_location` text NOT NULL,
  `return_location` text NOT NULL,
  `pickup_date` datetime DEFAULT NULL,
  `return_date` datetime DEFAULT NULL,
  `total` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `comment` text NOT NULL,
  `code` varchar(40) NOT NULL,
  `status` varchar(50) NOT NULL,
  `trash` int(1) NOT NULL DEFAULT '0',
  `date_modified` datetime DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`booking_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_currencies` (
  `currency_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL,
  `code` varchar(3) NOT NULL,
  `symbol_left` varchar(50) NOT NULL,
  `symbol_right` varchar(50) NOT NULL,
  `decimal_place` char(1) NOT NULL,
  `value` decimal(15,8) NOT NULL,
  `date_modified` datetime DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  `status` int(1) NOT NULL,
  `archive` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`currency_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_customer_meta` (
  `customer_meta_id` int(11) NOT NULL AUTO_INCREMENT,
  `customer_id` int(11) NOT NULL,
  `key` varchar(255) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`customer_id`,`customer_meta_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_customers` (
  `customer_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(10) NOT NULL,
  `firstname` varchar(30) NOT NULL,
  `lastname` varchar(30) NOT NULL,
  `dob` varchar(4) NOT NULL,
  `email` varchar(100) NOT NULL,
  `password` varchar(40) NOT NULL,
  `cart` text NOT NULL,
  `status` int(1) NOT NULL DEFAULT '0',
  `archive` int(1) NOT NULL DEFAULT '0',
  `date_modified` datetime DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`customer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_vehicle_meta` (
  `vehicle_meta_id` int(11) NOT NULL AUTO_INCREMENT,
  `vehicle_id` int(11) NOT NULL,
  `key` varchar(255) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`vehicle_meta_id`,`vehicle_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rc_vehicles` (
  `vehicle_id` int(11) NOT NULL AUTO_INCREMENT,
  `manufacturer` varchar(50) NOT NULL,
  `series` varchar(50) NOT NULL,
  `year` varchar(4) NOT NULL,
  `class` varchar(50) NOT NULL,
  `image` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `rent` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `quantity` int(4) NOT NULL DEFAULT '0',
  `status` int(1) NOT NULL DEFAULT '0',
  `archive` int(1) NOT NULL DEFAULT '0',
  `date_modified` datetime DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`vehicle_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `act_rcsm_subscribers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `f_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `l_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date` timestamp NULL DEFAULT NULL,
  `act_code` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `extra_detail` text COLLATE utf8mb4_unicode_520_ci,
  `flag` int(11) DEFAULT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_swpm_members_tbl` (
  `member_id` int(12) NOT NULL AUTO_INCREMENT,
  `user_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `first_name` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `last_name` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `member_since` date NOT NULL DEFAULT '0000-00-00',
  `membership_level` smallint(6) NOT NULL,
  `more_membership_levels` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `account_state` enum('active','inactive','expired','pending','unsubscribed') COLLATE utf8mb4_unicode_520_ci DEFAULT 'pending',
  `last_accessed` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_accessed_from_ip` varchar(128) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `email` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `phone` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `address_street` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `address_city` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `address_state` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `address_zipcode` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `home_page` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `country` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `gender` enum('male','female','not specified') COLLATE utf8mb4_unicode_520_ci DEFAULT 'not specified',
  `referrer` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `extra_info` text COLLATE utf8mb4_unicode_520_ci,
  `reg_code` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `subscription_starts` date DEFAULT NULL,
  `initial_membership_level` smallint(6) DEFAULT NULL,
  `txn_id` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `subscr_id` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `company_name` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `notes` text COLLATE utf8mb4_unicode_520_ci,
  `flags` int(11) DEFAULT '0',
  `profile_image` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  PRIMARY KEY (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_swpm_membership_meta_tbl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `level_id` int(11) NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `meta_label` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` text COLLATE utf8mb4_unicode_520_ci,
  `meta_type` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'text',
  `meta_default` text COLLATE utf8mb4_unicode_520_ci,
  `meta_context` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'default',
  PRIMARY KEY (`id`),
  KEY `level_id` (`level_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_swpm_membership_tbl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `alias` varchar(127) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `role` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'subscriber',
  `permissions` tinyint(4) NOT NULL DEFAULT '0',
  `subscription_period` varchar(11) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '-1',
  `subscription_duration_type` tinyint(4) NOT NULL DEFAULT '0',
  `subscription_unit` varchar(20) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `loginredirect_page` text COLLATE utf8mb4_unicode_520_ci,
  `category_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `page_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `post_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `comment_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `attachment_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `custom_post_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `disable_bookmark_list` longtext COLLATE utf8mb4_unicode_520_ci,
  `options` longtext COLLATE utf8mb4_unicode_520_ci,
  `protect_older_posts` tinyint(1) NOT NULL DEFAULT '0',
  `campaign_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_swpm_payments_tbl` (
  `id` int(12) NOT NULL AUTO_INCREMENT,
  `email` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `first_name` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `last_name` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `member_id` varchar(16) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `membership_level` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `txn_date` date NOT NULL DEFAULT '0000-00-00',
  `txn_id` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `subscr_id` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `reference` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `payment_amount` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `gateway` varchar(32) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `status` varchar(16) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  `ip_address` varchar(128) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=66 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `act_users_ultra_pm` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `parent` bigint(20) NOT NULL DEFAULT '-1',
  `subject` text NOT NULL,
  `content` text NOT NULL,
  `sender` int(11) NOT NULL,
  `recipient` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `readed` tinyint(1) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_ajaxrating_vote` (
  `ajaxrating_vote_id` int(11) NOT NULL AUTO_INCREMENT,
  `ajaxrating_vote_created_by` int(11) NOT NULL,
  `ajaxrating_photo_id` int(11) DEFAULT NULL,
  `ajaxrating_user_id` int(11) DEFAULT NULL,
  `ajaxrating_gallery_id` int(11) DEFAULT NULL,
  `ajaxrating_vote_ip` varchar(15) DEFAULT NULL,
  `ajaxrating_vote_score` int(11) DEFAULT NULL,
  `ajaxrating_vote_created_on` datetime DEFAULT NULL,
  `ajaxrating_vote_modified_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ajaxrating_vote_modified_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`ajaxrating_vote_id`),
  KEY `mt_ajaxrating_vote_ip` (`ajaxrating_vote_ip`),
  KEY `mt_ajaxrating_vote_blog_id` (`ajaxrating_photo_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_ajaxrating_votesummary` (
  `ajaxrating_votesummary_id` int(11) NOT NULL AUTO_INCREMENT,
  `ajaxrating_votesummary_avg_score` float DEFAULT NULL,
  `ajaxrating_votesummary_photo_id` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_user_id` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_gallery_id` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_total_score` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_vote_count` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_created_on` datetime DEFAULT NULL,
  `ajaxrating_votesummary_created_by` int(11) DEFAULT NULL,
  `ajaxrating_votesummary_modified_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ajaxrating_votesummary_modified_by` int(11) DEFAULT NULL,
  PRIMARY KEY (`ajaxrating_votesummary_id`),
  KEY `mt_ajaxrating_votesummary_vote_count` (`ajaxrating_votesummary_vote_count`),
  KEY `mt_ajaxrating_votesummary_total_score` (`ajaxrating_votesummary_total_score`),
  KEY `mt_ajaxrating_votesummary_avg_score` (`ajaxrating_votesummary_avg_score`),
  KEY `mt_ajaxrating_votesummary_blog_id` (`ajaxrating_votesummary_photo_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_friends` (
  `friend_id` int(11) NOT NULL AUTO_INCREMENT,
  `friend_receiver_id` int(11) NOT NULL,
  `friend_sender_user_id` int(11) NOT NULL,
  `friend_status` int(1) NOT NULL,
  `friend_date` datetime NOT NULL,
  PRIMARY KEY (`friend_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_galleries` (
  `gallery_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `gallery_user_id` int(11) NOT NULL,
  `gallery_name` varchar(60) NOT NULL,
  `gallery_order` int(11) NOT NULL,
  `gallery_private` int(1) NOT NULL,
  `gallery_only_friends` int(1) NOT NULL,
  `gallery_desc` text NOT NULL,
  PRIMARY KEY (`gallery_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_likes` (
  `like_id` int(11) NOT NULL AUTO_INCREMENT,
  `like_liked_id` int(11) NOT NULL,
  `like_liker_user_id` int(11) NOT NULL,
  `like_module` varchar(50) NOT NULL,
  `like_ip` varchar(100) NOT NULL,
  `like_vote` int(2) NOT NULL,
  `like_date` datetime NOT NULL,
  PRIMARY KEY (`like_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_orders` (
  `order_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `order_user_id` int(11) NOT NULL,
  `order_package_id` int(11) NOT NULL,
  `order_method_name` varchar(60) NOT NULL,
  `order_key` varchar(250) NOT NULL,
  `order_txt_id` varchar(60) NOT NULL,
  `order_status` varchar(60) NOT NULL,
  `order_amount` decimal(11,2) NOT NULL,
  `order_date` date NOT NULL,
  PRIMARY KEY (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_packages` (
  `package_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `package_name` text NOT NULL,
  `package_desc` text NOT NULL,
  `package_approvation` varchar(5) DEFAULT NULL,
  `package_limit_photos` int(11) DEFAULT NULL,
  `package_limit_galleries` int(11) DEFAULT NULL,
  `package_limit_posts` int(11) DEFAULT NULL,
  `package_customization` text NOT NULL,
  `package_type` varchar(60) NOT NULL,
  `package_number_of_times` varchar(60) NOT NULL,
  `package_time_period` varchar(60) NOT NULL,
  `package_amount` decimal(11,2) NOT NULL,
  PRIMARY KEY (`package_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_photo_cat_rel` (
  `photo_rel_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `photo_rel_cat_id` bigint(20) NOT NULL,
  `photo_rel_photo_id` bigint(20) NOT NULL,
  PRIMARY KEY (`photo_rel_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_photo_categories` (
  `photo_cat_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `photo_cat_name` varchar(100) NOT NULL,
  PRIMARY KEY (`photo_cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_photos` (
  `photo_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `photo_gal_id` bigint(20) NOT NULL,
  `photo_tags` varchar(200) DEFAULT NULL,
  `photo_name` varchar(200) NOT NULL,
  `photo_desc` varchar(200) DEFAULT NULL,
  `photo_mini` varchar(200) NOT NULL,
  `photo_thumb` varchar(200) NOT NULL,
  `photo_large` varchar(200) NOT NULL,
  `photo_main` int(1) NOT NULL,
  `photo_order` int(11) NOT NULL,
  PRIMARY KEY (`photo_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `act_usersultra_stats` (
  `stat_id` int(11) NOT NULL AUTO_INCREMENT,
  `stat_item_id` int(11) NOT NULL,
  `stat_module` varchar(100) NOT NULL,
  `stat_total_hits` int(11) NOT NULL,
  `stat_recent_visit` datetime NOT NULL,
  PRIMARY KEY (`stat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_stats_raw` (
  `stat_id` int(11) NOT NULL AUTO_INCREMENT,
  `stat_item_id` int(11) NOT NULL,
  `stat_module` varchar(100) NOT NULL,
  `stat_ip` varchar(250) NOT NULL,
  `stat_date` datetime NOT NULL,
  PRIMARY KEY (`stat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `act_usersultra_videos` (
  `video_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `video_user_id` bigint(20) NOT NULL,
  `video_name` varchar(200) NOT NULL,
  `video_type` varchar(50) NOT NULL,
  `video_unique_vid` varchar(50) NOT NULL,
  `video_order` int(11) NOT NULL,
  PRIMARY KEY (`video_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: act_ab_notifications */
INSERT INTO `act_ab_notifications` VALUES("1", "email", "client_pending_appointment", "0", "0", "Your appointment information", "<p>Dear {client_name}.</p>\n<p>This is a confirmation that you have booked {service_name}.</p>\n<p>We are waiting you at {company_address} on {appointment_date} at {appointment_time}.</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("2", "email", "client_pending_appointment_cart", "0", "0", "Your appointment information", "<p>Dear {client_name}.</p>\n<p>This is a confirmation that you have booked the following items:</p>\n<p>{cart_info}</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("3", "email", "staff_pending_appointment", "0", "0", "New booking information", "<p>Hello.</p>\n<p>You have new booking.</p>\n<p>Service: {service_name}<br />\nDate: {appointment_date}<br />\nTime: {appointment_time}<br />\nClient name: {client_name}<br />\nClient phone: {client_phone}<br />\nClient email: {client_email}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("4", "email", "client_approved_appointment", "0", "0", "Your appointment information", "<p>Dear {client_name}.</p>\n<p>This is a confirmation that you have booked {service_name}.</p>\n<p>We are waiting you at {company_address} on {appointment_date} at {appointment_time}.</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("5", "email", "client_approved_appointment_cart", "0", "0", "Your appointment information", "<p>Dear {client_name}.</p>\n<p>This is a confirmation that you have booked the following items:</p>\n<p>{cart_info}</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("6", "email", "staff_approved_appointment", "0", "0", "New booking information", "<p>Hello.</p>\n<p>You have new booking.</p>\n<p>Service: {service_name}<br />\nDate: {appointment_date}<br />\nTime: {appointment_time}<br />\nClient name: {client_name}<br />\nClient phone: {client_phone}<br />\nClient email: {client_email}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("7", "email", "client_cancelled_appointment", "0", "0", "Booking cancellation", "<p>Dear {client_name}.</p>\n<p>You have cancelled your booking of {service_name} on {appointment_date} at {appointment_time}.</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("8", "email", "staff_cancelled_appointment", "0", "0", "Booking cancellation", "<p>Hello.</p>\n<p>The following booking has been cancelled.</p>\n<p>Service: {service_name}<br />\nDate: {appointment_date}<br />\nTime: {appointment_time}<br />\nClient name: {client_name}<br />\nClient phone: {client_phone}<br />\nClient email: {client_email}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("9", "email", "client_rejected_appointment", "0", "0", "Booking rejection", "<p>Dear {client_name}.</p>\n<p>Your booking of {service_name} on {appointment_date} at {appointment_time} has been rejected.</p>\n<p>Reason: {cancellation_reason}</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("10", "email", "staff_rejected_appointment", "0", "0", "Booking rejection", "<p>Hello.</p>\n<p>The following booking has been rejected.</p>\n<p>Reason: {cancellation_reason}</p>\n<p>Service: {service_name}<br />\nDate: {appointment_date}<br />\nTime: {appointment_time}<br />\nClient name: {client_name}<br />\nClient phone: {client_phone}<br />\nClient email: {client_email}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("11", "email", "client_new_wp_user", "0", "0", "New customer", "<p>Hello.</p>\n<p>An account was created for you at {site_address}</p>\n<p>Your user details:<br />\nuser: {new_username}<br />\npassword: {new_password}</p>\n<p>Thanks.</p>\n");
INSERT INTO `act_ab_notifications` VALUES("12", "email", "client_reminder", "0", "0", "Your appointment at {company_name}", "<p>Dear {client_name}.</p>\n<p>We would like to remind you that you have booked {service_name} tomorrow on {appointment_time}. We are waiting you at {company_address}.</p>\n<p>Thank you for choosing our company.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("13", "email", "client_follow_up", "0", "0", "Your visit to {company_name}", "<p>Dear {client_name}.</p>\n<p>Thank you for choosing {company_name}. We hope you were satisfied with your {service_name}.</p>\n<p>Thank you and we look forward to seeing you again soon.</p>\n<p>{company_name}<br />\n{company_phone}<br />\n{company_website}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("14", "email", "staff_agenda", "0", "0", "Your agenda for {tomorrow_date}", "<p>Hello.</p>\n<p>Your agenda for tomorrow is:</p>\n<p>{next_day_agenda}</p>\n");
INSERT INTO `act_ab_notifications` VALUES("15", "sms", "client_pending_appointment", "1", "0", "", "Dear {client_name}.\nThis is a confirmation that you have booked {service_name}.\nWe are waiting you at {company_address} on {appointment_date} at {appointment_time}.\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("16", "sms", "client_pending_appointment_cart", "1", "0", "", "Dear {client_name}.\nThis is a confirmation that you have booked the following items:\n{cart_info}\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("17", "sms", "staff_pending_appointment", "1", "0", "", "Hello.\nYou have new booking.\nService: {service_name}\nDate: {appointment_date}\nTime: {appointment_time}\nClient name: {client_name}\nClient phone: {client_phone}\nClient email: {client_email}");
INSERT INTO `act_ab_notifications` VALUES("18", "sms", "client_approved_appointment", "1", "0", "", "Dear {client_name}.\nThis is a confirmation that you have booked {service_name}.\nWe are waiting you at {company_address} on {appointment_date} at {appointment_time}.\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("19", "sms", "client_approved_appointment_cart", "1", "0", "", "Dear {client_name}.\nThis is a confirmation that you have booked the following items:\n{cart_info}\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("20", "sms", "staff_approved_appointment", "1", "0", "", "Hello.\nYou have new booking.\nService: {service_name}\nDate: {appointment_date}\nTime: {appointment_time}\nClient name: {client_name}\nClient phone: {client_phone}\nClient email: {client_email}");
INSERT INTO `act_ab_notifications` VALUES("21", "sms", "client_cancelled_appointment", "1", "0", "", "Dear {client_name}.\nYou have cancelled your booking of {service_name} on {appointment_date} at {appointment_time}.\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("22", "sms", "staff_cancelled_appointment", "1", "0", "", "Hello.\nThe following booking has been cancelled.\nService: {service_name}\nDate: {appointment_date}\nTime: {appointment_time}\nClient name: {client_name}\nClient phone: {client_phone}\nClient email: {client_email}");
INSERT INTO `act_ab_notifications` VALUES("23", "sms", "client_rejected_appointment", "1", "0", "", "Dear {client_name}.\nYour booking of {service_name} on {appointment_date} at {appointment_time} has been rejected.\nReason: {cancellation_reason}\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("24", "sms", "staff_rejected_appointment", "1", "0", "", "Hello.\nThe following booking has been rejected.\nReason: {cancellation_reason}\nService: {service_name}\nDate: {appointment_date}\nTime: {appointment_time}\nClient name: {client_name}\nClient phone: {client_phone}\nClient email: {client_email}");
INSERT INTO `act_ab_notifications` VALUES("25", "sms", "client_new_wp_user", "1", "0", "", "Hello.\nAn account was created for you at {site_address}\nYour user details:\nuser: {new_username}\npassword: {new_password}\n\nThanks.");
INSERT INTO `act_ab_notifications` VALUES("26", "sms", "client_reminder", "0", "0", "", "Dear {client_name}.\nWe would like to remind you that you have booked {service_name} tomorrow on {appointment_time}. We are waiting you at {company_address}.\nThank you for choosing our company.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("27", "sms", "client_follow_up", "0", "0", "", "Dear {client_name}.\nThank you for choosing {company_name}. We hope you were satisfied with your {service_name}.\nThank you and we look forward to seeing you again soon.\n{company_name}\n{company_phone}\n{company_website}");
INSERT INTO `act_ab_notifications` VALUES("28", "sms", "staff_agenda", "0", "0", "", "Hello.\nYour agenda for tomorrow is:\n{next_day_agenda}");

/* INSERT TABLE DATA: act_ab_staff */
INSERT INTO `act_ab_staff` VALUES("1", NULL, NULL, "Employee", NULL, NULL, NULL, NULL, NULL, "public", "9999");

/* INSERT TABLE DATA: act_ab_staff_schedule_items */
INSERT INTO `act_ab_staff_schedule_items` VALUES("1", "1", "1", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("2", "1", "2", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("3", "1", "3", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("4", "1", "4", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("5", "1", "5", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("6", "1", "6", "08:00:00", "18:00:00");
INSERT INTO `act_ab_staff_schedule_items` VALUES("7", "1", "7", "08:00:00", "18:00:00");

/* INSERT TABLE DATA: act_apt_appearence */
INSERT INTO `act_apt_appearence` VALUES("1", "#337ab7", "yes", "yes", "http://localhost/actfinal/wp-content/plugins/appointment-scheduler-weblizar/images/logo.png", "150", "150", "yes", "+1 1234567890", "fa fa-phone", "yes", "example@gmail.com", "fa fa-envelope", "http://facebook.com", "http://google.com", "http://twitter.com", "http://pinterest.com", "http://instagram.com", "fa fa-facebook", "fa fa-google-plus", "fa fa-twitter", "fa fa-pinterest", "fa fa-instagram", "Next", "Back", "Next", "Back", "Next", "Back", "Next", "Next", "fa fa-thumbs-up");

/* INSERT TABLE DATA: act_apt_category */
INSERT INTO `act_apt_category` VALUES("1", "Demo Category", "dashicons dashicons-category");

/* INSERT TABLE DATA: act_apt_services */
INSERT INTO `act_apt_services` VALUES("1", "Demo Service", "fa fa-adjust", "#dd9933", "30", "0", "0", "paid_service", "10.00", "0", "1", "It is demo category");

/* INSERT TABLE DATA: act_apt_settings */
INSERT INTO `act_apt_settings` VALUES("1", "", "USD", "#337ab7", "custom_slots", "5", "sd", "pending", "", "", "", "", "", "", "", "", "", "", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "a:1:{i:0;a:2:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";}}", "", "", "", "", "", "", "", "", "", "direct_paypal_mode", "theme_01", "d-m-Y", "H:i", "month", "0", "#e9cb31", "green", "red", "#337ab7", "#676778", "Arial black", "", "", "", "", "", "", "", "", "");

/* INSERT TABLE DATA: act_apt_staff */
INSERT INTO `act_apt_staff` VALUES("1", "Demo staff", "fa fa-briefcase", "", "xyz@mail.com", "123456789", "+1 9876543210", "This is Demo Staff", "1", "1", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "a:1:{i:0;a:4:{s:10:\"start_time\";s:5:\"10:00\";s:8:\"end_time\";s:5:\"18:00\";s:11:\"break_start\";s:5:\"14:30\";s:9:\"break_end\";s:5:\"15:00\";}}", "", "", "", "", "", "", "");

/* INSERT TABLE DATA: act_booking */
INSERT INTO `act_booking` VALUES("1", "0", "", "1", "", "2017-06-10 00:00:00", "2017-06-08 12:53:30", "text^name1^Jony~text^secondname1^Smith~text^email1^example-free@wpbookingcalendar.com~text^phone1^458-77-77~textarea^details1^Reserve a room with sea view", "1");
INSERT INTO `act_booking` VALUES("2", "0", "", "1", "", "2017-06-09 00:00:00", "2017-06-08 13:59:38", "text^name1^james~text^secondname1^kimani~email^email1^jemskimani@gmail.com~text^phone1^0729305333~textarea^details1^request cab", "1");

/* INSERT TABLE DATA: act_bookingdates */
INSERT INTO `act_bookingdates` VALUES("1", "2017-06-10 00:00:00", "0");
INSERT INTO `act_bookingdates` VALUES("1", "2017-06-11 00:00:00", "0");
INSERT INTO `act_bookingdates` VALUES("1", "2017-06-12 00:00:00", "0");
INSERT INTO `act_bookingdates` VALUES("2", "2017-06-09 00:00:00", "0");

/* INSERT TABLE DATA: act_comments */
INSERT INTO `act_comments` VALUES("1", "1", "A WordPress Commenter", "wapuu@wordpress.example", "https://wordpress.org/", "", "2017-05-30 21:16:38", "2017-05-30 21:16:38", "Hi, this is a comment.\nTo get started with moderating, editing, and deleting comments, please visit the Comments screen in the dashboard.\nCommenter avatars come from <a href=\"https://gravatar.com\">Gravatar</a>.", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: act_duplicator_packages */
INSERT INTO `act_duplicator_packages` VALUES("1", "20170615_absolutecomforttravel", "0e4efb581727db1b8530170615120712", "20", "2017-06-15 12:07:52", "actjennifer", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-06-15 12:07:12\";s:7:\"Version\";s:5:\"1.2.8\";s:9:\"VersionWP\";s:3:\"4.8\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";i:1;s:4:\"Name\";s:30:\"20170615_absolutecomforttravel\";s:4:\"Hash\";s:32:\"0e4efb581727db1b8530170615120712\";s:8:\"NameHash\";s:63:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:37:\"C:/wamp/www/actfinal/wp-snapshots/tmp\";s:8:\"StoreURL\";s:39:\"http://localhost/actfinal/wp-snapshots/\";s:8:\"ScanFile\";s:73:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";s:11:\"actjennifer\";s:7:\"Archive\";O:11:\"DUP_Archive\":14:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:75:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:20:\"C:/wamp/www/actfinal\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":6:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-06-15 12:07:12\";s:7:\"Version\";s:5:\"1.2.8\";s:9:\"VersionWP\";s:3:\"4.8\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:30:\"20170615_absolutecomforttravel\";s:4:\"Hash\";s:32:\"0e4efb581727db1b8530170615120712\";s:8:\"NameHash\";s:63:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:37:\"C:/wamp/www/actfinal/wp-snapshots/tmp\";s:8:\"StoreURL\";s:39:\"http://localhost/actfinal/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";s:77:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:53;}s:8:\"Database\";O:12:\"DUP_Database\":13:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:76:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}}s:9:\"Installer\";r:75;s:8:\"Database\";r:88;}");

/* INSERT TABLE DATA: act_itsec_log */
INSERT INTO `act_itsec_log` VALUES("1", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 12:58:09", "2017-06-13 08:58:09", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("2", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 12:58:52", "2017-06-13 08:58:52", "::1", "jennifer", "0", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("3", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 12:59:01", "2017-06-13 08:59:01", "::1", "jennifer", "0", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("4", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 13:00:18", "2017-06-13 09:00:18", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("5", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 13:00:33", "2017-06-13 09:00:33", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("6", "lockout", "Host or User Lockout", "10", "2017-06-13 13:00:33", "2017-06-13 09:00:33", "::1", "", "0", "", "", "a:1:{i:0;s:76:\"A whitelisted host has triggered a lockout condition but was not locked out.\";}");
INSERT INTO `act_itsec_log` VALUES("7", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 13:00:43", "2017-06-13 09:00:43", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("8", "lockout", "Host or User Lockout", "10", "2017-06-13 13:00:43", "2017-06-13 09:00:43", "::1", "", "0", "", "", "a:1:{i:0;s:76:\"A whitelisted host has triggered a lockout condition but was not locked out.\";}");
INSERT INTO `act_itsec_log` VALUES("9", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 13:01:03", "2017-06-13 09:01:03", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("10", "brute_force", "Invalid Login Attempt", "5", "2017-06-13 13:01:03", "2017-06-13 09:01:03", "::1", "actjennifer", "1", "", "", "a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}");
INSERT INTO `act_itsec_log` VALUES("11", "lockout", "Host or User Lockout", "10", "2017-06-13 13:01:03", "2017-06-13 09:01:03", "::1", "", "0", "", "", "a:1:{i:0;s:76:\"A whitelisted host has triggered a lockout condition but was not locked out.\";}");
INSERT INTO `act_itsec_log` VALUES("12", "lockout", "Host or User Lockout", "10", "2017-06-13 13:01:03", "2017-06-13 09:01:03", "::1", "", "0", "", "", "a:1:{i:0;s:76:\"A whitelisted host has triggered a lockout condition but was not locked out.\";}");

/* INSERT TABLE DATA: act_options */
INSERT INTO `act_options` VALUES("1", "siteurl", "http://localhost/actfinal", "yes");
INSERT INTO `act_options` VALUES("2", "home", "http://localhost/actfinal", "yes");
INSERT INTO `act_options` VALUES("3", "blogname", "Absolute Comfort Travel", "yes");
INSERT INTO `act_options` VALUES("4", "blogdescription", "Your Comfort is our pride!", "yes");
INSERT INTO `act_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `act_options` VALUES("6", "admin_email", "absolutecomfortkenya@gmail.com", "yes");
INSERT INTO `act_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `act_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `act_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `act_options` VALUES("10", "require_name_email", "", "yes");
INSERT INTO `act_options` VALUES("11", "comments_notify", "", "yes");
INSERT INTO `act_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `act_options` VALUES("13", "rss_use_excerpt", "1", "yes");
INSERT INTO `act_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `act_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `act_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `act_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `act_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `act_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `act_options` VALUES("20", "default_ping_status", "closed", "yes");
INSERT INTO `act_options` VALUES("21", "default_pingback_flag", "", "yes");
INSERT INTO `act_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `act_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `act_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `act_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `act_options` VALUES("26", "comment_moderation", "", "yes");
INSERT INTO `act_options` VALUES("27", "moderation_notify", "", "yes");
INSERT INTO `act_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `act_options` VALUES("29", "rewrite_rules", "a:288:{s:11:\"services/?$\";s:28:\"index.php?post_type=services\";s:41:\"services/feed/(feed|rdf|rss|rss2|atom)/?$\";s:45:\"index.php?post_type=services&feed=$matches[1]\";s:36:\"services/(feed|rdf|rss|rss2|atom)/?$\";s:45:\"index.php?post_type=services&feed=$matches[1]\";s:28:\"services/page/([0-9]{1,})/?$\";s:46:\"index.php?post_type=services&paged=$matches[1]\";s:12:\"employees/?$\";s:29:\"index.php?post_type=employees\";s:42:\"employees/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=employees&feed=$matches[1]\";s:37:\"employees/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=employees&feed=$matches[1]\";s:29:\"employees/page/([0-9]{1,})/?$\";s:47:\"index.php?post_type=employees&paged=$matches[1]\";s:15:\"testimonials/?$\";s:32:\"index.php?post_type=testimonials\";s:45:\"testimonials/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?post_type=testimonials&feed=$matches[1]\";s:40:\"testimonials/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?post_type=testimonials&feed=$matches[1]\";s:32:\"testimonials/page/([0-9]{1,})/?$\";s:50:\"index.php?post_type=testimonials&paged=$matches[1]\";s:10:\"clients/?$\";s:27:\"index.php?post_type=clients\";s:40:\"clients/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=clients&feed=$matches[1]\";s:35:\"clients/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=clients&feed=$matches[1]\";s:27:\"clients/page/([0-9]{1,})/?$\";s:45:\"index.php?post_type=clients&paged=$matches[1]\";s:11:\"projects/?$\";s:28:\"index.php?post_type=projects\";s:41:\"projects/feed/(feed|rdf|rss|rss2|atom)/?$\";s:45:\"index.php?post_type=projects&feed=$matches[1]\";s:36:\"projects/(feed|rdf|rss|rss2|atom)/?$\";s:45:\"index.php?post_type=projects&feed=$matches[1]\";s:28:\"projects/page/([0-9]{1,})/?$\";s:46:\"index.php?post_type=projects&paged=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:15:\"user/([^/]+)/?$\";s:47:\"index.php?page_id=468&um_user=$matches[1]&lang=\";s:17:\"account/([^/]+)?$\";s:46:\"index.php?page_id=478&um_tab=$matches[1]&lang=\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:32:\"category/(.+?)/um-api(/(.*))?/?$\";s:54:\"index.php?category_name=$matches[1]&um-api=$matches[3]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:29:\"tag/([^/]+)/um-api(/(.*))?/?$\";s:44:\"index.php?tag=$matches[1]&um-api=$matches[3]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:36:\"services/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:46:\"services/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:66:\"services/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:61:\"services/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:61:\"services/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:42:\"services/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:25:\"services/([^/]+)/embed/?$\";s:41:\"index.php?services=$matches[1]&embed=true\";s:29:\"services/([^/]+)/trackback/?$\";s:35:\"index.php?services=$matches[1]&tb=1\";s:49:\"services/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?services=$matches[1]&feed=$matches[2]\";s:44:\"services/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?services=$matches[1]&feed=$matches[2]\";s:37:\"services/([^/]+)/page/?([0-9]{1,})/?$\";s:48:\"index.php?services=$matches[1]&paged=$matches[2]\";s:44:\"services/([^/]+)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?services=$matches[1]&cpage=$matches[2]\";s:34:\"services/([^/]+)/um-api(/(.*))?/?$\";s:49:\"index.php?services=$matches[1]&um-api=$matches[3]\";s:40:\"services/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:51:\"services/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:33:\"services/([^/]+)(?:/([0-9]+))?/?$\";s:47:\"index.php?services=$matches[1]&page=$matches[2]\";s:25:\"services/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:35:\"services/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:55:\"services/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:50:\"services/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:50:\"services/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:31:\"services/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:37:\"employees/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:47:\"employees/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:67:\"employees/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"employees/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"employees/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:43:\"employees/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:26:\"employees/([^/]+)/embed/?$\";s:42:\"index.php?employees=$matches[1]&embed=true\";s:30:\"employees/([^/]+)/trackback/?$\";s:36:\"index.php?employees=$matches[1]&tb=1\";s:50:\"employees/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?employees=$matches[1]&feed=$matches[2]\";s:45:\"employees/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?employees=$matches[1]&feed=$matches[2]\";s:38:\"employees/([^/]+)/page/?([0-9]{1,})/?$\";s:49:\"index.php?employees=$matches[1]&paged=$matches[2]\";s:45:\"employees/([^/]+)/comment-page-([0-9]{1,})/?$\";s:49:\"index.php?employees=$matches[1]&cpage=$matches[2]\";s:35:\"employees/([^/]+)/um-api(/(.*))?/?$\";s:50:\"index.php?employees=$matches[1]&um-api=$matches[3]\";s:41:\"employees/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:52:\"employees/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:34:\"employees/([^/]+)(?:/([0-9]+))?/?$\";s:48:\"index.php?employees=$matches[1]&page=$matches[2]\";s:26:\"employees/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:36:\"employees/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:56:\"employees/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"employees/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"employees/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:32:\"employees/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:40:\"testimonials/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:50:\"testimonials/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:70:\"testimonials/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"testimonials/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"testimonials/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:46:\"testimonials/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:29:\"testimonials/([^/]+)/embed/?$\";s:45:\"index.php?testimonials=$matches[1]&embed=true\";s:33:\"testimonials/([^/]+)/trackback/?$\";s:39:\"index.php?testimonials=$matches[1]&tb=1\";s:53:\"testimonials/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:51:\"index.php?testimonials=$matches[1]&feed=$matches[2]\";s:48:\"testimonials/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:51:\"index.php?testimonials=$matches[1]&feed=$matches[2]\";s:41:\"testimonials/([^/]+)/page/?([0-9]{1,})/?$\";s:52:\"index.php?testimonials=$matches[1]&paged=$matches[2]\";s:48:\"testimonials/([^/]+)/comment-page-([0-9]{1,})/?$\";s:52:\"index.php?testimonials=$matches[1]&cpage=$matches[2]\";s:38:\"testimonials/([^/]+)/um-api(/(.*))?/?$\";s:53:\"index.php?testimonials=$matches[1]&um-api=$matches[3]\";s:44:\"testimonials/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:55:\"testimonials/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:37:\"testimonials/([^/]+)(?:/([0-9]+))?/?$\";s:51:\"index.php?testimonials=$matches[1]&page=$matches[2]\";s:29:\"testimonials/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:39:\"testimonials/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:59:\"testimonials/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"testimonials/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"testimonials/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:35:\"testimonials/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:35:\"clients/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"clients/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"clients/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"clients/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"clients/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"clients/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:24:\"clients/([^/]+)/embed/?$\";s:40:\"index.php?clients=$matches[1]&embed=true\";s:28:\"clients/([^/]+)/trackback/?$\";s:34:\"index.php?clients=$matches[1]&tb=1\";s:48:\"clients/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?clients=$matches[1]&feed=$matches[2]\";s:43:\"clients/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?clients=$matches[1]&feed=$matches[2]\";s:36:\"clients/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?clients=$matches[1]&paged=$matches[2]\";s:43:\"clients/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?clients=$matches[1]&cpage=$matches[2]\";s:33:\"clients/([^/]+)/um-api(/(.*))?/?$\";s:48:\"index.php?clients=$matches[1]&um-api=$matches[3]\";s:39:\"clients/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:50:\"clients/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:32:\"clients/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?clients=$matches[1]&page=$matches[2]\";s:24:\"clients/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"clients/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"clients/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"clients/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"clients/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:30:\"clients/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:36:\"projects/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:46:\"projects/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:66:\"projects/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:61:\"projects/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:61:\"projects/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:42:\"projects/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:25:\"projects/([^/]+)/embed/?$\";s:41:\"index.php?projects=$matches[1]&embed=true\";s:29:\"projects/([^/]+)/trackback/?$\";s:35:\"index.php?projects=$matches[1]&tb=1\";s:49:\"projects/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?projects=$matches[1]&feed=$matches[2]\";s:44:\"projects/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?projects=$matches[1]&feed=$matches[2]\";s:37:\"projects/([^/]+)/page/?([0-9]{1,})/?$\";s:48:\"index.php?projects=$matches[1]&paged=$matches[2]\";s:44:\"projects/([^/]+)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?projects=$matches[1]&cpage=$matches[2]\";s:34:\"projects/([^/]+)/um-api(/(.*))?/?$\";s:49:\"index.php?projects=$matches[1]&um-api=$matches[3]\";s:40:\"projects/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:51:\"projects/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:33:\"projects/([^/]+)(?:/([0-9]+))?/?$\";s:47:\"index.php?projects=$matches[1]&page=$matches[2]\";s:25:\"projects/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:35:\"projects/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:55:\"projects/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:50:\"projects/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:50:\"projects/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:31:\"projects/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:35:\"um_form/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"um_form/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"um_form/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"um_form/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"um_form/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"um_form/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:24:\"um_form/([^/]+)/embed/?$\";s:40:\"index.php?um_form=$matches[1]&embed=true\";s:28:\"um_form/([^/]+)/trackback/?$\";s:34:\"index.php?um_form=$matches[1]&tb=1\";s:36:\"um_form/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?um_form=$matches[1]&paged=$matches[2]\";s:43:\"um_form/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?um_form=$matches[1]&cpage=$matches[2]\";s:33:\"um_form/([^/]+)/um-api(/(.*))?/?$\";s:48:\"index.php?um_form=$matches[1]&um-api=$matches[3]\";s:39:\"um_form/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:50:\"um_form/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:32:\"um_form/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?um_form=$matches[1]&page=$matches[2]\";s:24:\"um_form/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"um_form/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"um_form/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"um_form/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"um_form/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:30:\"um_form/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:35:\"um_role/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"um_role/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"um_role/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"um_role/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"um_role/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"um_role/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:24:\"um_role/([^/]+)/embed/?$\";s:40:\"index.php?um_role=$matches[1]&embed=true\";s:28:\"um_role/([^/]+)/trackback/?$\";s:34:\"index.php?um_role=$matches[1]&tb=1\";s:36:\"um_role/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?um_role=$matches[1]&paged=$matches[2]\";s:43:\"um_role/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?um_role=$matches[1]&cpage=$matches[2]\";s:33:\"um_role/([^/]+)/um-api(/(.*))?/?$\";s:48:\"index.php?um_role=$matches[1]&um-api=$matches[3]\";s:39:\"um_role/[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:50:\"um_role/[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:32:\"um_role/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?um_role=$matches[1]&page=$matches[2]\";s:24:\"um_role/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"um_role/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"um_role/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"um_role/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"um_role/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:30:\"um_role/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:38:\"private-page/.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:48:\"private-page/.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:68:\"private-page/.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"private-page/.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"private-page/.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:44:\"private-page/.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:27:\"private-page/(.+?)/embed/?$\";s:45:\"index.php?private-page=$matches[1]&embed=true\";s:31:\"private-page/(.+?)/trackback/?$\";s:39:\"index.php?private-page=$matches[1]&tb=1\";s:39:\"private-page/(.+?)/page/?([0-9]{1,})/?$\";s:52:\"index.php?private-page=$matches[1]&paged=$matches[2]\";s:46:\"private-page/(.+?)/comment-page-([0-9]{1,})/?$\";s:52:\"index.php?private-page=$matches[1]&cpage=$matches[2]\";s:36:\"private-page/(.+?)/um-api(/(.*))?/?$\";s:53:\"index.php?private-page=$matches[1]&um-api=$matches[3]\";s:42:\"private-page/.+?/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:53:\"private-page/.+?/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:35:\"private-page/(.+?)(?:/([0-9]+))?/?$\";s:51:\"index.php?private-page=$matches[1]&page=$matches[2]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=5&cpage=$matches[1]\";s:17:\"um-api(/(.*))?/?$\";s:29:\"index.php?&um-api=$matches[2]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:26:\"comments/um-api(/(.*))?/?$\";s:29:\"index.php?&um-api=$matches[2]\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:29:\"search/(.+)/um-api(/(.*))?/?$\";s:42:\"index.php?s=$matches[1]&um-api=$matches[3]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:32:\"author/([^/]+)/um-api(/(.*))?/?$\";s:52:\"index.php?author_name=$matches[1]&um-api=$matches[3]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:54:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/um-api(/(.*))?/?$\";s:82:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&um-api=$matches[5]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:41:\"([0-9]{4})/([0-9]{1,2})/um-api(/(.*))?/?$\";s:66:\"index.php?year=$matches[1]&monthnum=$matches[2]&um-api=$matches[4]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:28:\"([0-9]{4})/um-api(/(.*))?/?$\";s:45:\"index.php?year=$matches[1]&um-api=$matches[3]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:25:\"(.?.+?)/um-api(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&um-api=$matches[3]\";s:31:\".?.+?/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:42:\".?.+?/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:25:\"([^/]+)/um-api(/(.*))?/?$\";s:45:\"index.php?name=$matches[1]&um-api=$matches[3]\";s:31:\"[^/]+/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:42:\"[^/]+/attachment/([^/]+)/um-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&um-api=$matches[3]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}", "yes");
INSERT INTO `act_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `act_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `act_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `act_options` VALUES("33", "active_plugins", "a:8:{i:1;s:25:\"duplicator/duplicator.php\";i:2;s:15:\"kirki/kirki.php\";i:3;s:47:\"really-simple-captcha/really-simple-captcha.php\";i:4;s:39:\"siteorigin-panels/siteorigin-panels.php\";i:5;s:39:\"so-widgets-bundle/so-widgets-bundle.php\";i:6;s:33:\"sydney-toolbox/sydney-toolbox.php\";i:7;s:49:\"widgets-for-siteorigin/widgets-for-siteorigin.php\";i:8;s:25:\"wp-members/wp-members.php\";}", "yes");
INSERT INTO `act_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `act_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `act_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `act_options` VALUES("37", "gmt_offset", "", "yes");
INSERT INTO `act_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `act_options` VALUES("39", "recently_edited", "a:2:{i:0;s:75:\"C:\\wamp\\www\\actfinal/wp-content/plugins/mini-membership/mini-membership.php\";i:2;s:0:\"\";}", "no");
INSERT INTO `act_options` VALUES("40", "template", "sydney", "yes");
INSERT INTO `act_options` VALUES("41", "stylesheet", "sydney-child", "yes");
INSERT INTO `act_options` VALUES("42", "comment_whitelist", "", "yes");
INSERT INTO `act_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `act_options` VALUES("44", "comment_registration", "1", "yes");
INSERT INTO `act_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `act_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `act_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `act_options` VALUES("48", "db_version", "38590", "yes");
INSERT INTO `act_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `act_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `act_options` VALUES("51", "blog_public", "1", "yes");
INSERT INTO `act_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `act_options` VALUES("53", "show_on_front", "page", "yes");
INSERT INTO `act_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `act_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `act_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `act_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `act_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `act_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `act_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `act_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `act_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `act_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `act_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `act_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `act_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `act_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `act_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `act_options` VALUES("69", "close_comments_for_old_posts", "", "yes");
INSERT INTO `act_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `act_options` VALUES("71", "thread_comments", "", "yes");
INSERT INTO `act_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `act_options` VALUES("73", "page_comments", "", "yes");
INSERT INTO `act_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `act_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `act_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `act_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `act_options` VALUES("78", "widget_categories", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("79", "widget_text", "a:4:{i:1;a:0:{}i:2;a:4:{s:5:\"title\";s:11:\"The Company\";s:4:\"text\";s:462:\"<strong>OUR MISSION</strong>\r\n\r\nTo create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\r\n\r\nTo add value by consistently providing reliable quality services to our customers\r\n\r\n<strong>OUR VISION</strong>\r\n\r\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:6:\"filter\";s:7:\"content\";s:19:\"eds_animation_class\";s:0:\"\";}i:3;a:4:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("81", "uninstall_plugins", "a:5:{s:51:\"bookly-responsive-appointment-booking-tool/main.php\";a:2:{i:0;s:21:\"BooklyLite\\Lib\\Plugin\";i:1;s:9:\"uninstall\";}s:41:\"better-wp-security/better-wp-security.php\";a:2:{i:0;s:10:\"ITSEC_Core\";i:1;s:16:\"handle_uninstall\";}s:50:\"google-analytics-for-wordpress/googleanalytics.php\";s:35:\"monsterinsights_lite_uninstall_hook\";s:21:\"s2member/s2member.php\";s:45:\"c_ws_plugin__s2member_installation::uninstall\";s:26:\"easy-appointments/main.php\";a:2:{i:0;s:15:\"EasyAppointment\";i:1;s:9:\"uninstall\";}}", "no");
INSERT INTO `act_options` VALUES("82", "timezone_string", "Europe/Moscow", "yes");
INSERT INTO `act_options` VALUES("83", "page_for_posts", "87", "yes");
INSERT INTO `act_options` VALUES("84", "page_on_front", "5", "yes");
INSERT INTO `act_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `act_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `act_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `act_options` VALUES("88", "site_icon", "174", "yes");
INSERT INTO `act_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `act_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `act_options` VALUES("91", "initial_db_version", "38590", "yes");
INSERT INTO `act_options` VALUES("92", "act_user_roles", "a:9:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:67:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:13:\"rc_management\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:39:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:15:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:10:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:3:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;s:22:\"access_s2member_level0\";b:1;}}s:15:\"s2member_level1\";a:2:{s:4:\"name\";s:16:\"s2Member Level 1\";s:12:\"capabilities\";a:4:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;}}s:15:\"s2member_level2\";a:2:{s:4:\"name\";s:16:\"s2Member Level 2\";s:12:\"capabilities\";a:5:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;}}s:15:\"s2member_level3\";a:2:{s:4:\"name\";s:16:\"s2Member Level 3\";s:12:\"capabilities\";a:6:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;}}s:15:\"s2member_level4\";a:2:{s:4:\"name\";s:16:\"s2Member Level 4\";s:12:\"capabilities\";a:7:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;}}}", "yes");
INSERT INTO `act_options` VALUES("93", "fresh_site", "0", "yes");
INSERT INTO `act_options` VALUES("94", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("95", "widget_recent-posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("96", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("97", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("98", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("99", "sidebars_widgets", "a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:15:\"sydney_action-2\";i:2;s:21:\"sydney_contact_info-2\";}s:8:\"footer-1\";a:1:{i:0;s:13:\"media_image-2\";}s:8:\"footer-2\";a:1:{i:0;s:6:\"text-2\";}s:8:\"footer-3\";a:2:{i:0;s:6:\"text-3\";i:1;s:21:\"sydney_contact_info-3\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `act_options` VALUES("100", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("101", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("102", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("103", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("104", "cron", "a:15:{i:1497528489;a:1:{s:26:\"um_hourly_scheduled_events\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1497531810;a:1:{s:40:\"membership_perform_cron_processes_hourly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1497531933;a:1:{s:30:\"ms_cron_process_communications\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1497533847;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"6bcc73c2be50b89b57ac9897a5ab00ff\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:514;}}}}i:1497561399;a:2:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1497561400;a:1:{s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1497561416;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497561851;a:1:{s:16:\"itsec_purge_logs\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497561894;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497562438;a:1:{s:20:\"itsec_purge_lockouts\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497568089;a:1:{s:30:\"um_twicedaily_scheduled_events\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1497571500;a:1:{s:26:\"monsterinsights_daily_cron\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497605581;a:2:{s:25:\"swpm_account_status_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:33:\"swpm_delete_pending_account_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1497611289;a:1:{s:25:\"um_daily_scheduled_events\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `act_options` VALUES("105", "nonce_key", "sqkb]E,:v,}wOq5X+|SZSbo`LMkGRUi_FTx_)&y4?WDlUZXwdVa2f:4ShMKM)tlE", "no");
INSERT INTO `act_options` VALUES("106", "nonce_salt", "hR9xEWdINgCsU%$mS>><.=X?t(:=ZCy_#/B9|0WwthT f>vAY?4RSO4lw_!Pzt/|", "no");
INSERT INTO `act_options` VALUES("107", "theme_mods_twentyseventeen", "a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496179642;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("116", "auth_key", "`,n%lvH1ab~U>Xi_z*C).8E{(Eg1-Uc*E|^=l:&+S*u!!$x<K@NpepU9x>(teva?", "no");
INSERT INTO `act_options` VALUES("117", "auth_salt", "JR4G9_iNhsEw!jVTtZ*)tF9hD`?[+RP8HF?!V0`-Ohn;lp.m)Im1{[)A>$M^>4qc", "no");
INSERT INTO `act_options` VALUES("118", "logged_in_key", "u8Df%NJ,;r^U$F{|y_YMq~X$JE@]r*DA)|kxA^846h!%FciVg/=eTIlHP~VEB6me", "no");
INSERT INTO `act_options` VALUES("119", "logged_in_salt", "@up7t}2T0HqC1&o. J_?7v4Vxv K]%Sx*N%bpIUMr>(%S/S)8v54stmxOYvQSk}Y", "no");
INSERT INTO `act_options` VALUES("124", "can_compress_scripts", "1", "no");
INSERT INTO `act_options` VALUES("127", "recently_activated", "a:24:{s:25:\"booking/wpdev-booking.php\";i:1497528414;s:26:\"easy-appointments/main.php\";i:1497526612;s:36:\"contact-form-7/wp-contact-form-7.php\";i:1497523977;s:35:\"paid-member-subscriptions/index.php\";i:1497519723;s:21:\"s2member/s2member.php\";i:1497518323;s:24:\"users-ultra/xoousers.php\";i:1497517890;s:35:\"mini-membership/mini-membership.php\";i:1497517272;s:42:\"mini-membership/mini-membership-widget.php\";i:1497517272;s:65:\"private-content-login-redirect/private-content-login-redirect.php\";i:1497517154;s:23:\"client-portal/index.php\";i:1497516029;s:25:\"ultimate-member/index.php\";i:1497512017;s:25:\"animate-it/edsanimate.php\";i:1497476123;s:50:\"google-analytics-for-wordpress/googleanalytics.php\";i:1497476085;s:24:\"wordpress-seo/wp-seo.php\";i:1497476065;s:48:\"codelights-shortcodes-and-widgets/codelights.php\";i:1497476046;s:41:\"better-wp-security/better-wp-security.php\";i:1497476029;s:43:\"portfolio-post-type/portfolio-post-type.php\";i:1497475995;s:57:\"one-page-express-companion/one-page-express-companion.php\";i:1497475948;s:41:\"admin-custom-login/admin-custom-login.php\";i:1497475911;s:18:\"sagenda/plugin.php\";i:1497475681;s:51:\"bookly-responsive-appointment-booking-tool/main.php\";i:1497339490;s:65:\"appointment-scheduler-weblizar/appointment-scheduler-weblizar.php\";i:1497006580;s:59:\"responsive-coming-soon-page/responsive-coming-soon-page.php\";i:1497002193;s:25:\"multi-scheduler/msbdt.php\";i:1496968900;}", "yes");
INSERT INTO `act_options` VALUES("135", "duplicator_settings", "a:11:{s:7:\"version\";s:5:\"1.2.8\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";s:1:\"1\";s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";s:1:\"0\";s:20:\"storage_htaccess_off\";b:0;s:18:\"package_ui_created\";s:1:\"9\";}", "yes");
INSERT INTO `act_options` VALUES("136", "duplicator_version_plugin", "1.2.8", "yes");
INSERT INTO `act_options` VALUES("139", "siteorigin_panels_initial_version", "2.4.25", "no");
INSERT INTO `act_options` VALUES("141", "wpseo", "a:24:{s:14:\"blocking_files\";a:0:{}s:15:\"ms_defaults_set\";b:0;s:7:\"version\";s:3:\"4.9\";s:12:\"company_logo\";s:0:\"\";s:12:\"company_name\";s:0:\"\";s:17:\"company_or_person\";s:0:\"\";s:20:\"disableadvanced_meta\";b:1;s:19:\"onpage_indexability\";b:1;s:12:\"googleverify\";s:0:\"\";s:8:\"msverify\";s:0:\"\";s:11:\"person_name\";s:0:\"\";s:12:\"website_name\";s:0:\"\";s:22:\"alternate_website_name\";s:0:\"\";s:12:\"yandexverify\";s:0:\"\";s:9:\"site_type\";s:0:\"\";s:20:\"has_multiple_authors\";b:0;s:16:\"environment_type\";s:0:\"\";s:23:\"content_analysis_active\";b:1;s:23:\"keyword_analysis_active\";b:1;s:20:\"enable_setting_pages\";b:0;s:21:\"enable_admin_bar_menu\";b:1;s:26:\"enable_cornerstone_content\";b:1;s:22:\"show_onboarding_notice\";b:1;s:18:\"first_activated_on\";i:1496179453;}", "yes");
INSERT INTO `act_options` VALUES("142", "wpseo_permalinks", "a:9:{s:15:\"cleanpermalinks\";b:0;s:24:\"cleanpermalink-extravars\";s:0:\"\";s:29:\"cleanpermalink-googlecampaign\";b:0;s:31:\"cleanpermalink-googlesitesearch\";b:0;s:15:\"cleanreplytocom\";b:0;s:10:\"cleanslugs\";b:1;s:18:\"redirectattachment\";b:0;s:17:\"stripcategorybase\";b:0;s:13:\"trailingslash\";b:0;}", "yes");
INSERT INTO `act_options` VALUES("143", "wpseo_titles", "a:54:{s:10:\"title_test\";i:0;s:17:\"forcerewritetitle\";b:0;s:9:\"separator\";s:7:\"sc-dash\";s:5:\"noodp\";b:0;s:15:\"usemetakeywords\";b:0;s:16:\"title-home-wpseo\";s:42:\"%%sitename%% %%page%% %%sep%% %%sitedesc%%\";s:18:\"title-author-wpseo\";s:41:\"%%name%%, Author at %%sitename%% %%page%%\";s:19:\"title-archive-wpseo\";s:38:\"%%date%% %%page%% %%sep%% %%sitename%%\";s:18:\"title-search-wpseo\";s:63:\"You searched for %%searchphrase%% %%page%% %%sep%% %%sitename%%\";s:15:\"title-404-wpseo\";s:35:\"Page not found %%sep%% %%sitename%%\";s:19:\"metadesc-home-wpseo\";s:0:\"\";s:21:\"metadesc-author-wpseo\";s:0:\"\";s:22:\"metadesc-archive-wpseo\";s:0:\"\";s:18:\"metakey-home-wpseo\";s:0:\"\";s:20:\"metakey-author-wpseo\";s:0:\"\";s:22:\"noindex-subpages-wpseo\";b:0;s:20:\"noindex-author-wpseo\";b:0;s:21:\"noindex-archive-wpseo\";b:1;s:14:\"disable-author\";b:0;s:12:\"disable-date\";b:0;s:19:\"disable-post_format\";b:0;s:10:\"title-post\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-post\";s:0:\"\";s:12:\"metakey-post\";s:0:\"\";s:12:\"noindex-post\";b:0;s:13:\"showdate-post\";b:0;s:16:\"hideeditbox-post\";b:0;s:10:\"title-page\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-page\";s:0:\"\";s:12:\"metakey-page\";s:0:\"\";s:12:\"noindex-page\";b:0;s:13:\"showdate-page\";b:0;s:16:\"hideeditbox-page\";b:0;s:16:\"title-attachment\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:19:\"metadesc-attachment\";s:0:\"\";s:18:\"metakey-attachment\";s:0:\"\";s:18:\"noindex-attachment\";b:0;s:19:\"showdate-attachment\";b:0;s:22:\"hideeditbox-attachment\";b:0;s:18:\"title-tax-category\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-category\";s:0:\"\";s:20:\"metakey-tax-category\";s:0:\"\";s:24:\"hideeditbox-tax-category\";b:0;s:20:\"noindex-tax-category\";b:0;s:18:\"title-tax-post_tag\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-post_tag\";s:0:\"\";s:20:\"metakey-tax-post_tag\";s:0:\"\";s:24:\"hideeditbox-tax-post_tag\";b:0;s:20:\"noindex-tax-post_tag\";b:0;s:21:\"title-tax-post_format\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:24:\"metadesc-tax-post_format\";s:0:\"\";s:23:\"metakey-tax-post_format\";s:0:\"\";s:27:\"hideeditbox-tax-post_format\";b:0;s:23:\"noindex-tax-post_format\";b:1;}", "yes");
INSERT INTO `act_options` VALUES("144", "wpseo_social", "a:20:{s:9:\"fb_admins\";a:0:{}s:12:\"fbconnectkey\";s:32:\"b9b076c7df352d7cdad71e91f04f7418\";s:13:\"facebook_site\";s:0:\"\";s:13:\"instagram_url\";s:0:\"\";s:12:\"linkedin_url\";s:0:\"\";s:11:\"myspace_url\";s:0:\"\";s:16:\"og_default_image\";s:0:\"\";s:18:\"og_frontpage_title\";s:0:\"\";s:17:\"og_frontpage_desc\";s:0:\"\";s:18:\"og_frontpage_image\";s:0:\"\";s:9:\"opengraph\";b:1;s:13:\"pinterest_url\";s:0:\"\";s:15:\"pinterestverify\";s:0:\"\";s:14:\"plus-publisher\";s:0:\"\";s:7:\"twitter\";b:1;s:12:\"twitter_site\";s:0:\"\";s:17:\"twitter_card_type\";s:7:\"summary\";s:11:\"youtube_url\";s:0:\"\";s:15:\"google_plus_url\";s:0:\"\";s:10:\"fbadminapp\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("145", "wpseo_rss", "a:2:{s:9:\"rssbefore\";s:0:\"\";s:8:\"rssafter\";s:53:\"The post %%POSTLINK%% appeared first on %%BLOGLINK%%.\";}", "yes");
INSERT INTO `act_options` VALUES("146", "wpseo_internallinks", "a:10:{s:20:\"breadcrumbs-404crumb\";s:25:\"Error 404: Page not found\";s:23:\"breadcrumbs-blog-remove\";b:0;s:20:\"breadcrumbs-boldlast\";b:0;s:25:\"breadcrumbs-archiveprefix\";s:12:\"Archives for\";s:18:\"breadcrumbs-enable\";b:0;s:16:\"breadcrumbs-home\";s:4:\"Home\";s:18:\"breadcrumbs-prefix\";s:0:\"\";s:24:\"breadcrumbs-searchprefix\";s:16:\"You searched for\";s:15:\"breadcrumbs-sep\";s:7:\"&raquo;\";s:23:\"post_types-post-maintax\";i:0;}", "yes");
INSERT INTO `act_options` VALUES("147", "wpseo_xml", "a:16:{s:22:\"disable_author_sitemap\";b:1;s:22:\"disable_author_noposts\";b:1;s:16:\"enablexmlsitemap\";b:1;s:16:\"entries-per-page\";i:1000;s:14:\"excluded-posts\";s:0:\"\";s:38:\"user_role-administrator-not_in_sitemap\";b:0;s:31:\"user_role-editor-not_in_sitemap\";b:0;s:31:\"user_role-author-not_in_sitemap\";b:0;s:36:\"user_role-contributor-not_in_sitemap\";b:0;s:35:\"user_role-subscriber-not_in_sitemap\";b:0;s:30:\"post_types-post-not_in_sitemap\";b:0;s:30:\"post_types-page-not_in_sitemap\";b:0;s:36:\"post_types-attachment-not_in_sitemap\";b:1;s:34:\"taxonomies-category-not_in_sitemap\";b:0;s:34:\"taxonomies-post_tag-not_in_sitemap\";b:0;s:37:\"taxonomies-post_format-not_in_sitemap\";b:0;}", "yes");
INSERT INTO `act_options` VALUES("148", "wpseo_flush_rewrite", "1", "yes");
INSERT INTO `act_options` VALUES("149", "itsec-storage", "a:2:{s:6:\"global\";a:31:{s:18:\"notification_email\";a:1:{i:0;s:30:\"absolutecomfortkenya@gmail.com\";}s:12:\"backup_email\";a:1:{i:0;s:30:\"absolutecomfortkenya@gmail.com\";}s:15:\"lockout_message\";s:5:\"error\";s:20:\"user_lockout_message\";s:64:\"You have been locked out due to too many invalid login attempts.\";s:25:\"community_lockout_message\";s:77:\"Your IP address has been flagged as a threat by the iThemes Security network.\";s:9:\"blacklist\";b:1;s:15:\"blacklist_count\";i:3;s:16:\"blacklist_period\";i:7;s:19:\"email_notifications\";b:1;s:14:\"lockout_period\";i:15;s:18:\"lockout_white_list\";a:0:{}s:12:\"log_rotation\";i:14;s:8:\"log_type\";s:8:\"database\";s:12:\"log_location\";s:61:\"C:\\wamp\\www\\actfinal/wp-content/uploads/ithemes-security/logs\";s:8:\"log_info\";s:51:\"absolute-comfort-tra-AJuE5QSc0FMMCMy90Lh08XcfKQzQIq\";s:14:\"allow_tracking\";b:0;s:11:\"write_files\";b:1;s:10:\"nginx_file\";s:31:\"C:\\wamp\\www\\actfinal/nginx.conf\";s:24:\"infinitewp_compatibility\";b:0;s:11:\"did_upgrade\";b:0;s:9:\"lock_file\";b:0;s:12:\"digest_email\";b:0;s:14:\"proxy_override\";b:0;s:14:\"hide_admin_bar\";b:0;s:16:\"show_error_codes\";b:0;s:25:\"show_new_dashboard_notice\";b:1;s:19:\"show_security_check\";b:0;s:16:\"digest_last_sent\";i:1496179450;s:15:\"digest_messages\";a:0:{}s:5:\"build\";i:4070;s:20:\"activation_timestamp\";i:0;}s:16:\"wordpress-tweaks\";a:13:{s:18:\"wlwmanifest_header\";b:0;s:14:\"edituri_header\";b:0;s:12:\"comment_spam\";b:0;s:11:\"file_editor\";b:1;s:14:\"disable_xmlrpc\";i:0;s:22:\"allow_xmlrpc_multiauth\";b:0;s:8:\"rest_api\";s:14:\"default-access\";s:11:\"safe_jquery\";b:0;s:12:\"login_errors\";b:0;s:21:\"force_unique_nicename\";b:0;s:27:\"disable_unused_author_pages\";b:0;s:14:\"jquery_version\";s:6:\"1.12.4\";s:16:\"block_tabnapping\";b:0;}}", "yes");
INSERT INTO `act_options` VALUES("151", "siteorigin_panels_settings", "a:0:{}", "yes");
INSERT INTO `act_options` VALUES("153", "widget_cl-counter", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("154", "widget_cl-flipbox", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("155", "widget_cl-ib", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("156", "widget_cl-itext", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("157", "widget_cl-popup", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("158", "widget_cl-review", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("159", "widget_siteorigin-panels-post-content", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("160", "widget_siteorigin-panels-postloop", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("161", "widget_siteorigin-panels-builder", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("163", "monsterinsights_over_time", "a:3:{s:17:\"installed_version\";s:5:\"6.1.5\";s:14:\"installed_date\";i:1496179455;s:13:\"installed_pro\";b:0;}", "yes");
INSERT INTO `act_options` VALUES("164", "monsterinsights_db_version", "6.0.0", "yes");
INSERT INTO `act_options` VALUES("165", "monsterinsights_settings_version", "6.0.0", "yes");
INSERT INTO `act_options` VALUES("166", "monsterinsights_current_version", "6.1.5", "yes");
INSERT INTO `act_options` VALUES("167", "monsterinsights_settings", "a:23:{s:14:\"manual_ua_code\";s:0:\"\";s:26:\"track_internal_as_outbound\";i:0;s:23:\"track_internal_as_label\";s:0:\"\";s:14:\"track_outbound\";i:1;s:14:\"allow_tracking\";i:0;s:13:\"tracking_mode\";s:9:\"analytics\";s:11:\"events_mode\";s:2:\"js\";s:12:\"demographics\";i:1;s:12:\"ignore_users\";a:2:{i:0;s:13:\"administrator\";i:1;s:6:\"editor\";}s:19:\"dashboards_disabled\";i:0;s:13:\"anonymize_ips\";i:0;s:17:\"track_download_as\";s:5:\"event\";s:19:\"extensions_of_files\";s:30:\"doc,exe,js,pdf,ppt,tgz,zip,xls\";s:18:\"subdomain_tracking\";s:0:\"\";s:16:\"tag_links_in_rss\";i:0;s:12:\"allow_anchor\";i:0;s:16:\"add_allow_linker\";i:0;s:25:\"enhanced_link_attribution\";i:1;s:11:\"custom_code\";s:0:\"\";s:10:\"debug_mode\";i:0;s:14:\"anonymous_data\";i:0;s:12:\"save_setings\";a:0:{}s:12:\"view_reports\";a:0:{}}", "yes");
INSERT INTO `act_options` VALUES("170", "siteorigin_widget_bundle_version", "1.9.2", "yes");
INSERT INTO `act_options` VALUES("171", "siteorigin_widgets_old_widgets", "C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/button/button.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/cta/cta.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/contact/contact.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/editor/editor.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/features/features.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/google-map/google-map.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/headline/headline.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/hero/hero.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/icon/icon.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/image/image.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/image-grid/image-grid.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/slider/slider.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-ardn-widget/ink-ardn-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-alrt-widget/ink-alrt-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-auds-widget/ink-auds-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-barc-widget/ink-barc-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-blgs-widget/ink-blgs-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-btns-widget/ink-btns-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-crlc-widget/ink-crlc-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-dvdr-widget/ink-dvdr-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-fard-widget/ink-fard-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-mbox-widget/ink-mbox-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-numc-widget/ink-numc-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-prsn-widget/ink-prsn-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-ptfl-widget/ink-ptfl-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-prit-widget/ink-prit-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-sldr-widget/ink-sldr-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-tabb-widget/ink-tabb-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-tsml-widget/ink-tsml-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\widgets-for-siteorigin//widgets/ink-vids-widget/ink-vids-widget.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/layout-slider/layout-slider.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/post-carousel/post-carousel.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/price-table/price-table.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/simple-masonry/simple-masonry.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/social-media-buttons/social-media-buttons.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/taxonomy/taxonomy.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/testimonial/testimonial.php,C:\\wamp\\www\\actfinal\\wp-content\\plugins\\so-widgets-bundle/widgets/video/video.php", "yes");
INSERT INTO `act_options` VALUES("172", "monsterinsights_tracking_notice", "1", "yes");
INSERT INTO `act_options` VALUES("175", "wpseo_sitemap_1_cache_validator", "z7cs", "no");
INSERT INTO `act_options` VALUES("176", "wpseo_sitemap_page_cache_validator", "6B1HE", "no");
INSERT INTO `act_options` VALUES("183", "current_theme", "Sydney Child Theme", "yes");
INSERT INTO `act_options` VALUES("184", "theme_mods_hiero", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496179678;s:4:\"data\";a:7:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";N;s:9:\"sidebar-5\";N;s:9:\"sidebar-6\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("185", "theme_switched", "", "yes");
INSERT INTO `act_options` VALUES("186", "widget_athemes_preview_post", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("187", "widget_athemes_social_icons", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("188", "widget_athemes_media_embed", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("189", "widget_athemes_flickr_stream", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("190", "widget_athemes_tabs", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("193", "theme_mods_esteem", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496179823;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:20:\"esteem_right_sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:19:\"esteem_left_sidebar\";a:0:{}s:28:\"esteem_business_page_sidebar\";a:0:{}s:25:\"esteem_footer_sidebar_one\";N;s:25:\"esteem_footer_sidebar_two\";N;s:27:\"esteem_footer_sidebar_three\";N;s:27:\"esteem_contact_page_sidebar\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("194", "esteem_customizer_transfer", "1", "yes");
INSERT INTO `act_options` VALUES("195", "widget_esteem_service_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("196", "widget_esteem_recent_work_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("197", "widget_esteem_call_to_action_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("198", "widget_esteem_testimonial_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("199", "esteem_admin_notice_welcome", "1", "yes");
INSERT INTO `act_options` VALUES("204", "theme_mods_rocked", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496180001;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer-1\";a:0:{}s:8:\"footer-2\";a:0:{}s:8:\"footer-3\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("205", "widget_fp_social", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("206", "widget_rocked_contact_info", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("207", "widget_rocked_video_widget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("208", "widget_rocked_action", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("209", "widget_rocked_clients", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("210", "widget_rocked_employees", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("211", "widget_rocked_facts", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("212", "widget_rocked_latest_news", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("213", "widget_rocked_projects", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("214", "widget_rocked_services_type_a", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("215", "widget_rocked_services_type_b", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("216", "widget_rocked_skills", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("217", "widget_rocked_testimonials", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("221", "_transient_rocked_categories", "1", "yes");
INSERT INTO `act_options` VALUES("224", "theme_mods_intro", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496180163;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("225", "widget_intro_service_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("227", "WPLANG", "", "yes");
INSERT INTO `act_options` VALUES("232", "_transient_intro_categories", "1", "yes");
INSERT INTO `act_options` VALUES("235", "theme_mods_sweetheat", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496180266;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("236", "widget_sweetheat_video_widget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("237", "widget_sweetheat_clients", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("238", "widget_sweetheat_latest_news", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("239", "widget_sweetheat_portfolio", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("240", "widget_sweetheat_services", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("241", "widget_sweetheat_testimonials", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("244", "theme_mods_UpStream", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496180675;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:15:\"sidebar_primary\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer_1\";N;s:8:\"footer_2\";N;s:8:\"footer_3\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("245", "upstream_theme_options", "a:79:{s:20:\"themater_logo_source\";s:5:\"image\";s:4:\"logo\";s:68:\"http://localhost/actfinal/wp-content/themes/UpStream/images/logo.png\";s:10:\"site_title\";s:23:\"Absolute Comfort Travel\";s:16:\"site_description\";s:0:\"\";s:7:\"favicon\";s:71:\"http://localhost/actfinal/wp-content/themes/UpStream/images/favicon.png\";s:18:\"contact_form_email\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"read_more\";s:9:\"Read More\";s:27:\"featured_image_width_single\";s:3:\"300\";s:28:\"featured_image_height_single\";s:3:\"225\";s:30:\"featured_image_position_single\";s:9:\"alignleft\";s:18:\"footer_custom_text\";s:0:\"\";s:14:\"footer_widgets\";s:4:\"true\";s:7:\"rss_url\";s:0:\"\";s:10:\"custom_css\";s:0:\"\";s:9:\"head_code\";s:0:\"\";s:11:\"footer_code\";s:0:\"\";s:21:\"featuredposts_enabled\";a:1:{i:0;s:8:\"homepage\";}s:20:\"featuredposts_source\";s:6:\"custom\";s:27:\"featuredposts_custom_slides\";a:6:{i:0;a:4:{s:3:\"img\";s:80:\"http://localhost/actfinal/wp-content/themes/UpStream/images/default-slides/1.jpg\";s:4:\"link\";s:1:\"#\";s:5:\"title\";s:38:\"This is default featured slide 1 title\";s:7:\"content\";s:188:\"You can completely customize the featured slides from the theme theme options page. You can also easily hide the slider from certain part of your site like: categories, tags, archives etc.\";}i:1;a:4:{s:3:\"img\";s:80:\"http://localhost/actfinal/wp-content/themes/UpStream/images/default-slides/2.jpg\";s:4:\"link\";s:1:\"#\";s:5:\"title\";s:38:\"This is default featured slide 2 title\";s:7:\"content\";s:188:\"You can completely customize the featured slides from the theme theme options page. You can also easily hide the slider from certain part of your site like: categories, tags, archives etc.\";}i:2;a:4:{s:3:\"img\";s:80:\"http://localhost/actfinal/wp-content/themes/UpStream/images/default-slides/3.jpg\";s:4:\"link\";s:1:\"#\";s:5:\"title\";s:38:\"This is default featured slide 3 title\";s:7:\"content\";s:188:\"You can completely customize the featured slides from the theme theme options page. You can also easily hide the slider from certain part of your site like: categories, tags, archives etc.\";}i:3;a:4:{s:3:\"img\";s:80:\"http://localhost/actfinal/wp-content/themes/UpStream/images/default-slides/4.jpg\";s:4:\"link\";s:1:\"#\";s:5:\"title\";s:38:\"This is default featured slide 4 title\";s:7:\"content\";s:188:\"You can completely customize the featured slides from the theme theme options page. You can also easily hide the slider from certain part of your site like: categories, tags, archives etc.\";}i:4;a:4:{s:3:\"img\";s:80:\"http://localhost/actfinal/wp-content/themes/UpStream/images/default-slides/5.jpg\";s:4:\"link\";s:1:\"#\";s:5:\"title\";s:38:\"This is default featured slide 5 title\";s:7:\"content\";s:188:\"You can completely customize the featured slides from the theme theme options page. You can also easily hide the slider from certain part of your site like: categories, tags, archives etc.\";}s:9:\"the__id__\";a:4:{s:3:\"img\";s:0:\"\";s:4:\"link\";s:0:\"\";s:5:\"title\";s:0:\"\";s:7:\"content\";s:0:\"\";}}s:33:\"featuredposts_source_category_num\";s:1:\"5\";s:29:\"featuredposts_source_category\";s:0:\"\";s:26:\"featuredposts_source_posts\";s:0:\"\";s:26:\"featuredposts_source_pages\";s:0:\"\";s:20:\"featuredposts_effect\";s:4:\"fade\";s:25:\"featuredposts_moreoptions\";a:8:{i:0;s:9:\"thumbnail\";i:1;s:10:\"post_title\";i:2;s:12:\"post_excerpt\";i:3;s:5:\"pager\";i:4;s:9:\"next_prev\";i:5;s:4:\"sync\";i:6;s:5:\"pause\";i:7;s:17:\"pauseOnPagerHover\";}s:22:\"featuredposts_readmore\";s:7:\"More »\";s:28:\"featuredposts_excerpt_length\";s:2:\"32\";s:21:\"featuredposts_timeout\";s:4:\"4000\";s:19:\"featuredposts_delay\";s:1:\"0\";s:19:\"featuredposts_speed\";s:4:\"1000\";s:21:\"featuredposts_speedIn\";s:0:\"\";s:22:\"featuredposts_speedOut\";s:0:\"\";s:33:\"themater_social_profiles_networks\";a:6:{i:0;a:3:{s:5:\"title\";s:7:\"Twitter\";s:3:\"url\";s:19:\"http://twitter.com/\";s:6:\"button\";s:87:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/twitter.png\";}i:1;a:3:{s:5:\"title\";s:8:\"Facebook\";s:3:\"url\";s:20:\"http://facebook.com/\";s:6:\"button\";s:88:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/facebook.png\";}i:2;a:3:{s:5:\"title\";s:11:\"Google Plus\";s:3:\"url\";s:24:\"https://plus.google.com/\";s:6:\"button\";s:85:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/gplus.png\";}i:3;a:3:{s:5:\"title\";s:8:\"LinkedIn\";s:3:\"url\";s:24:\"http://www.linkedin.com/\";s:6:\"button\";s:88:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/linkedin.png\";}i:4;a:3:{s:5:\"title\";s:8:\"RSS Feed\";s:3:\"url\";s:31:\"http://localhost/actfinal/feed/\";s:6:\"button\";s:83:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/rss.png\";}i:5;a:3:{s:5:\"title\";s:5:\"Email\";s:3:\"url\";s:21:\"mailto:your@email.com\";s:6:\"button\";s:85:\"http://localhost/actfinal/wp-content/themes/UpStream/images/social-profiles/email.png\";}}s:12:\"menu_primary\";s:4:\"true\";s:25:\"menu_primary_mobile_title\";s:4:\"Menu\";s:18:\"menu_primary_depth\";s:1:\"0\";s:19:\"menu_primary_effect\";s:4:\"fade\";s:18:\"menu_primary_speed\";s:3:\"200\";s:18:\"menu_primary_delay\";s:3:\"800\";s:19:\"menu_primary_arrows\";s:4:\"true\";s:20:\"menu_primary_shadows\";s:0:\"\";s:14:\"menu_secondary\";s:4:\"true\";s:27:\"menu_secondary_mobile_title\";s:10:\"Navigation\";s:20:\"menu_secondary_depth\";s:1:\"0\";s:21:\"menu_secondary_effect\";s:4:\"fade\";s:20:\"menu_secondary_speed\";s:3:\"200\";s:20:\"menu_secondary_delay\";s:3:\"800\";s:21:\"menu_secondary_arrows\";s:4:\"true\";s:22:\"menu_secondary_shadows\";s:0:\"\";s:24:\"theme_guide_feature_tour\";s:0:\"\";s:24:\"themater_logo_iamge_wrap\";s:0:\"\";s:28:\"themater_logo_iamge_wrap_end\";s:0:\"\";s:23:\"themater_logo_text_wrap\";s:0:\"\";s:27:\"themater_logo_text_wrap_end\";s:0:\"\";s:23:\"featured_image_settings\";s:0:\"\";s:32:\"featured_image_settings_homepage\";s:0:\"\";s:20:\"featured_image_width\";s:0:\"\";s:21:\"featured_image_height\";s:0:\"\";s:23:\"featured_image_position\";s:0:\"\";s:30:\"featured_image_settings_single\";s:0:\"\";s:13:\"header_banner\";s:0:\"\";s:13:\"reset_options\";s:0:\"\";s:7:\"support\";s:0:\"\";s:20:\"featuredposts_images\";s:0:\"\";s:24:\"featuredposts_source_css\";s:0:\"\";s:32:\"featuredposts_source_custom_wrap\";s:0:\"\";s:36:\"featuredposts_source_custom_end_wrap\";s:0:\"\";s:34:\"featuredposts_source_category_wrap\";s:0:\"\";s:38:\"featuredposts_source_category_end_wrap\";s:0:\"\";s:31:\"featuredposts_source_posts_wrap\";s:0:\"\";s:35:\"featuredposts_source_posts_wrap_end\";s:0:\"\";s:31:\"featuredposts_source_pages_wrap\";s:0:\"\";s:35:\"featuredposts_source_pages_wrap_end\";s:0:\"\";s:31:\"featuredposts_misc_options_info\";s:0:\"\";s:15:\"social_profiles\";s:0:\"\";s:17:\"menu_primary_info\";s:0:\"\";s:22:\"menu_primary_drop_down\";s:0:\"\";s:19:\"menu_secondary_info\";s:0:\"\";s:24:\"menu_secondary_drop_down\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("246", "widget_themater_banners_125", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("247", "widget_themater_comments_posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("248", "widget_themater_posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("249", "widget_themater_social_profiles", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("250", "widget_themater_tabs", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("251", "widget_themater_infobox", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("252", "widget_themater_facebook", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("257", "theme_mods_thecompany", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496181129;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("261", "theme_mods_flash", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496181261;s:4:\"data\";a:7:{s:19:\"wp_inactive_widgets\";a:0:{}s:19:\"flash_right_sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:18:\"flash_left_sidebar\";N;s:21:\"flash_footer_sidebar1\";N;s:21:\"flash_footer_sidebar2\";N;s:21:\"flash_footer_sidebar3\";N;s:21:\"flash_footer_sidebar4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("262", "flash_admin_notice_welcome", "1", "yes");
INSERT INTO `act_options` VALUES("265", "theme_mods_bldr", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496181429;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("267", "widget_bldr_clients", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("268", "widget_bldr_columns", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("269", "widget_bldr_home_news", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("270", "widget_bldr_projects", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("271", "widget_bldr_services", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("272", "widget_bldr_testimonials", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("273", "widget_bldr_action", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("274", "widget_bldr_contact_info", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("275", "widget_bldr_video_widget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("279", "theme_mods_codepress-corporate", "a:6:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:11:\"custom_logo\";i:59;s:31:\"codepress_corporate_logo_optipn\";s:16:\"header_logo_only\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496834001;s:4:\"data\";a:10:{s:19:\"wp_inactive_widgets\";a:0:{}s:13:\"right-sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:12:\"left-sidebar\";N;s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;s:12:\"contact-temp\";N;s:25:\"woocommerce-sidebar-right\";N;s:24:\"woocommerce-sidebar-left\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("280", "widget_codepress_corporate_single_post", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("281", "widget_codepress_corporate_contact_info", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("282", "widget_codepress_corporate_social_link", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("283", "widget_codepress_corporate_contact_widgets", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("285", "widget_widget_recent_entries", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("289", "theme_mods_accesspress-parallax", "a:4:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496787331;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("303", "theme_mods_corporate-key", "a:4:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496382308;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";N;s:30:\"sidebar-front-page-widget-area\";N;s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("304", "widget_corporate-key-social", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("305", "widget_corporate-key-featured-page", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("306", "widget_corporate-key-call-to-action", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("307", "widget_corporate-key-latest-news", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("308", "widget_corporate-key-services", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("312", "theme_mods_luxicar-lite", "a:3:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496213863;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:13:\"sidebar_extra\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("313", "theme_mods_business-club", "a:5:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:13:\"theme_options\";a:3:{s:13:\"global_layout\";s:10:\"no-sidebar\";s:22:\"featured_slider_status\";s:9:\"home-page\";s:22:\"featured_slider_number\";i:5;}s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496903978;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:3:{i:0;s:29:\"business-club-featured-page-2\";i:1;s:30:\"business-club-call-to-action-2\";i:2;s:24:\"business-club-services-2\";}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";N;s:30:\"sidebar-front-page-widget-area\";N;s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("314", "widget_business-club-social", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("315", "widget_business-club-featured-page", "a:2:{i:2;a:7:{s:5:\"title\";s:0:\"\";s:13:\"featured_page\";i:7;s:12:\"content_type\";s:4:\"full\";s:14:\"excerpt_length\";i:80;s:14:\"featured_image\";s:6:\"medium\";s:24:\"featured_image_alignment\";s:4:\"left\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("316", "widget_business-club-call-to-action", "a:2:{i:2;a:9:{s:5:\"title\";s:5:\"fdhdh\";s:4:\"text\";s:15:\"dfdfgjfjdhdhdfh\";s:19:\"primary_button_text\";s:9:\"Read more\";s:18:\"primary_button_url\";s:26:\"http://localhost/actfinal/\";s:21:\"secondary_button_text\";s:10:\"Learn more\";s:20:\"secondary_button_url\";s:26:\"http://localhost/actfinal/\";s:6:\"layout\";i:1;s:16:\"background_image\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("317", "widget_business-club-latest-news", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("318", "widget_business-club-services", "a:2:{i:2;a:13:{s:5:\"title\";s:0:\"\";s:8:\"subtitle\";s:0:\"\";s:14:\"excerpt_length\";i:20;s:9:\"more_text\";s:9:\"Read more\";s:12:\"block_page_1\";i:7;s:12:\"block_icon_1\";s:7:\"fa-cogs\";s:12:\"block_page_2\";i:11;s:12:\"block_icon_2\";s:7:\"fa-cogs\";s:12:\"block_page_3\";i:5;s:12:\"block_icon_3\";s:7:\"fa-cogs\";s:12:\"block_page_4\";i:0;s:12:\"block_icon_4\";s:7:\"fa-cogs\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("346", "theme_mods_business-club-child", "a:8:{i:0;b:0;s:18:\"custom_css_post_id\";i:-1;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:16:\"background_image\";s:0:\"\";s:21:\"background_position_x\";s:6:\"center\";s:21:\"background_position_y\";s:6:\"center\";s:13:\"theme_options\";a:8:{s:14:\"contact_number\";s:33:\"+254797 119 418 , +254789 122 834\";s:13:\"contact_email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:13:\"global_layout\";s:10:\"no-sidebar\";s:22:\"featured_slider_status\";s:9:\"home-page\";s:22:\"featured_slider_page_1\";i:5;s:22:\"featured_slider_page_2\";i:7;s:22:\"featured_slider_page_3\";i:9;s:30:\"featured_slider_read_more_text\";s:0:\"\";}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496356870;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:30:\"sidebar-front-page-widget-area\";a:3:{i:0;s:29:\"business-club-featured-page-2\";i:1;s:30:\"business-club-call-to-action-2\";i:2;s:24:\"business-club-services-2\";}s:8:\"footer-1\";a:0:{}s:8:\"footer-2\";a:0:{}s:8:\"footer-3\";a:0:{}s:8:\"footer-4\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("347", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `act_options` VALUES("369", "theme_mods_thecompany-child", "a:15:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:20:\"home_slider_page_one\";i:42;s:20:\"home_slider_page_two\";i:44;s:22:\"home_slider_page_three\";i:46;s:16:\"slider_read_more\";s:0:\"\";s:16:\"header_textcolor\";s:6:\"81d742\";s:12:\"header_image\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:17:\"header_image_data\";O:8:\"stdClass\":5:{s:13:\"attachment_id\";i:50;s:3:\"url\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:13:\"thumbnail_url\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:6:\"height\";i:500;s:5:\"width\";i:1920;}s:36:\"thecompany_whychooseus_section_page1\";i:7;s:36:\"thecompany_whychooseus_section_page2\";i:44;s:36:\"thecompany_whychooseus_section_page3\";i:9;s:36:\"thecompany_whychooseus_section_page4\";i:46;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496360766;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:18:\"orphaned_widgets_1\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("387", "theme_mods_company-elite", "a:5:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:13:\"theme_options\";a:2:{s:22:\"featured_slider_status\";s:9:\"home-page\";s:22:\"featured_slider_number\";i:4;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496381954;s:4:\"data\";a:12:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:30:\"sidebar-front-page-widget-area\";a:3:{i:0;s:24:\"company-elite-features-2\";i:1;s:29:\"company-elite-featured-page-2\";i:2;s:30:\"company-elite-call-to-action-2\";}s:15:\"extra-sidebar-1\";a:0:{}s:15:\"extra-sidebar-2\";a:0:{}s:15:\"extra-sidebar-3\";a:0:{}s:15:\"extra-sidebar-4\";a:0:{}s:8:\"footer-1\";a:0:{}s:8:\"footer-2\";a:0:{}s:8:\"footer-3\";a:0:{}s:8:\"footer-4\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("388", "widget_company-elite-social", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("389", "widget_company-elite-featured-page", "a:2:{i:2;a:7:{s:5:\"title\";s:0:\"\";s:13:\"featured_page\";i:0;s:12:\"content_type\";s:4:\"full\";s:14:\"excerpt_length\";i:80;s:14:\"featured_image\";s:6:\"medium\";s:24:\"featured_image_alignment\";s:4:\"left\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("390", "widget_company-elite-call-to-action", "a:2:{i:2;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"primary_button_text\";s:9:\"Read more\";s:18:\"primary_button_url\";s:26:\"http://localhost/actfinal/\";s:21:\"secondary_button_text\";s:10:\"Learn more\";s:20:\"secondary_button_url\";s:26:\"http://localhost/actfinal/\";s:16:\"background_image\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("391", "widget_company-elite-latest-news", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("392", "widget_company-elite-services", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("393", "widget_company-elite-features", "a:2:{i:2;a:11:{s:5:\"title\";s:0:\"\";s:18:\"featured_page_main\";i:0;s:12:\"block_page_1\";i:0;s:12:\"block_icon_1\";s:7:\"fa-cogs\";s:12:\"block_page_2\";i:0;s:12:\"block_icon_2\";s:7:\"fa-cogs\";s:12:\"block_page_3\";i:0;s:12:\"block_icon_3\";s:7:\"fa-cogs\";s:12:\"block_page_4\";i:0;s:12:\"block_icon_4\";s:7:\"fa-cogs\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("395", "theme_mods_encrypted-lite", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496362216;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:13:\"right-sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:12:\"left-sidebar\";a:0:{}s:20:\"horizontal-sidebar-1\";a:0:{}s:8:\"footer-1\";a:0:{}s:8:\"footer-2\";a:0:{}s:8:\"footer-3\";a:0:{}s:8:\"footer-4\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("396", "widget_encrypted_lite_icon_text", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("410", "theme_mods_pixova-lite", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496382056;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:12:\"blog-sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:16:\"footer-sidebar-1\";a:0:{}s:16:\"footer-sidebar-2\";a:0:{}s:16:\"footer-sidebar-3\";a:0:{}s:16:\"footer-sidebar-4\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("411", "widget_pixova_lite_widget_about", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("412", "widget_pixova_lite_widget_social_media", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("413", "widget_pixova_lite_widget_latest_posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("416", "theme_mods_spacious", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496382192;s:4:\"data\";a:14:{s:19:\"wp_inactive_widgets\";a:0:{}s:22:\"spacious_right_sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:21:\"spacious_left_sidebar\";a:0:{}s:23:\"spacious_header_sidebar\";a:0:{}s:42:\"spacious_business_page_top_section_sidebar\";a:0:{}s:55:\"spacious_business_page_middle_section_left_half_sidebar\";a:0:{}s:56:\"spacious_business_page_middle_section_right_half_sidebar\";N;s:45:\"spacious_business_page_bottom_section_sidebar\";N;s:29:\"spacious_contact_page_sidebar\";N;s:31:\"spacious_error_404_page_sidebar\";N;s:27:\"spacious_footer_sidebar_one\";N;s:27:\"spacious_footer_sidebar_two\";N;s:29:\"spacious_footer_sidebar_three\";N;s:28:\"spacious_footer_sidebar_four\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("417", "widget_spacious_featured_single_page_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("418", "widget_spacious_service_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("419", "widget_spacious_call_to_action_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("420", "widget_spacious_testimonial_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("421", "widget_spacious_recent_work_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("423", "spacious_admin_notice_welcome", "1", "yes");
INSERT INTO `act_options` VALUES("451", "frontend_name", "Name", "yes");
INSERT INTO `act_options` VALUES("452", "frontend_email", "Email", "yes");
INSERT INTO `act_options` VALUES("453", "frontend_contact", "Contact No", "yes");
INSERT INTO `act_options` VALUES("454", "frontend_location", "Location", "yes");
INSERT INTO `act_options` VALUES("455", "frontend_professional", "Doctor", "yes");
INSERT INTO `act_options` VALUES("456", "frontend_message", "Message", "yes");
INSERT INTO `act_options` VALUES("457", "frontend_error_message", "Required", "yes");
INSERT INTO `act_options` VALUES("458", "frontend_button", "Appointment", "yes");
INSERT INTO `act_options` VALUES("459", "admin_pagination", "5", "yes");
INSERT INTO `act_options` VALUES("460", "admin_text_color", "#000000", "yes");
INSERT INTO `act_options` VALUES("461", "admin_edit_button_color", "#1e73be", "yes");
INSERT INTO `act_options` VALUES("462", "admin_delete_button_color", "#dd9933", "yes");
INSERT INTO `act_options` VALUES("463", "admin_submit_button_color", "#1e73be", "yes");
INSERT INTO `act_options` VALUES("464", "admin_submit_button_text_color", "#ffffff", "yes");
INSERT INTO `act_options` VALUES("465", "admin_fontfamily", "arial", "yes");
INSERT INTO `act_options` VALUES("466", "admin_fontsize", "12", "yes");
INSERT INTO `act_options` VALUES("467", "admin_text_color_active_page", "1", "yes");
INSERT INTO `act_options` VALUES("468", "frontend_fontfamily", "arial", "yes");
INSERT INTO `act_options` VALUES("469", "frontend_fontsize", "12", "yes");
INSERT INTO `act_options` VALUES("470", "text_color", "#000000", "yes");
INSERT INTO `act_options` VALUES("471", "submit_button_color", "#2192dd", "yes");
INSERT INTO `act_options` VALUES("472", "error_message_color", "#dd3333", "yes");
INSERT INTO `act_options` VALUES("473", "request_color", "#dd9933", "yes");
INSERT INTO `act_options` VALUES("474", "approve_color", "#81d742", "yes");
INSERT INTO `act_options` VALUES("475", "reject_color", "#dd3333", "yes");
INSERT INTO `act_options` VALUES("476", "avoilable_color", "#36af48", "yes");
INSERT INTO `act_options` VALUES("477", "calender_enable_color", "#81d742", "yes");
INSERT INTO `act_options` VALUES("478", "calender_active_color", "#dd9933", "yes");
INSERT INTO `act_options` VALUES("479", "calender_day_text_color", "#36af48", "yes");
INSERT INTO `act_options` VALUES("480", "calender_month_text_color", "#2192dd", "yes");
INSERT INTO `act_options` VALUES("481", "calender_header_bg_color", "#91d631", "yes");
INSERT INTO `act_options` VALUES("482", "calender_border_color", "#b0d330", "yes");
INSERT INTO `act_options` VALUES("501", "theme_mods_business-eye", "a:7:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:11:\"header_text\";i:0;s:11:\"custom_logo\";i:59;s:20:\"business-eye-options\";a:7:{s:34:\"business-eye-feature-slider-enable\";b:1;s:28:\"business-eye-fs-enable-arrow\";b:1;s:27:\"business-eye-fs-pages-ids_1\";i:7;s:27:\"business-eye-fs-pages-ids_2\";i:44;s:27:\"business-eye-fs-pages-ids_3\";i:9;s:27:\"business-eye-default-layout\";s:10:\"no-sidebar\";s:30:\"business-eye-about-pages-ids_1\";i:7;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496788284;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("506", "theme_mods_business-eye-child", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496820276;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `act_options` VALUES("509", "theme_mods_codepress-corporate-child", "a:12:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:40:\"codepress_corporate_social_link_activate\";s:0:\"\";s:38:\"codepress_corporate_top_contact_number\";s:32:\"+254797 119 418, +254789 122 834\";s:29:\"codepress_corporate_top_email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:40:\"codepress_corporate_archive_banner_image\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:37:\"codepress_corporate_page_banner_image\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:11:\"custom_logo\";i:67;s:31:\"codepress_corporate_logo_optipn\";s:9:\"show_both\";s:41:\"codepress_corporate_activate_page_comment\";s:0:\"\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496876153;s:4:\"data\";a:10:{s:19:\"wp_inactive_widgets\";a:0:{}s:13:\"right-sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:12:\"left-sidebar\";N;s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;s:12:\"contact-temp\";N;s:25:\"woocommerce-sidebar-right\";N;s:24:\"woocommerce-sidebar-left\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("513", "theme_mods_accesspress-parallax-child", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496872662;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;s:8:\"footer-4\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("528", "theme_mods_accesspress-basic-child", "a:7:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:12:\"header_image\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:17:\"header_image_data\";a:6:{s:13:\"attachment_id\";i:67;s:3:\"url\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:13:\"thumbnail_url\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:8:\"alt_text\";s:0:\"\";s:5:\"width\";i:190;s:6:\"height\";i:74;}s:16:\"header_textcolor\";s:6:\"1962c1\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496869276;s:4:\"data\";a:17:{s:19:\"wp_inactive_widgets\";a:0:{}s:21:\"apbasic_right_sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:20:\"apbasic_left_sidebar\";a:0:{}s:24:\"apbasic_featured_section\";a:0:{}s:19:\"apbasic_cta_section\";a:0:{}s:23:\"icon_text_block_section\";a:0:{}s:22:\"apbasic_toggle_section\";a:0:{}s:29:\"apbasic_featured_page_section\";a:0:{}s:27:\"apbasic_testimonial_section\";a:0:{}s:24:\"apbasic_services_section\";a:0:{}s:19:\"apbasic_header_text\";a:0:{}s:27:\"apbasic_header_social_links\";a:0:{}s:27:\"apbasic_footer_social_links\";a:0:{}s:18:\"apbasic_footer_one\";a:0:{}s:18:\"apbasic_footer_two\";a:0:{}s:20:\"apbasic_footer_three\";a:0:{}s:19:\"apbasic_footer_four\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("529", "widget_accesspress_basic_testimonial", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("530", "widget_accesspress_basic_features", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("531", "widget_accesspress_basic_services", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("532", "widget_accesspress_basic_cta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("533", "widget_accesspress_basic_icon_text", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("534", "widget_accesspress_basic_toggle", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("535", "widget_accesspress_basic_featured_page", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("536", "accesspressbasic_plugin_installed_notif", "1", "yes");
INSERT INTO `act_options` VALUES("539", "wpseo_sitemap_post_cache_validator", "3oXFZ", "no");
INSERT INTO `act_options` VALUES("552", "_transient_timeout_plugin_slugs", "1497614815", "no");
INSERT INTO `act_options` VALUES("553", "_transient_plugin_slugs", "a:9:{i:0;s:25:\"booking/wpdev-booking.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:15:\"kirki/kirki.php\";i:3;s:39:\"siteorigin-panels/siteorigin-panels.php\";i:4;s:47:\"really-simple-captcha/really-simple-captcha.php\";i:5;s:39:\"so-widgets-bundle/so-widgets-bundle.php\";i:6;s:33:\"sydney-toolbox/sydney-toolbox.php\";i:7;s:49:\"widgets-for-siteorigin/widgets-for-siteorigin.php\";i:8;s:25:\"wp-members/wp-members.php\";}", "no");
INSERT INTO `act_options` VALUES("557", "apbasic_options", "a:55:{s:11:\"header_logo\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:11:\"show_header\";s:16:\"header_logo_only\";s:11:\"show_search\";N;s:17:\"show_social_links\";N;s:11:\"header_text\";s:81:\"Call Us: +254797 119 418,  +254789 122 834  Email: Bookings@absolutecomfort.co.ke\";s:16:\"activate_favicon\";i:1;s:7:\"favicon\";s:78:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png\";s:11:\"site_layout\";s:10:\"full_width\";s:11:\"footer_text\";s:24:\"Absolute Comfort Travel.\";s:16:\"background_image\";s:8:\"pattern0\";s:14:\"default_layout\";s:15:\"no_sidebar_wide\";s:19:\"default_page_layout\";s:15:\"no_sidebar_wide\";s:19:\"default_post_layout\";s:15:\"no_sidebar_wide\";s:22:\"blog_post_display_type\";s:16:\"blog_image_large\";s:28:\"show_footer_featured_section\";N;s:20:\"enable_comments_page\";N;s:20:\"enable_comments_post\";N;s:11:\"show_slider\";s:3:\"yes\";s:11:\"slider_type\";s:9:\"fullwidth\";s:19:\"show_slider_in_post\";i:1;s:11:\"slider_mode\";s:10:\"horizontal\";s:27:\"open_slider_link_in_new_tab\";i:1;s:6:\"slide1\";s:76:\"http://localhost/actfinal/wp-content/uploads/2017/05/IMG-20170601-WA0002.jpg\";s:6:\"slide2\";s:76:\"http://localhost/actfinal/wp-content/uploads/2017/05/IMG-20170601-WA0003.jpg\";s:6:\"slide3\";s:76:\"http://localhost/actfinal/wp-content/uploads/2017/05/IMG-20170601-WA0004.jpg\";s:6:\"slide4\";s:0:\"\";s:19:\"show_silder_in_post\";i:1;s:12:\"slide1_title\";s:0:\"\";s:12:\"slide2_title\";s:0:\"\";s:12:\"slide3_title\";s:0:\"\";s:12:\"slide4_title\";s:0:\"\";s:18:\"slide1_description\";s:0:\"\";s:18:\"slide2_description\";s:0:\"\";s:18:\"slide3_description\";s:0:\"\";s:18:\"slide4_description\";s:0:\"\";s:20:\"slide1_readmore_text\";s:0:\"\";s:20:\"slide2_readmore_text\";s:0:\"\";s:20:\"slide3_readmore_text\";s:0:\"\";s:20:\"slide4_readmore_text\";s:0:\"\";s:27:\"slide1_readmore_button_icon\";s:0:\"\";s:27:\"slide2_readmore_button_icon\";s:0:\"\";s:27:\"slide3_readmore_button_icon\";s:0:\"\";s:27:\"slide4_readmore_button_icon\";s:0:\"\";s:20:\"slide1_readmore_link\";s:0:\"\";s:20:\"slide2_readmore_link\";s:0:\"\";s:20:\"slide3_readmore_link\";s:0:\"\";s:20:\"slide4_readmore_link\";s:0:\"\";s:22:\"features_readmore_text\";s:0:\"\";s:22:\"services_readmore_text\";s:0:\"\";s:18:\"blog_readmore_text\";s:0:\"\";s:23:\"search_results_for_text\";s:0:\"\";s:11:\"tagged_text\";s:0:\"\";s:14:\"posted_on_text\";s:0:\"\";s:7:\"by_text\";s:0:\"\";s:14:\"posted_in_text\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("571", "theme_mods_catch-everest", "a:9:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:12:\"header_image\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:17:\"header_image_data\";O:8:\"stdClass\":5:{s:13:\"attachment_id\";i:50;s:3:\"url\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:13:\"thumbnail_url\";s:81:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\";s:6:\"height\";i:500;s:5:\"width\";i:1920;}s:12:\"logo_version\";s:3:\"3.6\";s:18:\"custom_css_post_id\";i:-1;s:11:\"custom_logo\";i:59;s:16:\"header_textcolor\";s:5:\"blank\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496904077;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("572", "widget_widget_catcheverest_social_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("573", "widget_widget_catcheverest_adspace_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("578", "_transient_timeout_catcheverest_default_sliders", "1496956275", "no");
INSERT INTO `act_options` VALUES("579", "_transient_catcheverest_default_sliders", "\n		<div id=\"main-slider\" class=\"container\">\n			<section class=\"featured-slider\">\n				<article class=\"post hentry slides displayblock\">\n					<figure class=\"slider-image\">\n						<a title=\"Mount Everest\" href=\"#\">\n							<img src=\"http://localhost/actfinal/wp-content/themes/catch-everest/images/slider1.jpg\" class=\"wp-post-image\" alt=\"Mount Everest\" title=\"Mount Everest\">\n						</a>\n					</figure>\n					<div class=\"entry-container\">\n						<header class=\"entry-header\">\n							<h1 class=\"entry-title\">\n								<a title=\"Mount Everest\" href=\"#\"><span>Mount Everest</span></a>\n							</h1>\n						</header>\n						<div class=\"entry-content\">\n							<p>Mount Everest is the Earth\'s highest mountain, with a peak at 8,848 metres above sea level and the 5th tallest mountain measured from the centre of the Earth. It is located in the Nepal.</p>\n						</div>\n					</div>\n				</article><!-- .slides -->\n\n				<article class=\"post hentry slides displaynone\">\n					<figure class=\"slider-image\">\n						<a title=\"Nepal Prayer Wheels\" href=\"#\">\n							<img src=\"http://localhost/actfinal/wp-content/themes/catch-everest/images/slider2.jpg\" class=\"wp-post-image\" alt=\"Nepal Prayer Wheels\" title=\"Nepal Prayer Wheels\">\n						</a>\n					</figure>\n					<div class=\"entry-container\">\n						<header class=\"entry-header\">\n							<h1 class=\"entry-title\">\n								<a title=\"Nepal Prayer Wheels\" href=\"#\"><span>Nepal Prayer Wheels</span></a>\n							</h1>\n						</header>\n						<div class=\"entry-content\">\n							<p>A prayer wheel is a cylindrical wheel on a spindle made from metal, wood, stone, leather or coarse cotton. Traditionally, the mantra Om Mani Padme Hum is written in Sanskrit on the outside of the wheel.</p>\n						</div>\n					</div>\n				</article><!-- .slides -->\n			</section>\n			<div id=\"slider-nav\">\n				<a class=\"slide-previous\">&lt;</a>\n				<a class=\"slide-next\">&gt;</a>\n			</div>\n			<div id=\"controllers\"></div>\n		</div><!-- #main-slider -->", "no");
INSERT INTO `act_options` VALUES("582", "_transient_timeout_catcheverest_footer_content_new", "1496956276", "no");
INSERT INTO `act_options` VALUES("583", "_transient_catcheverest_footer_content_new", "<div class=\"copyright\">Copyright &copy; 2017 <a href=\"http://localhost/actfinal/\" title=\"Absolute Comfort Travel\" ><span>Absolute Comfort Travel</span></a> All Rights Reserved.</div><div class=\"powered\"><span class=\"theme-name\">Catch Everest Theme by </span><span class=\"theme-author\"><a href=\"https://catchthemes.com/\" target=\"_blank\" title=\"Catch Themes\">Catch Themes</a></span></div>", "no");
INSERT INTO `act_options` VALUES("689", "catcheverest_options", "a:70:{s:28:\"enable_featured_header_image\";s:7:\"allpage\";s:25:\"featured_header_image_url\";s:0:\"\";s:25:\"featured_header_image_alt\";s:0:\"\";s:26:\"featured_header_image_base\";s:1:\"0\";s:18:\"disable_responsive\";s:1:\"0\";s:28:\"disable_header_right_sidebar\";s:1:\"0\";s:10:\"custom_css\";s:0:\"\";s:16:\"disable_scrollup\";s:1:\"0\";s:14:\"sidebar_layout\";s:21:\"no-sidebar-full-width\";s:14:\"content_layout\";s:4:\"full\";s:12:\"reset_layout\";s:1:\"2\";s:13:\"more_tag_text\";s:23:\"Continue Reading &rarr;\";s:14:\"excerpt_length\";i:30;s:19:\"search_display_text\";s:15:\"Search &hellip;\";s:8:\"feed_url\";s:0:\"\";s:17:\"homepage_headline\";s:17:\"Homepage Headline\";s:20:\"homepage_subheadline\";s:48:\"You can edit or disable it through Theme Options\";s:25:\"disable_homepage_headline\";s:1:\"0\";s:28:\"disable_homepage_subheadline\";s:1:\"0\";s:25:\"disable_homepage_featured\";s:1:\"0\";s:26:\"homepage_featured_headline\";s:0:\"\";s:21:\"homepage_featured_qty\";i:3;s:23:\"homepage_featured_image\";a:0:{}s:21:\"homepage_featured_url\";a:0:{}s:22:\"homepage_featured_base\";a:0:{}s:23:\"homepage_featured_title\";a:0:{}s:25:\"homepage_featured_content\";a:0:{}s:17:\"enable_posts_home\";s:1:\"0\";s:19:\"front_page_category\";s:1:\"0\";s:13:\"enable_slider\";s:22:\"enable-slider-homepage\";s:10:\"slider_qty\";i:4;s:17:\"transition_effect\";s:4:\"fade\";s:16:\"transition_delay\";i:4;s:19:\"transition_duration\";i:1;s:19:\"exclude_slider_post\";i:0;s:15:\"featured_slider\";a:0:{}s:15:\"social_facebook\";s:0:\"\";s:14:\"social_twitter\";s:0:\"\";s:17:\"social_googleplus\";s:0:\"\";s:16:\"social_pinterest\";s:0:\"\";s:14:\"social_youtube\";s:0:\"\";s:12:\"social_vimeo\";s:0:\"\";s:15:\"social_linkedin\";s:0:\"\";s:17:\"social_slideshare\";s:0:\"\";s:17:\"social_foursquare\";s:0:\"\";s:13:\"social_flickr\";s:0:\"\";s:13:\"social_tumblr\";s:0:\"\";s:17:\"social_deviantart\";s:0:\"\";s:15:\"social_dribbble\";s:0:\"\";s:14:\"social_myspace\";s:0:\"\";s:16:\"social_wordpress\";s:0:\"\";s:10:\"social_rss\";s:0:\"\";s:16:\"social_delicious\";s:0:\"\";s:13:\"social_lastfm\";s:0:\"\";s:16:\"social_instagram\";s:0:\"\";s:13:\"social_github\";s:0:\"\";s:16:\"social_vkontakte\";s:0:\"\";s:14:\"social_myworld\";s:0:\"\";s:20:\"social_odnoklassniki\";s:0:\"\";s:16:\"social_goodreads\";s:0:\"\";s:12:\"social_skype\";s:0:\"\";s:17:\"social_soundcloud\";s:0:\"\";s:12:\"social_email\";s:0:\"\";s:14:\"social_contact\";s:0:\"\";s:11:\"social_xing\";s:0:\"\";s:19:\"google_verification\";s:0:\"\";s:18:\"yahoo_verification\";s:0:\"\";s:17:\"bing_verification\";s:0:\"\";s:15:\"analytic_header\";s:0:\"\";s:15:\"analytic_footer\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("690", "_transient_timeout_catcheverest_webmaster", "1496990968", "no");
INSERT INTO `act_options` VALUES("691", "_transient_catcheverest_webmaster", "", "no");
INSERT INTO `act_options` VALUES("693", "_transient_timeout_catcheverest_homepage_headline", "1496956677", "no");
INSERT INTO `act_options` VALUES("694", "_transient_catcheverest_homepage_headline", "<div id=\"homepage-message\" class=\"container\"><p>Homepage Headline<span>You can edit or disable it through Theme Options</span></p></div>", "no");
INSERT INTO `act_options` VALUES("695", "_transient_timeout_catcheverest_scrollup", "1496956677", "no");
INSERT INTO `act_options` VALUES("696", "_transient_catcheverest_scrollup", "<a href=\"#masthead\" id=\"scrollup\"></a>", "no");
INSERT INTO `act_options` VALUES("697", "_transient_timeout_catcheverest_footercode", "1496990968", "no");
INSERT INTO `act_options` VALUES("698", "_transient_catcheverest_footercode", "", "no");
INSERT INTO `act_options` VALUES("718", "wpseo_sitemap_category_cache_validator", "6pHpA", "no");
INSERT INTO `act_options` VALUES("720", "wpseo_sitemap_79_cache_validator", "6TMqq", "no");
INSERT INTO `act_options` VALUES("726", "wpseo_sitemap_81_cache_validator", "6UerI", "no");
INSERT INTO `act_options` VALUES("729", "codepress_corporate_slider_category_setting", "4", "yes");
INSERT INTO `act_options` VALUES("735", "theme_mods_eleganto", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496904457;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:22:\"eleganto-right-sidebar\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:21:\"eleganto-left-sidebar\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("740", "theme_mods_one-page-express", "a:11:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:29:\"one-page-express_page_content\";s:16899:\" <div id=\"overlapable-2\"  style=\"background-color:#ffffff\"  data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" class=\"features-coloured-icon-boxes-section\" data-overlap=\"true\"> <div class=\"gridContainer\"> <div class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\"> <div class=\"features-coloured-icon-boxes-featurecol cp3cols\" > <div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"> <i data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-bolt\"></i> </div> <h4 class=\"\">Responsive Design</h4> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p> <a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a> </div> <div class=\"features-coloured-icon-boxes-featurecol cp3cols\" > <div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"> <i data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-cloud\"></i> </div> <h4 class=\"\">Responsive Design</h4> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p> <a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a> </div> <div class=\"features-coloured-icon-boxes-featurecol cp3cols\" > <div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"> <i data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-signal\"></i> </div> <h4 class=\"\">Responsive Design</h4> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p> <a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a> </div> <div class=\"features-coloured-icon-boxes-featurecol cp3cols\" > <div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"> <i data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-pie-chart\"></i> </div> <h4 class=\"\">Responsive Design</h4> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p> <a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a> </div> </div> </div></div> <div id=\"about-1\"  style=\"background-color:#f6f6f6\"  data-label=\"About\" data-id=\"about-big-images-section\" class=\"about-big-images-section\"> <div class=\"gridContainer\"> <div class=\"about-big-images-textrow\"> <div class=\"about-big-images-textcol\" data-type=\"column\"> <h5 class=\"\">LOREM IPSUM DOLOR</h5> <h3 class=\"\">Brand new WordPress theme&nbsp;<span href=\"#\" class=\"span25\">with unlimited power</span>&nbsp;and customization possibilities<br></h3> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p> <a class=\"button blue big\" href=\"#\">GET STARTED NOW</a> </div> </div> </div> <div class=\"about-big-images-bottomrow\"> <div class=\"about-big-images-leftimgcol\"><img class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\"> </div> <div class=\"about-big-images-centerimgcol\"><img class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\"> </div> <div class=\"about-big-images-rightimgcol\"><img class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"> </div> </div> </div> <div id=\"content-3\"  style=\"background-color:#ffffff\"  data-label=\"Content\" data-id=\"content-image-left\" class=\"content-left-image-section\"> <div class=\"gridContainer\"> <div class=\"row\"> <div class=\"content-left-image-imgcol\" data-type=\"column\"> <img src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"> </div> <div class=\"content-left-image-textcol\" data-type=\"column\"> <h2>This is one of the things <br>we do best&nbsp;</h2> <p class=\"large_text\"> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. </p> <a class=\"button blue\" href=\"#\"> LEARN MORE </a> </div> </div> </div> </div> <div id=\"content-4\"  style=\"background-color:#f6f6f6\"  data-label=\"Content\" data-id=\"content-image-right\" class=\"content-right-image-section\"> <div class=\"gridContainer\"> <div class=\"content-right-image-gridcol\"> <div class=\"content-right-image-textcol\" data-type=\"column\"> <h2>This is one of the things <br>we do best&nbsp;</h2> <p class=\"large_text\"> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. </p> <a class=\"button blue\" href=\"#\"> Learn More </a> </div> <div class=\"content-right-image-imgcol\" data-type=\"column\"> <img Reiki_Companion_Plugin src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"> </div> </div> </div> </div> <div id=\"portfolio-2\"  style=\"background-color:#ffffff\"  data-label=\"Portfolio\" data-id=\"portfolio-full-section\"> <div class=\"portfolio-full-section\" data-type=\"row\"> <div class=\"portfolio-full-projectco cp4cols cp4cols-tablet\" > <div class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\"> <div class=\"ContentSwap103_content initial-image\"><img class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\"> </div> <div class=\"overlay\" style=\"\"></div> <div class=\"swap-inner\" style=\"opacity: 1; display: block;\"> <div class=\"ContentSwap103-center\"> <h4 class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a class=\"button yellow\" href=\"#\">Check it out</a> </div> </div> </div> </div> <div class=\"portfolio-full-projectco cp4cols cp4cols-tablet\"> <div class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\" is-hovered=\"1\"> <div class=\"ContentSwap103_content initial-image\"><img class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"> </div> <div class=\"overlay\"></div> <div class=\"swap-inner\" style=\"opacity: 1; display: block;\"> <div class=\"ContentSwap103-center\"> <h4 class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a class=\"button yellow\" href=\"#\">CHECK IT OUT</a> </div> </div> </div> </div> <div class=\"portfolio-full-projectco cp4cols cp4cols-tablet\"> <div class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\" is-hovered=\"1\"> <div class=\"ContentSwap103_content initial-image\"><img class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\"> </div> <div class=\"overlay\"></div> <div class=\"swap-inner\" style=\"opacity: 1; display: block;\"> <div class=\"ContentSwap103-center\"> <h4 class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a class=\"button yellow\" href=\"#\">CHECK IT OUT</a> </div> </div> </div> </div></div></div> <div id=\"testimonials-1\"  style=\"background-color:#f6f6f6\"  data-label=\"Testimonials\" data-id=\"testimonials-boxed-section\" class=\"testimonials-boxed-section\"> <div class=\"gridContainer\"> <div class=\"testimonials-boxed-textcol\" data-type=\"column\"> <h2>What Our Clients Say</h2> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p> </div> <div class=\"testimonials-boxed-itemsrow\" data-type=\"row\"> <div class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"> <div class=\"testimonials-boxed-itemcard\" data-type=\"column\"> <h4 class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\"> <h5 class=\"testimonials-boxed-itemname\">Anna Johnson</h5> <h6 class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6> </div> </div> <div class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"> <div class=\"testimonials-boxed-itemcard\" data-type=\"column\"> <h4 class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\"> <h5 class=\"testimonials-boxed-itemname\">Eric Black</h5> <h6 class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6> </div> </div> <div class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"> <div class=\"testimonials-boxed-itemcard\" data-type=\"column\"> <h4 class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\"> <h5 class=\"testimonials-boxed-itemname\">John Collins</h5> <h6 class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6> </div> </div> </div> </div></div> <div id=\"cta-1\"  data-label=\"Call to action\" data-id=\"cta-blue-section\" class=\"cta-blue-section\"> <div class=\"gridContainer\"> <div class=\"cta-blue-innerrow\"> <div class=\"cta-blue-textcol\"> <h2 class=\"cta-blue-text\"> <b class=\"element2\"> Join us. </b> It will only take a minute </h2> </div> <div class=\"cta-blue-btncol\"> <a class=\"button transparent\" href=\"#\"> GET STARTED </a> </div> </div> </div> </div> <div id=\"team-1\"  style=\"background-color:#ffffff\"  data-label=\"Team\" data-id=\"team-colors-section\" class=\"team-colors-section\"> <div class=\"gridContainer\"> <div class=\"team-colors-textcol\"> <h2>Our Awesome Team</h2> <p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p> </div> <div class=\"team-colors-membersrow\" data-type=\"row\"> <div class=\"team-colors-membercol cp3cols cp6cols-tablet\"> <div class=\"team-colors-membercard\"> <div class=\"team-colors-background\"></div> <div class=\"team-colors-memberinfo\" data-type=\"column\"><img class=\"team-colors-memberimg\" height=\"175\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\"> <h4 class=\"team-colors-membername\">Chip Mayer</h4> <p class=\"team-colors-memberposition\">Co-founder &amp; CEO</p> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p> <hr class=\"team-colors-separator\"> </div> <div class=\"team-colors-membericons\" data-type=\"group\"> <a href=\"#\"><i data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a> </div> </div> </div> <div class=\"team-colors-membercol cp3cols cp6cols-tablet\"> <div class=\"team-colors-membercard\"> <div class=\"team-colors-background\"></div> <div class=\"team-colors-memberinfo\" data-type=\"column\"><img class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\"> <h4 class=\"team-colors-membername\">Jane Brown</h4> <p class=\"team-colors-memberposition\">Co-founder &amp; COO</p> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p> <hr class=\"team-colors-separator\"> </div> <div class=\"team-colors-membericons\" data-type=\"group\"> <a href=\"#\"><i data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a> </div> </div> </div> <div class=\"team-colors-membercol cp3cols cp6cols-tablet\"> <div class=\"team-colors-membercard\"> <div class=\"team-colors-background\"></div> <div class=\"team-colors-memberinfo\" data-type=\"column\"><img class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\"> <h4 class=\"team-colors-membername\">Erika Black&nbsp;</h4> <p class=\"team-colors-memberposition\">Marketing Director</p> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p> <hr class=\"team-colors-separator\"> </div> <div class=\"team-colors-membericons\" data-type=\"group\"> <a href=\"#\"><i data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a> </div> </div> </div> <div class=\"team-colors-membercol cp3cols cp6cols-tablet\"> <div class=\"team-colors-membercard\"> <div class=\"team-colors-background\"></div> <div class=\"team-colors-memberinfo\" data-type=\"column\"><img class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\"> <h4 class=\"team-colors-membername\">George Mayer</h4> <p class=\"team-colors-memberposition\">Creative Director</p> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p> <hr class=\"team-colors-separator\"> </div> <div class=\"team-colors-membericons\" data-type=\"group\"> <a href=\"#\"><i data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a> <a href=\"#\"><i data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a> </div> </div> </div> </div> </div></div> <div id=\"numbers\"  data-label=\"Numbers\" data-id=\"numbers-section\" data-bg=\"transparent\" class=\"numbers-section\" data-parallax-depth=\"20\" > <div class=\"gridContainer\"> <div class=\"numbers-itemcol\" > <h2 class=\"numbers-numbertext\" >230</h2> <h3 class=\"numbers-titletext\" >PROJECTS</h3> </div> <div class=\"numbers-itemcol\"> <h2 class=\"numbers-numbertext\">75340</h2> <h3 class=\"numbers-titletext\">WORKED HOURS</h3> </div> <div class=\"numbers-itemcol-last\"> <h2 class=\"numbers-numbertext\" >25</h2> <h3 class=\"numbers-titletext\" >EMPROYEES</h3> </div> </div></div><div id=\"latest-posts\"  style=\"background-color:#ffffff\"  data-label=\"Latest posts\" data-id=\"blog-section\" class=\"blog-section\" style=\"\"> <div class=\"gridContainer\" style=\"\"> <div class=\"blog-textrow\"> <div class=\"blog-textcol\" data-type=\"column\"> <h2>Latest News</h2> <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p> </div> </div> <div class=\"blog-postsrow\" data-type=\"row\" data-dynamic-columns=\"one_page_express_latest_news_columns\" data-content-shortcode=\"one_page_express_latest_news\"> [one_page_express_latest_news] </div> <div class=\"blog-textcol\"> <a class=\"button blue\" data-attr-shortcode=\"href:one_page_express_blog_link\" href=\"[one_page_express_blog_link]\">SEE ALL BLOG POSTS</a> </div> </div></div> <div id=\"contact-2\"  data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\" class=\"contact-section-formsection white-text\"> <div class=\"gridContainer\"> <div class=\"row_224\"> <div class=\"contact-textrow\"> <div class=\"contact-textcol\"> <h2 class=\"\">Say Hello</h2> <p class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p> </div> </div> </div> <div class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\"> [one_page_express_contact_form] </div> </div></div>\";s:18:\"custom_css_post_id\";i:-1;s:39:\"one_page_express_header_background_type\";s:9:\"slideshow\";s:33:\"one_page_express_header_slideshow\";a:3:{i:0;a:1:{s:3:\"url\";i:39;}i:1;a:1:{s:3:\"url\";i:37;}i:2;a:1:{s:3:\"url\";i:33;}}s:39:\"one_page_express_inner_header_slideshow\";a:2:{i:0;a:1:{s:3:\"url\";s:95:\"http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/home_page_header.jpg\";}i:1;a:1:{s:3:\"url\";s:98:\"http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/jeremy-bishop-14593.jpg\";}}s:12:\"page_content\";b:0;s:39:\"one_page_express_header_overlay_opacity\";s:3:\"0.4\";s:11:\"custom_logo\";i:67;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496903945;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:34:\"one_page_express_first_box_widgets\";N;s:35:\"one_page_express_second_box_widgets\";N;s:34:\"one_page_express_third_box_widgets\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("746", "one-page-express_companion_old_show_on_front", "page", "yes");
INSERT INTO `act_options` VALUES("747", "one-page-express_companion_old_page_on_front", "5", "yes");
INSERT INTO `act_options` VALUES("762", "widget_widget_wpmemwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("778", "theme_mods_sydney", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496969347;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("779", "widget_list", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("782", "widget_sydney_contact_info", "a:4:{i:1;a:0:{}i:2;a:5:{s:5:\"title\";s:76:\"Absolute Comfort Travel Silver Pool Office Suites Hurlingham – Jabavu Lane\";s:7:\"address\";s:29:\"P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:7:\"address\";s:82:\"Silver Pool Office Suites Hurlingham – Jabavu Lane P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("783", "widget_sydney_video_widget", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("784", "widget_sydney_action", "a:3:{i:1;a:0:{}i:2;a:6:{s:5:\"title\";s:14:\"Online Booking\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:6:\"inline\";b:0;s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:19:\"eds_animation_class\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("785", "widget_sydney_clients", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("786", "widget_sydney_employees", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("787", "widget_sydney_facts", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("788", "widget_sydney_latest_news", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("789", "widget_sydney_portfolio", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("790", "widget_sydney_services_type_a", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("791", "widget_sydney_services_type_b", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("792", "widget_sydney_skills", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("793", "widget_sydney_testimonials", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("797", "widget_membershipleveltext", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("798", "widget_membershipsubtext", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("799", "M_Installed", "14", "yes");
INSERT INTO `act_options` VALUES("800", "membership_options", "a:6:{s:17:\"registration_page\";i:101;s:12:\"account_page\";i:102;s:14:\"nocontent_page\";i:103;s:25:\"membershipadminshortcodes\";a:1:{i:0;s:12:\"contact-form\";}s:24:\"membershipdownloadgroups\";a:1:{i:0;s:7:\"default\";}s:10:\"masked_url\";s:9:\"downloads\";}", "yes");
INSERT INTO `act_options` VALUES("801", "M_Newsstream_Installed", "1", "yes");
INSERT INTO `act_options` VALUES("804", "m2_use_new_version", "1", "yes");
INSERT INTO `act_options` VALUES("805", "wdev-frash", "a:3:{s:7:\"plugins\";a:1:{s:25:\"membership/membership.php\";i:1496909040;}s:5:\"queue\";a:2:{s:32:\"2f2349a065f9b83a9c2f2c566bb3ac10\";a:4:{s:6:\"plugin\";s:25:\"membership/membership.php\";s:4:\"type\";s:5:\"email\";s:7:\"show_at\";i:1496909040;s:6:\"sticky\";b:1;}s:32:\"6abd59e31e245bc69fa6fc25e5f3228a\";a:3:{s:6:\"plugin\";s:25:\"membership/membership.php\";s:4:\"type\";s:4:\"rate\";s:7:\"show_at\";i:1497513840;}}s:4:\"done\";a:0:{}}", "no");
INSERT INTO `act_options` VALUES("806", "ms_model_settings", "a:19:{s:8:\"currency\";s:3:\"USD\";s:6:\"custom\";a:0:{}s:9:\"downloads\";a:2:{s:15:\"protection_type\";s:24:\"protection_type_complete\";s:10:\"masked_url\";s:9:\"downloads\";}s:14:\"hide_admin_bar\";b:1;s:19:\"hide_wizard_pointer\";b:0;s:2:\"id\";s:18:\"ms_plugin_settings\";s:6:\"import\";a:0:{}s:13:\"initial_setup\";b:0;s:19:\"invoice_sender_name\";s:0:\"\";s:19:\"is_first_membership\";b:0;s:24:\"is_first_paid_membership\";b:1;s:22:\"is_global_payments_set\";b:0;s:15:\"menu_protection\";s:4:\"item\";s:4:\"name\";s:15:\"Plugin settings\";s:14:\"plugin_enabled\";b:1;s:19:\"protection_messages\";a:0:{}s:12:\"special_view\";b:0;s:7:\"version\";s:7:\"4.0.1.3\";s:11:\"wizard_step\";s:8:\"overview\";}", "yes");
INSERT INTO `act_options` VALUES("807", "ms_model_pages", "a:4:{s:6:\"custom\";a:0:{}s:2:\"id\";N;s:4:\"name\";N;s:8:\"settings\";a:9:{s:7:\"site_id\";i:0;s:11:\"memberships\";i:104;s:17:\"protected-content\";i:105;s:8:\"register\";i:106;s:21:\"registration-complete\";i:107;s:7:\"account\";i:108;s:15:\"has_nav_account\";b:1;s:19:\"has_nav_memberships\";b:1;s:16:\"has_nav_register\";b:1;}}", "yes");
INSERT INTO `act_options` VALUES("808", "ms_model_addon", "a:5:{s:6:\"active\";a:0:{}s:11:\"addon_files\";a:24:{s:29:\"class-ms-addon-attributes.php\";s:69:\"plugins\\membership/app/addon/attributes/class-ms-addon-attributes.php\";s:30:\"class-ms-addon-automessage.php\";s:71:\"plugins\\membership/app/addon/automessage/class-ms-addon-automessage.php\";s:26:\"class-ms-addon-bbpress.php\";s:63:\"plugins\\membership/app/addon/bbpress/class-ms-addon-bbpress.php\";s:29:\"class-ms-addon-buddypress.php\";s:69:\"plugins\\membership/app/addon/buddypress/class-ms-addon-buddypress.php\";s:27:\"class-ms-addon-category.php\";s:65:\"plugins\\membership/app/addon/category/class-ms-addon-category.php\";s:25:\"class-ms-addon-coupon.php\";s:61:\"plugins\\membership/app/addon/coupon/class-ms-addon-coupon.php\";s:29:\"class-ms-addon-invitation.php\";s:69:\"plugins\\membership/app/addon/invitation/class-ms-addon-invitation.php\";s:33:\"class-ms-addon-mailchimp-view.php\";s:72:\"plugins\\membership/app/addon/mailchimp/class-ms-addon-mailchimp-view.php\";s:28:\"class-ms-addon-mailchimp.php\";s:67:\"plugins\\membership/app/addon/mailchimp/class-ms-addon-mailchimp.php\";s:29:\"class-ms-addon-mediafiles.php\";s:69:\"plugins\\membership/app/addon/mediafiles/class-ms-addon-mediafiles.php\";s:32:\"class-ms-addon-profilefields.php\";s:75:\"plugins\\membership/app/addon/profilefields/class-ms-addon-profilefields.php\";s:26:\"class-ms-addon-prorate.php\";s:63:\"plugins\\membership/app/addon/prorate/class-ms-addon-prorate.php\";s:33:\"class-ms-addon-redirect-model.php\";s:71:\"plugins\\membership/app/addon/redirect/class-ms-addon-redirect-model.php\";s:32:\"class-ms-addon-redirect-view.php\";s:70:\"plugins\\membership/app/addon/redirect/class-ms-addon-redirect-view.php\";s:27:\"class-ms-addon-redirect.php\";s:65:\"plugins\\membership/app/addon/redirect/class-ms-addon-redirect.php\";s:30:\"class-ms-addon-searchindex.php\";s:71:\"plugins\\membership/app/addon/searchindex/class-ms-addon-searchindex.php\";s:29:\"class-ms-addon-taxamo-api.php\";s:65:\"plugins\\membership/app/addon/taxamo/class-ms-addon-taxamo-api.php\";s:31:\"class-ms-addon-taxamo-model.php\";s:67:\"plugins\\membership/app/addon/taxamo/class-ms-addon-taxamo-model.php\";s:37:\"class-ms-addon-taxamo-userprofile.php\";s:73:\"plugins\\membership/app/addon/taxamo/class-ms-addon-taxamo-userprofile.php\";s:30:\"class-ms-addon-taxamo-view.php\";s:66:\"plugins\\membership/app/addon/taxamo/class-ms-addon-taxamo-view.php\";s:25:\"class-ms-addon-taxamo.php\";s:61:\"plugins\\membership/app/addon/taxamo/class-ms-addon-taxamo.php\";s:23:\"class-ms-addon-wpbe.php\";s:57:\"plugins\\membership/app/addon/wpbe/class-ms-addon-wpbe.php\";s:23:\"class-ms-addon-wpml.php\";s:57:\"plugins\\membership/app/addon/wpml/class-ms-addon-wpml.php\";s:30:\"class-ms-addon-wprecaptcha.php\";s:71:\"plugins\\membership/app/addon/wprecaptcha/class-ms-addon-wprecaptcha.php\";}s:6:\"custom\";a:0:{}s:2:\"id\";N;s:4:\"name\";N;}", "yes");
INSERT INTO `act_options` VALUES("809", "widget_ms_widget_login", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("810", "wpseo_sitemap_ms_membership_cache_validator", "37n7P", "no");
INSERT INTO `act_options` VALUES("811", "ms_model_gateway", "a:4:{s:6:\"custom\";a:0:{}s:13:\"gateway_files\";a:7:{s:30:\"class-ms-gateway-authorize.php\";s:71:\"plugins\\membership/app/gateway/authorize/class-ms-gateway-authorize.php\";s:25:\"class-ms-gateway-free.php\";s:61:\"plugins\\membership/app/gateway/free/class-ms-gateway-free.php\";s:27:\"class-ms-gateway-manual.php\";s:65:\"plugins\\membership/app/gateway/manual/class-ms-gateway-manual.php\";s:33:\"class-ms-gateway-paypalsingle.php\";s:77:\"plugins\\membership/app/gateway/paypalsingle/class-ms-gateway-paypalsingle.php\";s:35:\"class-ms-gateway-paypalstandard.php\";s:81:\"plugins\\membership/app/gateway/paypalstandard/class-ms-gateway-paypalstandard.php\";s:31:\"class-ms-gateway-stripe-api.php\";s:69:\"plugins\\membership/app/gateway/stripe/class-ms-gateway-stripe-api.php\";s:27:\"class-ms-gateway-stripe.php\";s:65:\"plugins\\membership/app/gateway/stripe/class-ms-gateway-stripe.php\";}s:2:\"id\";N;s:4:\"name\";N;}", "yes");
INSERT INTO `act_options` VALUES("815", "wpseo_sitemap_ms_invoice_cache_validator", "37QTP", "no");
INSERT INTO `act_options` VALUES("850", "siteorigin_panels_active_version", "2.5.6", "yes");
INSERT INTO `act_options` VALUES("854", "theme_mods_vogue", "a:6:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:12:\"header_image\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:17:\"header_image_data\";O:8:\"stdClass\":5:{s:13:\"attachment_id\";i:67;s:3:\"url\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:13:\"thumbnail_url\";s:88:\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\";s:6:\"height\";i:74;s:5:\"width\";i:190;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496914366;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:26:\"vogue-site-footer-standard\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("864", "wpseo_sitemap_129_cache_validator", "3oXFa", "no");
INSERT INTO `act_options` VALUES("883", "booking_activation_process", "Off", "yes");
INSERT INTO `act_options` VALUES("884", "booking_admin_cal_count", "2", "yes");
INSERT INTO `act_options` VALUES("885", "booking_skin", "/css/skins/black.css", "yes");
INSERT INTO `act_options` VALUES("886", "booking_num_per_page", "10", "yes");
INSERT INTO `act_options` VALUES("887", "booking_sort_order", "", "yes");
INSERT INTO `act_options` VALUES("888", "booking_default_toolbar_tab", "filter", "yes");
INSERT INTO `act_options` VALUES("889", "booking_listing_default_view_mode", "vm_calendar", "yes");
INSERT INTO `act_options` VALUES("890", "booking_view_days_num", "90", "yes");
INSERT INTO `act_options` VALUES("891", "booking_max_monthes_in_calendar", "1y", "yes");
INSERT INTO `act_options` VALUES("892", "booking_client_cal_count", "1", "yes");
INSERT INTO `act_options` VALUES("893", "booking_start_day_weeek", "0", "yes");
INSERT INTO `act_options` VALUES("894", "booking_title_after_reservation", "Thank you for your online booking.  We will send confirmation of your booking as soon as possible.", "yes");
INSERT INTO `act_options` VALUES("895", "booking_title_after_reservation_time", "7000", "yes");
INSERT INTO `act_options` VALUES("896", "booking_type_of_thank_you_message", "message", "yes");
INSERT INTO `act_options` VALUES("897", "booking_thank_you_page_URL", "/thank-you", "yes");
INSERT INTO `act_options` VALUES("898", "booking_is_use_autofill_4_logged_user", "On", "yes");
INSERT INTO `act_options` VALUES("899", "booking_date_format", "F j, Y", "yes");
INSERT INTO `act_options` VALUES("900", "booking_date_view_type", "short", "yes");
INSERT INTO `act_options` VALUES("901", "booking_is_delete_if_deactive", "Off", "yes");
INSERT INTO `act_options` VALUES("902", "booking_dif_colors_approval_pending", "On", "yes");
INSERT INTO `act_options` VALUES("903", "booking_is_use_hints_at_admin_panel", "On", "yes");
INSERT INTO `act_options` VALUES("904", "booking_is_not_load_bs_script_in_client", "Off", "yes");
INSERT INTO `act_options` VALUES("905", "booking_is_not_load_bs_script_in_admin", "Off", "yes");
INSERT INTO `act_options` VALUES("906", "booking_is_load_js_css_on_specific_pages", "Off", "yes");
INSERT INTO `act_options` VALUES("907", "booking_pages_for_load_js_css", "", "yes");
INSERT INTO `act_options` VALUES("908", "booking_type_of_day_selections", "multiple", "yes");
INSERT INTO `act_options` VALUES("909", "booking_form_is_using_bs_css", "On", "yes");
INSERT INTO `act_options` VALUES("910", "booking_form_format_type", "vertical", "yes");
INSERT INTO `act_options` VALUES("911", "booking_form_field_active1", "On", "yes");
INSERT INTO `act_options` VALUES("912", "booking_form_field_required1", "On", "yes");
INSERT INTO `act_options` VALUES("913", "booking_form_field_label1", "First Name", "yes");
INSERT INTO `act_options` VALUES("914", "booking_form_field_active2", "On", "yes");
INSERT INTO `act_options` VALUES("915", "booking_form_field_required2", "On", "yes");
INSERT INTO `act_options` VALUES("916", "booking_form_field_label2", "Last Name", "yes");
INSERT INTO `act_options` VALUES("917", "booking_form_field_active3", "On", "yes");
INSERT INTO `act_options` VALUES("918", "booking_form_field_required3", "On", "yes");
INSERT INTO `act_options` VALUES("919", "booking_form_field_label3", "Email", "yes");
INSERT INTO `act_options` VALUES("920", "booking_form_field_active4", "On", "yes");
INSERT INTO `act_options` VALUES("921", "booking_form_field_required4", "Off", "yes");
INSERT INTO `act_options` VALUES("922", "booking_form_field_label4", "Phone", "yes");
INSERT INTO `act_options` VALUES("923", "booking_form_field_active5", "On", "yes");
INSERT INTO `act_options` VALUES("924", "booking_form_field_required5", "Off", "yes");
INSERT INTO `act_options` VALUES("925", "booking_form_field_label5", "Details", "yes");
INSERT INTO `act_options` VALUES("926", "booking_form_field_active6", "Off", "yes");
INSERT INTO `act_options` VALUES("927", "booking_form_field_required6", "Off", "yes");
INSERT INTO `act_options` VALUES("928", "booking_form_field_label6", "Visitors", "yes");
INSERT INTO `act_options` VALUES("929", "booking_form_field_values6", "1\n2\n3\n4", "yes");
INSERT INTO `act_options` VALUES("930", "booking_is_days_always_available", "Off", "yes");
INSERT INTO `act_options` VALUES("931", "booking_check_on_server_if_dates_free", "Off", "yes");
INSERT INTO `act_options` VALUES("932", "booking_unavailable_days_num_from_today", "0", "yes");
INSERT INTO `act_options` VALUES("933", "booking_unavailable_day0", "On", "yes");
INSERT INTO `act_options` VALUES("934", "booking_unavailable_day1", "On", "yes");
INSERT INTO `act_options` VALUES("935", "booking_unavailable_day2", "On", "yes");
INSERT INTO `act_options` VALUES("936", "booking_unavailable_day3", "On", "yes");
INSERT INTO `act_options` VALUES("937", "booking_unavailable_day4", "On", "yes");
INSERT INTO `act_options` VALUES("938", "booking_unavailable_day5", "On", "yes");
INSERT INTO `act_options` VALUES("939", "booking_unavailable_day6", "On", "yes");
INSERT INTO `act_options` VALUES("940", "booking_menu_position", "top", "yes");
INSERT INTO `act_options` VALUES("941", "booking_user_role_booking", "editor", "yes");
INSERT INTO `act_options` VALUES("942", "booking_user_role_addbooking", "editor", "yes");
INSERT INTO `act_options` VALUES("943", "booking_user_role_resources", "editor", "yes");
INSERT INTO `act_options` VALUES("944", "booking_user_role_settings", "administrator", "yes");
INSERT INTO `act_options` VALUES("945", "booking_is_email_reservation_adress", "On", "yes");
INSERT INTO `act_options` VALUES("946", "booking_email_reservation_adress", "&quot;Booking system&quot; &lt;absolutecomfortkenya@gmail.com&gt;", "yes");
INSERT INTO `act_options` VALUES("947", "booking_email_reservation_from_adress", "[visitoremail]", "yes");
INSERT INTO `act_options` VALUES("948", "booking_email_reservation_subject", "New booking", "yes");
INSERT INTO `act_options` VALUES("949", "booking_email_reservation_content", "You need to approve a new booking [bookingtype] for: [dates]&lt;br/&gt;&lt;br/&gt; Person detail information:&lt;br/&gt; [content]&lt;br/&gt;&lt;br/&gt; Currently a new booking is waiting for approval. Please visit the moderation panel [moderatelink]&lt;br/&gt;&lt;br/&gt;Thank you, Absolute Comfort Travel&lt;br/&gt;[siteurl]", "yes");
INSERT INTO `act_options` VALUES("950", "booking_is_email_newbookingbyperson_adress", "Off", "yes");
INSERT INTO `act_options` VALUES("951", "booking_email_newbookingbyperson_adress", "&quot;Booking system&quot; &lt;absolutecomfortkenya@gmail.com&gt;", "yes");
INSERT INTO `act_options` VALUES("952", "booking_email_newbookingbyperson_subject", "New booking", "yes");
INSERT INTO `act_options` VALUES("953", "booking_email_newbookingbyperson_content", "Your reservation [bookingtype] for: [dates] is processing now! We will send confirmation by email. &lt;br/&gt;&lt;br/&gt;[content]&lt;br/&gt;&lt;br/&gt; Thank you, Absolute Comfort Travel&lt;br/&gt;[siteurl]", "yes");
INSERT INTO `act_options` VALUES("954", "booking_is_email_approval_adress", "On", "yes");
INSERT INTO `act_options` VALUES("955", "booking_is_email_approval_send_copy_to_admin", "Off", "yes");
INSERT INTO `act_options` VALUES("956", "booking_email_approval_adress", "&quot;Booking system&quot; &lt;absolutecomfortkenya@gmail.com&gt;", "yes");
INSERT INTO `act_options` VALUES("957", "booking_email_approval_subject", "Your booking has been approved", "yes");
INSERT INTO `act_options` VALUES("958", "booking_email_approval_content", "Your booking [bookingtype] for: [dates] has been approved.&lt;br/&gt;&lt;br/&gt;[content]&lt;br/&gt;&lt;br/&gt;Thank you, Absolute Comfort Travel&lt;br/&gt;[siteurl]", "yes");
INSERT INTO `act_options` VALUES("959", "booking_is_email_deny_adress", "On", "yes");
INSERT INTO `act_options` VALUES("960", "booking_is_email_deny_send_copy_to_admin", "Off", "yes");
INSERT INTO `act_options` VALUES("961", "booking_email_deny_adress", "&quot;Booking system&quot; &lt;absolutecomfortkenya@gmail.com&gt;", "yes");
INSERT INTO `act_options` VALUES("962", "booking_email_deny_subject", "Your booking has been declined", "yes");
INSERT INTO `act_options` VALUES("963", "booking_email_deny_content", "Your booking [bookingtype] for: [dates] has been  canceled. &lt;br/&gt;[denyreason]&lt;br/&gt;&lt;br/&gt;[content]&lt;br/&gt;&lt;br/&gt;Thank you, Absolute Comfort Travel&lt;br/&gt;[siteurl]", "yes");
INSERT INTO `act_options` VALUES("964", "booking_widget_title", "Booking form", "yes");
INSERT INTO `act_options` VALUES("965", "booking_widget_show", "booking_form", "yes");
INSERT INTO `act_options` VALUES("966", "booking_widget_type", "1", "yes");
INSERT INTO `act_options` VALUES("967", "booking_widget_calendar_count", "1", "yes");
INSERT INTO `act_options` VALUES("968", "booking_widget_last_field", "", "yes");
INSERT INTO `act_options` VALUES("969", "booking_wpdev_copyright_adminpanel", "On", "yes");
INSERT INTO `act_options` VALUES("970", "booking_is_show_powered_by_notice", "On", "yes");
INSERT INTO `act_options` VALUES("971", "booking_is_use_captcha", "On", "yes");
INSERT INTO `act_options` VALUES("972", "booking_is_show_legend", "Off", "yes");
INSERT INTO `act_options` VALUES("973", "booking_legend_is_show_item_available", "On", "yes");
INSERT INTO `act_options` VALUES("974", "booking_legend_text_for_item_available", "Available", "yes");
INSERT INTO `act_options` VALUES("975", "booking_legend_is_show_item_pending", "On", "yes");
INSERT INTO `act_options` VALUES("976", "booking_legend_text_for_item_pending", "Pending", "yes");
INSERT INTO `act_options` VALUES("977", "booking_legend_is_show_item_approved", "On", "yes");
INSERT INTO `act_options` VALUES("978", "booking_legend_text_for_item_approved", "Booked", "yes");
INSERT INTO `act_options` VALUES("979", "booking_legend_is_show_numbers", "On", "yes");
INSERT INTO `act_options` VALUES("980", "booking_email_new_admin", "a:15:{s:7:\"enabled\";s:2:\"On\";s:2:\"to\";s:30:\"absolutecomfortkenya@gmail.com\";s:7:\"to_name\";s:14:\"Booking system\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:11:\"New booking\";s:7:\"content\";s:278:\"You need to approve a new booking [bookingtype] for: [dates]<br/><br/> Person detail information:<br/> [content]<br/><br/> Currently a new booking is waiting for approval. Please visit the moderation panel [moderatelink]<br/><br/>Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("981", "booking_email_new_visitor", "a:13:{s:7:\"enabled\";s:2:\"On\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:11:\"New booking\";s:7:\"content\";s:177:\"Your reservation [bookingtype] for: [dates] is processing now! We will send confirmation by email. <br/><br/>[content]<br/><br/> Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("982", "booking_email_approved", "a:14:{s:7:\"enabled\";s:2:\"On\";s:13:\"copy_to_admin\";s:3:\"Off\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:30:\"Your booking has been approved\";s:7:\"content\";s:135:\"Your booking [bookingtype] for: [dates] has been approved.<br/><br/>[content]<br/><br/>Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("983", "booking_email_deleted", "a:14:{s:7:\"enabled\";s:2:\"On\";s:13:\"copy_to_admin\";s:3:\"Off\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:30:\"Your booking has been declined\";s:7:\"content\";s:154:\"Your booking [bookingtype] for: [dates] has been  canceled. <br/>[denyreason]<br/><br/>[content]<br/><br/>Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("984", "booking_email_deny", "a:14:{s:7:\"enabled\";s:2:\"On\";s:13:\"copy_to_admin\";s:3:\"Off\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:30:\"Your booking has been declined\";s:7:\"content\";s:154:\"Your booking [bookingtype] for: [dates] has been  canceled. <br/>[denyreason]<br/><br/>[content]<br/><br/>Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("985", "booking_email_trash", "a:14:{s:7:\"enabled\";s:2:\"On\";s:13:\"copy_to_admin\";s:3:\"Off\";s:4:\"from\";s:30:\"absolutecomfortkenya@gmail.com\";s:9:\"from_name\";s:14:\"Booking system\";s:7:\"subject\";s:30:\"Your booking has been declined\";s:7:\"content\";s:154:\"Your booking [bookingtype] for: [dates] has been  canceled. <br/>[denyreason]<br/><br/>[content]<br/><br/>Thank you, Absolute Comfort Travel<br/>[siteurl]\";s:14:\"header_content\";s:0:\"\";s:14:\"footer_content\";s:0:\"\";s:13:\"template_file\";s:5:\"plain\";s:10:\"base_color\";s:7:\"#557da1\";s:16:\"background_color\";s:7:\"#f5f5f5\";s:10:\"body_color\";s:7:\"#fdfdfd\";s:10:\"text_color\";s:7:\"#505050\";s:18:\"email_content_type\";s:4:\"html\";}", "yes");
INSERT INTO `act_options` VALUES("986", "booking_form", "[calendar]\n<div class=\"standard-form\">\n     <p>Name*:<br />[text* name]</p>\n     <p>Email*:<br />[email* email]</p>\n     <p>Phone*:<br />[text* phone]</p>\n     <p>Details*:<br />[textarea* details]</p>\n     <p>[checkbox* individual use_label_element \"individual\"]</p>\n     <p>[checkbox* corporate use_label_element \"Corporate\"]</p>\n     <p>[captcha]</p>\n     <p>[submit class:btn \"Send\"]</p>\n</div>\n", "yes");
INSERT INTO `act_options` VALUES("987", "booking_form_show", "<div style=\"text-align:left;word-wrap: break-word;\">\n  <strong>Name</strong>: <span class=\"fieldvalue\">[name]</span><br/>\n  <strong>Email</strong>: <span class=\"fieldvalue\">[email]</span><br/>\n  <strong>Phone</strong>: <span class=\"fieldvalue\">[phone]</span><br/>\n  <strong>Details</strong>: <span class=\"fieldvalue\">[details]</span><br/>\n  <strong>individual</strong>: <span class=\"fieldvalue\">[individual]</span><br/>\n  <strong>Corporate</strong>: <span class=\"fieldvalue\">[corporate]</span><br/>\n</div>", "yes");
INSERT INTO `act_options` VALUES("988", "booking_form_visual", "a:10:{i:0;a:2:{s:4:\"type\";s:8:\"calendar\";s:10:\"obligatory\";s:2:\"On\";}i:1;a:7:{s:4:\"type\";s:4:\"text\";s:4:\"name\";s:4:\"name\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:4:\"Name\";s:5:\"value\";s:0:\"\";}i:2;a:7:{s:4:\"type\";s:5:\"email\";s:4:\"name\";s:5:\"email\";s:10:\"obligatory\";s:2:\"On\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:5:\"Email\";s:5:\"value\";s:0:\"\";}i:3;a:7:{s:4:\"type\";s:6:\"select\";s:4:\"name\";s:8:\"visitors\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:3:\"Off\";s:8:\"required\";s:3:\"Off\";s:5:\"label\";s:8:\"Visitors\";s:5:\"value\";s:10:\"1\r\n2\r\n3\r\n4\";}i:4;a:7:{s:4:\"type\";s:4:\"text\";s:4:\"name\";s:5:\"phone\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:5:\"Phone\";s:5:\"value\";s:0:\"\";}i:5;a:7:{s:4:\"type\";s:8:\"textarea\";s:4:\"name\";s:7:\"details\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:7:\"Details\";s:5:\"value\";s:0:\"\";}i:6;a:7:{s:4:\"type\";s:8:\"checkbox\";s:4:\"name\";s:10:\"individual\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:10:\"individual\";s:5:\"value\";s:9:\"undefined\";}i:7;a:7:{s:4:\"type\";s:8:\"checkbox\";s:4:\"name\";s:9:\"corporate\";s:10:\"obligatory\";s:3:\"Off\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:9:\"Corporate\";s:5:\"value\";s:9:\"undefined\";}i:8;a:6:{s:4:\"type\";s:7:\"captcha\";s:4:\"name\";s:7:\"captcha\";s:10:\"obligatory\";s:2:\"On\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:0:\"\";}i:9;a:6:{s:4:\"type\";s:6:\"submit\";s:4:\"name\";s:6:\"submit\";s:10:\"obligatory\";s:2:\"On\";s:6:\"active\";s:2:\"On\";s:8:\"required\";s:2:\"On\";s:5:\"label\";s:4:\"Send\";}}", "yes");
INSERT INTO `act_options` VALUES("989", "booking_gcal_feed", "", "yes");
INSERT INTO `act_options` VALUES("990", "booking_gcal_events_from", "month-start", "yes");
INSERT INTO `act_options` VALUES("991", "booking_gcal_events_from_offset", "", "yes");
INSERT INTO `act_options` VALUES("992", "booking_gcal_events_from_offset_type", "", "yes");
INSERT INTO `act_options` VALUES("993", "booking_gcal_events_until", "any", "yes");
INSERT INTO `act_options` VALUES("994", "booking_gcal_events_until_offset", "", "yes");
INSERT INTO `act_options` VALUES("995", "booking_gcal_events_until_offset_type", "", "yes");
INSERT INTO `act_options` VALUES("996", "booking_gcal_events_max", "25", "yes");
INSERT INTO `act_options` VALUES("997", "booking_gcal_api_key", "", "yes");
INSERT INTO `act_options` VALUES("998", "booking_gcal_timezone", "", "yes");
INSERT INTO `act_options` VALUES("999", "booking_gcal_is_send_email", "Off", "yes");
INSERT INTO `act_options` VALUES("1000", "booking_gcal_auto_import_is_active", "Off", "yes");
INSERT INTO `act_options` VALUES("1001", "booking_gcal_auto_import_time", "24", "yes");
INSERT INTO `act_options` VALUES("1002", "booking_gcal_events_form_fields", "s:101:\"a:3:{s:5:\"title\";s:9:\"text^name\";s:11:\"description\";s:16:\"textarea^details\";s:5:\"where\";s:5:\"text^\";}\";", "yes");
INSERT INTO `act_options` VALUES("1003", "booking_version_num", "7.2", "yes");
INSERT INTO `act_options` VALUES("1006", "widget_bookingwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1007", "booking_activation_redirect_for_version", "7.2", "yes");
INSERT INTO `act_options` VALUES("1018", "theme_mods_car-rental-theme-0.1.3/car-rental", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1496917621;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:19:\"sidebar-widget-area\";a:0:{}}}}", "yes");
INSERT INTO `act_options` VALUES("1019", "rc_booking_statuses", "a:5:{s:8:\"canceled\";s:8:\"Canceled\";s:3:\"new\";s:3:\"New\";s:7:\"pending\";s:7:\"Pending\";s:7:\"renting\";s:7:\"Renting\";s:8:\"complete\";s:8:\"Complete\";}", "yes");
INSERT INTO `act_options` VALUES("1020", "rc_countries", "a:193:{i:0;s:11:\"Afghanistan\";i:1;s:7:\"Albania\";i:2;s:7:\"Algeria\";i:3;s:7:\"Andorra\";i:4;s:6:\"Angola\";i:5;s:19:\"Antigua and Barbuda\";i:6;s:9:\"Argentina\";i:7;s:7:\"Armenia\";i:8;s:9:\"Australia\";i:9;s:7:\"Austria\";i:10;s:10:\"Azerbaijan\";i:11;s:7:\"Bahamas\";i:12;s:7:\"Bahrain\";i:13;s:10:\"Bangladesh\";i:14;s:8:\"Barbados\";i:15;s:7:\"Belarus\";i:16;s:7:\"Belgium\";i:17;s:6:\"Belize\";i:18;s:5:\"Benin\";i:19;s:6:\"Bhutan\";i:20;s:7:\"Bolivia\";i:21;s:22:\"Bosnia and Herzegovina\";i:22;s:8:\"Botswana\";i:23;s:6:\"Brazil\";i:24;s:6:\"Brunei\";i:25;s:8:\"Bulgaria\";i:26;s:12:\"Burkina Faso\";i:27;s:7:\"Burundi\";i:28;s:8:\"Cambodia\";i:29;s:8:\"Cameroon\";i:30;s:6:\"Canada\";i:31;s:10:\"Cape Verde\";i:32;s:24:\"Central African Republic\";i:33;s:4:\"Chad\";i:34;s:5:\"Chile\";i:35;s:5:\"China\";i:36;s:7:\"Colombi\";i:37;s:7:\"Comoros\";i:38;s:19:\"Congo (Brazzaville)\";i:39;s:5:\"Congo\";i:40;s:10:\"Costa Rica\";i:41;s:13:\"Cote d\'Ivoire\";i:42;s:7:\"Croatia\";i:43;s:4:\"Cuba\";i:44;s:6:\"Cyprus\";i:45;s:14:\"Czech Republic\";i:46;s:7:\"Denmark\";i:47;s:8:\"Djibouti\";i:48;s:8:\"Dominica\";i:49;s:18:\"Dominican Republic\";i:50;s:24:\"East Timor (Timor Timur)\";i:51;s:7:\"Ecuador\";i:52;s:5:\"Egypt\";i:53;s:11:\"El Salvador\";i:54;s:17:\"Equatorial Guinea\";i:55;s:7:\"Eritrea\";i:56;s:7:\"Estonia\";i:57;s:8:\"Ethiopia\";i:58;s:4:\"Fiji\";i:59;s:7:\"Finland\";i:60;s:6:\"France\";i:61;s:5:\"Gabon\";i:62;s:11:\"Gambia, The\";i:63;s:7:\"Georgia\";i:64;s:7:\"Germany\";i:65;s:5:\"Ghana\";i:66;s:6:\"Greece\";i:67;s:7:\"Grenada\";i:68;s:9:\"Guatemala\";i:69;s:6:\"Guinea\";i:70;s:13:\"Guinea-Bissau\";i:71;s:6:\"Guyana\";i:72;s:5:\"Haiti\";i:73;s:8:\"Honduras\";i:74;s:7:\"Hungary\";i:75;s:7:\"Iceland\";i:76;s:5:\"India\";i:77;s:9:\"Indonesia\";i:78;s:4:\"Iran\";i:79;s:4:\"Iraq\";i:80;s:7:\"Ireland\";i:81;s:6:\"Israel\";i:82;s:5:\"Italy\";i:83;s:7:\"Jamaica\";i:84;s:5:\"Japan\";i:85;s:6:\"Jordan\";i:86;s:10:\"Kazakhstan\";i:87;s:5:\"Kenya\";i:88;s:8:\"Kiribati\";i:89;s:12:\"Korea, North\";i:90;s:12:\"Korea, South\";i:91;s:6:\"Kuwait\";i:92;s:10:\"Kyrgyzstan\";i:93;s:4:\"Laos\";i:94;s:6:\"Latvia\";i:95;s:7:\"Lebanon\";i:96;s:7:\"Lesotho\";i:97;s:7:\"Liberia\";i:98;s:5:\"Libya\";i:99;s:13:\"Liechtenstein\";i:100;s:9:\"Lithuania\";i:101;s:10:\"Luxembourg\";i:102;s:9:\"Macedonia\";i:103;s:10:\"Madagascar\";i:104;s:6:\"Malawi\";i:105;s:8:\"Malaysia\";i:106;s:8:\"Maldives\";i:107;s:4:\"Mali\";i:108;s:5:\"Malta\";i:109;s:16:\"Marshall Islands\";i:110;s:10:\"Mauritania\";i:111;s:9:\"Mauritius\";i:112;s:6:\"Mexico\";i:113;s:10:\"Micronesia\";i:114;s:7:\"Moldova\";i:115;s:6:\"Monaco\";i:116;s:8:\"Mongolia\";i:117;s:7:\"Morocco\";i:118;s:10:\"Mozambique\";i:119;s:7:\"Myanmar\";i:120;s:7:\"Namibia\";i:121;s:5:\"Nauru\";i:122;s:4:\"Nepa\";i:123;s:11:\"Netherlands\";i:124;s:11:\"New Zealand\";i:125;s:9:\"Nicaragua\";i:126;s:5:\"Niger\";i:127;s:7:\"Nigeria\";i:128;s:6:\"Norway\";i:129;s:4:\"Oman\";i:130;s:8:\"Pakistan\";i:131;s:5:\"Palau\";i:132;s:6:\"Panama\";i:133;s:16:\"Papua New Guinea\";i:134;s:8:\"Paraguay\";i:135;s:4:\"Peru\";i:136;s:11:\"Philippines\";i:137;s:6:\"Poland\";i:138;s:8:\"Portugal\";i:139;s:5:\"Qatar\";i:140;s:7:\"Romania\";i:141;s:6:\"Russia\";i:142;s:6:\"Rwanda\";i:143;s:21:\"Saint Kitts and Nevis\";i:144;s:11:\"Saint Lucia\";i:145;s:13:\"Saint Vincent\";i:146;s:5:\"Samoa\";i:147;s:10:\"San Marino\";i:148;s:21:\"Sao Tome and Principe\";i:149;s:12:\"Saudi Arabia\";i:150;s:7:\"Senegal\";i:151;s:21:\"Serbia and Montenegro\";i:152;s:10:\"Seychelles\";i:153;s:12:\"Sierra Leone\";i:154;s:9:\"Singapore\";i:155;s:8:\"Slovakia\";i:156;s:8:\"Slovenia\";i:157;s:15:\"Solomon Islands\";i:158;s:7:\"Somalia\";i:159;s:12:\"South Africa\";i:160;s:5:\"Spain\";i:161;s:9:\"Sri Lanka\";i:162;s:5:\"Sudan\";i:163;s:8:\"Suriname\";i:164;s:9:\"Swaziland\";i:165;s:6:\"Sweden\";i:166;s:11:\"Switzerland\";i:167;s:5:\"Syria\";i:168;s:6:\"Taiwan\";i:169;s:10:\"Tajikistan\";i:170;s:8:\"Tanzania\";i:171;s:8:\"Thailand\";i:172;s:4:\"Togo\";i:173;s:5:\"Tonga\";i:174;s:19:\"Trinidad and Tobago\";i:175;s:7:\"Tunisia\";i:176;s:6:\"Turkey\";i:177;s:12:\"Turkmenistan\";i:178;s:6:\"Tuvalu\";i:179;s:6:\"Uganda\";i:180;s:7:\"Ukraine\";i:181;s:20:\"United Arab Emirates\";i:182;s:14:\"United Kingdom\";i:183;s:13:\"United States\";i:184;s:7:\"Uruguay\";i:185;s:10:\"Uzbekistan\";i:186;s:7:\"Vanuatu\";i:187;s:12:\"Vatican City\";i:188;s:9:\"Venezuela\";i:189;s:7:\"Vietnam\";i:190;s:5:\"Yemen\";i:191;s:6:\"Zambia\";i:192;s:8:\"Zimbabwe\";}", "yes");
INSERT INTO `act_options` VALUES("1021", "rc_settings_booking_email", "absolutecomfortkenya@gmail.com", "yes");
INSERT INTO `act_options` VALUES("1022", "rc_settings_booking_notification", "1", "yes");
INSERT INTO `act_options` VALUES("1023", "rc_settings_default_currency_id", "2", "yes");
INSERT INTO `act_options` VALUES("1024", "rc_settings_auto_update_currency", "0", "yes");
INSERT INTO `act_options` VALUES("1025", "rc_settings_booking_page_id", "-1", "yes");
INSERT INTO `act_options` VALUES("1026", "rc_settings_terms_page_id", "-1", "yes");
INSERT INTO `act_options` VALUES("1027", "rc_settings_minimum_driving_age", "18", "yes");
INSERT INTO `act_options` VALUES("1028", "rc_settings_maximum_driving_age", "70", "yes");
INSERT INTO `act_options` VALUES("1029", "rc_customer_titles", "a:5:{i:0;s:2:\"Mr\";i:1;s:3:\"Mrs\";i:2;s:4:\"Miss\";i:3;s:2:\"Dr\";i:4;s:2:\"Ms\";}", "yes");
INSERT INTO `act_options` VALUES("1030", "rc_settings_theme_style", "green", "yes");
INSERT INTO `act_options` VALUES("1031", "rc_settings_sidebar_position", "right", "yes");
INSERT INTO `act_options` VALUES("1032", "rc_settings_contact_email", "absolutecomfortkenya@gmail.com", "yes");
INSERT INTO `act_options` VALUES("1033", "rc_settings_booking_notification_subject", "New booking", "yes");
INSERT INTO `act_options` VALUES("1034", "rc_settings_booking_notification_message", "Customer: %firstname% %lastname%\nVehicle: %vehicle%\nPickup date: %pickup_date%\nPickup location: %pickup_location%\nReturn date: %return_date%\nReturn location: %return_location%\nDuration: %duration% day(s)\nTotal payable: %total%\n\nYour comment: %comment%", "yes");
INSERT INTO `act_options` VALUES("1035", "rc_settings_customer_booking_subject", "Your booking", "yes");
INSERT INTO `act_options` VALUES("1036", "rc_settings_customer_registration_subject", "Login information", "yes");
INSERT INTO `act_options` VALUES("1037", "rc_settings_customer_registration_message", "Email: %email%\nPassword: %password%", "yes");
INSERT INTO `act_options` VALUES("1038", "rc_settings_password_recovery_subject", "New password", "yes");
INSERT INTO `act_options` VALUES("1039", "rc_settings_password_recovery_message", "Email: %email%\nNew password: %password%", "yes");
INSERT INTO `act_options` VALUES("1040", "rc_theme_version", "0.1.3", "yes");
INSERT INTO `act_options` VALUES("1041", "widget_sidebaradvert", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1042", "widget_arbitrarytext", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1050", "wpseo_sitemap_services_cache_validator", "6ttwS", "no");
INSERT INTO `act_options` VALUES("1066", "theme_mods_enigma-child", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1497137474;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:3:{i:0;s:13:\"media_image-2\";i:1;s:6:\"text-2\";i:2;s:6:\"text-3\";}s:15:\"sidebar-primary\";a:1:{i:0;s:8:\"search-2\";}s:18:\"footer-widget-area\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("1089", "Admin_custome_login_Version", "s:30:\"a:1:{s:7:\"Version\";s:3:\"1.0\";}\";", "yes");
INSERT INTO `act_options` VALUES("1090", "Admin_custome_login_dashboard", "s:44:\"a:1:{s:16:\"dashboard_status\";s:7:\"disable\";}\";", "yes");
INSERT INTO `act_options` VALUES("1091", "Admin_custome_login_top", "s:409:\"a:9:{s:11:\"top_bg_type\";s:23:\"static-background-image\";s:9:\"top_color\";s:7:\"#f9fad2\";s:9:\"top_image\";s:89:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/3d-background.jpg\";s:9:\"top_cover\";s:3:\"yes\";s:10:\"top_repeat\";s:6:\"repeat\";s:12:\"top_position\";s:8:\"left top\";s:14:\"top_attachment\";s:5:\"fixed\";s:16:\"top_slideshow_no\";s:1:\"6\";s:23:\"top_bg_slider_animation\";s:13:\"slider-style1\";}\";", "yes");
INSERT INTO `act_options` VALUES("1092", "Admin_custome_login_login", "s:832:\"a:20:{s:19:\"login_form_position\";s:7:\"default\";s:16:\"login_form_float\";s:6:\"center\";s:15:\"login_form_left\";s:3:\"700\";s:14:\"login_form_top\";s:3:\"300\";s:16:\"login_custom_css\";s:0:\"\";s:19:\"login_redirect_user\";s:0:\"\";s:13:\"login_bg_type\";s:23:\"static-background-image\";s:14:\"login_bg_color\";s:7:\"#1e73be\";s:15:\"login_bg_effect\";s:9:\"pattern-1\";s:14:\"login_bg_image\";s:89:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/3d-background.jpg\";s:18:\"login_form_opacity\";s:2:\"10\";s:16:\"login_form_width\";s:3:\"520\";s:17:\"login_form_radius\";s:2:\"10\";s:18:\"login_border_style\";s:5:\"solid\";s:21:\"login_border_thikness\";s:1:\"4\";s:18:\"login_border_color\";s:7:\"#0069A0\";s:15:\"login_bg_repeat\";s:6:\"repeat\";s:17:\"login_bg_position\";s:8:\"left top\";s:19:\"login_enable_shadow\";s:3:\"yes\";s:18:\"login_shadow_color\";s:7:\"#C8C8C8\";}\";", "yes");
INSERT INTO `act_options` VALUES("1093", "Admin_custome_login_text", "s:627:\"a:17:{s:18:\"heading_font_color\";s:7:\"#ffffff\";s:16:\"input_font_color\";s:7:\"#000000\";s:10:\"link_color\";s:7:\"#ffffff\";s:12:\"button_color\";s:7:\"#dd3333\";s:17:\"heading_font_size\";s:2:\"14\";s:15:\"input_font_size\";s:2:\"18\";s:9:\"link_size\";s:2:\"14\";s:16:\"button_font_size\";s:2:\"14\";s:18:\"enable_link_shadow\";s:3:\"yes\";s:17:\"link_shadow_color\";s:7:\"#ffffff\";s:18:\"heading_font_style\";s:9:\"Open Sans\";s:16:\"input_font_style\";s:9:\"Open Sans\";s:15:\"link_font_style\";s:9:\"Open Sans\";s:17:\"button_font_style\";s:9:\"Open Sans\";s:20:\"enable_inputbox_icon\";s:3:\"yes\";s:15:\"user_input_icon\";s:7:\"fa-user\";s:19:\"password_input_icon\";s:6:\"fa-key\";}\";", "yes");
INSERT INTO `act_options` VALUES("1094", "Admin_custome_login_logo", "s:277:\"a:5:{s:10:\"logo_image\";s:88:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/default-logo.png\";s:10:\"logo_width\";s:3:\"274\";s:11:\"logo_height\";s:2:\"63\";s:8:\"logo_url\";s:25:\"http://localhost/actfinal\";s:14:\"logo_url_title\";s:23:\"Your Site Name and Info\";}\";", "yes");
INSERT INTO `act_options` VALUES("1095", "Admin_custome_login_Social", "s:841:\"a:19:{s:18:\"enable_social_icon\";s:5:\"outer\";s:16:\"social_icon_size\";s:6:\"mediam\";s:18:\"social_icon_layout\";s:9:\"rectangle\";s:17:\"social_icon_color\";s:7:\"#ffffff\";s:25:\"social_icon_color_onhover\";s:7:\"#1e73be\";s:14:\"social_icon_bg\";s:7:\"#1e73be\";s:22:\"social_icon_bg_onhover\";s:7:\"#ffffff\";s:20:\"social_facebook_link\";s:19:\"http://facebook.com\";s:19:\"social_twitter_link\";s:33:\"https://twitter.com/minimalmonkey\";s:20:\"social_linkedin_link\";s:0:\"\";s:23:\"social_google_plus_link\";s:22:\"http://plus.google.com\";s:21:\"social_pinterest_link\";s:0:\"\";s:16:\"social_digg_link\";s:0:\"\";s:19:\"social_youtube_link\";s:19:\"https://youtube.com\";s:18:\"social_flickr_link\";s:18:\"https://flickr.com\";s:18:\"social_tumblr_link\";s:0:\"\";s:21:\"social_vkontakte_link\";s:0:\"\";s:17:\"social_skype_link\";s:0:\"\";s:21:\"social_instagram_link\";s:21:\"https://instagram.com\";}\";", "yes");
INSERT INTO `act_options` VALUES("1096", "Admin_custome_login_Slidshow", "s:943:\"a:12:{s:16:\"Slidshow_image_1\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:16:\"Slidshow_image_2\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:16:\"Slidshow_image_3\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:16:\"Slidshow_image_4\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:16:\"Slidshow_image_5\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:16:\"Slidshow_image_6\";s:87:\"http://localhost/actfinal/wp-content/plugins/admin-custom-login//images/rpg-default.jpg\";s:22:\"Slidshow_image_label_1\";s:0:\"\";s:22:\"Slidshow_image_label_2\";s:0:\"\";s:22:\"Slidshow_image_label_3\";s:0:\"\";s:22:\"Slidshow_image_label_4\";s:0:\"\";s:22:\"Slidshow_image_label_5\";s:0:\"\";s:22:\"Slidshow_image_label_6\";s:0:\"\";}\";", "yes");
INSERT INTO `act_options` VALUES("1098", "Appoint_notification", "a:35:{s:9:\"emailtype\";s:7:\"phpmail\";s:6:\"enable\";s:3:\"yes\";s:7:\"wpemail\";s:0:\"\";s:8:\"phpemail\";s:30:\"absolutecomfortkenya@gmail.com\";s:8:\"hostname\";s:0:\"\";s:6:\"portno\";s:0:\"\";s:9:\"smtpemail\";s:0:\"\";s:8:\"password\";s:0:\"\";s:32:\"send_notification_admin_approved\";s:3:\"yes\";s:22:\"subject_admin_approved\";s:86:\"Hi  [ADMIN_NAME]  : New Appointment Scheduled By [CLIENT_NAME] is [APPOINTMENT_STATUS]\";s:19:\"admin_body_approved\";s:340:\"\rHi Admin,\r	\rAppointment Details:\r\rClient Name: [CLIENT_NAME]\rClient Email: [CLIENT_EMAIL]\rAppointment For: [SERVICE_NAME]\rAppointment Date: 	[APPOINTMENT_DATE]\rAppointment Time: 	[APPOINTMENT_TIME]\rAppointment Status: 	[APPOINTMENT_STATUS]\r\rView this appointment at [SITE_URL] dashboard.\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:31:\"send_notification_admin_pending\";s:3:\"yes\";s:21:\"subject_admin_pending\";s:86:\"Hi  [ADMIN_NAME]  : New Appointment Scheduled By [CLIENT_NAME] is [APPOINTMENT_STATUS]\";s:18:\"admin_body_pending\";s:340:\"\rHi Admin,\r	\rAppointment Details:\r\rClient Name: [CLIENT_NAME]\rClient Email: [CLIENT_EMAIL]\rAppointment For: [SERVICE_NAME]\rAppointment Date: 	[APPOINTMENT_DATE]\rAppointment Time: 	[APPOINTMENT_TIME]\rAppointment Status: 	[APPOINTMENT_STATUS]\r\rView this appointment at [SITE_URL] dashboard.\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:33:\"send_notification_admin_cancelled\";s:3:\"yes\";s:23:\"subject_admin_cancelled\";s:86:\"Hi  [ADMIN_NAME]  : New Appointment Scheduled By [CLIENT_NAME] is [APPOINTMENT_STATUS]\";s:20:\"admin_body_cancelled\";s:340:\"\rHi Admin,\r	\rAppointment Details:\r\rClient Name: [CLIENT_NAME]\rClient Email: [CLIENT_EMAIL]\rAppointment For: [SERVICE_NAME]\rAppointment Date: 	[APPOINTMENT_DATE]\rAppointment Time: 	[APPOINTMENT_TIME]\rAppointment Status: 	[APPOINTMENT_STATUS]\r\rView this appointment at [SITE_URL] dashboard.\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:33:\"send_notification_client_approval\";s:3:\"yes\";s:36:\"subject_notification_client_approval\";s:33:\"[BLOG_NAME] : Appointment Status.\";s:33:\"body_notification_client_approval\";s:273:\"\rHi [CLIENT_NAME],\r\rYour scheduled appointment for [SERVICE_NAME] on [APPOINTMENT_DATE] from [APPOINTMENT_TIME] has been [APPOINTMENT_STATUS].\r\rThank you for scheduling appointment with [BLOG_NAME].\r\rPlease Dont forget!!!\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:32:\"send_notification_client_pending\";s:3:\"yes\";s:35:\"subject_notification_client_pending\";s:33:\"[BLOG_NAME] : Appointment Status.\";s:32:\"body_notification_client_pending\";s:256:\"\rHi [CLIENT_NAME],\r\rYour appointment for [SERVICE_NAME] on [APPOINTMENT_DATE] at [APPOINTMENT_TIME] is [APPOINTMENT_STATUS]..\r\rThank you for scheduling appointment with [BLOG_NAME].\r\rPlease Dont forget!!!\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:31:\"send_notification_client_cancel\";s:3:\"yes\";s:34:\"subject_notification_client_cancel\";s:33:\"[BLOG_NAME] : Appointment Status.\";s:31:\"body_notification_client_cancel\";s:251:\"\rHi [CLIENT_NAME],\r\rYour scheduled appointment for [SERVICE_NAME] on [APPOINTMENT_DATE] from [APPOINTMENT_TIME] has been [APPOINTMENT_STATUS].\r\rThank you for scheduling appointment with [BLOG_NAME].\r\r\rBest Regards \r[ADMIN_NAME]\r[BLOG_NAME]\r[SITE_URL]\r\";s:32:\"send_notification_staff_approval\";s:0:\"\";s:35:\"subject_notification_staff_approval\";s:0:\"\";s:32:\"body_notification_staff_approval\";s:0:\"\";s:31:\"send_notification_staff_pending\";s:0:\"\";s:34:\"subject_notification_staff_pending\";s:0:\"\";s:31:\"body_notification_staff_pending\";s:0:\"\";s:30:\"send_notification_staff_cancel\";s:0:\"\";s:33:\"subject_notification_staff_cancel\";s:0:\"\";s:30:\"body_notification_staff_cancel\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("1099", "service_tips", "\r<b>Follow The Step:</b></center>\r\r* Select Service.\r* Select Appointment Date.\r", "yes");
INSERT INTO `act_options` VALUES("1100", "time_tips", "\r<b>Follow The Step:</b>\r\r* Select Appointment Time.\r", "yes");
INSERT INTO `act_options` VALUES("1101", "details_tips", "\r<b>Follow The Step:</b>\r\r* Sign-Up If You Are New User. \r* Login If You Are Existing User. \r", "yes");
INSERT INTO `act_options` VALUES("1102", "confirm_tips", "\r<b>Follow The Step:</b>\r\r* Please Check The Appointment Details\r", "yes");
INSERT INTO `act_options` VALUES("1103", "payment_tips", "\r<b>Follow The Step:</b>\r\r* Select Payment Method.\r", "yes");
INSERT INTO `act_options` VALUES("1104", "done_tips", "\r<b>BOOKING DONE.</b>\rThank You! Your Booking Is Complete.\r", "yes");
INSERT INTO `act_options` VALUES("1105", "weblizar_rcsm_options", "a:81:{s:15:\"select_template\";s:16:\"select_template1\";s:15:\"page_meta_title\";s:52:\"Absolute Comfort Travel - Your Comfort is our pride!\";s:18:\"page_meta_keywords\";s:0:\"\";s:21:\"page_meta_discription\";s:56:\"Our website is under construction. It will be live soon.\";s:13:\"search_robots\";s:2:\"on\";s:16:\"rcsm_robots_meta\";s:12:\"index follow\";s:20:\"upload_image_favicon\";s:96:\"http://localhost/actfinal/wp-content/plugins/responsive-coming-soon-page/options/images/logo.png\";s:13:\"layout_status\";s:10:\"deactivate\";s:17:\"coming-soon_title\";s:26:\"Our Site Is Coming Soon!!!\";s:21:\"coming-soon_sub_title\";s:32:\"Stay Tuned For Something Amazing\";s:19:\"coming-soon_message\";s:41:\"Responsive Design & Faster User Interface\";s:9:\"site_logo\";s:10:\"logo_image\";s:15:\"logo_text_value\";s:23:\"Absolute Comfort Travel\";s:17:\"upload_image_logo\";s:96:\"http://localhost/actfinal/wp-content/plugins/responsive-coming-soon-page/options/images/logo.png\";s:11:\"logo_height\";s:3:\"150\";s:10:\"logo_width\";s:3:\"250\";s:8:\"bg_color\";s:7:\"#0098ff\";s:18:\"template_bg_select\";s:17:\"Custom_Background\";s:13:\"custom_bg_img\";s:99:\"http://localhost/actfinal/wp-content/plugins/responsive-coming-soon-page/options/images/cg_img1.jpg\";s:12:\"button_onoff\";s:2:\"on\";s:11:\"button_text\";s:13:\"DISCOVER MORE\";s:16:\"button_text_link\";s:6:\"#timer\";s:10:\"link_admin\";s:2:\"on\";s:15:\"admin_link_text\";s:15:\"Admin Dashboard\";s:10:\"user_value\";a:0:{}s:16:\"page_layout_swap\";a:2:{i:0;s:16:\"Count Down Timer\";i:1;s:15:\"Subscriber Form\";}s:19:\"theme_color_schemes\";s:7:\"#eb5054\";s:13:\"social_icon_1\";s:14:\"fa fa-facebook\";s:13:\"social_icon_2\";s:13:\"fa fa-twitter\";s:13:\"social_icon_3\";s:17:\"fa fa-google-plus\";s:13:\"social_icon_4\";s:14:\"fa fa-linkedin\";s:13:\"social_icon_5\";s:15:\"fa fa-pinterest\";s:13:\"social_link_1\";s:1:\"#\";s:13:\"social_link_2\";s:1:\"#\";s:13:\"social_link_3\";s:1:\"#\";s:13:\"social_link_4\";s:1:\"#\";s:13:\"social_link_5\";s:1:\"#\";s:10:\"link_tab_1\";s:3:\"off\";s:10:\"link_tab_2\";s:3:\"off\";s:10:\"link_tab_3\";s:3:\"off\";s:10:\"link_tab_4\";s:3:\"off\";s:10:\"link_tab_5\";s:3:\"off\";s:18:\"total_Social_links\";s:1:\"5\";s:16:\"social_icon_list\";s:0:\"\";s:15:\"subscriber_form\";s:2:\"on\";s:21:\"subscriber_form_title\";s:27:\"SUBSCRIBE TO OUR NEWSLETTER\";s:20:\"subscriber_form_icon\";s:16:\"fa fa-envelope-o\";s:25:\"subscriber_form_sub_title\";s:61:\"In the mean time connect with us to subscribed our newsletter\";s:23:\"subscriber_form_message\";s:92:\"Subscribe and we\'ll notify you on our launch. We\'ll also throw in a freebie for your effort.\";s:20:\"sub_form_button_text\";s:9:\"Subscribe\";s:22:\"sub_form_button_f_name\";s:10:\"First Name\";s:22:\"sub_form_button_l_name\";s:9:\"Last Name\";s:24:\"sub_form_subscribe_title\";s:5:\"Email\";s:9:\"user_sets\";s:14:\"$user_sets_all\";s:35:\"sub_form_subscribe_seuccess_message\";s:42:\"Thank you! We will be back with the quote.\";s:34:\"sub_form_subscribe_invalid_message\";s:28:\"You have already subscribed.\";s:19:\"subscriber_msg_body\";s:0:\"\";s:42:\"sub_form_subscribe_confirm_success_message\";s:83:\"Thank You!!! Subscription has been confirmed. We will notify when the site is live.\";s:42:\"sub_form_subscribe_already_confirm_message\";s:73:\"You subscription is already active. We will notify when the site is live.\";s:37:\"sub_form_invalid_confirmation_message\";s:36:\"Error: Invalid subscription details.\";s:16:\"subscribe_select\";s:7:\"wp_mail\";s:16:\"wp_mail_email_id\";s:30:\"absolutecomfortkenya@gmail.com\";s:23:\"confirm_email_subscribe\";s:3:\"off\";s:23:\"auto_sentto_activeusers\";s:2:\"on\";s:28:\"subscriber_users_mail_option\";s:9:\"all_users\";s:23:\"subscriber_mail_subject\";s:0:\"\";s:23:\"subscriber_mail_message\";s:0:\"\";s:13:\"counter_title\";s:17:\"We\'re Coming Soon\";s:18:\"counter_title_icon\";s:13:\"fa fa-clock-o\";s:11:\"counter_msg\";s:45:\"We Are Currently Working On Something Awesome\";s:18:\"disable_the_plugin\";s:3:\"off\";s:16:\"maintenance_date\";s:16:\"2017/06/16 08:50\";s:21:\"footer_copyright_text\";s:68:\"Copyright © 2016 Weblizar Themes & Plugins | All Rights Reserved By\";s:11:\"footer_link\";s:20:\"https://weblizar.com\";s:16:\"footer_link_text\";s:8:\"Weblizar\";s:10:\"custom_css\";s:0:\"\";s:16:\"google_analytics\";s:0:\"\";s:13:\"feedback_mail\";s:0:\"\";s:16:\"feedback_heading\";s:16:\"Book Appointment\";s:13:\"feedback_icon\";s:14:\"fa fa-calendar\";s:12:\"feedback_btn\";s:19:\"Booking Appointment\";}", "yes");
INSERT INTO `act_options` VALUES("1116", "theme_mods_sydney-child", "a:37:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:14:\"slider_image_1\";s:72:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_11_screened.jpg\";s:13:\"header_height\";i:300;s:10:\"menu_style\";s:6:\"inline\";s:9:\"site_logo\";s:61:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo.jpg\";s:13:\"primary_color\";s:7:\"#a2d729\";s:16:\"site_title_color\";s:7:\"#343a1a\";s:11:\"slider_text\";s:7:\"#ffffff\";s:18:\"sidebar_background\";s:7:\"#ffffff\";s:25:\"footer_widgets_background\";s:7:\"#252525\";s:20:\"footer_widgets_color\";s:7:\"#767676\";s:15:\"top_items_color\";s:7:\"#ffffff\";s:18:\"slider_button_text\";s:8:\"Book Now\";s:14:\"slider_title_1\";s:33:\"We cater to all your travel needs\";s:12:\"header_image\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\";s:17:\"header_image_data\";O:8:\"stdClass\":5:{s:13:\"attachment_id\";i:259;s:3:\"url\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\";s:13:\"thumbnail_url\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\";s:6:\"height\";i:1400;s:5:\"width\";i:1920;}s:14:\"slider_image_2\";s:72:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_screened.jpg\";s:14:\"slider_image_3\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_screened.jpg\";s:14:\"slider_image_4\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_3_screened.jpg\";s:14:\"slider_image_5\";s:71:\"http://localhost/actfinal/wp-content/uploads/2017/06/act_2_screened.jpg\";s:15:\"body_text_color\";s:7:\"#565656\";s:19:\"wrapper_top_padding\";i:15;s:22:\"wrapper_bottom_padding\";i:15;s:12:\"hide_overlay\";i:1;s:16:\"menu_items_hover\";s:7:\"#a2d729\";s:13:\"menu_bg_color\";s:7:\"#000000\";s:17:\"slider_subtitle_1\";s:82:\"We specialize in airport transfers, inter-office transfers and outstation services\";s:14:\"slider_title_2\";s:25:\"Travel with peace of mind\";s:17:\"slider_subtitle_2\";s:81:\"Two way radio for effective communication Vehicle tracking and monitoring devices\";s:14:\"slider_title_3\";s:7:\"Comfort\";s:17:\"slider_subtitle_3\";s:43:\"We have new, clean Air conditioned vehicles\";s:14:\"slider_title_4\";s:4:\"Safe\";s:17:\"slider_subtitle_4\";s:57:\"Our chauffeurs are well trained in safe defensive driving\";s:14:\"slider_title_5\";s:10:\"Affordable\";s:17:\"slider_subtitle_5\";s:31:\"Our prices are very competitive\";}", "yes");
INSERT INTO `act_options` VALUES("1131", "swpm_db_version", "1.2", "yes");
INSERT INTO `act_options` VALUES("1132", "swpm-settings", "a:42:{i:0;b:0;s:16:\"join-us-page-url\";s:42:\"http://localhost/actfinal/membership-join/\";s:21:\"registration-page-url\";s:66:\"http://localhost/actfinal/membership-join/membership-registration/\";s:14:\"login-page-url\";s:43:\"http://localhost/actfinal/membership-login/\";s:16:\"profile-page-url\";s:62:\"http://localhost/actfinal/membership-login/membership-profile/\";s:14:\"reset-page-url\";s:58:\"http://localhost/actfinal/membership-login/password-reset/\";s:25:\"reg-complete-mail-subject\";s:29:\"Your registration is complete\";s:22:\"reg-complete-mail-body\";s:223:\"Dear {first_name} {last_name}\r\n\r\nYour registration is now complete!\r\n\r\nRegistration details:\r\nUsername: {user_name}\r\nPassword: {password}\r\n\r\nPlease login to the member area at the following URL:\r\n\r\n{login_link}\r\n\r\nThank You\";s:32:\"reg-prompt-complete-mail-subject\";s:26:\"Complete your registration\";s:29:\"reg-prompt-complete-mail-body\";s:154:\"Dear {first_name} {last_name}\r\n\r\nThank you for joining us!\r\n\r\nPlease complete your registration by visiting the following link:\r\n\r\n{reg_link}\r\n\r\nThank You\";s:29:\"upgrade-complete-mail-subject\";s:44:\"Subject for email sent after account upgrade\";s:26:\"upgrade-complete-mail-body\";s:77:\"Dear {first_name} {last_name}\r\n\r\nYour Account Has Been Upgraded.\r\n\r\nThank You\";s:18:\"reset-mail-subject\";s:37:\"Absolute Comfort Travel: New Password\";s:15:\"reset-mail-body\";s:222:\"Dear {first_name} {last_name}\r\n\r\nHere is your new password:\r\n\r\nUsername: {user_name}\r\nPassword: {password}\r\n\r\nYou can change the password from the edit profile section of the site (after you log into the site)\r\n\r\nThank You\";s:28:\"account-change-email-subject\";s:16:\"Account Updated!\";s:25:\"account-change-email-body\";s:149:\"Dear {first_name} {last_name},\n\nYour account status has been updated! Please login to the member area at the following URL:\n\n {login_link}\n\nThank You\";s:10:\"email-from\";s:30:\"absolutecomfortkenya@gmail.com\";s:31:\"reg-complete-mail-subject-admin\";s:23:\"New Member Registration\";s:28:\"reg-complete-mail-body-admin\";s:251:\"A new member has completed the registration.\r\n\r\nUsername: {user_name}\r\nEmail: {email}\r\n\r\nPlease login to the admin dashboard to view details of this user.\r\n\r\nYou can customize this email message from the Email Settings menu of the plugin.\r\n\r\nThank You\";s:33:\"bulk-activate-notify-mail-subject\";s:18:\"Account Activated!\";s:30:\"bulk-activate-notify-mail-body\";s:93:\"Hi,\r\n\r\nYour account has been activated!\r\n\r\nYou can now login to the member area.\r\n\r\nThank You\";s:19:\"swpm-active-version\";s:5:\"3.4.9\";s:13:\"hide-adminbar\";s:27:\"checked=&#039;checked&#039;\";s:24:\"show-adminbar-admin-only\";s:27:\"checked=&#039;checked&#039;\";s:30:\"disable-access-to-wp-dashboard\";s:27:\"checked=&#039;checked&#039;\";s:18:\"protect-everything\";s:0:\"\";s:22:\"enable-free-membership\";s:27:\"checked=&#039;checked&#039;\";s:14:\"enable-moretag\";s:0:\"\";s:12:\"enable-debug\";s:0:\"\";s:22:\"enable-sandbox-testing\";s:0:\"\";s:18:\"free-membership-id\";i:2;s:22:\"default-account-status\";s:6:\"active\";s:24:\"members-login-to-comment\";s:27:\"checked=&#039;checked&#039;\";s:35:\"enable-admin-notification-after-reg\";s:27:\"checked=&#039;checked&#039;\";s:24:\"admin-notification-email\";s:61:\"absolutecomfortkenya@gmail.com,bookings@absolutecomfort.co.ke\";s:41:\"enable-notification-after-manual-user-add\";s:27:\"checked=&#039;checked&#039;\";s:28:\"enable-expired-account-login\";s:0:\"\";s:22:\"allow-account-deletion\";s:27:\"checked=&#039;checked&#039;\";s:22:\"use-wordpress-timezone\";s:27:\"checked=&#039;checked&#039;\";s:22:\"delete-pending-account\";s:1:\"0\";s:33:\"admin-dashboard-access-permission\";s:14:\"manage_options\";s:16:\"renewal-page-url\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("1133", "swpm_private_key_one", "593a81dd2d3d57.86361671", "yes");
INSERT INTO `act_options` VALUES("1159", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1497090177", "no");
INSERT INTO `act_options` VALUES("1160", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Popular — WordPress Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wordpress.org/plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"Plugins extend and expand the functionality of WordPress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 21:57:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=4.9-alpha-40885\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/contact-form-7/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/contact-form-7/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:43:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wordpress.org/plugins-wp/contact-form-7/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5025:\"<p><!--section=description--></p>\n<p>Contact Form 7 can manage multiple contact forms, plus you can customize the form and the mail contents flexibly with simple markup. The form supports Ajax-powered submitting, CAPTCHA, Akismet spam filtering and so on.</p>\n<h4>Docs &amp; Support</h4>\n<p>You can find <a href=\"https://contactform7.com/docs/\" rel=\"nofollow\">docs</a>, <a href=\"https://contactform7.com/faq/\" rel=\"nofollow\">FAQ</a> and more detailed information about Contact Form 7 on <a href=\"https://contactform7.com/\" rel=\"nofollow\">contactform7.com</a>. If you were unable to find the answer to your question on the FAQ or in any of the documentation, you should check the <a href=\"https://wordpress.org/support/plugin/contact-form-7/\" rel=\"nofollow\">support forum</a> on WordPress.org. If you can&#8217;t locate any topics that pertain to your particular issue, post a new topic for it.</p>\n<h4>Contact Form 7 Needs Your Support</h4>\n<p>It is hard to continue development and support for this free plugin without contributions from users like you. If you enjoy using Contact Form 7 and find it useful, please consider <a href=\"https://contactform7.com/donate/\" rel=\"nofollow\"><strong>making a donation</strong></a>. Your donation will help encourage and support the plugin&#8217;s continued development and better user support.</p>\n<h4>Recommended Plugins</h4>\n<p>The following plugins are recommended for Contact Form 7 users:</p>\n<ul>\n<li><a href=\"https://wordpress.org/plugins/flamingo/\">Flamingo</a> by Takayuki Miyoshi &#8211; With Flamingo, you can save submitted messages via contact forms in the database.</li>\n<li><a href=\"https://wordpress.org/plugins/postman-smtp/\">Postman</a> by<br />\nJason Hendriks &#8211; Postman is a next-generation SMTP Mailer, software that assists in the delivery of email generated by your WordPress site.</li>\n<li><a href=\"https://wordpress.org/plugins/bogo/\">Bogo</a> by Takayuki Miyoshi &#8211; Bogo is a straight-forward multilingual plugin that doesn&#8217;t cause headaches.</li>\n</ul>\n<h4>Translations</h4>\n<p>You can <a href=\"https://contactform7.com/translating-contact-form-7/\" rel=\"nofollow\">translate Contact Form 7</a> on <a href=\"https://translate.wordpress.org/projects/wp-plugins/contact-form-7\" rel=\"nofollow\"><strong>translate.wordpress.org</strong></a>.</p>\n<p><!--section=installation--></p>\n<ol>\n<li>Upload the entire <code>contact-form-7</code> folder to the <code>/wp-content/plugins/</code> directory.</li>\n<li>Activate the plugin through the &#8216;Plugins&#8217; menu in WordPress.</li>\n</ol>\n<p>You will find &#8216;Contact&#8217; menu in your WordPress admin panel.</p>\n<p>For basic usage, you can also have a look at the <a href=\"https://contactform7.com/\" rel=\"nofollow\">plugin web site</a>.</p>\n<p><!--section=faq--></p>\n<p>Do you have questions or issues with Contact Form 7? Use these support channels appropriately.</p>\n<ol>\n<li><a href=\"https://contactform7.com/docs/\" rel=\"nofollow\">Docs</a></li>\n<li><a href=\"https://contactform7.com/faq/\" rel=\"nofollow\">FAQ</a></li>\n<li><a href=\"https://wordpress.org/support/plugin/contact-form-7/\" rel=\"nofollow\">Support Forum</a></li>\n</ol>\n<p><a href=\"https://contactform7.com/support/\" rel=\"nofollow\">Support</a></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<ol>\n<li>Upload the entire <code>contact-form-7</code> folder to the <code>/wp-content/plugins/</code> directory.</li>\n<li>Activate the plugin through the &#8216;Plugins&#8217; menu in WordPress.</li>\n</ol>\n<p>You will find &#8216;Contact&#8217; menu in your WordPress admin panel.</p>\n<p>For basic usage, you can also have a look at the <a href=\"https://contactform7.com/\" rel=\"nofollow\">plugin web site</a>.</p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<p>For more information, see <a href=\"https://contactform7.com/category/releases/\" rel=\"nofollow\">Releases</a>.</p>\n<h4>4.8</h4>\n<ul>\n<li>Stopped using jquery.form.js.</li>\n<li>Added custom REST API endpoints for Ajax form submissions.</li>\n<li>WPCF7_FormTag class implements ArrayAccess interface.</li>\n<li>WPCF7_FormTagsManager::filter() filters form-tags based on features they support.</li>\n<li>New form-tag features: do-not-store, display-block, and display-hidden</li>\n<li>Removed inappropriate content from h1 headings.</li>\n<li>Added the support of size:invisible option to the reCAPTCHA form-tag.</li>\n</ul>\n<h4>4.7</h4>\n<ul>\n<li>Added REST API custom endpoints to manipulate contact form data.</li>\n<li>Config Validator: Added test items for field names and attachment file paths.</li>\n<li>Added custom DOM events: <code>wpcf7invalid</code>, <code>wpcf7spam</code>, <code>wpcf7mailsent</code>, <code>wpcf7mailfailed</code> and <code>wpcf7submit</code>.</li>\n<li>New action hook: <code>wpcf7_after_flamingo</code>.</li>\n<li>Added <code>size</code> option to <code>select</code> and <code>select*</code> form-tag types.</li>\n<li>Made it possible to use the 3rd parameter of <code>wpcf7_add_form_tag()</code> to specify &#8220;features&#8221; of the form-tag type.</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/plugins/contact-form-7/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://wordpress.org/plugins/akismet/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Oct 2005 08:57:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/plugins-wp/akismet/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"Akismet checks your comments and contact form submissions against our global database of spam to&#8230;\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18320:\"<p><!--section=description--></p>\n<p>Akismet checks your comments and contact form submissions against our global database of spam to prevent your site from publishing malicious content. You can review the comment spam it catches on your blog&#8217;s &#8220;Comments&#8221; admin screen.</p>\n<p>Major features in Akismet include:</p>\n<ul>\n<li>Automatically checks all comments and filters out the ones that look like spam.</li>\n<li>Each comment has a status history, so you can easily see which comments were caught or cleared by Akismet and which were spammed or unspammed by a moderator.</li>\n<li>URLs are shown in the comment body to reveal hidden or misleading links.</li>\n<li>Moderators can see the number of approved comments for each user.</li>\n<li>A discard feature that outright blocks the worst spam, saving you disk space and speeding up your site.</li>\n</ul>\n<p>PS: You&#8217;ll need an <a href=\"https://akismet.com/get/\" rel=\"nofollow\">Akismet.com API key</a> to use it.  Keys are free for personal blogs; paid subscriptions are available for businesses and commercial sites.</p>\n<p><!--section=installation--></p>\n<p>Upload the Akismet plugin to your blog, Activate it, then enter your <a href=\"https://akismet.com/get/\" rel=\"nofollow\">Akismet.com API key</a>.</p>\n<p>1, 2, 3: You&#8217;re done!</p>\n<p><!--section=changelog--></p>\n<h4>3.3.2</h4>\n<p><em>Release Date &#8211; 10 May 2017</em></p>\n<ul>\n<li>Fixed a bug causing JavaScript errors in some browsers.</li>\n</ul>\n<h4>3.3.1</h4>\n<p><em>Release Date &#8211; 2 May 2017</em></p>\n<ul>\n<li>Improve performance by only requesting the akismet_comment_nonce option when absolutely necessary.</li>\n<li>Fixed two bugs that could cause PHP warnings.</li>\n<li>Fixed a bug that was preventing the &#8220;Remove author URL&#8221; feature from working after a comment was edited using &#8220;Quick Edit.&#8221;</li>\n<li>Fixed a bug that was preventing the URL preview feature from working after a comment was edited using &#8220;Quick Edit.&#8221;</li>\n</ul>\n<h4>3.3</h4>\n<p><em>Release Date &#8211; 23 February 2017</em></p>\n<ul>\n<li>Updated the Akismet admin pages with a new clean design.</li>\n<li>Fixed bugs preventing the <code>akismet_add_comment_nonce</code> and <code>akismet_update_alert</code> wrapper functions from working properly.</li>\n<li>Fixed bug preventing the loading indicator from appearing when re-checking all comments for spam.</li>\n<li>Added a progress indicator to the &#8220;Check for Spam&#8221; button.</li>\n<li>Added a success message after manually rechecking the Pending queue for spam.</li>\n</ul>\n<h4>3.2</h4>\n<p><em>Release Date &#8211; 6 September 2016</em></p>\n<ul>\n<li>Added a WP-CLI module. You can now check comments and recheck the moderation queue from the command line.</li>\n<li>Stopped using the deprecated jQuery function <code>.live()</code>.</li>\n<li>Fixed a bug in <code>remove_comment_author_url()</code> and <code>add_comment_author_url()</code> that could generate PHP notices.</li>\n<li>Fixed a bug that could cause an infinite loop for sites with very very very large comment IDs.</li>\n<li>Fixed a bug that could cause the Akismet widget title to be blank.</li>\n</ul>\n<h4>3.1.11</h4>\n<p><em>Release Date &#8211; 12 May 2016</em></p>\n<ul>\n<li>Fixed a bug that could cause the &#8220;Check for Spam&#8221; button to skip some comments.</li>\n<li>Fixed a bug that could prevent some spam submissions from being sent to Akismet.</li>\n<li>Updated all links to use https:// when possible.</li>\n<li>Disabled Akismet debug logging unless WP_DEBUG and WP_DEBUG_LOG are both enabled.</li>\n</ul>\n<h4>3.1.10</h4>\n<p><em>Release Date &#8211; 1 April 2016</em></p>\n<ul>\n<li>Fixed a bug that could cause comments caught as spam to be placed in the Pending queue.</li>\n<li>Fixed a bug that could have resulted in comments that were caught by the core WordPress comment blacklist not to have a corresponding History entry.</li>\n<li>Fixed a bug that could have caused avoidable PHP warnings in the error log.</li>\n</ul>\n<h4>3.1.9</h4>\n<p><em>Release Date &#8211; 28 March 2016</em></p>\n<ul>\n<li>Add compatibility with Jetpack so that Jetpack can automatically configure Akismet settings when appropriate.</li>\n<li>Fixed a bug preventing some comment data from being sent to Akismet.</li>\n</ul>\n<h4>3.1.8</h4>\n<p><em>Release Date &#8211; 4 March 2016</em></p>\n<ul>\n<li>Fixed a bug preventing Akismet from being used with some plugins that rewrite admin URLs.</li>\n<li>Reduced the amount of bandwidth used on Akismet API calls</li>\n<li>Reduced the amount of space Akismet uses in the database</li>\n<li>Fixed a bug that could cause comments caught as spam to be placed in the Pending queue.</li>\n</ul>\n<h4>3.1.7</h4>\n<p><em>Release Date &#8211; 4 January 2016</em></p>\n<ul>\n<li>Added documentation for the &#8216;akismet_comment_nonce&#8217; filter.</li>\n<li>The post-install activation button is now accessible to screen readers and keyboard-only users.</li>\n<li>Fixed a bug that was preventing the &#8220;Remove author URL&#8221; feature from working in WordPress 4.4</li>\n</ul>\n<h4>3.1.6</h4>\n<p><em>Release Date &#8211; 14 December 2015</em></p>\n<ul>\n<li>Improve the notices shown after activating Akismet.</li>\n<li>Update some strings to allow for the proper plural forms in all languages.</li>\n</ul>\n<h4>3.1.5</h4>\n<p><em>Release Date &#8211; 13 October 2015</em></p>\n<ul>\n<li>Closes a potential XSS vulnerability.</li>\n</ul>\n<h4>3.1.4</h4>\n<p><em>Release Date &#8211; 24 September 2015</em></p>\n<ul>\n<li>Fixed a bug that was preventing some users from automatically connecting using Jetpack if they didn&#8217;t have a current Akismet subscription.</li>\n<li>Fixed a bug that could cause comments caught as spam to be placed in the Pending queue.</li>\n<li>Error messages and instructions have been simplified to be more understandable.</li>\n<li>Link previews are enabled for all links inside comments, not just the author&#8217;s website link.</li>\n</ul>\n<h4>3.1.3</h4>\n<p><em>Release Date &#8211; 6 July 2015</em></p>\n<ul>\n<li>Notify users when their account status changes after previously being successfully set up. This should help any users who are seeing blank Akismet settings screens.</li>\n</ul>\n<h4>3.1.2</h4>\n<p><em>Release Date &#8211; 7 June 2015</em></p>\n<ul>\n<li>Reduced the amount of space Akismet uses in the commentmeta table.</li>\n<li>Fixed a bug where some comments with quotes in the author name weren&#8217;t getting history entries</li>\n<li>Pre-emptive security improvements to ensure that the Akismet plugin can&#8217;t be used by attackers to compromise a WordPress installation.</li>\n<li>Better UI for the key entry field: allow whitespace to be included at the beginning or end of the key and strip it out automatically when the form is submitted.</li>\n<li>When deactivating the plugin, notify the Akismet API so the site can be marked as inactive.</li>\n<li>Clearer error messages.</li>\n</ul>\n<h4>3.1.1</h4>\n<p><em>Release Date &#8211; 17th March, 2015</em></p>\n<ul>\n<li>Improvements to the &#8220;Remove comment author URL&#8221; JavaScript</li>\n<li>Include the pingback pre-check from the 2.6 branch.</li>\n</ul>\n<h4>3.1</h4>\n<p><em>Release Date &#8211; 11th March, 2015</em></p>\n<ul>\n<li>Use HTTPS by default for all requests to Akismet.</li>\n<li>Fix for a situation where Akismet might strip HTML from a comment.</li>\n</ul>\n<h4>3.0.4</h4>\n<p><em>Release Date &#8211; 11th December, 2014</em></p>\n<ul>\n<li>Fix to make .htaccess compatible with Apache 2.4.</li>\n<li>Fix to allow removal of https author URLs.</li>\n<li>Fix to avoid stripping part of the author URL when removing and re-adding.</li>\n<li>Removed the &#8220;Check for Spam&#8221; button from the &#8220;Trash&#8221; and &#8220;Approved&#8221; queues, where it would have no effect.</li>\n<li>Allow automatic API key configuration when Jetpack is installed and connected to a WordPress.com account</li>\n</ul>\n<h4>3.0.3</h4>\n<p><em>Release Date &#8211; 3rd November, 2014</em></p>\n<ul>\n<li>Fix for sending the wrong data to delete_comment action that could have prevented old spam comments from being deleted.</li>\n<li>Added a filter to disable logging of Akismet debugging information.</li>\n<li>Added a filter for the maximum comment age when deleting old spam comments.</li>\n<li>Added a filter for the number per batch when deleting old spam comments.</li>\n<li>Removed the &#8220;Check for Spam&#8221; button from the Spam folder.</li>\n</ul>\n<h4>3.0.2</h4>\n<p><em>Release Date &#8211; 18th August, 2014</em></p>\n<ul>\n<li>Performance improvements.</li>\n<li>Fixed a bug that could truncate the comment data being sent to Akismet for checking.</li>\n</ul>\n<h4>3.0.1</h4>\n<p><em>Release Date &#8211; 9th July, 2014</em></p>\n<ul>\n<li>Removed dependency on PHP&#8217;s fsockopen function</li>\n<li>Fix spam/ham reports to work when reported outside of the WP dashboard, e.g., from Notifications or the WP app</li>\n<li>Remove jQuery dependency for comment form JavaScript</li>\n<li>Remove unnecessary data from some Akismet comment meta</li>\n<li>Suspended keys will now result in all comments being put in moderation, not spam.</li>\n</ul>\n<h4>3.0.0</h4>\n<p><em>Release Date &#8211; 15th April, 2014</em></p>\n<ul>\n<li>Move Akismet to Settings menu</li>\n<li>Drop Akismet Stats menu</li>\n<li>Add stats snapshot to Akismet settings</li>\n<li>Add Akismet subscription details and status to Akismet settings</li>\n<li>Add contextual help for each page</li>\n<li>Improve Akismet setup to use Jetpack to automate plugin setup</li>\n<li>Fix &#8220;Check for Spam&#8221; to use AJAX to avoid page timing out</li>\n<li>Fix Akismet settings page to be responsive</li>\n<li>Drop legacy code</li>\n<li>Tidy up CSS and Javascript</li>\n<li>Replace the old discard setting with a new &#8220;discard pervasive spam&#8221; feature.</li>\n</ul>\n<h4>2.6.0</h4>\n<p><em>Release Date &#8211; 18th March, 2014</em></p>\n<ul>\n<li>Add ajax paging to the check for spam button to handle large volumes of comments</li>\n<li>Optimize javascript and add localization support </li>\n<li>Fix bug in link to spam comments from right now dashboard widget</li>\n<li>Fix bug with deleting old comments to avoid timeouts dealing with large volumes of comments</li>\n<li>Include X-Pingback-Forwarded-For header in outbound WordPress pingback verifications</li>\n<li>Add pre-check for pingbacks, to stop spam before an outbound verification request is made</li>\n</ul>\n<h4>2.5.9</h4>\n<p><em>Release Date &#8211; 1st August, 2013</em></p>\n<ul>\n<li>Update &#8216;Already have a key&#8217; link to redirect page rather than depend on javascript</li>\n<li>Fix some non-translatable strings to be translatable</li>\n<li>Update Activation banner in plugins page to redirect user to Akismet config page</li>\n</ul>\n<h4>2.5.8</h4>\n<p><em>Release Date &#8211; 20th January, 2013</em></p>\n<ul>\n<li>Simplify the activation process for new users</li>\n<li>Remove the reporter_ip parameter</li>\n<li>Minor preventative security improvements</li>\n</ul>\n<h4>2.5.7</h4>\n<p><em>Release Date &#8211; 13th December, 2012</em></p>\n<ul>\n<li>FireFox Stats iframe preview bug</li>\n<li>Fix mshots preview when using https</li>\n<li>Add .htaccess to block direct access to files</li>\n<li>Prevent some PHP notices</li>\n<li>Fix Check For Spam return location when referrer is empty</li>\n<li>Fix Settings links for network admins</li>\n<li>Fix prepare() warnings in WP 3.5</li>\n</ul>\n<h4>2.5.6</h4>\n<p><em>Release Date &#8211; 26th April, 2012</em></p>\n<ul>\n<li>Prevent retry scheduling problems on sites where wp_cron is misbehaving</li>\n<li>Preload mshot previews</li>\n<li>Modernize the widget code</li>\n<li>Fix a bug where comments were not held for moderation during an error condition</li>\n<li>Improve the UX and display when comments are temporarily held due to an error</li>\n<li>Make the Check For Spam button force a retry when comments are held due to an error</li>\n<li>Handle errors caused by an invalid key</li>\n<li>Don&#8217;t retry comments that are too old</li>\n<li>Improve error messages when verifying an API key</li>\n</ul>\n<h4>2.5.5</h4>\n<p><em>Release Date &#8211; 11th January, 2012</em></p>\n<ul>\n<li>Add nonce check for comment author URL remove action</li>\n<li>Fix the settings link</li>\n</ul>\n<h4>2.5.4</h4>\n<p><em>Release Date &#8211; 5th January, 2012</em></p>\n<ul>\n<li>Limit Akismet CSS and Javascript loading in wp-admin to just the pages that need it</li>\n<li>Added author URL quick removal functionality</li>\n<li>Added mShot preview on Author URL hover</li>\n<li>Added empty index.php to prevent directory listing</li>\n<li>Move wp-admin menu items under Jetpack, if it is installed</li>\n<li>Purge old Akismet comment meta data, default of 15 days</li>\n</ul>\n<h4>2.5.3</h4>\n<p><em>Release Date &#8211; 8th Febuary, 2011</em></p>\n<ul>\n<li>Specify the license is GPL v2 or later</li>\n<li>Fix a bug that could result in orphaned commentmeta entries</li>\n<li>Include hotfix for WordPress 3.0.5 filter issue</li>\n</ul>\n<h4>2.5.2</h4>\n<p><em>Release Date &#8211; 14th January, 2011</em></p>\n<ul>\n<li>Properly format the comment count for author counts</li>\n<li>Look for super admins on multisite installs when looking up user roles</li>\n<li>Increase the HTTP request timeout</li>\n<li>Removed padding for author approved count</li>\n<li>Fix typo in function name</li>\n<li>Set Akismet stats iframe height to fixed 2500px.  Better to have one tall scroll bar than two side by side.</li>\n</ul>\n<h4>2.5.1</h4>\n<p><em>Release Date &#8211; 17th December, 2010</em></p>\n<ul>\n<li>Fix a bug that caused the &#8220;Auto delete&#8221; option to fail to discard comments correctly</li>\n<li>Remove the comment nonce form field from the &#8216;Akismet Configuration&#8217; page in favor of using a filter, akismet_comment_nonce</li>\n<li>Fixed padding bug in &#8220;author&#8221; column of posts screen</li>\n<li>Added margin-top to &#8220;cleared by &#8230;&#8221; badges on dashboard</li>\n<li>Fix possible error when calling akismet_cron_recheck()</li>\n<li>Fix more PHP warnings</li>\n<li>Clean up XHTML warnings for comment nonce</li>\n<li>Fix for possible condition where scheduled comment re-checks could get stuck</li>\n<li>Clean up the comment meta details after deleting a comment</li>\n<li>Only show the status badge if the comment status has been changed by someone/something other than Akismet</li>\n<li>Show a &#8216;History&#8217; link in the row-actions</li>\n<li>Translation fixes</li>\n<li>Reduced font-size on author name</li>\n<li>Moved &#8220;flagged by&#8230;&#8221; notification to top right corner of comment container and removed heavy styling</li>\n<li>Hid &#8220;flagged by&#8230;&#8221; notification while on dashboard</li>\n</ul>\n<h4>2.5.0</h4>\n<p><em>Release Date &#8211; 7th December, 2010</em></p>\n<ul>\n<li>Track comment actions under &#8216;Akismet Status&#8217; on the edit comment screen</li>\n<li>Fix a few remaining deprecated function calls ( props Mike Glendinning ) </li>\n<li>Use HTTPS for the stats IFRAME when wp-admin is using HTTPS</li>\n<li>Use the WordPress HTTP class if available</li>\n<li>Move the admin UI code to a separate file, only loaded when needed</li>\n<li>Add cron retry feature, to replace the old connectivity check</li>\n<li>Display Akismet status badge beside each comment</li>\n<li>Record history for each comment, and display it on the edit page</li>\n<li>Record the complete comment as originally submitted in comment_meta, to use when reporting spam and ham</li>\n<li>Highlight links in comment content</li>\n<li>New option, &#8220;Show the number of comments you&#8217;ve approved beside each comment author.&#8221;</li>\n<li>New option, &#8220;Use a nonce on the comment form.&#8221;</li>\n</ul>\n<h4>2.4.0</h4>\n<p><em>Release Date &#8211; 23rd August, 2010</em></p>\n<ul>\n<li>Spell out that the license is GPLv2</li>\n<li>Fix PHP warnings</li>\n<li>Fix WordPress deprecated function calls</li>\n<li>Fire the delete_comment action when deleting comments</li>\n<li>Move code specific for older WP versions to legacy.php</li>\n<li>General code clean up</li>\n</ul>\n<h4>2.3.0</h4>\n<p><em>Release Date &#8211; 5th June, 2010</em></p>\n<ul>\n<li>Fix &#8220;Are you sure&#8221; nonce message on config screen in WPMU</li>\n<li>Fix XHTML compliance issue in sidebar widget</li>\n<li>Change author link; remove some old references to WordPress.com accounts</li>\n<li>Localize the widget title (core ticket #13879)</li>\n</ul>\n<h4>2.2.9</h4>\n<p><em>Release Date &#8211; 2nd June, 2010</em></p>\n<ul>\n<li>Eliminate a potential conflict with some plugins that may cause spurious reports</li>\n</ul>\n<h4>2.2.8</h4>\n<p><em>Release Date &#8211; 27th May, 2010</em></p>\n<ul>\n<li>Fix bug in initial comment check for ipv6 addresses</li>\n<li>Report comments as ham when they are moved from spam to moderation</li>\n<li>Report comments as ham when clicking undo after spam</li>\n<li>Use transition_comment_status action when available instead of older actions for spam/ham submissions</li>\n<li>Better diagnostic messages when PHP network functions are unavailable</li>\n<li>Better handling of comments by logged-in users</li>\n</ul>\n<h4>2.2.7</h4>\n<p><em>Release Date &#8211; 17th December, 2009</em></p>\n<ul>\n<li>Add a new AKISMET_VERSION constant</li>\n<li>Reduce the possibility of over-counting spam when another spam filter plugin is in use</li>\n<li>Disable the connectivity check when the API key is hard-coded for WPMU</li>\n</ul>\n<h4>2.2.6</h4>\n<p><em>Release Date &#8211; 20th July, 2009</em></p>\n<ul>\n<li>Fix a global warning introduced in 2.2.5</li>\n<li>Add changelog and additional readme.txt tags</li>\n<li>Fix an array conversion warning in some versions of PHP</li>\n<li>Support a new WPCOM_API_KEY constant for easier use with WordPress MU</li>\n</ul>\n<h4>2.2.5</h4>\n<p><em>Release Date &#8211; 13th July, 2009</em></p>\n<ul>\n<li>Include a new Server Connectivity diagnostic check, to detect problems caused by firewalls</li>\n</ul>\n<h4>2.2.4</h4>\n<p><em>Release Date &#8211; 3rd June, 2009</em></p>\n<ul>\n<li>Fixed a key problem affecting the stats feature in WordPress MU</li>\n<li>Provide additional blog information in Akismet API calls</li>\n</ul>\n<p><!--section=faq--></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<p>Upload the Akismet plugin to your blog, Activate it, then enter your <a href=\"https://akismet.com/get/\" rel=\"nofollow\">Akismet.com API key</a>.</p>\n<p>1, 2, 3: You&#8217;re done!</p>\n</dd>\n</dl>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"https://wordpress.org/plugins/akismet/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n		\n		\n		\n		\n		\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Yoast SEO\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://wordpress.org/plugins/wordpress-seo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 11 Oct 2010 20:55:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://wordpress.org/plugins-wp/wordpress-seo/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WordPress out of the box is already technically quite a good platform for SEO. This&#8230;\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:12921:\"<p><!--section=description--></p>\n<p>WordPress out of the box is already technically quite a good platform for SEO. This was true when Joost wrote his original <a href=\"https://yoast.com/articles/wordpress-seo/\" rel=\"nofollow\">WordPress SEO</a> article in 2008 (updated every few months) and it&#8217;s still true today, but that doesn&#8217;t mean you can&#8217;t improve it further! This plugin is written from the ground up by Joost de Valk and his team at <a href=\"https://yoast.com/\" rel=\"nofollow\">Yoast</a> to improve your site&#8217;s SEO on <em>all</em> needed aspects. While this <a href=\"https://yoast.com/wordpress/plugins/seo/\" rel=\"nofollow\">Yoast SEO plugin</a> goes the extra mile to take care of all the technical optimization, more on that below, it first and foremost helps you write better content.  Yoast SEO forces you to choose a focus keyword when you&#8217;re writing your articles, and then makes sure you use that focus keyword everywhere.</p>\n<blockquote>\n<p><strong>Premium Support</strong><br />\n  The Yoast team does not always provide active support for the Yoast SEO plugin on the WordPress.org forums. One-on-one email support is available to people who bought the <a href=\"https://yoast.com/wordpress/plugins/seo-premium/\" rel=\"nofollow\">Premium Yoast SEO plugin</a> only.<br />\n  Note that the Premium SEO plugin has several extra features too, including the option to have multiple focus keywords and a redirect manager, so it might be well worth your investment!</p>\n<p>You should also check out the <a href=\"https://yoast.com/wordpress/plugins/local-seo/\" rel=\"nofollow\">Yoast Local SEO</a>, <a href=\"https://yoast.com/wordpress/plugins/news-seo/\" rel=\"nofollow\">Yoast News SEO</a> and <a href=\"https://yoast.com/wordpress/plugins/video-seo/\" rel=\"nofollow\">Yoast Video SEO</a> extensions to Yoast SEO. These of course come with support too.</p>\n<p><strong>Bug Reports</strong><br />\n  Bug reports for Yoast SEO are <a href=\"https://github.com/Yoast/wordpress-seo\" rel=\"nofollow\">welcomed on GitHub</a>. Please note GitHub is <em>not</em> a support forum, and issues that aren&#8217;t properly qualified as bugs will be closed.</p>\n</blockquote>\n<h4>Write better content with Yoast SEO</h4>\n<p>Using the snippet preview, you can see a rendering of what your post or page will look like in the search results, whether your title is too long or too short, and whether your meta description makes sense in the context of a search result. This way the plugin will help you not only increase rankings but also increase the click through rate for organic search results.</p>\n<h4>Page Analysis</h4>\n<p>The Yoast SEO plugins <a href=\"https://yoast.com/content-seo-wordpress-linkdex/\" rel=\"nofollow\">Page Analysis</a> functionality checks simple things you&#8217;re bound to forget. It checks, for instance, if you have images in your post and whether they have an alt tag containing the focus keyword for that post. It also checks whether your posts are long enough, whether you&#8217;ve written a meta description and if that meta description contains your focus keyword, if you&#8217;ve used any subheadings within your post, etc. etc.</p>\n<p>The plugin alsgruo allows you to write meta titles and descriptions for all your category, tag and custom taxonomy archives, giving you the option to further optimize those pages.</p>\n<p>Combined, this plugin makes sure that your content is the type of content search engines will love!</p>\n<h4>Technical WordPress Search Engine Optimization</h4>\n<p>While out of the box WordPress is pretty good for SEO, it needs some tweaks here and there. This Yoast SEO plugin guides you through some of the settings needed, for instance by reminding you to enable pretty permalinks. But it also goes beyond that, by automatically optimizing and inserting the meta tags and link elements that Google and other search engines like so much:</p>\n<h4>Meta &amp; Link Elements</h4>\n<p>With the Yoast SEO plugin you can control which pages Google shows in its search results and which pages it doesn&#8217;t show. By default, it will tell search engines to index all of your pages, including category and tag archives, but to only show the first pages in the search results. It&#8217;s not very useful for a user to end up on the third page of your &#8220;personal&#8221; category, right?</p>\n<p>WordPress itself only shows canonical link elements on single pages, but Yoast SEO makes it output canonical link elements everywhere. Google has recently announced they would also use <code>rel=\"next\"</code> and <code>rel=\"prev\"</code> link elements in the <code>head</code> section of your paginated archives. This plugin adds those automatically. See <a href=\"https://yoast.com/rel-next-prev-paginated-archives/\" rel=\"nofollow\">this post</a> for more info.</p>\n<h4>XML Sitemaps</h4>\n<p>The Yoast SEO plugin has the most advanced XML Sitemaps functionality in any WordPress plugin. Once you check the box, it automatically creates XML sitemaps and notifies Google &amp; Bing of the sitemaps&#8217; existence. These XML sitemaps include the images in your posts &amp; pages too, so that your images may be found better in the search engines too.</p>\n<p>These XML Sitemaps will even work on large sites, because of how they&#8217;re created, using one index sitemap that links to sub-sitemaps for each 1,000 posts. They will also work with custom post types and custom taxonomies automatically, while giving you the option to remove those from the XML sitemap should you wish to.</p>\n<p>Because of using <a href=\"https://yoast.com/xsl-stylesheet-xml-sitemap/\" rel=\"nofollow\">XSL stylesheets for these XML Sitemaps</a>, the XML sitemaps are easily readable for the human eye too, so you can spot things that shouldn&#8217;t be in there.</p>\n<h4>RSS Optimization</h4>\n<p>Are you being outranked by scrapers? Instead of cursing at them, use them to your advantage! By automatically adding a link to your RSS feed pointing back to the original article, you&#8217;re telling the search engine where they should be looking for the original. This way, the Yoast SEO plugin increases your own chance of ranking for your chosen keywords and gets rid of scrapers in one go!</p>\n<h4>Breadcrumbs</h4>\n<p>If your theme is compatible, and themes based on for instance Genesis or by WooThemes often are, you can use the built-in Breadcrumbs functionality. This allows you to create an easy navigation that is great for both users and search engines, and will support the search engines in understanding the structure of your site.</p>\n<p>Making your theme compatible isn&#8217;t hard either, check <a href=\"https://kb.yoast.com/kb/implement-wordpress-seo-breadcrumbs/\" rel=\"nofollow\">these instructions</a>.</p>\n<h4>Edit your .htaccess and robots.txt file</h4>\n<p>Using the built-in file editor, you can edit your WordPress blog&#8217;s <code>.htaccess</code> and <code>robots.txt</code> file, giving you direct access to the two most powerful files, from an SEO perspective, in your WordPress install.</p>\n<h4>Social Integration</h4>\n<p>SEO and Social Media are heavily intertwined. That&#8217;s why this plugin also comes with a Facebook OpenGraph implementation and will soon also support Google+ sharing tags.</p>\n<h4>Multi-Site Compatible</h4>\n<p>The Yoast SEO plugin, unlike some others, is fully Multi-Site compatible. The XML Sitemaps work fine in all setups and you even have the option, in the Network settings, to copy the settings from one blog to another, or make blogs default to the settings for a specific blog.</p>\n<h4>Import &amp; Export functionality</h4>\n<p>If you have multiple blogs, setting up plugins like this one on all of them might seem like a daunting task. Except that it&#8217;s not, because what you can do is simple: you set up the plugin once. You then export your settings and simply import them on all your other sites. It&#8217;s that simple!</p>\n<h4>Import functionality for other WordPress SEO plugins</h4>\n<p>If you&#8217;ve used All In One SEO Pack or HeadSpace2 before using this plugin, you might want to import all your old titles and descriptions. You can do that easily using the built-in import functionality. There&#8217;s also import functionality for some of the older Yoast plugins, like Robots Meta and RSS footer.</p>\n<p>Should you have a need to import from another SEO plugin to Yoast SEO, or from a theme like Genesis or Thesis, you can use the <a href=\"https://wordpress.org/extend/plugins/seo-data-transporter/\" rel=\"nofollow\">SEO Data Transporter</a> plugin, which will easily convert your SEO meta data from and to a whole set of plugins like Platinum SEO, SEO Ultimate, Greg&#8217;s High Performance SEO, and themes like Headway, Hybrid, WooFramework, Catalyst etc.</p>\n<p>Read <a href=\"https://yoast.com/all-in-one-seo-pack-migration/\" rel=\"nofollow\">this migration guide</a> if you still have questions about migrating from another SEO plugin to Yoast SEO.</p>\n<h4>Yoast SEO Plugin in your Language!</h4>\n<p>Currently a huge translation project is underway, translating Yoast SEO in as much as 24 languages. So far, the translations for French and Dutch are complete, but we still need help on a lot of other languages, so if you&#8217;re good at translating, please join us at <a href=\"http://translate.yoast.com\" rel=\"nofollow\">translate.yoast.com</a>.</p>\n<h4>News SEO</h4>\n<p>Be sure to also check out the premium <a href=\"https://yoast.com/wordpress/plugins/news-seo/\" rel=\"nofollow\">News SEO module</a> if you need Google News Sitemaps. It tightly integrates with Yoast SEO to give you the combined power of News Sitemaps and full Search Engine Optimization.</p>\n<h4>Further Reading</h4>\n<p>For more info, check out the following articles:</p>\n<ul>\n<li>The <a href=\"https://kb.yoast.com/kb/category/yoast-seo/\" rel=\"nofollow\">Yoast SEO Knowledgebase</a>.</li>\n<li><a href=\"https://yoast.com/articles/wordpress-seo/\" rel=\"nofollow\">WordPress SEO &#8211; The definitive Guide by Yoast</a>.</li>\n<li>Once you have great SEO, you&#8217;ll need the <a href=\"https://yoast.com/articles/wordpress-hosting/\" rel=\"nofollow\">best WordPress Hosting</a>.</li>\n<li>The <a href=\"https://yoast.com/wordpress/plugins/seo/\" rel=\"nofollow\">Yoast SEO Plugin</a> official homepage.</li>\n<li>Other <a href=\"https://yoast.com/wordpress/plugins/\" rel=\"nofollow\">WordPress Plugins</a> by the same team.</li>\n<li>Follow Yoast on <a href=\"https://facebook.com/yoast\" rel=\"nofollow\">Facebook</a> &amp; <a href=\"http://twitter.com/yoast\" rel=\"nofollow\">Twitter</a>.</li>\n</ul>\n<h3>From within WordPress</h3>\n<ol>\n<li>Visit &#8216;Plugins &gt; Add New&#8217;</li>\n<li>Search for &#8216;Yoast SEO&#8217;</li>\n<li>Activate Yoast SEO from your Plugins page.</li>\n<li>Go to &#8220;after activation&#8221; below.</li>\n</ol>\n<h3>Manually</h3>\n<ol>\n<li>Upload the <code>wordpress-seo</code> folder to the <code>/wp-content/plugins/</code> directory</li>\n<li>Activate the Yoast SEO plugin through the &#8216;Plugins&#8217; menu in WordPress</li>\n<li>Go to &#8220;after activation&#8221; below.</li>\n</ol>\n<h3>After activation</h3>\n<ol>\n<li>You should see (a notice to start) the Yoast SEO configuration wizard.</li>\n<li>Go through the configuration wizard and set up the plugin for your site.</li>\n<li>You&#8217;re done!</li>\n</ol>\n<p><!--section=faq--></p>\n<p>You&#8217;ll find answers to many of your questions on <a href=\"https://kb.yoast.com/kb/category/yoast-seo/\" rel=\"nofollow\">kb.yoast.com</a>.</p>\n<p><!--section=changelog--></p>\n<h4>4.9.0</h4>\n<p>Release Date: June 7th, 2017</p>\n<ul>\n<li>\n<p>Bugfixes</p>\n<ul>\n<li>Fixes a bug where there were certain assessments missing when switching to cornerstone content.</li>\n<li>Fixes a bug where the configuration wizard button was visible for users who didn&#8217;t have enough rights to access the configuration wizard.</li>\n<li>Fixes a bug where the column <code>ID</code> was ambiguous, causing an SQL error.</li>\n<li>Fixes a bug where the category URL in the sitemap was encoded twice.</li>\n<li>Fixes a bug where an old upgrade notice is not removed.</li>\n</ul>\n</li>\n<li>\n<p>Enhancements</p>\n<ul>\n<li>Removes the noodp advanced robots meta value as it is no longer used.</li>\n<li>Loads the translations only when the configuration wizard endpoint is called, instead of every time <code>rest_api_init</code> is called.</li>\n</ul>\n</li>\n</ul>\n<h4>4.8.0</h4>\n<p>Release Date: May 23rd, 2017</p>\n<ul>\n<li>\n<p>Bugfixes</p>\n<ul>\n<li>Fixes a bug where the tabs in the social and advanced metabox section are gone when keyword analysis has been disabled.</li>\n</ul>\n</li>\n<li>\n<p>Enhancements</p>\n<ul>\n<li>Optimizes the way the cornerstone flag is saved.</li>\n<li>Analyzes the content using cornerstone assessors when a post or page is cornerstone content.</li>\n</ul>\n</li>\n</ul>\n<h4>Earlier versions</h4>\n<p>For the changelog of earlier versions, please refer to the separate changelog.txt file.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"https://wordpress.org/plugins/jetpack/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://wordpress.org/plugins/jetpack/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/plugins-wp/jetpack/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"The one plugin you need for stats, related posts, search engine optimization, social sharing, protection,&#8230;\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:13334:\"<p><!--section=description--></p>\n<p>Keep any WordPress site secure, increase traffic, and engage your readers.</p>\n<h4>Traffic and SEO Tools</h4>\n<p>Traffic is the lifeblood of any website. Jetpack includes:</p>\n<ul>\n<li>[free] Site stats and analytics</li>\n<li>[free] Automatic sharing on Facebook, Twitter, LinkedIn, Tumblr, Reddit, and WhatsApp</li>\n<li>[free] Related posts</li>\n<li>[paid] Search engine optimization tools for Google, Bing, Twitter, Facebook, and WordPress.com</li>\n<li>[paid] Advertising program that includes the best of AdSense, Facebook Ads, AOL, Amazon, Google AdX, and Yahoo</li>\n</ul>\n<h4>Security and Backup Services</h4>\n<p>Stop worrying about data loss, downtime, and hacking. Jetpack provides:</p>\n<ul>\n<li>[free] Brute force attack protection</li>\n<li>[free] Downtime and uptime monitoring</li>\n<li>[free] Secured logins and two-factor authentication</li>\n<li>[paid] Malware scanning, code scanning, and threat resolution</li>\n<li>[paid] Site backups, restores, and migrations</li>\n</ul>\n<h4>Content Creation</h4>\n<p>Add rich, beautifully-presented media &#8212; no graphic design expertise necessary:</p>\n<ul>\n<li>[free] A high-speed CDN for your images</li>\n<li>[free] Carousels, slideshows, and tiled galleries</li>\n<li>[free] Simple embeds from YouTube, Google Documents, Spotify and more</li>\n<li>[free] Sidebar customization including Facebook, Twitter, and RSS feeds</li>\n<li>[free] Extra sidebar widgets including blog stats, calendar, and author widgets</li>\n<li>[paid] High-speed, ad-free, and high-definition video hosting</li>\n</ul>\n<h4>Discussion and Community</h4>\n<p>Create a connection with your readers and keep them coming back to your site with:</p>\n<ul>\n<li>[free] Email subscriptions</li>\n<li>[free] Comment login with Facebook, Twitter, and Google</li>\n<li>[free] Fully-customizable contact forms</li>\n<li>[free] Infinite scroll for your posts</li>\n</ul>\n<h4>Expert Support</h4>\n<p>We have an entire team of Happiness Engineers ready to help you. Ask your questions in the support forum, or <a href=\"https://jetpack.com/contact-support\" rel=\"nofollow\">contact us directly</a>.</p>\n<h4>Paid Services</h4>\n<p>Most of Jetpack&#8217;s features and services are free. Jetpack also provides advanced security and backup services, video hosting, site monetization, priority support, and more SEO tools in three <a href=\"https://jetpack.com/pricing?from=wporg\" rel=\"nofollow\">simple and affordable plans</a>.</p>\n<h4>Get Started</h4>\n<p>Installation is free, quick, and easy. Set up <a href=\"https://jetpack.com/install?from=wporg\" rel=\"nofollow\">the free plan</a> in minutes.</p>\n<p><!--section=installation--></p>\n<h4>Automated Installation</h4>\n<p>Installation is free, quick, and easy. <a href=\"https://jetpack.com/install?from=wporg\" rel=\"nofollow\">Install Jetpack from our site</a> in minutes.</p>\n<h4>Manual Alternatives</h4>\n<p>Alternatively, install Jetpack via the plugin directory, or upload the files manually to your server and follow the on-screen instructions. If you need additional help <a href=\"http://jetpack.com/support/installing-jetpack/\" rel=\"nofollow\">read our detailed instructions</a>.</p>\n<p><!--section=faq--></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<h4>Automated Installation</h4>\n<p>Installation is free, quick, and easy. <a href=\"https://jetpack.com/install?from=wporg\" rel=\"nofollow\">Install Jetpack from our site</a> in minutes.</p>\n<h4>Manual Alternatives</h4>\n<p>Alternatively, install Jetpack via the plugin directory, or upload the files manually to your server and follow the on-screen instructions. If you need additional help <a href=\"http://jetpack.com/support/installing-jetpack/\" rel=\"nofollow\">read our detailed instructions</a>.</p>\n</dd>\n<dt>Is Jetpack Free?</dt>\n<dd>\n<p>Yes! Jetpack&#8217;s core features are and always will be free.</p>\n<p>These include: <a href=\"https://jetpack.com/features/traffic/site-stats\" rel=\"nofollow\">site stats</a>, a <a href=\"https://jetpack.com/features/writing/content-delivery-network/\" rel=\"nofollow\">high-speed CDN</a> for images, <a href=\"https://jetpack.com/features/traffic/related-posts\" rel=\"nofollow\">related posts</a>, <a href=\"https://jetpack.com/features/security/downtime-monitoring\" rel=\"nofollow\">downtime monitoring</a>, brute force <a href=\"https://jetpack.com/features/security/brute-force-attack-protection\" rel=\"nofollow\">attack protection</a>, <a href=\"https://jetpack.com/features/traffic/automatic-publishing/\" rel=\"nofollow\">automated sharing</a> to social networks, <a href=\"https://jetpack.com/features/writing/sidebar-customization/\" rel=\"nofollow\">sidebar customization</a>, and many more.</p>\n</dd>\n<dt>Should I purchase a paid plan?</dt>\n<dd>\n<p>Jetpack&#8217;s paid services include automated backups, security scanning, spam filtering, video hosting, site monetization, SEO tools, and priority support.</p>\n<p>If you&#8217;re interested in learning more about the extra layers of protection and advanced tools available, learn more about our <a href=\"https://jetpack.com/pricing?from=wporg\" rel=\"nofollow\">paid plans</a>.</p>\n</dd>\n<dt>Why do I need a WordPress.com account?</dt>\n<dd>\n<p>Since Jetpack and its services are provided and hosted by WordPress.com, a WordPress.com account is required for Jetpack to function.</p>\n</dd>\n<dt>I already have a WordPress account, but Jetpack isn&#8217;t working. What&#8217;s going on?</dt>\n<dd>\n<p>A WordPress.com account is different from the account you use to log into your self-hosted WordPress. If you can log into <a href=\"https://wordpress.com\" rel=\"nofollow\">WordPress.com</a>, then you already have a WordPress.com account. If you can&#8217;t, you can easily create one <a href=\"https://jetpack.com/install?from=wporg\" rel=\"nofollow\">during installation</a>.</p>\n</dd>\n<dt>How do I view my stats?</dt>\n<dd>\n<p>Once you&#8217;ve installed Jetpack your stats will be available on <a href=\"https://wordpress.com/stats\" rel=\"nofollow\">WordPress.com/Stats</a>, on the official <a href=\"https://apps.wordpress.com/mobile/\" rel=\"nofollow\">WordPress mobile apps</a>, and on your Jetpack dashboard.</p>\n</dd>\n<dt>How do I contribute to Jetpack?</dt>\n<dd>\n<p>There are opportunities for developers at all levels to contribute. <a href=\"https://jetpack.com/contribute\" rel=\"nofollow\">Learn more about contributing to Jetpack</a> or consider <a href=\"https://jetpack.com/beta\" rel=\"nofollow\">joining our beta program</a>.</p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<h4>5.0</h4>\n<ul>\n<li>Release date: June 6th, 2017</li>\n<li>Release post: http://wp.me/p1moTy-5hK</li>\n</ul>\n<p><strong>Enhancements</strong></p>\n<ul>\n<li>Several changes to the Jetpack dashboard and notices: alignment tweaks, code refactor, text simplification, and more.</li>\n<li>Changes to the communication layer between your site and WordPress.com, to improve performance and allow you to do more to manage your site from WordPress.com.</li>\n<li>Social menu gets icons for Etsy, Meetup, 500px, and Goodreads.</li>\n<li>Jetpack data sync now better supports WordPress updates, themes changes, widgets, and multisite networks.</li>\n<li>Video is updated to be fully compatible with the upcoming Media Widget.</li>\n<li>Force secure WordPress.com API requests for request body, remove deprecated stats methods, and add new endpoints for post listing and user invitations.</li>\n<li>Jetpack&#8217;s Command Line tools can now output information about the primary Jetpack site owner. Try <code>wp jetpack status</code>!</li>\n<li>Custom CSS now supports the <code>animation-fill-mode</code>, <code>fill</code>, and <code>stroke</code> properties.</li>\n<li>Remove the &#8220;Menus&#8221; item from the WordPress.com toolbar for parity with the toolbar on WordPress.com.</li>\n<li>Improve the display of the Omnisearch results page on sites using an RTL language.</li>\n<li>Trim any white space when adding new email address in the Contact Info Widget.</li>\n<li>Improve the look of your recipes in search engine result pages, when you use the Recipe shortcode.</li>\n</ul>\n<p><strong>Compatibility Improvements</strong></p>\n<ul>\n<li>Improve the connection process for end users and hosts.</li>\n<li>Improve compatibility of Jetpack data sync with WooCommerce and Pet Manager plugins.</li>\n<li>Make sure Jetpack&#8217;s SEO Tools don&#8217;t conflict with other SEO plugins that may already be active on the site, like Yoast SEO or All In One SEO Pack.</li>\n</ul>\n<p><strong>Bug Fixes</strong></p>\n<ul>\n<li>Add a &#8220;Set Up&#8221; button when a Personal plan is purchased, but VaultPress isn&#8217;t active yet.</li>\n<li>When the Ads feature is active, do not display Ads in RSS feeds.</li>\n<li>Comments do not use Photon for Facebook and Twitter avatars and now avoid non-secure warnings when submitting comments on a HTTP site in Safari.</li>\n<li>Contact form emails are now sent in a way that ensures they are correctly rendered as HTML.</li>\n<li>Properly print the full list of modules when using the sync command in Jetpack&#8217;s Command Line Interface (CLI).</li>\n<li>Avoid errors when reordering a lot of Restaurant menu items at once.</li>\n<li>Add a mechanism to detect broken connection states and resolve them.</li>\n<li>Autosaves can now be restored as Markdown.</li>\n<li>Photon no longer conflicts with Facebook&#8217;s CDN, local images, and plugins that customize reponsive images.</li>\n<li>Avoid potential PHP notice in Publicize.</li>\n<li>Fix bad jQuery selector in Presentations shortcode.</li>\n<li>Avoid fatal errors for Social Links on sites running PHP 7.1.</li>\n<li>Properly escape button attribute in spellchecker.</li>\n<li>Avoid PHP notices for stats on some sites when user roles are not attributed properly.</li>\n<li>No longer attempt to sync options that do not exist and avoid fatal errors when de/activating plugins.</li>\n<li>Avoid errors when Social Menu functions have already been defined in the theme or in another plugin.</li>\n<li>VideoPress media items now always return their unique ID, and do not trigger any PHP notice.</li>\n<li>Fix style of the EU Cookie Law Widget on themes with specific positioning.</li>\n<li>Use correct time constant to define an hour in Upcoming Events Widget.</li>\n<li>Avoid HTML encoding issues in sitemaps.</li>\n</ul>\n<h4>4.9</h4>\n<ul>\n<li>Release date: May 2nd, 2017</li>\n<li>Release post: http://wp.me/p1moTy-4Rl</li>\n</ul>\n<p><strong>Major Enhancements</strong></p>\n<ul>\n<li>New &#8220;EU Cookie Law Banner&#8221;, Flickr, and &#8220;Internet Defense League&#8221; widgets.</li>\n</ul>\n<p><strong>Slightly Less Exciting Enhancements</strong></p>\n<ul>\n<li>Success notices are automatically dismissed after a short period.</li>\n<li>Removed unused code from &#8220;My Jetpack&#8221; interface and deprecated an XML-RPC method.</li>\n<li>Contact Form now adds display names to email addresses in the <code>To</code> header.</li>\n<li>Updated multiple unit tests to increase code coverage.</li>\n<li>Development mode now also shows module list.</li>\n<li>Updated the list of locales available in Jetpack.</li>\n<li>Plugin auto-updates only triggered from WordPress.com and now trigger WordPress&#8217; maintenance mode.</li>\n</ul>\n<p><strong>Performance Improvements</strong></p>\n<ul>\n<li>Record comment content modifications and moderation events to make sure comments are always up to date on WordPress.com.</li>\n<li>Sync post deletions, changes to sidebar, user events (addition, removal, and update) and theme installation.</li>\n<li>We now distinguish between a new and an updated attachment.</li>\n<li>Sync plugin and theme names when a related event is triggered including theme updates.</li>\n</ul>\n<p><strong>Compatibility Improvements</strong></p>\n<ul>\n<li>Protect avoid conflicts with other plugins hooking into the log in form.</li>\n<li>Contact Form not auto-activated when Ninja Forms is active.</li>\n<li>WordPess.com REST API now allows <code>HTTP PUT</code> requests.</li>\n<li>Ensure that Jetpack&#8217;s Image Widget is fully compatible with the Media Widget soon to be available in WordPress 4.8.</li>\n</ul>\n<p><strong>Bug Fixes</strong></p>\n<ul>\n<li>Fixed wording in Post By Email button when no email address has been generated.</li>\n<li>Fixed a notice in the subscription widget in PHP 7.1</li>\n<li>Properly display VaultPress notices in the Jetpack dashboard.</li>\n<li>VideoPress now included in search results for &#8220;video&#8221; and fixed positioning of search icon on mobile screens.</li>\n<li>Protect supports IPv6 addresses properly.</li>\n<li>Dashboard avoids API requests being cached on some hosts and avoids errors when Spellchecker is inactive.</li>\n<li>Contact Form message content type is now set properly to restore compatibility with email plugins.</li>\n<li>Ads not displayed in the portfolio projects custom content type.</li>\n<li>Display all sites available in a network, even on large multisite installations.</li>\n<li>Featured Image is always used in tweets posted via Publicize.</li>\n<li>Avoid fatal errors when the exclusion parameter in Related Posts is not a string.</li>\n<li>Allow the removal of all custom title settings in the SEO feature.</li>\n<li>Make sure images are not distorted when Tiled Galleries uses Photon.</li>\n<li>Avoid PHP warnings and errors in the Stats dashboard on Multisite.</li>\n<li>Avoid errors when the Jetpack plugin is deleted.</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"https://wordpress.org/plugins/jetpack/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/wordpress-importer/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 18:48:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Uncategorized\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins-wp/wordpress-importer/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4618:\"<p><!--section=description--></p>\n<p>The WordPress Importer will import the following content from a WordPress export file:</p>\n<ul>\n<li>Posts, pages and other custom post types</li>\n<li>Comments</li>\n<li>Custom fields and post meta</li>\n<li>Categories, tags and terms from custom taxonomies</li>\n<li>Authors</li>\n</ul>\n<p>For further information and instructions please see the <a href=\"https://codex.wordpress.org/Importing_Content#WordPress\" rel=\"nofollow\">Codex page on Importing Content</a></p>\n<h3>Filters</h3>\n<p>The importer has a couple of filters to allow you to completely enable/block certain features:</p>\n<ul>\n<li><code>import_allow_create_users</code>: return false if you only want to allow mapping to existing users</li>\n<li><code>import_allow_fetch_attachments</code>: return false if you do not wish to allow importing and downloading of attachments</li>\n<li><code>import_attachment_size_limit</code>: return an integer value for the maximum file size in bytes to save (default is 0, which is unlimited)</li>\n</ul>\n<p>There are also a few actions available to hook into:</p>\n<ul>\n<li><code>import_start</code>: occurs after the export file has been uploaded and author import settings have been chosen</li>\n<li><code>import_end</code>: called after the last output from the importer</li>\n</ul>\n<p><!--section=faq--></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<p>The quickest method for installing the importer is:</p>\n<ol>\n<li>Visit Tools -&gt; Import in the WordPress dashboard</li>\n<li>Click on the WordPress link in the list of importers</li>\n<li>Click &#8220;Install Now&#8221;</li>\n<li>Finally click &#8220;Activate Plugin &amp; Run Importer&#8221;</li>\n</ol>\n<p>If you would prefer to do things manually then follow these instructions:</p>\n<ol>\n<li>Upload the <code>wordpress-importer</code> folder to the <code>/wp-content/plugins/</code> directory</li>\n<li>Activate the plugin through the &#8216;Plugins&#8217; menu in WordPress</li>\n<li>Go to the Tools -&gt; Import screen, click on WordPress</li>\n</ol>\n</dd>\n<dt>Help! I&#8217;m getting out of memory errors or a blank screen.</dt>\n<dd>\n<p>If your exported file is very large, the import script may run into your host&#8217;s configured memory limit for PHP.</p>\n<p>A message like &#8220;Fatal error: Allowed memory size of 8388608 bytes exhausted&#8221; indicates that the script can&#8217;t successfully import your XML file under the current PHP memory limit. If you have access to the php.ini file, you can manually increase the limit; if you do not (your WordPress installation is hosted on a shared server, for instance), you might have to break your exported XML file into several smaller pieces and run the import script one at a time.</p>\n<p>For those with shared hosting, the best alternative may be to consult hosting support to determine the safest approach for running the import. A host may be willing to temporarily lift the memory limit and/or run the process directly from their end.</p>\n<p>&#8212; <a href=\"https://codex.wordpress.org/Importing_Content#Before_Importing\" rel=\"nofollow\">WordPress Codex: Importing Content</a></p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<h4>0.6.3</h4>\n<ul>\n<li>Add support for import term metadata.</li>\n<li>Fix bug that caused slashes to be stripped from imported content.</li>\n<li>Fix bug that caused characters to be stripped inside of CDATA in some cases.</li>\n<li>Fix PHP notices.</li>\n</ul>\n<h4>0.6.2</h4>\n<ul>\n<li>Add wp_import_existing_post filter. See: https://core.trac.wordpress.org/ticket/33721</li>\n</ul>\n<h4>0.6</h4>\n<ul>\n<li>Support for WXR 1.2 and multiple CDATA sections</li>\n<li>Post aren&#8217;t duplicates if their post_type&#8217;s are different</li>\n</ul>\n<h4>0.5.2</h4>\n<ul>\n<li>Double check that the uploaded export file exists before processing it. This prevents incorrect error messages when<br />\nan export file is uploaded to a server with bad permissions and WordPress 3.3 or 3.3.1 is being used.</li>\n</ul>\n<h4>0.5</h4>\n<ul>\n<li>Import comment meta (requires export from WordPress 3.2)</li>\n<li>Minor bugfixes and enhancements</li>\n</ul>\n<h4>0.4</h4>\n<ul>\n<li>Map comment user_id where possible</li>\n<li>Import attachments from <code>wp:attachment_url</code></li>\n<li>Upload attachments to correct directory</li>\n<li>Remap resized image URLs correctly</li>\n</ul>\n<h4>0.3</h4>\n<ul>\n<li>Use an XML Parser if possible</li>\n<li>Proper import support for nav menus</li>\n<li>&#8230; and much more, see <a href=\"https://core.trac.wordpress.org/ticket/15197\" rel=\"nofollow\">Trac ticket #15197</a></li>\n</ul>\n<h4>0.1</h4>\n<ul>\n<li>Initial release</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"https://wordpress.org/plugins/woocommerce/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/plugins/woocommerce/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Sep 2011 15:32:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins-wp/woocommerce/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:40601:\"<p><!--section=description--></p>\n<p>WooCommerce is a free eCommerce plugin that allows you to sell anything, beautifully. Built to integrate seamlessly with WordPress, WooCommerce is the world’s favorite eCommerce solution that gives both store owners and developers complete control.</p>\n<p>With endless flexibility and access to hundreds of free and premium WordPress extensions, WooCommerce now powers 30% of all online stores &#8212; more than any other platform.</p>\n<iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/1KahlicghaE?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe>\n<h4>Sell anything, anywhere</h4>\n<p>With WooCommerce, you can sell both physical and digital goods in all shapes and sizes, offer product variations, multiple configurations, and instant downloads to shoppers, and even sell affiliate goods from online marketplaces.</p>\n<p>With premium extensions, you can offer bookings, memberships, and recurring subscriptions. Perhaps you’d like to sell monthly subscriptions for physical goods, or offer your members a discount on digital downloads? It’s all possible.</p>\n<h4>Ship wherever you like</h4>\n<p>Offer free shipping, flat rate shipping, or make real-time calculations. Limit your shipments to specific countries, or open your store up to the world. Shipping is highly configurable, and WooCommerce even supports drop shipping.</p>\n<h4>Extensive payment options</h4>\n<p>WooCommerce comes bundled with the ability to accept major credit cards, PayPal, BACS (bank transfers), and cash on delivery. Need additional options? More than 140 region-specific gateways integrate with WooCommerce, including popular choices like Stripe, Authorize.Net, and Amazon Payments.</p>\n<h4>You control it all &#8212; forever</h4>\n<p>WooCommerce gives you complete control of your store, from taxes to stock levels to customer accounts. Add and remove extensions, change your design, and switch settings as you please. It’s all under your control.</p>\n<p>One of the biggest risks of using a hosted eCommerce platform is what happens to your store if the provider closes up shop. With WooCommerce, you have complete control, so there’s never any reason to worry. Your data belongs to you &#8212; and it’s kept secure, thanks to regular audits by industry leaders.</p>\n<h4>Define your style with Storefront</h4>\n<p><a href=\"https://wordpress.org/themes/storefront/\" rel=\"nofollow\">Storefront</a> is a free WordPress theme available to any WooCommerce store. Along with deep WooCommerce integration, Storefront prioritizes speed and uptime while eliminating theme and plugin conflicts during major updates.</p>\n<p>Define your style even further by customizing Storefront to your liking or choosing from one of our several <a href=\"https://woocommerce.com/product-category/themes/storefront-child-theme-themes/\" rel=\"nofollow\">Storefront child themes</a>. It’s all up to you, and all open source.</p>\n<h4>Built with developers in mind</h4>\n<p>Extendable, adaptable, and open source &#8212; WooCommerce was created with developers in mind. With its strong, robust framework, you can scale your client’s store all the way from basic to high-end (infinity and beyond).</p>\n<p>Built with a REST API, WooCommerce can integrate with virtually any service. Your store’s data can be accessed anywhere, anytime, 100% securely. WooCommerce allows developers to easily create, modify, and grow a store that meets their specifications.</p>\n<p>No matter the size of the store you want to build, WooCommerce will scale to meet your requirements. With a growing collection of more than 300 extensions, you can enhance each store’s features to meet your client’s unique needs &#8212; or even create your own solution.</p>\n<p>If security is a concern, rest easy. WooCommerce is audited by a dedicated team of developers working around the clock to identify and patch any and all discovered bugs.</p>\n<p>We also support WooCommerce and all its extensions with comprehensive, easily-accessible documentation. With our docs, you’ll learn how to create the exact site your client needs.</p>\n<h4>Extensions galore</h4>\n<p>WordPress.org is home to some amazing extensions for WooCommerce, including:</p>\n<ul>\n<li><a href=\"https://wordpress.org/plugins/woocommerce-google-analytics-integration/\">Google Analytics</a></li>\n<li><a href=\"https://wordpress.org/plugins/woocommerce-delivery-notes/\">Delivery Notes</a></li>\n<li><a href=\"https://wordpress.org/plugins/woocommerce-pdf-invoices-packing-slips/\">PDF Invoices and Packing Slips</a></li>\n<li><a href=\"https://wordpress.org/plugins/affiliates-woocommerce-light/\">Affiliates Integration Light</a></li>\n<li><a href=\"https://wordpress.org/plugins/woocommerce-new-product-badge/\">New Product Badges</a></li>\n</ul>\n<p>Keen to see them all? Search WordPress.org for ‘WooCommerce’ to dive in.</p>\n<p>If you’re looking for something endorsed and maintained by the developers who built WooCommerce, there are a plethora of premium eCommerce extensions, the most popular of which include:</p>\n<ul>\n<li><a href=\"https://woocommerce.com/products/woocommerce-subscriptions/\" rel=\"nofollow\">WooCommerce Subscriptions</a></li>\n<li><a href=\"https://woocommerce.com/products/woocommerce-memberships/\" rel=\"nofollow\">WooCommerce Memberships</a></li>\n<li><a href=\"https://woocommerce.com/products/woocommerce-bookings/\" rel=\"nofollow\">WooCommerce Bookings</a></li>\n<li><a href=\"https://woocommerce.com/products/dynamic-pricing/\" rel=\"nofollow\">Dynamic Pricing</a></li>\n<li><a href=\"https://woocommerce.com/products/table-rate-shipping/\" rel=\"nofollow\">Table Rate Shipping</a></li>\n<li><a href=\"https://woocommerce.com/products/product-csv-import-suite/\" rel=\"nofollow\">Product CSV Import Suite</a></li>\n</ul>\n<p>And there’s plenty more where they came from. Visit our <a href=\"https://woocommerce.com/product-category/woocommerce-extensions/\" rel=\"nofollow\">extensions page</a> to find out everything you’re capable of and all that&#8217;s possible with premium WooCommerce extensions.</p>\n<h4>Join our growing community</h4>\n<p>When you download WooCommerce, you join a community of more than a million store owners, developers, and WordPress enthusiasts. We’re one of the fastest-growing open source communities online, and whether you’re a n00b or a Ninja, we’d love to have you!</p>\n<p>If you’re interested in contributing to WooCommerce we’ve got more than 350 contributors, and there’s always room for more. Head over to the <a href=\"https://github.com/woocommerce/woocommerce\" rel=\"nofollow\">WooCommerce GitHub Repository</a> to find out how you can pitch in.</p>\n<p>Want to add a new language to WooCommerce? Swell! You can contribute via <a href=\"https://translate.wordpress.org/projects/wp-plugins/woocommerce\" rel=\"nofollow\">translate.wordpress.org</a>.</p>\n<p>And, finally, consider joining or spearheading a WooCommerce Meetup locally, more about those <a href=\"https://woocommerce.com/woocommerce/meetups/\" rel=\"nofollow\">here</a>.</p>\n<p><!--section=installation--></p>\n<h4>Minimum Requirements</h4>\n<ul>\n<li>PHP version 5.2.4 or greater (PHP 5.6 or greater is recommended)</li>\n<li>MySQL version 5.0 or greater (MySQL 5.6 or greater is recommended)</li>\n<li>Some payment gateways require fsockopen support (for IPN access)</li>\n<li>WooCommerce 2.5 requires WordPress 4.1+</li>\n<li>WooCommerce 2.6 requires WordPress 4.4+</li>\n</ul>\n<p>Visit the <a href=\"https://docs.woocommerce.com/document/server-requirements/\" rel=\"nofollow\">WooCommerce server requirements documentation</a> for a detailed list of server requirements.</p>\n<h4>Automatic installation</h4>\n<p>Automatic installation is the easiest option as WordPress handles the file transfers itself and you don’t need to leave your web browser. To do an automatic install of WooCommerce, log in to your WordPress dashboard, navigate to the Plugins menu and click Add New.</p>\n<p>In the search field type “WooCommerce” and click Search Plugins. Once you’ve found our eCommerce plugin you can view details about it such as the point release, rating and description. Most importantly of course, you can install it by simply clicking “Install Now”.</p>\n<h4>Manual installation</h4>\n<p>The manual installation method involves downloading our eCommerce plugin and uploading it to your webserver via your favourite FTP application. The WordPress codex contains <a href=\"https://codex.wordpress.org/Managing_Plugins#Manual_Plugin_Installation\" rel=\"nofollow\">instructions on how to do this here</a>.</p>\n<h4>Updating</h4>\n<p>Automatic updates should work like a charm; as always though, ensure you backup your site just in case.</p>\n<p>If on the off-chance you do encounter issues with the shop/category pages after an update you simply need to flush the permalinks by going to WordPress &gt; Settings &gt; Permalinks and hitting &#8216;save&#8217;. That should return things to normal.</p>\n<h4>Dummy data</h4>\n<p>WooCommerce comes with some dummy data you can use to see how products look; either import dummy_data.xml via the <a href=\"https://wordpress.org/plugins/wordpress-importer/\">WordPress importer</a> or use our <a href=\"https://woocommerce.com/products/product-csv-import-suite/\" rel=\"nofollow\">CSV Import Suite plugin</a> to import dummy_data.csv and dummy_data_variations.csv.</p>\n<p><!--section=faq--></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<h4>Minimum Requirements</h4>\n<ul>\n<li>PHP version 5.2.4 or greater (PHP 5.6 or greater is recommended)</li>\n<li>MySQL version 5.0 or greater (MySQL 5.6 or greater is recommended)</li>\n<li>Some payment gateways require fsockopen support (for IPN access)</li>\n<li>WooCommerce 2.5 requires WordPress 4.1+</li>\n<li>WooCommerce 2.6 requires WordPress 4.4+</li>\n</ul>\n<p>Visit the <a href=\"https://docs.woocommerce.com/document/server-requirements/\" rel=\"nofollow\">WooCommerce server requirements documentation</a> for a detailed list of server requirements.</p>\n<h4>Automatic installation</h4>\n<p>Automatic installation is the easiest option as WordPress handles the file transfers itself and you don’t need to leave your web browser. To do an automatic install of WooCommerce, log in to your WordPress dashboard, navigate to the Plugins menu and click Add New.</p>\n<p>In the search field type “WooCommerce” and click Search Plugins. Once you’ve found our eCommerce plugin you can view details about it such as the point release, rating and description. Most importantly of course, you can install it by simply clicking “Install Now”.</p>\n<h4>Manual installation</h4>\n<p>The manual installation method involves downloading our eCommerce plugin and uploading it to your webserver via your favourite FTP application. The WordPress codex contains <a href=\"https://codex.wordpress.org/Managing_Plugins#Manual_Plugin_Installation\" rel=\"nofollow\">instructions on how to do this here</a>.</p>\n<h4>Updating</h4>\n<p>Automatic updates should work like a charm; as always though, ensure you backup your site just in case.</p>\n<p>If on the off-chance you do encounter issues with the shop/category pages after an update you simply need to flush the permalinks by going to WordPress &gt; Settings &gt; Permalinks and hitting &#8216;save&#8217;. That should return things to normal.</p>\n<h4>Dummy data</h4>\n<p>WooCommerce comes with some dummy data you can use to see how products look; either import dummy_data.xml via the <a href=\"https://wordpress.org/plugins/wordpress-importer/\">WordPress importer</a> or use our <a href=\"https://woocommerce.com/products/product-csv-import-suite/\" rel=\"nofollow\">CSV Import Suite plugin</a> to import dummy_data.csv and dummy_data_variations.csv.</p>\n</dd>\n<dt>Where can I find WooCommerce documentation and user guides?</dt>\n<dd>\n<p>For help setting up and configuring WooCommerce please refer to our <a href=\"https://docs.woocommerce.com/documentation/plugins/woocommerce/getting-started/\" rel=\"nofollow\">user guide</a></p>\n<p>For extending or theming WooCommerce, see our <a href=\"https://docs.woocommerce.com/documentation/plugins/woocommerce/woocommerce-codex/\" rel=\"nofollow\">codex</a>.</p>\n</dd>\n<dt>Where can I get support or talk to other users?</dt>\n<dd>\n<p>If you get stuck, you can ask for help in the <a href=\"https://wordpress.org/support/plugin/woocommerce\" rel=\"nofollow\">WooCommerce Plugin Forum</a>.</p>\n<p>For help with premium extensions from WooThemes, use <a href=\"https://support.woothemes.com/\" rel=\"nofollow\">our helpdesk</a>.</p>\n</dd>\n<dt>Will WooCommerce work with my theme?</dt>\n<dd>\n<p>Yes; WooCommerce will work with any theme, but may require some styling to make it match nicely. Please see our <a href=\"https://docs.woocommerce.com/documentation/plugins/woocommerce/woocommerce-codex/\" rel=\"nofollow\">codex</a> for help. If you&#8217;re looking for a theme with built in WooCommerce integration we recommend <a href=\"https://woocommerce.com/storefront/\" rel=\"nofollow\">Storefront</a>.</p>\n</dd>\n<dt>Where can I request new features, eCommerce themes and extensions?</dt>\n<dd>\n<p>You can vote on and request new features and extensions in our <a href=\"http://ideas.woothemes.com/forums/133476-woocommerce\" rel=\"nofollow\">WooIdeas board</a></p>\n</dd>\n<dt>Where can I report bugs or contribute to the project?</dt>\n<dd>\n<p>Bugs can be reported either in our support forum or preferably on the <a href=\"https://github.com/woocommerce/woocommerce/issues\" rel=\"nofollow\">WooCommerce GitHub repository</a>.</p>\n</dd>\n<dt>Where can I find the REST API documentation?</dt>\n<dd>\n<p>You can find the documentation of our REST API on the <a href=\"https://woocommerce.github.io/woocommerce-rest-api-docs/\" rel=\"nofollow\">WooCommerce REST API Docs</a>.</p>\n</dd>\n<dt>WooCommerce is awesome! Can I contribute?</dt>\n<dd>\n<p>Yes you can! Join in on our <a href=\"http://github.com/woocommerce/woocommerce/\" rel=\"nofollow\">GitHub repository</a> <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<h4>3.0.8 &#8211; 2017-06-06</h4>\n<ul>\n<li>Fix &#8211; Include multi-dimensional array support in oAuth1.0.</li>\n<li>Fix &#8211; Stock/backorder notice when stock management is disabled.</li>\n<li>Fix &#8211; Handle shipping item taxes if set to avoid the legacy fallback.</li>\n<li>Fix &#8211; Variations should inherit purchase_note from parent.</li>\n<li>Fix &#8211; Check if subtotal is blank, not empty, before setting for order items.</li>\n<li>Fix &#8211; Cancelled email should be send for processing orders, not pending.</li>\n<li>Fix &#8211; Missing variable in legacy API.</li>\n<li>Fix &#8211; Correct price query when on a post type archive.</li>\n<li>Fix &#8211; Missing $ip Variable in geolocation class.</li>\n<li>Fix &#8211; A single multi-word attribute is fine for variation titles.</li>\n<li>Fix &#8211; Gallery should be updated even if empty in REST API.</li>\n<li>Fix &#8211; Fix saving of text attributes with special chars.</li>\n<li>Fix &#8211; Undefined index warning when saving variations with stock management disabled.</li>\n<li>Fix &#8211; Use meta id instead of key in WC_Order_Item::offsetGet.</li>\n<li>Fix &#8211; Format parent stock qty on read.</li>\n<li>Fix &#8211; Hide replies from recent reviews widgets.</li>\n<li>Fix &#8211; Use formatted weight and dimensions for variations.</li>\n<li>Fix &#8211; Ensure we have child before getting price to fix a notice in grouped products.</li>\n<li>Fix &#8211; Fixed unicode characters when saving webhook delivery logs.</li>\n<li>Fix &#8211; Avoid deprecated ID in legacy API.</li>\n<li>Fix &#8211; Add correct args to woocommerce_shipping_zone_method_deleted and woocommerce_shortcode_products_query hooks.</li>\n<li>Fix &#8211; Correctly append cache in product widget.</li>\n<li>Fix &#8211; Add ability to invalidate cache by object ID.</li>\n<li>Fix &#8211; Notice in structured data class.</li>\n<li>Fix &#8211; Only delete if an object has an ID in CRUD to avoid wp_delete_post using global ID.</li>\n<li>Fix &#8211; Avoid notices on checkout by ensuring all legacy data is correctly set.</li>\n<li>Fix &#8211; Add failed to processing event for the processing email.</li>\n<li>Fix &#8211; Store user ID and use that to determine if the session should be loaded or not. Ensures user data is correct and shipping calculator data is stored.</li>\n</ul>\n<h4>3.0.7 &#8211; 2017-05-16</h4>\n<ul>\n<li>Fix &#8211; Display of grouped product permalinks + names.</li>\n<li>Fix &#8211; Ensure <code>wc_get_payment_gateway_by_order</code> has a valid order ID to avoid errors.</li>\n<li>Fix &#8211; Ensure <code>get_plugin_updates</code> exists in API.</li>\n<li>Fix &#8211; Correctly set rating term after updating product visibility.</li>\n<li>Fix &#8211; <code>is_ip_address</code> should be static.</li>\n<li>Fix &#8211; Handle clearing for 3, 4, and 5 columns in the product gallery.</li>\n<li>Fix &#8211; Some added protection against notices/errors in the assets and variation data-store files.</li>\n<li>Fix &#8211; If backorders are enabled, do not make variable products out of stock.</li>\n<li>Fix &#8211; Undefined function in <code>class-wc-embed.php</code>.</li>\n<li>Fix &#8211; Fix &#8216;base location&#8217; not being returned via the settings API.</li>\n<li>Fix &#8211; When re-filling fields on checkout, only change the empty ones to avoid conflicts with gateway plugins and hidden fields.</li>\n<li>Fix &#8211; Make calculate tax function clear taxes if taxes are disabled on recalculation.</li>\n<li>Fix &#8211; Update all customer session address fields when updating via checkout.</li>\n<li>Fix &#8211; Support customer searches &lt; 3 characters long, but with result limiting.</li>\n</ul>\n<h4>3.0.6 &#8211; 2017-05-09</h4>\n<ul>\n<li>Fix &#8211; Fixed conflict between global attributes and custom attributes with the same names.</li>\n<li>Fix &#8211; Added missing &#8220;id&#8221; to API for shipping zone methods to support the CLI.</li>\n<li>Fix &#8211; Incorrect use of <code>wc_format_price_range</code> in <code>get_price_html_from_to</code>.</li>\n<li>Fix &#8211; Clone each meta object when cloning WC_Data object to avoid modifying original meta stdClass objects.</li>\n<li>Fix &#8211; Fix non numeric warning for some order data.</li>\n<li>Fix &#8211; Fixed a warning when no customer country is defined for state input.</li>\n<li>Fix &#8211; Use term name when reordering so correct data is passed to the new order.</li>\n<li>Fix &#8211; Formatting issues in wc_display_item_meta.</li>\n<li>Fix &#8211; Check if IP address is valid in IP address detection code.</li>\n<li>Fix &#8211; wc_attribute_taxonomy_id_by_name should use wc_sanitize_taxonomy_name to prevent breaking special chars.</li>\n<li>Fix &#8211; Correct variable name in order structured data.</li>\n<li>Fix &#8211; Prepend new item keys with <code>$items_key</code> to make them unique.</li>\n<li>Fix &#8211; Hide offers from structured markup when blank.</li>\n<li>Fix &#8211; Fixed &#8220;Process to checkout&#8221; button color in Twenty seventeen dark theme.</li>\n<li>Fix &#8211; Only set reply-to if the email + name is set.</li>\n<li>Fix &#8211; Correctly exclude terms in wc_get_related_products.</li>\n<li>Fix &#8211; Reset post data prevents grouped products working in shortcodes.</li>\n<li>Fix &#8211; Fix min price range comparisons.</li>\n<li>Fix &#8211; Properly save order items in legacy REST API.</li>\n<li>Fix &#8211; Use correct full size for variation images.</li>\n<li>Fix &#8211; Add noscript style for gallery.</li>\n<li>Fix &#8211; Fix/duplicate potential stock reduction with paypal.</li>\n<li>Tweak &#8211; Improve _wc_term_recount performance.</li>\n<li>Tweak &#8211; Improve plugin update detection in system status report to reduce timeouts.</li>\n<li>Tweak &#8211; Improve &#8220;Save Order&#8221; button to reproduce WordPress post/page behavior.</li>\n<li>Tweak &#8211; Added zipcode validation for France.</li>\n<li>Dev &#8211; Added woocommerce_shop_order_search_results filter.</li>\n</ul>\n<h4>3.0.5 &#8211; 2017-04-28</h4>\n<ul>\n<li>Fix &#8211; Tooltip display within shipping zone modals.</li>\n<li>Fix &#8211; Fix missing title for actions column on mobile.</li>\n<li>Fix &#8211; Allow forward slash in telephone field.</li>\n<li>Fix &#8211; Sort grouped products by menu order when displaying.</li>\n<li>Fix &#8211; Fix term exclusion in term count queries.</li>\n<li>Fix &#8211; Filter invalid products before returning them for wc_get_products.</li>\n<li>Fix &#8211; Prevent orders being their own parent (causes errors).</li>\n<li>Fix &#8211; Correctly migrate legacy shipping taxes data.</li>\n<li>Fix &#8211; Make sure the meta data cache is not shared among instances.</li>\n<li>Fix &#8211; Correct the stock display notice when a variable product manages stock for it&#8217;s children.</li>\n<li>Fix &#8211; On multisite, add user to blog during checkout if not a user to prevent errors.</li>\n<li>Fix &#8211; Correct sale price date handling with some timezone setups.</li>\n<li>Fix &#8211; wc_attribute_taxonomy_id_by_name needs to use lowercase attribute slug to work.</li>\n<li>Fix &#8211; Make changes to the buyer&#8217;s company name in the shipping section of checkout persist.</li>\n<li>Tweak &#8211; Add required placeholder for meta fields in backend.</li>\n<li>Tweak &#8211; Don&#8217;t strtolower address strings on checkout validation messages.</li>\n<li>REST API &#8211; Prevent password change notification when creating a customer.</li>\n<li>REST API &#8211; Removed duplicated items returned in shipping and checkout endpoints.</li>\n<li>CLI &#8211; Fixed missing shipping zones route.</li>\n<li>Dev &#8211; Make get_price_html handling match 2.6 and pass all values through woocommerce_get_price_html filter.</li>\n<li>Dev &#8211; Legacy customer class missing get_address / get_address_2 functions.</li>\n<li>Dev &#8211; Restored filter <code>woocommerce_checkout_customer_id</code> during checkout validation.</li>\n<li>Dev &#8211; Adds missing <code>$this</code> argument for all <code>woocommerce_payment_complete_order_status</code> filters.</li>\n</ul>\n<h4>3.0.4 &#8211; 2017-04-20</h4>\n<ul>\n<li>Fix &#8211; Variations were not inheriting the product image and shipping class ID.</li>\n<li>Fix &#8211; Prevent rating/review counts being duplicated when duplicating products.</li>\n<li>Fix &#8211; Fixed gallery navigation between images with long captions.</li>\n<li>Fix &#8211; Support transparent PNG in the gallery by setting a background color.</li>\n<li>Fix &#8211; Removed name/company from the shipping address Google map links.</li>\n<li>Fix &#8211; Fixed the address field sorting script on the checkout.</li>\n<li>Fix &#8211; Fixed the upgrade routine for grouped products so that parents are unset.</li>\n<li>Fix &#8211; Fixed support for WordPress 4.7 user locale settings.</li>\n<li>Fix &#8211; Fixed default option filter for product types in the product meta box.</li>\n<li>Fix &#8211; Improved the css in Twenty Seventeen for dark color schemes.</li>\n<li>Fix &#8211; Fixed display of refunds in sales report.</li>\n<li>Fix &#8211; Updated <code>single-product/add-to-cart/variable.php</code> template version to 3.0.0 since it had changes since 2.6.</li>\n<li>Fix &#8211; Fixed warnings when product attribute do not exists.</li>\n<li>Fix &#8211; Used a div for comment-form-rating to prevent invalid nested markup.</li>\n<li>Fix &#8211; Fixed some logic that checks if order taxes are compound.</li>\n<li>Fix &#8211; Fixed SKU checks to only exclude products that are trashed.</li>\n<li>Fix &#8211; Fixed display of download permissions in first email sent after checkout.</li>\n<li>Fix &#8211; Hidden the backorder notification stock text when notification is disabled.</li>\n<li>Fix &#8211; Fixed incorrect stock numbers in low stock emails.</li>\n<li>Tweak &#8211; Removed the non-functional order total input box, and combined the recalculation buttons into one working button.</li>\n<li>Tweak &#8211; Updated Guided Tour videos.</li>\n<li>Tweak &#8211; Updated js-cookie.js to 2.1.4.</li>\n<li>Tweak &#8211; Updated schema.org URLs to use HTTPS.</li>\n<li>Tweak &#8211; Status report request timeouts.</li>\n<li>REST API &#8211; Fixed an issue that prevented deleting a term if errors were thrown during creation.</li>\n<li>REST API &#8211; Fixed reports endpoint when querying by date.</li>\n<li>REST API &#8211; Fixed ignored order parameters when changing order status.</li>\n<li>Dev &#8211; Support guest orders in <code>wc_get_orders</code> function.</li>\n<li>Dev &#8211; Fixed downloadable variation filters for download URLs.</li>\n<li>Dev &#8211; Added safeguards to prevent infinite loops while saving coupons, products and orders in admin.</li>\n<li>Dev &#8211; Added a fallback for <code>queue_transactional_email</code> if background sending is disabled.</li>\n<li>Dev &#8211; Added <code>has_shipping_address</code> helper method.</li>\n<li>Dev &#8211; Introduced <code>woocommerce_order_item_get_formatted_meta_data</code> filter.</li>\n<li>Dev &#8211; Made wc_add_order_item pass correct values to woocommerce_new_order_item.</li>\n<li>Dev &#8211; Fixed <code>legacy_posted_data</code> access in checkout class.</li>\n<li>Dev &#8211; Fixed undefined property notice in <code>WC_Order_Item::offsetGet</code>.</li>\n<li>Dev &#8211; Fixed PHP 7.1 warnings when using non-float values to <code>wc_get_weight()</code>.</li>\n<li>Dev &#8211; Fixed incorrect variable name in <code>wc_add_order_item()</code>.</li>\n</ul>\n<h4>3.0.3 &#8211; 2017-04-13</h4>\n<ul>\n<li>Fix &#8211; Fixed an issue with variation tax-classes when set to &#8216;parent&#8217;. This made taxes apply on top of the tax inclusive price in certain setups.</li>\n<li>Fix &#8211; Escaped attribute translations in the <code>cart.php</code> template and bumped the template version to match.</li>\n<li>Fix &#8211; Corrected the display of refund dates on the order screen.</li>\n<li>Fix &#8211; Fixed the grouped product visibility check in the grouped.php template and bumped the template version to match.</li>\n<li>Fix &#8211; Fixed the sale badge display for grouped products.</li>\n<li>Fix &#8211; Added the <code>itemReviewed</code> structured data for product reviews to make it validate.</li>\n<li>Fix &#8211; Made the <code>get_attribute</code> method work on variation objects.</li>\n<li>Tweak &#8211; Turned off the deferred email sending by default which was added in 3.0. Whilst it does improve performance, there were compatibility problems on some servers. It can be enabled with a filter if desired.</li>\n<li>Dev &#8211; Added backtrace information to the deprecation messages to help find problem plugins.</li>\n</ul>\n<h4>3.0.2 &#8211; 2017-04-12</h4>\n<ul>\n<li>Fix &#8211; Removed required states for GP, GF, KW, LB, MQ, RE and YT countries.</li>\n<li>Fix &#8211; Made cache in the [products] shortcode respect filters from plugins.</li>\n<li>Fix &#8211; Added missing <code>woocommerce_cross_sells_columns</code> filter.</li>\n<li>Fix &#8211; Fixed shortcode rendering on the shop page.</li>\n<li>Fix &#8211; Fixed incorrect sale dates when bulk editing variations.</li>\n<li>Fix &#8211; Fixed calls to wc_reduce_stock_levels in PayPal and Simplify gateways.</li>\n<li>Fix &#8211; Exclude &#8220;location&#8221; meta when reading customer meta data.</li>\n<li>Fix &#8211; Updated <code>emails/email-addresses.php</code>, <code>emails/email-order-details.php</code>, <code>content-single-product.php</code>, <code>checkout/form-shipping.php</code>, <code>myaccount/form-add-payment-method.php</code>, <code>myaccount/form-edit-address.php</code>, <code>myaccount/form-lost-password.php</code>, <code>myaccount/form-reset-password.php</code>, <code>myaccount/orders.php</code> and <code>myaccount/view-order.php</code> template version to 3.0.0 since they had changes since 2.6.</li>\n<li>Fix &#8211; Fixed default behavior of variation tax classes when originally set to &#8220;parent&#8221;.</li>\n<li>Fix &#8211; When duplicating products, do not copy slug, append &#8220;(Copy)&#8221; to the product name, correctly copy all meta data, and prevent children of grouped products being duplicated too.</li>\n<li>Fix &#8211; Removed duplicated items when outputting cross sells on the cart page.</li>\n<li>Fix &#8211; Fixed output of default &#8220;add to cart&#8221; text of external products in loops.</li>\n<li>Fix &#8211; Fixed backwards compatibility of guest checkout rules when being altered by plugins directly.</li>\n<li>Fix &#8211; Use correct thumbnail sizes for variation images in the new gallery.</li>\n<li>Fix &#8211; Fixed captions on thumbnails and main image in the new gallery.</li>\n<li>Fix &#8211; Trigger wc_fragments_loaded after add to cart fragment refresh.</li>\n<li>Fix &#8211; Download permissions; Convert dates to timestamp on read so UTC is preserved.</li>\n<li>Fix &#8211; Fixed notices under PHP 7.1 when sorting products by name (numeric).</li>\n<li>Fix &#8211; Added additional checks to ensure objects are read before using class methods to avoid errors.</li>\n<li>Fix &#8211; Removed legacy suggest.js code which was causing JS error on bulk edit.</li>\n<li>Fix &#8211; Fixed warnings on the &#8220;Lost password&#8221; page and when loading a product with invalid attributes.</li>\n<li>Fix &#8211; Made background emailer update the queue after a successful send so duplicate mails are less likely.</li>\n<li>Fix &#8211; Typo in flexslider_enabled option in new gallery script.</li>\n<li>Fix &#8211; woocommerce_notify_low_stock and woocommerce_notify_no_stock options had no effect.</li>\n<li>Tweak &#8211; For downloadable files, only validate file type when dealing with relative paths.</li>\n<li>Tweak &#8211; Improved automatic variation name generation.</li>\n<li>Dev &#8211; Added product visibility terms to system status report to help debug.</li>\n<li>Dev &#8211; Introduced <code>woocommerce_admin_order_date_format</code> filter to replace missing <code>post_date_column_time</code>.</li>\n<li>Dev &#8211; Introduced <code>woocommerce_update_customer_args</code> filter to prevent updates to user objects if needed.</li>\n<li>REST API &#8211; Fixed saving of variations in legacy REST API v3.</li>\n<li>REST API &#8211; Fixed backwards compatibility of line_items meta in legacy REST API.</li>\n</ul>\n<h4>3.0.1 &#8211; 2017-04-06</h4>\n<ul>\n<li>Fix &#8211; Show catalog hidden products within grouped products.</li>\n<li>Fix &#8211; Fade in the gallery in if no images are set or it&#8217;s custom.</li>\n<li>Fix &#8211; Use wc_deprecated_function in WC_Deprecated_Hooks so notices aren&#8217;t output in ajax requests.</li>\n<li>Fix &#8211; Added back the ability to include extra items to the System Status using the <code>woocommerce_system_status_environment_rows</code> filter.</li>\n<li>Fix &#8211; Coupon category restrictions and limits for variations.</li>\n<li>Fix &#8211; Allow shortcodes and HTML in variation descriptions like in 2.6.</li>\n<li>Fix &#8211; Unset post date when duplicating products.</li>\n<li>Fix &#8211; Show a sale price on variable products if on sale and all prices are the same.</li>\n<li>Fix &#8211; Corrected download links when a product has multiple downloads.</li>\n<li>Fix &#8211; Prevented potential errors if the product type was not posted for any reason on save.</li>\n<li>Fix &#8211; Updated <code>single-product/up-sells.php</code>, <code>loop/add-to-cart.php</code>, <code>loop/rating.php</code>, <code>checkout/form-billing.php</code>, and <code>content-product.php</code> template version to 3.0.0.</li>\n<li>Fix &#8211; Included clearfixes on billing and shipping field wrappers,</li>\n<li>Fix &#8211; Fixed styling of logs table in some languages.</li>\n<li>Fix &#8211; Fixed display of variation attributes on old orders.</li>\n<li>Fix &#8211; Use placeholder text for external products add to cart button text if left blank.</li>\n<li>Fix &#8211; Fallback to home URL if no shop page is set for system status security check for HTTPS.</li>\n<li>Fix &#8211; For variations, pull tax status and sold individually from the parent since there is no UI to set this at variation level.</li>\n<li>Fix &#8211; Moved cron emails to background processing to avoid multiple sends.</li>\n<li>Fix &#8211; Wrapped structured data in a hidden element when added to emails.</li>\n<li>Fix &#8211; Missing gateway information in queued emails.</li>\n<li>Fix &#8211; Fixed a bug that caused pages to permanently reload if &#8220;Default customer location&#8221; was set to &#8220;Geolocate (with page caching support)&#8221;.</li>\n<li>Fix &#8211; When forcing shipping to billing, set the shipping fields in the order itself.</li>\n<li>Fix &#8211; Check for invalid objects in WC_Register_WP_Admin_Settings.</li>\n<li>Fix &#8211; Check for error object in wc_get_object_terms.</li>\n<li>Fix &#8211; Removed slashes in shipping meta data on the order edit screen.</li>\n<li>Fix &#8211; Prevented permalink rewrites for attributes with missing names.</li>\n<li>Fix &#8211; Fixed saving of meta data when multiple extensions use the <code>save_post</code> action.</li>\n<li>Fix &#8211; Allow search customers by ID in edit order screen.</li>\n<li>Fix &#8211; Prevents session data overwriting customer data on login.</li>\n<li>Fix &#8211; Fixed cross-sell column display and variation support.</li>\n<li>Fix &#8211; Fixed variable product stock syncing on save.</li>\n<li>Fix &#8211; Included try/catch wrapper to prevent issues with Select2.</li>\n<li>Fix &#8211; Prevented a bug that deleted all variations when the product type was change from variable to simple.</li>\n<li>Fix &#8211; Switched to WPDB to quicker update when syncing titles for variations.</li>\n<li>Fix &#8211; Exclude deprecated properties when loading a customer object.</li>\n<li>Fix &#8211; Fixed notices while trying to order again.</li>\n<li>Fix &#8211; Fixed notices when <code>$wpdb-&gt;prefix</code> is empty.</li>\n<li>Fix &#8211; Prevent errors when loading a product with an invalid download file types.</li>\n<li>REST API &#8211; Fixed missing array declaration in CRUD controller.</li>\n<li>REST API &#8211; Removed extra <code>exclude</code>, <code>include</code> and <code>search</code> parameters from taxes endpoint.</li>\n<li>REST API &#8211; Fixed variation description formatting.</li>\n<li>REST API &#8211; Fixed incorrect attribute check in products endpoint in Legacy REST API.</li>\n<li>REST API &#8211; Allow variation image to be unset.</li>\n</ul>\n<h4>3.0.0 &#8211; 2017-04-04</h4>\n<ul>\n<li>New gallery on single product pages with better mobile support, using PhotoSwipe and Zoom. Declare support with add_theme_support() &#8211; wc-product-gallery-zoom, wc-product-gallery-lightbox, wc-product-gallery-slider</li>\n<li>Made the store notice dismissible on the frontend.</li>\n<li>Variable products no longer show striked out prices in combination with ranges for clarity when on sale.</li>\n<li>Prices no longer display as &#8216;free&#8217; instead of 0, to fix issues with ranges and localization and for consistency.</li>\n<li>Improved structured product data by using JSON-LD instead of inline Microdata.</li>\n<li>Improved downloads list layout (template file).</li>\n<li>Respect stock status and prevent the &#8220;out of stock threshold&#8221; setting affecting existing in-stock products.</li>\n<li>Improved handling of shop page rewrite rules to allow subpages.</li>\n<li>Redirect to login after password reset.</li>\n<li>When using authorizations in PayPal Standard, automatically capture funds when the order goes processing/completed.</li>\n<li>On multisite, when a user logs into a store with an account on a site, but not the current site, rather than error, add the user to the current site as a customer.</li>\n<li>Show variable weights/dimensions even when parent values are not set.</li>\n<li>Automatically sort tax rates rather than allow clunky manual sorting.</li>\n<li>When deleting a tax rate class, remove it&#8217;s tax rates.</li>\n<li>Made WC_Logger pluggable via wc_get_logger function.</li>\n<li>Use &#8216;average rating&#8217; post meta for &#8216;rating&#8217; product sorting option.</li>\n<li>Show better labels in nav menus metabox.</li>\n<li>Sort “Recently Viewed” products by the view order.</li>\n<li>Removed internal scroll from log viewer.</li>\n<li>Add reply-to to admin emails.</li>\n<li>Improved the zone setup flow.</li>\n<li>Made wc_get_wildcard_postcodes return the orignal postcode plus * since wildcards should match empty strings too.</li>\n<li>Use all paid statuses in $customer-&gt;get_total_spent().</li>\n<li>Move location of billing email field to work with password managers.</li>\n<li>Option to restrict selling locations by country.</li>\n<li>Added tool to clear orphaned variations in system status.</li>\n<li>Remove checkbox options in system status tools and replace with constants.</li>\n<li>Added security section in system status report.</li>\n<li>Add image_url setting to PayPal Standard.</li>\n<li>Fixed attribute registration. Attributes are non-hierarchical by default (parent is not supported).</li>\n<li>Add sort parameter to checkout fields to aid with sorting per locale.</li>\n<li>Merged percent and percent product coupon types (they provide the same discount).</li>\n<li>Prevent payment details being cleared after update_checkout events.</li>\n<li>Performance &#8211; Converted _featured and _visibility meta data to terms for faster catalog queries. Upgrade routine handles migration. Developers may need to update queries to reflect this change.</li>\n<li>Includes product attributes archives links in &#8220;Additional Information&#8221; tab.</li>\n<li>Select2 has been upgraded to v4.</li>\n<li>Improved logging system for extensions.</li>\n<li>Tax suffix is now hidden on non-taxable products.</li>\n<li>Grouped products are linked from the parent rather than the children. Children can be in more than one group.</li>\n<li>Removed coupon usage link in coupons admin screen.</li>\n<li>Performance &#8211; Converted rating filters to visibility terms.</li>\n<li>Performance &#8211; Added visibility term for outofstock products to speed those queries up also.</li>\n<li>Performance &#8211; Introduced a new CRUD (create, read, update, delete) system for Products, Orders, Customers and Shipping Zones.</li>\n<li>Performance &#8211; Optimised variable product sync. Upper/lower price meta is no longer stored, just the main prices, if a child has weight, and if a child has dimensions.</li>\n<li>Performance &#8211; Removed WP_Query from up-sells.php and related.php and replaced with PHP foreach loop (since we already have the product IDs).</li>\n<li>Performance &#8211; Removed the feature where old orders get access to new downloads on product edit. Looping potentially thousands of orders to do this is too much of a performance burden for stores and this can sometimes be unexpected behavior too. This does however updates <em>edited</em> downloads.</li>\n<li>Performance &#8211; Removed &#8216;items&#8217; column on orders screen due to loading excessive data.</li>\n<li>Performance &#8211; Deferred email sending for faster checkouts. Now uses CRON.</li>\n<li>API &#8211; New Rest API v2 with support for meta_data amongst other things.</li>\n<li>API &#8211; Removed last order from customers part of the API due to performance concerns &#8211; use orders endpoint instead. Other order data on the endpoint is now transient cached.</li>\n<li>API &#8211; Allow oAuth1.0a authentication using headers.</li>\n<li>API &#8211; New Shipping Zones endpoints.</li>\n<li>API &#8211; New variations endpoints.</li>\n<li>API &#8211; New settings endpoints.</li>\n<li>API &#8211; Payment gateways and shipping methods endpoints.</li>\n<li>API &#8211; Prevented the (broken) ability to manipulate variations directly on the products endpoints.</li>\n<li>CLI &#8211; New CLI which uses the REST API endpoints rather than it&#8217;s own functions.</li>\n<li>Localization &#8211; Improved RTL support.</li>\n<li>Localization &#8211; Added a language independent permalink setting function.</li>\n<li>Localization &#8211; Added inline comments for placeholder strings.</li>\n<li>Localization &#8211; Added Nigerian and Pakistan Provinces to i18n/state.</li>\n<li>Localization &#8211; US and Poland postcode validation.</li>\n<li>To read more about this release, see our dev blog announcement here: http://wp.me/p6wtcw-Uo</li>\n</ul>\n<p><a href=\"https://raw.githubusercontent.com/woocommerce/woocommerce/master/CHANGELOG.txt\" rel=\"nofollow\">See changelog for all versions</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://wordpress.org/plugins/woocommerce/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/plugins/all-in-one-seo-pack/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wordpress.org/plugins/all-in-one-seo-pack/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 19:30:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins-wp/all-in-one-seo-pack/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"The original SEO plugin for WordPress, downloaded over 30,000,000 times since 2007.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4934:\"<p><!--section=description--></p>\n<p>Use <strong>All in One SEO Pack</strong> to optimize your WordPress site for SEO. It&#8217;s easy and works out of the box for beginners, and has advanced features and an API for developers.</p>\n<p><strong><a href=\"http://semperplugins.com/plugins/all-in-one-seo-pack-pro-version/?loc=readme_utpv\" rel=\"nofollow\">Upgrade to Pro Version</a></strong></p>\n<p><a href=\"http://semperplugins.com/support/?loc=readme_ps\" rel=\"nofollow\">Premium Support</a></p>\n<p>First created in 2007, see why AIOSEO is one of the all time most downloaded plugins for WordPress.</p>\n<ul>\n<li>XML Sitemap support &#8211; submit your sitemap to Google and Bing and improve your SEO</li>\n<li>Google AMP support (Accelerated Mobile Pages)</li>\n<li>Google Analytics support</li>\n<li>Support for SEO on Custom Post Types</li>\n<li>Advanced Canonical URLs</li>\n<li>Redirect attachment pages to parent post</li>\n<li>Automatically notifies search engines like Google and Bing about changes to your site</li>\n<li>Built-in API so other plugins/themes can access and extend functionality</li>\n<li>ONLY free plugin to provide SEO Integration for e-Commerce sites, including WooCommerce</li>\n<li>Nonce Security built into All in One SEO Pack</li>\n<li>Automatically optimizes your <strong>titles</strong> for Google and other search engines</li>\n<li>Generates <strong>META tags automatically</strong></li>\n<li>Avoids the typical duplicate content found on WordPress blogs</li>\n<li>For beginners, you don&#8217;t even have to look at the options, it works out-of-the-box. Just install.</li>\n<li>For advanced users, you can fine-tune everything to optimize your SEO</li>\n<li>You can override any title and set any META description and any META keywords you want.</li>\n<li>Compatibility with many other plugins</li>\n<li>Translated into 57 languages</li>\n<li>PHP 7 100% Compatible</li>\n</ul>\n<p>Follow me on Twitter to keep up with the latest updates <a href=\"http://twitter.com/michaeltorbert/\" rel=\"nofollow\">Michael<br />\nTorbert</a></p>\n<p><iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/46MR4FboMaA?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe></p>\n<h4>Tags</h4>\n<p>seo, SEO, All in One, google, meta, meta description, search engine optimization, xml sitemap, xml sitemaps, google sitemap, sitemap, sitemaps, robots meta, rss, rss footer, yahoo, bing, widget, Post, plugin, admin, posts, shortcode, sidebar, twitter, page, images, comments, image, news sitemaps, XML News Sitemaps, WordPress SEO, multisite, canonical, nofollow, noindex, keywords, meta keywords, description, webmaster tools, google webmaster tools, seo pack, schema.org, search engines, custom post types, custom taxonomies, canonical</p>\n<p><!--section=faq--></p>\n<p>Please visit our complete <strong><a href=\"http://semperplugins.com/documentation/\" rel=\"nofollow\">Documentation</a></strong> before requesting support for SEO from the<br />\n<strong><a href=\"http://semperplugins.com/support/\" rel=\"nofollow\">All in One SEO Pack Support Forum</a></strong></p>\n<p><a href=\"http://semperfiwebdesign.com/documentation/all-in-one-seo-pack/translations-for-all-in-one-seo-pack/\" rel=\"nofollow\">Translations</a></p>\n<dl>\n<dt>General Settings</dt>\n<dd>\n<p><iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/uGt6CVbA5bI?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe></p>\n</dd>\n<dt>XML Sitemaps</dt>\n<dd>\n<p><iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/zvNU92Low8A?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe></p>\n</dd>\n<dt>Social Meta</dt>\n<dd>\n<p><iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/Dfe49FiiAog?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe></p>\n</dd>\n<dt>Performance</dt>\n<dd>\n<p><iframe class=\'youtube-player\' type=\'text/html\' width=\'640\' height=\'390\' src=\'https://www.youtube.com/embed/A0VKinM5s00?version=3&#038;rel=1&#038;fs=1&#038;autohide=2&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;wmode=transparent\' allowfullscreen=\'true\' style=\'border:0;\'></iframe></p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<p>All in One SEO Pack <a href=\"http://semperfiwebdesign.com/documentation/all-in-one-seo-pack/all-in-one-seo-pack-release-history/\" rel=\"nofollow\">Changelog</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/all-in-one-seo-pack/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/google-sitemap-generator/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"https://wordpress.org/plugins/google-sitemap-generator/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Jun 2005 09:33:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wordpress.org/plugins-wp/google-sitemap-generator/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"This plugin will generate a special XML sitemap which will help search engines to better&#8230;\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Arne Brachhold\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7635:\"<p><!--section=description--></p>\n<p>This plugin will generate a special XML sitemap which will help search engines like Google, Bing, Yahoo and Ask.com to better index your blog. With such a sitemap, it&#8217;s much easier for the crawlers to see the complete structure of your site and retrieve it more efficiently. The plugin supports all kinds of WordPress generated pages as well as custom URLs. Additionally it notifies all major search engines every time you create a post about the new content.</p>\n<p>Supported since <em>over 9 years</em> and rated as the <a href=\"https://wordpress.org/plugins/browse/top-rated/\">best WordPress plugin</a>, it will do exactly what it&#8217;s supposed to do &#8211; providing a complete XML sitemap for search engines. It will not break your site, slow it down or annoy you. Guaranteed!</p>\n<blockquote>\n<p>If you like the plugin, feel free to rate it (on the right side of this page) or <a href=\"http://www.arnebrachhold.de/redir/sitemap-paypal/\" rel=\"nofollow\">donate via PayPal</a>. I&#8217;m gladly supporting this plugin since over 9 years! Thanks a lot! <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></p>\n</blockquote>\n<p>Related Links:</p>\n<ul>\n<li><a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/\" title=\"Google XML Sitemaps Plugin for WordPress\" rel=\"nofollow\">Plugin Homepage</a></li>\n<li><a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/changelog/\" title=\"Changelog of the Google XML Sitemaps Plugin for WordPress\" rel=\"nofollow\">Changelog</a></li>\n<li><a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/help/\" title=\"Google Sitemaps FAQ\" rel=\"nofollow\">Plugin help and sitemaps FAQ</a></li>\n<li><a href=\"https://wordpress.org/support/topic/read-before-opening-a-new-support-topic\" rel=\"nofollow\">Support Forum</a></li>\n</ul>\n<h3>License</h3>\n<p>Good news, this plugin is free for everyone! Since it&#8217;s released under the GPL, you can use it free of charge on your personal or commercial blog. But if you enjoy this plugin, you can thank me and leave a <a href=\"http://www.arnebrachhold.de/redir/sitemap-paypal\" title=\"Donate with PayPal\" rel=\"nofollow\">small donation</a> for the time I&#8217;ve spent writing and supporting this plugin. And I really don&#8217;t want to know how many hours of my life this plugin has already eaten <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f609.png\" alt=\"😉\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></p>\n<h3>Translations</h3>\n<p>The plugin comes with various translations, please refer to the <a href=\"https://codex.wordpress.org/Installing_WordPress_in_Your_Language\" title=\"Installing WordPress in Your Language\" rel=\"nofollow\">WordPress Codex</a> for more information about activating the translation. If you want to help to translate the plugin to your language, please have a look at the sitemap.pot file which contains all definitions and may be used with a <a href=\"http://www.gnu.org/software/gettext/\" rel=\"nofollow\">gettext</a> editor like <a href=\"http://www.poedit.net/\" rel=\"nofollow\">Poedit</a> (Windows).</p>\n<p><!--section=installation--></p>\n<ol>\n<li>Install the plugin like you always install plugins, either by uploading it via FTP or by using the &#8220;Add Plugin&#8221; function of WordPress.</li>\n<li>Activate the plugin at the plugin administration page</li>\n<li>If you want: Open the plugin configuration page, which is located under Settings -&gt; XML-Sitemap and customize settings like priorities and change frequencies.</li>\n<li>The plugin will automatically update your sitemap of you publish a post, so there is nothing more to do <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></li>\n</ol>\n<p><!--section=faq--></p>\n<dl>\n<dt>Where can I find the options page of the plugin?</dt>\n<dd>\n<p>It is under Settings &gt; XML Sitemap. I know nowadays many plugins add top-level menu items, but in most of the cases it is just not necessary. I&#8217;ve seen WP installations which looked like an Internet Explorer ten years ago with 20 toolbars installed. <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f609.png\" alt=\"😉\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></p>\n</dd>\n<dt>Do I have to create a sitemap.xml and sitemap.xml.gz by myself?</dt>\n<dd>\n<p>Not anymore. Since version 4, these files are dynamically generated. <em>There must be no sitemap.xml or sitemap.xml.gz in your blog directory anymore!</em> The plugin will try to rename them to sitemap.xml.bak if they still exists.</p>\n</dd>\n<dt>Does this plugin use static files or &#8220;I can&#8217;t find the sitemap.xml file!&#8221;</dt>\n<dd>\n<p>Not anymore. Since version 4, these files are dynamically generated just like any other WordPress content.</p>\n</dd>\n<dt>There are no comments yet (or I&#8217;ve disabled them) and all my postings have a priority of zero!</dt>\n<dd>\n<p>Please disable automatic priority calculation and define a static priority for posts.</p>\n</dd>\n<dt>So many configuration options&#8230; Do I need to change them?</dt>\n<dd>\n<p>No, only if you want to. Default values are ok for most sites.</p>\n</dd>\n<dt>Does this plugin work with all WordPress versions?</dt>\n<dd>\n<p>This version works with WordPress 3.3 and better. If you&#8217;re using an older version, please check the <a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/\" title=\"Google (XML) Sitemap Generator Plugin Homepage\" rel=\"nofollow\">Google Sitemaps Plugin Homepage</a> for the legacy releases. There is a working release for every WordPress version since 1.5, but you really should consider updating your WordPress installation!</p>\n</dd>\n<dt>My question isn&#8217;t answered here</dt>\n<dd>\n<p>Most of the plugin options are described at the <a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/\" rel=\"nofollow\">plugin homepage</a> as well as the dedicated <a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/help/\" title=\"List of common questions / problems regarding Google (XML) Sitemaps\" rel=\"nofollow\">Google Sitemaps FAQ</a>.</p>\n</dd>\n<dt>My question isn&#8217;t even answered there</dt>\n<dd>\n<p>Please post your question at the <a href=\"https://wordpress.org/support/topic/read-before-opening-a-new-support-topic\" rel=\"nofollow\">WordPress support forum</a> and tag your post with &#8220;google-sitemap-generator&#8221;.</p>\n</dd>\n<dt>What&#8217;s new in the latest version?</dt>\n<dd>\n<p>The changelog is maintained <a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/changelog/\" title=\"Google (XML) Sitemap Generator Plugin Changelog\" rel=\"nofollow\">here</a></p>\n</dd>\n<dt>Why is the changelog on a separate page and not here?</dt>\n<dd>\n<p>The WordPress.org repository is just another place to download this plugin. I don&#8217;t want to maintain too many pages with the same content. Thank you for your understanding!</p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<p>You can always find the changelog on <a href=\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/changelog/\" title=\"Google (XML) Sitemap Generator Plugin Changelog\" rel=\"nofollow\">the plugin website</a>, since I don&#8217;t like to maintain the same content on different pages. Thank you for your understanding!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/google-sitemap-generator/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Limit Login Attempts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/limit-login-attempts/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/limit-login-attempts/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 15 Jan 2009 14:20:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins-wp/limit-login-attempts/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"Limit rate of login attempts, including by way of cookies, for each IP. Fully customizable.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:11759:\"<p><!--section=description--></p>\n<p>Limit the number of login attempts possible both through normal login as well as using auth cookies.</p>\n<p>By default WordPress allows unlimited login attempts either through the login page or by sending special cookies. This allows passwords (or hashes) to be brute-force cracked with relative ease.</p>\n<p>Limit Login Attempts blocks an Internet address from making further attempts after a specified limit on retries is reached, making a brute-force attack difficult or impossible.</p>\n<p>Features</p>\n<ul>\n<li>Limit the number of retry attempts when logging in (for each IP). Fully customizable</li>\n<li>Limit the number of attempts to log in using auth cookies in same way</li>\n<li>Informs user about remaining retries or lockout time on login page</li>\n<li>Optional logging, optional email notification</li>\n<li>Handles server behind reverse proxy</li>\n<li>It is possible to whitelist IPs using a filter. But you probably shouldn&#8217;t. <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></li>\n</ul>\n<p>Translations: Bulgarian, Brazilian Portuguese, Catalan, Chinese (Traditional), Czech, Dutch, Finnish, French, German, Hungarian, Norwegian, Persian, Romanian, Russian, Spanish, Swedish, Turkish</p>\n<p>Plugin uses standard actions and filters only.</p>\n<p><!--section=installation--></p>\n<ol>\n<li>Download and extract plugin files to a wp-content/plugin directory.</li>\n<li>Activate the plugin through the WordPress admin interface.</li>\n<li>Customize the settings on the options page, if desired. If your server is located behind a reverse proxy make sure to change this setting.</li>\n</ol>\n<p>If you have any questions or problems please make a post here: https://wordpress.org/tags/limit-login-attempts</p>\n<p><!--section=faq--></p>\n<dl>\n<dt>Why not reset failed attempts on a successful login?</dt>\n<dd>\n<p>This is very much by design. Otherwise you could brute force the &#8220;admin&#8221; password by logging in as your own user every 4th attempt.</p>\n</dd>\n<dt>What is this option about site connection and reverse proxy?</dt>\n<dd>\n<p>A reverse proxy is a server in between the site and the Internet (perhaps handling caching or load-balancing). This makes getting the correct client IP to block slightly more complicated.</p>\n<p>The option default to NOT being behind a proxy &#8212; which should be by far the common case.</p>\n</dd>\n<dt>How do I know if my site is behind a reverse proxy?</dt>\n<dd>\n<p>You probably are not or you would know. We show a pretty good guess on the option page. Set the option using this unless you are sure you know better.</p>\n</dd>\n<dt>Can I whitelist my IP so I don&#8217;t get locked out?</dt>\n<dd>\n<p>First please consider if you really need this. Generally speaking it is not a good idea to have exceptions to your security policies.</p>\n<p>That said, there is now a filter which allows you to do it: &#8220;limit_login_whitelist_ip&#8221;.</p>\n<p>Example:<br />\nfunction my_ip_whitelist($allow, $ip) {<br />\n     return ($ip == &#8216;my-ip&#8217;) ? true : $allow;<br />\n}<br />\nadd_filter(&#8216;limit_login_whitelist_ip&#8217;, &#8216;my_ip_whitelist&#8217;, 10, 2);</p>\n<p>Note that we still do notification and logging as usual. This is meant to allow you to be aware of any suspicious activity from whitelisted IPs.</p>\n</dd>\n<dt>I locked myself out testing this thing, what do I do?</dt>\n<dd>\n<p>Either wait, or:</p>\n<p>If you know how to edit / add to PHP files you can use the IP whitelist functionality described above. You should then use the &#8220;Restore Lockouts&#8221; button on the plugin settings page and remove the whitelist function again.</p>\n<p>If you have ftp / ssh access to the site rename the file &#8220;wp-content/plugins/limit-login-attempts/limit-login-attempts.php&#8221; to deactivate the plugin.</p>\n<p>If you have access to the database (for example through phpMyAdmin) you can clear the limit_login_lockouts option in the wordpress options table. In a default setup this would work: &#8220;UPDATE wp_options SET option_value = &#8221; WHERE option_name = &#8216;limit_login_lockouts\'&#8221;</p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<h4>1.7.1</h4>\n<p>This version fixes a security bug in version 1.6.2 and 1.7.0. Please upgrade immediately.</p>\n<p>&#8220;Auth cookies&#8221; are special cookies set at login that authenticating you to the system. It is how WordPress &#8220;remembers&#8221; that you are logged in between page loads.</p>\n<p>During lockout these are supposed to be cleared, but a change in 1.6.2 broke this. It allowed an attacker to keep trying to break these cookies during a lockout.</p>\n<p>Lockout of normal password login attempts still worked as it should, and it appears that all &#8220;auth cookie&#8221; attempts would keep getting logged.</p>\n<p>In theory the &#8220;auth cookie&#8221; is quite resistant to brute force attack. It contains a cryptographic hash of the user password, and the difficulty to break it is not based on the password strength but instead on the cryptographic operations used and the length of the hash value. In theory it should take many many years to break this hash. As theory and practice does not always agree it is still a good idea to have working lockouts of any such attempts.</p>\n<h4>1.7.0</h4>\n<ul>\n<li>Added filter that allows whitelisting IP. Please use with care!!</li>\n<li>Update to Spanish translation, thanks to Marcelo Pedra</li>\n<li>Updated Swedish translation</li>\n<li>Tested against WordPress 3.3.2</li>\n</ul>\n<h4>1.6.2</h4>\n<ul>\n<li>Fix bug where log would not get updated after it had been cleared</li>\n<li>Do plugin setup in &#8216;init&#8217; action</li>\n<li>Small update to Spanish translation file, thanks to Marcelo Pedra</li>\n<li>Tested against WordPress 3.2.1</li>\n</ul>\n<h4>1.6.1</h4>\n<ul>\n<li>(WordPress 3.0+) An invalid cookie can sometimes get sent multiple times before it gets cleared, resulting in multiple failed attempts or even a lockout from a single invalid cookie. Store the latest failed cookie to make sure we only count it as one failed attempt</li>\n<li>Define &#8220;Text Domain&#8221; correctly</li>\n<li>Include correct Dutch tranlation file. Thanks to Martin1 for noticing. Thanks again to Bjorn Wijers for the translation</li>\n<li>Updated POT file for this version</li>\n<li>Tested against WordPress 3.1-RC4</li>\n</ul>\n<h4>1.6.0</h4>\n<ul>\n<li>Happy New Year</li>\n<li>Tested against WordPress 3.1-RC1</li>\n<li>Plugin now requires WordPress version 2.8+. Of course you should never ever use anything but the latest version</li>\n<li>Fixed deprecation warnings that had been piling up with the old version requirement. Thanks to Johannes Ruthenberg for the report that prompted this</li>\n<li>Removed auth cookie admin check for version 2.7.</li>\n<li>Make sure relevant values in $_COOKIE get cleared right away on auth cookie validation failure. There are still some problems with cookie auth handling. The lockout can trigger prematurely in rare cases, but fixing it is plugin version 2 stuff unfortunately.</li>\n<li>Changed default time for retries to reset from 24 hours to 12 hours. The security impact is very minor and it means the warning will disappear &#8220;overnight&#8221;</li>\n<li>Added question to FAQ (&#8220;Why not reset failed attempts on a successful login?&#8221;)</li>\n<li>Updated screenshots</li>\n</ul>\n<h4>1.5.2</h4>\n<ul>\n<li>Reverted minor cookie-handling cleanup which might somehow be responsible for recently reported cookie related lockouts</li>\n<li>Added version 1.x Brazilian Portuguese translation, thanks to Luciano Passuello</li>\n<li>Added Finnish translation, thanks to Ari Kontiainen</li>\n</ul>\n<h4>1.5.1</h4>\n<ul>\n<li>Further multisite &amp; WPMU support (again thanks to <a href=\"mailto:&#101;&#114;&#105;&#x6b;&#x40;&#101;&#114;&#105;&#x6b;&#x73;&#x68;&#111;&#115;t&#x69;&#x6e;&#103;&#046;c&#x6f;&#x6d;\" rel=\"nofollow\">&#101;&#114;&#105;&#x6b;&#x40;&#101;&#114;&#105;&#x6b;&#x73;&#x68;&#111;&#115;t&#x69;&#x6e;&#103;&#046;c&#x6f;&#x6d;</a>)</li>\n<li>Better error handling if option variables are damaged</li>\n<li>Added Traditional Chinese translation, thanks to Denny Huang <a href=\"mailto:&#x62;&#105;&#x67;&#101;&#x78;&#112;&#x6c;&#111;&#114;&#x61;&#116;&#x69;&#111;&#x6e;&#115;&#064;&#x62;&#105;&#x67;&#101;&#x78;&#112;&#108;&#x6f;&#114;&#x61;&#116;&#x69;&#111;n&#x73;&#046;&#x63;&#111;&#x6d;&#046;t&#x77;\" rel=\"nofollow\">&#x62;&#105;&#x67;&#101;&#x78;&#112;&#x6c;&#111;&#114;&#x61;&#116;&#x69;&#111;&#x6e;&#115;&#064;&#x62;&#105;&#x67;&#101;&#x78;&#112;&#108;&#x6f;&#114;&#x61;&#116;&#x69;&#111;n&#x73;&#046;&#x63;&#111;&#x6d;&#046;t&#x77;</a></li>\n</ul>\n<h4>1.5</h4>\n<ul>\n<li>Tested against WordPress 3.0</li>\n<li>Handle 3.0 login page failure &#8220;shake&#8221;</li>\n<li>Basic multisite support (parts thanks to <a href=\"mailto:&#101;&#114;&#105;&#x6b;&#x40;&#101;&#114;&#105;&#x6b;&#x73;&#x68;&#111;&#115;t&#x69;&#x6e;&#103;&#046;c&#x6f;&#x6d;\" rel=\"nofollow\">&#101;&#114;&#105;&#x6b;&#x40;&#101;&#114;&#105;&#x6b;&#x73;&#x68;&#111;&#115;t&#x69;&#x6e;&#103;&#046;c&#x6f;&#x6d;</a>)</li>\n<li>Added Dutch translation, thanks to Bjorn Wijers <a href=\"mailto:b&#117;&#x72;&#111;&#x62;&#x6a;&#111;&#x72;n&#064;&#x62;&#117;&#x72;&#x6f;&#098;&#x6a;&#111;&#114;&#x6e;&#046;&#x6e;l\" rel=\"nofollow\">b&#117;&#x72;&#111;&#x62;&#x6a;&#111;&#x72;n&#064;&#x62;&#117;&#x72;&#x6f;&#098;&#x6a;&#111;&#114;&#x6e;&#046;&#x6e;l</a></li>\n<li>Added Hungarian translation, thanks to B?lint Vereskuti <a href=\"mailto:&#098;&#097;&#x6c;&#x69;&#110;&#116;&#x40;v&#101;&#x72;&#x65;&#115;&#107;&#x75;&#x74;&#105;&#046;&#x69;n&#102;&#x6f;\" rel=\"nofollow\">&#098;&#097;&#x6c;&#x69;&#110;&#116;&#x40;v&#101;&#x72;&#x65;&#115;&#107;&#x75;&#x74;&#105;&#046;&#x69;n&#102;&#x6f;</a></li>\n<li>Added French translation, thanks to oVa <a href=\"mailto:&#111;&#118;&#x61;&#x31;&#x33;l&#097;&#115;&#x74;&#x61;&#x72;&#064;&#103;&#109;&#097;&#x69;&#x6c;&#x2e;&#099;&#111;&#109;\" rel=\"nofollow\">&#111;&#118;&#x61;&#x31;&#x33;l&#097;&#115;&#x74;&#x61;&#x72;&#064;&#103;&#109;&#097;&#x69;&#x6c;&#x2e;&#099;&#111;&#109;</a></li>\n</ul>\n<h4>1.4.1</h4>\n<ul>\n<li>Added Turkish translation, thanks to Yazan Canarkadas</li>\n</ul>\n<h4>1.4</h4>\n<ul>\n<li>Protect admin page update using wp_nonce</li>\n<li>Added Czech translation, thanks to Jakub Jedelsky</li>\n</ul>\n<h4>1.3.2</h4>\n<ul>\n<li>Added Bulgarian translation, thanks to Hristo Chakarov</li>\n<li>Added Norwegian translation, thanks to Rune Gulbrands?y</li>\n<li>Added Spanish translation, thanks to Marcelo Pedra</li>\n<li>Added Persian translation, thanks to Mostafa Soufi</li>\n<li>Added Russian translation, thanks to Jack Leonid (http://studio-xl.com)</li>\n</ul>\n<h4>1.3.1</h4>\n<ul>\n<li>Added Catalan translation, thanks to Robert Buj</li>\n<li>Added Romanian translation, thanks to Robert Tudor</li>\n</ul>\n<h4>1.3</h4>\n<ul>\n<li>Support for getting the correct IP for clients while server is behind reverse proxy, thanks to Michael Skerwiderski</li>\n<li>Added German translation, thanks to Michael Skerwiderski</li>\n</ul>\n<h4>1.2</h4>\n<ul>\n<li>No longer replaces pluggable function when cookie handling active. Re-implemented using available actions and filters</li>\n<li>Filter error messages during login to avoid information leak regarding available usernames</li>\n<li>Do not show retries or lockout messages except for login (registration, lost password pages). No change in actual enforcement</li>\n<li>Slightly more aggressive in trimming old retries data</li>\n</ul>\n<h4>1.1</h4>\n<ul>\n<li>Added translation support</li>\n<li>Added Swedish translation</li>\n<li>During lockout, filter out all other login errors</li>\n<li>Minor cleanups</li>\n</ul>\n<h4>1.0</h4>\n<ul>\n<li>Initial version</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/limit-login-attempts/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n		\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://wordpress.org/plugins/tinymce-advanced/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/tinymce-advanced/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Jun 2007 06:02:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/plugins-wp/tinymce-advanced/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Extends and enhances TinyMCE, the WordPress Visual Editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:10701:\"<p><!--section=description--></p>\n<p>This plugin will let you add, remove and arrange the buttons that are shown on the Visual Editor toolbar. You can configure up to four rows of buttons including Font Sizes, Font Family, text and background colors, tables, etc. It will also let you enable the editor menu, see the <a href=\"screenshots\" rel=\"nofollow\">screenshots</a>.</p>\n<p>It includes 15 plugins for <a href=\"http://tinymce.com/\" rel=\"nofollow\">TinyMCE</a> that are automatically enabled or disabled depending on the buttons you have chosen. In addition this plugin adds some commonly used options as keeping the paragraph tags in the Text editor and importing the CSS classes from the theme&#8217;s editor-style.css.</p>\n<h4>Some of the features added by this plugin</h4>\n<ul>\n<li>Support for creating and editing tables.</li>\n<li>More options when inserting lists.</li>\n<li>Search and Replace in the editor.</li>\n<li>Ability to set Font Family and Font Sizes.</li>\n<li>And many others.</li>\n</ul>\n<p>With this plugin you can also enable the TinyMCE menu above the toolbars. This will make the editor even more powerful and convenient.</p>\n<p><!--section=installation--></p>\n<p>Best is to install directly from WordPress. If manual installation is required, please make sure that the plugin files are in a folder named &#8220;tinymce-advanced&#8221; (not two nested folders) in the WordPress plugins folder, usually &#8220;wp-content/plugins&#8221;.</p>\n<p><!--section=faq--></p>\n<dl>\n<dt>Installation Instructions</dt>\n<dd>\n<p>Best is to install directly from WordPress. If manual installation is required, please make sure that the plugin files are in a folder named &#8220;tinymce-advanced&#8221; (not two nested folders) in the WordPress plugins folder, usually &#8220;wp-content/plugins&#8221;.</p>\n</dd>\n<dt>No styles are imported in the Formats sub-menu.</dt>\n<dd>\n<p>These styles are imported from your current theme editor-style.css file. However some themes do not have this functionality. For these themes TinyMCE Advanced has the option to let you add a customized editor-style.css and import it into the editor.</p>\n</dd>\n<dt>I have just installed this plugin, but it does not do anything.</dt>\n<dd>\n<p>Change some buttons on one of the toolbars, save your changes, clear your browser cache, and try again. If that does not work try reloding the Edit page several times while holding down Shift or Ctrl. There may also be a network cache somewhere between you and your host. You may need to wait for a few hours until this cache expires.</p>\n</dd>\n<dt>When I add &#8220;Smilies&#8221;, they do not show in the editor.</dt>\n<dd>\n<p>The &#8220;Emoticons&#8221; button in TinyMCE adds the codes for the smilies. The actual images are added by WordPress when viewing the Post. Make sure the checkbox &#8220;Convert emoticons to graphics on display&#8221; in &#8220;Options &#8211; Writing&#8221; is checked.</p>\n</dd>\n<dt>The plugin does not add any buttons.</dt>\n<dd>\n<p>Make sure the &#8220;Disable the visual editor when writing&#8221; checkbox under &#8220;Users &#8211; Your Profile&#8221; is <strong>not</strong> checked.</p>\n</dd>\n<dt>I still see the &#8220;old&#8221; buttons in the editor</dt>\n<dd>\n<p>Click the &#8220;Restore Default Settings&#8221; button on the plugin settings page and then set the buttons again and save.</p>\n</dd>\n<dt>Other questions? More screenshots?</dt>\n<dd>\n<p>Please post on the support forum or visit the homepage for <a href=\"http://www.laptoptips.ca/projects/tinymce-advanced/\" rel=\"nofollow\">TinyMCE Advanced</a>.</p>\n</dd>\n</dl>\n<p><!--section=changelog--></p>\n<h4>4.6.3</h4>\n<ul>\n<li>Updated for WordPress 4.8 and TinyMCE 4.6.3.</li>\n</ul>\n<h4>4.5.6</h4>\n<ul>\n<li>Updated for WordPress 4.7.4 and TinyMCE 4.5.6.</li>\n<li>Fixed PHP notice after importing settings.</li>\n</ul>\n<h4>4.4.3</h4>\n<ul>\n<li>Updated for WordPress 4.7 and TinyMCE 4.4.3.</li>\n<li>Fixed missing &#8220;Source code&#8221; button bug.</li>\n</ul>\n<h4>4.4.1</h4>\n<ul>\n<li>Updated for WordPress 4.6 and TinyMCE 4.4.1.</li>\n<li>Fixed multisite saving bug.</li>\n<li>Added new button in the Text editor to add or reset the line breaks. Adds line breaks only between tags. Works only when it detects that line breaks are missing so it doesn&#8217;t reformat posts with removed paragraphs.</li>\n</ul>\n<h4>4.3.10.1</h4>\n<ul>\n<li>Fixed adding paragraph tags when loading posts that were saved before turning autop off.</li>\n<li>Disabled the (new) inline toolbar for tables as it was overlapping the table in some cases.</li>\n</ul>\n<h4>4.3.10</h4>\n<ul>\n<li>Updated for WordPress 4.5.1 and TinyMCE 4.3.10.</li>\n<li>Fixed support for adding editor-style.css to themes that don&#8217;t have it.</li>\n</ul>\n<h4>4.3.8</h4>\n<ul>\n<li>Updated for WordPress 4.5 and TinyMCE 4.3.8.</li>\n<li>Separated standard options and admin options.</li>\n<li>Added settings that can disable the plugin for the main editor, other editors in wp-admin or editors on the front-end.</li>\n<li>Korean translation by Josh Kim and Greek translation by Stathis Mellios.</li>\n</ul>\n<h4>4.2.8</h4>\n<ul>\n<li>Updated for WordPress 4.4 and TinyMCE 4.2.8.</li>\n<li>Japanese translation by Manabu Miwa.</li>\n</ul>\n<h4>4.2.5</h4>\n<ul>\n<li>Updated for WordPress 4.3.1 and TinyMCE 4.2.5.</li>\n<li>Fixed text domain and plugin headers.</li>\n</ul>\n<h4>4.2.3.1</h4>\n<ul>\n<li>Fix error with removing the &#8216;textpattern&#8217; plugin.</li>\n</ul>\n<h4>4.2.3</h4>\n<ul>\n<li>Updated for WordPress 4.3 and TinyMCE 4.2.3.</li>\n<li>Removed the &#8216;textpattern&#8217; plugin as WordPress 4.3 includes similar functionality by default.</li>\n<li>French translation by Nicolas Schneider.</li>\n</ul>\n<h4>4.1.9</h4>\n<ul>\n<li>Updated for WordPress 4.2 and TinyMCE 4.1.9.</li>\n<li>Fixed bugs with showing oEmbed previews when pasting an URL.</li>\n<li>Fixed bugs with getting the content from TinyMCE with line breaks.</li>\n</ul>\n<h4>4.1.7</h4>\n<ul>\n<li>Updated for WordPress 4.1 and TinyMCE 4.1.7.</li>\n<li>Fixed bug where consecutive caption shortcodes may be split with an empty paragraph tag.</li>\n</ul>\n<h4>4.1.1</h4>\n<ul>\n<li>Fix bug with image captions when wpautop is disabled.</li>\n<li>Add translation support to the settings page. Button names/descriptions are translated from JS using the existing WordPress translation, so this part of the settings page will be translated by default. The other text still needs separate translation.</li>\n</ul>\n<h4>4.1</h4>\n<ul>\n<li>Updated for WordPress 4.0 and TinyMCE 4.1.</li>\n<li>Add the &#8216;textpattern&#8217; plugin that supports some of the markdown syntax while typing, <a href=\"http://www.tinymce.com/wiki.php/Configuration:textpattern_patterns\" rel=\"nofollow\">(more info)</a>.</li>\n<li>Add the updated &#8216;table&#8217; plugin that supports background and border color.</li>\n</ul>\n<h4>4.0.2</h4>\n<ul>\n<li>Fix showing of the second, third and forth button rows when the Toolbar Toggle button is not used.</li>\n<li>Fix adding the &#8221;directionality&#8221; plugin when RTL or LTR button is selected.</li>\n<li>Show the &#8221;Advanced Options&#8221; to super admins on multisite installs.</li>\n<li>Add the &#8221;link&#8221; plugin including link rel setting. Replaces the Insert/Edit Link dialog when enabled.</li>\n<li>Include updated &#8221;table&#8221; plugin that has support for vertical align for cells.</li>\n</ul>\n<h4>4.0.1</h4>\n<p>Fix warnings on pages other than Edit Post. Update the description.</p>\n<h4>4.0</h4>\n<p>Updated for WordPress 3.9 and TinyMCE 4.0. Refreshed the settings screen. Added support for exporting and importing of the settings.</p>\n<h4>3.5.9.1</h4>\n<p>Updated for WordPress 3.8, fixed auto-embedding of single line URLs when not removing paragraph tags.</p>\n<h4>3.5.9</h4>\n<p>Updated for WordPress 3.7 and TinyMCE 3.5.9.</p>\n<h4>3.5.8</h4>\n<p>Updated for WordPress 3.5 and TinyMCE 3.5.8.</p>\n<h4>3.4.9</h4>\n<p>Updated for WordPress 3.4 and TinyMCE 3.4.9.</p>\n<h4>3.4.5.1</h4>\n<p>Fixed a bug preventing TinyMCE from importing CSS classes from editor-style.css.</p>\n<h4>3.4.5</h4>\n<p>Updated for WordPress 3.3 or later and TinyMCE 3.4.5.</p>\n<h4>3.4.2.1</h4>\n<p>Fix the removal of the <em>media</em> plugin so it does not require re-saving the settings.</p>\n<h4>3.4.2</h4>\n<p>Compatibility with WordPress 3.2 and TinyMCE 3.4.2, removed the options for support for iframe and HTML 5.0 elements as they are supported by default in WordPress 3.2, removed the <em>media</em> plugin as it is included by default.</p>\n<h4>3.3.9.1</h4>\n<p>Added advanced options: stop removing iframes, stop removing HTML 5.0 elements, moved the support for custom editor styles to editor-style.css in the current theme.</p>\n<p>Attention: if you have a customized tadv-mce.css file and your theme doesn&#8217;t have editor-style.css, please download tadv-mce.css, rename it to editor-style.css and upload it to your current theme directory. Alternatively you can add there the editor-style.css from the Twenty Ten theme. If your theme has editor-style.css you can add any custom styles there.</p>\n<h4>3.3.9</h4>\n<p>Compatibility with WordPress 3.1 and TinyMCE 3.3.9, improved P and BR tags option.</p>\n<h4>3.2.7</h4>\n<p>Compatibility with WordPress 2.9 and TinyMCE 3.2.7, several minor bug fixes.</p>\n<h4>3.2.4</h4>\n<p>Compatibility with WordPress 2.8 and TinyMCE 3.2.4, minor bug fixes.</p>\n<h4>3.2</h4>\n<p>Compatibility with WordPress 2.7 and TinyMCE 3.2, minor bug fixes.</p>\n<h4>3.1</h4>\n<p>Compatibility with WordPress 2.6 and TinyMCE 3.1, keeps empty paragraphs when disabling the removal of P and BR tags, the buttons for MCImageManager and MCFileManager can be arranged (if installed).</p>\n<h4>3.0.1</h4>\n<p>Compatibility with WordPress 2.5.1 and TinyMCE 3.0.7, added option to disable the removal of P and BR tags when saving and in the HTML editor (autop), added two more buttons to the HTML editor: autop and undo, fixed the removal of non-default TinyMCE buttons.</p>\n<h4>3.0</h4>\n<p>Support for WordPress 2.5 and TinyMCE 3.0.</p>\n<h4>2.2</h4>\n<p>Deactivate/Uninstall option page, font size drop-down menu and other small changes.</p>\n<h4>2.1</h4>\n<p>Improved language selection, improved compatibility with WordPress 2.3 and TinyMCE 2.1.1.1, option to override some of the imported css classes and other small improvements and bugfixes.</p>\n<h4>2.0</h4>\n<p>Includes an admin page for arranging the TinyMCE toolbar buttons, easy installation, a lot of bugfixes, customized &#8220;Smilies&#8221; plugin that uses the built-in WordPress smilies, etc. The admin page uses jQuery and jQuery UI that lets you &#8220;drag and drop&#8221; the TinyMCE buttons to arrange your own toolbars and enables/disables the corresponding plugins depending on the used buttons.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/tinymce-advanced/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:50:\"https://wordpress.org/plugins/browse/popular/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 09 Jun 2017 22:22:53 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Fri, 09 Jun 2017 21:57:44 GMT\";s:4:\"link\";s:66:\"<https://wordpress.org/plugins/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("1161", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1497090179", "no");
INSERT INTO `act_options` VALUES("1162", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1497046979", "no");
INSERT INTO `act_options` VALUES("1163", "_transient_timeout_dash_88ae138922fe95674369b1cb3d215a2b", "1497090180", "no");
INSERT INTO `act_options` VALUES("1164", "_transient_dash_88ae138922fe95674369b1cb3d215a2b", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2017/06/evans/\'>WordPress 4.8 “Evans”</a> <span class=\"rss-date\">June 8, 2017</span><div class=\"rssSummary\">An Update with You in Mind Gear up for a more intuitive WordPress! Version 4.8 of WordPress, named “Evans” in honor of jazz pianist and composer William John “Bill” Evans, is available for download or update in your WordPress dashboard. New features in 4.8 add more ways for you to express yourself and represent your brand. Though some [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wptavern.com/unsplash-updates-its-license-raises-gpl-compatibility-concerns\'>WPTavern: Unsplash Updates its License, Raises GPL Compatibility Concerns</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/major-update-coming-to-wp-super-cache-new-rest-api-user-friendly-settings-page-and-improvements-to-legacy-file-storage\'>WPTavern: Major Update Coming to WP Super Cache: New REST API, User-Friendly Settings Page, and Improvements to Legacy File Storage</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/harare-zimbabwe-to-host-its-2nd-wordcamp-november-4-2017\'>WPTavern: Harare, Zimbabwe to Host Its 2nd WordCamp November 4, 2017</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\"dashboard-news-plugin\"><span>Popular Plugin:</span> Jetpack by WordPress.com&nbsp;<a href=\"plugin-install.php?tab=plugin-information&amp;plugin=jetpack&amp;_wpnonce=b9c511e9a5&amp;TB_iframe=true&amp;width=600&amp;height=800\" class=\"thickbox open-plugin-details-modal\" aria-label=\"Install Jetpack by WordPress.com\">(Install)</a></li></ul></div>", "no");
INSERT INTO `act_options` VALUES("1173", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1174", "widget_media_image", "a:2:{i:2;a:16:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:17:\"link_target_blank\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1175", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1177", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.8.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.8.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-4.8-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-4.8-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"4.8\";s:7:\"version\";s:3:\"4.8\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"4.7\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1497526653;s:15:\"version_checked\";s:3:\"4.8\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `act_options` VALUES("1208", "siteorigin_widgets_active", "a:26:{s:9:\"ink-alert\";b:1;s:13:\"ink-accordion\";b:1;s:9:\"ink-audio\";b:1;s:13:\"ink-bar-count\";b:1;s:8:\"ink-blog\";b:1;s:11:\"ink-buttons\";b:1;s:16:\"ink-circle-count\";b:1;s:11:\"ink-divider\";b:1;s:13:\"ink-filt-ardn\";b:1;s:13:\"ink-media-box\";b:1;s:13:\"ink-num-count\";b:1;s:17:\"ink-pricing-table\";b:1;s:10:\"ink-person\";b:1;s:9:\"ink-folio\";b:1;s:10:\"ink-slider\";b:1;s:8:\"ink-tabs\";b:1;s:15:\"ink-testimonial\";b:1;s:9:\"ink-video\";b:1;s:6:\"editor\";b:1;s:5:\"image\";b:1;s:13:\"post-carousel\";b:1;s:13:\"layout-slider\";b:1;s:15:\"ink-mbox-widget\";b:1;s:8:\"headline\";b:1;s:10:\"google-map\";b:1;s:6:\"slider\";b:1;}", "yes");
INSERT INTO `act_options` VALUES("1209", "widget_sow-editor", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1210", "_transient_timeout_sow:cleared", "1497655189", "no");
INSERT INTO `act_options` VALUES("1211", "_transient_sow:cleared", "1", "no");
INSERT INTO `act_options` VALUES("1219", "category_children", "a:0:{}", "yes");
INSERT INTO `act_options` VALUES("1230", "wpseo_sitemap_cache_validator_global", "7damZ", "no");
INSERT INTO `act_options` VALUES("1257", "widget_sow-image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1294", "theme_mods_one-page-express-child", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1497136832;s:4:\"data\";a:5:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:1:{i:0;s:8:\"search-2\";}s:34:\"one_page_express_first_box_widgets\";a:1:{i:0;s:13:\"media_image-2\";}s:35:\"one_page_express_second_box_widgets\";a:1:{i:0;s:6:\"text-2\";}s:34:\"one_page_express_third_box_widgets\";a:1:{i:0;s:6:\"text-3\";}}}}", "yes");
INSERT INTO `act_options` VALUES("1297", "_site_transient_timeout_wporg_theme_feature_list", "1497148229", "no");
INSERT INTO `act_options` VALUES("1298", "_site_transient_wporg_theme_feature_list", "a:3:{s:6:\"Layout\";a:7:{i:0;s:11:\"grid-layout\";i:1;s:10:\"one-column\";i:2;s:11:\"two-columns\";i:3;s:13:\"three-columns\";i:4;s:12:\"four-columns\";i:5;s:12:\"left-sidebar\";i:6;s:13:\"right-sidebar\";}s:8:\"Features\";a:20:{i:0;s:19:\"accessibility-ready\";i:1;s:10:\"buddypress\";i:2;s:17:\"custom-background\";i:3;s:13:\"custom-colors\";i:4;s:13:\"custom-header\";i:5;s:11:\"custom-menu\";i:6;s:12:\"editor-style\";i:7;s:21:\"featured-image-header\";i:8;s:15:\"featured-images\";i:9;s:15:\"flexible-header\";i:10;s:14:\"footer-widgets\";i:11;s:20:\"front-page-post-form\";i:12;s:19:\"full-width-template\";i:13;s:12:\"microformats\";i:14;s:12:\"post-formats\";i:15;s:20:\"rtl-language-support\";i:16;s:11:\"sticky-post\";i:17;s:13:\"theme-options\";i:18;s:17:\"threaded-comments\";i:19;s:17:\"translation-ready\";}s:7:\"Subject\";a:9:{i:0;s:4:\"blog\";i:1;s:10:\"e-commerce\";i:2;s:9:\"education\";i:3;s:13:\"entertainment\";i:4;s:14:\"food-and-drink\";i:5;s:7:\"holiday\";i:6;s:4:\"news\";i:7;s:11:\"photography\";i:8;s:9:\"portfolio\";}}", "no");
INSERT INTO `act_options` VALUES("1300", "theme_mods_oceanwp", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:7:\"primary\";i:2;s:6:\"footer\";i:3;s:6:\"social\";i:0;}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1497137662;s:4:\"data\";a:7:{s:19:\"wp_inactive_widgets\";a:3:{i:0;s:13:\"media_image-2\";i:1;s:6:\"text-2\";i:2;s:6:\"text-3\";}s:7:\"sidebar\";a:1:{i:0;s:8:\"search-2\";}s:14:\"search_sidebar\";N;s:10:\"footer-one\";N;s:10:\"footer-two\";N;s:12:\"footer-three\";N;s:11:\"footer-four\";N;}}}", "yes");
INSERT INTO `act_options` VALUES("1361", "wpseo_sitemap_111_cache_validator", "2WTAC", "no");
INSERT INTO `act_options` VALUES("1362", "wpseo_sitemap_113_cache_validator", "2WTBQ", "no");
INSERT INTO `act_options` VALUES("1363", "wpseo_sitemap_115_cache_validator", "2WTCN", "no");
INSERT INTO `act_options` VALUES("1364", "wpseo_sitemap_237_cache_validator", "cTEI", "no");
INSERT INTO `act_options` VALUES("1365", "wpseo_sitemap_238_cache_validator", "2WXqm", "no");
INSERT INTO `act_options` VALUES("1366", "wpseo_sitemap_112_cache_validator", "2X8hQ", "no");
INSERT INTO `act_options` VALUES("1367", "wpseo_sitemap_114_cache_validator", "2X8j5", "no");
INSERT INTO `act_options` VALUES("1368", "wpseo_sitemap_116_cache_validator", "2X8k3", "no");
INSERT INTO `act_options` VALUES("1421", "bookly_data_loaded", "1", "yes");
INSERT INTO `act_options` VALUES("1422", "bookly_db_version", "13.0", "yes");
INSERT INTO `act_options` VALUES("1423", "bookly_installation_time", "1497332965", "yes");
INSERT INTO `act_options` VALUES("1424", "bookly_grace_start", "1498542565", "yes");
INSERT INTO `act_options` VALUES("1425", "bookly_envato_purchase_code", "", "yes");
INSERT INTO `act_options` VALUES("1426", "bookly_enabled", "1", "yes");
INSERT INTO `act_options` VALUES("1427", "bookly_app_color", "#f4662f", "yes");
INSERT INTO `act_options` VALUES("1428", "bookly_app_required_employee", "0", "yes");
INSERT INTO `act_options` VALUES("1429", "bookly_app_show_blocked_timeslots", "0", "yes");
INSERT INTO `act_options` VALUES("1430", "bookly_app_show_calendar", "0", "yes");
INSERT INTO `act_options` VALUES("1431", "bookly_app_show_day_one_column", "0", "yes");
INSERT INTO `act_options` VALUES("1432", "bookly_app_show_progress_tracker", "1", "yes");
INSERT INTO `act_options` VALUES("1433", "bookly_app_staff_name_with_price", "1", "yes");
INSERT INTO `act_options` VALUES("1434", "bookly_api_server_error_time", "0", "yes");
INSERT INTO `act_options` VALUES("1435", "bookly_l10n_button_apply", "Apply", "yes");
INSERT INTO `act_options` VALUES("1436", "bookly_l10n_button_back", "Back", "yes");
INSERT INTO `act_options` VALUES("1437", "bookly_l10n_button_book_more", "Book More", "yes");
INSERT INTO `act_options` VALUES("1438", "bookly_l10n_button_next", "Next", "yes");
INSERT INTO `act_options` VALUES("1439", "bookly_l10n_info_cart_step", "Below you can find a list of services selected for booking.\nClick BOOK MORE if you want to add more services.", "yes");
INSERT INTO `act_options` VALUES("1440", "bookly_l10n_info_complete_step", "Thank you! Your booking is complete. An email with details of your booking has been sent to you.", "yes");
INSERT INTO `act_options` VALUES("1441", "bookly_l10n_info_coupon", "The total price for the booking is {total_price}.", "yes");
INSERT INTO `act_options` VALUES("1442", "bookly_l10n_info_details_step", "You selected a booking for {service_name} by {staff_name} at {service_time} on {service_date}. The price for the service is {service_price}.\nPlease provide your details in the form below to proceed with booking.", "yes");
INSERT INTO `act_options` VALUES("1443", "bookly_l10n_info_details_step_guest", "", "yes");
INSERT INTO `act_options` VALUES("1444", "bookly_l10n_info_payment_step", "Please tell us how you would like to pay: ", "yes");
INSERT INTO `act_options` VALUES("1445", "bookly_l10n_info_service_step", "Please select service: ", "yes");
INSERT INTO `act_options` VALUES("1446", "bookly_l10n_info_time_step", "Below you can find a list of available time slots for {service_name} by {staff_name}.\nClick on a time slot to proceed with booking.", "yes");
INSERT INTO `act_options` VALUES("1447", "bookly_l10n_label_category", "Category", "yes");
INSERT INTO `act_options` VALUES("1448", "bookly_l10n_label_ccard_code", "Card Security Code", "yes");
INSERT INTO `act_options` VALUES("1449", "bookly_l10n_label_ccard_expire", "Expiration Date", "yes");
INSERT INTO `act_options` VALUES("1450", "bookly_l10n_label_ccard_number", "Credit Card Number", "yes");
INSERT INTO `act_options` VALUES("1451", "bookly_l10n_label_coupon", "Coupon", "yes");
INSERT INTO `act_options` VALUES("1452", "bookly_l10n_label_email", "Email", "yes");
INSERT INTO `act_options` VALUES("1453", "bookly_l10n_label_employee", "Employee", "yes");
INSERT INTO `act_options` VALUES("1454", "bookly_l10n_label_finish_by", "Finish by", "yes");
INSERT INTO `act_options` VALUES("1455", "bookly_l10n_label_name", "Name", "yes");
INSERT INTO `act_options` VALUES("1456", "bookly_l10n_label_number_of_persons", "Number of persons", "yes");
INSERT INTO `act_options` VALUES("1457", "bookly_l10n_label_pay_ccard", "I will pay now with Credit Card", "yes");
INSERT INTO `act_options` VALUES("1458", "bookly_l10n_label_pay_locally", "I will pay locally", "yes");
INSERT INTO `act_options` VALUES("1459", "bookly_l10n_label_pay_mollie", "I will pay now with Mollie", "yes");
INSERT INTO `act_options` VALUES("1460", "bookly_l10n_label_pay_paypal", "I will pay now with PayPal", "yes");
INSERT INTO `act_options` VALUES("1461", "bookly_l10n_label_phone", "Phone", "yes");
INSERT INTO `act_options` VALUES("1462", "bookly_l10n_label_select_date", "I\'m available on or after", "yes");
INSERT INTO `act_options` VALUES("1463", "bookly_l10n_label_service", "Service", "yes");
INSERT INTO `act_options` VALUES("1464", "bookly_l10n_label_start_from", "Start from", "yes");
INSERT INTO `act_options` VALUES("1465", "bookly_l10n_option_category", "Select category", "yes");
INSERT INTO `act_options` VALUES("1466", "bookly_l10n_option_employee", "Any", "yes");
INSERT INTO `act_options` VALUES("1467", "bookly_l10n_option_service", "Select service", "yes");
INSERT INTO `act_options` VALUES("1468", "bookly_l10n_required_email", "Please tell us your email", "yes");
INSERT INTO `act_options` VALUES("1469", "bookly_l10n_required_employee", "Please select an employee", "yes");
INSERT INTO `act_options` VALUES("1470", "bookly_l10n_required_name", "Please tell us your name", "yes");
INSERT INTO `act_options` VALUES("1471", "bookly_l10n_required_phone", "Please tell us your phone", "yes");
INSERT INTO `act_options` VALUES("1472", "bookly_l10n_required_service", "Please select a service", "yes");
INSERT INTO `act_options` VALUES("1473", "bookly_l10n_step_cart", "Cart", "yes");
INSERT INTO `act_options` VALUES("1474", "bookly_l10n_step_details", "Details", "yes");
INSERT INTO `act_options` VALUES("1475", "bookly_l10n_step_done", "Done", "yes");
INSERT INTO `act_options` VALUES("1476", "bookly_l10n_step_payment", "Payment", "yes");
INSERT INTO `act_options` VALUES("1477", "bookly_l10n_step_service", "Service", "yes");
INSERT INTO `act_options` VALUES("1478", "bookly_l10n_step_time", "Time", "yes");
INSERT INTO `act_options` VALUES("1479", "bookly_cart_enabled", "0", "yes");
INSERT INTO `act_options` VALUES("1480", "bookly_cart_show_columns", "a:6:{s:7:\"service\";a:1:{s:4:\"show\";i:1;}s:4:\"date\";a:1:{s:4:\"show\";i:1;}s:4:\"time\";a:1:{s:4:\"show\";i:1;}s:8:\"employee\";a:1:{s:4:\"show\";i:1;}s:5:\"price\";a:1:{s:4:\"show\";i:1;}s:7:\"deposit\";a:1:{s:4:\"show\";i:1;}}", "yes");
INSERT INTO `act_options` VALUES("1481", "bookly_co_logo_attachment_id", "", "yes");
INSERT INTO `act_options` VALUES("1482", "bookly_co_name", "", "yes");
INSERT INTO `act_options` VALUES("1483", "bookly_co_address", "", "yes");
INSERT INTO `act_options` VALUES("1484", "bookly_co_phone", "", "yes");
INSERT INTO `act_options` VALUES("1485", "bookly_co_website", "", "yes");
INSERT INTO `act_options` VALUES("1486", "bookly_cst_create_account", "0", "yes");
INSERT INTO `act_options` VALUES("1487", "bookly_cst_new_account_role", "subscriber", "yes");
INSERT INTO `act_options` VALUES("1488", "bookly_cst_phone_default_country", "auto", "yes");
INSERT INTO `act_options` VALUES("1489", "bookly_cst_default_country_code", "", "yes");
INSERT INTO `act_options` VALUES("1490", "bookly_cst_cancel_action", "cancel", "yes");
INSERT INTO `act_options` VALUES("1491", "bookly_cst_combined_notifications", "0", "yes");
INSERT INTO `act_options` VALUES("1492", "bookly_custom_fields", "[{\"type\":\"textarea\",\"label\":\"Notes\",\"required\":false,\"id\":1,\"services\":[]}]", "yes");
INSERT INTO `act_options` VALUES("1493", "bookly_custom_fields_per_service", "0", "yes");
INSERT INTO `act_options` VALUES("1494", "bookly_email_sender", "absolutecomfortkenya@gmail.com", "yes");
INSERT INTO `act_options` VALUES("1495", "bookly_email_sender_name", "Absolute Comfort Travel", "yes");
INSERT INTO `act_options` VALUES("1496", "bookly_email_send_as", "html", "yes");
INSERT INTO `act_options` VALUES("1497", "bookly_email_reply_to_customers", "1", "yes");
INSERT INTO `act_options` VALUES("1498", "bookly_gc_client_id", "", "yes");
INSERT INTO `act_options` VALUES("1499", "bookly_gc_client_secret", "", "yes");
INSERT INTO `act_options` VALUES("1500", "bookly_gc_event_title", "{service_name}", "yes");
INSERT INTO `act_options` VALUES("1501", "bookly_gc_limit_events", "50", "yes");
INSERT INTO `act_options` VALUES("1502", "bookly_gc_two_way_sync", "1", "yes");
INSERT INTO `act_options` VALUES("1503", "bookly_lite_uninstall_remove_bookly_data", "0", "yes");
INSERT INTO `act_options` VALUES("1504", "bookly_gen_time_slot_length", "15", "yes");
INSERT INTO `act_options` VALUES("1505", "bookly_gen_service_duration_as_slot_length", "0", "yes");
INSERT INTO `act_options` VALUES("1506", "bookly_gen_default_appointment_status", "approved", "yes");
INSERT INTO `act_options` VALUES("1507", "bookly_gen_min_time_prior_booking", "0", "yes");
INSERT INTO `act_options` VALUES("1508", "bookly_gen_min_time_prior_cancel", "0", "yes");
INSERT INTO `act_options` VALUES("1509", "bookly_gen_approve_page_url", "http://localhost/actfinal", "yes");
INSERT INTO `act_options` VALUES("1510", "bookly_gen_cancel_page_url", "http://localhost/actfinal", "yes");
INSERT INTO `act_options` VALUES("1511", "bookly_gen_cancel_denied_page_url", "http://localhost/actfinal", "yes");
INSERT INTO `act_options` VALUES("1512", "bookly_gen_max_days_for_booking", "365", "yes");
INSERT INTO `act_options` VALUES("1513", "bookly_gen_use_client_time_zone", "0", "yes");
INSERT INTO `act_options` VALUES("1514", "bookly_gen_final_step_url", "", "yes");
INSERT INTO `act_options` VALUES("1515", "bookly_gen_allow_staff_edit_profile", "1", "yes");
INSERT INTO `act_options` VALUES("1516", "bookly_gen_link_assets_method", "enqueue", "yes");
INSERT INTO `act_options` VALUES("1517", "bookly_cron_reminder_times", "a:3:{s:16:\"client_follow_up\";i:21;s:15:\"client_reminder\";i:18;s:12:\"staff_agenda\";i:18;}", "yes");
INSERT INTO `act_options` VALUES("1518", "bookly_grace_notifications", "a:3:{s:6:\"bookly\";s:1:\"0\";s:7:\"add-ons\";i:0;s:4:\"sent\";s:1:\"0\";}", "yes");
INSERT INTO `act_options` VALUES("1519", "bookly_grace_hide_admin_notice_time", "0", "yes");
INSERT INTO `act_options` VALUES("1520", "bookly_sms_token", "", "yes");
INSERT INTO `act_options` VALUES("1521", "bookly_sms_administrator_phone", "", "yes");
INSERT INTO `act_options` VALUES("1522", "bookly_sms_notify_low_balance", "1", "yes");
INSERT INTO `act_options` VALUES("1523", "bookly_sms_notify_weekly_summary", "1", "yes");
INSERT INTO `act_options` VALUES("1524", "bookly_sms_notify_weekly_summary_sent", "24", "yes");
INSERT INTO `act_options` VALUES("1525", "bookly_wc_enabled", "0", "yes");
INSERT INTO `act_options` VALUES("1526", "bookly_wc_product", "", "yes");
INSERT INTO `act_options` VALUES("1527", "bookly_l10n_wc_cart_info_name", "Appointment", "yes");
INSERT INTO `act_options` VALUES("1528", "bookly_l10n_wc_cart_info_value", "Date: {appointment_date}\nTime: {appointment_time}\nService: {service_name}", "yes");
INSERT INTO `act_options` VALUES("1529", "bookly_bh_monday_start", "08:00", "yes");
INSERT INTO `act_options` VALUES("1530", "bookly_bh_monday_end", "18:00", "yes");
INSERT INTO `act_options` VALUES("1531", "bookly_bh_tuesday_start", "08:00", "yes");
INSERT INTO `act_options` VALUES("1532", "bookly_bh_tuesday_end", "18:00", "yes");
INSERT INTO `act_options` VALUES("1533", "bookly_bh_wednesday_start", "08:00", "yes");
INSERT INTO `act_options` VALUES("1534", "bookly_bh_wednesday_end", "18:00", "yes");
INSERT INTO `act_options` VALUES("1535", "bookly_bh_thursday_end", "18:00", "yes");
INSERT INTO `act_options` VALUES("1536", "bookly_bh_thursday_start", "08:00", "yes");
INSERT INTO `act_options` VALUES("1537", "bookly_bh_friday_start", "08:00", "yes");
INSERT INTO `act_options` VALUES("1538", "bookly_bh_friday_end", "18:00", "yes");
INSERT INTO `act_options` VALUES("1539", "bookly_bh_saturday_start", "", "yes");
INSERT INTO `act_options` VALUES("1540", "bookly_bh_saturday_end", "", "yes");
INSERT INTO `act_options` VALUES("1541", "bookly_bh_sunday_start", "", "yes");
INSERT INTO `act_options` VALUES("1542", "bookly_bh_sunday_end", "", "yes");
INSERT INTO `act_options` VALUES("1543", "bookly_pmt_currency", "USD", "yes");
INSERT INTO `act_options` VALUES("1544", "bookly_pmt_coupons", "0", "yes");
INSERT INTO `act_options` VALUES("1545", "bookly_pmt_local", "1", "yes");
INSERT INTO `act_options` VALUES("1546", "bookly_pmt_paypal", "disabled", "yes");
INSERT INTO `act_options` VALUES("1547", "bookly_pmt_paypal_sandbox", "0", "yes");
INSERT INTO `act_options` VALUES("1548", "bookly_pmt_paypal_api_password", "", "yes");
INSERT INTO `act_options` VALUES("1549", "bookly_pmt_paypal_api_signature", "", "yes");
INSERT INTO `act_options` VALUES("1550", "bookly_pmt_paypal_api_username", "", "yes");
INSERT INTO `act_options` VALUES("1551", "bookly_pmt_paypal_id", "", "yes");
INSERT INTO `act_options` VALUES("1552", "bookly_pmt_authorize_net", "disabled", "yes");
INSERT INTO `act_options` VALUES("1553", "bookly_pmt_authorize_net_api_login_id", "", "yes");
INSERT INTO `act_options` VALUES("1554", "bookly_pmt_authorize_net_transaction_key", "", "yes");
INSERT INTO `act_options` VALUES("1555", "bookly_pmt_authorize_net_sandbox", "0", "yes");
INSERT INTO `act_options` VALUES("1556", "bookly_pmt_stripe", "disabled", "yes");
INSERT INTO `act_options` VALUES("1557", "bookly_pmt_stripe_publishable_key", "", "yes");
INSERT INTO `act_options` VALUES("1558", "bookly_pmt_stripe_secret_key", "", "yes");
INSERT INTO `act_options` VALUES("1559", "bookly_pmt_2checkout", "disabled", "yes");
INSERT INTO `act_options` VALUES("1560", "bookly_pmt_2checkout_api_secret_word", "", "yes");
INSERT INTO `act_options` VALUES("1561", "bookly_pmt_2checkout_api_seller_id", "", "yes");
INSERT INTO `act_options` VALUES("1562", "bookly_pmt_2checkout_sandbox", "0", "yes");
INSERT INTO `act_options` VALUES("1563", "bookly_pmt_payu_latam", "disabled", "yes");
INSERT INTO `act_options` VALUES("1564", "bookly_pmt_payu_latam_api_account_id", "", "yes");
INSERT INTO `act_options` VALUES("1565", "bookly_pmt_payu_latam_api_key", "", "yes");
INSERT INTO `act_options` VALUES("1566", "bookly_pmt_payu_latam_api_merchant_id", "", "yes");
INSERT INTO `act_options` VALUES("1567", "bookly_pmt_payu_latam_sandbox", "0", "yes");
INSERT INTO `act_options` VALUES("1568", "bookly_pmt_payson", "disabled", "yes");
INSERT INTO `act_options` VALUES("1569", "bookly_pmt_payson_api_agent_id", "", "yes");
INSERT INTO `act_options` VALUES("1570", "bookly_pmt_payson_api_key", "", "yes");
INSERT INTO `act_options` VALUES("1571", "bookly_pmt_payson_api_receiver_email", "", "yes");
INSERT INTO `act_options` VALUES("1572", "bookly_pmt_payson_fees_payer", "PRIMARYRECEIVER", "yes");
INSERT INTO `act_options` VALUES("1573", "bookly_pmt_payson_funding", "a:1:{i:0;s:10:\"CREDITCARD\";}", "yes");
INSERT INTO `act_options` VALUES("1574", "bookly_pmt_payson_sandbox", "0", "yes");
INSERT INTO `act_options` VALUES("1575", "bookly_pmt_mollie", "disabled", "yes");
INSERT INTO `act_options` VALUES("1576", "bookly_pmt_mollie_api_key", "", "yes");
INSERT INTO `act_options` VALUES("1587", "mrs1_authentication_code", "b7dc33b646214b70b6134cd87c54e7e2", "yes");
INSERT INTO `act_options` VALUES("1612", "itsec_active_modules", "a:6:{s:9:\"ban-users\";b:1;s:11:\"brute-force\";b:1;s:6:\"backup\";b:1;s:19:\"network-brute-force\";b:1;s:16:\"strong-passwords\";b:1;s:16:\"wordpress-tweaks\";b:1;}", "yes");
INSERT INTO `act_options` VALUES("1615", "_site_transient_timeout_browser_973b0af64fa9ae42ab017fa2edcf5878", "1497949304", "no");
INSERT INTO `act_options` VALUES("1616", "_site_transient_browser_973b0af64fa9ae42ab017fa2edcf5878", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"58.0.3029.110\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "no");
INSERT INTO `act_options` VALUES("1669", "widget_sow-post-carousel", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1670", "widget_sow-layout-slider", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1671", "widget_ink-media-box", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1672", "widget_sow-headline", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1695", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1497526658;s:7:\"checked\";a:2:{s:12:\"sydney-child\";s:3:\"1.0\";s:6:\"sydney\";s:4:\"1.39\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `act_options` VALUES("1729", "widget_sow-google-map", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1776", "widget_sow-slider", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1802", "swpm-messages", "a:0:{}", "yes");
INSERT INTO `act_options` VALUES("1811", "wpseo_sitemap_240_cache_validator", "4VdXV", "no");
INSERT INTO `act_options` VALUES("1851", "wpseo_sitemap_432_cache_validator", "6aoOx", "no");
INSERT INTO `act_options` VALUES("1853", "wpseo_sitemap_440_cache_validator", "6bvsX", "no");
INSERT INTO `act_options` VALUES("1875", "_site_transient_timeout_itsec_wp_upload_dir", "1497562438", "no");
INSERT INTO `act_options` VALUES("1876", "_site_transient_itsec_wp_upload_dir", "a:6:{s:4:\"path\";s:47:\"C:\\wamp\\www\\actfinal/wp-content/uploads/2017/06\";s:3:\"url\";s:52:\"http://localhost/actfinal/wp-content/uploads/2017/06\";s:6:\"subdir\";s:8:\"/2017/06\";s:7:\"basedir\";s:39:\"C:\\wamp\\www\\actfinal/wp-content/uploads\";s:7:\"baseurl\";s:44:\"http://localhost/actfinal/wp-content/uploads\";s:5:\"error\";b:0;}", "no");
INSERT INTO `act_options` VALUES("1920", "ws_plugin__s2member_activated_levels", "4", "yes");
INSERT INTO `act_options` VALUES("1921", "ws_plugin__s2member_cache", "a:3:{s:18:\"login_welcome_page\";a:3:{s:4:\"page\";s:0:\"\";s:4:\"time\";i:1497518291;s:4:\"link\";s:26:\"http://localhost/actfinal/\";}s:23:\"membership_options_page\";a:3:{s:4:\"page\";s:0:\"\";s:4:\"time\";i:1497518291;s:4:\"link\";s:26:\"http://localhost/actfinal/\";}s:33:\"file_download_limit_exceeded_page\";a:3:{s:4:\"page\";s:0:\"\";s:4:\"time\";i:1497518291;s:4:\"link\";s:26:\"http://localhost/actfinal/\";}}", "yes");
INSERT INTO `act_options` VALUES("1922", "ws_plugin__s2member_notices", "a:1:{i:0;a:5:{s:6:\"notice\";s:592:\"<strong>Note:</strong> s2Member adds some new data columns to your list of Users/Members. If your list gets overcrowded, please use the <strong>Screen Options</strong> tab <em>(upper right-hand corner)</em>. With WordPress Screen Options, you can add/remove specific data columns; thereby making the most important data easier to read. For example, if you create Custom Registration/Profile Fields with s2Member, those Custom Fields will result in new data columns; which can cause your list of Users/Members to become nearly unreadable. So just use the Screen Options tab to clean things up.\";s:8:\"on_pages\";s:14:\"blog:users.php\";s:5:\"error\";b:0;s:4:\"time\";b:0;s:7:\"dismiss\";b:1;}}", "yes");
INSERT INTO `act_options` VALUES("1923", "ws_plugin__s2member_options", "a:211:{s:16:\"options_checksum\";s:32:\"c2e27a62b50b993fe240746a4d97f688\";s:15:\"options_version\";s:5:\"1.002\";s:18:\"gateway_debug_logs\";s:1:\"0\";s:28:\"gateway_debug_logs_extensive\";s:1:\"0\";s:16:\"lazy_load_css_js\";s:1:\"0\";s:28:\"sc_conds_allow_arbitrary_php\";s:1:\"0\";s:18:\"sec_encryption_key\";s:0:\"\";s:26:\"sec_encryption_key_history\";a:0:{}s:24:\"def_combo_encryption_key\";s:0:\"\";s:32:\"def_combo_encryption_key_history\";a:0:{}s:32:\"def_custom_combo_encryption_keys\";a:0:{}s:22:\"s_badge_status_enabled\";s:1:\"0\";s:18:\"max_ip_restriction\";s:1:\"5\";s:23:\"max_ip_restriction_time\";s:4:\"3600\";s:25:\"max_failed_login_attempts\";s:1:\"5\";s:23:\"max_simultaneous_logins\";s:1:\"0\";s:31:\"max_simultaneous_logins_timeout\";s:10:\"30 minutes\";s:22:\"run_uninstall_routines\";s:1:\"0\";s:17:\"custom_reg_fields\";s:0:\"\";s:16:\"custom_reg_names\";s:1:\"1\";s:23:\"custom_reg_display_name\";s:4:\"full\";s:19:\"custom_reg_password\";s:1:\"0\";s:30:\"custom_reg_password_min_length\";s:1:\"8\";s:32:\"custom_reg_password_min_strength\";s:4:\"good\";s:17:\"custom_reg_opt_in\";s:1:\"1\";s:23:\"custom_reg_opt_in_label\";s:41:\"Yes, I want to receive updates via email.\";s:24:\"custom_reg_auto_opt_outs\";a:0:{}s:35:\"custom_reg_auto_opt_out_transitions\";s:1:\"0\";s:21:\"custom_reg_fields_4bp\";a:0:{}s:32:\"custom_reg_force_personal_emails\";s:0:\"\";s:20:\"allow_subscribers_in\";s:1:\"1\";s:20:\"force_admin_lockouts\";s:1:\"0\";s:15:\"filter_wp_query\";a:1:{i:0;s:3:\"all\";}s:21:\"default_url_shortener\";s:8:\"tiny_url\";s:25:\"default_url_shortener_key\";s:0:\"\";s:32:\"default_custom_str_url_shortener\";s:0:\"\";s:14:\"mms_auto_patch\";s:1:\"1\";s:21:\"mms_registration_file\";s:8:\"wp-login\";s:23:\"mms_registration_grants\";s:4:\"none\";s:29:\"mms_registration_blogs_level0\";s:1:\"0\";s:29:\"mms_registration_blogs_level1\";s:1:\"5\";s:29:\"mms_registration_blogs_level2\";s:2:\"10\";s:29:\"mms_registration_blogs_level3\";s:2:\"15\";s:29:\"mms_registration_blogs_level4\";s:2:\"20\";s:18:\"login_welcome_page\";s:0:\"\";s:26:\"login_redirection_override\";s:0:\"\";s:23:\"membership_options_page\";s:0:\"\";s:35:\"membership_options_page_vars_enable\";s:1:\"1\";s:38:\"membership_options_page_ga_vars_enable\";s:1:\"1\";s:24:\"login_reg_design_enabled\";s:1:\"1\";s:26:\"login_reg_background_color\";s:6:\"FFFFFF\";s:26:\"login_reg_background_image\";s:71:\"http://localhost/actfinal/wp-content/plugins/s2member/src/images/bg.png\";s:33:\"login_reg_background_image_repeat\";s:6:\"repeat\";s:31:\"login_reg_background_text_color\";s:6:\"000000\";s:38:\"login_reg_background_text_shadow_color\";s:6:\"EEEEEE\";s:37:\"login_reg_background_box_shadow_color\";s:6:\"EEEEEE\";s:18:\"login_reg_logo_src\";s:73:\"http://localhost/actfinal/wp-content/plugins/s2member/src/images/logo.png\";s:24:\"login_reg_logo_src_width\";s:3:\"550\";s:25:\"login_reg_logo_src_height\";s:3:\"100\";s:18:\"login_reg_logo_url\";s:26:\"http://localhost/actfinal/\";s:20:\"login_reg_logo_title\";s:23:\"Absolute Comfort Travel\";s:19:\"login_reg_font_size\";s:4:\"12px\";s:21:\"login_reg_font_family\";s:30:\"\'Verdana\', \'Arial\', sans-serif\";s:25:\"login_reg_font_field_size\";s:4:\"18px\";s:27:\"login_reg_footer_backtoblog\";s:1:\"0\";s:23:\"login_reg_footer_design\";s:0:\"\";s:19:\"reg_email_from_name\";s:23:\"Absolute Comfort Travel\";s:20:\"reg_email_from_email\";s:30:\"absolutecomfortkenya@gmail.com\";s:22:\"reg_email_support_link\";s:37:\"mailto:absolutecomfortkenya@gmail.com\";s:23:\"new_user_emails_enabled\";s:1:\"0\";s:22:\"new_user_email_subject\";s:43:\"[Absolute Comfort Travel] Username/Password\";s:22:\"new_user_email_message\";s:144:\"Your Username/Password for:\nAbsolute Comfort Travel\n\nUsername: %%user_login%%\nTo set your password, visit: %%wp_set_pass_url%%\n\n%%wp_login_url%%\";s:31:\"new_user_admin_email_recipients\";s:30:\"absolutecomfortkenya@gmail.com\";s:28:\"new_user_admin_email_subject\";s:47:\"[Absolute Comfort Travel] New User Registration\";s:28:\"new_user_admin_email_message\";s:152:\"New User Registration on your site:\nAbsolute Comfort Travel\n\nUser ID: %%user_id%%\nUsername: %%user_login%%\nEmail: %%user_email%%\nIP Address: %%user_ip%%\";s:14:\"paypal_sandbox\";s:1:\"0\";s:15:\"paypal_business\";s:0:\"\";s:18:\"paypal_merchant_id\";s:0:\"\";s:19:\"paypal_api_username\";s:0:\"\";s:19:\"paypal_api_password\";s:0:\"\";s:20:\"paypal_api_signature\";s:0:\"\";s:21:\"paypal_identity_token\";s:0:\"\";s:21:\"paypal_btn_encryption\";s:1:\"1\";s:27:\"paypal_payflow_api_username\";s:0:\"\";s:26:\"paypal_payflow_api_partner\";s:6:\"PayPal\";s:25:\"paypal_payflow_api_vendor\";s:0:\"\";s:27:\"paypal_payflow_api_password\";s:0:\"\";s:21:\"signup_tracking_codes\";s:0:\"\";s:27:\"modification_tracking_codes\";s:0:\"\";s:19:\"ccap_tracking_codes\";s:0:\"\";s:17:\"sp_tracking_codes\";s:0:\"\";s:23:\"signup_email_recipients\";s:33:\"\"%%full_name%%\" <%%payer_email%%>\";s:20:\"signup_email_subject\";s:52:\"Congratulations! (your membership has been approved)\";s:20:\"signup_email_message\";s:283:\"Thanks %%first_name%%! Your membership has been approved.\n\nIf you haven\'t already done so, the next step is to Register a Username.\n\nComplete your registration here:\n%%registration_url%%\n\nIf you have any trouble, please feel free to contact us.\n\nBest Regards,\nAbsolute Comfort Travel\";s:29:\"modification_email_recipients\";s:33:\"\"%%full_name%%\" <%%payer_email%%>\";s:26:\"modification_email_subject\";s:41:\"Thank you! Your account has been updated.\";s:26:\"modification_email_message\";s:166:\"Thanks %%first_name%%! Your account now has access to: %%item_name%%.\n\nIf you have any trouble, please feel free to contact us.\n\nBest Regards,\nAbsolute Comfort Travel\";s:21:\"ccap_email_recipients\";s:33:\"\"%%full_name%%\" <%%payer_email%%>\";s:18:\"ccap_email_subject\";s:41:\"Thank you! Your account has been updated.\";s:18:\"ccap_email_message\";s:166:\"Thanks %%first_name%%! Your account now has access to: %%item_name%%.\n\nIf you have any trouble, please feel free to contact us.\n\nBest Regards,\nAbsolute Comfort Travel\";s:19:\"sp_email_recipients\";s:33:\"\"%%full_name%%\" <%%payer_email%%>\";s:16:\"sp_email_subject\";s:36:\"Thank You! (instructions for access)\";s:16:\"sp_email_message\";s:223:\"Thanks %%first_name%%!\n\n%%item_name%%\n\nYour order can be retrieved here:\n%%sp_access_url%%\n(link expires in %%sp_access_exp%%)\n\nIf you have any trouble, please feel free to contact us.\n\nBest Regards,\nAbsolute Comfort Travel\";s:17:\"mailchimp_api_key\";s:0:\"\";s:19:\"getresponse_api_key\";s:0:\"\";s:14:\"aweber_api_key\";s:0:\"\";s:23:\"aweber_internal_api_key\";s:0:\"\";s:15:\"aweber_api_type\";s:3:\"api\";s:25:\"level0_mailchimp_list_ids\";s:0:\"\";s:25:\"level1_mailchimp_list_ids\";s:0:\"\";s:25:\"level2_mailchimp_list_ids\";s:0:\"\";s:25:\"level3_mailchimp_list_ids\";s:0:\"\";s:25:\"level4_mailchimp_list_ids\";s:0:\"\";s:27:\"level0_getresponse_list_ids\";s:0:\"\";s:27:\"level1_getresponse_list_ids\";s:0:\"\";s:27:\"level2_getresponse_list_ids\";s:0:\"\";s:27:\"level3_getresponse_list_ids\";s:0:\"\";s:27:\"level4_getresponse_list_ids\";s:0:\"\";s:22:\"level0_aweber_list_ids\";s:0:\"\";s:22:\"level1_aweber_list_ids\";s:0:\"\";s:22:\"level2_aweber_list_ids\";s:0:\"\";s:22:\"level3_aweber_list_ids\";s:0:\"\";s:22:\"level4_aweber_list_ids\";s:0:\"\";s:24:\"signup_notification_urls\";s:0:\"\";s:30:\"registration_notification_urls\";s:0:\"\";s:25:\"payment_notification_urls\";s:0:\"\";s:30:\"modification_notification_urls\";s:0:\"\";s:30:\"cancellation_notification_urls\";s:0:\"\";s:25:\"eot_del_notification_urls\";s:0:\"\";s:25:\"ref_rev_notification_urls\";s:0:\"\";s:25:\"sp_sale_notification_urls\";s:0:\"\";s:28:\"sp_ref_rev_notification_urls\";s:0:\"\";s:30:\"signup_notification_recipients\";s:0:\"\";s:36:\"registration_notification_recipients\";s:0:\"\";s:31:\"payment_notification_recipients\";s:0:\"\";s:36:\"modification_notification_recipients\";s:0:\"\";s:36:\"cancellation_notification_recipients\";s:0:\"\";s:31:\"eot_del_notification_recipients\";s:0:\"\";s:31:\"ref_rev_notification_recipients\";s:0:\"\";s:31:\"sp_sale_notification_recipients\";s:0:\"\";s:34:\"sp_ref_rev_notification_recipients\";s:0:\"\";s:12:\"level0_label\";s:15:\"Free Subscriber\";s:12:\"level1_label\";s:13:\"Bronze Member\";s:12:\"level2_label\";s:13:\"Silver Member\";s:12:\"level3_label\";s:11:\"Gold Member\";s:12:\"level4_label\";s:15:\"Platinum Member\";s:24:\"apply_label_translations\";s:1:\"0\";s:29:\"level0_file_downloads_allowed\";s:0:\"\";s:29:\"level1_file_downloads_allowed\";s:0:\"\";s:29:\"level2_file_downloads_allowed\";s:0:\"\";s:29:\"level3_file_downloads_allowed\";s:0:\"\";s:29:\"level4_file_downloads_allowed\";s:0:\"\";s:34:\"level0_file_downloads_allowed_days\";s:0:\"\";s:34:\"level1_file_downloads_allowed_days\";s:0:\"\";s:34:\"level2_file_downloads_allowed_days\";s:0:\"\";s:34:\"level3_file_downloads_allowed_days\";s:0:\"\";s:34:\"level4_file_downloads_allowed_days\";s:0:\"\";s:33:\"file_download_limit_exceeded_page\";s:0:\"\";s:31:\"file_download_inline_extensions\";s:0:\"\";s:31:\"file_download_stream_extensions\";s:0:\"\";s:35:\"file_download_content_encodong_none\";s:1:\"0\";s:22:\"amazon_s3_files_bucket\";s:0:\"\";s:29:\"amazon_s3_files_bucket_region\";s:0:\"\";s:26:\"amazon_s3_files_access_key\";s:0:\"\";s:26:\"amazon_s3_files_secret_key\";s:0:\"\";s:27:\"amazon_cf_files_private_key\";s:0:\"\";s:30:\"amazon_cf_files_private_key_id\";s:0:\"\";s:33:\"amazon_cf_files_distros_access_id\";s:0:\"\";s:36:\"amazon_cf_files_distros_s3_access_id\";s:0:\"\";s:35:\"amazon_cf_files_distro_downloads_id\";s:0:\"\";s:38:\"amazon_cf_files_distro_downloads_cname\";s:0:\"\";s:38:\"amazon_cf_files_distro_downloads_dname\";s:0:\"\";s:35:\"amazon_cf_files_distro_streaming_id\";s:0:\"\";s:38:\"amazon_cf_files_distro_streaming_cname\";s:0:\"\";s:38:\"amazon_cf_files_distro_streaming_dname\";s:0:\"\";s:42:\"amazon_cf_files_distros_auto_config_status\";s:0:\"\";s:38:\"amazon_cf_files_rtmp_policy_include_ip\";s:1:\"1\";s:20:\"ruris_case_sensitive\";s:1:\"0\";s:12:\"level0_ruris\";s:0:\"\";s:12:\"level1_ruris\";s:0:\"\";s:12:\"level2_ruris\";s:0:\"\";s:12:\"level3_ruris\";s:0:\"\";s:12:\"level4_ruris\";s:0:\"\";s:12:\"level0_catgs\";s:0:\"\";s:12:\"level1_catgs\";s:0:\"\";s:12:\"level2_catgs\";s:0:\"\";s:12:\"level3_catgs\";s:0:\"\";s:12:\"level4_catgs\";s:0:\"\";s:12:\"level0_ptags\";s:0:\"\";s:12:\"level1_ptags\";s:0:\"\";s:12:\"level2_ptags\";s:0:\"\";s:12:\"level3_ptags\";s:0:\"\";s:12:\"level4_ptags\";s:0:\"\";s:12:\"level0_posts\";s:0:\"\";s:12:\"level1_posts\";s:0:\"\";s:12:\"level2_posts\";s:0:\"\";s:12:\"level3_posts\";s:0:\"\";s:12:\"level4_posts\";s:0:\"\";s:12:\"level0_pages\";s:0:\"\";s:12:\"level1_pages\";s:0:\"\";s:12:\"level2_pages\";s:0:\"\";s:12:\"level3_pages\";s:0:\"\";s:12:\"level4_pages\";s:0:\"\";s:12:\"specific_ids\";s:0:\"\";s:22:\"triggers_immediate_eot\";s:9:\"reversals\";s:23:\"membership_eot_behavior\";s:6:\"demote\";s:21:\"eot_time_ext_behavior\";s:6:\"extend\";s:23:\"auto_eot_system_enabled\";s:1:\"1\";s:17:\"eots_remove_ccaps\";s:1:\"1\";s:14:\"eot_grace_time\";s:5:\"86400\";s:14:\"wp_footer_code\";s:0:\"\";}", "yes");
INSERT INTO `act_options` VALUES("1924", "ws_plugin__s2member_configured", "1", "yes");
INSERT INTO `act_options` VALUES("1925", "ws_plugin__s2member_activated_version", "170524", "yes");
INSERT INTO `act_options` VALUES("1932", "widget_mm_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1949", "_site_transient_timeout_browser_f79e47a86b8ea9eea660d3183e0c0e4f", "1498086847", "no");
INSERT INTO `act_options` VALUES("1950", "_site_transient_browser_f79e47a86b8ea9eea660d3183e0c0e4f", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"53.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "no");
INSERT INTO `act_options` VALUES("1975", "userultra_default_user_tabs", "a:5:{i:1;a:4:{s:8:\"position\";i:1;s:4:\"icon\";i:0;s:5:\"title\";s:17:\"Basic Information\";s:7:\"visible\";i:1;}i:2;a:4:{s:8:\"position\";i:2;s:4:\"icon\";i:0;s:5:\"title\";s:9:\"My Cyrcle\";s:7:\"visible\";i:1;}i:3;a:4:{s:8:\"position\";i:3;s:4:\"icon\";i:0;s:5:\"title\";s:9:\"My Photos\";s:7:\"visible\";i:1;}i:4;a:4:{s:8:\"position\";i:4;s:4:\"icon\";i:0;s:5:\"title\";s:12:\"My Galleries\";s:7:\"visible\";i:1;}i:5;a:4:{s:8:\"position\";i:5;s:4:\"icon\";i:0;s:5:\"title\";s:15:\"My Latest Posts\";s:7:\"visible\";i:1;}}", "yes");
INSERT INTO `act_options` VALUES("1976", "userultra_options", "a:63:{s:23:\"html_user_login_message\";s:42:\"Please log in to view / edit your profile.\";s:18:\"html_login_to_view\";s:36:\"Please log in to view user profiles.\";s:20:\"html_private_content\";s:43:\"User registration is currently not allowed.\";s:17:\"clickable_profile\";i:1;s:12:\"set_password\";i:1;s:15:\"guests_can_view\";i:1;s:14:\"users_can_view\";i:1;s:5:\"style\";s:7:\"default\";s:15:\"profile_page_id\";s:1:\"0\";s:14:\"hide_admin_bar\";s:1:\"1\";s:18:\"registration_rules\";s:1:\"1\";s:25:\"uultra_loggedin_activated\";s:0:\"\";s:18:\"media_avatar_width\";s:3:\"190\";s:19:\"media_avatar_height\";s:3:\"190\";s:22:\"media_photo_mini_width\";s:2:\"80\";s:23:\"media_photo_mini_height\";s:2:\"80\";s:23:\"media_photo_thumb_width\";s:3:\"190\";s:24:\"media_photo_thumb_height\";s:3:\"180\";s:23:\"media_photo_large_width\";s:3:\"700\";s:24:\"media_photo_large_height\";s:3:\"800\";s:22:\"media_uploading_folder\";s:15:\"usersultramedia\";s:37:\"uultra_front_publisher_default_amount\";s:4:\"9999\";s:37:\"uultra_front_publisher_default_status\";s:7:\"pending\";s:38:\"uultra_front_publisher_allows_category\";s:3:\"yes\";s:39:\"uultra_front_publisher_default_category\";s:0:\"\";s:26:\"uultra_loggedin_post_title\";s:10:\"No rights!\";s:28:\"uultra_loggedin_post_content\";s:49:\"Sorry you have to be logged in to view this post!\";s:36:\"uultra_loggedin_post_comment_content\";s:33:\"Sorry no rights to view comments!\";s:26:\"uultra_loggedin_page_title\";s:10:\"No rights!\";s:28:\"uultra_loggedin_page_content\";s:49:\"Sorry you have to be logged in to view this page!\";s:36:\"uultra_loggedin_page_comment_content\";s:33:\"Sorry no rights to view comments!\";s:26:\"usersultra_my_account_slug\";s:9:\"myaccount\";s:15:\"usersultra_slug\";s:7:\"profile\";s:21:\"usersultra_login_slug\";s:5:\"login\";s:28:\"usersultra_registration_slug\";s:12:\"registration\";s:25:\"usersultra_directory_slug\";s:9:\"directory\";s:14:\"mailchimp_text\";s:47:\"Subscribe to receive our periodic email updates\";s:13:\"login_page_id\";s:1:\"0\";s:20:\"registration_page_id\";s:1:\"0\";s:24:\"redirect_backend_profile\";s:1:\"0\";s:29:\"redirect_backend_registration\";s:1:\"0\";s:22:\"redirect_backend_login\";s:1:\"0\";s:24:\"paid_membership_currency\";s:3:\"USD\";s:22:\"paid_membership_symbol\";s:1:\"$\";s:31:\"uurofile_setting_display_photos\";s:6:\"public\";s:22:\"uultra_password_lenght\";s:1:\"7\";s:30:\"messaging_welcome_email_client\";s:374:\"Hi,\r\n\r\nThanks for registering. Your account is now active.\r\n\r\nTo login please visit the following URL:\r\n\r\n{{userl_ultra_login_url}}\r\n\r\nYour account e-mail: {{userultra_user_email}}\r\nYour account username: {{userultra_user_name}}\r\nYour account password: (same used on registration)\r\n\r\nIf you have any problems, please contact us at {{userultra_admin_email}}.\r\n\r\nBest Regards!\";s:36:\"messaging_welcome_email_client_admin\";s:207:\"Hi,\r\n\r\nA new user has been registered.\r\n\r\nAccount e-mail: {{userultra_user_email}}\r\nAccount username: {{userultra_user_name}}\r\nThis is an automated notification. No further action is needed.\r\n\r\nBest Regards!\";s:26:\"messaging_paid_email_admin\";s:249:\"Hi,\r\n\r\nA new paid user has been registered.\r\n\r\nAccount e-mail: {{userultra_user_email}}\r\nAccount username: {{userultra_user_name}}\r\nPackage: {{userultra_user_package}}\r\nThis is an automated notification. No further action is needed.\r\n\r\nBest Regards!\";s:46:\"messaging_welcome_email_with_activation_client\";s:388:\"Hi,\r\n\r\nThanks for registering. Your account needs activation.\r\n\r\nPlease click on the link below to activate your account:\r\n\r\n{{user_ultra_activation_url}}\r\n\r\nYour account e-mail: {{userultra_user_email}}\r\nYour account username: {{userultra_user_name}}\r\nYour account password: {{userultra_pass}}\r\n\r\nIf you have any problems, please contact us at {{userultra_admin_email}}.\r\n\r\nBest Regards!\";s:33:\"messaging_re_send_activation_link\";s:236:\"Hi,\r\n\r\nWe are re-sending you the activation link.\r\n\r\nPlease click on the link below to activate your account:\r\n\r\n{{user_ultra_activation_url}}\r\n\r\nIf you have any problems, please contact us at {{userultra_admin_email}}.\r\n\r\nBest Regards!\";s:31:\"messaging_admin_moderation_user\";s:96:\"Hi {{userultra_user_name}},\r\n\r\nYour account will be reviewed by the admin soon.\r\n\r\nBest Regards!\";s:32:\"messaging_admin_moderation_admin\";s:199:\"Hi Admin,\r\n\r\nAn account needs approbation.\r\n\r\nAccount e-mail: {{userultra_user_email}}\r\nAccount username: {{userultra_user_name}}\r\nPlease login to your admin to activate the account.\r\n\r\nBest Regards!\";s:45:\"messaging_welcome_email_with_activation_admin\";s:198:\"Hi Admin,\r\n\r\nAn account needs activation.\r\n\r\nAccount e-mail: {{userultra_user_email}}\r\nAccount username: {{userultra_user_name}}\r\nPlease login to your admin to activate the account.\r\n\r\nBest Regards!\";s:36:\"account_verified_sucess_message_body\";s:141:\"Hi,\r\n\r\nYour account has been verified.\r\n\r\nPlease use the link below to get in your account.\r\n\r\n{{userl_ultra_login_url}}\r\n\r\nBest Regards!\r\n\r\n\";s:22:\"message_friend_request\";s:86:\"Hi,\r\n\r\nYou have a new friend request at {{user_ultra_blog_name}}.\r\n\r\nBest Regards!\r\n\r\n\";s:29:\"messaging_welcome_email_admin\";s:258:\"Hi,\r\n\r\n{{userultra_user_name}} has just created a new account at {{user_ultra_blog_name}}.\r\n\r\nYou can check his profile via the following link:\r\n{{userl_ultra_login_url}}\r\n\r\nThis is an automated notification. No further action is needed.\r\n\r\nBest Regards!\r\n\r\n\";s:17:\"messaging_user_pm\";s:257:\"Hi,\r\n\r\n{{userultra_user_name}} has just sent you a new private message at {{user_ultra_blog_name}}.\r\n\r\nSubject: {{userultra_pm_subject}}\r\nMessage: {{userultra_pm_message}}\r\nThis is an automated notification. No further action is needed.\r\n\r\nBest Regards!\r\n\r\n\";s:22:\"reset_lik_message_body\";s:169:\"Hi,\r\n\r\nPlease use the following link to reset your password.\r\n\r\n{{userultra_reset_link}}\r\n\r\nIf you did not request a new password delete this email.\r\n\r\nBest Regards!\r\n\r\n\";s:27:\"password_reset_confirmation\";s:302:\"Hi,\r\n\r\nYour password has been reset.\r\n\r\nTo login please visit the following URL:\r\n\r\n{{userl_ultra_login_url}}\r\n\r\nYour account e-mail: {{userultra_user_email}}\r\n\r\nYour account username: {{userultra_user_name}}\r\n\r\nIf you have any problems, please contact us at {{userultra_admin_email}}.\r\n\r\nBest Regards!\";s:33:\"admin_account_active_message_body\";s:142:\"Hi,\r\n\r\nYour account has been activated.\r\n\r\nPlease use the link below to get in your account.\r\n\r\n{{userl_ultra_login_url}}\r\n\r\nBest Regards!\r\n\r\n\";s:31:\"admin_account_deny_message_body\";s:146:\"Hi,\r\n\r\nWe\'re sorry but your account has not been approved.\r\n\r\nThis is an automated notification. No further action is needed.\r\n\r\nBest Regards!\r\n\r\n\";s:24:\"messaging_send_from_name\";s:18:\"Users Ultra Plugin\";}", "yes");
INSERT INTO `act_options` VALUES("1978", "usersultra_profile_fields", "a:17:{i:80;a:6:{s:8:\"position\";s:2:\"50\";s:4:\"type\";s:9:\"separator\";s:4:\"name\";s:12:\"Profile Info\";s:7:\"private\";i:0;s:16:\"show_in_register\";i:1;s:7:\"deleted\";i:0;}i:100;a:12:{s:8:\"position\";s:3:\"100\";s:4:\"icon\";s:4:\"user\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:10:\"first_name\";s:4:\"name\";s:10:\"First Name\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:7:\"deleted\";i:0;}i:120;a:12:{s:8:\"position\";s:3:\"101\";s:4:\"icon\";i:0;s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:9:\"last_name\";s:4:\"name\";s:9:\"Last Name\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:7:\"deleted\";i:0;}i:130;a:15:{s:8:\"position\";s:3:\"130\";s:4:\"icon\";s:1:\"0\";s:5:\"field\";s:6:\"select\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:3:\"age\";s:4:\"name\";s:3:\"Age\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:8:\"required\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:18:\"predefined_options\";s:3:\"age\";s:7:\"deleted\";i:0;s:10:\"allow_html\";i:0;}i:150;a:13:{s:8:\"position\";s:3:\"150\";s:4:\"icon\";s:4:\"user\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:12:\"display_name\";s:4:\"name\";s:12:\"Display Name\";s:8:\"can_hide\";i:0;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:8:\"required\";i:1;s:7:\"deleted\";i:0;}i:170;a:13:{s:8:\"position\";s:3:\"200\";s:4:\"icon\";s:6:\"pencil\";s:5:\"field\";s:8:\"textarea\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:17:\"brief_description\";s:4:\"name\";s:17:\"Brief Description\";s:8:\"can_hide\";i:0;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:7:\"deleted\";i:0;s:10:\"allow_html\";i:1;}i:190;a:13:{s:8:\"position\";s:3:\"200\";s:4:\"icon\";s:6:\"pencil\";s:5:\"field\";s:8:\"textarea\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:11:\"description\";s:4:\"name\";s:11:\"About / Bio\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:7:\"deleted\";i:0;s:10:\"allow_html\";i:1;}i:200;a:15:{s:8:\"position\";s:3:\"200\";s:4:\"icon\";s:1:\"0\";s:5:\"field\";s:6:\"select\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:7:\"country\";s:4:\"name\";s:7:\"Country\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:8:\"required\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:0;s:18:\"predefined_options\";s:9:\"countries\";s:7:\"deleted\";i:0;s:10:\"allow_html\";i:0;}i:230;a:6:{s:8:\"position\";s:3:\"250\";s:4:\"type\";s:9:\"separator\";s:4:\"name\";s:12:\"Contact Info\";s:7:\"private\";i:0;s:16:\"show_in_register\";i:1;s:7:\"deleted\";i:0;}i:430;a:13:{s:8:\"position\";s:3:\"400\";s:4:\"icon\";s:4:\"link\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:8:\"user_url\";s:4:\"name\";s:7:\"Website\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:8:\"required\";i:0;s:7:\"private\";i:0;s:6:\"social\";i:0;s:7:\"deleted\";i:0;}i:470;a:6:{s:8:\"position\";s:3:\"450\";s:4:\"type\";s:9:\"separator\";s:4:\"name\";s:15:\"Social Profiles\";s:7:\"private\";i:0;s:16:\"show_in_register\";i:1;s:7:\"deleted\";i:0;}i:520;a:14:{s:8:\"position\";s:3:\"500\";s:4:\"icon\";s:8:\"facebook\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:8:\"facebook\";s:4:\"name\";s:8:\"Facebook\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:8:\"required\";i:0;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:1;s:7:\"tooltip\";s:20:\"Connect via Facebook\";s:7:\"deleted\";i:0;}i:560;a:14:{s:8:\"position\";s:3:\"510\";s:4:\"icon\";s:7:\"twitter\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:7:\"twitter\";s:4:\"name\";s:16:\"Twitter Username\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:8:\"required\";i:0;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:6:\"social\";i:1;s:7:\"tooltip\";s:19:\"Connect via Twitter\";s:7:\"deleted\";i:0;}i:590;a:14:{s:8:\"position\";s:3:\"520\";s:4:\"icon\";s:11:\"google-plus\";s:5:\"field\";s:4:\"text\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:10:\"googleplus\";s:4:\"name\";s:7:\"Google+\";s:8:\"can_hide\";i:1;s:8:\"can_edit\";i:1;s:16:\"show_in_register\";i:1;s:7:\"private\";i:0;s:8:\"required\";i:0;s:6:\"social\";i:1;s:7:\"tooltip\";s:19:\"Connect via Google+\";s:7:\"deleted\";i:0;}i:600;a:6:{s:8:\"position\";s:3:\"550\";s:4:\"type\";s:9:\"separator\";s:4:\"name\";s:12:\"Account Info\";s:7:\"private\";i:0;s:16:\"show_in_register\";i:0;s:7:\"deleted\";i:0;}i:690;a:11:{s:8:\"position\";s:3:\"600\";s:4:\"icon\";s:4:\"lock\";s:5:\"field\";s:8:\"password\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:9:\"user_pass\";s:4:\"name\";s:12:\"New Password\";s:8:\"can_hide\";i:0;s:8:\"can_edit\";i:1;s:7:\"private\";i:1;s:6:\"social\";i:0;s:7:\"deleted\";i:0;}i:720;a:11:{s:8:\"position\";s:3:\"700\";s:4:\"icon\";i:0;s:5:\"field\";s:8:\"password\";s:4:\"type\";s:8:\"usermeta\";s:4:\"meta\";s:17:\"user_pass_confirm\";s:4:\"name\";i:0;s:8:\"can_hide\";i:0;s:8:\"can_edit\";i:1;s:7:\"private\";i:1;s:6:\"social\";i:0;s:7:\"deleted\";i:0;}}", "yes");
INSERT INTO `act_options` VALUES("1991", "redux-framework-tracking", "a:3:{s:8:\"dev_mode\";b:0;s:4:\"hash\";s:32:\"6dc21f5baa1fba0e94ae30ce928beed9\";s:14:\"allow_tracking\";s:2:\"no\";}", "yes");
INSERT INTO `act_options` VALUES("1992", "um_version", "1.3.84", "yes");
INSERT INTO `act_options` VALUES("1993", "um_cache_fonticons", "a:1218:{i:0;s:13:\"um-icon-alert\";i:1;s:21:\"um-icon-alert-circled\";i:2;s:19:\"um-icon-android-add\";i:3;s:26:\"um-icon-android-add-circle\";i:4;s:27:\"um-icon-android-alarm-clock\";i:5;s:21:\"um-icon-android-alert\";i:6;s:20:\"um-icon-android-apps\";i:7;s:23:\"um-icon-android-archive\";i:8;s:26:\"um-icon-android-arrow-back\";i:9;s:26:\"um-icon-android-arrow-down\";i:10;s:30:\"um-icon-android-arrow-dropdown\";i:11;s:37:\"um-icon-android-arrow-dropdown-circle\";i:12;s:30:\"um-icon-android-arrow-dropleft\";i:13;s:37:\"um-icon-android-arrow-dropleft-circle\";i:14;s:31:\"um-icon-android-arrow-dropright\";i:15;s:38:\"um-icon-android-arrow-dropright-circle\";i:16;s:28:\"um-icon-android-arrow-dropup\";i:17;s:35:\"um-icon-android-arrow-dropup-circle\";i:18;s:29:\"um-icon-android-arrow-forward\";i:19;s:24:\"um-icon-android-arrow-up\";i:20;s:22:\"um-icon-android-attach\";i:21;s:19:\"um-icon-android-bar\";i:22;s:23:\"um-icon-android-bicycle\";i:23;s:20:\"um-icon-android-boat\";i:24;s:24:\"um-icon-android-bookmark\";i:25;s:20:\"um-icon-android-bulb\";i:26;s:19:\"um-icon-android-bus\";i:27;s:24:\"um-icon-android-calendar\";i:28;s:20:\"um-icon-android-call\";i:29;s:22:\"um-icon-android-camera\";i:30;s:22:\"um-icon-android-cancel\";i:31;s:19:\"um-icon-android-car\";i:32;s:20:\"um-icon-android-cart\";i:33;s:20:\"um-icon-android-chat\";i:34;s:24:\"um-icon-android-checkbox\";i:35;s:30:\"um-icon-android-checkbox-blank\";i:36;s:32:\"um-icon-android-checkbox-outline\";i:37;s:38:\"um-icon-android-checkbox-outline-blank\";i:38;s:32:\"um-icon-android-checkmark-circle\";i:39;s:25:\"um-icon-android-clipboard\";i:40;s:21:\"um-icon-android-close\";i:41;s:21:\"um-icon-android-cloud\";i:42;s:28:\"um-icon-android-cloud-circle\";i:43;s:26:\"um-icon-android-cloud-done\";i:44;s:29:\"um-icon-android-cloud-outline\";i:45;s:29:\"um-icon-android-color-palette\";i:46;s:23:\"um-icon-android-compass\";i:47;s:23:\"um-icon-android-contact\";i:48;s:24:\"um-icon-android-contacts\";i:49;s:24:\"um-icon-android-contract\";i:50;s:22:\"um-icon-android-create\";i:51;s:22:\"um-icon-android-delete\";i:52;s:23:\"um-icon-android-desktop\";i:53;s:24:\"um-icon-android-document\";i:54;s:20:\"um-icon-android-done\";i:55;s:24:\"um-icon-android-done-all\";i:56;s:24:\"um-icon-android-download\";i:57;s:22:\"um-icon-android-drafts\";i:58;s:20:\"um-icon-android-exit\";i:59;s:22:\"um-icon-android-expand\";i:60;s:24:\"um-icon-android-favorite\";i:61;s:32:\"um-icon-android-favorite-outline\";i:62;s:20:\"um-icon-android-film\";i:63;s:22:\"um-icon-android-folder\";i:64;s:27:\"um-icon-android-folder-open\";i:65;s:22:\"um-icon-android-funnel\";i:66;s:21:\"um-icon-android-globe\";i:67;s:20:\"um-icon-android-hand\";i:68;s:23:\"um-icon-android-hangout\";i:69;s:21:\"um-icon-android-happy\";i:70;s:20:\"um-icon-android-home\";i:71;s:21:\"um-icon-android-image\";i:72;s:22:\"um-icon-android-laptop\";i:73;s:20:\"um-icon-android-list\";i:74;s:22:\"um-icon-android-locate\";i:75;s:20:\"um-icon-android-lock\";i:76;s:20:\"um-icon-android-mail\";i:77;s:19:\"um-icon-android-map\";i:78;s:20:\"um-icon-android-menu\";i:79;s:26:\"um-icon-android-microphone\";i:80;s:30:\"um-icon-android-microphone-off\";i:81;s:31:\"um-icon-android-more-horizontal\";i:82;s:29:\"um-icon-android-more-vertical\";i:83;s:24:\"um-icon-android-navigate\";i:84;s:29:\"um-icon-android-notifications\";i:85;s:34:\"um-icon-android-notifications-none\";i:86;s:33:\"um-icon-android-notifications-off\";i:87;s:20:\"um-icon-android-open\";i:88;s:23:\"um-icon-android-options\";i:89;s:22:\"um-icon-android-people\";i:90;s:22:\"um-icon-android-person\";i:91;s:26:\"um-icon-android-person-add\";i:92;s:31:\"um-icon-android-phone-landscape\";i:93;s:30:\"um-icon-android-phone-portrait\";i:94;s:19:\"um-icon-android-pin\";i:95;s:21:\"um-icon-android-plane\";i:96;s:25:\"um-icon-android-playstore\";i:97;s:21:\"um-icon-android-print\";i:98;s:32:\"um-icon-android-radio-button-off\";i:99;s:31:\"um-icon-android-radio-button-on\";i:100;s:23:\"um-icon-android-refresh\";i:101;s:22:\"um-icon-android-remove\";i:102;s:29:\"um-icon-android-remove-circle\";i:103;s:26:\"um-icon-android-restaurant\";i:104;s:19:\"um-icon-android-sad\";i:105;s:22:\"um-icon-android-search\";i:106;s:20:\"um-icon-android-send\";i:107;s:24:\"um-icon-android-settings\";i:108;s:21:\"um-icon-android-share\";i:109;s:25:\"um-icon-android-share-alt\";i:110;s:20:\"um-icon-android-star\";i:111;s:25:\"um-icon-android-star-half\";i:112;s:28:\"um-icon-android-star-outline\";i:113;s:25:\"um-icon-android-stopwatch\";i:114;s:22:\"um-icon-android-subway\";i:115;s:21:\"um-icon-android-sunny\";i:116;s:20:\"um-icon-android-sync\";i:117;s:23:\"um-icon-android-textsms\";i:118;s:20:\"um-icon-android-time\";i:119;s:21:\"um-icon-android-train\";i:120;s:22:\"um-icon-android-unlock\";i:121;s:22:\"um-icon-android-upload\";i:122;s:27:\"um-icon-android-volume-down\";i:123;s:27:\"um-icon-android-volume-mute\";i:124;s:26:\"um-icon-android-volume-off\";i:125;s:25:\"um-icon-android-volume-up\";i:126;s:20:\"um-icon-android-walk\";i:127;s:23:\"um-icon-android-warning\";i:128;s:21:\"um-icon-android-watch\";i:129;s:20:\"um-icon-android-wifi\";i:130;s:16:\"um-icon-aperture\";i:131;s:15:\"um-icon-archive\";i:132;s:20:\"um-icon-arrow-down-a\";i:133;s:20:\"um-icon-arrow-down-b\";i:134;s:20:\"um-icon-arrow-down-c\";i:135;s:20:\"um-icon-arrow-expand\";i:136;s:29:\"um-icon-arrow-graph-down-left\";i:137;s:30:\"um-icon-arrow-graph-down-right\";i:138;s:27:\"um-icon-arrow-graph-up-left\";i:139;s:28:\"um-icon-arrow-graph-up-right\";i:140;s:20:\"um-icon-arrow-left-a\";i:141;s:20:\"um-icon-arrow-left-b\";i:142;s:20:\"um-icon-arrow-left-c\";i:143;s:18:\"um-icon-arrow-move\";i:144;s:20:\"um-icon-arrow-resize\";i:145;s:25:\"um-icon-arrow-return-left\";i:146;s:26:\"um-icon-arrow-return-right\";i:147;s:21:\"um-icon-arrow-right-a\";i:148;s:21:\"um-icon-arrow-right-b\";i:149;s:21:\"um-icon-arrow-right-c\";i:150;s:20:\"um-icon-arrow-shrink\";i:151;s:18:\"um-icon-arrow-swap\";i:152;s:18:\"um-icon-arrow-up-a\";i:153;s:18:\"um-icon-arrow-up-b\";i:154;s:18:\"um-icon-arrow-up-c\";i:155;s:16:\"um-icon-asterisk\";i:156;s:10:\"um-icon-at\";i:157;s:17:\"um-icon-backspace\";i:158;s:25:\"um-icon-backspace-outline\";i:159;s:11:\"um-icon-bag\";i:160;s:24:\"um-icon-battery-charging\";i:161;s:21:\"um-icon-battery-empty\";i:162;s:20:\"um-icon-battery-full\";i:163;s:20:\"um-icon-battery-half\";i:164;s:19:\"um-icon-battery-low\";i:165;s:14:\"um-icon-beaker\";i:166;s:12:\"um-icon-beer\";i:167;s:17:\"um-icon-bluetooth\";i:168;s:15:\"um-icon-bonfire\";i:169;s:16:\"um-icon-bookmark\";i:170;s:14:\"um-icon-bowtie\";i:171;s:17:\"um-icon-briefcase\";i:172;s:11:\"um-icon-bug\";i:173;s:18:\"um-icon-calculator\";i:174;s:16:\"um-icon-calendar\";i:175;s:14:\"um-icon-camera\";i:176;s:12:\"um-icon-card\";i:177;s:12:\"um-icon-cash\";i:178;s:15:\"um-icon-chatbox\";i:179;s:23:\"um-icon-chatbox-working\";i:180;s:17:\"um-icon-chatboxes\";i:181;s:18:\"um-icon-chatbubble\";i:182;s:26:\"um-icon-chatbubble-working\";i:183;s:19:\"um-icon-chatbubbles\";i:184;s:17:\"um-icon-checkmark\";i:185;s:25:\"um-icon-checkmark-circled\";i:186;s:23:\"um-icon-checkmark-round\";i:187;s:20:\"um-icon-chevron-down\";i:188;s:20:\"um-icon-chevron-left\";i:189;s:21:\"um-icon-chevron-right\";i:190;s:18:\"um-icon-chevron-up\";i:191;s:17:\"um-icon-clipboard\";i:192;s:13:\"um-icon-clock\";i:193;s:13:\"um-icon-close\";i:194;s:21:\"um-icon-close-circled\";i:195;s:19:\"um-icon-close-round\";i:196;s:25:\"um-icon-closed-captioning\";i:197;s:13:\"um-icon-cloud\";i:198;s:12:\"um-icon-code\";i:199;s:21:\"um-icon-code-download\";i:200;s:20:\"um-icon-code-working\";i:201;s:14:\"um-icon-coffee\";i:202;s:15:\"um-icon-compass\";i:203;s:15:\"um-icon-compose\";i:204;s:23:\"um-icon-connection-bars\";i:205;s:16:\"um-icon-contrast\";i:206;s:12:\"um-icon-crop\";i:207;s:12:\"um-icon-cube\";i:208;s:12:\"um-icon-disc\";i:209;s:16:\"um-icon-document\";i:210;s:21:\"um-icon-document-text\";i:211;s:12:\"um-icon-drag\";i:212;s:13:\"um-icon-earth\";i:213;s:13:\"um-icon-easel\";i:214;s:12:\"um-icon-edit\";i:215;s:11:\"um-icon-egg\";i:216;s:13:\"um-icon-eject\";i:217;s:13:\"um-icon-email\";i:218;s:20:\"um-icon-email-unread\";i:219;s:24:\"um-icon-erlenmeyer-flask\";i:220;s:32:\"um-icon-erlenmeyer-flask-bubbles\";i:221;s:11:\"um-icon-eye\";i:222;s:20:\"um-icon-eye-disabled\";i:223;s:14:\"um-icon-female\";i:224;s:14:\"um-icon-filing\";i:225;s:19:\"um-icon-film-marker\";i:226;s:16:\"um-icon-fireball\";i:227;s:12:\"um-icon-flag\";i:228;s:13:\"um-icon-flame\";i:229;s:13:\"um-icon-flash\";i:230;s:17:\"um-icon-flash-off\";i:231;s:14:\"um-icon-folder\";i:232;s:12:\"um-icon-fork\";i:233;s:17:\"um-icon-fork-repo\";i:234;s:15:\"um-icon-forward\";i:235;s:14:\"um-icon-funnel\";i:236;s:14:\"um-icon-gear-a\";i:237;s:14:\"um-icon-gear-b\";i:238;s:12:\"um-icon-grid\";i:239;s:14:\"um-icon-hammer\";i:240;s:13:\"um-icon-happy\";i:241;s:21:\"um-icon-happy-outline\";i:242;s:17:\"um-icon-headphone\";i:243;s:13:\"um-icon-heart\";i:244;s:20:\"um-icon-heart-broken\";i:245;s:12:\"um-icon-help\";i:246;s:17:\"um-icon-help-buoy\";i:247;s:20:\"um-icon-help-circled\";i:248;s:12:\"um-icon-home\";i:249;s:16:\"um-icon-icecream\";i:250;s:13:\"um-icon-image\";i:251;s:14:\"um-icon-images\";i:252;s:19:\"um-icon-information\";i:253;s:27:\"um-icon-information-circled\";i:254;s:13:\"um-icon-ionic\";i:255;s:17:\"um-icon-ios-alarm\";i:256;s:25:\"um-icon-ios-alarm-outline\";i:257;s:18:\"um-icon-ios-albums\";i:258;s:26:\"um-icon-ios-albums-outline\";i:259;s:28:\"um-icon-ios-americanfootball\";i:260;s:36:\"um-icon-ios-americanfootball-outline\";i:261;s:21:\"um-icon-ios-analytics\";i:262;s:29:\"um-icon-ios-analytics-outline\";i:263;s:22:\"um-icon-ios-arrow-back\";i:264;s:22:\"um-icon-ios-arrow-down\";i:265;s:25:\"um-icon-ios-arrow-forward\";i:266;s:22:\"um-icon-ios-arrow-left\";i:267;s:23:\"um-icon-ios-arrow-right\";i:268;s:27:\"um-icon-ios-arrow-thin-down\";i:269;s:27:\"um-icon-ios-arrow-thin-left\";i:270;s:28:\"um-icon-ios-arrow-thin-right\";i:271;s:25:\"um-icon-ios-arrow-thin-up\";i:272;s:20:\"um-icon-ios-arrow-up\";i:273;s:14:\"um-icon-ios-at\";i:274;s:22:\"um-icon-ios-at-outline\";i:275;s:19:\"um-icon-ios-barcode\";i:276;s:27:\"um-icon-ios-barcode-outline\";i:277;s:20:\"um-icon-ios-baseball\";i:278;s:28:\"um-icon-ios-baseball-outline\";i:279;s:22:\"um-icon-ios-basketball\";i:280;s:30:\"um-icon-ios-basketball-outline\";i:281;s:16:\"um-icon-ios-bell\";i:282;s:24:\"um-icon-ios-bell-outline\";i:283;s:16:\"um-icon-ios-body\";i:284;s:24:\"um-icon-ios-body-outline\";i:285;s:16:\"um-icon-ios-bolt\";i:286;s:24:\"um-icon-ios-bolt-outline\";i:287;s:16:\"um-icon-ios-book\";i:288;s:24:\"um-icon-ios-book-outline\";i:289;s:21:\"um-icon-ios-bookmarks\";i:290;s:29:\"um-icon-ios-bookmarks-outline\";i:291;s:15:\"um-icon-ios-box\";i:292;s:23:\"um-icon-ios-box-outline\";i:293;s:21:\"um-icon-ios-briefcase\";i:294;s:29:\"um-icon-ios-briefcase-outline\";i:295;s:20:\"um-icon-ios-browsers\";i:296;s:28:\"um-icon-ios-browsers-outline\";i:297;s:22:\"um-icon-ios-calculator\";i:298;s:30:\"um-icon-ios-calculator-outline\";i:299;s:20:\"um-icon-ios-calendar\";i:300;s:28:\"um-icon-ios-calendar-outline\";i:301;s:18:\"um-icon-ios-camera\";i:302;s:26:\"um-icon-ios-camera-outline\";i:303;s:16:\"um-icon-ios-cart\";i:304;s:24:\"um-icon-ios-cart-outline\";i:305;s:21:\"um-icon-ios-chatboxes\";i:306;s:29:\"um-icon-ios-chatboxes-outline\";i:307;s:22:\"um-icon-ios-chatbubble\";i:308;s:30:\"um-icon-ios-chatbubble-outline\";i:309;s:21:\"um-icon-ios-checkmark\";i:310;s:27:\"um-icon-ios-checkmark-empty\";i:311;s:29:\"um-icon-ios-checkmark-outline\";i:312;s:25:\"um-icon-ios-circle-filled\";i:313;s:26:\"um-icon-ios-circle-outline\";i:314;s:17:\"um-icon-ios-clock\";i:315;s:25:\"um-icon-ios-clock-outline\";i:316;s:17:\"um-icon-ios-close\";i:317;s:23:\"um-icon-ios-close-empty\";i:318;s:25:\"um-icon-ios-close-outline\";i:319;s:17:\"um-icon-ios-cloud\";i:320;s:26:\"um-icon-ios-cloud-download\";i:321;s:34:\"um-icon-ios-cloud-download-outline\";i:322;s:25:\"um-icon-ios-cloud-outline\";i:323;s:24:\"um-icon-ios-cloud-upload\";i:324;s:32:\"um-icon-ios-cloud-upload-outline\";i:325;s:18:\"um-icon-ios-cloudy\";i:326;s:24:\"um-icon-ios-cloudy-night\";i:327;s:32:\"um-icon-ios-cloudy-night-outline\";i:328;s:26:\"um-icon-ios-cloudy-outline\";i:329;s:15:\"um-icon-ios-cog\";i:330;s:23:\"um-icon-ios-cog-outline\";i:331;s:24:\"um-icon-ios-color-filter\";i:332;s:32:\"um-icon-ios-color-filter-outline\";i:333;s:22:\"um-icon-ios-color-wand\";i:334;s:30:\"um-icon-ios-color-wand-outline\";i:335;s:19:\"um-icon-ios-compose\";i:336;s:27:\"um-icon-ios-compose-outline\";i:337;s:19:\"um-icon-ios-contact\";i:338;s:27:\"um-icon-ios-contact-outline\";i:339;s:16:\"um-icon-ios-copy\";i:340;s:24:\"um-icon-ios-copy-outline\";i:341;s:16:\"um-icon-ios-crop\";i:342;s:23:\"um-icon-ios-crop-strong\";i:343;s:20:\"um-icon-ios-download\";i:344;s:28:\"um-icon-ios-download-outline\";i:345;s:16:\"um-icon-ios-drag\";i:346;s:17:\"um-icon-ios-email\";i:347;s:25:\"um-icon-ios-email-outline\";i:348;s:15:\"um-icon-ios-eye\";i:349;s:23:\"um-icon-ios-eye-outline\";i:350;s:23:\"um-icon-ios-fastforward\";i:351;s:31:\"um-icon-ios-fastforward-outline\";i:352;s:18:\"um-icon-ios-filing\";i:353;s:26:\"um-icon-ios-filing-outline\";i:354;s:16:\"um-icon-ios-film\";i:355;s:24:\"um-icon-ios-film-outline\";i:356;s:16:\"um-icon-ios-flag\";i:357;s:24:\"um-icon-ios-flag-outline\";i:358;s:17:\"um-icon-ios-flame\";i:359;s:25:\"um-icon-ios-flame-outline\";i:360;s:17:\"um-icon-ios-flask\";i:361;s:25:\"um-icon-ios-flask-outline\";i:362;s:18:\"um-icon-ios-flower\";i:363;s:26:\"um-icon-ios-flower-outline\";i:364;s:18:\"um-icon-ios-folder\";i:365;s:26:\"um-icon-ios-folder-outline\";i:366;s:20:\"um-icon-ios-football\";i:367;s:28:\"um-icon-ios-football-outline\";i:368;s:29:\"um-icon-ios-game-controller-a\";i:369;s:37:\"um-icon-ios-game-controller-a-outline\";i:370;s:29:\"um-icon-ios-game-controller-b\";i:371;s:37:\"um-icon-ios-game-controller-b-outline\";i:372;s:16:\"um-icon-ios-gear\";i:373;s:24:\"um-icon-ios-gear-outline\";i:374;s:19:\"um-icon-ios-glasses\";i:375;s:27:\"um-icon-ios-glasses-outline\";i:376;s:21:\"um-icon-ios-grid-view\";i:377;s:29:\"um-icon-ios-grid-view-outline\";i:378;s:17:\"um-icon-ios-heart\";i:379;s:25:\"um-icon-ios-heart-outline\";i:380;s:16:\"um-icon-ios-help\";i:381;s:22:\"um-icon-ios-help-empty\";i:382;s:24:\"um-icon-ios-help-outline\";i:383;s:16:\"um-icon-ios-home\";i:384;s:24:\"um-icon-ios-home-outline\";i:385;s:20:\"um-icon-ios-infinite\";i:386;s:28:\"um-icon-ios-infinite-outline\";i:387;s:23:\"um-icon-ios-information\";i:388;s:29:\"um-icon-ios-information-empty\";i:389;s:31:\"um-icon-ios-information-outline\";i:390;s:25:\"um-icon-ios-ionic-outline\";i:391;s:18:\"um-icon-ios-keypad\";i:392;s:26:\"um-icon-ios-keypad-outline\";i:393;s:21:\"um-icon-ios-lightbulb\";i:394;s:29:\"um-icon-ios-lightbulb-outline\";i:395;s:16:\"um-icon-ios-list\";i:396;s:24:\"um-icon-ios-list-outline\";i:397;s:20:\"um-icon-ios-location\";i:398;s:28:\"um-icon-ios-location-outline\";i:399;s:18:\"um-icon-ios-locked\";i:400;s:26:\"um-icon-ios-locked-outline\";i:401;s:16:\"um-icon-ios-loop\";i:402;s:23:\"um-icon-ios-loop-strong\";i:403;s:19:\"um-icon-ios-medical\";i:404;s:27:\"um-icon-ios-medical-outline\";i:405;s:18:\"um-icon-ios-medkit\";i:406;s:26:\"um-icon-ios-medkit-outline\";i:407;s:15:\"um-icon-ios-mic\";i:408;s:19:\"um-icon-ios-mic-off\";i:409;s:23:\"um-icon-ios-mic-outline\";i:410;s:17:\"um-icon-ios-minus\";i:411;s:23:\"um-icon-ios-minus-empty\";i:412;s:25:\"um-icon-ios-minus-outline\";i:413;s:19:\"um-icon-ios-monitor\";i:414;s:27:\"um-icon-ios-monitor-outline\";i:415;s:16:\"um-icon-ios-moon\";i:416;s:24:\"um-icon-ios-moon-outline\";i:417;s:16:\"um-icon-ios-more\";i:418;s:24:\"um-icon-ios-more-outline\";i:419;s:24:\"um-icon-ios-musical-note\";i:420;s:25:\"um-icon-ios-musical-notes\";i:421;s:20:\"um-icon-ios-navigate\";i:422;s:28:\"um-icon-ios-navigate-outline\";i:423;s:21:\"um-icon-ios-nutrition\";i:424;s:29:\"um-icon-ios-nutrition-outline\";i:425;s:17:\"um-icon-ios-paper\";i:426;s:25:\"um-icon-ios-paper-outline\";i:427;s:22:\"um-icon-ios-paperplane\";i:428;s:30:\"um-icon-ios-paperplane-outline\";i:429;s:23:\"um-icon-ios-partlysunny\";i:430;s:31:\"um-icon-ios-partlysunny-outline\";i:431;s:17:\"um-icon-ios-pause\";i:432;s:25:\"um-icon-ios-pause-outline\";i:433;s:15:\"um-icon-ios-paw\";i:434;s:23:\"um-icon-ios-paw-outline\";i:435;s:18:\"um-icon-ios-people\";i:436;s:26:\"um-icon-ios-people-outline\";i:437;s:18:\"um-icon-ios-person\";i:438;s:26:\"um-icon-ios-person-outline\";i:439;s:21:\"um-icon-ios-personadd\";i:440;s:29:\"um-icon-ios-personadd-outline\";i:441;s:18:\"um-icon-ios-photos\";i:442;s:26:\"um-icon-ios-photos-outline\";i:443;s:15:\"um-icon-ios-pie\";i:444;s:23:\"um-icon-ios-pie-outline\";i:445;s:16:\"um-icon-ios-pint\";i:446;s:24:\"um-icon-ios-pint-outline\";i:447;s:16:\"um-icon-ios-play\";i:448;s:24:\"um-icon-ios-play-outline\";i:449;s:16:\"um-icon-ios-plus\";i:450;s:22:\"um-icon-ios-plus-empty\";i:451;s:24:\"um-icon-ios-plus-outline\";i:452;s:20:\"um-icon-ios-pricetag\";i:453;s:28:\"um-icon-ios-pricetag-outline\";i:454;s:21:\"um-icon-ios-pricetags\";i:455;s:29:\"um-icon-ios-pricetags-outline\";i:456;s:19:\"um-icon-ios-printer\";i:457;s:27:\"um-icon-ios-printer-outline\";i:458;s:17:\"um-icon-ios-pulse\";i:459;s:24:\"um-icon-ios-pulse-strong\";i:460;s:17:\"um-icon-ios-rainy\";i:461;s:25:\"um-icon-ios-rainy-outline\";i:462;s:21:\"um-icon-ios-recording\";i:463;s:29:\"um-icon-ios-recording-outline\";i:464;s:16:\"um-icon-ios-redo\";i:465;s:24:\"um-icon-ios-redo-outline\";i:466;s:19:\"um-icon-ios-refresh\";i:467;s:25:\"um-icon-ios-refresh-empty\";i:468;s:27:\"um-icon-ios-refresh-outline\";i:469;s:18:\"um-icon-ios-reload\";i:470;s:26:\"um-icon-ios-reverse-camera\";i:471;s:34:\"um-icon-ios-reverse-camera-outline\";i:472;s:18:\"um-icon-ios-rewind\";i:473;s:26:\"um-icon-ios-rewind-outline\";i:474;s:16:\"um-icon-ios-rose\";i:475;s:24:\"um-icon-ios-rose-outline\";i:476;s:18:\"um-icon-ios-search\";i:477;s:25:\"um-icon-ios-search-strong\";i:478;s:20:\"um-icon-ios-settings\";i:479;s:27:\"um-icon-ios-settings-strong\";i:480;s:19:\"um-icon-ios-shuffle\";i:481;s:26:\"um-icon-ios-shuffle-strong\";i:482;s:24:\"um-icon-ios-skipbackward\";i:483;s:32:\"um-icon-ios-skipbackward-outline\";i:484;s:23:\"um-icon-ios-skipforward\";i:485;s:31:\"um-icon-ios-skipforward-outline\";i:486;s:17:\"um-icon-ios-snowy\";i:487;s:23:\"um-icon-ios-speedometer\";i:488;s:31:\"um-icon-ios-speedometer-outline\";i:489;s:16:\"um-icon-ios-star\";i:490;s:21:\"um-icon-ios-star-half\";i:491;s:24:\"um-icon-ios-star-outline\";i:492;s:21:\"um-icon-ios-stopwatch\";i:493;s:29:\"um-icon-ios-stopwatch-outline\";i:494;s:17:\"um-icon-ios-sunny\";i:495;s:25:\"um-icon-ios-sunny-outline\";i:496;s:21:\"um-icon-ios-telephone\";i:497;s:29:\"um-icon-ios-telephone-outline\";i:498;s:22:\"um-icon-ios-tennisball\";i:499;s:30:\"um-icon-ios-tennisball-outline\";i:500;s:24:\"um-icon-ios-thunderstorm\";i:501;s:32:\"um-icon-ios-thunderstorm-outline\";i:502;s:16:\"um-icon-ios-time\";i:503;s:24:\"um-icon-ios-time-outline\";i:504;s:17:\"um-icon-ios-timer\";i:505;s:25:\"um-icon-ios-timer-outline\";i:506;s:18:\"um-icon-ios-toggle\";i:507;s:26:\"um-icon-ios-toggle-outline\";i:508;s:17:\"um-icon-ios-trash\";i:509;s:25:\"um-icon-ios-trash-outline\";i:510;s:16:\"um-icon-ios-undo\";i:511;s:24:\"um-icon-ios-undo-outline\";i:512;s:20:\"um-icon-ios-unlocked\";i:513;s:28:\"um-icon-ios-unlocked-outline\";i:514;s:18:\"um-icon-ios-upload\";i:515;s:26:\"um-icon-ios-upload-outline\";i:516;s:20:\"um-icon-ios-videocam\";i:517;s:28:\"um-icon-ios-videocam-outline\";i:518;s:23:\"um-icon-ios-volume-high\";i:519;s:22:\"um-icon-ios-volume-low\";i:520;s:21:\"um-icon-ios-wineglass\";i:521;s:29:\"um-icon-ios-wineglass-outline\";i:522;s:17:\"um-icon-ios-world\";i:523;s:25:\"um-icon-ios-world-outline\";i:524;s:12:\"um-icon-ipad\";i:525;s:14:\"um-icon-iphone\";i:526;s:12:\"um-icon-ipod\";i:527;s:11:\"um-icon-jet\";i:528;s:11:\"um-icon-key\";i:529;s:13:\"um-icon-knife\";i:530;s:14:\"um-icon-laptop\";i:531;s:12:\"um-icon-leaf\";i:532;s:14:\"um-icon-levels\";i:533;s:17:\"um-icon-lightbulb\";i:534;s:12:\"um-icon-link\";i:535;s:14:\"um-icon-load-a\";i:536;s:14:\"um-icon-load-b\";i:537;s:14:\"um-icon-load-c\";i:538;s:14:\"um-icon-load-d\";i:539;s:16:\"um-icon-location\";i:540;s:24:\"um-icon-lock-combination\";i:541;s:14:\"um-icon-locked\";i:542;s:14:\"um-icon-log-in\";i:543;s:15:\"um-icon-log-out\";i:544;s:12:\"um-icon-loop\";i:545;s:14:\"um-icon-magnet\";i:546;s:12:\"um-icon-male\";i:547;s:11:\"um-icon-man\";i:548;s:11:\"um-icon-map\";i:549;s:14:\"um-icon-medkit\";i:550;s:13:\"um-icon-merge\";i:551;s:13:\"um-icon-mic-a\";i:552;s:13:\"um-icon-mic-b\";i:553;s:13:\"um-icon-mic-c\";i:554;s:13:\"um-icon-minus\";i:555;s:21:\"um-icon-minus-circled\";i:556;s:19:\"um-icon-minus-round\";i:557;s:15:\"um-icon-model-s\";i:558;s:15:\"um-icon-monitor\";i:559;s:12:\"um-icon-more\";i:560;s:13:\"um-icon-mouse\";i:561;s:18:\"um-icon-music-note\";i:562;s:15:\"um-icon-navicon\";i:563;s:21:\"um-icon-navicon-round\";i:564;s:16:\"um-icon-navigate\";i:565;s:15:\"um-icon-network\";i:566;s:18:\"um-icon-no-smoking\";i:567;s:15:\"um-icon-nuclear\";i:568;s:14:\"um-icon-outlet\";i:569;s:18:\"um-icon-paintbrush\";i:570;s:19:\"um-icon-paintbucket\";i:571;s:22:\"um-icon-paper-airplane\";i:572;s:17:\"um-icon-paperclip\";i:573;s:13:\"um-icon-pause\";i:574;s:14:\"um-icon-person\";i:575;s:18:\"um-icon-person-add\";i:576;s:22:\"um-icon-person-stalker\";i:577;s:17:\"um-icon-pie-graph\";i:578;s:11:\"um-icon-pin\";i:579;s:16:\"um-icon-pinpoint\";i:580;s:13:\"um-icon-pizza\";i:581;s:13:\"um-icon-plane\";i:582;s:14:\"um-icon-planet\";i:583;s:12:\"um-icon-play\";i:584;s:19:\"um-icon-playstation\";i:585;s:12:\"um-icon-plus\";i:586;s:20:\"um-icon-plus-circled\";i:587;s:18:\"um-icon-plus-round\";i:588;s:14:\"um-icon-podium\";i:589;s:13:\"um-icon-pound\";i:590;s:13:\"um-icon-power\";i:591;s:16:\"um-icon-pricetag\";i:592;s:17:\"um-icon-pricetags\";i:593;s:15:\"um-icon-printer\";i:594;s:20:\"um-icon-pull-request\";i:595;s:18:\"um-icon-qr-scanner\";i:596;s:13:\"um-icon-quote\";i:597;s:19:\"um-icon-radio-waves\";i:598;s:14:\"um-icon-record\";i:599;s:15:\"um-icon-refresh\";i:600;s:13:\"um-icon-reply\";i:601;s:17:\"um-icon-reply-all\";i:602;s:16:\"um-icon-ribbon-a\";i:603;s:16:\"um-icon-ribbon-b\";i:604;s:11:\"um-icon-sad\";i:605;s:19:\"um-icon-sad-outline\";i:606;s:16:\"um-icon-scissors\";i:607;s:14:\"um-icon-search\";i:608;s:16:\"um-icon-settings\";i:609;s:13:\"um-icon-share\";i:610;s:15:\"um-icon-shuffle\";i:611;s:21:\"um-icon-skip-backward\";i:612;s:20:\"um-icon-skip-forward\";i:613;s:22:\"um-icon-social-android\";i:614;s:30:\"um-icon-social-android-outline\";i:615;s:22:\"um-icon-social-angular\";i:616;s:30:\"um-icon-social-angular-outline\";i:617;s:20:\"um-icon-social-apple\";i:618;s:28:\"um-icon-social-apple-outline\";i:619;s:22:\"um-icon-social-bitcoin\";i:620;s:30:\"um-icon-social-bitcoin-outline\";i:621;s:21:\"um-icon-social-buffer\";i:622;s:29:\"um-icon-social-buffer-outline\";i:623;s:21:\"um-icon-social-chrome\";i:624;s:29:\"um-icon-social-chrome-outline\";i:625;s:22:\"um-icon-social-codepen\";i:626;s:30:\"um-icon-social-codepen-outline\";i:627;s:19:\"um-icon-social-css3\";i:628;s:27:\"um-icon-social-css3-outline\";i:629;s:27:\"um-icon-social-designernews\";i:630;s:35:\"um-icon-social-designernews-outline\";i:631;s:23:\"um-icon-social-dribbble\";i:632;s:31:\"um-icon-social-dribbble-outline\";i:633;s:22:\"um-icon-social-dropbox\";i:634;s:30:\"um-icon-social-dropbox-outline\";i:635;s:19:\"um-icon-social-euro\";i:636;s:27:\"um-icon-social-euro-outline\";i:637;s:23:\"um-icon-social-facebook\";i:638;s:31:\"um-icon-social-facebook-outline\";i:639;s:25:\"um-icon-social-foursquare\";i:640;s:33:\"um-icon-social-foursquare-outline\";i:641;s:28:\"um-icon-social-freebsd-devil\";i:642;s:21:\"um-icon-social-github\";i:643;s:29:\"um-icon-social-github-outline\";i:644;s:21:\"um-icon-social-google\";i:645;s:29:\"um-icon-social-google-outline\";i:646;s:25:\"um-icon-social-googleplus\";i:647;s:33:\"um-icon-social-googleplus-outline\";i:648;s:25:\"um-icon-social-hackernews\";i:649;s:33:\"um-icon-social-hackernews-outline\";i:650;s:20:\"um-icon-social-html5\";i:651;s:28:\"um-icon-social-html5-outline\";i:652;s:24:\"um-icon-social-instagram\";i:653;s:32:\"um-icon-social-instagram-outline\";i:654;s:25:\"um-icon-social-javascript\";i:655;s:33:\"um-icon-social-javascript-outline\";i:656;s:23:\"um-icon-social-linkedin\";i:657;s:31:\"um-icon-social-linkedin-outline\";i:658;s:23:\"um-icon-social-markdown\";i:659;s:21:\"um-icon-social-nodejs\";i:660;s:22:\"um-icon-social-octocat\";i:661;s:24:\"um-icon-social-pinterest\";i:662;s:32:\"um-icon-social-pinterest-outline\";i:663;s:21:\"um-icon-social-python\";i:664;s:21:\"um-icon-social-reddit\";i:665;s:29:\"um-icon-social-reddit-outline\";i:666;s:18:\"um-icon-social-rss\";i:667;s:26:\"um-icon-social-rss-outline\";i:668;s:19:\"um-icon-social-sass\";i:669;s:20:\"um-icon-social-skype\";i:670;s:28:\"um-icon-social-skype-outline\";i:671;s:23:\"um-icon-social-snapchat\";i:672;s:31:\"um-icon-social-snapchat-outline\";i:673;s:21:\"um-icon-social-tumblr\";i:674;s:29:\"um-icon-social-tumblr-outline\";i:675;s:18:\"um-icon-social-tux\";i:676;s:21:\"um-icon-social-twitch\";i:677;s:29:\"um-icon-social-twitch-outline\";i:678;s:22:\"um-icon-social-twitter\";i:679;s:30:\"um-icon-social-twitter-outline\";i:680;s:18:\"um-icon-social-usd\";i:681;s:26:\"um-icon-social-usd-outline\";i:682;s:20:\"um-icon-social-vimeo\";i:683;s:28:\"um-icon-social-vimeo-outline\";i:684;s:23:\"um-icon-social-whatsapp\";i:685;s:31:\"um-icon-social-whatsapp-outline\";i:686;s:22:\"um-icon-social-windows\";i:687;s:30:\"um-icon-social-windows-outline\";i:688;s:24:\"um-icon-social-wordpress\";i:689;s:32:\"um-icon-social-wordpress-outline\";i:690;s:20:\"um-icon-social-yahoo\";i:691;s:28:\"um-icon-social-yahoo-outline\";i:692;s:18:\"um-icon-social-yen\";i:693;s:26:\"um-icon-social-yen-outline\";i:694;s:22:\"um-icon-social-youtube\";i:695;s:30:\"um-icon-social-youtube-outline\";i:696;s:16:\"um-icon-soup-can\";i:697;s:24:\"um-icon-soup-can-outline\";i:698;s:20:\"um-icon-speakerphone\";i:699;s:19:\"um-icon-speedometer\";i:700;s:13:\"um-icon-spoon\";i:701;s:12:\"um-icon-star\";i:702;s:18:\"um-icon-stats-bars\";i:703;s:13:\"um-icon-steam\";i:704;s:12:\"um-icon-stop\";i:705;s:19:\"um-icon-thermometer\";i:706;s:18:\"um-icon-thumbsdown\";i:707;s:16:\"um-icon-thumbsup\";i:708;s:14:\"um-icon-toggle\";i:709;s:21:\"um-icon-toggle-filled\";i:710;s:19:\"um-icon-transgender\";i:711;s:15:\"um-icon-trash-a\";i:712;s:15:\"um-icon-trash-b\";i:713;s:14:\"um-icon-trophy\";i:714;s:14:\"um-icon-tshirt\";i:715;s:22:\"um-icon-tshirt-outline\";i:716;s:16:\"um-icon-umbrella\";i:717;s:18:\"um-icon-university\";i:718;s:16:\"um-icon-unlocked\";i:719;s:14:\"um-icon-upload\";i:720;s:11:\"um-icon-usb\";i:721;s:19:\"um-icon-videocamera\";i:722;s:19:\"um-icon-volume-high\";i:723;s:18:\"um-icon-volume-low\";i:724;s:21:\"um-icon-volume-medium\";i:725;s:19:\"um-icon-volume-mute\";i:726;s:12:\"um-icon-wand\";i:727;s:17:\"um-icon-waterdrop\";i:728;s:12:\"um-icon-wifi\";i:729;s:17:\"um-icon-wineglass\";i:730;s:13:\"um-icon-woman\";i:731;s:14:\"um-icon-wrench\";i:732;s:12:\"um-icon-xbox\";i:733;s:15:\"um-faicon-glass\";i:734;s:15:\"um-faicon-music\";i:735;s:16:\"um-faicon-search\";i:736;s:20:\"um-faicon-envelope-o\";i:737;s:15:\"um-faicon-heart\";i:738;s:14:\"um-faicon-star\";i:739;s:16:\"um-faicon-star-o\";i:740;s:14:\"um-faicon-user\";i:741;s:14:\"um-faicon-film\";i:742;s:18:\"um-faicon-th-large\";i:743;s:12:\"um-faicon-th\";i:744;s:17:\"um-faicon-th-list\";i:745;s:15:\"um-faicon-check\";i:746;s:15:\"um-faicon-times\";i:747;s:21:\"um-faicon-search-plus\";i:748;s:22:\"um-faicon-search-minus\";i:749;s:19:\"um-faicon-power-off\";i:750;s:16:\"um-faicon-signal\";i:751;s:13:\"um-faicon-cog\";i:752;s:17:\"um-faicon-trash-o\";i:753;s:14:\"um-faicon-home\";i:754;s:16:\"um-faicon-file-o\";i:755;s:17:\"um-faicon-clock-o\";i:756;s:14:\"um-faicon-road\";i:757;s:18:\"um-faicon-download\";i:758;s:29:\"um-faicon-arrow-circle-o-down\";i:759;s:27:\"um-faicon-arrow-circle-o-up\";i:760;s:15:\"um-faicon-inbox\";i:761;s:23:\"um-faicon-play-circle-o\";i:762;s:16:\"um-faicon-repeat\";i:763;s:17:\"um-faicon-refresh\";i:764;s:18:\"um-faicon-list-alt\";i:765;s:14:\"um-faicon-lock\";i:766;s:14:\"um-faicon-flag\";i:767;s:20:\"um-faicon-headphones\";i:768;s:20:\"um-faicon-volume-off\";i:769;s:21:\"um-faicon-volume-down\";i:770;s:19:\"um-faicon-volume-up\";i:771;s:16:\"um-faicon-qrcode\";i:772;s:17:\"um-faicon-barcode\";i:773;s:13:\"um-faicon-tag\";i:774;s:14:\"um-faicon-tags\";i:775;s:14:\"um-faicon-book\";i:776;s:18:\"um-faicon-bookmark\";i:777;s:15:\"um-faicon-print\";i:778;s:16:\"um-faicon-camera\";i:779;s:14:\"um-faicon-font\";i:780;s:14:\"um-faicon-bold\";i:781;s:16:\"um-faicon-italic\";i:782;s:21:\"um-faicon-text-height\";i:783;s:20:\"um-faicon-text-width\";i:784;s:20:\"um-faicon-align-left\";i:785;s:22:\"um-faicon-align-center\";i:786;s:21:\"um-faicon-align-right\";i:787;s:23:\"um-faicon-align-justify\";i:788;s:14:\"um-faicon-list\";i:789;s:17:\"um-faicon-outdent\";i:790;s:16:\"um-faicon-indent\";i:791;s:22:\"um-faicon-video-camera\";i:792;s:19:\"um-faicon-picture-o\";i:793;s:16:\"um-faicon-pencil\";i:794;s:20:\"um-faicon-map-marker\";i:795;s:16:\"um-faicon-adjust\";i:796;s:14:\"um-faicon-tint\";i:797;s:25:\"um-faicon-pencil-square-o\";i:798;s:24:\"um-faicon-share-square-o\";i:799;s:24:\"um-faicon-check-square-o\";i:800;s:16:\"um-faicon-arrows\";i:801;s:23:\"um-faicon-step-backward\";i:802;s:23:\"um-faicon-fast-backward\";i:803;s:18:\"um-faicon-backward\";i:804;s:14:\"um-faicon-play\";i:805;s:15:\"um-faicon-pause\";i:806;s:14:\"um-faicon-stop\";i:807;s:17:\"um-faicon-forward\";i:808;s:22:\"um-faicon-fast-forward\";i:809;s:22:\"um-faicon-step-forward\";i:810;s:15:\"um-faicon-eject\";i:811;s:22:\"um-faicon-chevron-left\";i:812;s:23:\"um-faicon-chevron-right\";i:813;s:21:\"um-faicon-plus-circle\";i:814;s:22:\"um-faicon-minus-circle\";i:815;s:22:\"um-faicon-times-circle\";i:816;s:22:\"um-faicon-check-circle\";i:817;s:25:\"um-faicon-question-circle\";i:818;s:21:\"um-faicon-info-circle\";i:819;s:20:\"um-faicon-crosshairs\";i:820;s:24:\"um-faicon-times-circle-o\";i:821;s:24:\"um-faicon-check-circle-o\";i:822;s:13:\"um-faicon-ban\";i:823;s:20:\"um-faicon-arrow-left\";i:824;s:21:\"um-faicon-arrow-right\";i:825;s:18:\"um-faicon-arrow-up\";i:826;s:20:\"um-faicon-arrow-down\";i:827;s:15:\"um-faicon-share\";i:828;s:16:\"um-faicon-expand\";i:829;s:18:\"um-faicon-compress\";i:830;s:14:\"um-faicon-plus\";i:831;s:15:\"um-faicon-minus\";i:832;s:18:\"um-faicon-asterisk\";i:833;s:28:\"um-faicon-exclamation-circle\";i:834;s:14:\"um-faicon-gift\";i:835;s:14:\"um-faicon-leaf\";i:836;s:14:\"um-faicon-fire\";i:837;s:13:\"um-faicon-eye\";i:838;s:19:\"um-faicon-eye-slash\";i:839;s:30:\"um-faicon-exclamation-triangle\";i:840;s:15:\"um-faicon-plane\";i:841;s:18:\"um-faicon-calendar\";i:842;s:16:\"um-faicon-random\";i:843;s:17:\"um-faicon-comment\";i:844;s:16:\"um-faicon-magnet\";i:845;s:20:\"um-faicon-chevron-up\";i:846;s:22:\"um-faicon-chevron-down\";i:847;s:17:\"um-faicon-retweet\";i:848;s:23:\"um-faicon-shopping-cart\";i:849;s:16:\"um-faicon-folder\";i:850;s:21:\"um-faicon-folder-open\";i:851;s:18:\"um-faicon-arrows-v\";i:852;s:18:\"um-faicon-arrows-h\";i:853;s:19:\"um-faicon-bar-chart\";i:854;s:24:\"um-faicon-twitter-square\";i:855;s:25:\"um-faicon-facebook-square\";i:856;s:22:\"um-faicon-camera-retro\";i:857;s:13:\"um-faicon-key\";i:858;s:14:\"um-faicon-cogs\";i:859;s:18:\"um-faicon-comments\";i:860;s:21:\"um-faicon-thumbs-o-up\";i:861;s:23:\"um-faicon-thumbs-o-down\";i:862;s:19:\"um-faicon-star-half\";i:863;s:17:\"um-faicon-heart-o\";i:864;s:18:\"um-faicon-sign-out\";i:865;s:25:\"um-faicon-linkedin-square\";i:866;s:20:\"um-faicon-thumb-tack\";i:867;s:23:\"um-faicon-external-link\";i:868;s:17:\"um-faicon-sign-in\";i:869;s:16:\"um-faicon-trophy\";i:870;s:23:\"um-faicon-github-square\";i:871;s:16:\"um-faicon-upload\";i:872;s:17:\"um-faicon-lemon-o\";i:873;s:15:\"um-faicon-phone\";i:874;s:18:\"um-faicon-square-o\";i:875;s:20:\"um-faicon-bookmark-o\";i:876;s:22:\"um-faicon-phone-square\";i:877;s:17:\"um-faicon-twitter\";i:878;s:18:\"um-faicon-facebook\";i:879;s:16:\"um-faicon-github\";i:880;s:16:\"um-faicon-unlock\";i:881;s:21:\"um-faicon-credit-card\";i:882;s:13:\"um-faicon-rss\";i:883;s:15:\"um-faicon-hdd-o\";i:884;s:18:\"um-faicon-bullhorn\";i:885;s:14:\"um-faicon-bell\";i:886;s:21:\"um-faicon-certificate\";i:887;s:22:\"um-faicon-hand-o-right\";i:888;s:21:\"um-faicon-hand-o-left\";i:889;s:19:\"um-faicon-hand-o-up\";i:890;s:21:\"um-faicon-hand-o-down\";i:891;s:27:\"um-faicon-arrow-circle-left\";i:892;s:28:\"um-faicon-arrow-circle-right\";i:893;s:25:\"um-faicon-arrow-circle-up\";i:894;s:27:\"um-faicon-arrow-circle-down\";i:895;s:15:\"um-faicon-globe\";i:896;s:16:\"um-faicon-wrench\";i:897;s:15:\"um-faicon-tasks\";i:898;s:16:\"um-faicon-filter\";i:899;s:19:\"um-faicon-briefcase\";i:900;s:20:\"um-faicon-arrows-alt\";i:901;s:15:\"um-faicon-users\";i:902;s:14:\"um-faicon-link\";i:903;s:15:\"um-faicon-cloud\";i:904;s:15:\"um-faicon-flask\";i:905;s:18:\"um-faicon-scissors\";i:906;s:17:\"um-faicon-files-o\";i:907;s:19:\"um-faicon-paperclip\";i:908;s:18:\"um-faicon-floppy-o\";i:909;s:16:\"um-faicon-square\";i:910;s:14:\"um-faicon-bars\";i:911;s:17:\"um-faicon-list-ul\";i:912;s:17:\"um-faicon-list-ol\";i:913;s:23:\"um-faicon-strikethrough\";i:914;s:19:\"um-faicon-underline\";i:915;s:15:\"um-faicon-table\";i:916;s:15:\"um-faicon-magic\";i:917;s:15:\"um-faicon-truck\";i:918;s:19:\"um-faicon-pinterest\";i:919;s:26:\"um-faicon-pinterest-square\";i:920;s:28:\"um-faicon-google-plus-square\";i:921;s:21:\"um-faicon-google-plus\";i:922;s:15:\"um-faicon-money\";i:923;s:20:\"um-faicon-caret-down\";i:924;s:18:\"um-faicon-caret-up\";i:925;s:20:\"um-faicon-caret-left\";i:926;s:21:\"um-faicon-caret-right\";i:927;s:17:\"um-faicon-columns\";i:928;s:14:\"um-faicon-sort\";i:929;s:19:\"um-faicon-sort-desc\";i:930;s:18:\"um-faicon-sort-asc\";i:931;s:18:\"um-faicon-envelope\";i:932;s:18:\"um-faicon-linkedin\";i:933;s:14:\"um-faicon-undo\";i:934;s:15:\"um-faicon-gavel\";i:935;s:20:\"um-faicon-tachometer\";i:936;s:19:\"um-faicon-comment-o\";i:937;s:20:\"um-faicon-comments-o\";i:938;s:14:\"um-faicon-bolt\";i:939;s:17:\"um-faicon-sitemap\";i:940;s:18:\"um-faicon-umbrella\";i:941;s:19:\"um-faicon-clipboard\";i:942;s:21:\"um-faicon-lightbulb-o\";i:943;s:18:\"um-faicon-exchange\";i:944;s:24:\"um-faicon-cloud-download\";i:945;s:22:\"um-faicon-cloud-upload\";i:946;s:17:\"um-faicon-user-md\";i:947;s:21:\"um-faicon-stethoscope\";i:948;s:18:\"um-faicon-suitcase\";i:949;s:16:\"um-faicon-bell-o\";i:950;s:16:\"um-faicon-coffee\";i:951;s:17:\"um-faicon-cutlery\";i:952;s:21:\"um-faicon-file-text-o\";i:953;s:20:\"um-faicon-building-o\";i:954;s:20:\"um-faicon-hospital-o\";i:955;s:19:\"um-faicon-ambulance\";i:956;s:16:\"um-faicon-medkit\";i:957;s:21:\"um-faicon-fighter-jet\";i:958;s:14:\"um-faicon-beer\";i:959;s:18:\"um-faicon-h-square\";i:960;s:21:\"um-faicon-plus-square\";i:961;s:27:\"um-faicon-angle-double-left\";i:962;s:28:\"um-faicon-angle-double-right\";i:963;s:25:\"um-faicon-angle-double-up\";i:964;s:27:\"um-faicon-angle-double-down\";i:965;s:20:\"um-faicon-angle-left\";i:966;s:21:\"um-faicon-angle-right\";i:967;s:18:\"um-faicon-angle-up\";i:968;s:20:\"um-faicon-angle-down\";i:969;s:17:\"um-faicon-desktop\";i:970;s:16:\"um-faicon-laptop\";i:971;s:16:\"um-faicon-tablet\";i:972;s:16:\"um-faicon-mobile\";i:973;s:18:\"um-faicon-circle-o\";i:974;s:20:\"um-faicon-quote-left\";i:975;s:21:\"um-faicon-quote-right\";i:976;s:17:\"um-faicon-spinner\";i:977;s:14:\"um-faicon-spin\";i:978;s:16:\"um-faicon-circle\";i:979;s:15:\"um-faicon-reply\";i:980;s:20:\"um-faicon-github-alt\";i:981;s:18:\"um-faicon-folder-o\";i:982;s:23:\"um-faicon-folder-open-o\";i:983;s:17:\"um-faicon-smile-o\";i:984;s:17:\"um-faicon-frown-o\";i:985;s:15:\"um-faicon-meh-o\";i:986;s:17:\"um-faicon-gamepad\";i:987;s:20:\"um-faicon-keyboard-o\";i:988;s:16:\"um-faicon-flag-o\";i:989;s:24:\"um-faicon-flag-checkered\";i:990;s:18:\"um-faicon-terminal\";i:991;s:14:\"um-faicon-code\";i:992;s:19:\"um-faicon-reply-all\";i:993;s:21:\"um-faicon-star-half-o\";i:994;s:24:\"um-faicon-location-arrow\";i:995;s:14:\"um-faicon-crop\";i:996;s:19:\"um-faicon-code-fork\";i:997;s:22:\"um-faicon-chain-broken\";i:998;s:18:\"um-faicon-question\";i:999;s:14:\"um-faicon-info\";i:1000;s:21:\"um-faicon-exclamation\";i:1001;s:21:\"um-faicon-superscript\";i:1002;s:19:\"um-faicon-subscript\";i:1003;s:16:\"um-faicon-eraser\";i:1004;s:22:\"um-faicon-puzzle-piece\";i:1005;s:20:\"um-faicon-microphone\";i:1006;s:26:\"um-faicon-microphone-slash\";i:1007;s:16:\"um-faicon-shield\";i:1008;s:20:\"um-faicon-calendar-o\";i:1009;s:27:\"um-faicon-fire-extinguisher\";i:1010;s:16:\"um-faicon-rocket\";i:1011;s:16:\"um-faicon-maxcdn\";i:1012;s:29:\"um-faicon-chevron-circle-left\";i:1013;s:30:\"um-faicon-chevron-circle-right\";i:1014;s:27:\"um-faicon-chevron-circle-up\";i:1015;s:29:\"um-faicon-chevron-circle-down\";i:1016;s:15:\"um-faicon-html5\";i:1017;s:14:\"um-faicon-css3\";i:1018;s:16:\"um-faicon-anchor\";i:1019;s:20:\"um-faicon-unlock-alt\";i:1020;s:18:\"um-faicon-bullseye\";i:1021;s:20:\"um-faicon-ellipsis-h\";i:1022;s:20:\"um-faicon-ellipsis-v\";i:1023;s:20:\"um-faicon-rss-square\";i:1024;s:21:\"um-faicon-play-circle\";i:1025;s:16:\"um-faicon-ticket\";i:1026;s:22:\"um-faicon-minus-square\";i:1027;s:24:\"um-faicon-minus-square-o\";i:1028;s:18:\"um-faicon-level-up\";i:1029;s:20:\"um-faicon-level-down\";i:1030;s:22:\"um-faicon-check-square\";i:1031;s:23:\"um-faicon-pencil-square\";i:1032;s:30:\"um-faicon-external-link-square\";i:1033;s:22:\"um-faicon-share-square\";i:1034;s:17:\"um-faicon-compass\";i:1035;s:29:\"um-faicon-caret-square-o-down\";i:1036;s:27:\"um-faicon-caret-square-o-up\";i:1037;s:30:\"um-faicon-caret-square-o-right\";i:1038;s:13:\"um-faicon-eur\";i:1039;s:13:\"um-faicon-gbp\";i:1040;s:13:\"um-faicon-usd\";i:1041;s:13:\"um-faicon-inr\";i:1042;s:13:\"um-faicon-jpy\";i:1043;s:13:\"um-faicon-rub\";i:1044;s:13:\"um-faicon-krw\";i:1045;s:13:\"um-faicon-btc\";i:1046;s:14:\"um-faicon-file\";i:1047;s:19:\"um-faicon-file-text\";i:1048;s:24:\"um-faicon-sort-alpha-asc\";i:1049;s:25:\"um-faicon-sort-alpha-desc\";i:1050;s:25:\"um-faicon-sort-amount-asc\";i:1051;s:26:\"um-faicon-sort-amount-desc\";i:1052;s:26:\"um-faicon-sort-numeric-asc\";i:1053;s:27:\"um-faicon-sort-numeric-desc\";i:1054;s:19:\"um-faicon-thumbs-up\";i:1055;s:21:\"um-faicon-thumbs-down\";i:1056;s:24:\"um-faicon-youtube-square\";i:1057;s:17:\"um-faicon-youtube\";i:1058;s:14:\"um-faicon-xing\";i:1059;s:21:\"um-faicon-xing-square\";i:1060;s:22:\"um-faicon-youtube-play\";i:1061;s:17:\"um-faicon-dropbox\";i:1062;s:24:\"um-faicon-stack-overflow\";i:1063;s:19:\"um-faicon-instagram\";i:1064;s:16:\"um-faicon-flickr\";i:1065;s:13:\"um-faicon-adn\";i:1066;s:19:\"um-faicon-bitbucket\";i:1067;s:26:\"um-faicon-bitbucket-square\";i:1068;s:16:\"um-faicon-tumblr\";i:1069;s:23:\"um-faicon-tumblr-square\";i:1070;s:25:\"um-faicon-long-arrow-down\";i:1071;s:23:\"um-faicon-long-arrow-up\";i:1072;s:25:\"um-faicon-long-arrow-left\";i:1073;s:26:\"um-faicon-long-arrow-right\";i:1074;s:15:\"um-faicon-apple\";i:1075;s:17:\"um-faicon-windows\";i:1076;s:17:\"um-faicon-android\";i:1077;s:15:\"um-faicon-linux\";i:1078;s:18:\"um-faicon-dribbble\";i:1079;s:15:\"um-faicon-skype\";i:1080;s:20:\"um-faicon-foursquare\";i:1081;s:16:\"um-faicon-trello\";i:1082;s:16:\"um-faicon-female\";i:1083;s:14:\"um-faicon-male\";i:1084;s:16:\"um-faicon-gittip\";i:1085;s:15:\"um-faicon-sun-o\";i:1086;s:16:\"um-faicon-moon-o\";i:1087;s:17:\"um-faicon-archive\";i:1088;s:13:\"um-faicon-bug\";i:1089;s:12:\"um-faicon-vk\";i:1090;s:15:\"um-faicon-weibo\";i:1091;s:16:\"um-faicon-renren\";i:1092;s:19:\"um-faicon-pagelines\";i:1093;s:24:\"um-faicon-stack-exchange\";i:1094;s:30:\"um-faicon-arrow-circle-o-right\";i:1095;s:29:\"um-faicon-arrow-circle-o-left\";i:1096;s:29:\"um-faicon-caret-square-o-left\";i:1097;s:22:\"um-faicon-dot-circle-o\";i:1098;s:20:\"um-faicon-wheelchair\";i:1099;s:22:\"um-faicon-vimeo-square\";i:1100;s:13:\"um-faicon-try\";i:1101;s:23:\"um-faicon-plus-square-o\";i:1102;s:23:\"um-faicon-space-shuttle\";i:1103;s:15:\"um-faicon-slack\";i:1104;s:25:\"um-faicon-envelope-square\";i:1105;s:19:\"um-faicon-wordpress\";i:1106;s:16:\"um-faicon-openid\";i:1107;s:20:\"um-faicon-university\";i:1108;s:24:\"um-faicon-graduation-cap\";i:1109;s:15:\"um-faicon-yahoo\";i:1110;s:16:\"um-faicon-google\";i:1111;s:16:\"um-faicon-reddit\";i:1112;s:23:\"um-faicon-reddit-square\";i:1113;s:28:\"um-faicon-stumbleupon-circle\";i:1114;s:21:\"um-faicon-stumbleupon\";i:1115;s:19:\"um-faicon-delicious\";i:1116;s:14:\"um-faicon-digg\";i:1117;s:20:\"um-faicon-pied-piper\";i:1118;s:24:\"um-faicon-pied-piper-alt\";i:1119;s:16:\"um-faicon-drupal\";i:1120;s:16:\"um-faicon-joomla\";i:1121;s:18:\"um-faicon-language\";i:1122;s:13:\"um-faicon-fax\";i:1123;s:18:\"um-faicon-building\";i:1124;s:15:\"um-faicon-child\";i:1125;s:13:\"um-faicon-paw\";i:1126;s:15:\"um-faicon-spoon\";i:1127;s:14:\"um-faicon-cube\";i:1128;s:15:\"um-faicon-cubes\";i:1129;s:17:\"um-faicon-behance\";i:1130;s:24:\"um-faicon-behance-square\";i:1131;s:15:\"um-faicon-steam\";i:1132;s:22:\"um-faicon-steam-square\";i:1133;s:17:\"um-faicon-recycle\";i:1134;s:13:\"um-faicon-car\";i:1135;s:14:\"um-faicon-taxi\";i:1136;s:14:\"um-faicon-tree\";i:1137;s:17:\"um-faicon-spotify\";i:1138;s:20:\"um-faicon-deviantart\";i:1139;s:20:\"um-faicon-soundcloud\";i:1140;s:18:\"um-faicon-database\";i:1141;s:20:\"um-faicon-file-pdf-o\";i:1142;s:21:\"um-faicon-file-word-o\";i:1143;s:22:\"um-faicon-file-excel-o\";i:1144;s:27:\"um-faicon-file-powerpoint-o\";i:1145;s:22:\"um-faicon-file-image-o\";i:1146;s:24:\"um-faicon-file-archive-o\";i:1147;s:22:\"um-faicon-file-audio-o\";i:1148;s:22:\"um-faicon-file-video-o\";i:1149;s:21:\"um-faicon-file-code-o\";i:1150;s:14:\"um-faicon-vine\";i:1151;s:17:\"um-faicon-codepen\";i:1152;s:18:\"um-faicon-jsfiddle\";i:1153;s:19:\"um-faicon-life-ring\";i:1154;s:24:\"um-faicon-circle-o-notch\";i:1155;s:15:\"um-faicon-rebel\";i:1156;s:16:\"um-faicon-empire\";i:1157;s:20:\"um-faicon-git-square\";i:1158;s:13:\"um-faicon-git\";i:1159;s:21:\"um-faicon-hacker-news\";i:1160;s:23:\"um-faicon-tencent-weibo\";i:1161;s:12:\"um-faicon-qq\";i:1162;s:16:\"um-faicon-weixin\";i:1163;s:21:\"um-faicon-paper-plane\";i:1164;s:23:\"um-faicon-paper-plane-o\";i:1165;s:17:\"um-faicon-history\";i:1166;s:21:\"um-faicon-circle-thin\";i:1167;s:16:\"um-faicon-header\";i:1168;s:19:\"um-faicon-paragraph\";i:1169;s:17:\"um-faicon-sliders\";i:1170;s:19:\"um-faicon-share-alt\";i:1171;s:26:\"um-faicon-share-alt-square\";i:1172;s:14:\"um-faicon-bomb\";i:1173;s:18:\"um-faicon-futbol-o\";i:1174;s:13:\"um-faicon-tty\";i:1175;s:20:\"um-faicon-binoculars\";i:1176;s:14:\"um-faicon-plug\";i:1177;s:20:\"um-faicon-slideshare\";i:1178;s:16:\"um-faicon-twitch\";i:1179;s:14:\"um-faicon-yelp\";i:1180;s:21:\"um-faicon-newspaper-o\";i:1181;s:14:\"um-faicon-wifi\";i:1182;s:20:\"um-faicon-calculator\";i:1183;s:16:\"um-faicon-paypal\";i:1184;s:23:\"um-faicon-google-wallet\";i:1185;s:17:\"um-faicon-cc-visa\";i:1186;s:23:\"um-faicon-cc-mastercard\";i:1187;s:21:\"um-faicon-cc-discover\";i:1188;s:17:\"um-faicon-cc-amex\";i:1189;s:19:\"um-faicon-cc-paypal\";i:1190;s:19:\"um-faicon-cc-stripe\";i:1191;s:20:\"um-faicon-bell-slash\";i:1192;s:22:\"um-faicon-bell-slash-o\";i:1193;s:15:\"um-faicon-trash\";i:1194;s:19:\"um-faicon-copyright\";i:1195;s:12:\"um-faicon-at\";i:1196;s:20:\"um-faicon-eyedropper\";i:1197;s:21:\"um-faicon-paint-brush\";i:1198;s:23:\"um-faicon-birthday-cake\";i:1199;s:20:\"um-faicon-area-chart\";i:1200;s:19:\"um-faicon-pie-chart\";i:1201;s:20:\"um-faicon-line-chart\";i:1202;s:16:\"um-faicon-lastfm\";i:1203;s:23:\"um-faicon-lastfm-square\";i:1204;s:20:\"um-faicon-toggle-off\";i:1205;s:19:\"um-faicon-toggle-on\";i:1206;s:17:\"um-faicon-bicycle\";i:1207;s:13:\"um-faicon-bus\";i:1208;s:17:\"um-faicon-ioxhost\";i:1209;s:19:\"um-faicon-angellist\";i:1210;s:12:\"um-faicon-cc\";i:1211;s:13:\"um-faicon-ils\";i:1212;s:18:\"um-faicon-meanpath\";i:1213;s:14:\"um-faicon-spin\";i:1214;s:14:\"um-faicon-spin\";i:1215;s:14:\"um-faicon-spin\";i:1216;s:14:\"um-faicon-spin\";i:1217;s:14:\"um-faicon-spin\";}", "yes");
INSERT INTO `act_options` VALUES("1994", "widget_um_search_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1995", "um_cached_role_admin", "a:15:{s:4:\"core\";s:5:\"admin\";s:18:\"can_access_wpadmin\";i:1;s:20:\"can_not_see_adminbar\";i:0;s:17:\"can_edit_everyone\";i:1;s:19:\"can_delete_everyone\";i:1;s:16:\"can_edit_profile\";i:1;s:18:\"can_delete_profile\";i:1;s:12:\"can_view_all\";i:1;s:24:\"can_make_private_profile\";i:1;s:26:\"can_access_private_profile\";i:1;s:16:\"default_homepage\";i:1;s:6:\"status\";s:8:\"approved\";s:16:\"auto_approve_act\";s:16:\"redirect_profile\";s:11:\"after_login\";s:14:\"redirect_admin\";s:12:\"after_logout\";s:13:\"redirect_home\";}", "yes");
INSERT INTO `act_options` VALUES("1996", "um_cache_userdata_1", "a:136:{s:2:\"ID\";i:1;s:10:\"user_login\";s:11:\"actjennifer\";s:9:\"user_pass\";s:34:\"$P$B3stafisQpvJxU1TKmK7K9sovuIkle1\";s:13:\"user_nicename\";s:11:\"actjennifer\";s:10:\"user_email\";s:30:\"absolutecomfortkenya@gmail.com\";s:8:\"user_url\";s:0:\"\";s:15:\"user_registered\";s:19:\"2017-05-30 21:16:38\";s:11:\"user_status\";s:1:\"0\";s:12:\"display_name\";s:11:\"actjennifer\";s:13:\"administrator\";b:1;s:15:\"membershipadmin\";b:1;s:24:\"membershipadmindashboard\";b:1;s:22:\"membershipadminmembers\";b:1;s:21:\"membershipadminlevels\";b:1;s:28:\"membershipadminsubscriptions\";b:1;s:22:\"membershipadmincoupons\";b:1;s:24:\"membershipadminpurchases\";b:1;s:29:\"membershipadmincommunications\";b:1;s:21:\"membershipadmingroups\";b:1;s:20:\"membershipadminpings\";b:1;s:23:\"membershipadmingateways\";b:1;s:22:\"membershipadminoptions\";b:1;s:32:\"membershipadminupdatepermissions\";b:1;s:8:\"wp_roles\";s:13:\"administrator\";s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:13:\"rc_management\";b:1;s:22:\"access_s2member_level0\";b:1;s:22:\"access_s2member_level1\";b:1;s:22:\"access_s2member_level2\";b:1;s:22:\"access_s2member_level3\";b:1;s:22:\"access_s2member_level4\";b:1;s:6:\"filter\";N;s:8:\"nickname\";s:11:\"actjennifer\";s:10:\"first_name\";s:0:\"\";s:9:\"last_name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"rich_editing\";s:4:\"true\";s:17:\"comment_shortcuts\";s:5:\"false\";s:11:\"admin_color\";s:5:\"fresh\";s:7:\"use_ssl\";s:1:\"0\";s:20:\"show_admin_bar_front\";s:4:\"true\";s:6:\"locale\";s:0:\"\";s:16:\"act_capabilities\";s:491:\"a:14:{s:13:\"administrator\";b:1;s:15:\"membershipadmin\";b:1;s:24:\"membershipadmindashboard\";b:1;s:22:\"membershipadminmembers\";b:1;s:21:\"membershipadminlevels\";b:1;s:28:\"membershipadminsubscriptions\";b:1;s:22:\"membershipadmincoupons\";b:1;s:24:\"membershipadminpurchases\";b:1;s:29:\"membershipadmincommunications\";b:1;s:21:\"membershipadmingroups\";b:1;s:20:\"membershipadminpings\";b:1;s:23:\"membershipadmingateways\";b:1;s:22:\"membershipadminoptions\";b:1;s:32:\"membershipadminupdatepermissions\";b:1;}\";s:14:\"act_user_level\";s:2:\"10\";s:18:\"show_welcome_panel\";s:1:\"1\";s:38:\"act_dashboard_quick_press_last_post_id\";s:3:\"459\";s:29:\"itsec_user_activity_last_seen\";s:10:\"1497475188\";s:28:\"_yoast_wpseo_profile_updated\";s:10:\"1497137663\";s:17:\"act_user-settings\";s:36:\"libraryContent=browse&editor=tinymce\";s:22:\"act_user-settings-time\";s:10:\"1497470458\";s:6:\"active\";s:1:\"1\";s:30:\"membership_permissions_updated\";s:3:\"yes\";s:10:\"googleplus\";s:0:\"\";s:7:\"twitter\";s:0:\"\";s:8:\"facebook\";s:0:\"\";s:14:\"ms_custom_data\";s:6:\"a:0:{}\";s:8:\"ms_email\";s:30:\"absolutecomfortkenya@gmail.com\";s:13:\"ms_first_name\";s:0:\"\";s:19:\"ms_gateway_profiles\";s:6:\"a:0:{}\";s:5:\"ms_id\";s:1:\"1\";s:12:\"ms_is_member\";s:1:\"1\";s:12:\"ms_last_name\";s:0:\"\";s:7:\"ms_name\";s:11:\"actjennifer\";s:16:\"ms_subscriptions\";s:6:\"a:0:{}\";s:11:\"ms_username\";s:11:\"actjennifer\";s:25:\"community-events-location\";s:24:\"a:1:{s:2:\"ip\";s:2:\"::\";}\";s:27:\"so_panels_directory_enabled\";s:1:\"1\";s:22:\"act_media_library_mode\";s:4:\"grid\";s:19:\"itsec-settings-view\";s:4:\"grid\";s:14:\"account_status\";s:8:\"approved\";s:19:\"account_status_name\";s:8:\"Approved\";s:4:\"core\";s:5:\"admin\";s:18:\"can_access_wpadmin\";i:1;s:20:\"can_not_see_adminbar\";i:0;s:17:\"can_edit_everyone\";i:1;s:19:\"can_delete_everyone\";i:1;s:16:\"can_edit_profile\";i:1;s:18:\"can_delete_profile\";i:1;s:12:\"can_view_all\";i:1;s:24:\"can_make_private_profile\";i:1;s:26:\"can_access_private_profile\";i:1;s:16:\"default_homepage\";i:1;s:6:\"status\";s:8:\"approved\";s:16:\"auto_approve_act\";s:16:\"redirect_profile\";s:11:\"after_login\";s:14:\"redirect_admin\";s:12:\"after_logout\";s:13:\"redirect_home\";s:11:\"super_admin\";i:1;}", "yes");
INSERT INTO `act_options` VALUES("1997", "__ultimatemember_sitekey", "localhost/actfinal-oUYNjLQucEkAX4h6sWEr", "yes");
INSERT INTO `act_options` VALUES("1998", "um_is_installed", "1", "yes");
INSERT INTO `act_options` VALUES("1999", "um_core_forms", "a:3:{i:464;i:464;i:465;i:465;i:466;i:466;}", "yes");
INSERT INTO `act_options` VALUES("2000", "um_core_directories", "a:1:{i:467;i:467;}", "yes");
INSERT INTO `act_options` VALUES("2001", "um_core_pages", "a:7:{s:4:\"user\";i:468;s:5:\"login\";i:470;s:8:\"register\";i:472;s:7:\"members\";i:474;s:6:\"logout\";i:476;s:7:\"account\";i:478;s:14:\"password-reset\";i:480;}", "yes");
INSERT INTO `act_options` VALUES("2002", "um_options", "a:201:{s:8:\"last_tab\";s:0:\"\";s:9:\"core_user\";s:3:\"468\";s:12:\"core_account\";s:3:\"478\";s:12:\"core_members\";s:3:\"474\";s:13:\"core_register\";s:3:\"472\";s:10:\"core_login\";s:3:\"470\";s:11:\"core_logout\";s:3:\"476\";s:19:\"core_password-reset\";s:3:\"480\";s:12:\"default_role\";s:6:\"member\";s:14:\"permalink_base\";s:10:\"user_login\";s:12:\"display_name\";s:9:\"full_name\";s:18:\"display_name_field\";s:0:\"\";s:29:\"force_display_name_capitlized\";s:1:\"1\";s:15:\"author_redirect\";s:1:\"0\";s:12:\"members_page\";s:1:\"0\";s:13:\"use_gravatars\";s:1:\"0\";s:37:\"use_um_gravatar_default_builtin_image\";s:7:\"default\";s:29:\"use_um_gravatar_default_image\";s:1:\"0\";s:24:\"reset_require_strongpass\";s:1:\"0\";s:33:\"editable_primary_email_in_profile\";s:1:\"0\";s:20:\"account_tab_password\";s:1:\"1\";s:19:\"account_tab_privacy\";s:1:\"1\";s:25:\"account_tab_notifications\";s:1:\"1\";s:18:\"account_tab_delete\";s:1:\"1\";s:19:\"delete_account_text\";s:150:\"Are you sure you want to delete your account? This will erase all of your account data from the site. To delete your account enter your password below\";s:12:\"account_name\";s:1:\"1\";s:20:\"account_name_disable\";s:1:\"0\";s:20:\"account_name_require\";s:1:\"1\";s:13:\"account_email\";s:1:\"1\";s:25:\"account_hide_in_directory\";s:1:\"1\";s:26:\"account_require_strongpass\";s:1:\"0\";s:9:\"panic_key\";s:10:\"e9cGbBXfPD\";s:10:\"accessible\";s:1:\"0\";s:15:\"access_redirect\";s:0:\"\";s:20:\"home_page_accessible\";s:1:\"1\";s:24:\"category_page_accessible\";s:1:\"1\";s:13:\"wpadmin_login\";s:1:\"0\";s:25:\"deny_admin_frontend_login\";s:1:\"0\";s:22:\"wpadmin_login_redirect\";s:13:\"um_login_page\";s:26:\"wpadmin_login_redirect_url\";s:0:\"\";s:16:\"wpadmin_register\";s:1:\"0\";s:25:\"wpadmin_register_redirect\";s:16:\"um_register_page\";s:29:\"wpadmin_register_redirect_url\";s:0:\"\";s:24:\"access_widget_admin_only\";s:1:\"1\";s:27:\"enable_reset_password_limit\";s:1:\"1\";s:27:\"reset_password_limit_number\";s:1:\"3\";s:34:\"disable_admin_reset_password_limit\";s:1:\"0\";s:17:\"wpadmin_allow_ips\";s:0:\"\";s:11:\"blocked_ips\";s:0:\"\";s:14:\"blocked_emails\";s:0:\"\";s:13:\"blocked_words\";s:47:\"admin\r\nadministrator\r\nwebmaster\r\nsupport\r\nstaff\";s:9:\"mail_from\";s:23:\"Absolute Comfort Travel\";s:14:\"mail_from_addr\";s:30:\"absolutecomfortkenya@gmail.com\";s:10:\"email_html\";s:1:\"0\";s:16:\"welcome_email_on\";s:1:\"1\";s:17:\"welcome_email_sub\";s:23:\"Welcome to {site_name}!\";s:13:\"welcome_email\";s:306:\"Hi {display_name},\r\n\r\nThank you for signing up with {site_name}! Your account is now active.\r\n\r\nTo login please visit the following url:\r\n\r\n{login_url}\r\n\r\nYour account e-mail: {email}\r\nYour account username: {username}\r\n\r\nIf you have any problems, please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:18:\"checkmail_email_on\";s:1:\"1\";s:19:\"checkmail_email_sub\";s:28:\"Please activate your account\";s:15:\"checkmail_email\";s:266:\"Hi {display_name},\r\n\r\nThank you for signing up with {site_name}! To activate your account, please click the link below to confirm your email address:\r\n\r\n{account_activation_link}\r\n\r\nIf you have any problems, please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:16:\"pending_email_on\";s:1:\"1\";s:17:\"pending_email_sub\";s:30:\"Your account is pending review\";s:13:\"pending_email\";s:272:\"Hi {display_name},\r\n\r\nThank you for signing up with {site_name}! Your account is currently being reviewed by a member of our team.\r\n\r\nPlease allow us some time to process your request.\r\n\r\nIf you have any problems, please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:17:\"approved_email_on\";s:1:\"1\";s:18:\"approved_email_sub\";s:41:\"Your account at {site_name} is now active\";s:14:\"approved_email\";s:378:\"Hi {display_name},\r\n\r\nThank you for signing up with {site_name}! Your account has been approved and is now active.\r\n\r\nTo login please visit the following url:\r\n\r\n{login_url}\r\n\r\nYour account e-mail: {email}\r\nYour account username: {username}\r\nSet your account password: {password_reset_link}\r\n\r\nIf you have any problems, please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:17:\"rejected_email_on\";s:1:\"1\";s:18:\"rejected_email_sub\";s:30:\"Your account has been rejected\";s:14:\"rejected_email\";s:260:\"Hi {display_name},\r\n\r\nThank you for applying for membership to {site_name}! We have reviewed your information and unfortunately we are unable to accept you as a member at this moment.\r\n\r\nPlease feel free to apply again at a future date.\r\n\r\nThanks,\r\n{site_name}\";s:17:\"inactive_email_on\";s:1:\"1\";s:18:\"inactive_email_sub\";s:33:\"Your account has been deactivated\";s:14:\"inactive_email\";s:222:\"Hi {display_name},\r\n\r\nThis is an automated email to let you know your {site_name} account has been deactivated.\r\n\r\nIf you would like your account to be reactivated please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:17:\"deletion_email_on\";s:1:\"1\";s:18:\"deletion_email_sub\";s:29:\"Your account has been deleted\";s:14:\"deletion_email\";s:332:\"Hi {display_name},\r\n\r\nThis is an automated email to let you know your {site_name} account has been deleted. All of your personal information has been permanently deleted and you will no longer be able to login to {site_name}.\r\n\r\nIf your account has been deleted by accident please contact us at {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:16:\"resetpw_email_on\";s:1:\"1\";s:17:\"resetpw_email_sub\";s:19:\"Reset your password\";s:13:\"resetpw_email\";s:266:\"Hi {display_name},\r\n\r\nWe received a request to reset the password for your account. If you made this request, click the link below to change your password:\r\n\r\n{password_reset_link}\r\n\r\nIf you didn\'t make this request, you can ignore this email\r\n\r\nThanks,\r\n{site_name}\";s:18:\"changedpw_email_on\";s:1:\"1\";s:19:\"changedpw_email_sub\";s:42:\"Your {site_name} password has been changed\";s:15:\"changedpw_email\";s:279:\"Hi {display_name},\r\n\r\nYou recently changed the password associated with your {site_name} account.\r\n\r\nIf you did not make this change and believe your {site_name} account has been compromised, please contact us at the following email address: {admin_email}\r\n\r\nThanks,\r\n{site_name}\";s:11:\"admin_email\";s:30:\"absolutecomfortkenya@gmail.com\";s:24:\"notification_new_user_on\";s:1:\"1\";s:25:\"notification_new_user_sub\";s:30:\"[{site_name}] New user account\";s:21:\"notification_new_user\";s:187:\"{display_name} has just created an account on {site_name}. To view their profile click here:\r\n\r\n{user_profile_link}\r\n\r\nHere is the submitted registration form:\r\n\r\n{submitted_registration}\";s:22:\"notification_review_on\";s:1:\"0\";s:23:\"notification_review_sub\";s:38:\"[{site_name}] New user awaiting review\";s:19:\"notification_review\";s:245:\"{display_name} has just applied for membership to {site_name} and is waiting to be reviewed.\r\n\r\nTo review this member please click the following link:\r\n\r\n{user_profile_link}\r\n\r\nHere is the submitted registration form:\r\n\r\n{submitted_registration}\";s:24:\"notification_deletion_on\";s:1:\"0\";s:25:\"notification_deletion_sub\";s:29:\"[{site_name}] Account deleted\";s:21:\"notification_deletion\";s:58:\"{display_name} has just deleted their {site_name} account.\";s:22:\"profile_photo_max_size\";s:0:\"\";s:20:\"cover_photo_max_size\";s:0:\"\";s:17:\"photo_thumb_sizes\";a:3:{i:0;s:2:\"40\";i:1;s:2:\"80\";i:2;s:3:\"190\";}s:17:\"cover_thumb_sizes\";a:2:{i:0;s:3:\"300\";i:1;s:3:\"600\";}s:17:\"image_compression\";s:2:\"60\";s:15:\"image_max_width\";s:4:\"1000\";s:15:\"cover_min_width\";s:4:\"1000\";s:13:\"profile_title\";s:40:\"{display_name} | Absolute Comfort Travel\";s:12:\"profile_desc\";s:83:\"{display_name} is on {site_name}. Join {site_name} to view {display_name}\'s profile\";s:18:\"directory_template\";s:7:\"members\";s:12:\"active_color\";s:7:\"#3ba1da\";s:15:\"secondary_color\";s:7:\"#44b0ec\";s:17:\"primary_btn_color\";s:7:\"#3ba1da\";s:17:\"primary_btn_hover\";s:7:\"#44b0ec\";s:16:\"primary_btn_text\";s:7:\"#ffffff\";s:19:\"secondary_btn_color\";s:7:\"#eeeeee\";s:19:\"secondary_btn_hover\";s:7:\"#e5e5e5\";s:18:\"secondary_btn_text\";s:7:\"#666666\";s:14:\"help_tip_color\";s:7:\"#cccccc\";s:16:\"form_field_label\";s:7:\"#555555\";s:11:\"form_border\";s:14:\"2px solid #ddd\";s:17:\"form_border_hover\";s:14:\"2px solid #bbb\";s:13:\"form_bg_color\";s:7:\"#ffffff\";s:19:\"form_bg_color_focus\";s:7:\"#ffffff\";s:15:\"form_text_color\";s:7:\"#666666\";s:16:\"form_placeholder\";s:7:\"#aaaaaa\";s:15:\"form_icon_color\";s:7:\"#aaaaaa\";s:13:\"form_asterisk\";s:1:\"0\";s:19:\"form_asterisk_color\";s:7:\"#aaaaaa\";s:16:\"profile_template\";s:7:\"profile\";s:17:\"profile_max_width\";s:6:\"1000px\";s:22:\"profile_area_max_width\";s:5:\"600px\";s:13:\"profile_align\";s:6:\"center\";s:13:\"profile_icons\";s:5:\"label\";s:24:\"profile_primary_btn_word\";s:14:\"Update Profile\";s:21:\"profile_secondary_btn\";s:1:\"1\";s:26:\"profile_secondary_btn_word\";s:6:\"Cancel\";s:12:\"profile_role\";s:1:\"0\";s:15:\"profile_main_bg\";s:0:\"\";s:17:\"profile_header_bg\";s:0:\"\";s:14:\"default_avatar\";a:5:{s:3:\"url\";s:90:\"http://localhost/actfinal/wp-content/plugins/ultimate-member/assets/img/default_avatar.jpg\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:13:\"default_cover\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:17:\"profile_photosize\";s:5:\"190px\";s:19:\"profile_photocorner\";s:1:\"1\";s:21:\"profile_cover_enabled\";s:1:\"1\";s:19:\"profile_cover_ratio\";s:5:\"2.7:1\";s:21:\"profile_show_metaicon\";s:1:\"0\";s:19:\"profile_header_text\";s:7:\"#999999\";s:25:\"profile_header_link_color\";s:7:\"#555555\";s:26:\"profile_header_link_hcolor\";s:7:\"#444444\";s:25:\"profile_header_icon_color\";s:7:\"#aaaaaa\";s:26:\"profile_header_icon_hcolor\";s:7:\"#3ba1da\";s:17:\"profile_show_name\";s:1:\"1\";s:25:\"profile_show_social_links\";s:1:\"0\";s:16:\"profile_show_bio\";s:1:\"1\";s:21:\"profile_show_html_bio\";s:0:\"\";s:20:\"profile_bio_maxchars\";s:3:\"180\";s:19:\"profile_header_menu\";s:2:\"bc\";s:18:\"profile_empty_text\";s:1:\"1\";s:22:\"profile_empty_text_emo\";s:1:\"1\";s:12:\"profile_menu\";s:1:\"1\";s:16:\"profile_tab_main\";s:1:\"1\";s:24:\"profile_tab_main_privacy\";s:1:\"0\";s:17:\"profile_tab_posts\";s:1:\"1\";s:25:\"profile_tab_posts_privacy\";s:1:\"0\";s:20:\"profile_tab_comments\";s:1:\"1\";s:28:\"profile_tab_comments_privacy\";s:1:\"0\";s:24:\"profile_menu_default_tab\";s:4:\"main\";s:18:\"profile_menu_icons\";s:1:\"1\";s:17:\"register_template\";s:8:\"register\";s:18:\"register_max_width\";s:5:\"450px\";s:14:\"register_align\";s:6:\"center\";s:14:\"register_icons\";s:5:\"label\";s:25:\"register_primary_btn_word\";s:8:\"Register\";s:22:\"register_secondary_btn\";s:1:\"1\";s:27:\"register_secondary_btn_word\";s:5:\"Login\";s:26:\"register_secondary_btn_url\";s:0:\"\";s:13:\"register_role\";s:1:\"0\";s:14:\"login_template\";s:5:\"login\";s:15:\"login_max_width\";s:5:\"450px\";s:11:\"login_align\";s:6:\"center\";s:11:\"login_icons\";s:5:\"label\";s:22:\"login_primary_btn_word\";s:5:\"Login\";s:19:\"login_secondary_btn\";s:1:\"1\";s:24:\"login_secondary_btn_word\";s:8:\"Register\";s:23:\"login_secondary_btn_url\";s:0:\"\";s:22:\"login_forgot_pass_link\";s:1:\"1\";s:21:\"login_show_rememberme\";s:1:\"1\";s:28:\"um_profile_object_cache_stop\";s:1:\"0\";s:13:\"um_flush_stop\";s:1:\"0\";s:29:\"um_generate_slug_in_directory\";s:1:\"0\";s:18:\"current_url_method\";s:11:\"SERVER_NAME\";s:22:\"um_port_forwarding_url\";s:1:\"0\";s:21:\"um_force_utf8_strings\";s:1:\"0\";s:14:\"enable_timebot\";s:1:\"1\";s:14:\"disable_minify\";s:1:\"0\";s:12:\"disable_menu\";s:1:\"0\";s:19:\"js_css_exlcude_home\";s:1:\"0\";s:17:\"enable_custom_css\";s:1:\"0\";s:14:\"allow_tracking\";s:1:\"0\";s:24:\"addon_bp_avatar_transfer\";s:0:\"\";s:23:\"addon_gravatar_transfer\";s:0:\"\";s:27:\"addon_generate_random_users\";s:0:\"\";s:17:\"addon_system_info\";s:0:\"\";s:19:\"access_exclude_uris\";a:0:{}s:22:\"profile_tab_main_roles\";s:0:\"\";s:23:\"profile_tab_posts_roles\";s:0:\"\";s:26:\"profile_tab_comments_roles\";s:0:\"\";s:14:\"js_css_exclude\";a:0:{}s:14:\"js_css_include\";a:0:{}}", "yes");
INSERT INTO `act_options` VALUES("2003", "um_first_setup_roles", "1", "yes");
INSERT INTO `act_options` VALUES("2004", "um_hashed_passwords_fix", "1", "yes");
INSERT INTO `act_options` VALUES("2006", "redux_version_upgraded_from", "3.6.2", "yes");
INSERT INTO `act_options` VALUES("2007", "_transient_timeout__redux_activation_redirect", "1497512047", "no");
INSERT INTO `act_options` VALUES("2008", "_transient__redux_activation_redirect", "1", "no");
INSERT INTO `act_options` VALUES("2010", "um_options-transients", "a:2:{s:14:\"changed_values\";a:2:{s:13:\"wpadmin_login\";s:1:\"1\";s:16:\"wpadmin_register\";s:1:\"1\";}s:9:\"last_save\";i:1497510489;}", "yes");
INSERT INTO `act_options` VALUES("2014", "_transient_timeout_feed_2b16a4f9a2b7110ce37a7c1a0e3bbb94", "1497553335", "no");
INSERT INTO `act_options` VALUES("2015", "_transient_feed_2b16a4f9a2b7110ce37a7c1a0e3bbb94", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:2:\"\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:17:\"\n	\n	\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Comments on: Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://ultimatemember.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"A Free Community & User Profile WordPress Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 14 Jun 2017 22:58:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=4.7.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:37:\"https://ultimatemember.com/blog/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:18:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 15 Jun 2017 07:02:12 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:14:\"content-length\";s:3:\"434\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:10:\"set-cookie\";s:44:\"PHPSESSID=l02uv7ceh2lch8b9q7a27jb8e6; path=/\";s:7:\"expires\";s:29:\"Thu, 19 Nov 1981 08:52:00 GMT\";s:13:\"cache-control\";s:70:\"no-store, no-cache, must-revalidate, post-check=0, pre-check=0, public\";s:6:\"pragma\";s:8:\"no-cache\";s:13:\"last-modified\";s:29:\"Wed, 14 Jun 2017 22:58:38 GMT\";s:4:\"etag\";s:34:\"\"39681cefbb36dd47074bb8193ccd3fd2\"\";s:15:\"x-ua-compatible\";s:7:\"IE=edge\";s:12:\"x-robots-tag\";s:15:\"noindex, follow\";s:4:\"link\";a:2:{i:0;s:63:\"<https://ultimatemember.com/wp-json/>; rel=\"https://api.w.org/\"\";i:1;s:50:\"<https://ultimatemember.com/?p=523>; rel=shortlink\";}s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:22:\"x-content-type-options\";s:7:\"nosniff\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:16:\"content-encoding\";s:4:\"gzip\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("2016", "_transient_timeout_feed_mod_2b16a4f9a2b7110ce37a7c1a0e3bbb94", "1497553336", "no");
INSERT INTO `act_options` VALUES("2017", "_transient_feed_mod_2b16a4f9a2b7110ce37a7c1a0e3bbb94", "1497510136", "no");
INSERT INTO `act_options` VALUES("2027", "um_existing_rows_465", "a:1:{i:0;s:9:\"_um_row_1\";}", "yes");
INSERT INTO `act_options` VALUES("2028", "um_form_rowdata_465", "a:1:{s:9:\"_um_row_1\";a:4:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"1\";s:4:\"cols\";s:1:\"1\";}}", "yes");
INSERT INTO `act_options` VALUES("2030", "um_existing_rows_484", "a:1:{i:0;s:9:\"_um_row_1\";}", "yes");
INSERT INTO `act_options` VALUES("2031", "um_form_rowdata_484", "a:1:{s:9:\"_um_row_1\";a:5:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"2\";s:4:\"cols\";s:3:\"2:1\";s:6:\"origin\";s:9:\"_um_row_1\";}}", "yes");
INSERT INTO `act_options` VALUES("2032", "um_fields", "a:1:{s:5:\"_name\";a:9:{s:4:\"type\";s:4:\"text\";s:5:\"title\";s:10:\"First Name\";s:7:\"metakey\";s:5:\"_name\";s:10:\"visibility\";s:3:\"all\";s:5:\"label\";s:10:\"First Name\";s:6:\"public\";s:2:\"-1\";s:8:\"required\";s:1:\"1\";s:8:\"editable\";s:1:\"1\";s:17:\"conditional_value\";s:1:\"0\";}}", "yes");
INSERT INTO `act_options` VALUES("2034", "um_cached_role_", "a:15:{s:4:\"core\";s:6:\"member\";s:18:\"can_access_wpadmin\";i:0;s:20:\"can_not_see_adminbar\";i:1;s:17:\"can_edit_everyone\";i:0;s:19:\"can_delete_everyone\";i:0;s:16:\"can_edit_profile\";i:1;s:18:\"can_delete_profile\";i:1;s:12:\"can_view_all\";i:1;s:24:\"can_make_private_profile\";i:0;s:26:\"can_access_private_profile\";i:0;s:16:\"default_homepage\";i:1;s:6:\"status\";s:8:\"approved\";s:16:\"auto_approve_act\";s:16:\"redirect_profile\";s:11:\"after_login\";s:16:\"redirect_profile\";s:12:\"after_logout\";s:13:\"redirect_home\";}", "yes");
INSERT INTO `act_options` VALUES("2040", "um_cached_users_queue", "0", "no");
INSERT INTO `act_options` VALUES("2069", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1497528342", "no");
INSERT INTO `act_options` VALUES("2070", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "O:8:\"stdClass\":100:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";i:4343;}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";i:2485;}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";i:2353;}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";i:2137;}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";i:1819;}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";i:1585;}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";i:1557;}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";i:1428;}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";i:1339;}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";i:1326;}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";i:1318;}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";i:1268;}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";i:1260;}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";i:1110;}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";i:1046;}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";i:1040;}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";i:985;}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";i:925;}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";i:814;}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";i:792;}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";i:791;}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";i:762;}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";i:759;}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";i:667;}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";i:658;}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";i:653;}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";i:650;}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";i:644;}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";i:635;}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";i:627;}s:6:\"slider\";a:3:{s:4:\"name\";s:6:\"slider\";s:4:\"slug\";s:6:\"slider\";s:5:\"count\";i:604;}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";i:592;}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"ajax\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";i:589;}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";i:580;}s:9:\"analytics\";a:3:{s:4:\"name\";s:9:\"analytics\";s:4:\"slug\";s:9:\"analytics\";s:5:\"count\";i:577;}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";i:570;}s:6:\"search\";a:3:{s:4:\"name\";s:6:\"search\";s:4:\"slug\";s:6:\"search\";s:5:\"count\";i:568;}s:10:\"e-commerce\";a:3:{s:4:\"name\";s:10:\"e-commerce\";s:4:\"slug\";s:10:\"e-commerce\";s:5:\"count\";i:554;}s:4:\"menu\";a:3:{s:4:\"name\";s:4:\"menu\";s:4:\"slug\";s:4:\"menu\";s:5:\"count\";i:551;}s:5:\"embed\";a:3:{s:4:\"name\";s:5:\"embed\";s:4:\"slug\";s:5:\"embed\";s:5:\"count\";i:538;}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";i:530;}s:4:\"form\";a:3:{s:4:\"name\";s:4:\"form\";s:4:\"slug\";s:4:\"form\";s:5:\"count\";i:524;}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";i:518;}s:3:\"css\";a:3:{s:4:\"name\";s:3:\"css\";s:4:\"slug\";s:3:\"css\";s:5:\"count\";i:506;}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";i:499;}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";i:491;}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";i:489;}s:5:\"theme\";a:3:{s:4:\"name\";s:5:\"theme\";s:4:\"slug\";s:5:\"theme\";s:5:\"count\";i:476;}s:6:\"custom\";a:3:{s:4:\"name\";s:6:\"custom\";s:4:\"slug\";s:6:\"custom\";s:5:\"count\";i:466;}s:10:\"responsive\";a:3:{s:4:\"name\";s:10:\"responsive\";s:4:\"slug\";s:10:\"responsive\";s:5:\"count\";i:464;}s:10:\"categories\";a:3:{s:4:\"name\";s:10:\"categories\";s:4:\"slug\";s:10:\"categories\";s:5:\"count\";i:463;}s:9:\"dashboard\";a:3:{s:4:\"name\";s:9:\"dashboard\";s:4:\"slug\";s:9:\"dashboard\";s:5:\"count\";i:463;}s:3:\"ads\";a:3:{s:4:\"name\";s:3:\"ads\";s:4:\"slug\";s:3:\"ads\";s:5:\"count\";i:441;}s:9:\"affiliate\";a:3:{s:4:\"name\";s:9:\"affiliate\";s:4:\"slug\";s:9:\"affiliate\";s:5:\"count\";i:435;}s:4:\"tags\";a:3:{s:4:\"name\";s:4:\"tags\";s:4:\"slug\";s:4:\"tags\";s:5:\"count\";i:434;}s:6:\"button\";a:3:{s:4:\"name\";s:6:\"button\";s:4:\"slug\";s:6:\"button\";s:5:\"count\";i:433;}s:6:\"editor\";a:3:{s:4:\"name\";s:6:\"editor\";s:4:\"slug\";s:6:\"editor\";s:5:\"count\";i:429;}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";i:420;}s:12:\"contact-form\";a:3:{s:4:\"name\";s:12:\"contact form\";s:4:\"slug\";s:12:\"contact-form\";s:5:\"count\";i:413;}s:4:\"user\";a:3:{s:4:\"name\";s:4:\"user\";s:4:\"slug\";s:4:\"user\";s:5:\"count\";i:409;}s:9:\"slideshow\";a:3:{s:4:\"name\";s:9:\"slideshow\";s:4:\"slug\";s:9:\"slideshow\";s:5:\"count\";i:405;}s:6:\"mobile\";a:3:{s:4:\"name\";s:6:\"mobile\";s:4:\"slug\";s:6:\"mobile\";s:5:\"count\";i:401;}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";i:399;}s:7:\"contact\";a:3:{s:4:\"name\";s:7:\"contact\";s:4:\"slug\";s:7:\"contact\";s:5:\"count\";i:397;}s:5:\"users\";a:3:{s:4:\"name\";s:5:\"users\";s:4:\"slug\";s:5:\"users\";s:5:\"count\";i:396;}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";i:394;}s:10:\"statistics\";a:3:{s:4:\"name\";s:10:\"statistics\";s:4:\"slug\";s:10:\"statistics\";s:5:\"count\";i:378;}s:3:\"api\";a:3:{s:4:\"name\";s:3:\"api\";s:4:\"slug\";s:3:\"api\";s:5:\"count\";i:375;}s:10:\"navigation\";a:3:{s:4:\"name\";s:10:\"navigation\";s:4:\"slug\";s:10:\"navigation\";s:5:\"count\";i:367;}s:6:\"events\";a:3:{s:4:\"name\";s:6:\"events\";s:4:\"slug\";s:6:\"events\";s:5:\"count\";i:366;}s:4:\"news\";a:3:{s:4:\"name\";s:4:\"news\";s:4:\"slug\";s:4:\"news\";s:5:\"count\";i:351;}s:8:\"calendar\";a:3:{s:4:\"name\";s:8:\"calendar\";s:4:\"slug\";s:8:\"calendar\";s:5:\"count\";i:337;}s:7:\"plugins\";a:3:{s:4:\"name\";s:7:\"plugins\";s:4:\"slug\";s:7:\"plugins\";s:5:\"count\";i:330;}s:12:\"social-media\";a:3:{s:4:\"name\";s:12:\"social media\";s:4:\"slug\";s:12:\"social-media\";s:5:\"count\";i:329;}s:9:\"multisite\";a:3:{s:4:\"name\";s:9:\"multisite\";s:4:\"slug\";s:9:\"multisite\";s:5:\"count\";i:329;}s:10:\"shortcodes\";a:3:{s:4:\"name\";s:10:\"shortcodes\";s:4:\"slug\";s:10:\"shortcodes\";s:5:\"count\";i:323;}s:4:\"code\";a:3:{s:4:\"name\";s:4:\"code\";s:4:\"slug\";s:4:\"code\";s:5:\"count\";i:321;}s:4:\"meta\";a:3:{s:4:\"name\";s:4:\"meta\";s:4:\"slug\";s:4:\"meta\";s:5:\"count\";i:320;}s:4:\"list\";a:3:{s:4:\"name\";s:4:\"list\";s:4:\"slug\";s:4:\"list\";s:5:\"count\";i:319;}s:7:\"payment\";a:3:{s:4:\"name\";s:7:\"payment\";s:4:\"slug\";s:7:\"payment\";s:5:\"count\";i:317;}s:10:\"newsletter\";a:3:{s:4:\"name\";s:10:\"newsletter\";s:4:\"slug\";s:10:\"newsletter\";s:5:\"count\";i:315;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"url\";s:4:\"slug\";s:3:\"url\";s:5:\"count\";i:314;}s:5:\"popup\";a:3:{s:4:\"name\";s:5:\"popup\";s:4:\"slug\";s:5:\"popup\";s:5:\"count\";i:303;}s:9:\"marketing\";a:3:{s:4:\"name\";s:9:\"marketing\";s:4:\"slug\";s:9:\"marketing\";s:5:\"count\";i:300;}s:6:\"simple\";a:3:{s:4:\"name\";s:6:\"simple\";s:4:\"slug\";s:6:\"simple\";s:5:\"count\";i:294;}s:3:\"tag\";a:3:{s:4:\"name\";s:3:\"tag\";s:4:\"slug\";s:3:\"tag\";s:5:\"count\";i:292;}s:16:\"custom-post-type\";a:3:{s:4:\"name\";s:16:\"custom post type\";s:4:\"slug\";s:16:\"custom-post-type\";s:5:\"count\";i:288;}s:4:\"chat\";a:3:{s:4:\"name\";s:4:\"chat\";s:4:\"slug\";s:4:\"chat\";s:5:\"count\";i:286;}s:8:\"redirect\";a:3:{s:4:\"name\";s:8:\"redirect\";s:4:\"slug\";s:8:\"redirect\";s:5:\"count\";i:286;}s:11:\"advertising\";a:3:{s:4:\"name\";s:11:\"advertising\";s:4:\"slug\";s:11:\"advertising\";s:5:\"count\";i:283;}s:6:\"author\";a:3:{s:4:\"name\";s:6:\"author\";s:4:\"slug\";s:6:\"author\";s:5:\"count\";i:278;}s:7:\"adsense\";a:3:{s:4:\"name\";s:7:\"adsense\";s:4:\"slug\";s:7:\"adsense\";s:5:\"count\";i:277;}s:8:\"lightbox\";a:3:{s:4:\"name\";s:8:\"lightbox\";s:4:\"slug\";s:8:\"lightbox\";s:5:\"count\";i:274;}s:4:\"html\";a:3:{s:4:\"name\";s:4:\"html\";s:4:\"slug\";s:4:\"html\";s:5:\"count\";i:274;}s:15:\"payment-gateway\";a:3:{s:4:\"name\";s:15:\"payment gateway\";s:4:\"slug\";s:15:\"payment-gateway\";s:5:\"count\";i:273;}s:5:\"forms\";a:3:{s:4:\"name\";s:5:\"forms\";s:4:\"slug\";s:5:\"forms\";s:5:\"count\";i:270;}s:14:\"administration\";a:3:{s:4:\"name\";s:14:\"administration\";s:4:\"slug\";s:14:\"administration\";s:5:\"count\";i:264;}s:7:\"captcha\";a:3:{s:4:\"name\";s:7:\"captcha\";s:4:\"slug\";s:7:\"captcha\";s:5:\"count\";i:262;}s:12:\"notification\";a:3:{s:4:\"name\";s:12:\"notification\";s:4:\"slug\";s:12:\"notification\";s:5:\"count\";i:262;}s:5:\"cache\";a:3:{s:4:\"name\";s:5:\"cache\";s:4:\"slug\";s:5:\"cache\";s:5:\"count\";i:261;}}", "no");
INSERT INTO `act_options` VALUES("2089", "pms_settings", "a:4:{s:7:\"general\";a:1:{s:11:\"use_pms_css\";i:1;}s:8:\"payments\";a:3:{s:8:\"currency\";s:3:\"USD\";s:16:\"active_pay_gates\";a:1:{i:0;s:15:\"paypal_standard\";}s:23:\"default_payment_gateway\";s:15:\"paypal_standard\";}s:8:\"messages\";a:2:{s:10:\"logged_out\";s:43:\"You must be logged in to view this content.\";s:11:\"non_members\";s:53:\"This content is restricted for your membership level.\";}s:6:\"emails\";a:10:{s:15:\"email-from-name\";s:23:\"Absolute Comfort Travel\";s:16:\"email-from-email\";s:30:\"absolutecomfortkenya@gmail.com\";s:20:\"register_sub_subject\";s:22:\"You have a new account\";s:20:\"activate_sub_subject\";s:31:\"Your Subscription is now active\";s:18:\"cancel_sub_subject\";s:35:\"Your Subscription has been canceled\";s:19:\"expired_sub_subject\";s:29:\"Your Subscription has expired\";s:12:\"register_sub\";s:75:\"Congratulations {{display_name}}! You have successfully created an account!\";s:12:\"activate_sub\";s:99:\"Congratulations {{display_name}}! The \"{{subscription_name}}\" plan has been successfully activated.\";s:10:\"cancel_sub\";s:75:\"Hello {{display_name}}, The \"{{subscription_name}}\" plan has been canceled.\";s:11:\"expired_sub\";s:68:\"Hello {{display_name}},The \"{{subscription_name}}\" plan has expired.\";}}", "yes");
INSERT INTO `act_options` VALUES("2090", "pms_version", "1.4.5", "yes");
INSERT INTO `act_options` VALUES("2098", "wpmembers_settings", "a:19:{s:7:\"version\";s:7:\"3.1.8.1\";s:6:\"notify\";s:1:\"1\";s:7:\"mod_reg\";i:0;s:7:\"captcha\";s:1:\"2\";s:7:\"use_exp\";i:0;s:9:\"use_trial\";i:0;s:8:\"warnings\";i:0;s:10:\"user_pages\";a:3:{s:7:\"profile\";s:3:\"510\";s:8:\"register\";s:3:\"508\";s:5:\"login\";s:3:\"506\";}s:6:\"cssurl\";s:80:\"http://localhost/actfinal/wp-content/plugins/wp-members/css/generic-no-float.css\";s:5:\"style\";s:80:\"http://localhost/actfinal/wp-content/plugins/wp-members/css/generic-no-float.css\";s:6:\"attrib\";i:0;s:10:\"post_types\";a:0:{}s:9:\"form_tags\";a:1:{s:7:\"default\";s:20:\"Registration Default\";}s:5:\"email\";a:2:{s:4:\"from\";s:0:\"\";s:9:\"from_name\";s:0:\"\";}s:5:\"block\";a:2:{s:4:\"post\";s:1:\"1\";s:4:\"page\";s:1:\"0\";}s:12:\"show_excerpt\";a:2:{s:4:\"post\";i:0;s:4:\"page\";i:0;}s:10:\"show_login\";a:2:{s:4:\"post\";s:1:\"1\";s:4:\"page\";s:1:\"1\";}s:8:\"show_reg\";a:2:{s:4:\"post\";s:1:\"1\";s:4:\"page\";s:1:\"1\";}s:6:\"autoex\";a:2:{s:4:\"post\";a:3:{s:7:\"enabled\";i:0;s:6:\"length\";i:0;s:4:\"text\";s:0:\"\";}s:4:\"page\";a:3:{s:7:\"enabled\";i:0;s:6:\"length\";i:0;s:4:\"text\";s:0:\"\";}}}", "yes");
INSERT INTO `act_options` VALUES("2099", "wpmembers_fields", "a:18:{i:0;a:7:{i:0;i:1;i:1;s:10:\"First Name\";i:2;s:10:\"first_name\";i:3;s:4:\"text\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"y\";}i:1;a:7:{i:0;i:2;i:1;s:9:\"Last Name\";i:2;s:9:\"last_name\";i:3;s:4:\"text\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"y\";}i:2;a:10:{i:0;s:2:\"17\";i:1;s:12:\"Company Name\";i:2;s:10:\"thecompany\";i:3;s:4:\"text\";i:4;s:1:\"y\";i:5;s:0:\"\";i:6;s:1:\"n\";s:11:\"placeholder\";s:35:\"for business/corporate registration\";s:7:\"pattern\";s:0:\"\";s:5:\"title\";s:0:\"\";}i:3;a:10:{i:0;i:5;i:1;s:30:\"Location of Company / Business\";i:2;s:4:\"city\";i:3;s:4:\"text\";i:4;s:1:\"y\";i:5;s:0:\"\";i:6;s:1:\"n\";s:11:\"placeholder\";s:35:\"for business/corporate registration\";s:7:\"pattern\";s:0:\"\";s:5:\"title\";s:0:\"\";}i:4;a:12:{i:0;s:2:\"18\";i:1;s:16:\"Telephone Number\";i:2;s:8:\"thephone\";i:3;s:6:\"number\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"n\";s:11:\"placeholder\";s:0:\"\";s:7:\"pattern\";s:0:\"\";s:5:\"title\";s:0:\"\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";}i:5;a:7:{i:0;i:10;i:1;s:5:\"Email\";i:2;s:10:\"user_email\";i:3;s:5:\"email\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"y\";}i:6;a:7:{i:0;i:14;i:1;s:8:\"Password\";i:2;s:8:\"password\";i:3;s:8:\"password\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"n\";}i:7;a:7:{i:0;i:15;i:1;s:16:\"Confirm Password\";i:2;s:16:\"confirm_password\";i:3;s:8:\"password\";i:4;s:1:\"y\";i:5;s:1:\"y\";i:6;s:1:\"n\";}i:8;a:7:{i:0;i:3;i:1;s:9:\"Address 1\";i:2;s:5:\"addr1\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:9;a:7:{i:0;i:4;i:1;s:9:\"Address 2\";i:2;s:5:\"addr2\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:10;a:7:{i:0;i:6;i:1;s:5:\"State\";i:2;s:8:\"thestate\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:11;a:7:{i:0;i:7;i:1;s:3:\"Zip\";i:2;s:3:\"zip\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:12;a:7:{i:0;i:8;i:1;s:7:\"Country\";i:2;s:7:\"country\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:13;a:7:{i:0;i:9;i:1;s:9:\"Day Phone\";i:2;s:6:\"phone1\";i:3;s:4:\"text\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:14;a:7:{i:0;i:11;i:1;s:13:\"Confirm Email\";i:2;s:13:\"confirm_email\";i:3;s:5:\"email\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";}i:15;a:7:{i:0;i:12;i:1;s:7:\"Website\";i:2;s:8:\"user_url\";i:3;s:3:\"url\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"y\";}i:16;a:7:{i:0;i:13;i:1;s:17:\"Biographical Info\";i:2;s:11:\"description\";i:3;s:8:\"textarea\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"y\";}i:17;a:9:{i:0;i:16;i:1;s:3:\"TOS\";i:2;s:3:\"tos\";i:3;s:8:\"checkbox\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:1:\"n\";i:7;s:5:\"agree\";i:8;s:1:\"n\";}}", "yes");
INSERT INTO `act_options` VALUES("2100", "wpmembers_tos", "Put your TOS (Terms of Service) text here.  You can use HTML markup.", "yes");
INSERT INTO `act_options` VALUES("2101", "wpmembers_dialogs", "a:9:{s:14:\"restricted_msg\";s:119:\"This content is restricted to site members.  If you are an existing user, please log in.  New users may register below.\";s:4:\"user\";s:50:\"Sorry, that username is taken, please try another.\";s:5:\"email\";s:74:\"Sorry, that email address already has an account.<br />Please try another.\";s:7:\"success\";s:124:\"Congratulations! Your registration was successful.<br /><br />You may now log in using the password that was emailed to you.\";s:11:\"editsuccess\";s:29:\"Your information was updated!\";s:11:\"pwdchangerr\";s:53:\"Passwords did not match.<br /><br />Please try again.\";s:16:\"pwdchangesuccess\";s:30:\"Password successfully changed!\";s:11:\"pwdreseterr\";s:65:\"Either the username or email address do not exist in our records.\";s:15:\"pwdresetsuccess\";s:135:\"Password successfully reset!<br /><br />An email containing a new password has been sent to the email address on file for your account.\";}", "yes");
INSERT INTO `act_options` VALUES("2102", "wpmembers_email_newreg", "a:2:{s:4:\"subj\";s:37:\"Your registration info for [blogname]\";s:4:\"body\";s:269:\"Thank you for registering for [blogname]\r\n\r\nYour registration information is below.\r\nYou may wish to retain a copy for your records.\r\n\r\nusername: [username]\r\npassword: [password]\r\n\r\nYou may log in here:\r\n[reglink]\r\n\r\nYou may change your password here:\r\n[user-profile]\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2103", "wpmembers_email_newmod", "a:2:{s:4:\"subj\";s:40:\"Thank you for registering for [blogname]\";s:4:\"body\";s:173:\"Thank you for registering for [blogname]. \r\nYour registration has been received and is pending approval.\r\nYou will receive login instructions upon approval of your account\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2104", "wpmembers_email_appmod", "a:2:{s:4:\"subj\";s:50:\"Your registration for [blogname] has been approved\";s:4:\"body\";s:300:\"Your registration for [blogname] has been approved.\r\n\r\nYour registration information is below.\r\nYou may wish to retain a copy for your records.\r\n\r\nusername: [username]\r\npassword: [password]\r\n\r\nYou may log in and change your password here:\r\n[user-profile]\r\n\r\nYou originally registered at:\r\n[reglink]\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2105", "wpmembers_email_repass", "a:2:{s:4:\"subj\";s:34:\"Your password reset for [blogname]\";s:4:\"body\";s:157:\"Your password for [blogname] has been reset\r\n\r\nYour new password is included below. You may wish to retain a copy for your records.\r\n\r\npassword: [password]\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2106", "wpmembers_email_notify", "a:2:{s:4:\"subj\";s:36:\"New user registration for [blogname]\";s:4:\"body\";s:194:\"The following user registered for [blogname]:\r\n\r\nusername: [username]\r\nemail: [email]\r\n\r\n[fields]\r\nThis user registered here:\r\n[reglink]\r\n\r\nuser IP: [user-ip]\r\n\r\nactivate user: [activate-user]\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2107", "wpmembers_email_footer", "----------------------------------\r\nThis is an automated message from [blogname]\r\nPlease do not reply to this address", "no");
INSERT INTO `act_options` VALUES("2108", "wpmembers_email_getuser", "a:2:{s:4:\"subj\";s:23:\"Username for [blogname]\";s:4:\"body\";s:64:\"Your username for [blogname] is below.\r\n\r\nusername: [username]\r\n\";}", "no");
INSERT INTO `act_options` VALUES("2109", "wpmembers_style", "http://localhost/actfinal/wp-content/plugins/wp-members/css/generic-no-float.css", "yes");
INSERT INTO `act_options` VALUES("2111", "_transient_timeout_feed_5a25458da46a336967a55e430a3eace5", "1497563322", "no");
INSERT INTO `act_options` VALUES("2112", "_transient_feed_5a25458da46a336967a55e430a3eace5", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:34:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"RocketGeek Interactive\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://rocketgeek.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"Home of WP-Members, The Original WordPress Membership Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 12 Jun 2017 18:31:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://wordpress.org/?v=4.8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:5:{i:0;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"Restrict registration to specific email domains, IPs, or other data\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://rocketgeek.com/tips-and-tricks/restrict-registration-to-specific-email-domains-ips-or-other-data/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Jun 2017 15:52:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:15:\"Tips and Tricks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"explode\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"in_array\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:6:\"substr\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:23:\"wpmem_pre_register_data\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://rocketgeek.com/?p=13104\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:383:\"WP-Members allows for customizing to restrict registration based on the user&#8217;s information.  Often people ask how they might restrict registration based on the user&#8217;s email address, IP address, or some other data point.  This article covers some different approaches to that. It should be noted that this only applies to WP-Members registration. It has become [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"Create a “free” category for all registered users when using the PayPal Subscriptions extension\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"http://rocketgeek.com/tips-and-tricks/create-a-free-category-for-all-registered-users-when-using-the-paypal-subscriptions-extension/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 13:30:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:15:\"Tips and Tricks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"in_category\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:6:\"paypal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://rocketgeek.com/?p=13087\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:350:\"When using the PayPal extension, any blocked content will require the user to have a valid and current subscription with an expiration date in the future.  Otherwise, when viewing content, it would ordinarily be replaced by a message indicating they either have not completed payment or that their subscription has expired and they need to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:27:\"\n		\n		\n		\n		\n				\n\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WP-Members 3.1.8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://rocketgeek.com/release-announcements/wp-members-3-1-8/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 31 May 2017 13:00:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Release Announcements\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://rocketgeek.com/?p=12917\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:507:\"<br />\n<b>Warning</b>:  Illegal string offset \'field\' in <b>/home/cbjr87/rocketgeek.com/wp/wp-content/plugins/wp-members/inc/shortcodes.php</b> on line <b>466</b><br />\nWP-Members 3.1.8 is complete and is now available for upgrading. Here is what&#8217;s in store for you in this new release:   New Fields Tab This release rebuilds the form fields tab to manage registration/profile fields.  On a technical level, it was rebuilt to utilize WP&#8217;s list table class, so the table and bulk menu [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n		\n		\n		\n		\n				\n		\n\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"WP-Members and WooCommerce 3.0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://rocketgeek.com/blog/wp-members-and-woocommerce-3-0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Apr 2017 14:46:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"woocommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://rocketgeek.com/?p=12781\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:386:\"WooCommerce 3.0 makes some changes to its API that affect users who use WP-Members for additional WC registration fields.   WP-Members adds fields to the native WordPress registration using the WP action hook `register_form`. This action hook was also part of the WooCommerce registration form. In previous versions WC used its own hook, `woocommerce_register_form`, followed [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:27:\"\n		\n		\n		\n		\n				\n\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Recently Viewed Pages Shortcode\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://rocketgeek.com/tips-and-tricks/recently-viewed-pages-shortcode/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Apr 2017 18:50:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Tips and Tricks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://rocketgeek.com/?p=12726\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:323:\"This article gives you code and instructions to create a custom shortcode that can be used with the WP-Members User Tracking extension. It will display the last X number of pages the user visited. This can be useful for creating user dashboards on the User Profile shortcode page.  (You can see an example of how [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:27:\"http://rocketgeek.com/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:6:{s:4:\"date\";s:29:\"Thu, 15 Jun 2017 09:48:38 GMT\";s:6:\"server\";s:6:\"Apache\";s:4:\"etag\";s:34:\"\"28c3f92cc05eb5a218d3dc0865997427\"\";s:4:\"link\";s:58:\"<http://rocketgeek.com/wp-json/>; rel=\"https://api.w.org/\"\";s:13:\"last-modified\";s:29:\"Mon, 12 Jun 2017 18:31:51 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("2113", "_transient_timeout_feed_mod_5a25458da46a336967a55e430a3eace5", "1497563322", "no");
INSERT INTO `act_options` VALUES("2114", "_transient_feed_mod_5a25458da46a336967a55e430a3eace5", "1497520122", "no");
INSERT INTO `act_options` VALUES("2115", "_site_transient_timeout_available_translations", "1497530972", "no");
INSERT INTO `act_options` VALUES("2116", "_site_transient_available_translations", "a:108:{s:2:\"af\";a:8:{s:8:\"language\";s:2:\"af\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-05 12:49:21\";s:12:\"english_name\";s:9:\"Afrikaans\";s:11:\"native_name\";s:9:\"Afrikaans\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/af.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"af\";i:2;s:3:\"afr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Gaan voort\";}}s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-13 02:18:05\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:3:\"ary\";a:8:{s:8:\"language\";s:3:\"ary\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:42:35\";s:12:\"english_name\";s:15:\"Moroccan Arabic\";s:11:\"native_name\";s:31:\"العربية المغربية\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.5/ary.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:3;s:3:\"ary\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"as\";a:8:{s:8:\"language\";s:2:\"as\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-22 18:59:07\";s:12:\"english_name\";s:8:\"Assamese\";s:11:\"native_name\";s:21:\"অসমীয়া\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/as.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"as\";i:2;s:3:\"asm\";i:3;s:3:\"asm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:0:\"\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-06 00:09:27\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:3:\"azb\";a:8:{s:8:\"language\";s:3:\"azb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-12 20:34:31\";s:12:\"english_name\";s:17:\"South Azerbaijani\";s:11:\"native_name\";s:29:\"گؤنئی آذربایجان\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/azb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:3;s:3:\"azb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:3:\"bel\";a:8:{s:8:\"language\";s:3:\"bel\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-12 20:04:05\";s:12:\"english_name\";s:10:\"Belarusian\";s:11:\"native_name\";s:29:\"Беларуская мова\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/translation/core/4.8/bel.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"be\";i:2;s:3:\"bel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Працягнуць\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-09 17:15:08\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Напред\";}}s:5:\"bn_BD\";a:8:{s:8:\"language\";s:5:\"bn_BD\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-04 16:58:43\";s:12:\"english_name\";s:7:\"Bengali\";s:11:\"native_name\";s:15:\"বাংলা\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/bn_BD.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"bn\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:23:\"এগিয়ে চল.\";}}s:2:\"bo\";a:8:{s:8:\"language\";s:2:\"bo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-05 09:44:12\";s:12:\"english_name\";s:7:\"Tibetan\";s:11:\"native_name\";s:21:\"བོད་ཡིག\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/bo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bo\";i:2;s:3:\"tib\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:24:\"མུ་མཐུད།\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-04 20:20:28\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-10 11:37:00\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:3:\"ceb\";a:8:{s:8:\"language\";s:3:\"ceb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-02 17:25:51\";s:12:\"english_name\";s:7:\"Cebuano\";s:11:\"native_name\";s:7:\"Cebuano\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/ceb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"ceb\";i:3;s:3:\"ceb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Padayun\";}}s:5:\"cs_CZ\";a:8:{s:8:\"language\";s:5:\"cs_CZ\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-12 08:46:26\";s:12:\"english_name\";s:5:\"Czech\";s:11:\"native_name\";s:12:\"Čeština‎\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/cs_CZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cs\";i:2;s:3:\"ces\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Pokračovat\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 13:21:24\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 23:24:44\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsæt\";}}s:5:\"de_CH\";a:8:{s:8:\"language\";s:5:\"de_CH\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 08:45:09\";s:12:\"english_name\";s:20:\"German (Switzerland)\";s:11:\"native_name\";s:17:\"Deutsch (Schweiz)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/de_CH.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:14:\"de_CH_informal\";a:8:{s:8:\"language\";s:14:\"de_CH_informal\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 08:50:23\";s:12:\"english_name\";s:30:\"German (Switzerland, Informal)\";s:11:\"native_name\";s:21:\"Deutsch (Schweiz, Du)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/4.8/de_CH_informal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:12:\"de_DE_formal\";a:8:{s:8:\"language\";s:12:\"de_DE_formal\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 00:09:35\";s:12:\"english_name\";s:15:\"German (Formal)\";s:11:\"native_name\";s:13:\"Deutsch (Sie)\";s:7:\"package\";s:69:\"https://downloads.wordpress.org/translation/core/4.8/de_DE_formal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 00:09:17\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:3:\"dzo\";a:8:{s:8:\"language\";s:3:\"dzo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-06-29 08:59:03\";s:12:\"english_name\";s:8:\"Dzongkha\";s:11:\"native_name\";s:18:\"རྫོང་ཁ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/dzo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"dz\";i:2;s:3:\"dzo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:0:\"\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-12 07:31:13\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 07:18:00\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-05 00:53:46\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_ZA\";a:8:{s:8:\"language\";s:5:\"en_ZA\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:53:43\";s:12:\"english_name\";s:22:\"English (South Africa)\";s:11:\"native_name\";s:22:\"English (South Africa)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/en_ZA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_NZ\";a:8:{s:8:\"language\";s:5:\"en_NZ\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 06:27:23\";s:12:\"english_name\";s:21:\"English (New Zealand)\";s:11:\"native_name\";s:21:\"English (New Zealand)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/en_NZ.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 05:14:35\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-04 17:21:42\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 11:35:29\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/es_ES.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"es\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_MX\";a:8:{s:8:\"language\";s:5:\"es_MX\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-13 08:16:03\";s:12:\"english_name\";s:16:\"Spanish (Mexico)\";s:11:\"native_name\";s:19:\"Español de México\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/es_MX.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_AR\";a:8:{s:8:\"language\";s:5:\"es_AR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-12 07:30:32\";s:12:\"english_name\";s:19:\"Spanish (Argentina)\";s:11:\"native_name\";s:21:\"Español de Argentina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/es_AR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_GT\";a:8:{s:8:\"language\";s:5:\"es_GT\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:54:37\";s:12:\"english_name\";s:19:\"Spanish (Guatemala)\";s:11:\"native_name\";s:21:\"Español de Guatemala\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/es_GT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CO\";a:8:{s:8:\"language\";s:5:\"es_CO\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:54:37\";s:12:\"english_name\";s:18:\"Spanish (Colombia)\";s:11:\"native_name\";s:20:\"Español de Colombia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/es_CO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_VE\";a:8:{s:8:\"language\";s:5:\"es_VE\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-04-23 23:02:31\";s:12:\"english_name\";s:19:\"Spanish (Venezuela)\";s:11:\"native_name\";s:21:\"Español de Venezuela\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/es_VE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-28 20:09:49\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/es_CL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-09 09:36:22\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/es_PE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"et\";a:8:{s:8:\"language\";s:2:\"et\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 16:37:11\";s:12:\"english_name\";s:8:\"Estonian\";s:11:\"native_name\";s:5:\"Eesti\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/et.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"et\";i:2;s:3:\"est\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Jätka\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 21:40:39\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-09 15:50:45\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 18:25:22\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_BE\";a:8:{s:8:\"language\";s:5:\"fr_BE\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 08:58:29\";s:12:\"english_name\";s:16:\"French (Belgium)\";s:11:\"native_name\";s:21:\"Français de Belgique\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/fr_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 06:56:04\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_CA\";a:8:{s:8:\"language\";s:5:\"fr_CA\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 08:47:21\";s:12:\"english_name\";s:15:\"French (Canada)\";s:11:\"native_name\";s:19:\"Français du Canada\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/fr_CA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-08-23 17:41:37\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 21:41:28\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"gu\";a:8:{s:8:\"language\";s:2:\"gu\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 12:07:46\";s:12:\"english_name\";s:8:\"Gujarati\";s:11:\"native_name\";s:21:\"ગુજરાતી\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/gu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gu\";i:2;s:3:\"guj\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:31:\"ચાલુ રાખવું\";}}s:3:\"haz\";a:8:{s:8:\"language\";s:3:\"haz\";s:7:\"version\";s:5:\"4.4.2\";s:7:\"updated\";s:19:\"2015-12-05 00:59:09\";s:12:\"english_name\";s:8:\"Hazaragi\";s:11:\"native_name\";s:15:\"هزاره گی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.4.2/haz.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"haz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 19:41:37\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"המשך\";}}s:5:\"hi_IN\";a:8:{s:8:\"language\";s:5:\"hi_IN\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-10 20:08:33\";s:12:\"english_name\";s:5:\"Hindi\";s:11:\"native_name\";s:18:\"हिन्दी\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/hi_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hi\";i:2;s:3:\"hin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"जारी\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 07:24:44\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:48:39\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Folytatás\";}}s:2:\"hy\";a:8:{s:8:\"language\";s:2:\"hy\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-03 16:21:10\";s:12:\"english_name\";s:8:\"Armenian\";s:11:\"native_name\";s:14:\"Հայերեն\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/hy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hy\";i:2;s:3:\"hye\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Շարունակել\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 21:11:01\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"is_IS\";a:8:{s:8:\"language\";s:5:\"is_IS\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-04-13 13:55:54\";s:12:\"english_name\";s:9:\"Icelandic\";s:11:\"native_name\";s:9:\"Íslenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/is_IS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"is\";i:2;s:3:\"isl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Áfram\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 07:29:14\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-13 00:48:04\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"続ける\";}}s:5:\"ka_GE\";a:8:{s:8:\"language\";s:5:\"ka_GE\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-12 09:20:11\";s:12:\"english_name\";s:8:\"Georgian\";s:11:\"native_name\";s:21:\"ქართული\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/ka_GE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ka\";i:2;s:3:\"kat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"გაგრძელება\";}}s:3:\"kab\";a:8:{s:8:\"language\";s:3:\"kab\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:39:13\";s:12:\"english_name\";s:6:\"Kabyle\";s:11:\"native_name\";s:9:\"Taqbaylit\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/kab.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"kab\";i:3;s:3:\"kab\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Kemmel\";}}s:2:\"km\";a:8:{s:8:\"language\";s:2:\"km\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-07 02:07:59\";s:12:\"english_name\";s:5:\"Khmer\";s:11:\"native_name\";s:27:\"ភាសាខ្មែរ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/km.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"km\";i:2;s:3:\"khm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"បន្ត\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 11:11:38\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:3:\"ckb\";a:8:{s:8:\"language\";s:3:\"ckb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:48:25\";s:12:\"english_name\";s:16:\"Kurdish (Sorani)\";s:11:\"native_name\";s:13:\"كوردی‎\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/ckb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ku\";i:3;s:3:\"ckb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"به‌رده‌وام به‌\";}}s:2:\"lo\";a:8:{s:8:\"language\";s:2:\"lo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 09:59:23\";s:12:\"english_name\";s:3:\"Lao\";s:11:\"native_name\";s:21:\"ພາສາລາວ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/lo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lo\";i:2;s:3:\"lao\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"ຕໍ່​ໄປ\";}}s:5:\"lt_LT\";a:8:{s:8:\"language\";s:5:\"lt_LT\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-09 11:50:13\";s:12:\"english_name\";s:10:\"Lithuanian\";s:11:\"native_name\";s:15:\"Lietuvių kalba\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/lt_LT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lt\";i:2;s:3:\"lit\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Tęsti\";}}s:2:\"lv\";a:8:{s:8:\"language\";s:2:\"lv\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-03-17 20:40:40\";s:12:\"english_name\";s:7:\"Latvian\";s:11:\"native_name\";s:16:\"Latviešu valoda\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.5/lv.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lv\";i:2;s:3:\"lav\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Turpināt\";}}s:5:\"mk_MK\";a:8:{s:8:\"language\";s:5:\"mk_MK\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:54:41\";s:12:\"english_name\";s:10:\"Macedonian\";s:11:\"native_name\";s:31:\"Македонски јазик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/mk_MK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mk\";i:2;s:3:\"mkd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Продолжи\";}}s:5:\"ml_IN\";a:8:{s:8:\"language\";s:5:\"ml_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 03:43:32\";s:12:\"english_name\";s:9:\"Malayalam\";s:11:\"native_name\";s:18:\"മലയാളം\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ml_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ml\";i:2;s:3:\"mal\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"തുടരുക\";}}s:2:\"mn\";a:8:{s:8:\"language\";s:2:\"mn\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-12 07:29:35\";s:12:\"english_name\";s:9:\"Mongolian\";s:11:\"native_name\";s:12:\"Монгол\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/mn.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mn\";i:2;s:3:\"mon\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:24:\"Үргэлжлүүлэх\";}}s:2:\"mr\";a:8:{s:8:\"language\";s:2:\"mr\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-03-24 06:52:11\";s:12:\"english_name\";s:7:\"Marathi\";s:11:\"native_name\";s:15:\"मराठी\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.5/mr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mr\";i:2;s:3:\"mar\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"सुरु ठेवा\";}}s:5:\"ms_MY\";a:8:{s:8:\"language\";s:5:\"ms_MY\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-03-05 09:45:10\";s:12:\"english_name\";s:5:\"Malay\";s:11:\"native_name\";s:13:\"Bahasa Melayu\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/ms_MY.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ms\";i:2;s:3:\"msa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Teruskan\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:6:\"4.1.18\";s:7:\"updated\";s:19:\"2015-03-26 15:57:42\";s:12:\"english_name\";s:17:\"Myanmar (Burmese)\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.1.18/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ဆောင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 10:39:02\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"ne_NP\";a:8:{s:8:\"language\";s:5:\"ne_NP\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-02 10:20:10\";s:12:\"english_name\";s:6:\"Nepali\";s:11:\"native_name\";s:18:\"नेपाली\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/ne_NP.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ne\";i:2;s:3:\"nep\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:43:\"जारी राख्नुहोस्\";}}s:5:\"nl_BE\";a:8:{s:8:\"language\";s:5:\"nl_BE\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-10 04:16:03\";s:12:\"english_name\";s:15:\"Dutch (Belgium)\";s:11:\"native_name\";s:20:\"Nederlands (België)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/nl_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 07:08:46\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:12:\"nl_NL_formal\";a:8:{s:8:\"language\";s:12:\"nl_NL_formal\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-02-16 13:24:21\";s:12:\"english_name\";s:14:\"Dutch (Formal)\";s:11:\"native_name\";s:20:\"Nederlands (Formeel)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/4.7.5/nl_NL_formal.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nn_NO\";a:8:{s:8:\"language\";s:5:\"nn_NO\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 13:05:53\";s:12:\"english_name\";s:19:\"Norwegian (Nynorsk)\";s:11:\"native_name\";s:13:\"Norsk nynorsk\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/nn_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nn\";i:2;s:3:\"nno\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Hald fram\";}}s:3:\"oci\";a:8:{s:8:\"language\";s:3:\"oci\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-02 13:47:38\";s:12:\"english_name\";s:7:\"Occitan\";s:11:\"native_name\";s:7:\"Occitan\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/oci.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"oc\";i:2;s:3:\"oci\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Contunhar\";}}s:5:\"pa_IN\";a:8:{s:8:\"language\";s:5:\"pa_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-16 05:19:43\";s:12:\"english_name\";s:7:\"Punjabi\";s:11:\"native_name\";s:18:\"ਪੰਜਾਬੀ\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/pa_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pa\";i:2;s:3:\"pan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"ਜਾਰੀ ਰੱਖੋ\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-04-23 09:31:28\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:2:\"ps\";a:8:{s:8:\"language\";s:2:\"ps\";s:7:\"version\";s:6:\"4.1.18\";s:7:\"updated\";s:19:\"2015-03-29 22:19:48\";s:12:\"english_name\";s:6:\"Pashto\";s:11:\"native_name\";s:8:\"پښتو\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1.18/ps.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ps\";i:2;s:3:\"pus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"دوام ورکړه\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-06 23:12:46\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 07:30:18\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:3:\"rhg\";a:8:{s:8:\"language\";s:3:\"rhg\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-16 13:03:18\";s:12:\"english_name\";s:8:\"Rohingya\";s:11:\"native_name\";s:8:\"Ruáinga\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/rhg.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"rhg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:0:\"\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-15 08:32:44\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 20:29:10\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:3:\"sah\";a:8:{s:8:\"language\";s:3:\"sah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-21 02:06:41\";s:12:\"english_name\";s:5:\"Sakha\";s:11:\"native_name\";s:14:\"Сахалыы\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/sah.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"sah\";i:3;s:3:\"sah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Салҕаа\";}}s:5:\"si_LK\";a:8:{s:8:\"language\";s:5:\"si_LK\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 06:00:52\";s:12:\"english_name\";s:7:\"Sinhala\";s:11:\"native_name\";s:15:\"සිංහල\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/si_LK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"si\";i:2;s:3:\"sin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:44:\"දිගටම කරගෙන යන්න\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-05-10 13:48:29\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:5:\"sl_SI\";a:8:{s:8:\"language\";s:5:\"sl_SI\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 15:29:14\";s:12:\"english_name\";s:9:\"Slovenian\";s:11:\"native_name\";s:13:\"Slovenščina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/sl_SI.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sl\";i:2;s:3:\"slv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Nadaljuj\";}}s:2:\"sq\";a:8:{s:8:\"language\";s:2:\"sq\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-04-24 08:35:30\";s:12:\"english_name\";s:8:\"Albanian\";s:11:\"native_name\";s:5:\"Shqip\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.5/sq.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sq\";i:2;s:3:\"sqi\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Vazhdo\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 11:06:53\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 17:15:31\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:3:\"szl\";a:8:{s:8:\"language\";s:3:\"szl\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-24 19:58:14\";s:12:\"english_name\";s:8:\"Silesian\";s:11:\"native_name\";s:17:\"Ślōnskŏ gŏdka\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/szl.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"szl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:13:\"Kōntynuować\";}}s:5:\"ta_IN\";a:8:{s:8:\"language\";s:5:\"ta_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 03:22:47\";s:12:\"english_name\";s:5:\"Tamil\";s:11:\"native_name\";s:15:\"தமிழ்\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ta_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ta\";i:2;s:3:\"tam\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:24:\"தொடரவும்\";}}s:2:\"te\";a:8:{s:8:\"language\";s:2:\"te\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:47:39\";s:12:\"english_name\";s:6:\"Telugu\";s:11:\"native_name\";s:18:\"తెలుగు\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/te.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"te\";i:2;s:3:\"tel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"కొనసాగించు\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:48:43\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:2:\"tl\";a:8:{s:8:\"language\";s:2:\"tl\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-30 02:38:08\";s:12:\"english_name\";s:7:\"Tagalog\";s:11:\"native_name\";s:7:\"Tagalog\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/tl.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tl\";i:2;s:3:\"tgl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Magpatuloy\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-08 19:56:31\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"tt_RU\";a:8:{s:8:\"language\";s:5:\"tt_RU\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-20 20:20:50\";s:12:\"english_name\";s:5:\"Tatar\";s:11:\"native_name\";s:19:\"Татар теле\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/tt_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tt\";i:2;s:3:\"tat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:17:\"дәвам итү\";}}s:3:\"tah\";a:8:{s:8:\"language\";s:3:\"tah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-06 18:39:39\";s:12:\"english_name\";s:8:\"Tahitian\";s:11:\"native_name\";s:10:\"Reo Tahiti\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/tah.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"ty\";i:2;s:3:\"tah\";i:3;s:3:\"tah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:0:\"\";}}s:5:\"ug_CN\";a:8:{s:8:\"language\";s:5:\"ug_CN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-05 09:23:39\";s:12:\"english_name\";s:6:\"Uighur\";s:11:\"native_name\";s:9:\"Uyƣurqə\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ug_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ug\";i:2;s:3:\"uig\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:26:\"داۋاملاشتۇرۇش\";}}s:2:\"uk\";a:8:{s:8:\"language\";s:2:\"uk\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-07 21:03:19\";s:12:\"english_name\";s:9:\"Ukrainian\";s:11:\"native_name\";s:20:\"Українська\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/uk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uk\";i:2;s:3:\"ukr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продовжити\";}}s:2:\"ur\";a:8:{s:8:\"language\";s:2:\"ur\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-03 00:28:41\";s:12:\"english_name\";s:4:\"Urdu\";s:11:\"native_name\";s:8:\"اردو\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/ur.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ur\";i:2;s:3:\"urd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"جاری رکھیں\";}}s:5:\"uz_UZ\";a:8:{s:8:\"language\";s:5:\"uz_UZ\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-05-13 09:55:38\";s:12:\"english_name\";s:5:\"Uzbek\";s:11:\"native_name\";s:11:\"O‘zbekcha\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/uz_UZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uz\";i:2;s:3:\"uzb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Davom etish\";}}s:2:\"vi\";a:8:{s:8:\"language\";s:2:\"vi\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-14 14:59:30\";s:12:\"english_name\";s:10:\"Vietnamese\";s:11:\"native_name\";s:14:\"Tiếng Việt\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.8/vi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"vi\";i:2;s:3:\"vie\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Tiếp tục\";}}s:5:\"zh_HK\";a:8:{s:8:\"language\";s:5:\"zh_HK\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-01 15:14:05\";s:12:\"english_name\";s:19:\"Chinese (Hong Kong)\";s:11:\"native_name\";s:16:\"香港中文版	\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/zh_HK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:3:\"4.8\";s:7:\"updated\";s:19:\"2017-06-13 07:07:19\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:5:\"4.7.5\";s:7:\"updated\";s:19:\"2017-01-26 15:54:45\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.5/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}}", "no");
INSERT INTO `act_options` VALUES("2119", "duplicator_package_active", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-06-15 12:07:12\";s:7:\"Version\";s:5:\"1.2.8\";s:9:\"VersionWP\";s:3:\"4.8\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:30:\"20170615_absolutecomforttravel\";s:4:\"Hash\";s:32:\"0e4efb581727db1b8530170615120712\";s:8:\"NameHash\";s:63:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:37:\"C:/wamp/www/actfinal/wp-snapshots/tmp\";s:8:\"StoreURL\";s:39:\"http://localhost/actfinal/wp-snapshots/\";s:8:\"ScanFile\";s:73:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":14:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:20:\"C:/wamp/www/actfinal\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":6:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-06-15 12:07:12\";s:7:\"Version\";s:5:\"1.2.8\";s:9:\"VersionWP\";s:3:\"4.8\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:30:\"20170615_absolutecomforttravel\";s:4:\"Hash\";s:32:\"0e4efb581727db1b8530170615120712\";s:8:\"NameHash\";s:63:\"20170615_absolutecomforttravel_0e4efb581727db1b8530170615120712\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:37:\"C:/wamp/www/actfinal/wp-snapshots/tmp\";s:8:\"StoreURL\";s:39:\"http://localhost/actfinal/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:53;}s:8:\"Database\";O:12:\"DUP_Database\":13:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:10:\"\0*\0Package\";r:53;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}}s:9:\"Installer\";r:75;s:8:\"Database\";r:88;}", "yes");
INSERT INTO `act_options` VALUES("2123", "_transient_timeout_feed_2c2fe0099a2578688413800ea68677d6", "1497564360", "no");
INSERT INTO `act_options` VALUES("2124", "_transient_feed_2c2fe0099a2578688413800ea68677d6", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"ButlerBlog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://www.butlerblog.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"chad butler\'s weblog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 19 Apr 2017 12:29:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=4.7.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:36:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"New StudioPress Sites Offers Simplicity in a Powerful Hosted Package\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/UYt5OIF7M4A/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://www.butlerblog.com/2017/01/31/new-studiopress-sites-offers-simplicity-powerful-hosted-package/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Jan 2017 21:08:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Editorial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3659\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1770:\"I am excited to share with you a new product from StudioPress.  StudioPress is not just another WordPress company.  The founder, my friend Brian Gardner, was arguably the first person to begin...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=UYt5OIF7M4A:qVo19aW2DTc:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=UYt5OIF7M4A:qVo19aW2DTc:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=UYt5OIF7M4A:qVo19aW2DTc:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=UYt5OIF7M4A:qVo19aW2DTc:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/UYt5OIF7M4A\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"http://www.butlerblog.com/2017/01/31/new-studiopress-sites-offers-simplicity-powerful-hosted-package/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3659\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://www.butlerblog.com/2017/01/31/new-studiopress-sites-offers-simplicity-powerful-hosted-package/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:36:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"The Premium Support Business Model\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/L66h2uKB77Q/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://www.butlerblog.com/2016/08/24/the-premium-support-business-model/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 Aug 2016 19:47:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Editorial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3579\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1775:\"With the growth of WordPress in the Internet ecosystem, we have also seen a variety of business models grow up around it.  Some work, some don&#8217;t.  I want to share with you my current business...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=L66h2uKB77Q:7vMT6Nwaze8:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=L66h2uKB77Q:7vMT6Nwaze8:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=L66h2uKB77Q:7vMT6Nwaze8:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=L66h2uKB77Q:7vMT6Nwaze8:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/L66h2uKB77Q\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://www.butlerblog.com/2016/08/24/the-premium-support-business-model/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3579\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://www.butlerblog.com/2016/08/24/the-premium-support-business-model/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Word-based Passwords Plugin for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/LT6rAuGlTqo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://www.butlerblog.com/2016/06/13/word-based-passwords-plugin-for-wordpress/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 Jun 2016 13:29:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3563\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1775:\"Word-based passwords are not a new thing, but they have not readily been available for WordPress.  Over the course of time supporting my WP-Members membership plugin, I have gotten a lot of requests...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LT6rAuGlTqo:I28em8w_dQs:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LT6rAuGlTqo:I28em8w_dQs:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LT6rAuGlTqo:I28em8w_dQs:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LT6rAuGlTqo:I28em8w_dQs:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/LT6rAuGlTqo\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://www.butlerblog.com/2016/06/13/word-based-passwords-plugin-for-wordpress/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3563\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://www.butlerblog.com/2016/06/13/word-based-passwords-plugin-for-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:36:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"A Great Way to Get Free Gold\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/ijf0cDmn5Ek/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://www.butlerblog.com/2016/02/03/free-gold/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Feb 2016 15:24:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Editorial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3518\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1773:\"Who doesn&#8217;t like free?  What&#8217;s better than free?  Free without a catch.  Nobody likes fine print and unrealistic hurdles to overcome. So with that in mind, consider this &#8211; Free...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ijf0cDmn5Ek:qrAHf60MP9I:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ijf0cDmn5Ek:qrAHf60MP9I:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ijf0cDmn5Ek:qrAHf60MP9I:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ijf0cDmn5Ek:qrAHf60MP9I:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/ijf0cDmn5Ek\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://www.butlerblog.com/2016/02/03/free-gold/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3518\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://www.butlerblog.com/2016/02/03/free-gold/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:51:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"5 Articles to Help You Manage WordPress Better\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/-HQU00er-qs/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://www.butlerblog.com/2015/06/11/articles-to-help-you-manage-wordpress-better/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2015 15:59:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:6:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:6:\"design\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:11:\"development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:4:\"tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3436\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1776:\"Here are some posts that I have done on the site to help you manage WordPress better.   Maybe you&#8217;re a writer or designer, and not a developer. Then you are in luck! These posts are to help the...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=-HQU00er-qs:sLeSOeyZpBU:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=-HQU00er-qs:sLeSOeyZpBU:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=-HQU00er-qs:sLeSOeyZpBU:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=-HQU00er-qs:sLeSOeyZpBU:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/-HQU00er-qs\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://www.butlerblog.com/2015/06/11/articles-to-help-you-manage-wordpress-better/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3436\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://www.butlerblog.com/2015/06/11/articles-to-help-you-manage-wordpress-better/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:54:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Don’t Let This Mistake Kill Your Business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/AFPMDwe6Lv8/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://www.butlerblog.com/2015/06/04/dont-let-this-mistake-kill-your-business/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Jun 2015 14:00:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:7:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"Editorial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:17:\"content-marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:4:\"fear\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:9:\"freelance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:12:\"productivity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3370\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1770:\"It&#8217;s called &#8220;Perfectionism&#8221; and it effects many new writers, developers, and freelancers. At some point, it effects almost everyone who attempts to launch their business online...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=AFPMDwe6Lv8:pK0kUdPxMmA:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=AFPMDwe6Lv8:pK0kUdPxMmA:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=AFPMDwe6Lv8:pK0kUdPxMmA:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=AFPMDwe6Lv8:pK0kUdPxMmA:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/AFPMDwe6Lv8\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://www.butlerblog.com/2015/06/04/dont-let-this-mistake-kill-your-business/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3370\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://www.butlerblog.com/2015/06/04/dont-let-this-mistake-kill-your-business/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Is your site ready for mobilegeddon?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/mgXl7Q4PrM8/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://www.butlerblog.com/2015/04/20/is-your-site-ready-for-mobilegeddon/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Apr 2015 03:34:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"Editorial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"Web\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3393\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1771:\"Is your site currently mobile friendly?  How fast does it load on mobile devices? Dubbed &#8220;Mobilegeddon,&#8221; Google will be making changes to its search algorithm on Tuesday to take into...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=mgXl7Q4PrM8:77HxzmE4DWw:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=mgXl7Q4PrM8:77HxzmE4DWw:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=mgXl7Q4PrM8:77HxzmE4DWw:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=mgXl7Q4PrM8:77HxzmE4DWw:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/mgXl7Q4PrM8\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://www.butlerblog.com/2015/04/20/is-your-site-ready-for-mobilegeddon/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3393\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://www.butlerblog.com/2015/04/20/is-your-site-ready-for-mobilegeddon/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:69:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"Personal Brand Building with Your Own URL Shortener\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/ISeEKBHBNSU/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://www.butlerblog.com/2015/02/05/personal-brand-building-your-own-url-shortener/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Feb 2015 14:00:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:12:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:14:\"Brand Building\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:11:\"Brand Image\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:8:\"branding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:17:\"content-marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:17:\"Personal Branding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:7;a:5:{s:4:\"data\";s:14:\"Shortened Urls\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:8;a:5:{s:4:\"data\";s:4:\"tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:9;a:5:{s:4:\"data\";s:5:\"tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:10;a:5:{s:4:\"data\";s:6:\"webdev\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:11;a:5:{s:4:\"data\";s:9:\"WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3297\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1775:\"You may have noticed that last year I started the process of reinforcing my personal brand image, placing a larger importance on personal branding.  This included a web site makeover, a new logo for...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ISeEKBHBNSU:dx5Efy0GcqQ:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ISeEKBHBNSU:dx5Efy0GcqQ:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=ISeEKBHBNSU:dx5Efy0GcqQ:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=ISeEKBHBNSU:dx5Efy0GcqQ:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/ISeEKBHBNSU\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://www.butlerblog.com/2015/02/05/personal-brand-building-your-own-url-shortener/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3297\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://www.butlerblog.com/2015/02/05/personal-brand-building-your-own-url-shortener/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:48:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"Schedule Your Day to Improve Productivity in 3 Easy Steps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/M8lGPovanBo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://www.butlerblog.com/2015/02/03/schedule-your-day-to-improve-productivity-in-3-easy-steps/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Feb 2015 13:00:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:17:\"content-marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:11:\"development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:9:\"freelance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3239\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1775:\"I once wrote a post about the importance of avoiding distractions as a freelancer. It began with a little story about burning a pot of coffee and related that to how distractions can yield a similar...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=M8lGPovanBo:aXSUkrdH0YQ:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=M8lGPovanBo:aXSUkrdH0YQ:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=M8lGPovanBo:aXSUkrdH0YQ:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=M8lGPovanBo:aXSUkrdH0YQ:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/M8lGPovanBo\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://www.butlerblog.com/2015/02/03/schedule-your-day-to-improve-productivity-in-3-easy-steps/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3239\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://www.butlerblog.com/2015/02/03/schedule-your-day-to-improve-productivity-in-3-easy-steps/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n		\n		\n		\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"5 Top Bloggers Teach You How to Drive Traffic to Your Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/butlerblog/~3/LKX4GwZQzyE/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://www.butlerblog.com/2015/02/02/5-top-bloggers-teach-you-how-to-drive-traffic-to-your-blog/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Feb 2015 18:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:13:\"Blogging Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:17:\"content-marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:4:\"tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://www.butlerblog.com/?p=3131\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1772:\"These 5 top bloggers command top dollar for their advice and expertise. Here is an opportunity for you to get some of their best advice on how to get more blog traffic. And you don&#8217;t have to...<br/>\n<br/>\n[[ This is a content summary only. Visit my website for full links, other content, and more! ]]<div class=\"feedflare\">\n<a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:yIl2AUoC8zA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=yIl2AUoC8zA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:V_sGLiPBpWU\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LKX4GwZQzyE:mtZt7OT42PU:V_sGLiPBpWU\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:dnMXMwOfBR0\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=dnMXMwOfBR0\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:F7zBnMyn0Lo\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LKX4GwZQzyE:mtZt7OT42PU:F7zBnMyn0Lo\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:7Q72WNTAKBA\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=7Q72WNTAKBA\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:qj6IDK7rITs\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?d=qj6IDK7rITs\" border=\"0\"></img></a> <a href=\"http://feeds.feedburner.com/~ff/butlerblog?a=LKX4GwZQzyE:mtZt7OT42PU:gIN9vFwOqvQ\"><img src=\"http://feeds.feedburner.com/~ff/butlerblog?i=LKX4GwZQzyE:mtZt7OT42PU:gIN9vFwOqvQ\" border=\"0\"></img></a>\n</div><img src=\"http://feeds.feedburner.com/~r/butlerblog/~4/LKX4GwZQzyE\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Chad Butler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://www.butlerblog.com/2015/02/02/5-top-bloggers-teach-you-how-to-drive-traffic-to-your-blog/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"3131\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://www.butlerblog.com/2015/02/02/5-top-bloggers-teach-you-how-to-drive-traffic-to-your-blog/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"23349228\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:2:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";s:4:\"href\";s:38:\"http://feeds.feedburner.com/butlerblog\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:2:{s:3:\"rel\";s:3:\"hub\";s:4:\"href\";s:32:\"http://pubsubhubbub.appspot.com/\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:3:{s:4:\"info\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:3:\"uri\";s:10:\"butlerblog\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:14:\"emailServiceId\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"butlerblog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:18:\"feedburnerHostname\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://feedburner.google.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:10:{s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:4:\"etag\";s:27:\"uU1Qnod8qUwMSN1fHYc83rhncAo\";s:13:\"last-modified\";s:29:\"Thu, 15 Jun 2017 09:23:16 GMT\";s:16:\"content-encoding\";s:4:\"gzip\";s:4:\"date\";s:29:\"Thu, 15 Jun 2017 10:05:57 GMT\";s:7:\"expires\";s:29:\"Thu, 15 Jun 2017 10:05:57 GMT\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:22:\"x-content-type-options\";s:7:\"nosniff\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:6:\"server\";s:3:\"GSE\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("2125", "_transient_timeout_feed_mod_2c2fe0099a2578688413800ea68677d6", "1497564360", "no");
INSERT INTO `act_options` VALUES("2126", "_transient_feed_mod_2c2fe0099a2578688413800ea68677d6", "1497521160", "no");
INSERT INTO `act_options` VALUES("2127", "wpmembers_utfields", "", "yes");
INSERT INTO `act_options` VALUES("2142", "_transient_is_multi_author", "0", "yes");
INSERT INTO `act_options` VALUES("2146", "_site_transient_timeout_community-events-4501c091b0366d76ea3218b6cfdd8097", "1497569808", "no");
INSERT INTO `act_options` VALUES("2147", "_site_transient_community-events-4501c091b0366d76ea3218b6cfdd8097", "a:2:{s:8:\"location\";a:1:{s:2:\"ip\";s:2:\"::\";}s:6:\"events\";a:4:{i:0;a:7:{s:4:\"type\";s:6:\"meetup\";s:5:\"title\";s:46:\"Building a Career on WordPress by Bruce Lunnis\";s:3:\"url\";s:71:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/events/240630667/\";s:6:\"meetup\";s:30:\"Nairobi WordPress Meetup Group\";s:10:\"meetup_url\";s:54:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/\";s:4:\"date\";s:19:\"2017-06-16 17:30:00\";s:8:\"location\";a:4:{s:8:\"location\";s:14:\"Nairobi, Kenya\";s:7:\"country\";s:2:\"ke\";s:8:\"latitude\";d:-1.2710680000000001;s:9:\"longitude\";d:36.807903000000003;}}i:1;a:7:{s:4:\"type\";s:6:\"meetup\";s:5:\"title\";s:22:\"Nairobi Monthly Meetup\";s:3:\"url\";s:74:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/events/txjwkmywjbgc/\";s:6:\"meetup\";s:30:\"Nairobi WordPress Meetup Group\";s:10:\"meetup_url\";s:54:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/\";s:4:\"date\";s:19:\"2017-06-24 14:00:00\";s:8:\"location\";a:4:{s:8:\"location\";s:30:\"Nairobi, Nairobi County, Kenya\";s:7:\"country\";s:2:\"KE\";s:8:\"latitude\";d:-1.289999961853;s:9:\"longitude\";d:36.819999694823998;}}i:2;a:7:{s:4:\"type\";s:6:\"meetup\";s:5:\"title\";s:22:\"Nairobi Monthly Meetup\";s:3:\"url\";s:74:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/events/txjwkmywkbmc/\";s:6:\"meetup\";s:30:\"Nairobi WordPress Meetup Group\";s:10:\"meetup_url\";s:54:\"https://www.meetup.com/Nairobi-WordPress-Meetup-Group/\";s:4:\"date\";s:19:\"2017-07-29 14:00:00\";s:8:\"location\";a:4:{s:8:\"location\";s:30:\"Nairobi, Nairobi County, Kenya\";s:7:\"country\";s:2:\"KE\";s:8:\"latitude\";d:-1.289999961853;s:9:\"longitude\";d:36.819999694823998;}}i:3;a:7:{s:4:\"type\";s:8:\"wordcamp\";s:5:\"title\";s:16:\"WordCamp Nairobi\";s:3:\"url\";s:33:\"https://2017.nairobi.wordcamp.org\";s:6:\"meetup\";N;s:10:\"meetup_url\";N;s:4:\"date\";s:19:\"2017-10-14 00:00:00\";s:8:\"location\";a:4:{s:8:\"location\";s:14:\"Nairobi, Kenya\";s:7:\"country\";s:2:\"KE\";s:8:\"latitude\";d:-1.259056;s:9:\"longitude\";d:36.786067000000003;}}}}", "no");
INSERT INTO `act_options` VALUES("2148", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1497569812", "no");
INSERT INTO `act_options` VALUES("2149", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 16:08:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=4.9-alpha-40904\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 4.8 “Evans”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/news/2017/06/evans/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 14:49:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4770\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"An Update with You in Mind Gear up for a more intuitive WordPress! Version 4.8 of WordPress, named &#8220;Evans&#8221; in honor of jazz pianist and composer William John &#8220;Bill&#8221; Evans, is available for download or update in your WordPress dashboard. New features in 4.8 add more ways for you to express yourself and represent your brand. Though some [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:34132:\"<h2 style=\"text-align: center\">An Update with You in Mind</h2>\n<p><img class=\"aligncenter size-large wp-image-4816\" src=\"https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?resize=632%2C316&#038;ssl=1\" alt=\"\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?resize=1024%2C512&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?resize=300%2C150&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?resize=768%2C384&amp;ssl=1 768w, https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?w=1264&amp;ssl=1 1264w, https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></p>\n<h3>Gear up for a more intuitive WordPress!</h3>\n<p>Version 4.8 of WordPress, named &#8220;Evans&#8221; in honor of jazz pianist and composer William John &#8220;Bill&#8221; Evans, is available for download or update in your WordPress dashboard. New features in 4.8 add more ways for you to express yourself and represent your brand.</p>\n<p>Though some updates seem minor, they’ve been built by hundreds of contributors with <em>you</em> in mind. Get ready for new features you’ll welcome like an old friend: link improvements, <em>three</em> new media widgets covering images, audio, and video, an updated text widget that supports visual editing, and an upgraded news section in your dashboard which brings in nearby and upcoming WordPress events.</p>\n<hr />\n<h2 style=\"text-align: center\">Exciting Widget Updates</h2>\n<p><img class=\"size-large wp-image-4776 aligncenter\" src=\"https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?resize=632%2C436&#038;ssl=1\" alt=\"\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?resize=1024%2C706&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?resize=300%2C207&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?resize=768%2C530&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?w=1264&amp;ssl=1 1264w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></p>\n<h3>Image Widget</h3>\n<p>Adding an image to a widget is now a simple task that is achievable for any WordPress user without needing to know code. Simply insert your image right within the widget settings. Try adding something like a headshot or a photo of your latest weekend adventure — and see it appear automatically.</p>\n<h3>Video Widget</h3>\n<p>A welcome video is a great way to humanize the branding of your website. You can now add any video from the Media Library to a sidebar on your site with the new Video widget. Use this to showcase a welcome video to introduce visitors to your site or promote your latest and greatest content.</p>\n<h3>Audio Widget</h3>\n<p>Are you a podcaster, musician, or avid blogger? Adding a widget with your audio file has never been easier. Upload your audio file to the Media Library, go to the widget settings, select your file, and you’re ready for listeners. This would be a easy way to add a more personal welcome message, too!</p>\n<h3>Rich Text Widget</h3>\n<p>This feature deserves a parade down the center of town! Rich-text editing capabilities are now native for Text widgets. Add a widget anywhere and format away. Create lists, add emphasis, and quickly and easily insert links. Have fun with your newfound formatting powers, and watch what you can accomplish in a short amount of time.</p>\n<hr />\n<h2 style=\"text-align: center\">Link Boundaries</h2>\n<div id=\"v-8BDWH3QG-1\" class=\"video-player\"><video id=\"v-8BDWH3QG-1-video\" width=\"632\" height=\"342\" poster=\"https://videos.files.wordpress.com/8BDWH3QG/3-link-boundaries_dvd.original.jpg\" controls=\"true\" preload=\"metadata\" dir=\"ltr\" lang=\"en\"><source src=\"https://videos.files.wordpress.com/8BDWH3QG/3-link-boundaries_dvd.mp4\" type=\"video/mp4; codecs=&quot;avc1.64001E, mp4a.40.2&quot;\" /><source src=\"https://videos.files.wordpress.com/8BDWH3QG/3-link-boundaries_fmt1.ogv\" type=\"video/ogg; codecs=&quot;theora, vorbis&quot;\" /><div><img alt=\"Link Boundaries\" src=\"https://videos.files.wordpress.com/8BDWH3QG/3-link-boundaries_dvd.original.jpg?resize=632%2C342\" data-recalc-dims=\"1\" /></div><p>Link Boundaries</p></video></div>\n<p>Have you ever tried updating a link, or the text around a link, and found you can&#8217;t seem to edit it correctly? When you edit the text after the link, your new text also ends up linked. Or you edit the text in the link, but your text ends up outside of it. This can be frustrating! With link boundaries, a great new feature, the process is streamlined and your links will work well. You’ll be happier. We promise.</p>\n<hr />\n<h2 style=\"text-align: center\">Nearby WordPress Events</h2>\n<p><img class=\"aligncenter wp-image-4779 size-large\" src=\"https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?resize=632%2C465&#038;ssl=1\" alt=\"\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?resize=1024%2C753&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?resize=300%2C221&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?resize=768%2C565&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?w=1126&amp;ssl=1 1126w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></p>\n<p>Did you know that WordPress has a thriving offline community with groups meeting regularly in more than 400 cities around the world? WordPress now draws your attention to the events that help you continue improving your WordPress skills, meet friends, and, of course, publish!</p>\n<p>This is quickly becoming one of our favorite features. While you are in the dashboard (because you’re running updates and writing posts, right?) all upcoming WordCamps and official WordPress Meetups — local to you — will be displayed.</p>\n<p>Being part of the community can help you improve your WordPress skills and network with people you wouldn&#8217;t otherwise meet. Now you can easily find your local events just by logging in to your dashboard and looking at the new Events and News dashboard widget.</p>\n<hr />\n<h2 style=\"text-align: center\">Even More Developer Happiness <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f60a.png\" alt=\"😊\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></h2>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/17/cleaner-headings-in-the-admin-screens/\">More Accessible Admin Panel Headings</a></h3>\n<p>New CSS rules mean extraneous content (like “Add New” links) no longer need to be included in admin-area headings. These panel headings improve the experience for people using assistive technologies.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/22/removal-of-core-embedding-support-for-wmv-and-wma-file-formats/\">Removal of Core Support for WMV and WMA Files</a></h3>\n<p>As fewer and fewer browsers support Silverlight, file formats which require the presence of the Silverlight plugin are being removed from core support. Files will still display as a download link, but will no longer be embedded automatically.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/22/multisite-focused-changes-in-4-8/\">Multisite Updates</a></h3>\n<p>New capabilities have been introduced to 4.8 with an eye towards removing calls to<br />\n<code>is_super_admin()</code>. Additionally, new hooks and tweaks to more granularly control site and user counts per network have been added.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/23/addition-of-tinymce-to-the-text-widget/\">Text-Editor JavaScript API</a></h3>\n<p>With the addition of TinyMCE to the text widget in 4.8 comes a new JavaScript API for instantiating the editor after page load. This can be used to add an editor instance to any text area, and customize it with buttons and functions. Great for plugin authors!</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/26/media-widgets-for-images-video-and-audio/\">Media Widgets API</a></h3>\n<p>The introduction of a new base media widget REST API schema to 4.8 opens up possibilities for even more media widgets (like galleries or playlists) in the future. The three new media widgets are powered by a shared base class that covers most of the interactions with the media modal. That class also makes it easier to create new media widgets and paves the way for more to come.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/16/customizer-sidebar-width-is-now-variable/\">Customizer Width Variable</a></h3>\n<p>Rejoice! New responsive breakpoints have been added to the customizer sidebar to make it wider on high-resolution screens. Customizer controls should use percentage-based widths instead of pixels.</p>\n<hr />\n<h2 style=\"text-align: center\">The Squad</h2>\n<p>This release was led by <a href=\"https://matt.blog\">Matt</a> and <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a>, with the help of the following fabulous folks. There are 346 contributors with props in this release, with 106 of them contributing for the first time. Pull up some Bill Evans on your music service of choice, and check out some of their profiles:</p>\n<a href=\"https://profiles.wordpress.org/1naveengiri\">1naveengiri</a>, <a href=\"https://profiles.wordpress.org/4nickpick\">4nickpick</a>, <a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/abhishek\">abhishek</a>, <a href=\"https://profiles.wordpress.org/abhishekfdd\">Abhishek Kumar</a>, <a href=\"https://profiles.wordpress.org/abrain\">abrain</a>, <a href=\"https://profiles.wordpress.org/kawauso\">Adam Harley (Kawauso)</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adamsoucie\">Adam Soucie</a>, <a href=\"https://profiles.wordpress.org/afzalmultani\">Afzal Multani</a>, <a href=\"https://profiles.wordpress.org/mrahmadawais\">Ahmad Awais</a>, <a href=\"https://profiles.wordpress.org/ajoah\">ajoah</a>, <a href=\"https://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/apmarshall\">Alex Floyd Marshall</a>, <a href=\"https://profiles.wordpress.org/alexkingorg\">Alex King</a>, <a href=\"https://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andreamiddleton\">Andrea Middleton</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/rockwell15\">Andrew Rockwell</a>, <a href=\"https://profiles.wordpress.org/kelderic\">Andy Mercer</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/arena94\">arena94</a>, <a href=\"https://profiles.wordpress.org/arshidkv12\">Arshid</a>, <a href=\"https://profiles.wordpress.org/aryamaaru\">Arun</a>, <a href=\"https://profiles.wordpress.org/asalce\">asalce</a>, <a href=\"https://profiles.wordpress.org/ashokkumar24\">ashokkumar24</a>, <a href=\"https://profiles.wordpress.org/barryceelen\">Barry Ceelen</a>, <a href=\"https://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"https://profiles.wordpress.org/bharatkambariya\">Bharat Kambariya</a>, <a href=\"https://profiles.wordpress.org/blobfolio\">Blobfolio</a>, <a href=\"https://profiles.wordpress.org/gitlost\">bonger</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">Boone B. Gorges</a>, <a href=\"https://profiles.wordpress.org/bor0\">Boro Sitnikovski</a>, <a href=\"https://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"https://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/drrobotnik\">Brandon Lavigne</a>, <a href=\"https://profiles.wordpress.org/bridgetwillard\">Bridget Willard</a>, <a href=\"https://profiles.wordpress.org/bhargavbhandari90\">Bunty</a>, <a href=\"https://profiles.wordpress.org/camikaos\">Cami Kaos</a>, <a href=\"https://profiles.wordpress.org/carl-alberto\">Carl Alberto</a>, <a href=\"https://profiles.wordpress.org/caseypatrickdriscoll\">Casey Driscoll</a>, <a href=\"https://profiles.wordpress.org/cazm\">cazm</a>, <a href=\"https://profiles.wordpress.org/ccprog\">ccprog</a>, <a href=\"https://profiles.wordpress.org/chandrapatel\">Chandra Patel</a>, <a href=\"https://profiles.wordpress.org/chesio\">chesio</a>, <a href=\"https://profiles.wordpress.org/ketuchetan\">chetansatasiya</a>, <a href=\"https://profiles.wordpress.org/chiragpatel\">Chirag Patel</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/cklosows\">Chris Klosowski</a>, <a href=\"https://profiles.wordpress.org/chris_dev\">Chris Mok</a>, <a href=\"https://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"https://profiles.wordpress.org/christian1012\">Christian Chung</a>, <a href=\"https://profiles.wordpress.org/coreymckrill\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/courtneypk\">Courtney P.K.</a>, <a href=\"https://profiles.wordpress.org/cristianozanca\">Cristiano Zanca</a>, <a href=\"https://profiles.wordpress.org/csloisel\">csloisel</a>, <a href=\"https://profiles.wordpress.org/curdin\">Curdin Krummenacher</a>, <a href=\"https://profiles.wordpress.org/clarinetlord\">Cyrus Collier</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber </a>, <a href=\"https://profiles.wordpress.org/diddledan\">Daniel Llewellyn</a>, <a href=\"https://profiles.wordpress.org/mte90\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/nerrad\">Darren Ethier (nerrad)</a>, <a href=\"https://profiles.wordpress.org/darshan02\">Darshan_dj</a>, <a href=\"https://profiles.wordpress.org/darthaud\">darthaud</a>, <a href=\"https://profiles.wordpress.org/dllh\">Daryl L. L. Houston (dllh)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"https://profiles.wordpress.org/davidbinda\">David Binovec</a>, <a href=\"https://profiles.wordpress.org/dlh\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dshanske\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/davidbenton\">davidbenton</a>, <a href=\"https://profiles.wordpress.org/designsimply\">designsimply</a>, <a href=\"https://profiles.wordpress.org/dhanendran\">Dhanendran</a>, <a href=\"https://profiles.wordpress.org/dharm1025\">Dharmesh Patel</a>, <a href=\"https://profiles.wordpress.org/dhaval-parekh\">Dhaval Parekh</a>, <a href=\"https://profiles.wordpress.org/dingo_bastard\">dingo-d</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dotancohen\">Dotan Cohen</a>, <a href=\"https://profiles.wordpress.org/doublehhh\">DoubleH</a>, <a href=\"https://profiles.wordpress.org/dreamon11\">DreamOn11</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/drivingralle\">Drivingralle</a>, <a href=\"https://profiles.wordpress.org/dspilka\">dspilka</a>, <a href=\"https://profiles.wordpress.org/chopinbach\">Edwin Cromley</a>, <a href=\"https://profiles.wordpress.org/ejner69\">Ejner Galaz</a>, <a href=\"https://profiles.wordpress.org/iseulde\">Ella Iseulde Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/emirpprime\">emirpprime</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"https://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"https://profiles.wordpress.org/endif-media\">Ethan Allen</a>, <a href=\"https://profiles.wordpress.org/fab1en\">Fabien Quatravaux</a>, <a href=\"https://profiles.wordpress.org/flixos90\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/fibonaccina\">fibonaccina</a>, <a href=\"https://profiles.wordpress.org/mista-flo\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/francina\">Francesca Marano</a>, <a href=\"https://profiles.wordpress.org/fstaude\">Frank Neumann-Staude</a>, <a href=\"https://profiles.wordpress.org/f-j-kaiser\">Franz Josef Kaiser</a>, <a href=\"https://profiles.wordpress.org/gma992\">Gabriel Maldonado</a>, <a href=\"https://profiles.wordpress.org/voldemortensen\">Garth Mortensen</a>, <a href=\"https://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/ghosttoast\">Gustave F. Gerhardt</a>, <a href=\"https://profiles.wordpress.org/hedgefield\">hedgefield</a>, <a href=\"https://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"https://profiles.wordpress.org/helgatheviking\">helgatheviking</a>, <a href=\"https://profiles.wordpress.org/hristo-sg\">Hristo Pandjarov</a>, <a href=\"https://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ig_communitysites\">ig_communitysites</a>, <a href=\"https://profiles.wordpress.org/zinigor\">Igor Zinovyev</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/ireneyoast\">ireneyoast</a>, <a href=\"https://profiles.wordpress.org/iv3rson76\">Ivan Stefanov</a>, <a href=\"https://profiles.wordpress.org/ivantedja\">ivantedja</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/whyisjake\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jnylen0\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jaydeep-rami\">Jaydeep Rami</a>, <a href=\"https://profiles.wordpress.org/jazbek\">jazbek</a>, <a href=\"https://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jfarthing84\">Jeff Farthing</a>, <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a>, <a href=\"https://profiles.wordpress.org/cheffheid\">Jeffrey de Wit</a>, <a href=\"https://profiles.wordpress.org/jenblogs4u\">Jen Miller</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/jesseenterprises\">jesseenterprises</a>, <a href=\"https://profiles.wordpress.org/jigneshnakrani\">Jignesh Nakrani</a>, <a href=\"https://profiles.wordpress.org/jipmoors\">Jip Moors</a>, <a href=\"https://profiles.wordpress.org/jjcomack\">jjcomack</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"https://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/chanthaboune\">Josepha</a>, <a href=\"https://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"https://profiles.wordpress.org/juhise\">Juhi Saxena</a>, <a href=\"https://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"https://profiles.wordpress.org/vijustin\">Justin McGuire</a>, <a href=\"https://profiles.wordpress.org/certainstrings\">Justin Tucker</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/kafleg\">kafleg</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/karinedo\">karinedo</a>, <a href=\"https://profiles.wordpress.org/zoonini\">Kathryn</a>, <a href=\"https://profiles.wordpress.org/kaushik\">kaushik</a>, <a href=\"https://profiles.wordpress.org/kkoppenhaver\">Keanan Koppenhaver</a>, <a href=\"https://profiles.wordpress.org/keesiemeijer\">keesiemeijer</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/ixkaito\">Kite</a>, <a href=\"https://profiles.wordpress.org/kjellr\">kjellr</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/kostasx\">kostasx</a>, <a href=\"https://profiles.wordpress.org/kubik-rubik\">kubik-rubik</a>, <a href=\"https://profiles.wordpress.org/kuck1u\">KUCKLU</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/laurelfulford\">Laurel Fulford</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/leemon\">leemon</a>, <a href=\"https://profiles.wordpress.org/lewiscowles\">LewisCowles</a>, <a href=\"https://profiles.wordpress.org/liammcarthur\">LiamMcArthur</a>, <a href=\"https://profiles.wordpress.org/lucasstark\">Lucas Stark</a>, <a href=\"https://profiles.wordpress.org/lukasbesch\">lukasbesch</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/maedahbatool\">Maedah Batool</a>, <a href=\"https://profiles.wordpress.org/mp518\">Mahesh Prajapati</a>, <a href=\"https://profiles.wordpress.org/mantismamita\">mantismamita</a>, <a href=\"https://profiles.wordpress.org/tyxla\">Marin Atanasov</a>, <a href=\"https://profiles.wordpress.org/maguiar\">Mario Aguiar</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/mrwweb\">Mark Root-Wiley</a>, <a href=\"https://profiles.wordpress.org/mapk\">Mark Uraine</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/matheusfd\">Matheus Martins</a>, <a href=\"https://profiles.wordpress.org/matheusgimenez\">MatheusGimenez</a>, <a href=\"https://profiles.wordpress.org/mathieuhays\">mathieuhays</a>, <a href=\"https://profiles.wordpress.org/matias\">matias</a>, <a href=\"https://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/maximeculea\">Maxime Culea</a>, <a href=\"https://profiles.wordpress.org/mayukojpn\">Mayo Moriyama</a>, <a href=\"https://profiles.wordpress.org/mayurk\">Mayur Keshwani</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/menakas\">Menaka S.</a>, <a href=\"https://profiles.wordpress.org/michaelarestad\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michalzuber\">michalzuber</a>, <a href=\"https://profiles.wordpress.org/michelleweber\">michelleweber</a>, <a href=\"https://profiles.wordpress.org/stubgo\">Miina Sikk</a>, <a href=\"https://profiles.wordpress.org/mihai2u\">Mike Crantea</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikejolley\">Mike Jolley</a>, <a href=\"https://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"https://profiles.wordpress.org/mnelson4\">Mike Nelson</a>, <a href=\"https://profiles.wordpress.org/mikeschroder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinić</a>, <a href=\"https://profiles.wordpress.org/milindmore22\">Milind More</a>, <a href=\"https://profiles.wordpress.org/mitraval192\">Mithun Raval</a>, <a href=\"https://profiles.wordpress.org/mmdeveloper\">MMDeveloper</a>, <a href=\"https://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/mohanjith\">mohanjith</a>, <a href=\"https://profiles.wordpress.org/monikarao\">monikarao</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/mt8biz\">moto hachi ( mt8.biz )</a>, <a href=\"https://profiles.wordpress.org/mrgregwaugh\">MrGregWaugh</a>, <a href=\"https://profiles.wordpress.org/mschadegg\">mschadegg</a>, <a href=\"https://profiles.wordpress.org/codegeass\">Muhammet Arslan</a>, <a href=\"https://profiles.wordpress.org/dots\">MULTIDOTS</a>, <a href=\"https://profiles.wordpress.org/nao\">Naoko Takano</a>, <a href=\"https://profiles.wordpress.org/naomicbush\">Naomi C. Bush</a>, <a href=\"https://profiles.wordpress.org/natereist\">Nate Reist</a>, <a href=\"https://profiles.wordpress.org/greatislander\">Ned Zimmerman</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey </a>, <a href=\"https://profiles.wordpress.org/nikschavan\">Nikhil Chavan</a>, <a href=\"https://profiles.wordpress.org/nitin-kevadiya\">Nitin Kevadiya</a>, <a href=\"https://profiles.wordpress.org/kailanitish90\">Nitish Kaila</a>, <a href=\"https://profiles.wordpress.org/nobremarcos\">nobremarcos</a>, <a href=\"https://profiles.wordpress.org/nosegraze\">NoseGraze</a>, <a href=\"https://profiles.wordpress.org/nsundberg\">nsundberg</a>, <a href=\"https://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"https://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"https://profiles.wordpress.org/iaaxpage\">page-carbajal</a>, <a href=\"https://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"https://profiles.wordpress.org/figureone\">Paul Ryan</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/sirbrillig\">Payton Swick</a>, <a href=\"https://profiles.wordpress.org/pdufour\">pdufour</a>, <a href=\"https://profiles.wordpress.org/piewp\">Perdaan</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/philipjohn\">Philip John</a>, <a href=\"https://profiles.wordpress.org/delawski\">Piotr Delawski</a>, <a href=\"https://profiles.wordpress.org/psoluch\">Piotr Soluch</a>, <a href=\"https://profiles.wordpress.org/postpostmodern\">postpostmodern</a>, <a href=\"https://profiles.wordpress.org/pranalipatel\">Pranali Patel</a>, <a href=\"https://profiles.wordpress.org/pratikshrestha\">Pratik Shrestha</a>, <a href=\"https://profiles.wordpress.org/presskopp\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/printsachen1\">printsachen1</a>, <a href=\"https://profiles.wordpress.org/priyankabehera155\">Priyanka Behera</a>, <a href=\"https://profiles.wordpress.org/prosti\">prosti</a>, <a href=\"https://profiles.wordpress.org/ptbello\">ptbello</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rafaehlers\">Rafael Ehlers</a>, <a href=\"https://profiles.wordpress.org/raggedrobins\">raggedrobins</a>, <a href=\"https://profiles.wordpress.org/raisonon\">raisonon</a>, <a href=\"https://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"https://profiles.wordpress.org/ramiabraham\">ramiabraham</a>, <a href=\"https://profiles.wordpress.org/ranh\">ranh</a>, <a href=\"https://profiles.wordpress.org/rclations\">RC Lations</a>, <a href=\"https://profiles.wordpress.org/redrambles\">redrambles</a>, <a href=\"https://profiles.wordpress.org/reidbusi\">reidbusi</a>, <a href=\"https://profiles.wordpress.org/reldev\">reldev</a>, <a href=\"https://profiles.wordpress.org/rellect\">rellect</a>, <a href=\"https://profiles.wordpress.org/arena\">RENAUT</a>, <a href=\"https://profiles.wordpress.org/rensw90\">rensw90</a>, <a href=\"https://profiles.wordpress.org/reportermike\">reportermike</a>, <a href=\"https://profiles.wordpress.org/rianrietveld\">Rian Rietveld</a>, <a href=\"https://profiles.wordpress.org/riddhiehta02\">Riddhi Mehta</a>, <a href=\"https://profiles.wordpress.org/aussieguy123\">Robbie Cahill</a>, <a href=\"https://profiles.wordpress.org/sanchothefat\">Robert O\'Rourke</a>, <a href=\"https://profiles.wordpress.org/littlerchicken\">Robin Cornett</a>, <a href=\"https://profiles.wordpress.org/runciters\">runciters</a>, <a href=\"https://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/welcher\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/sagarjadhav\">Sagar Jadhav</a>, <a href=\"https://profiles.wordpress.org/sagarprajapati\">Sagar Prajapati</a>, <a href=\"https://profiles.wordpress.org/sagarkbhatt\">sagarkbhatt</a>, <a href=\"https://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"https://profiles.wordpress.org/samantha-miller\">Samantha Miller</a>, <a href=\"https://profiles.wordpress.org/samikeijonen\">Sami Keijonen</a>, <a href=\"https://profiles.wordpress.org/samuelsidler\">Samuel Sidler</a>, <a href=\"https://profiles.wordpress.org/sanketparmar\">Sanket Parmar</a>, <a href=\"https://profiles.wordpress.org/sathyapulse\">sathyapulse</a>, <a href=\"https://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sfpt\">sfpt</a>, <a href=\"https://profiles.wordpress.org/sgolemon\">sgolemon</a>, <a href=\"https://profiles.wordpress.org/shadyvb\">Shady Sharaf</a>, <a href=\"https://profiles.wordpress.org/shanee\">shanee</a>, <a href=\"https://profiles.wordpress.org/shashwatmittal\">Shashwat Mittal</a>, <a href=\"https://profiles.wordpress.org/shazahm1hotmailcom\">shazahm1</a>, <a href=\"https://profiles.wordpress.org/shulard\">shulard</a>, <a href=\"https://profiles.wordpress.org/slbmeh\">slbmeh</a>, <a href=\"https://profiles.wordpress.org/soean\">Soren Wrede</a>, <a href=\"https://profiles.wordpress.org/sstoqnov\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/stephdau\">Stephane Daury (stephdau)</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"https://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"https://profiles.wordpress.org/stormrockwell\">Storm Rockwell</a>, <a href=\"https://profiles.wordpress.org/sudar\">Sudar Muthu</a>, <a href=\"https://profiles.wordpress.org/supercoder\">Supercoder</a>, <a href=\"https://profiles.wordpress.org/cybr\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/szaqal21\">szaqal21</a>, <a href=\"https://profiles.wordpress.org/gonom9\">taggon</a>, <a href=\"https://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/takayukister\">Takayuki Miyoshi</a>, <a href=\"https://profiles.wordpress.org/karmatosed\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/technopolitica\">technopolitica</a>, <a href=\"https://profiles.wordpress.org/teinertb\">teinertb</a>, <a href=\"https://profiles.wordpress.org/tejas5989\">tejas5989</a>, <a href=\"https://profiles.wordpress.org/terwdan\">terwdan</a>, <a href=\"https://profiles.wordpress.org/tharsheblows\">tharsheblows</a>, <a href=\"https://profiles.wordpress.org/themiked\">theMikeD</a>, <a href=\"https://profiles.wordpress.org/thepelkus\">thepelkus</a>, <a href=\"https://profiles.wordpress.org/tfrommen\">Thorsten Frommen</a>, <a href=\"https://profiles.wordpress.org/timmydcrawford\">Timmy Crawford</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/timph\">timph</a>, <a href=\"https://profiles.wordpress.org/tmatsuur\">tmatsuur</a>, <a href=\"https://profiles.wordpress.org/tomdxw\">tomdxw</a>, <a href=\"https://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/triplejumper12\">triplejumper12</a>, <a href=\"https://profiles.wordpress.org/truongwp\">truongwp</a>, <a href=\"https://profiles.wordpress.org/tymvie\">tymvie</a>, <a href=\"https://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"https://profiles.wordpress.org/utkarshpatel\">Utkarsh</a>, <a href=\"https://profiles.wordpress.org/vaishuagola27\">vaishu.agola27</a>, <a href=\"https://profiles.wordpress.org/vortfu\">vortfu</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/wpfo\">wpfo</a>, <a href=\"https://profiles.wordpress.org/xrmx\">xrmx</a>, <a href=\"https://profiles.wordpress.org/ze3kr\">ze3kr</a>, and <a href=\"https://profiles.wordpress.org/h3llas\">Zeljko Ascic</a>.\n<p>&nbsp;</p>\n<p>Finally, thanks to all the community translators who worked on WordPress 4.8. Their efforts bring WordPress 4.8 fully translated to 38 languages at release time with more on the way.</p>\n<p>Do you want to report on WordPress 4.8? <a href=\"https://s.w.org/images/core/4.8/wp-4-8_press-kit.zip\">We&#8217;ve compiled a press kit</a> featuring information about the release features, and some media assets to help you along.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress — we hope you enjoy!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4770\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 4.8 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2017/06/wordpress-4-8-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jun 2017 22:13:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4765\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:336:\"The second release candidate for WordPress 4.8 is now available. To test WordPress 4.8, you can use the WordPress Beta Tester plugin or you can download the release candidate here (zip). We&#8217;ve made a handful of changes since releasing RC 1 last week. For more details about what&#8217;s new in version 4.8, check out the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Mel Choyce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1173:\"<p>The second release candidate for WordPress 4.8 is now available.</p>\n<p>To test WordPress 4.8, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.8-RC2.zip\">download the release candidate here</a> (zip).</p>\n<p>We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log/trunk/?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=40866&amp;stop_rev=40847\">a handful of changes</a> since releasing RC 1 last week. For more details about what&#8217;s new in version 4.8, check out the <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\">Beta 1</a>, <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-2/\">Beta 2</a>, and <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-release-candidate/\">RC1</a> blog posts.</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you&#8217;ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Happy testing!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4765\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 4.8 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2017/05/wordpress-4-8-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 May 2017 23:04:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4758\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:325:\"The release candidate for WordPress 4.8 is now available. RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.8 on Thursday, June 8, but we need your help to get there. If you haven’t tested 4.8 yet, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Mel Choyce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2365:\"<p>The release candidate for WordPress 4.8 is now available.</p>\n<p>RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.8 on <strong>Thursday, June 8</strong>, but we need <em>your</em> help to get there. If you haven’t tested 4.8 yet, now is the time!</p>\n<p>To test WordPress 4.8, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.8-RC1.zip\">download the release candidate here</a> (zip).</p>\n<p>We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log/trunk/?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=40840&amp;stop_rev=40821\">a handful of changes</a> since releasing Beta 2 earlier this week. For more details about what’s new in version 4.8, check out the <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\">Beta 1</a> and <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-2/\">Beta 2</a> blog posts.</p>\n<p><strong>Think you’ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you’ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>Developers</strong>, please test your plugins and themes against WordPress 4.8 and update your plugin’s <em>Tested up to</em> version in the readme to 4.8. If you find compatibility problems please be sure to post to the support forums so we can figure those out before the final release – we work hard to avoid breaking things. An in-depth field guide to developer-focused changes is coming soon on the <a href=\"https://make.wordpress.org/core/\">core development blog</a>.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p>This release&#8217;s haiku is courtesy of <a href=\'https://profiles.wordpress.org/matveb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>matveb</a>:</p>\n<p><em>Érrese uno</em><br />\n<em>Cien veces y más</em><br />\n<em>Erre ce dos</em></p>\n<p>Thanks for your continued help testing out the latest versions of WordPress.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4758\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.8 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 23 May 2017 00:02:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4749\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.8 Beta 2 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.8, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Mel Choyce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1621:\"<p>WordPress 4.8 Beta 2 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.8, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.8-beta2.zip\">download the beta here</a> (zip).</p>\n<p>For more information on what’s new in 4.8, check out the <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\">Beta 1</a> blog post. Since then, we’ve made <a href=\"https://core.trac.wordpress.org/log/trunk/?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=40819&amp;stop_rev=40664&amp;limit=100&amp;sfp_email=&amp;sfph_mail=\">over 50 changes</a> in Beta 2.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n<p><em>WordPress four point eight<br />\nOne step closer to release<br />\nPlease test Beta 2!</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4749\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 4.7.5 Security and Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2017/05/wordpress-4-7-5/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 May 2017 22:39:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4734\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"WordPress 4.7.5 is now available. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7.4 and earlier are affected by six security issues: Insufficient redirect validation in the HTTP class. Reported by Ronni Skansing. Improper handling of post meta data values in the XML-RPC [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Pascal Birchler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2349:\"<p>WordPress 4.7.5 is now available. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7.4 and earlier are affected by six security issues:</p>\n<ol>\n<li>Insufficient redirect validation in the HTTP class. Reported by <a href=\"https://dk.linkedin.com/in/ronni-skansing-36143b65\">Ronni Skansing</a>.</li>\n<li>Improper handling of post meta data values in the XML-RPC API. Reported by <a href=\"https://hackerone.com/jazzy2fives\">Sam Thomas</a>.</li>\n<li>Lack of capability checks for post meta data in the XML-RPC API. Reported by <a href=\"https://profiles.wordpress.org/vortfu\">Ben Bidner</a> of the WordPress Security Team.</li>\n<li>A Cross Site Request Forgery (CSRF)  vulnerability was discovered in the filesystem credentials dialog. Reported by <a href=\"https://twitter.com/yorickkoster\">Yorick Koster</a>.</li>\n<li>A cross-site scripting (XSS) vulnerability was discovered when attempting to upload very large files. Reported by <a href=\"https://dk.linkedin.com/in/ronni-skansing-36143b65\">Ronni Skansing</a>.</li>\n<li>A cross-site scripting (XSS) vulnerability was discovered related to the Customizer. Reported by <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a> of the WordPress Security Team.</li>\n</ol>\n<p>Thank you to the reporters of these issues for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p>In addition to the security issues above, WordPress 4.7.5 contains 3 maintenance fixes to the 4.7 release series. For more information, see the <a href=\"https://codex.wordpress.org/Version_4.7.5\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=4.7.5&amp;group=component&amp;col=id&amp;col=summary&amp;col=component&amp;col=status&amp;col=owner&amp;col=type&amp;col=priority&amp;col=keywords&amp;order=priority\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.5</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.5.</p>\n<p>Thanks to everyone who contributed to 4.7.5.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4734\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress Now on HackerOne\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://wordpress.org/news/2017/05/wordpress-now-on-hackerone/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 May 2017 16:02:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4730\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:322:\"WordPress has grown a lot over the last thirteen years – it now powers more than 28% of the top ten million sites on the web. During this growth, each team has worked hard to continually improve their tools and processes. Today, the WordPress Security Team is happy to announce that WordPress is now officially [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Aaron D. Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1718:\"<p>WordPress has grown a lot over the last thirteen years – it now powers more than 28% of the top ten million sites on the web. During this growth, each team has worked hard to continually improve their tools and processes. Today, the WordPress Security Team is happy to announce that <a href=\"https://hackerone.com/wordpress\">WordPress is now officially on HackerOne</a>!</p>\n<p><a href=\"https://www.hackerone.com/about\">HackerOne</a> is a platform for security researchers to securely and responsibly report vulnerabilities to our team. It provides tools that improve the quality and consistency of communication with reporters, and will reduce the time spent on responding to commonly reported issues. This frees our team to spend more time working on improving the security of WordPress.</p>\n<p>The security team has been working on this project for quite some time. Nikolay Bachiyski started the team working on it just over a year ago. We ran it as a private program while we worked out our procedures and processes, and are excited to finally make it public.</p>\n<p>With the announcement of the WordPress HackerOne program we are also introducing bug bounties. Bug bounties let us reward reporters for disclosing issues to us and helping us secure our products and infrastructure. We&#8217;ve already awarded more than $3,700 in bounties to seven different reporters! We are thankful to Automattic for paying the bounties on behalf of the WordPress project.</p>\n<p>The program and bounties cover all our projects including WordPress, BuddyPress, bbPress, GlotPress, and WP-CLI as well as all of our sites including WordPress.org, bbPress.org, WordCamp.org, BuddyPress.org, and GlotPress.org.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4730\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.8 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 May 2017 00:15:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4727\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:342:\"We&#8217;re planning a smaller WP release early next month, bringing in three major enhancements: An improved visual editor experience, with a new TinyMCE that allows you to navigate more intuitively in and out of inline elements like links. (Try it out to see, it&#8217;s hard to describe.) A revamp of the dashboard news widget to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1148:\"<p>We&#8217;re planning a smaller WP release early next month, bringing in three major enhancements:</p>\n<ul>\n<li>An improved visual editor experience, with a new TinyMCE that allows you to navigate more intuitively in and out of inline elements like links. (Try it out to see, it&#8217;s hard to describe.)</li>\n<li>A revamp of the dashboard news widget to bring in nearby and upcoming events including meetups and WordCamps.</li>\n<li>Several new media widgets covering images, audio, and video, and an enhancement to the text widget to support visual editing.</li>\n</ul>\n<p>The first beta of 4.8 is now available for testing. You can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">beta tester plugin</a> (or just run trunk) to try the latest and greatest, and each of these areas could use a ton of testing. Our goals are to make editing posts with links more intuitive, make widgets easier for new users and more convenient for existing ones, and get many more people aware of and attending our community events.</p>\n<p><em>Four point eight is here<br />\nSmall changes with a big punch<br />\nBig ones come later</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4727\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:36:\"\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 4.7.4 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2017/04/wordpress-4-7-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Apr 2017 17:54:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4710\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:376:\"After almost sixty million downloads of WordPress 4.7, we are pleased to announce the immediate availability of WordPress 4.7.4, a maintenance release. This release contains 47 bug fixes and enhancements, chief among them an incompatibility between the upcoming Chrome version and the visual editor, inconsistencies in media handling, and further improvements to the REST API.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Pascal Birchler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4518:\"<p>After almost sixty million downloads of WordPress 4.7, we are pleased to announce the immediate availability of WordPress 4.7.4, a maintenance release.</p>\n<p>This release contains 47 maintenance fixes and enhancements, chief among them an incompatibility between the upcoming Chrome version and the visual editor, inconsistencies in media handling, and further improvements to the REST API. For a full list of changes, consult the <a href=\"https://codex.wordpress.org/Version_4.7.4\">release notes</a> and the <a href=\"https://core.trac.wordpress.org/log/branches/4.7?rev=40487&amp;stop_rev=40224\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.4</a> or visit <strong>Dashboard → Updates</strong> and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.4.</p>\n<p>Thanks to everyone who contributed to 4.7.4:<br />\n<a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/aussieguy123/\">aussieguy123</a>, <a href=\"https://profiles.wordpress.org/blobfolio/\">Blobfolio</a>, <a href=\"https://profiles.wordpress.org/boldwater/\">boldwater</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bor0/\">Boro Sitnikovski</a>, <a href=\"https://profiles.wordpress.org/chesio/\">chesio</a>, <a href=\"https://profiles.wordpress.org/curdin/\">Curdin Krummenacher</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber/\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/nerrad/\">Darren Ethier (nerrad)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy/\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/davidbenton/\">davidbenton</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling (ocean90)</a>, <a href=\"https://profiles.wordpress.org/eclev91/\">eclev91</a>, <a href=\"https://profiles.wordpress.org/iseulde/\">Ella Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/ghosttoast/\">Gustave F. Gerhardt</a>, <a href=\"https://profiles.wordpress.org/ig_communitysites/\">ig_communitysites</a>, <a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/karinedo/\">karinedo</a>, <a href=\"https://profiles.wordpress.org/lukasbesch/\">lukasbesch</a>, <a href=\"https://profiles.wordpress.org/maguiar/\">maguiar</a>, <a href=\"https://profiles.wordpress.org/matheusgimenez/\">MatheusGimenez</a>, <a href=\"https://profiles.wordpress.org/mboynes/\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mattwiebe/\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mayurk/\">Mayur Keshwani</a>, <a href=\"https://profiles.wordpress.org/melchoyce/\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/delawski/\">Piotr Delawski</a>, <a href=\"https://profiles.wordpress.org/pratikshrestha/\">Pratik Shrestha</a>, <a href=\"https://profiles.wordpress.org/programmin/\">programmin</a>, <a href=\"https://profiles.wordpress.org/rachelbaker/\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/sagarkbhatt/\">sagarkbhatt</a>, <a href=\"https://profiles.wordpress.org/sagarprajapati/\">Sagar Prajapati</a>, <a href=\"https://profiles.wordpress.org/sboisvert/\">sboisvert</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic/\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/cybr/\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/timmydcrawford/\">Timmy Crawford</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, and <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4710\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 4.7.3 Security and Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"https://wordpress.org/news/2017/03/wordpress-4-7-3-security-and-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 06 Mar 2017 17:53:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4696\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:396:\"WordPress 4.7.3 is now available. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7.2 and earlier are affected by six security issues: Cross-site scripting (XSS) via media file metadata.  Reported by Chris Andrè Dale, Yorick Koster, and Simon P. Briggs. Control characters can trick redirect [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"James Nylen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6191:\"<p>WordPress 4.7.3 is now available. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7.2 and earlier are affected by six security issues:</p>\n<ol>\n<li>Cross-site scripting (XSS) via media file metadata.  Reported by <a href=\"https://www.securesolutions.no/\">Chris Andrè Dale</a>, <a href=\"https://twitter.com/yorickkoster\">Yorick Koster</a>, and Simon P. Briggs.</li>\n<li>Control characters can trick redirect URL validation.  Reported by <a href=\"http://www.danielchatfield.com/\">Daniel Chatfield</a>.</li>\n<li>Unintended files can be deleted by administrators using the plugin deletion functionality.  Reported by <a href=\"https://hackerone.com/triginc\">TrigInc</a> and <a href=\"http://b.360.cn/\">xuliang</a>.</li>\n<li>Cross-site scripting (XSS) via video URL in YouTube embeds.  Reported by <a href=\"https://twitter.com/marcs0h\">Marc Montpas</a>.</li>\n<li>Cross-site scripting (XSS) via taxonomy term names.  Reported by <a href=\"https://profiles.wordpress.org/deltamgm2\">Delta</a>.</li>\n<li>Cross-site request forgery (CSRF) in Press This leading to excessive use of server resources.  Reported by Sipke Mellema.</li>\n</ol>\n<p>Thank you to the reporters for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p>In addition to the security issues above, WordPress 4.7.3 contains 39 maintenance fixes to the 4.7 release series. For more information, see the <a href=\"https://codex.wordpress.org/Version_4.7.3\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=4.7.3&amp;group=component&amp;col=id&amp;col=summary&amp;col=component&amp;col=status&amp;col=owner&amp;col=type&amp;col=priority&amp;col=keywords&amp;order=priority\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.3</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.3.</p>\n<p>Thanks to everyone who contributed to 4.7.3: <a href=\"https://profiles.wordpress.org/aaroncampbell/\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/asalce/\">asalce</a>, <a href=\"https://profiles.wordpress.org/blobfolio/\">blobfolio</a>, <a href=\"https://profiles.wordpress.org/gitlost/\">bonger</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bor0/\">Boro Sitnikovski</a>, <a href=\"https://profiles.wordpress.org/bradyvercher/\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/drrobotnik/\">Brandon Lavigne</a>, <a href=\"https://profiles.wordpress.org/bhargavbhandari90/\">Bunty</a>, <a href=\"https://profiles.wordpress.org/ccprog/\">ccprog</a>, <a href=\"https://profiles.wordpress.org/ketuchetan/\">chetansatasiya</a>, <a href=\"https://profiles.wordpress.org/davidakennedy/\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dhanendran/\">Dhanendran</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling (ocean90)</a>, <a href=\"https://profiles.wordpress.org/drivingralle/\">Drivingralle</a>, <a href=\"https://profiles.wordpress.org/iseulde/\">Ella Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jazbek/\">jazbek</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry/\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/joehoyle/\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/markoheijnen/\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/matheusgimenez/\">MatheusGimenez</a>, <a href=\"https://profiles.wordpress.org/mnelson4/\">Mike Nelson</a>, <a href=\"https://profiles.wordpress.org/mikeschroder/\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/codegeass/\">Muhammet Arslan</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pavelevap/\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/rachelbaker/\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/reldev/\">reldev</a>, <a href=\"https://profiles.wordpress.org/sanchothefat/\">Robert O&#8217;Rourke</a>, <a href=\"https://profiles.wordpress.org/welcher/\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/sanketparmar/\">Sanket Parmar</a>, <a href=\"https://profiles.wordpress.org/seanchayes/\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/triplejumper12/\">triplejumper12</a>, <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>, and <a href=\"https://profiles.wordpress.org/wpfo/\">wpfo</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4696\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 4.7.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Jan 2017 19:34:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4676\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"WordPress 4.7.2 is now available. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7.1 and earlier are affected by three security issues: The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Aaron D. Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2142:\"<p>WordPress 4.7.2 is now available. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7.1 and earlier are affected by three security issues:</p>\n<ol>\n<li>The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. Reported by David Herrera of <a href=\"https://www.alleyinteractive.com/\">Alley Interactive</a>.</li>\n<li><code>WP_Query</code> is vulnerable to a SQL injection (SQLi) when passing unsafe data. WordPress core is not directly vulnerable to this issue, but we&#8217;ve added hardening to prevent plugins and themes from accidentally causing a vulnerability. Reported by <a href=\"https://github.com/mjangda\">Mo Jangda</a> (batmoo).</li>\n<li>A cross-site scripting (XSS) vulnerability was discovered in the posts list table. Reported by <a href=\"https://iandunn.name/\">Ian Dunn</a> of the WordPress Security Team.</li>\n<li>An unauthenticated privilege escalation vulnerability was discovered in a REST API endpoint. Reported by <a href=\"https://twitter.com/MarcS0h\">Marc-Alexandre Montpas</a> of Sucuri Security. *</li>\n</ol>\n<p>Thank you to the reporters of these issues for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.2</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.2.</p>\n<p>Thanks to everyone who contributed to 4.7.2.</p>\n<p>* Update: An additional serious vulnerability was fixed in this release and public disclosure was delayed. For more information on this vulnerability, additional mitigation steps taken, and an explanation for why disclosure was delayed, please read <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\">Disclosure of Additional Security Fix in WordPress 4.7.2</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4676\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"14607090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 15 Jun 2017 11:36:47 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Thu, 08 Jun 2017 16:08:34 GMT\";s:4:\"link\";s:63:\"<https://wordpress.org/news/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("2150", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1497569812", "no");
INSERT INTO `act_options` VALUES("2151", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1497526612", "no");
INSERT INTO `act_options` VALUES("2153", "_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "1497569817", "no");
INSERT INTO `act_options` VALUES("2154", "_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"Post Status: An entrepreneurial journey around eCommerce, with Patrick Rauland — Draft Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=37565\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"https://poststatus.com/entrepreneurial-journey-around-ecommerce-patrick-rauland-draft-podcast/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2487:\"<p>Welcome to the Post Status <a href=\"https://poststatus.com/category/draft\">Draft podcast</a>, which you can find <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">on iTunes</a>, <a href=\"https://play.google.com/music/m/Ih5egfxskgcec4qadr3f4zfpzzm?t=Post_Status__Draft_WordPress_Podcast\">Google Play</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, and <a href=\"http://simplecast.fm/podcasts/1061/rss\">via RSS</a> for your favorite podcatcher. Post Status Draft is hosted by the creator and editor of Post Status, Brian Krogsgard, and this week&#8217;s guest host, Patrick Rauland.</p>\n<p>In this episode, Brian and Patrick Rauland discuss the state of eCommerce today, both from a product perspective, and for store owners. They also discuss Patrick’s own journeys in the land of eCommerce, as a former product manager for WooCommerce, a course author for Lynda (now LinkedIn Learning), consulting, and putting on an online eCommerce conference.</p>\n<p><!--[if lt IE 9]><script>document.createElement(\'audio\');</script><![endif]-->\n<a href=\"https://audio.simplecast.com/72909.mp3\">https://audio.simplecast.com/72909.mp3</a><br />\n<a href=\"https://audio.simplecast.com/72909.mp3\">Direct Download</a></p>\n<h3>Links</h3>\n<ul>\n<li><a href=\"https://www.speakinginbytes.com/\">Patrick&#8217;s programming blog</a></li>\n<li><a href=\"https://www.liftoffsummit.com/\">Lift Off Summit</a></li>\n<li><a href=\"https://neversettle.it/projects/apis/ns-fba-for-woocommerce-premium-wordpress-plugins/\">Amazon FBA for WooCommerce</a></li>\n<li><a href=\"http://www.shipstation.com/\">ShipStation</a></li>\n<li><a href=\"https://www.stitchlabs.com/\">Stitch Labs</a></li>\n<li><a href=\"http://www.tropicalmba.com/\">Tropical MBA</a></li>\n<li><a href=\"https://wooconf.com/\">WooConf</a></li>\n<li><a href=\"http://www.ecommercefuel.com/\">eCommerceFuel</a></li>\n<li><a href=\"https://poststatus.com/publish/\">Post Status Publish</a></li>\n</ul>\n<p><a href=\"https://www.flickr.com/photos/46544223@N05/26247563071/in/photostream/\">Photo Credit</a></p>\n<h3>Sponsor: Pagely</h3>\n<p><a href=\"https://pagely.com\"><span>Pagely</span></a><span> offers best in class managed WordPress hosting, powered by the Amazon Cloud, the Internet’s most reliable infrastructure. Post Status is proudly hosted by Pagely. Thank you to </span><a href=\"https://pagely.com\"><span>Pagely</span></a><span> for being a Post Status partner.</span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 15 Jun 2017 01:30:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Katie Richards\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WPTavern: WPWeekly Episode 277 – WordPress 4.8, Filing Good Bug Reports, and WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=71968&preview=true&preview_id=71968\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"https://wptavern.com/wpweekly-episode-277-wordpress-4-8-filing-good-bug-reports-and-wp-super-cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3427:\"<p>In this episode, <a href=\"https://jjj.blog/\">John James Jacoby</a> and I start off the show by sending Jesse Peterson our thoughts, prayers, and positive energy. Peterson is a longtime member of the WordPress community, founder of<a href=\"https://www.genesisthe.me/\"> Genesis The.me</a>, and is battling <a href=\"http://www.cffatboy.com/what-is-cystic-fibrosis/\">Cystic Fibrosis</a>. He received the call last Friday to receive a double-lung transplant but the surgery was cancelled after doctors determined the lungs were bad after removing them from the patient. We&#8217;re hoping he gets the call again soon!</p>\n<p>We give insight into what&#8217;s new in WordPress 4.8, provide tips for filing a good bug report, and tell you what to expect in the next major version of WP Super Cache. We discuss Imagely acquiring TeslaThemes and near the end of the show, we talk about the WordPress Community Summit at WordCamp Europe.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wptavern.com/wordpress-4-8-evans-released-featuring-nearby-wordpress-events-new-media-widgets-and-link-boundaries\">WordPress 4.8 “Evans” Released Featuring Nearby WordPress Events, New Media Widgets, and Link Boundaries</a><br />\n<a href=\"https://wptavern.com/harare-zimbabwe-to-host-its-2nd-wordcamp-november-4-2017\">Harare, Zimbabwe to Host Its 2nd WordCamp November 4, 2017</a><br />\n<a href=\"https://wptavern.com/major-update-coming-to-wp-super-cache-new-rest-api-user-friendly-settings-page-and-improvements-to-legacy-file-storage\">Major Update Coming to WP Super Cache: New REST API, User-Friendly Settings Page, and Improvements to Legacy File Storage</a><br />\n<a href=\"https://wptavern.com/imagely-acquires-teslathemes-is-seeking-other-acquisition-opportunities\">Imagely Acquires TeslaThemes, Is Seeking Other Acquisition Opportunities</a></p>\n<h2>Picks of the Week:</h2>\n<p><a href=\"https://wptestdrive.com/\">wpTestDrive</a> allows you to try commercial themes and plugins before purchasing them. wpTestDrive creates a new WordPress instance with admin access where you can test plugins, themes, and their add-ons with or without demo content. It’s free, and test drives stay active for 10 days for registered members or 24 hours for guests. The site uses affiliate links to commercial products to offset the cost of running the site.</p>\n<p><a href=\"https://wordpress.org/plugins/camptix/\">CampTix</a> is a free, open source ticketing plugin for WordPress that powers the ticket purchasing experience on WordCamp.org. Some of its features include, multiple ticket and attendee forms, coupon codes, mass emailing of attendees, exporting data into CSV or XML, refunds, and more.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, June 21st 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #277:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 14 Jun 2017 23:22:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"HeroPress: Trust Yourself\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1915\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"https://heropress.com/essays/trust-yourself/?utm_source=rss&utm_medium=rss&utm_campaign=trust-yourself\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8453:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/06/061417-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: Be open minded, trust yourself, and talk about what matters to you.\" /><p><em><strong>Editor&#8217;s Note:</strong> Birgit has been a friend of HeroPress since it&#8217;s very beginning. Through the oddities of life she was never able to do an essay. Recently she told me she would have one soon. This is not that essay. Our contributor this week needed some extra time and Birgit said she had something she wanted to write about, so here it is. Many thanks Birgit.</em></p>\n<p>Something is in the air. Do you feel the WordPress vibrations? It&#8217;s shortly before the fifth WordCamp Europe which will be held in Paris this year. The social channels like Twitter &amp; Co. are flooded with pre-event messages. You can feel the emotions of excitement and sadness in the timeline nearby. People share their excitement about their upcoming attendance and others who can&#8217;t make it. I am a person who belongs to both groups.</p>\n<p>But let me begin some months ago to tell you how this came to be. After WordCamp Europe in Vienna last summer I purchased my ticket for WCEU 2017 in Paris directly after the ticket sale was opened. There was no doubt at all I would participate.</p>\n<blockquote><p>How life&#8217;s play changes, it worked out differently than planned.</p></blockquote>\n<p>I&#8217;ve struggled with some health issues over several years. Mostly caused by stress during and after the divorce, as well as some deaths in the vicinity. Nothing really serious, but not ignorable. I thought&#8230; But at the end of the summer last year I got seriously ill. Not the right place for details here, but I had to quit my day job in a small agency because the fixed-term employment contract ended at the same time. Also, I had to reduce any contributions to the WordPress project. I had to reduce my freelancing contracts, too.</p>\n<p>I ran from one medical specialist to the other to find the cause of my illness. I was so frustrated not to be able to work like I&#8217;ve done before and so upset about the brain-fog and the fatigue. It was so depressing. As a mom of five children, it is not funny to be ill. The three youngest kids are living at home with me and my new partner. My oldest daughter bought her own house. But I couldn&#8217;t help her while moving. Can you imagine, how frustrating this could be?</p>\n<p>But hey &#8211; I am a fighter like a lioness. I put everything on the plate, invested my small savings into healing treatments and so on.</p>\n<blockquote><p>To make a long story short, I am getting healthier every day.</p></blockquote>\n<p>We found the cause and the healing treatments are helping like expected. Two operations went well. It is a process, but it&#8217;s going forward.</p>\n<p>Sitting at home without a job is not my thing, so I searched for a new day job. I found a part-time employment in my hometown as a head of a tutoring institute. It is ok, but nothing WordPress related. It secures my existence. But my saving balance allowed no budget for WordCamp travels. I gave up thoughts of attending WordCamp Europe in Paris this year.</p>\n<p>So I decided to offer my ticket.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">I’v to sell my <a href=\"https://twitter.com/hashtag/wceu?src=hash\">#wceu</a> ticket I bought last year. Unless it happens a miracle and there is a sponsor for stay &amp; travel <a href=\"https://twitter.com/WCEurope\">@WCEurope</a> <a href=\"https://t.co/PFWBTtSmlq\">pic.twitter.com/PFWBTtSmlq</a></p>\n<p>&mdash; Coach Birgit Olzem (@CoachBirgit) <a href=\"https://twitter.com/CoachBirgit/status/867323301399588864\">May 24, 2017</a></p></blockquote>\n<p></p>\n<p>The unexpected miracle happened. I found sponsors for travel &amp; stay without active seeking. My generous sponsors rewarded my past contributions to WordPress and Community over several years with this openhearted support. I am so grateful for this.</p>\n<p>Since 2012 I have been an active member of the WordPress Community. First as the main responsible person for the translations of WordPress into German, then as a part of the international Polyglots team. I am also editor and release manager for local German site and I am a member of some other contribution teams in the WordPress ecosystem. I spent a lot of spare time and money on contributions and WordCamp travels.</p>\n<blockquote><p>Perhaps you can imagine how frustrating it was, that I couldn&#8217;t afford to travel to WordCamp Europe.</p></blockquote>\n<p>An event where I can meet a lot of friends I made over the last years. Even more, I was happy to get the generous sponsoring. I am so grateful!</p>\n<p>In the last two years I had to reduce my contribution time and disappeared from the scene, but I followed the changes and enhancements within the community in the background. Nevertheless I wasn&#8217;t forgotten.</p>\n<p>And it&#8217;s not only me who get help to attend to WCEU:</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Today is a completely different day. Largely thanks to <a href=\"https://twitter.com/jdevalk\">@jdevalk</a> (and team <a href=\"https://twitter.com/yoast\">@yoast</a> ) I WILL be attending. Beyond grateful is what I am.</p>\n<p>&mdash; Remkus de Vries (@DeFries) <a href=\"https://twitter.com/DeFries/status/874595421112414208\">June 13, 2017</a></p></blockquote>\n<p></p>\n<p>Everyone has had some downs and some ups. If you ask, there is always someone who is willing to help you. It is an example of a mindset from an open-source community like the WordPress community and it reflects the philosophy. You can get everything, but you have to ask. Only speaking people can be helped.</p>\n<p>Apropos speaking people can get helped:</p>\n<p>I have a dream over some years to contribute to WordPress in full-time as a WordPress Community Manager. There are so many things I can do even if I am not a full-stack developer. Perhaps this miracle happens, too. But at this moment I am sitting on my suitcases to write about the generosity in the WordPress Community. This essay wasn&#8217;t planned, but it happened to have been written.</p>\n<p>I am so grateful for my heroes who made it happen, that I can go to the WordCamp Europe this year.</p>\n<p>There are so many unseen heroes outside who need to be seen.</p>\n<blockquote><p>Be open minded, trust yourself and talk about what matters to you.</p></blockquote>\n<p>There is a light at the end of the tunnel. Be your own hero.</p>\n<p>Beyond everything else: Care about yourself!</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Trust Yourself\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Trust%20Yourself&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-yourself%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Trust Yourself\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-yourself%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-yourself%2F&title=Trust+Yourself\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Trust Yourself\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/trust-yourself/&media=https://heropress.com/wp-content/uploads/2017/06/061417-150x150.jpg&description=Trust Yourself\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Trust Yourself\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/trust-yourself/\" title=\"Trust Yourself\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/trust-yourself/\">Trust Yourself</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 14 Jun 2017 08:00:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Birgit Olzem\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Imagely Acquires TeslaThemes, Is Seeking Other Acquisition Opportunities\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71716\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://wptavern.com/imagely-acquires-teslathemes-is-seeking-other-acquisition-opportunities\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4432:\"<p>In an effort to diversify and expand into the commercial WordPress theme market, <a href=\"https://www.imagely.com\">Imagely</a>, maintainers of <a href=\"https://www.imagely.com/wordpress-gallery-plugin/\">NextGEN Gallery</a>, <a href=\"https://www.imagely.com/tesla-themes-acquisition/\">have acquired</a> <a href=\"http://teslathemes.com/\">TeslaThemes</a> for an undisclosed amount.</p>\n<p>TeslaThemes <a href=\"https://wptavern.com/interview-with-brand-new-theme-club-teslathemes\">launched in 2013</a> as a theme club and recently celebrated its <a href=\"http://teslathemes.com/blog/teslathemes-anniversary-giveaway-and-redesign-announcement/\">fourth anniversary</a>. The company has 68 themes in its library, including the TeslaThemes framework.</p>\n<p>Eric Danzer, Founder and CEO of Imagely, says no major changes will be happening with TeslaThemes and that their immediate focus will be to provide maintenance and support.</p>\n<p>&#8220;Beyond that, our goal is to do more of what Tesla has already been doing so well &#8211; creating beautiful new themes and continually enhancing the existing themes,&#8221; Danzer said.</p>\n<p>Imagely has been busy this year launching a <a href=\"https://www.imagely.com/websites/\">managed WordPress hosting service</a> for photographers, releasing <a href=\"https://www.imagely.com/wordpress-photography-themes/\">new photography themes</a>, and an <a href=\"https://www.imagely.com/wordpress-lightroom-plugin/\">Adobe Lightroom plugin</a> that allows users to manage NextGEN galleries from within Lightroom.</p>\n<p>Later this year, Imagely plans to release a new version of NextGEN gallery with a redesigned backend interface. The company is also working on a way to add automated print fulfillment to WordPress.</p>\n<p>&#8220;Automated print fulfillment allows photographers to sell prints from their websites, and have those prints automatically delivered via the print lab without any intervention on their part,&#8221; Danzer said.</p>\n<p>&#8220;This functionality drives many large companies in the photo industry &#8211; SmugMug, ShootProof, Pixieset, Zenfolio, Photoshelter, and others. But it&#8217;s not possible yet on WordPress.</p>\n<p>&#8220;Bringing a full print solution to WordPress has the potential to revolutionize the photo industry and make WordPress the default web solution for photographers that it should be.&#8221;</p>\n<p>Marcel Sobieski, co-founder of TeslaThemes, <a href=\"http://teslathemes.com/blog/acquisition/\">thanked customers</a> for their support and confirmed that they exited the company on June 9th.</p>\n<p>&#8220;We built a solid, trusted and valuable business, that is needed on the market and is appreciated both by industry colleagues and clients,&#8221; Sobieski said.</p>\n<p>This is the second exit in the last six months for Sobieski and his team. The sale of TeslaThemes will allow them to focus on a new venture called <a href=\"http://www.wpmatic.io/\">WPMatic.io</a>, a one-on-one WordPress support and development company.</p>\n<p>&#8220;The six years of experience that we have in WordPress is already helping a few hundred clients and tens of companies and agencies in need, right after purchasing a WP Theme from the market,&#8221; Sobieski said.</p>\n<p>&#8220;Soon we will start partnering with some of the best WP Theme Clubs to deliver a unique experience for their clients.&#8221;</p>\n<p>The acquisition of TeslaThemes represents Imagely&#8217;s first major move into the general WordPress products market. The company is also seeking acquisition opportunities for other WordPress plugin and theme companies.</p>\n<p>&#8220;In the coming years, we&#8217;ll be both building and be acquiring a range of other WordPress theme and plugin companies,&#8221; Danzer said.</p>\n<p>&#8220;I&#8217;ll even add a small call here: if you have a solid WordPress product, with a great brand and stable revenue over around $200,000, and you are looking to exit, feel free to reach out to me directly to chat.&#8221;</p>\n<p><strong>Correction: June 14th, 2017</strong> The article incorrectly identifies Imagely as the creators of NextGEN Gallery. Alex Rabe is the creator of NextGEN Gallery and he <a href=\"https://alexrabe.wordpress.com/nextgen-gallery/\">released it in 2007</a>. Photocrati <a href=\"https://www.imagely.com/photocrati-acquires-nextgen-gallery/\">acquired the plugin</a> in February, 2016.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 13 Jun 2017 21:33:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Akismet: Coming Soon to a Jetpack Near You\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1942\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://blog.akismet.com/2017/06/13/coming-soon-to-a-jetpack-near-you/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:999:\"<p>If you haven&#8217;t tried Jetpack yet &#8212; our sister plugin &#8212; there&#8217;s never been a better time to add it to your bucket list.</p>\n<p>In the coming weeks we&#8217;ll be announcing a really exciting new addition to Jetpack&#8217;s services and you can <a href=\"https://jetpack.com/know/\">sign up to get early access right here</a>.</p>\n<div id=\"v-Q1CJRnNs-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1942/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1942/\" /></a> <img alt=\"\" border=\"0\" src=\"http://pixel.wp.com/b.gif?host=blog.akismet.com&blog=116920&post=1942&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://blog.akismet.com/2017/06/13/coming-soon-to-a-jetpack-near-you/\"><img alt=\"Coming Soon to Jetpack\" src=\"http://videos.videopress.com/Q1CJRnNs/jetpack_30secondsfinal_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 13 Jun 2017 10:00:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Richard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: WordCamp for Publishers Opens Up Ticket Sales, 50% Sold in the First Day\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71732\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"https://wptavern.com/wordcamp-for-publishers-opens-up-ticket-sales-50-sold-in-the-first-day\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2365:\"<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/06/wordcamp-for-publishers-2017.png?ssl=1\"><img /></a></p>\n<p>WordCamp for Publishers, the first niche WordCamp to be focused around a specific industry, <a href=\"https://2017-denver.journalist.wordcamp.org/tickets/\" target=\"_blank\">opened up ticket sales</a> today. The event will take place in Denver, Colorado, August 17-19, and organizers have planned for just 230 attendees, due to venue constraints. In less than 24 hours since tickets went on sale, the event is already 50% sold out.</p>\n<p><a href=\"https://2017-denver.journalist.wordcamp.org/speakers/\" target=\"_blank\">Speakers</a> and workshop facilitators have already been selected and published to the event&#8217;s website, featuring publication directors, developers, product managers, and other industry experts.</p>\n<p>The tentative schedule for the WordCamp includes a mixture of presentations, hands-on workshops, and social events to encourage networking and collaboration among publishers.</p>\n<ul>\n<li><strong>Thursday, August 17:</strong> Presentations and workshops, followed by a brewery tour</li>\n<li><strong>Friday, August 18:</strong> Presentations and workshops, followed by an after party</li>\n<li><strong>Saturday, August 19:</strong> Publisher plugin contributor day, followed by a Rockies baseball game</li>\n</ul>\n<p>One of the goals for the event is to encourage those who are maintaining open source tools for publishers to work together towards ensuring a strong future for those projects. Contributing is an important part of the event, as many of the organizers have experience working at or with publishing organizations that heavily rely on open source tools.</p>\n<p>The <a href=\"http://www.denverpost.com/\" target=\"_blank\">Denver Post</a> has donated the venue for the event as an official sponsor and the official hotel is a five-minute walk from there. After purchasing a ticket online, attendees will receive an email with a link to make a reservation at the Sheraton Denver Downtown Hotel, which has a designated block of rooms for WordCampers.</p>\n<p>Organizers expect the event to sell out quickly, so if you&#8217;re thinking of attending, don&#8217;t wait to <a href=\"https://2017-denver.journalist.wordcamp.org/tickets/\" target=\"_blank\">buy your ticket</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 22:05:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: Unsplash Updates its License, Raises GPL Compatibility Concerns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71742\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"https://wptavern.com/unsplash-updates-its-license-raises-gpl-compatibility-concerns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6631:\"<p><a href=\"https://unsplash.com/\">Unsplash.com</a>, a site that provides high-resolution photos for free, updated its license and the change has people in the WordPress community concerned.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">So unsplash images are no longer public domain. No longer gpl compatible. What does it mean for <a href=\"https://twitter.com/hashtag/WordPressThemes?src=hash\">#WordPressThemes</a>  that uses these images?</p>\n<p>&mdash; Carolina Nymark (@carolinapoena) <a href=\"https://twitter.com/carolinapoena/status/872977081067548672\">June 9, 2017</a></p></blockquote>\n<p></p>\n<p>Prior to the change, Unsplash&#8217;s license stated the following:</p>\n<blockquote><p><span>All photos published on Unsplash are licensed under <a href=\"https://web.archive.org/web/20170530053437/http://creativecommons.org/publicdomain/zero/1.0/\">Creative Commons Zero</a> which means you can copy, modify, distribute and use the photos for free, including commercial purposes, without asking permission from or providing attribution to the photographer or Unsplash.</span></p></blockquote>\n<p>According to GNU.org, the CC0 or Creative Commons Zero license <a href=\"https://www.gnu.org/licenses/license-list.en.html\">is compatible</a> with the GPL.</p>\n<blockquote><p>CC0 is a public domain dedication from Creative Commons. A work released under CC0 is dedicated to the public domain to the fullest extent permitted by law. If that is not possible for any reason, CC0 also provides a lax, permissive license as a fallback. Both public domain works and the lax license provided by CC0 are compatible with the GNU GPL.</p>\n<p>If you want to release your work to the public domain, we recommend you use CC0.</p></blockquote>\n<p>Unsplash&#8217;s new license states (emphasis mine):</p>\n<blockquote><p>All photos published on Unsplash can be used for free. You can use them for commercial and noncommercial purposes. You do not need to ask permission from or provide credit to the photographer or Unsplash, although it is appreciated when possible.</p>\n<p>More precisely, Unsplash grants you a nonexclusive copyright license to download, copy, modify, distribute, perform, and use photos from Unsplash for free, including for commercial purposes, without permission from or attributing the photographer or Unsplash. <strong>This license does not include the right to compile photos from Unsplash to replicate a similar or competing service. </strong></p></blockquote>\n<p>The inability to compile photos from Unsplash to replicate a similar or competing service is a restriction on how the photos can be used, calling into question its compatibility with the GPL.</p>\n<p>Luke Chesser, co-founder of Unsplash, <a href=\"https://twitter.com/lukechesser/status/873146783945416704\">explained on</a> Twitter that individual photos have no restrictions.</p>\n<p>&#8220;The Unsplash license doesn&#8217;t violate GPL and can still be used in WordPress themes,&#8221; Chesser said. &#8220;There are no restrictions on the individual photos.</p>\n<p>&#8220;There is only a restriction on the collection of photos, which doesn&#8217;t even apply unless your intent is to create a similar service.&#8221;</p>\n<p>For example, it&#8217;s ok if someone creates a site that displays the best photos of bridges from Unsplash. But if the site makes those photos available for download, it would <a href=\"https://community.unsplash.com/help-section/do-i-have-to-give-credit-to-a-photographer-when-i-use-their-photo\">violate the license</a>.</p>\n<p>On its FAQ page, Unsplash <a href=\"https://community.unsplash.com/help-section/what-is-the-unsplash-license-and-where-can-i-find-it\">explains why</a> the restriction was put in place:</p>\n<blockquote><p>The fuel that drives Unsplash is the exceptional images that are generously contributed by people from all over the world. Without them, none of this would work. Unsplash would be nothing. We owe everyone who’s contributed a photo not only a thank you but support and empowerment for the gifts they’ve given us.</p>\n<p>Out of respect for our contributors and our ability to uphold our value of empowering creativity, we added this sentence to the Unsplash License.</p>\n<p>We don’t support the mass duplication of Unsplash photos with the purpose of replicating a similar or competing service because it leads to confusion which negatively impacts both the spirit of open creative use and the celebration of Unsplash contributors.</p></blockquote>\n<p>Mass compiling of photos from Unsplash to distribute on other sites has created legal issues in the past. &#8220;Sites that mass duplicate and compile Unsplash photos point support and legal issues back to Unsplash, while continuing to redistribute photos that may be removed on Unsplash,&#8221; the company said.</p>\n<p>The reasons cited by Unsplash for putting the restriction in place are some of the same reasons WordPress plugin developers <a href=\"https://wptavern.com/the-gpl-license-doesnt-provide-the-freedom-to-infringe-registered-trademarks\">register trademarks</a>. The GPL allows the following freedoms.</p>\n<ol start=\"0\">\n<li>The freedom to run the program, for any purpose.</li>\n<li>The freedom to study how the program works, and change it so it does your computing as you wish.</li>\n<li>The freedom to redistribute copies so you can help your neighbor.</li>\n<li>The freedom to distribute copies of your modified versions, giving the community a chance to benefit from your changes.</li>\n</ol>\n<p>Over the years, there have been many instances in the WordPress community where businesses have taken advantage of these freedoms merely to profit from the work of others.</p>\n<p>The reselling of commercial plugins causes confusion in the market and resellers typically point support and other inquiries back to the plugin&#8217;s developers.</p>\n<p>Trademarks give commercial plugin authors measures to protect their brand without violating the GPL. A good example is the <a href=\"http://www.gravityforms.com/trademark/\">GravityForms Trademark page</a> which clearly outlines how its brand can be used and displayed.</p>\n<p>For now, it appears that most people who use Unsplash will be unaffected by the licensing change. However, as long as there is one license that governs the use of images and it has at least one restriction, its compatibility with the GPL will remain in doubt.</p>\n<p><strong>Correction June 14th</strong> Luke Chesser, co-founder of Unsplash, did not say that individual photos are still CC0-licensed but rather, have no restrictions.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 21:27:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"WPTavern: Major Update Coming to WP Super Cache: New REST API, User-Friendly Settings Page, and Improvements to Legacy File Storage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71718\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:139:\"https://wptavern.com/major-update-coming-to-wp-super-cache-new-rest-api-user-friendly-settings-page-and-improvements-to-legacy-file-storage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2550:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2015/04/wp-super-cache.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://wordpress.org/plugins/wp-super-cache/\" target=\"_blank\">WP Super Cache</a>, a WordPress caching plugin maintained by Donncha Ó Caoimh and Automattic, is looking for users to help test the plugin <a href=\"https://odd.blog/2017/06/07/take-a-sneak-peek-at-wp-super-cache/\" target=\"_blank\">ahead of the next major update</a>. Ó Caoimh said the upcoming release is in a &#8220;stable and usable&#8221; state, but with the unusually large number of bug fixes and new features, it could use some testing in different environments.</p>\n<p>WP Super Cache is set to introduce a REST API, which will be useful for situations where administrators are not using wp-admin to manage their sites. The plugin is also <a href=\"https://github.com/Automattic/wp-super-cache/pull/177\" target=\"_blank\">changing the location for storing legacy cache files</a> to the supercache directory.</p>\n<p>&#8220;This makes it easier to manage these files,&#8221; Ó Caoimh said. &#8220;The plugin doesn’t have to search through potentially hundreds of cache files for those that need to be deleted if a page updates or someone leaves a comment. Now all those files will be in the same directory structure the anonymous “supercache” files will be. I’m really excited about this feature as it makes caching for logged-in users/users who comment and caching of pages with parameters so much faster now.&#8221;</p>\n<p>Ó Caoimh is also updating the settings page to make it easier for new users to understand the options. Currently it asks the user to select from mod_rewrite, PHP, or Legacy page caching with little explanation for why a user might opt for a certain delivery method. The new settings page simplifies the language used to describe the caching types.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/06/wp-super-cache-new-settings.png?ssl=1\"><img /></a></p>\n<p>The upcoming release will also <a href=\"https://github.com/Automattic/wp-super-cache/pulls?q=is%3Apr+is%3Aclosed\" target=\"_blank\">fix nearly 100 bugs</a>. As WP Super Cache is one of the most popular WordPress caching solutions and is active on more than a million sites, any problems with a major release will have a far-reaching impact. The latest changes to the plugin are <a href=\"https://github.com/Automattic/wp-super-cache\" target=\"_blank\">available on GitHub</a> for anyone who wants to help test.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 20:04:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Harare, Zimbabwe to Host Its 2nd WordCamp November 4, 2017\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71314\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"https://wptavern.com/harare-zimbabwe-to-host-its-2nd-wordcamp-november-4-2017\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3375:\"<a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2016/12/harare.jpg?ssl=1\"><img /></a>photo credit: <a href=\"https://www.lonelyplanet.com/zimbabwe/harare\">Lonely Planet</a>\n<p>Harare, Zimbabwe will be <a href=\"https://2017.harare.wordcamp.org/2017/01/18/welcome-to-wordcamp-harare/\" target=\"_blank\">hosting its second WordCamp</a> on November 4, 2017, at <a href=\"http://www.hellenicacademy.ac.zw/\" target=\"_blank\">Hellenic Academy</a>. The city was one of three selected to be part of the <a href=\"https://wptavern.com/wordcamp-incubator-program-to-launch-in-indonesia-zimbabwe-and-columbia\" target=\"_blank\">WordCamp Incubator Program</a> in 2016. Harare&#8217;s first WordCamp was successful in connecting the local WordPress community and inspiring local leaders to carry on with organizing future events.</p>\n<p>Last year the <a href=\"https://www.meetup.com/Harare-WordPress-Meetup/\" target=\"_blank\">Harare WordPress Meetup</a> had 82 members and the group has nearly doubled in size with 142 members today.  Members meet every month and communicate outside of meetings via an active WhatsApp group. The current venue they use was donated by <a href=\"http://motorepublik.co/\" target=\"_blank\">Moto Republik</a>, thanks to one of the members Munya Bloggo, who works there.</p>\n<p>&#8220;It was always the goal of the WordCamp Incubator program to organize an easily-reproducible event that we could organize independently in the years to come,&#8221; 2017 lead organizer <a href=\"https://franksweb.org/\" target=\"_blank\">Thabo Tswana</a> said. &#8220;We expected it of ourselves. Some attendees and organizers actually approached me about the next WordCamp during WordCamp Harare 2016.&#8221;</p>\n<p>Tswana said the turnout at last year&#8217;s event was larger than he expected, because very few attendees booked tickets online. The majority ended up buying tickets at the door on the day of the event, a fairly uncommon scenario for most WordCamps that makes it somewhat difficult to estimate total attendees.</p>\n<p>&#8220;One of the biggest impacts that WordCamp had was introducing us to the WordPress Community,&#8221; Tswana said. &#8220;There are so many WordPress users in Zimbabwe (bloggers, designers, developers) but hardly anyone knew about the WordPress Community or how to contribute to WordPress. We now have a growing meetup group and the local community is starting to become more aware of what WordPress has to offer.&#8221;</p>\n<p>The local community consists primarily of developers and advanced WordPress users and Tswana said he would like see more of them getting involved with contributing. As the majority of meetup members are new to the larger WordPress community, they are still learning about the many ways users can contribute back to the project.</p>\n<p>Two Harare WordPress Meetup members, Kudakwashe Zafevere and Rima Trew, arranged for Hellenic Academy to donate a venue for WordCamp Harare 2017. The facilities are well-suited to hosting a tech event with wifi available.</p>\n<p>&#8220;This year, some local companies and organizations expressed interest in helping us out,&#8221; Tswana said. &#8220;We definitely expect more attendees due to the buzz that was created by last year&#8217;s WordCamp. To sum it all up, more people and organizations are getting involved this year.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 02:33:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"WPTavern: WordPress 4.8 “Evans” Released Featuring Nearby WordPress Events, New Media Widgets, and Link Boundaries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71534\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"https://wptavern.com/wordpress-4-8-evans-released-featuring-nearby-wordpress-events-new-media-widgets-and-link-boundaries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7169:\"<p><a href=\"https://wordpress.org/news/2017/06/evans/\">WordPress 4.8 &#8220;Evans&#8221;</a> is available for download and is the first major release of the year under the <a href=\"https://wptavern.com/state-of-the-word-2016-mullenweg-pushes-calypso-as-future-of-wordpress-interface-proposes-major-changes-to-release-cycle\">new release cycle</a>. WordPress 4.8 is named after <a href=\"https://en.wikipedia.org/wiki/Bill_Evans\">William John &#8220;Bill&#8221; Evans</a>, an American jazz pianist.</p>\n<h2>New Image, Video, and Audio Widgets</h2>\n<p>WordPress 4.8 includes <a href=\"https://make.wordpress.org/core/2017/05/26/media-widgets-for-images-video-and-audio/\">three new widgets</a>. All three widgets make it easier to display images, video, or audio  without using HTML. The Text widget now has support for TinyMCE providing rich-text functionality. Similar to the post editor, users have a choice between using a Visual or Text editor with limited formatting options.</p>\n<img />Image, Video, and Enhanced Text Widget\n<p>Because the Text widget uses TinyMCE, it inherits its nuances when it comes to pasting and displaying code. In a <a href=\"https://make.wordpress.org/core/2017/05/23/addition-of-tinymce-to-the-text-widget/\">dev note</a> that explains how TinyMCE was added to the Text Widget, Weston Ruter offers the following notice.</p>\n<blockquote><p>When pasting HTML into the &#8216;Text&#8217; (HTML) tab of the Text widget, any extraneous line breaks should be removed or else unwanted paragraphs and line beaks may result. This is particularly important when you paste in <code>script</code> or <code>style</code> tags (as in the case of 3rd-party JavaScript embeds), since auto-inserted paragraphs will cause script errors; this will be fixed in <span class=\"p2_hovercardify\"><a href=\"https://core.trac.wordpress.org/ticket/2833\">#2833</a></span>.</p>\n<p>This behavior aligns with longstanding behavior in the post editor, so it is not new, although it does differ from how the Text widget has previously behaved. As noted above, for previously existing Text widgets that had the auto-add paragraphs&#8217; checkbox unchecked (and thus the <code>filter</code> instance prop set to <code>false</code>), the previous behavior of not doing <code>wpautop</code> will be maintained: only once the widgets are modified will any extraneous line breaks need to be removed.</p></blockquote>\n<h2>Link Boundaries</h2>\n<p>Adding and editing links in the visual editor is more intuitive thanks to link boundaries. Link boundaries provide a visual representation of where a link begins and ends. This helps prevent adding unnecessary text to the beginning or end of a link.</p>\n<p></p>\n<p></p>\n<h2>See Nearby WordPress Events in the Dashboard</h2>\n<p>One of the pillars of WordPress&#8217; ecosystem is its community of meetups and WordCamps. <a href=\"https://wptavern.com/state-of-the-word-2016-mullenweg-pushes-calypso-as-future-of-wordpress-interface-proposes-major-changes-to-release-cycle\">In 2016</a>, more than 62,566 people attended a local meetup in 58 countries. About a third of those were new members.</p>\n<p>WordPress 4.8 draws attention to these events by <a href=\"https://make.wordpress.org/community/2017/03/23/showing-upcoming-local-events-in-wp-admin/\">enhancing the News Dashboard widget</a>. The widget will try to automatically guess your location and display meetups and WordCamps that are nearby.</p>\n<img />News Widget Shows Upcoming Meetups and WordCamps\n<p>If the location is incorrect, clicking the Pencil button opens a box where you can type in your city. The bottom of the widget includes links to the <a href=\"https://make.wordpress.org/community/meetups-landing-page\">WordPress Meetup landing page</a>, <a href=\"https://central.wordcamp.org/schedule/\">WordCamp Central Schedule</a>, and the <a href=\"https://wordpress.org/news/\">WordPress.org news blog</a>.</p>\n<h2>Responsive Customizer Sidebar</h2>\n<p>In previous versions of WordPress, the Customizer Sidebar had a maximum width of 300 pixels. In WordPress 4.8, the <a href=\"https://wptavern.com/wordpress-4-8-increases-maximum-width-of-the-customizer-sidebar-to-600-pixels\">Customizer Sidebar is responsive</a> and its width will automatically increase based on the size of the screen up to a maximum of 600 pixels.</p>\n<img />Customizer Sidebar 345 Pixels Wide\n<h2>More Accessible Admin Pages</h2>\n<p>The headers on admin screens are now <a href=\"https://wptavern.com/wordpress-4-8-improves-accessibility-on-admin-screens\">separate elements</a> making it easier for assistive technologies to help people navigate pages.</p>\n<h2>Support Dropped for Internet Explorer Versions 8, 9, and 10</h2>\n<p>WordPress 4.8 <a href=\"https://make.wordpress.org/core/2017/04/23/target-browser-coverage/\">drops support</a> for Internet Explorer versions 8, 9, and 10 as these versions no longer receive security updates and are used by a small percentage of people. WordPress 4.8 will work in these browsers but some features related to TinyMCE will be limited. New features will no longer be tested against these older versions of IE.</p>\n<h2>Noteworthy Changes</h2>\n<ul>\n<li><a href=\"https://make.wordpress.org/core/2017/05/20/editor-api-changes-in-4-8/\">Changes to the Editor API</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/22/removal-of-core-embedding-support-for-wmv-and-wma-file-formats/\">Embeds of WMV and WMA files are no longer supported</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/22/multisite-focused-changes-in-4-8/\">New Capabilities and others enhancements for WordPress Multisite</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/26/tag-cloud-widget-changes-in-4-8/\">Accessibility improvements to the Tag Cloud widget</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/26/media-widgets-for-images-video-and-audio/\">The addition of a Media Widgets API</a></li>\n<li>TinyMCE was updated from version <strong>4.5.6</strong> to version <strong>4.6.2</strong></li>\n<li>Twemoji was updated from version <strong>2.2.2</strong> to version <strong>2.3.0</strong></li>\n<li>zxcvbn was updated from version <strong>1.0</strong> to version <strong>4.4.1</strong></li>\n</ul>\n<p>This release was led by <a href=\"https://matt.blog/\">Matt Mullenweg</a> and <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a>. 346 people contributed to WordPress 4.8 and 106 of them were first time contributors.</p>\n<p>If you think you&#8217;ve discovered a bug in WordPress 4.8, read <a href=\"https://wordpress.org/support/topic/read-this-first-wordpress-4-8-master-list/\">this support thread</a> first to see if it&#8217;s a common issue that&#8217;s already been reported. If not, describe your issue in as much detail as possible and publish it to the <a href=\"https://wordpress.org/support/forum/how-to-and-troubleshooting/\">Troubleshooting section</a> on the support forums.</p>\n<p>As you upgrade your sites today, enjoy <a href=\"https://en.wikipedia.org/wiki/Time_Remembered_(album)\">Time Remembered</a> by Bill Evans, released in 1983.</p>\n<div class=\"embed-wrap\"></div>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 19:29:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Worona Releases Free WordCamp Europe Paris Guide App\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71494\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://wptavern.com/worona-releases-free-wordcamp-europe-paris-guide-app\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4240:\"<p><a href=\"https://www.worona.org/\" target=\"_blank\">Worona</a>, a Madrid-based WordPress startup that builds mobile apps for free, has created an app for WordCamp Europe attendees. The <a href=\"https://blog.worona.org/wceu-paris-guide/\" target=\"_blank\">WCEU Paris Guide app</a> includes location and transportation information, schedules for the event, suggestions on where to eat (restaurants, bistros, a selection of the best cheap eats), a list of top attractions and museums, and nightlife recommendations.</p>\n<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/06/wceu-paris-guide.png?ssl=1\"><img /></a></p>\n<p>Worona has released an <a href=\"https://play.google.com/store/apps/details?id=org.worona.paris.app\" target=\"_blank\">Android app</a> and an <a href=\"https://itunes.apple.com/WebObjects/MZStore.woa/wa/viewSoftware?id=1238819389&mt=8\" target=\"_blank\">iOS app</a> for attendees to download. Currently the app needs to be connected to the internet, but the company is working on supporting an offline mode in the next version, which is rolling out soon.</p>\n<p>&#8220;We used our online platform to turn a WordPress blog (<a href=\"https://paris.worona.org\" target=\"_blank\">paris.worona.org</a>) into a native app,&#8221; Reyes Martínez, Worona&#8217;s marketing and communications specialist, said. &#8220;We use React and fetch the content using the WP-API. The apps are created with <a href=\"https://cordova.apache.org/\" target=\"_blank\">Cordova</a>.&#8221;</p>\n<p>Worona is a relatively new WordPress startup in Europe, having released its first prototype in late 2014. The company offers its mobile app building platform to users for free via its <a href=\"https://wordpress.org/plugins/worona/\" target=\"_blank\">plugin on WordPress.org</a>. The platform turns WordPress sites into native mobile apps that users can publish to the app stores. Worona can also manage the process of publishing the app for a one-time 290€ fee.</p>\n<p>In 2016, Worona had more than 12,000 users from 150 different countries. After launching its new platform four months ago, more than 11,500 users have signed up.</p>\n<p>Martínez said that Worona differs from existing WordPress app builders in that it is free, user-friendly, completely open source, and extensible.</p>\n<p>&#8220;We studied the WordPress ecosystem and the mobile distribution trends during the last three years and realized that other existing solutions, such as AppPresser, are just focused on one or two mobile channels, but not in all of them,&#8221; Martínez said. &#8220;This can be a problem for publishers, as they have to configure the different channels (apps, web apps, AMP, Facebook Instant Articles) one by one and take care of being consistent with all of them. After launching our own beta in 2015 and testing similar solutions, we decided to develop an all-in-one platform with the vision of becoming the leading solution for mobile distribution.&#8221;</p>\n<p>Worona is also aiming to create an ecosystem of extensions and themes for the platform, allowing third-party developers to create new solutions.</p>\n<p>&#8220;The strategy of creating a marketplace of extensions has been successfully accomplished by the WordPress ecosystem before (but not by any of our direct competitors),&#8221; Martínez said. &#8220;WooCommerce, for example, gives you access to a variety of extensions aiming to solve any problems related to your e-commerce. Because it is open-source, these features can be created by any developer or user. The bigger the community, the higher the range of solutions.&#8221;</p>\n<p>Worona is currently a team of five, including two co-founders, a marketing specialist, and two full-stack developers. Most of the team will be at WordCamp Europe. They hope the <a href=\"https://blog.worona.org/wceu-paris-guide/\" target=\"_blank\">WCEU Paris Guide app</a> will be useful for attendees and also provide a good introduction to their product. If you have any feedback that would make the app more useful, make sure to <a href=\"https://blog.worona.org/wceu-paris-guide/\" target=\"_blank\">comment on the announcement</a> and Worona may be able to incorporate user suggestions before the event.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 17:32:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Dev Blog: WordPress 4.8 “Evans”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4770\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/news/2017/06/evans/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:31595:\"<h2>An Update with You in Mind</h2>\n<p><img class=\"aligncenter size-large wp-image-4816\" src=\"https://i0.wp.com/wordpress.org/news/files/2017/06/release-featured-image.png?resize=632%2C316&ssl=1\" alt=\"\" /></p>\n<h3>Gear up for a more intuitive WordPress!</h3>\n<p>Version 4.8 of WordPress, named &#8220;Evans&#8221; in honor of jazz pianist and composer William John &#8220;Bill&#8221; Evans, is available for download or update in your WordPress dashboard. New features in 4.8 add more ways for you to express yourself and represent your brand.</p>\n<p>Though some updates seem minor, they’ve been built by hundreds of contributors with <em>you</em> in mind. Get ready for new features you’ll welcome like an old friend: link improvements, <em>three</em> new media widgets covering images, audio, and video, an updated text widget that supports visual editing, and an upgraded news section in your dashboard which brings in nearby and upcoming WordPress events.</p>\n<hr />\n<h2>Exciting Widget Updates</h2>\n<p><img class=\"size-large wp-image-4776 aligncenter\" src=\"https://i1.wp.com/wordpress.org/news/files/2017/06/widgets-with-all-four.png?resize=632%2C436&ssl=1\" alt=\"\" /></p>\n<h3>Image Widget</h3>\n<p>Adding an image to a widget is now a simple task that is achievable for any WordPress user without needing to know code. Simply insert your image right within the widget settings. Try adding something like a headshot or a photo of your latest weekend adventure — and see it appear automatically.</p>\n<h3>Video Widget</h3>\n<p>A welcome video is a great way to humanize the branding of your website. You can now add any video from the Media Library to a sidebar on your site with the new Video widget. Use this to showcase a welcome video to introduce visitors to your site or promote your latest and greatest content.</p>\n<h3>Audio Widget</h3>\n<p>Are you a podcaster, musician, or avid blogger? Adding a widget with your audio file has never been easier. Upload your audio file to the Media Library, go to the widget settings, select your file, and you’re ready for listeners. This would be a easy way to add a more personal welcome message, too!</p>\n<h3>Rich Text Widget</h3>\n<p>This feature deserves a parade down the center of town! Rich-text editing capabilities are now native for Text widgets. Add a widget anywhere and format away. Create lists, add emphasis, and quickly and easily insert links. Have fun with your newfound formatting powers, and watch what you can accomplish in a short amount of time.</p>\n<hr />\n<h2>Link Boundaries</h2>\n<div id=\"v-8BDWH3QG-1\" class=\"video-player\"><div><img alt=\"Link Boundaries\" src=\"https://videos.files.wordpress.com/8BDWH3QG/3-link-boundaries_dvd.original.jpg?resize=632%2C342\" /></div><p>Link Boundaries</p></div>\n<p>Have you ever tried updating a link, or the text around a link, and found you can&#8217;t seem to edit it correctly? When you edit the text after the link, your new text also ends up linked. Or you edit the text in the link, but your text ends up outside of it. This can be frustrating! With link boundaries, a great new feature, the process is streamlined and your links will work well. You’ll be happier. We promise.</p>\n<hr />\n<h2>Nearby WordPress Events</h2>\n<p><img class=\"aligncenter wp-image-4779 size-large\" src=\"https://i2.wp.com/wordpress.org/news/files/2017/06/events-widget.png?resize=632%2C465&ssl=1\" alt=\"\" /></p>\n<p>Did you know that WordPress has a thriving offline community with groups meeting regularly in more than 400 cities around the world? WordPress now draws your attention to the events that help you continue improving your WordPress skills, meet friends, and, of course, publish!</p>\n<p>This is quickly becoming one of our favorite features. While you are in the dashboard (because you’re running updates and writing posts, right?) all upcoming WordCamps and official WordPress Meetups — local to you — will be displayed.</p>\n<p>Being part of the community can help you improve your WordPress skills and network with people you wouldn&#8217;t otherwise meet. Now you can easily find your local events just by logging in to your dashboard and looking at the new Events and News dashboard widget.</p>\n<hr />\n<h2>Even More Developer Happiness <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f60a.png\" alt=\"😊\" class=\"wp-smiley\" /></h2>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/17/cleaner-headings-in-the-admin-screens/\">More Accessible Admin Panel Headings</a></h3>\n<p>New CSS rules mean extraneous content (like “Add New” links) no longer need to be included in admin-area headings. These panel headings improve the experience for people using assistive technologies.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/22/removal-of-core-embedding-support-for-wmv-and-wma-file-formats/\">Removal of Core Support for WMV and WMA Files</a></h3>\n<p>As fewer and fewer browsers support Silverlight, file formats which require the presence of the Silverlight plugin are being removed from core support. Files will still display as a download link, but will no longer be embedded automatically.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/22/multisite-focused-changes-in-4-8/\">Multisite Updates</a></h3>\n<p>New capabilities have been introduced to 4.8 with an eye towards removing calls to<br />\n<code>is_super_admin()</code>. Additionally, new hooks and tweaks to more granularly control site and user counts per network have been added.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/23/addition-of-tinymce-to-the-text-widget/\">Text-Editor JavaScript API</a></h3>\n<p>With the addition of TinyMCE to the text widget in 4.8 comes a new JavaScript API for instantiating the editor after page load. This can be used to add an editor instance to any text area, and customize it with buttons and functions. Great for plugin authors!</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/26/media-widgets-for-images-video-and-audio/\">Media Widgets API</a></h3>\n<p>The introduction of a new base media widget REST API schema to 4.8 opens up possibilities for even more media widgets (like galleries or playlists) in the future. The three new media widgets are powered by a shared base class that covers most of the interactions with the media modal. That class also makes it easier to create new media widgets and paves the way for more to come.</p>\n<h3><a href=\"https://make.wordpress.org/core/2017/05/16/customizer-sidebar-width-is-now-variable/\">Customizer Width Variable</a></h3>\n<p>Rejoice! New responsive breakpoints have been added to the customizer sidebar to make it wider on high-resolution screens. Customizer controls should use percentage-based widths instead of pixels.</p>\n<hr />\n<h2>The Squad</h2>\n<p>This release was led by <a href=\"https://matt.blog\">Matt</a> and <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a>, with the help of the following fabulous folks. There are 346 contributors with props in this release, with 106 of them contributing for the first time. Pull up some Bill Evans on your music service of choice, and check out some of their profiles:</p>\n<a href=\"https://profiles.wordpress.org/1naveengiri\">1naveengiri</a>, <a href=\"https://profiles.wordpress.org/4nickpick\">4nickpick</a>, <a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/abhishek\">abhishek</a>, <a href=\"https://profiles.wordpress.org/abhishekfdd\">Abhishek Kumar</a>, <a href=\"https://profiles.wordpress.org/abrain\">abrain</a>, <a href=\"https://profiles.wordpress.org/kawauso\">Adam Harley (Kawauso)</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adamsoucie\">Adam Soucie</a>, <a href=\"https://profiles.wordpress.org/afzalmultani\">Afzal Multani</a>, <a href=\"https://profiles.wordpress.org/mrahmadawais\">Ahmad Awais</a>, <a href=\"https://profiles.wordpress.org/ajoah\">ajoah</a>, <a href=\"https://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/apmarshall\">Alex Floyd Marshall</a>, <a href=\"https://profiles.wordpress.org/alexkingorg\">Alex King</a>, <a href=\"https://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andreamiddleton\">Andrea Middleton</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/rockwell15\">Andrew Rockwell</a>, <a href=\"https://profiles.wordpress.org/kelderic\">Andy Mercer</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/arena94\">arena94</a>, <a href=\"https://profiles.wordpress.org/arshidkv12\">Arshid</a>, <a href=\"https://profiles.wordpress.org/aryamaaru\">Arun</a>, <a href=\"https://profiles.wordpress.org/asalce\">asalce</a>, <a href=\"https://profiles.wordpress.org/ashokkumar24\">ashokkumar24</a>, <a href=\"https://profiles.wordpress.org/barryceelen\">Barry Ceelen</a>, <a href=\"https://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"https://profiles.wordpress.org/bharatkambariya\">Bharat Kambariya</a>, <a href=\"https://profiles.wordpress.org/blobfolio\">Blobfolio</a>, <a href=\"https://profiles.wordpress.org/gitlost\">bonger</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">Boone B. Gorges</a>, <a href=\"https://profiles.wordpress.org/bor0\">Boro Sitnikovski</a>, <a href=\"https://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"https://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/drrobotnik\">Brandon Lavigne</a>, <a href=\"https://profiles.wordpress.org/bridgetwillard\">Bridget Willard</a>, <a href=\"https://profiles.wordpress.org/bhargavbhandari90\">Bunty</a>, <a href=\"https://profiles.wordpress.org/camikaos\">Cami Kaos</a>, <a href=\"https://profiles.wordpress.org/carl-alberto\">Carl Alberto</a>, <a href=\"https://profiles.wordpress.org/caseypatrickdriscoll\">Casey Driscoll</a>, <a href=\"https://profiles.wordpress.org/cazm\">cazm</a>, <a href=\"https://profiles.wordpress.org/ccprog\">ccprog</a>, <a href=\"https://profiles.wordpress.org/chandrapatel\">Chandra Patel</a>, <a href=\"https://profiles.wordpress.org/chesio\">chesio</a>, <a href=\"https://profiles.wordpress.org/ketuchetan\">chetansatasiya</a>, <a href=\"https://profiles.wordpress.org/chiragpatel\">Chirag Patel</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/cklosows\">Chris Klosowski</a>, <a href=\"https://profiles.wordpress.org/chris_dev\">Chris Mok</a>, <a href=\"https://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"https://profiles.wordpress.org/christian1012\">Christian Chung</a>, <a href=\"https://profiles.wordpress.org/coreymckrill\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/courtneypk\">Courtney P.K.</a>, <a href=\"https://profiles.wordpress.org/cristianozanca\">Cristiano Zanca</a>, <a href=\"https://profiles.wordpress.org/csloisel\">csloisel</a>, <a href=\"https://profiles.wordpress.org/curdin\">Curdin Krummenacher</a>, <a href=\"https://profiles.wordpress.org/clarinetlord\">Cyrus Collier</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber </a>, <a href=\"https://profiles.wordpress.org/diddledan\">Daniel Llewellyn</a>, <a href=\"https://profiles.wordpress.org/mte90\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/nerrad\">Darren Ethier (nerrad)</a>, <a href=\"https://profiles.wordpress.org/darshan02\">Darshan_dj</a>, <a href=\"https://profiles.wordpress.org/darthaud\">darthaud</a>, <a href=\"https://profiles.wordpress.org/dllh\">Daryl L. L. Houston (dllh)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"https://profiles.wordpress.org/davidbinda\">David Binovec</a>, <a href=\"https://profiles.wordpress.org/dlh\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dshanske\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/davidbenton\">davidbenton</a>, <a href=\"https://profiles.wordpress.org/designsimply\">designsimply</a>, <a href=\"https://profiles.wordpress.org/dhanendran\">Dhanendran</a>, <a href=\"https://profiles.wordpress.org/dharm1025\">Dharmesh Patel</a>, <a href=\"https://profiles.wordpress.org/dhaval-parekh\">Dhaval Parekh</a>, <a href=\"https://profiles.wordpress.org/dingo_bastard\">dingo-d</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dotancohen\">Dotan Cohen</a>, <a href=\"https://profiles.wordpress.org/doublehhh\">DoubleH</a>, <a href=\"https://profiles.wordpress.org/dreamon11\">DreamOn11</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/drivingralle\">Drivingralle</a>, <a href=\"https://profiles.wordpress.org/dspilka\">dspilka</a>, <a href=\"https://profiles.wordpress.org/chopinbach\">Edwin Cromley</a>, <a href=\"https://profiles.wordpress.org/ejner69\">Ejner Galaz</a>, <a href=\"https://profiles.wordpress.org/iseulde\">Ella Iseulde Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/emirpprime\">emirpprime</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"https://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"https://profiles.wordpress.org/endif-media\">Ethan Allen</a>, <a href=\"https://profiles.wordpress.org/fab1en\">Fabien Quatravaux</a>, <a href=\"https://profiles.wordpress.org/flixos90\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/fibonaccina\">fibonaccina</a>, <a href=\"https://profiles.wordpress.org/mista-flo\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/francina\">Francesca Marano</a>, <a href=\"https://profiles.wordpress.org/fstaude\">Frank Neumann-Staude</a>, <a href=\"https://profiles.wordpress.org/f-j-kaiser\">Franz Josef Kaiser</a>, <a href=\"https://profiles.wordpress.org/gma992\">Gabriel Maldonado</a>, <a href=\"https://profiles.wordpress.org/voldemortensen\">Garth Mortensen</a>, <a href=\"https://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/ghosttoast\">Gustave F. Gerhardt</a>, <a href=\"https://profiles.wordpress.org/hedgefield\">hedgefield</a>, <a href=\"https://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"https://profiles.wordpress.org/helgatheviking\">helgatheviking</a>, <a href=\"https://profiles.wordpress.org/hristo-sg\">Hristo Pandjarov</a>, <a href=\"https://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ig_communitysites\">ig_communitysites</a>, <a href=\"https://profiles.wordpress.org/zinigor\">Igor Zinovyev</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/ireneyoast\">ireneyoast</a>, <a href=\"https://profiles.wordpress.org/iv3rson76\">Ivan Stefanov</a>, <a href=\"https://profiles.wordpress.org/ivantedja\">ivantedja</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/whyisjake\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jnylen0\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jaydeep-rami\">Jaydeep Rami</a>, <a href=\"https://profiles.wordpress.org/jazbek\">jazbek</a>, <a href=\"https://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jfarthing84\">Jeff Farthing</a>, <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a>, <a href=\"https://profiles.wordpress.org/cheffheid\">Jeffrey de Wit</a>, <a href=\"https://profiles.wordpress.org/jenblogs4u\">Jen Miller</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/jigneshnakrani\">Jignesh Nakrani</a>, <a href=\"https://profiles.wordpress.org/jipmoors\">Jip Moors</a>, <a href=\"https://profiles.wordpress.org/jjcomack\">jjcomack</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"https://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/chanthaboune\">Josepha</a>, <a href=\"https://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"https://profiles.wordpress.org/juhise\">Juhi Saxena</a>, <a href=\"https://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"https://profiles.wordpress.org/certainstrings\">Justin Tucker</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/kafleg\">kafleg</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/karinedo\">karinedo</a>, <a href=\"https://profiles.wordpress.org/zoonini\">Kathryn</a>, <a href=\"https://profiles.wordpress.org/kaushik\">kaushik</a>, <a href=\"https://profiles.wordpress.org/kkoppenhaver\">Keanan Koppenhaver</a>, <a href=\"https://profiles.wordpress.org/keesiemeijer\">keesiemeijer</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/ixkaito\">Kite</a>, <a href=\"https://profiles.wordpress.org/kjellr\">kjellr</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/kostasx\">kostasx</a>, <a href=\"https://profiles.wordpress.org/kubik-rubik\">kubik-rubik</a>, <a href=\"https://profiles.wordpress.org/kuck1u\">KUCKLU</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/laurelfulford\">Laurel Fulford</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/leemon\">leemon</a>, <a href=\"https://profiles.wordpress.org/lewiscowles\">LewisCowles</a>, <a href=\"https://profiles.wordpress.org/liammcarthur\">LiamMcArthur</a>, <a href=\"https://profiles.wordpress.org/lucasstark\">Lucas Stark</a>, <a href=\"https://profiles.wordpress.org/lukasbesch\">lukasbesch</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/maedahbatool\">Maedah Batool</a>, <a href=\"https://profiles.wordpress.org/maguiar\">maguiar</a>, <a href=\"https://profiles.wordpress.org/mp518\">Mahesh Prajapati</a>, <a href=\"https://profiles.wordpress.org/mantismamita\">mantismamita</a>, <a href=\"https://profiles.wordpress.org/tyxla\">Marin Atanasov</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/mrwweb\">Mark Root-Wiley</a>, <a href=\"https://profiles.wordpress.org/mapk\">Mark Uraine</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/matheusfd\">Matheus Martins</a>, <a href=\"https://profiles.wordpress.org/matheusgimenez\">MatheusGimenez</a>, <a href=\"https://profiles.wordpress.org/mathieuhays\">mathieuhays</a>, <a href=\"https://profiles.wordpress.org/matias\">matias</a>, <a href=\"https://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/maximeculea\">Maxime Culea</a>, <a href=\"https://profiles.wordpress.org/mayukojpn\">Mayo Moriyama</a>, <a href=\"https://profiles.wordpress.org/mayurk\">Mayur Keshwani</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/menakas\">Menaka S.</a>, <a href=\"https://profiles.wordpress.org/michaelarestad\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michalzuber\">michalzuber</a>, <a href=\"https://profiles.wordpress.org/michelleweber\">michelleweber</a>, <a href=\"https://profiles.wordpress.org/stubgo\">Miina Sikk</a>, <a href=\"https://profiles.wordpress.org/mihai2u\">Mike Crantea</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikejolley\">Mike Jolley</a>, <a href=\"https://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"https://profiles.wordpress.org/mnelson4\">Mike Nelson</a>, <a href=\"https://profiles.wordpress.org/mikeschroder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinić</a>, <a href=\"https://profiles.wordpress.org/milindmore22\">Milind More</a>, <a href=\"https://profiles.wordpress.org/mitraval192\">Mithun Raval</a>, <a href=\"https://profiles.wordpress.org/mmdeveloper\">MMDeveloper</a>, <a href=\"https://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/mohanjith\">mohanjith</a>, <a href=\"https://profiles.wordpress.org/monikarao\">monikarao</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/mt8biz\">moto hachi ( mt8.biz )</a>, <a href=\"https://profiles.wordpress.org/mrgregwaugh\">MrGregWaugh</a>, <a href=\"https://profiles.wordpress.org/mschadegg\">mschadegg</a>, <a href=\"https://profiles.wordpress.org/codegeass\">Muhammet Arslan</a>, <a href=\"https://profiles.wordpress.org/dots\">MULTIDOTS</a>, <a href=\"https://profiles.wordpress.org/nao\">Naoko Takano</a>, <a href=\"https://profiles.wordpress.org/naomicbush\">Naomi C. Bush</a>, <a href=\"https://profiles.wordpress.org/natereist\">Nate Reist</a>, <a href=\"https://profiles.wordpress.org/greatislander\">Ned Zimmerman</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey </a>, <a href=\"https://profiles.wordpress.org/nikschavan\">Nikhil Chavan</a>, <a href=\"https://profiles.wordpress.org/nitin-kevadiya\">Nitin Kevadiya</a>, <a href=\"https://profiles.wordpress.org/kailanitish90\">Nitish Kaila</a>, <a href=\"https://profiles.wordpress.org/nobremarcos\">nobremarcos</a>, <a href=\"https://profiles.wordpress.org/nosegraze\">NoseGraze</a>, <a href=\"https://profiles.wordpress.org/nsundberg\">nsundberg</a>, <a href=\"https://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"https://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"https://profiles.wordpress.org/iaaxpage\">page-carbajal</a>, <a href=\"https://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"https://profiles.wordpress.org/figureone\">Paul Ryan</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/sirbrillig\">Payton Swick</a>, <a href=\"https://profiles.wordpress.org/pdufour\">pdufour</a>, <a href=\"https://profiles.wordpress.org/piewp\">Perdaan</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/philipjohn\">Philip John</a>, <a href=\"https://profiles.wordpress.org/delawski\">Piotr Delawski</a>, <a href=\"https://profiles.wordpress.org/psoluch\">Piotr Soluch</a>, <a href=\"https://profiles.wordpress.org/postpostmodern\">postpostmodern</a>, <a href=\"https://profiles.wordpress.org/pranalipatel\">Pranali Patel</a>, <a href=\"https://profiles.wordpress.org/pratikshrestha\">Pratik Shrestha</a>, <a href=\"https://profiles.wordpress.org/presskopp\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/printsachen1\">printsachen1</a>, <a href=\"https://profiles.wordpress.org/priyankabehera155\">Priyanka Behera</a>, <a href=\"https://profiles.wordpress.org/prosti\">prosti</a>, <a href=\"https://profiles.wordpress.org/ptbello\">ptbello</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rafaehlers\">Rafael Ehlers</a>, <a href=\"https://profiles.wordpress.org/raggedrobins\">raggedrobins</a>, <a href=\"https://profiles.wordpress.org/raisonon\">raisonon</a>, <a href=\"https://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"https://profiles.wordpress.org/ramiabraham\">ramiabraham</a>, <a href=\"https://profiles.wordpress.org/ranh\">ranh</a>, <a href=\"https://profiles.wordpress.org/rclations\">RC Lations</a>, <a href=\"https://profiles.wordpress.org/redrambles\">redrambles</a>, <a href=\"https://profiles.wordpress.org/reidbusi\">reidbusi</a>, <a href=\"https://profiles.wordpress.org/reldev\">reldev</a>, <a href=\"https://profiles.wordpress.org/rellect\">rellect</a>, <a href=\"https://profiles.wordpress.org/arena\">RENAUT</a>, <a href=\"https://profiles.wordpress.org/rensw90\">rensw90</a>, <a href=\"https://profiles.wordpress.org/reportermike\">reportermike</a>, <a href=\"https://profiles.wordpress.org/rianrietveld\">Rian Rietveld</a>, <a href=\"https://profiles.wordpress.org/riddhiehta02\">Riddhi Mehta</a>, <a href=\"https://profiles.wordpress.org/aussieguy123\">Robbie Cahill</a>, <a href=\"https://profiles.wordpress.org/sanchothefat\">Robert O\'Rourke</a>, <a href=\"https://profiles.wordpress.org/littlerchicken\">Robin Cornett</a>, <a href=\"https://profiles.wordpress.org/runciters\">runciters</a>, <a href=\"https://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/welcher\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/sagarjadhav\">Sagar Jadhav</a>, <a href=\"https://profiles.wordpress.org/sagarprajapati\">Sagar Prajapati</a>, <a href=\"https://profiles.wordpress.org/sagarkbhatt\">sagarkbhatt</a>, <a href=\"https://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"https://profiles.wordpress.org/samantha-miller\">Samantha Miller</a>, <a href=\"https://profiles.wordpress.org/samikeijonen\">Sami Keijonen</a>, <a href=\"https://profiles.wordpress.org/samuelsidler\">Samuel Sidler</a>, <a href=\"https://profiles.wordpress.org/sanketparmar\">Sanket Parmar</a>, <a href=\"https://profiles.wordpress.org/sathyapulse\">sathyapulse</a>, <a href=\"https://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sfpt\">sfpt</a>, <a href=\"https://profiles.wordpress.org/sgolemon\">sgolemon</a>, <a href=\"https://profiles.wordpress.org/shadyvb\">Shady Sharaf</a>, <a href=\"https://profiles.wordpress.org/shashwatmittal\">shashwatmittal</a>, <a href=\"https://profiles.wordpress.org/shazahm1hotmailcom\">shazahm1</a>, <a href=\"https://profiles.wordpress.org/shulard\">shulard</a>, <a href=\"https://profiles.wordpress.org/slbmeh\">slbmeh</a>, <a href=\"https://profiles.wordpress.org/soean\">Soren Wrede</a>, <a href=\"https://profiles.wordpress.org/sstoqnov\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/stephdau\">Stephane Daury (stephdau)</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"https://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"https://profiles.wordpress.org/stormrockwell\">stormrockwell</a>, <a href=\"https://profiles.wordpress.org/sudar\">Sudar Muthu</a>, <a href=\"https://profiles.wordpress.org/supercoder\">Supercoder</a>, <a href=\"https://profiles.wordpress.org/cybr\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/szaqal21\">szaqal21</a>, <a href=\"https://profiles.wordpress.org/gonom9\">taggon</a>, <a href=\"https://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/takayukister\">Takayuki Miyoshi</a>, <a href=\"https://profiles.wordpress.org/karmatosed\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/technopolitica\">technopolitica</a>, <a href=\"https://profiles.wordpress.org/teinertb\">teinertb</a>, <a href=\"https://profiles.wordpress.org/tejas5989\">tejas5989</a>, <a href=\"https://profiles.wordpress.org/terwdan\">terwdan</a>, <a href=\"https://profiles.wordpress.org/tharsheblows\">tharsheblows</a>, <a href=\"https://profiles.wordpress.org/themiked\">theMikeD</a>, <a href=\"https://profiles.wordpress.org/thepelkus\">thepelkus</a>, <a href=\"https://profiles.wordpress.org/tfrommen\">Thorsten Frommen</a>, <a href=\"https://profiles.wordpress.org/timmydcrawford\">Timmy Crawford</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/timph\">timph</a>, <a href=\"https://profiles.wordpress.org/tmatsuur\">tmatsuur</a>, <a href=\"https://profiles.wordpress.org/tomdxw\">tomdxw</a>, <a href=\"https://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/triplejumper12\">triplejumper12</a>, <a href=\"https://profiles.wordpress.org/truongwp\">truongwp</a>, <a href=\"https://profiles.wordpress.org/tymvie\">tymvie</a>, <a href=\"https://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"https://profiles.wordpress.org/utkarshpatel\">Utkarsh</a>, <a href=\"https://profiles.wordpress.org/vaishuagola27\">vaishu.agola27</a>, <a href=\"https://profiles.wordpress.org/vijustin\">vijustin</a>, <a href=\"https://profiles.wordpress.org/vortfu\">vortfu</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/wpfo\">wpfo</a>, <a href=\"https://profiles.wordpress.org/xrmx\">xrmx</a>, <a href=\"https://profiles.wordpress.org/ze3kr\">ze3kr</a>, and <a href=\"https://profiles.wordpress.org/h3llas\">Zeljko Ascic</a>.\n<p>&nbsp;</p>\n<p>Finally, thanks to all the community translators who worked on WordPress 4.8. Their efforts bring WordPress 4.8 fully translated to 38 languages at release time with more on the way.</p>\n<p>Do you want to report on WordPress 4.8? <a href=\"https://s.w.org/images/core/4.8/wp-4-8_press-kit.zip\">We&#8217;ve compiled a press kit</a> featuring information about the release features, and some media assets to help you along.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress — we hope you enjoy!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 14:49:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Holler Box: A Smart Notification Plugin for WordPress Websites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71490\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"https://wptavern.com/holler-box-a-smart-notification-plugin-for-wordpress-websites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4373:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/06/holler-box.png?ssl=1\"><img /></a></p>\n<p>Scott Bolinger, co-founder of <a href=\"http://apppresser.com/\" target=\"_blank\">AppPresser</a>, has launched a new sales and conversion tool for WordPress websites called <a href=\"http://hollerwp.com/\" target=\"_blank\">Holler Box</a>. The plugin offers a lightweight, elegant popup message for capturing email addresses, displaying a (fake) live chat, or announcing a sale or event.</p>\n<p>Bolinger designed it to be non-intrusive &#8211; it&#8217;s not the kind of modal dialog that obscures content with an animated box in the middle of the page. Holler Box appears at the bottom right-hand of the page by default.</p>\n<p>After finding other WordPress popup plugins to be too complex for his needs, Bolinger decided to create his own solution for displaying a quick notification on his websites.</p>\n<p>&#8220;I’m a developer, and even adding a simple banner or popup to my site is not easy,&#8221; Bolinger said. I have to write the code, test locally, push to staging, test there, then push to production and do a final test. When I want to remove the message, I have to reverse the process. I’m busy, and that takes time.&#8221;</p>\n<p>Bolinger made it so that creating a new Holler Box is as easy as writing a new blog post. The content editing screen includes a meta box with options for customizing the display.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/06/holler-box-meta-box.png?ssl=1\"><img /></a></p>\n<p>The &#8220;Advanced Settings&#8221; meta box allows users to set pages where the notification should be displayed, limit to logged-in only or logged-out visitors, set the display for new or returning visitors, and customize the delay based on time or scrolling. It also gives options for when the Holler Box should disappear and how often it should be shown to each visitor.</p>\n<p>Holler Box is capable of a wide range of uses. A few examples include the following:</p>\n<ul>\n<li><strong>(Fake) Live Chat with Opt-in</strong>\n<p>Show a live chat box to collect customer questions and emails, without having to actually deal with the hassle of live chat. As soon as your visitor types a question, an email opt-in pops up so you can follow up with them at a convenient time.</li>\n<li><strong>Polls and Forms</strong>\n<p>Embed anything into your Holler Box, including a feedback form or poll.</li>\n<li><strong>Interactivity</strong>\n<p>Add a link, video, contact form, or simple opt-in form that integrates with major email providers like MailChimp and Convertkit.</li>\n</ul>\n<p>Below is an example of how the MailChimp email opt-in form works:</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/06/holler-box.gif?ssl=1\"><img /></a></p>\n<p>Holler Box also tracks impressions and conversions (link clicks and message opens) so that users can see how well their notifications are performing and optimize them as needed.</p>\n<p>The <a href=\"https://wordpress.org/plugins/holler-box/\" target=\"_blank\">free version on WordPress.org</a> has an impressive number of customization options, but Bolinger also plans to release a Pro version that will include additional features, such as an option for a header banner, more advanced display filters, automatic message deactivation, advanced email opt-in features, more conversion data, and support.</p>\n<p>&#8220;Holler Box aims to be more stylish and easier to use than existing options,&#8221; Bolinger said. &#8220;I use it when I need to make an announcement without spending a lot of time in a complex tool.&#8221; He said he could see the plugin working well side-by-side with well-established popup plugin competitors like OptinMonster.</p>\n<p>Bolinger said Holler Box is not affiliated with AppPresser, but he plans to use it as a sales tool on all of his sites. The plugin&#8217;s unique feature set is something he found missing in WordPress&#8217; marketplace for sales/conversion tools.</p>\n<p>&#8220;I think Holler Box will increase sales and conversions without being as disruptive as other popups,&#8221; Bolinger said. &#8220;The sale notification popup and faux live chat feature are really unique. It’s how I want to communicate with my audience &#8211; hopefully other people feel the same.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 01:37:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: WPWeekly Episode 276 – Interview with Jon Brown, a Traveling Digital Nomad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=71482&preview=true&preview_id=71482\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://wptavern.com/wpweekly-episode-276-interview-with-jon-brown-a-traveling-digital-nomad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2848:\"<p>In this episode, <a href=\"http://jjj.me/\">John James Jacoby</a> and I are joined by <a href=\"https://www.wanderingjon.com/\">Jon Brown</a>. Brown is a <a href=\"https://9seeds.com/author/jbrown/\">developer and author</a> for <a href=\"https://9seeds.com/\">9seeds</a>, a WordPress development agency. Brown describes what it&#8217;s like to work remotely and offers tips on how to stay productive while traveling. He tells us what items he can&#8217;t travel without. We also get his take on recent developments and debates going on in the WordPress community.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wptavern.com/open-sourcing-mental-illness-surpases-50k-fundraising-goal\">Open Sourcing Mental Illness Surpasses $50K Fundraising Goal</a><br />\n<a href=\"https://wptavern.com/vue-js-creator-evan-you-weighs-in-on-wordpress-javascript-framework-discussion\">Vue.js Creator Evan You Weighs in on WordPress JavaScript Framework Discussion</a><br />\n<a href=\"https://wptavern.com/wordcamp-europe-2017-livestream-tickets-now-available\">WordCamp Europe 2017 Livestream Tickets Now Available</a><br />\n<a href=\"https://wptavern.com/wpforms-acquires-wp-mail-smtp-plugin\">WPForms Acquires WP Mail SMTP Plugin</a><br />\n<a href=\"https://wptavern.com/versionpress-launches-versionpress-com-to-fund-open-source-project\">VersionPress Launches VersionPress.com to Fund Open Source Project</a></p>\n<h2>Picks of the Week:</h2>\n<p><a href=\"https://generatewp.com/\">GenerateWP</a> is a collection of tools that generates code for Shortcodes, Post Types, Meta Boxes, Taxonomies, Term Meta, and Post Statuses.</p>\n<p><a href=\"https://wordpress.org/plugins/holler-box/\">Holler Box</a> enables users to create customizable marketing messages to display to site visitors. Use Holler Box to convert website visitors, upsell customers, and get messages out to the right people at the right time.</p>\n<p><a href=\"https://wpperformanceprofiler.interconnectit.com/\">WP Performance Profiler</a> is a plugin by Interconnect.it that helps developers optimize the performance of WordPress sites running on PHP 5.3 to 5.6.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, June 14th 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\" rel=\"noopener\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #276:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Jun 2017 01:10:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"Post Status: Teaching what you learn with Joe Casabona — Draft Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=37463\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://poststatus.com/teaching-learn-joe-casabona-draft-podcast/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1627:\"<p>Welcome to the Post Status <a href=\"https://poststatus.com/category/draft\">Draft podcast</a>, which you can find <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">on iTunes</a>, <a href=\"https://play.google.com/music/m/Ih5egfxskgcec4qadr3f4zfpzzm?t=Post_Status__Draft_WordPress_Podcast\">Google Play</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, and <a href=\"http://simplecast.fm/podcasts/1061/rss\">via RSS</a> for your favorite podcatcher. Post Status Draft is hosted by the creator and editor of Post Status, Brian Krogsgard, and this week&#8217;s guest host, Joe Casabona.</p>\n<p>Brian and Joe discuss the way they have learned WordPress over the years, and how they’ve gone about sharing and teaching what they’ve learned. They focus mostly on front-end parts of WordPress development.</p>\n<p><a href=\"https://audio.simplecast.com/72351.mp3\">https://audio.simplecast.com/72351.mp3</a><br />\n<a href=\"https://audio.simplecast.com/72351.mp3\">Direct Download</a></p>\n<h3>Links</h3>\n<ul>\n<li><a href=\"https://wpinonemonth.com/\">WP in one month</a></li>\n<li><a href=\"https://casabona.org/\">Casabona.org</a></li>\n<li><a href=\"http://howibuilt.it/\">How I Built It</a></li>\n<li><a href=\"http://wesbos.com/\">WesBos.com</a></li>\n</ul>\n<h3>Sponsor: Yoast</h3>\n<p>Yoast SEO Premium gives you 24/7 support from a great support team and extra features such as a redirect manager, recommended internal links, tutorial videos and integration with Google Webmaster Tools! Check out <a href=\"https://yoast.com/\">Yoast SEO Premium</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Jun 2017 17:33:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Katie Richards\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Donncha: Take a sneak peek at WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://odd.blog/?p=89500269\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://odd.blog/2017/06/07/take-a-sneak-peek-at-wp-super-cache/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4302:\"<p>WP Super Cache is a full page caching plugin for WordPress that makes your site faster, and helps deal with unexpected surges in traffic.</p>\n<p>Over the last few months we&#8217;ve been busy <a href=\"https://github.com/Automattic/wp-super-cache/\">working on the plugin</a> to add new features and fix bugs and we can almost call it ready. It&#8217;s stable and usable and runs on this site but we would love more people to test it out before we release a new version.</p>\n<p>Here&#8217;s just some of the new features and bug fixes we&#8217;ve been working on:</p>\n<ul>\n<li> The plugin was based on WP-Cache which stored cache files in a single directory, and those (legacy caching) files were for the most part stored the same way all this time but now they&#8217;re being placed in the supercache directories (<a href=\"https://github.com/Automattic/wp-super-cache/pull/177\">#177</a>). This makes it easier to manage these files. The plugin doesn&#8217;t have to search through potentially hundreds of cache files for those that need to be deleted if a page updates or someone leaves a comment. Now all those files will be in the same directory structure the anonymous &#8220;supercache&#8221; files will be. I&#8217;m really excited about this feature as it makes caching for logged in users/users who comment and caching of pages with parameters so much faster now.</li>\n<li> We&#8217;re adding a <a href=\"https://developer.wordpress.org/rest-api/\">REST API</a> to the plugin because in the future not everyone is going to use wp-admin to take care of their sites. Take a look in the <a href=\"https://github.com/Automattic/wp-super-cache/tree/master/rest\">rest directory</a> for the code we&#8217;re working on.</li>\n<li> Debug logs now have a username and password to protect them from prying eyes.</li>\n<li> And many <a href=\"https://github.com/Automattic/wp-super-cache/pulls?q=is%3Apr+is%3Aclosed\">bugs fixed</a> over the last few months.</li>\n</ul>\n<p>Since &#8220;legacy caching&#8221; or &#8220;WP-Cache caching&#8221; is now more maintainable and faster we <a href=\"https://github.com/Automattic/wp-super-cache/issues/224\">want to change the language</a> describing how the plugin caches and delivers pages. </p>\n<p><a href=\"https://odd.blog/files/2017/06/Screen-Shot-2017-06-07-at-17.35.25.png\"><img /></a></p>\n<p>Currently the plugin asks you to choose between mod_rewrite, PHP and &#8220;Legacy page caching&#8221; which isn&#8217;t really useful. Most users won&#8217;t recognise those terms. It&#8217;s also not accurate as &#8220;legacy page caching&#8221; is active all the time as long as caching is enabled.<br />\nInstead we should have &#8220;Standard Caching&#8221; and &#8220;Super Caching&#8221;. Super Caching will then have simple and expert delivery methods.</p>\n<p>Simple delivery is through PHP, while expert delivery uses mod_rewrite rules which means the .htaccess file has to be updated and hopefully the warning below it will discourage casual users from testing it.</p>\n<p>Due to the huge number of changes in the plugin we really need people to give it a try and check if everything works ok. The <a href=\"https://github.com/Automattic/wp-super-cache/pull/255\">changes to the settings page</a> will hopefully make it easier for new users to get to grips with it too.</p>\n<p>You can find the newest code <a href=\"https://github.com/Automattic/wp-super-cache\">on Github</a>. The changes to the settings page are in <a href=\"https://github.com/Automattic/wp-super-cache/pull/255\">#255</a> if you want to comment on them. </p>\n<p>Thanks in advance! 🙂</p>\n\n<p><strong>Related Posts</strong><ul><li> <a href=\"https://odd.blog/2011/10/19/preload-categories-and-custom-post-content/\" rel=\"bookmark\" title=\"Permanent Link: Preload categories and custom post content\">Preload categories and custom post content</a></li><li> <a href=\"https://odd.blog/2008/10/24/wp-super-cache-084-the-garbage-collector/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.4, the garbage collector\">WP Super Cache 0.8.4, the garbage collector</a></li><li> <a href=\"https://odd.blog/2009/01/09/wp-super-cache-087/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.7\">WP Super Cache 0.8.7</a></li></ul></p>\n<p><a href=\"https://odd.blog/\" rel=\"external nofollow\">Source</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Jun 2017 17:24:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Donncha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"HeroPress: Trust The Dots\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1890\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"https://heropress.com/essays/trust-the-dots/?utm_source=rss&utm_medium=rss&utm_campaign=trust-the-dots\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12678:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/06/060717-min-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: WordPress is such an amazing melting pot that involves people from everywhere, no matter how old they are, where they are from, or what languages they speak.\" /><p>I was born twice: first, as a baby boy in the sunny morning of Monday June 14, 1993 in Taiz, Yemen; and then again, in the fall of 2008. It was my first time to study at a public high school, grade 10, class 12. It was completely different than the private school I used to study at. It was big and crowded, with a minimum of 80 students in each class!</p>\n<p>At that time, I was trying to improve my personality and explore new opportunities. I wanted to live my life fully, not as the teenager that I was. A way to organize my thoughts and connect with new people was needed. I did not have a clue what to do until the moment I got the chance to use the internet and began to read online blogs of many interesting bloggers. The idea of blogging was fascinating to me. “Why not starting one?” I thought to myself.</p>\n<h3>Finding WordPress</h3>\n<p>As days passed, I met four enthusiastic and ambitious schoolmates who became my friends till now.  Mohammed, one of them, was a relatively quiet and open minded person. My mates and I got to know him through MSN Messenger, and, surprisingly, he was studying in the next class! He was very absorbed in Web Development and was working on a custom CMS platform and some other web applications for his father’s clinic. I asked him about blogging software he would recommend. He strongly recommended Joomla and also suggested Drupal, WordPress and others. I tried them all.</p>\n<blockquote><p>WordPress was so easy to use and out-of-the-box, although I had failed a few times while I was trying to install it locally. Once I had logged-in to the dashboard, honestly, I thrilled to pieces!</p></blockquote>\n<p>After some time, my friends and I decided to start a simple blog about Graphics Design using WordPress. It was my beginning to learn the basics of Web Development (HTML, CSS, Javascript and PHP). Fortunately, Mohammed had a book that he lent me, and some PDFs, that I copied. We were constantly discussing and learning from each other during break times or in the afternoons. They were enjoyable and enlightening moments.</p>\n<p>I used to receive some positive messages as the developer of the blog we started and appreciative replies to my answers for some questions in <a href=\"http://ar-wp.com\">Arab WordPress</a> community, a forum to share knowledge among Arab WordPress users. This encouraged me to start a small freelancing business with WordPress. It seemed a great idea to expand expertise, earn some money, and follow my passion!</p>\n<h3>Fitting It All In</h3>\n<p>Being a freelancer and a high-school student at the same time was not that easy as one would think! Sometimes I was working until 3:00 a.m. to finish a client project, and then woke up at 6:30 a.m. rushing to school. Most often, classes were so dry that led me to write PHP codes in every copy-book of mine! If you would like to try this at your school, remember to move yourself to the end of your class or be ready for any of your teachers’ mean reactions to keep you attentive! On several afternoons, I used to take naps to restore my energy and be ready to work at night.</p>\n<blockquote><p>Very rarely, I would have to stay out at internet cafés until 2:00 a.m. to upload/download things I needed because we had no Internet connection at home.</p></blockquote>\n<p>For sure, this made my parents quite angry and obviously worried. Most importantly, I had neither a cell phone because of some strict rules in my family nor a national ID card because of the legal age requirement in Yemen. I was attempting to use my school ID card to receive money transactions, and guess what? I was lucky enough to manage it twice. But then I was asked to present a national ID. “ When will I turn 18?” I just had to overcome that obstacle, asking trustworthy friends to help.</p>\n<p>My clients were mostly from the Arab World, Europe, and USA. I had the chance to contact with many nice and outstanding people who not only boosted my experience but also showed me the way into some new opportunities and more success.</p>\n<h3>Support At Home</h3>\n<p>At the beginning, most of my family members thought I was playing, except my MOTHER. I remember the moment I told her about my fairly new business. She said, &#8220;Regardless of what it is, just do what you love and believe in!&#8221; However, I faced hard times trying to convince her I did not smoke as she smelled cigarette on my clothes whenever I got back home from those cafés! On the other hand, my father was the kind of man who stood backstage. He used to tell his friends how happy and proud he was of me. That was all what I needed from him.</p>\n<h3>Giving Back</h3>\n<p>On August 2012, I sent a message to Rasheed Bydousi, Arab WordPress community founder and translation editor of Arabic language, to suggest some ideas and ask to be a volunteer. He was very supportive and truly wise. We started discussing and working on some ideas for more than <a href=\"http://www.ar-wp.com/forums/topic/2119/\">4 months</a>. In parallel with studying, working, and being a volunteer, I increased my efforts in translating, patching (helping in development), and reporting bugs for WordPress projects.</p>\n<blockquote><p>It was very important for me to give back to the community I had taken a lot from.</p></blockquote>\n<p>I felt the need of holding a WordPress meeting in my hometown, Taiz, because of the lack of specialized people who would like to collaborate and share knowledge. In 2013, I invited local developers to a small meeting in a local coffeeshop called “AL-Rassef”.</p>\n<p><img class=\"aligncenter wp-image-1894 size-full\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/06/wp-meeting-alraseef-coffeshop.jpg\" alt=\"WordPress Meeting in Taiz, Yemen\" width=\"960\" height=\"720\" /></p>\n<p>Afterward, I presented a lecture about WordPress at Taiz University, in the same lecture hall I used to be a student in by that time. It was a warm beginning but I couldn&#8217;t continue due to my work and the deterioration of the political and security situation.</p>\n<h3>Disruption</h3>\n<p>Since 2011, my country has been facing major political changes and instability. On April 2015, the Yemeni crisis has reached its climax and war started in my city, Taiz, and it is still going on! Some of my relatives had decided to move out of Taiz but my father chose to stay, hoping that war will stop quickly. We lived for months without public electricity or Internet. When the fight crawled to our area, we lived for weeks in the ground floor of our house, no way to go out, tanks firing from 300 meters away, airstrikes on nearby areas, and snipers shooting whoever dared to walk on streets. Many friends and innocent people were killed and some members of my family were hurt. We couldn&#8217;t sleep for days, fearing that at any moment they will knock our house door.</p>\n<p>I thought that was the end for me and all of my dreams. I was pretending to be cool and calm so my younger brother and two sisters feel better. I was telling jokes, reading books or watching movies when we got some power from my uncle generator. &#8220;Life of Pi&#8221; was one of the movies we had watched and everyone enjoyed it! I refused to hold a gun, &#8220;How could it help?! That&#8217;s not my role in life!&#8221; I was thinking.</p>\n<blockquote><p>I was struggling to believe in tomorrow, no matter how it looked miserable and sad.</p></blockquote>\n<p>In one of the mornings, after a nearby airstrike, we got a chance to escape. I tried to hold every detail of our house, neighborhood and street. &#8220;Thank you for all great memories. I will definitely return,&#8221; I told my house, feeling torn apart back then! I only took my laptop, tablet, and few clothes, they were all what I needed to start over.</p>\n<h3>Starting Over</h3>\n<blockquote><p>“You can’t connect the dots looking forward; you can only connect them looking backwards. So you have to trust that the dots will somehow connect in your future. You have to trust in something — your gut, destiny, life, karma, whatever. This approach has never let me down, and it has made all the difference in my life.”<br />\n— Steve Jobs</p></blockquote>\n<p>After some time of catching my breath, I realized that I had to connect the dots, keep on following my dreams and aim higher. On May 2016, I moved to Sana&#8217;a, the capital city of Yemen, leaving the pain and frustration behind. I got to know some enthusiastic developers and we decided to establish a community called <a href=\"https://www.facebook.com/ydevclub/\">Yemeni Developers Club</a> for people who are interested in computer programming and have the passion for it. We hold a meeting on the first Saturday of every month to share ideas, answer questions, and help one another to innovate, learn, and grow. We are planning to have, in the near future, special meetings to discuss WordPress related topics and learn how to obtain the maximum benefit from it.</p>\n<img class=\"wp-image-1895 size-full\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/06/taiz_and_sanaa_poster.jpg\" alt=\"\" width=\"768\" height=\"420\" />Photos for Ta&#8217;izz and Sana&#8217;a cites, photographed by Mona Athubhani.\n<h3>Amazing Melting Pot</h3>\n<div class=\"_h8t\">\n<div id=\"js_jl2\" class=\"_5wd9 direction_rtl\">\n<div class=\"_5wde _n4o\">\n<div class=\"_5w1r _3_om _5wdf\">\n<div class=\"_4gx_\">\n<div class=\"_d97\"><span class=\"_5yl5\">I am sure that WordPress helps thousands of developers, including me, be more independent, involves them to be parts of it, and offers opportunities to serve people from around the world.</span></div>\n</div>\n</div>\n</div>\n</div>\n</div>\n<blockquote><p>WordPress is such an amazing melting pot that contains people from everywhere, no matter how old they are, where they are from, or what languages they speak.</p></blockquote>\n<h3>Become a Hero</h3>\n<p>Being a WordPress hero is not about programming skills or contributions size, it is all about the challenges we face and overcome. It is even more about supporting the new users to be the next heroes.</p>\n<hr />\n<h3>Thank You</h3>\n<p>Thanks to all my friends who contributed to make this essay better. Many thanks to <strong>Topher DeRosia</strong> for inviting me to write here and SPECIAL THANKS to <span id=\"cch_f100e4e57d51432\" class=\"_mh6 _wsc\"><span class=\"_3oh-\"><a href=\"https://about.me/mona_athubhani\"><strong>Mona Athubhani</strong></a> without whom I would not have completed this essay.</span></span></p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Trust The Dots\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Trust%20The%20Dots&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-the-dots%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Trust The Dots\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-the-dots%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Ftrust-the-dots%2F&title=Trust+The+Dots\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Trust The Dots\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/trust-the-dots/&media=https://heropress.com/wp-content/uploads/2017/06/060717-min-150x150.jpg&description=Trust The Dots\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Trust The Dots\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/trust-the-dots/\" title=\"Trust The Dots\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/trust-the-dots/\">Trust The Dots</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Jun 2017 00:00:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nashwan Doaqan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: VersionPress Launches VersionPress.com to Fund Open Source Project\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71410\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"https://wptavern.com/versionpress-launches-versionpress-com-to-fund-open-source-project\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3005:\"<p>The founders of <a href=\"http://versionpress.net/\">VersionPress</a> have launched <a href=\"https://preview.versionpress.com/\">VersionPress.com</a>, a <a href=\"https://blog.versionpress.net/2017/06/announcing-versionpress-com/\">WordPress managed hosting</a> service. VersionPress.com is the best of what VersionPress offers paired with features such as, staging sites and backups, on an Amazon Web Services infrastructure.</p>\n<p><img />VersionPress is essentially an undo button for WordPress or full version-control. At the click of a button, users can undo an action and restore a site&#8217;s database to a previous point in history without having to export and import MySQL.</p>\n<p>Borek Bernard, co-founder of VersionPress, says the move is the result of trying to overcome two major challenges: WordPress plugins and Hosts. WordPress plugins can alter a site&#8217;s database. Building <a href=\"https://github.com/versionpress/versionpress/blob/master/docs/Plugin-Support.md\">in support</a> for the 40K+ plugins that exist in the repository has been a huge undertaking for the team.</p>\n<p>In order to use VersionPress, a webhost needs to have <a href=\"https://git-scm.com/\">Git</a> installed and allow proc_open which it uses to interact with Git. Most hosts do not allow proc_open for security reasons or have older versions of Git installed, generating incompatibilities. &#8220;Over time, it became clear we needed our own environment to run VersionPress in,&#8221; Bernard said.</p>\n<p>All sites hosted on the platform run PHP 7 or Nginx, HTTP/2, and at least two Docker instances that auto-scale based on load. VersionPress.com includes the ability to set up staging and production sites using VersionPress&#8217; capabilities to merge changes between the two. Similar to <a href=\"https://getflywheel.com/why-flywheel/client-billing-transfer/\">Flywheel</a>, billing can be assigned to a developer, agency, or client account. &#8220;The platform is geared towards WordPress developers and agencies but will help anyone who wants a fast, reliable WordPress site,&#8221; Bernard said.</p>\n<p>The model they&#8217;re using is similar to WordPress.com and self-hosted WordPress. &#8220;A hosted service will provide resources to fund the development of the open source project and its long-term stability,&#8221; he said. &#8220;So it became a no-brainer at some point.&#8221; General availability for VersionPress.com won&#8217;t open until July but those who <a href=\"https://preview.versionpress.com/#preorder\">pre-order</a> will receive a substantial discount.</p>\n<p>Bernard re-iterated that VersionPress will always be a free, open source project and that VersionPress.com is a major step towards bringing full version control of WordPress to the masses.</p>\n<p>The managed WordPress hosting space is well established and perhaps a bit crowded. It will be interesting to see how VersionPress.com compares to and fits in with the competition.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 21:45:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Matt: Remote Work Can’t Be Stopped\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=47433\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://ma.tt/2017/06/remote-work-cant-be-stopped/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:489:\"<p>Christopher Mims writes for the Wall Street Journal <a href=\"https://www.wsj.com/articles/why-remote-work-cant-be-stopped-1496577602?mg=prod/accounts-wsj\">Why Remote Work Can&#8217;t Be Stopped</a>, also riffing off the <a href=\"https://ma.tt/2017/05/ibm-goes-non-remote/\">IBM shift I wrote about a few weeks ago</a>. I was exciting to see an <a href=\"https://automattic.com/\">Automattician</a> Julia featured at the top and a few other colleagues having their voice in the article.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 21:14:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"WPTavern: WPForms Acquires WP Mail SMTP Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71426\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wptavern.com/wpforms-acquires-wp-mail-smtp-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4349:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/06/wpforms.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://wpforms.com/\" target=\"_blank\">WPForms</a>, founded by Syed Balkhi, has <a href=\"https://wpforms.com/welcoming-wp-mail-smtp-to-the-wpforms-family/\" target=\"_blank\">acquired the free WP Mail SMTP plugin</a> from WordPress plugin developer <a href=\"https://www.callum-macdonald.com/\" target=\"_blank\">Callum MacDonald</a>. <a href=\"https://wordpress.org/plugins/wp-mail-smtp/\" target=\"_blank\">WP Mail SMTP</a> has more than 600,000 active installs and WPForms will allow it to continue to operate as an independent plugin on WordPress.org. Balkhi said the plugin will become the company&#8217;s go-to recommendation on WPForms as well as WPBeginner.</p>\n<p>Email deliverability is a common problem for all types of WordPress websites, but it is the most frequent support issue for those using WPForms.</p>\n<p>&#8220;The number is only growing as Gmail, Yahoo, and others implement aggressive filters to reduce spam,&#8221; Balkhi said. &#8220;These spam filters look to see whether an email is originating from the location it claims to be originating from. This causes the emails sent from your WordPress site to either go in the spam folder or sometimes not be delivered at all! Having a proper SMTP solution significantly increases email deliverability. I believe that once we implement the new UX and workflow, this will significantly reduce our support load since this is the #1 issue our users deal with.&#8221;</p>\n<p>After a few months of email exchanges, Balkhi and Callum MacDonald reached an agreement for WPForms to purchase WP Mail SMTP. Balkhi would not disclose the exact financial details of the acquisition but said it was &#8220;a five-figure-deal because the plugin itself did not generate any revenue.&#8221;</p>\n<p>MacDonald had considered monetizing the plugin in the past but saw too many hurdles as he became less active in the WordPress space over the past few years.</p>\n<p>&#8220;There are a few recent developments around SMTP that mean the plugin could use an update,&#8221; MacDonald said. &#8220;I didn&#8217;t have the time, so it made sense to move on at this point. I went over [monetizing] it several times. My conclusion is that it&#8217;s a lot harder than it looks. If I was still active in the WordPress space, it would make more sense, but I&#8217;m not, so monetizing was going to be a long road and hard work. It made more sense to sell.&#8221;</p>\n<p>Balkhi said he approached MacDonald because email deliverability was a problem that he was looking to solve for WPForms users as well as the larger WPBeginner and WordPress community.</p>\n<p>&#8220;We didn&#8217;t want to build an add-on for WPForms because the problem isn&#8217;t unique to just us,&#8221; Balkhi said. &#8220;It affects every form plugin and basically every WordPress website that sends an email of any kind (forgot password, user registration, etc).&#8221;</p>\n<p>Last year Balkhi and his team acquired <a href=\"https://wptavern.com/syed-balkhi-acquires-google-analytics-by-yoast-renames-to-monsterinsights\" target=\"_blank\">Yoast&#8217;s Google Analytics and renamed it to MonsterInsights</a>. Over the past year the plugin has continued its growth from 10 million downloads at the time of acquisition to more than 16 million today.</p>\n<p>Balkhi reports that the MonsterInsights acquisition has been a success but the product was a very different type of acquisition from the one announced today. He said he has no plans to build an email deliverability service but rather wants to invest in a solution that will help his customers and others in the WordPress community.</p>\n<p>WP Mail SMTP plugin users can expect improvements to the plugin and a more &#8220;beginner-friendly&#8221; redesign, which Balkhi anticipates to release at the end of Q3 or Q4 of 2017.</p>\n<p>&#8220;In terms of growing our WPForms&#8217; user base through WP Mail SMTP, that&#8217;s not our primary goal,&#8221; Balkhi said. &#8220;Our top priority is to solve the email deliverability issue that our existing users and the larger WordPress community faces.&#8221; Balkhi said he hopes to leverage the 600,000+ user base to negotiate better deals with established email deliverability services.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 20:12:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: Cory Miller and Dr. Sherry Walling Launch ZenTribes an Entrepreneur Peer Group\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71006\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"https://wptavern.com/cory-miller-and-dr-sherry-walling-launch-zentribes-an-entrepreneur-peer-group\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3202:\"<p>Being an entrepreneur can be stressful, emotional, and lonely, especially during a rough part of life. Cory Miller, founder of <a href=\"https://ithemes.com/\">iThemes</a>, has been at the forefront of <a href=\"https://wordpress.tv/2016/12/10/cory-miller-managing-your-iceberg/\">advocating</a> that entrepreneurs don&#8217;t have to go through the struggles of running a business alone.</p>\n<p>Two years after founding iThemes, Miller found himself going through a tough divorce at the same time his company started taking off.</p>\n<p>&#8220;Not many people in my life at that time could come close to relating to what I was going through as a human combined with being an entrepreneur,&#8221; Miller said.</p>\n<p>&#8220;I was suffering in solitude. And I was craving authentic relationships with like-minded people on a similar path who knew what living the entrepreneurial life — with its sometimes drastic ups and downs — meant and who were walking it every day, like me, and wanted to walk together with others too.&#8221;</p>\n<p>Miller eventually found himself in an <a href=\"http://corymiller.com/find-belonging-support-entrepreneurial-peer-group/\">entrepreneur peer group</a> in Oklahoma City, OK, where entrepreneurs meet once a month for three hours to discuss the trials and tribulations of running a business.</p>\n<p>Miller says the group is partially responsible for his good health and happiness as a business owner, father, husband, and human being.</p>\n<p>In an effort to create similar opportunities for other business owners, Miller has partnered with <a href=\"http://www.sherrywalling.com/\">Dr. Sherry Walling</a>, who has a PhD in Psychology, to launch <a href=\"http://zenfounder.com/zentribes/\">ZenTribes</a>.</p>\n<p>ZenTribes is a group of 6-9 like-minded entrepreneurs that get together once a month online to share stories, encouragement, and express support for one another. Walling and Miller are both members of the group and will be sharing their expertise with members.</p>\n<p>Meetings will take place every Wednesday from 1-2:30 PM Central Standard Time for eight weeks using <a href=\"https://zoom.us/\">Zoom</a>. The first meeting is on July 12th. The last meeting is on August 30th.</p>\n<p>The first 15 minutes of meetings will focus on a key topic with an hour set aside for discussions and sharing experiences related to that topic. The last 15 minutes are dedicated to sharing resources and giving attendees suggested homework.</p>\n<p>Some of the topics that will be discussed include:</p>\n<ul>\n<li>Burnout</li>\n<li>Depression</li>\n<li>Conflict</li>\n<li>Failure and loss</li>\n<li>Loneliness and friendship</li>\n</ul>\n<p>ZenTribes is <a href=\"http://zenfounder.com/zentribes/apply/\">accepting applications</a> for the first group of people until 1 PM CST June 15th. The cost to be a member of the group is $799. For more information about this initiative, <a href=\"http://zenfounder.com/episodes/episode-120-announcing-zentribes/\">listen to episode 120</a> of the ZenFounder podcast. In it, Miller and Sherry describe the program, why they created it, and how entrepreneurial groups can benefit business owners.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 17:35:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Safe Avocado-ing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=47427\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://ma.tt/2017/06/safe-avocado-ing/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:460:\"<p>I&#8217;m glad <a href=\"https://www.nytimes.com/2017/05/01/dining/avocado-injuries-cutting-safety.html?_r=2\">the New York Times is covering how to safely cut an avocado</a>, because I&#8217;ve messed that up 100% of the time I&#8217;ve tried to handle an avocado in the past month. It makes you almost want to forgive them for that <a href=\"https://www.eater.com/2017/3/14/14905200/pea-guacamole-controversy-melissa-clark\">green pea guacamole thing</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Jun 2017 04:07:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: WordCamp Europe 2017 Livestream Tickets Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71286\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wptavern.com/wordcamp-europe-2017-livestream-tickets-now-available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1075:\"<p>WordCamp Europe will be livestreaming all sessions again this year to make the event accessible to those who are unable to travel to Paris. Live stream tickets are free, but viewers must sign up on the <a href=\"https://2017.europe.wordcamp.org/tickets/\" target=\"_blank\">tickets page</a>.</p>\n<p>Organizers have also set up a page on the event&#8217;s website for people to advertise for <a href=\"https://2017.europe.wordcamp.org/2017/06/02/got-a-wceu-ticket-to-sale-let-others-know/\" target=\"_blank\">buying or selling tickets</a>. Many who have already purchased regular tickets have had a last-minute change of plans, problems with obtaining a visa, or have an extra ticket due to being selected as a speaker or a volunteer. More than two dozen tickets have already been posted for sale.</p>\n<p>Regular ticket sales concluded at the end of May, but there are 2,915 livestreaming <a href=\"https://2017.europe.wordcamp.org/tickets/\" target=\"_blank\">tickets remaining</a>, along with 272 micro-sponsorship slots at € 150.00 apiece.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Jun 2017 20:07:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: Vue.js Creator Evan You Weighs in on WordPress JavaScript Framework Discussion\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71279\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"https://wptavern.com/vue-js-creator-evan-you-weighs-in-on-wordpress-javascript-framework-discussion\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8193:\"<a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/06/evan-you.png?ssl=1\"><img /></a>photo credit: <a href=\"https://www.youtube.com/watch?v=EiTORdpGqns\">JSConf China</a>\n<p>Last week WordPress core contributors <a href=\"https://wptavern.com/wordpress-core-javascript-framework-debate-heats-up-contributors-narrow-discussion-to-react-vs-vue\" target=\"_blank\">narrowed their considerations for a new JavaScript framework to React and Vue</a>. As the core team has more collective knowledge of working with React, they have reached out to developers with different experiences of using other frameworks in a  WordPress context.</p>\n<p>One of the chief concerns contributors have regarding Vue is the longevity of the project. I asked Vue creator <a href=\"http://evanyou.me/\" target=\"_blank\">Evan You</a> if he could weigh in on the topic to give WordPress contributors a better understanding of the project, specifically regarding his efforts to cultivate additional maintainers to help share the load of maintainership.</p>\n<p>&#8220;I think it&#8217;s important to look at the track record &#8211; Vue has been around for almost 4 years, and all the work has been done in public on GitHub so anyone can go and check the maintenance history,&#8221; You said. &#8220;While it has been largely developed by me, the current maintenance is a lot more community-driven. We have active core team members triaging most of the issues and a larger and larger percentage of the issues fixed by community PRs. So &#8211; yes, I had already been working on cultivating additional maintainers and will continue to do so.&#8221;</p>\n<p>You currently receives <a href=\"https://www.patreon.com/evanyou\" target=\"_blank\">$10K/month from recurring Patreon donations</a> that fund his full-time efforts working on Vue. Prior to this he also worked at Google and Meteor. During his time at Google, some of the projects You worked on used Angular, which he said he found to be too heavy for his use cases at the time. He built Vue.js to be a more lightweight implementation of the concepts that he liked about Angular.</p>\n<p>You also recently said he has learned quite a bit from the React community, which has influenced some of his technical decisions in Vue 2.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">I learned a lot from the React community &#8211; on both code and people. I hope everyone can be like <a href=\"https://twitter.com/dan_abramov\">@dan_abramov</a>. Peace.</p>\n<p>&mdash; Evan You (@youyuxi) <a href=\"https://twitter.com/youyuxi/status/869020366705799168\">May 29, 2017</a></p></blockquote>\n<p></p>\n<p>&#8220;First, Vue 2 uses the same Virtual DOM based rendering model underneath, which was first pioneered by React,&#8221; You said. &#8220;Introducing a Virtual DOM allowed Vue to expose the power of vdom composition while maintaining the approachability.</p>\n<p>&#8220;The React community is also very active when there are new problem domains being explored &#8211; e.g. state management and CSS management. There are many competing solutions and a lot of inspirations when I was implementing official solutions for Vue.&#8221;</p>\n<h3>Evan You Addresses WordPress Core Contributors&#8217; Misconceptions about Vue.js</h3>\n<p>You said he has been following WordPress contributors&#8217; discussions on React vs Vue but would not offer an opinion on which is a better choice for the project.</p>\n<p>&#8220;My answer would obviously be biased, and honestly I&#8217;m not in the shoes of the WP core team so I don&#8217;t have enough perspective to make a choice,&#8221; You said. &#8220;However, I can provide feedback on some of the issues being discussed in hope of helping them make a better-informed decision.&#8221;</p>\n<p>You left a <a href=\"https://make.wordpress.org/core/2017/05/31/javascript-chat-summary-for-may-30th/#comment-32642\" target=\"_blank\">comment</a> on the most recent Javascript meeting notes with clarifications on a few misunderstandings about Vue.js. You addressed the point regarding &#8220;embracing JavaScript the language,&#8221; as some contributors think Vue&#8217;s templating language obscures the underlying JavaScript.</p>\n<p>&#8220;I think &#8217;embracing JavaScript the language&#8217; is another primitive of React we don’t see in Vue,&#8221; Andrew Duthie <a href=\"https://wordpress.slack.com/archives/C02RQBWTW/p1496150274570299\" target=\"_blank\">said</a> during the last meeting.</p>\n<p>You&#8217;s reply compares Vue&#8217;s use of templates as &#8220;syntax sugar for view representation on top of HTML&#8221; to what he believes to be a similar usage in the case of JSX as view representation on top of JavaScript:</p>\n<blockquote><p>The increasing richness of UI does NOT necessitate putting everything in JavaScript. On the other hand, just because Vue uses templates by default doesn’t mean it allows people to get by without learning JavaScript properly.</p>\n<p>Vue’s templates are compiled into JavaScript render functions under the hood and they are actually closer to JavaScript than to traditional string templating. It’s just a layer of syntax sugar on top of the underlying Virtual DOM representation. Think of JSX as syntax sugar for view representation on top of JS; Vue templates are syntax sugar for view representation on top of HTML.</p>\n<p>JSX/Raw JS does provide more flexibility when you need to apply direct manipulation of Virtual DOM nodes, this is why Vue also supports render functions. But this is not putting two opposing paradigms under the same tent – it’s simply allowing the user to skip the syntax sugar layer for more control.</p></blockquote>\n<p>You said the idea behind templating on top of render functions is to provide &#8220;better approachability,&#8221; a concern shared by many other proponents of WordPress adopting Vue.</p>\n<p>&#8220;Users who are more comfortable with HTML and have simpler use cases could use the template, while users who are already familiar of JSX/render functions can leverage the full power of JS,&#8221; You said. &#8220;This would fit pretty nicely for the use of WP core: community users who care about approachability have an easier time getting started, while the core team have access to JSX/render functions for advanced use cases.&#8221;</p>\n<p>You also addressed the concern of longevity by offering more information on Vue&#8217;s development processes. He confirmed that the current codebase is largely developed by him alone, but maintenance is spread across a core team with members all over the world.</p>\n<p>&#8220;Other contributors have lower commit counts because their contributions are all submitted in the form of PRs and we use the &#8216;Squash and commit&#8217; feature on GitHub so each PR results in only one commit for the contributor,&#8221; You said. &#8220;We’ve merged close to 500 PRs in the core repo alone, and many more across the organization. Other repos under the vuejs organization, e.g. vuex, vue-router, vuejs.org are also largely maintained by dedicated team members.&#8221;</p>\n<p>You also offered clarification on questions of stability and future compatibility, as WordPress contributors presented concerns regarding breaking changes in the templating language in Vue 2.0.</p>\n<p>&#8220;This begs for some clarification: Vue versioning strictly follows semver,&#8221; You said. &#8220;The only time there had been breaking API changes post 1.0 was the 2.0 bump. The template syntax is part of the API so it’s not going to [break], and in between major version bumps we commit to 100% API backwards compatibility. We take stability very seriously, so do our community and in-production users, including GitLab, Vice, and some of the biggest internet companies in China.&#8221;</p>\n<p>As many WordPress core contributors have been developing on top of React for years, You&#8217;s input offers a more detailed, in-depth look at Vue that contributors have been asking for during various rounds of feedback. The discussion will continue over the next several weeks and contributors plan to include the topic at WordCamp Europe&#8217;s contributor summit.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Jun 2017 18:04:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Open Sourcing Mental Illness Surpasses $50K Fundraising Goal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71138\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"https://wptavern.com/open-sourcing-mental-illness-surpases-50k-fundraising-goal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3035:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2016/03/mental-health-in-tech-2016.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://osmihelp.org/\" target=\"_blank\">Open Sourcing Mental Illness</a> (OSMI), a non-profit organization that raises mental health awareness in the tech community, has <a href=\"https://osmihelp.org/blog/fundraising-2017-recap\" target=\"_blank\">surpassed its $50K fundraising goal</a> for 2017. Ed Finkler, who founded OSMI in 2013, left his position as CTO of <a href=\"https://www.graphstory.com/\" target=\"_blank\">Graph Story</a> to work full-time on speaking, educating, and providing resources to support mental wellness in the tech and open source communities. As of today, the campaign has raised more than $58,000.</p>\n<p>In addition to donations from individuals, OSMI has added several corporate sponsors, including CakeDC, Github, Digital Ocean, and Laravel. CakeDC has designated $1,000/month for 12 months to support Finkler&#8217;s salary. Finkler works together with a board of directors and a team of volunteers who also speak at conferences about mental health in tech. Several WordPress companies have also been involved in raising support for OSMI, including <a href=\"https://www.youcaring.com/opensourcingmentalillness-704978\" target=\"_blank\">WebDevStudios</a> and <a href=\"https://wptavern.com/wp-elevation-is-focusing-all-content-on-mental-health-for-month-of-may\" target=\"_blank\">WP Elevation</a>.</p>\n<p>OSMI conducts an annual Mental Health in Tech survey as part of ongoing research. Last year&#8217;s survey received more than 1,500 responses and the results underscore the great need for removing the stigma surrounding mental illness in the tech industry. A few examples Finkler highlighted include:</p>\n<ul>\n<li>Respondents believe it&#8217;s 6 times more likely that discussing a mental health issue with their employer would have a negative consequence, vs a physical health issue.</li>\n<li>Respondents are 3.5 times less likely to bring up a mental health issue in an interview than a physical health issue.</li>\n<li>87% believe being identified as a person with a mental health issue would hurt their career.</li>\n<li>Only 30% of respondents&#8217; employers provide information about mental health and how to seek help.</li>\n</ul>\n<p>OSMI offers all of the resources it creates for free. The funds raised in the campaign will help to create more tools, documents, videos, and other educational resources. Finkler is working towards engaging with more HR departments and educating more executive teams. He also plans to use the funds to do more research and employ additional experts to reach more people.</p>\n<p>For more information about OSMI&#8217;s efforts to improve mental health in the tech industry, check out Jeff Chandler&#8217;s <a href=\"https://wptavern.com/wpweekly-episode-273-mental-health-awareness-with-bridget-willard-and-ed-finkler\" target=\"_blank\">recent interview with Finkler on the WP Weekly podcast</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 03 Jun 2017 03:59:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: In Case You Missed It – Issue 21\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=71142&preview=true&preview_id=71142\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wptavern.com/in-case-you-missed-it-issue-21\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6022:\"<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2016/01/ICYMIFeaturedImage.png?ssl=1\" rel=\"attachment wp-att-50955\"><img /></a>photo credit: <a href=\"http://www.flickr.com/photos/112901923@N07/16153818039\">Night Moves</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-nc/2.0/\">(license)</a>\n<p>There’s a lot of great WordPress content published in the community but not all of it is featured on the Tavern. This post is an assortment of items related to WordPress that caught my eye but didn’t make it into a full post.</p>\n<h2>Bob Dunn and Patrick Rauland Host Lift Off Summit</h2>\n<p><a href=\"https://bobwp.com\">Bob Dunn</a> and <a href=\"https://www.speakinginbytes.com/\">Patrick Rauland</a> have partnered up for <a href=\"https://www.liftoffsummit.com/\">Lift Off Summit</a>. Between June 19-23, visitors will be able to watch 3-4 videos per day focused on getting more traffic, increasing social interactions, and keeping customers to their online stores. The virtual conference is free to watch.</p>\n<h2>The Evolution of WordPress Magazine Themes</h2>\n<p>Alex Denning takes a look back at the <a href=\"http://www.wpzoom.com/case-studies/magazine-themes-whats-next/\">evolution of WordPress magazine themes</a> over the last 10 years and offers insights into what might be next for the style.</p>\n<p>WordPress magazine themes were a huge deal between 2009-2011. Brian Gardner was able to create a profitable business with a single magazine style theme called Revolution, one of the first themes to display content in ways different from the typical single column blog layout.</p>\n<p>Magazine themes are a great chapter of WordPress&#8217; history. Their popularity is why WordPress has featured images and automatic thumbnail generation in core.</p>\n<h2>Highlights From Season Four of ManageWP&#8217;s Ask Me Anything</h2>\n<p>ManageWP <a href=\"https://managewp.com/ama-season-4-highlights\">published highlights</a> from season four of Ask Me Anything, a weekly event where members of the WordPress community voluntarily answer any questions submitted.</p>\n<h2>WordPress 4.8 Field Guide</h2>\n<p>Everything you need to know to prepare for WordPress 4.8, tentatively scheduled for release on June 8th, is in <a href=\"https://make.wordpress.org/core/2017/05/26/wordpress-4-8-field-guide/\">the field guide</a>.</p>\n<h2>Take the WPCampus WordPress in Higher Education Survey</h2>\n<p>WPCampus is once again asking for those who work with WordPress in educational settings to fill out the <a href=\"https://www.surveymonkey.com/r/wpcampus17\">following survey</a>. This year, three randomly selected participants will receive a free ticket to attend WPCampus in Buffalo, NY, July 14-15.</p>\n<p>The data will be used to create a series of reports on how WordPress is used in public schools and higher education. <a href=\"https://wptavern.com/wpcampus-survey-results-indicate-misconceptions-of-wordpress-are-slowing-its-growth-in-higher-education\">Last year&#8217;s survey</a> indicated that misconceptions surrounding WordPress security and scalability are slowing its growth in higher education.</p>\n<h2>A Plugin for Monitoring Directory Sizes</h2>\n<p>David Bisset shared a dashboard widget that displays the sizes of directories.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">WordPress dashboard widget that displays directory sizes, in case you need to keep an eye on that for some reason. <a href=\"https://t.co/eWu6cxtze7\">https://t.co/eWu6cxtze7</a> <a href=\"https://t.co/bPOgXVkwvL\">pic.twitter.com/bPOgXVkwvL</a></p>\n<p>&mdash; David Bisset (@dimensionmedia) <a href=\"https://twitter.com/dimensionmedia/status/870081713036181504\">June 1, 2017</a></p></blockquote>\n<p></p>\n<h2>Stop Signup Spam Integrates with GiveWP</h2>\n<p><a href=\"https://wordpress.org/plugins/stop-signup-spam/\">Stop Signup Spam</a>, a plugin we <a href=\"https://wptavern.com/new-wordpress-plugin-blocks-spam-user-registrations-using-stop-forum-spam-database\">featured last month</a> now integrates with GiveWP.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">My \"Stop Signup Spam\" plugin now integrates with <a href=\"https://twitter.com/GiveWP\">@GiveWP</a>, thanks to a contribution from <a href=\"https://twitter.com/learnwithmattc\">@learnwithmattc</a>! <a href=\"https://t.co/hmHBxxKEki\">https://t.co/hmHBxxKEki</a></p>\n<p>&mdash; Leland Fiegel (@lelandf) <a href=\"https://twitter.com/lelandf/status/869976727912579073\">May 31, 2017</a></p></blockquote>\n<p></p>\n<h2>LED WordPress Badge</h2>\n<p>George Stephanis unveiled his wifi-enabled light up WordPress badge on Twitter. He ordered the parts and soldered them together himself. You&#8217;ll get to see it in person if you&#8217;re attending <a href=\"https://2017.kyoto.wordcamp.org/\">WordCamp Kyoto</a>.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">IT IS ALIIIIIIIVE! I\'ll be debuting my shiny new (wifi-enabled, esp-8266 powered) WordPress badge in ONE MONTH at <a href=\"https://twitter.com/wckyoto2017\">@wckyoto2017</a>! <a href=\"https://t.co/P7WZmQUf9z\">pic.twitter.com/P7WZmQUf9z</a></p>\n<p>&mdash; george ﬆephanis (@daljo628) <a href=\"https://twitter.com/daljo628/status/869653149245747201\">May 30, 2017</a></p></blockquote>\n<p></p>\n<h2>Wabster!</h2>\n<p>In what is a traditional part of this series, I end each issue by featuring a Wapuu design. For those who don&#8217;t know, Wapuu is the <a href=\"http://wapuu.jp/2015/12/12/wapuu-origins/\">unofficial mascot</a> of the WordPress project. This week&#8217;s edition features a variation of the Wapuu design. <a href=\"https://wapu.us/wapuu/wabster/\">Wabster</a>, created by Alison Knott, is the <a href=\"https://2017.halifax.wordcamp.org/2017/04/05/welcome-lobster-wapuu-wordcamp-halifaxs-official-mascot/\">mascot of WordCamp Halifax</a>.</p>\n<p><img /></p>\n<p>That&#8217;s it for issue twenty-one. If you recently discovered a cool resource or post related to WordPress, please share it with us in the comments.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Jun 2017 20:23:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Chassis Desktop Application for Local WordPress Development Now in Beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71126\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://wptavern.com/chassis-desktop-application-for-local-wordpress-development-now-in-beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2112:\"<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/06/chassis-desktop.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://hmn.md/\" target=\"_blank\">Human Made</a> has released its first public beta of <a href=\"http://beta.chassis.io/\" target=\"_blank\">Chassis Desktop</a>, an application for local WordPress development. <a href=\"https://github.com/Chassis/Chassis/\" target=\"_blank\">Chassis</a> is a Vagrant-based virtual server and a community project that Human Made has commercially supported since 2012. The new desktop app is in early beta at version 0.2.0 with version 1.0.0 coming soon.</p>\n<p>Chassis Desktop was designed with a user-friendly interface suitable for beginners and experts alike. It was built by Bronson Quick and Ryan McCue using <a href=\"http://electron.atom.io/\" target=\"_blank\">Electron</a> and contains code from the <a href=\"https://github.com/facebookincubator/create-react-app\" target=\"_blank\">create-react-app</a> project.</p>\n<p>On first launch the app makes sure that Vagrant and VirtualBox are installed and then guides the user to create a new box. Setting up a new Chassis install or adding Chassis to an existing install is fast and easy with the simple UI. The app also includes keyboard navigation and a built-in terminal for quick access to more control over your box.</p>\n<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/06/add-new-box.png?ssl=1\"><img /></a></p>\n<p>Over the years Chassis contributors have created an ecosystem of <a href=\"http://beta.chassis.io/extensions/\" target=\"_blank\">extensions</a> for things like MailHog, Photon, Memcache, debugging, and other software. These add-ons allow users to tailor their systems to their needs.</p>\n<p>Chassis Desktop aims to make it easy for users to manager their Chassis development environments without having to touch the command line. As it is currently in pre-release status, early adopters may discover some bugs. Beta testers are encouraged to <a href=\"https://github.com/Chassis/Desktop/issues\" target=\"_blank\">log any issues on GitHub</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Jun 2017 03:24:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Dev Blog: WordPress 4.8 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4765\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2017/06/wordpress-4-8-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1160:\"<p>The second release candidate for WordPress 4.8 is now available.</p>\n<p>To test WordPress 4.8, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.8-RC2.zip\">download the release candidate here</a> (zip).</p>\n<p>We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log/trunk/?action=stop_on_copy&mode=stop_on_copy&rev=40866&stop_rev=40847\">a handful of changes</a> since releasing RC 1 last week. For more details about what&#8217;s new in version 4.8, check out the <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\">Beta 1</a>, <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-2/\">Beta 2</a>, and <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-release-candidate/\">RC1</a> blog posts.</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you&#8217;ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Happy testing!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jun 2017 22:13:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Mel Choyce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: Inpsyde Open Sources Wonolog, a Monolog-based Logging Package for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71109\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"https://wptavern.com/inpsyde-open-sources-wonolog-a-monolog-based-logging-package-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1721:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/06/wonolog.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://inpsyde.com\" target=\"_blank\">Inpsyde</a>, a WordPress agency and WordPress.com VIP partner based in Germany, has open sourced <a href=\"https://inpsyde.com/en/wonolog-wordpress-logging-library/\" target=\"_blank\">Wonolog</a>, a package that integrates Monolog for sophisticated WordPress data logging. <a href=\"https://seldaek.github.io/monolog/\" target=\"_blank\">Monolog</a> is the most widely used PHP logging library with more than 57 million downloads to date.</p>\n<p>Wonolog automatically creates logs that target specific WordPress requests and can be customized with action and filter hooks. Here are a few examples of WordPress data it can log:</p>\n<ul>\n<li>Log any failed logins</li>\n<li>Keep track of all WordPress cron requests</li>\n<li>Intercept the WordPress-specific exit function, wp_die(), and log any (direct or indirect) usage</li>\n<li>PHP core notices, warnings and (fatal) errors, uncaught exceptions (as well as PHP 7+ Throwable)</li>\n<li>WordPress core errors such as database errors, HTTP API errors, wp_mail() errors, and 404 errors</li>\n</ul>\n<p>Wonolog is available as a Composer package and its creators recommend installing at the website level. Inpsyde has been using it successfully in production with different projects for several months. Wonolog requires PHP 5.6 or higher and WordPress 4.6+. A <a href=\"https://inpsyde.github.io/Wonolog/\" target=\"_blank\">documentation site</a> is available to help new users get started and the project can be found on <a href=\"https://github.com/inpsyde/Wonolog\" target=\"_blank\">GitHub</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jun 2017 20:54:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: WPWeekly Episode 275 – The JavaScript Framework Rabbit Hole\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=71102&preview=true&preview_id=71102\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://wptavern.com/wpweekly-episode-275-the-javascript-framework-rabbit-hole\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2549:\"<p>In this episode, <a href=\"http://jjj.me/\">John James Jacoby</a> and I celebrate WordPress&#8217; 14th birthday. We discuss the removal of HHVM from WordPress&#8217; testing infrastructure and how it was likely the reason PHP 7 gained so many performance improvements.</p>\n<p>For a majority of the show, Jacoby and I spoke in-depth on which JavaScript framework WordPress core should choose. We discuss what&#8217;s at stake, who might be impacted, and why the discussion and eventual decision is important for WordPress&#8217; future. To round out the show, we share our picks of the week and let you know about <a href=\"https://central.wordcamp.org/\">upcoming WordCamps</a>.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://ma.tt/2017/05/wordpress-14/\">WordPress Turns 14</a><br />\n<a href=\"https://wptavern.com/wordpress-removes-hhvm-from-testing-infrastructure\">WordPress Removes HHVM from Testing Infrastructure</a><br />\n<a href=\"https://wptavern.com/wordpress-core-javascript-framework-debate-heats-up-contributors-narrow-discussion-to-react-vs-vue\">WordPress Core JavaScript Framework Debate Heats Up, Contributors Narrow Discussion to React vs. Vue</a></p>\n<h2>Picks of the Week:</h2>\n<p><a href=\"https://wapu.us/\">Wapu.us</a>, created by James Tryon, is a place to discover and learn about Wapuu, the unofficial mascot of the WordPress project.</p>\n<p><a href=\"https://github.com/humanmade/Cavalcade\">Cavalcade</a> is a scalable job system, designed as a drop-in replacement for WordPress’ built-in pseudo-cron system <a href=\"https://engineering.hmn.md/projects/cavalcade/\">created by Human Made</a>.</p>\n<p><a href=\"https://givewp.com/\">Give</a> is a free WordPress donation management plugin by <a href=\"https://wordimpress.com/\">WordImpress.</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, June 7th 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #275:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jun 2017 01:09:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: WP-CLI 1.2.0 Released, Project Unveils New Logo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71086\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wptavern.com/wp-cli-1-2-0-released-project-unveils-new-logo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3398:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/05/wp-cli-logo.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://make.wordpress.org/cli/2017/05/31/version-1-2-0-released/\" target=\"_blank\">WP-CLI 1.2.0</a> was released today with a major overhaul that removes bundled commands from core in favor of maintaining them in distinct packages. This is the second release since the project was <a href=\"https://wptavern.com/wp-cli-gets-official-wordpress-org-support\" target=\"_blank\">brought under the official WordPress umbrella</a> and the first major release since <a href=\"https://wptavern.com/wp-cli-names-alain-schlesser-new-co-maintainer\" target=\"_blank\">hiring Alain Schlesser as a part-time co-maintainer</a>.</p>\n<p>Splitting WP-CLI&#8217;s internal commands into separate packages moves the project closer to the goal of having official maintainers for the commands in the future. This new structure for the framework and its commands provides several benefits, as outlined by co-maintainer Daniel Bachhuber in the release post:</p>\n<ul>\n<li>While developing, the tests are only run for the specific component you’re working on, making the feedback loop much shorter.</li>\n<li>Individual command packages can be controlled and set up independently, opening up the opportunity for better collaboration.</li>\n<li>Hotfixes and intermediary releases can be published for individual commands, that can then be updated through the built-in package manager.</li>\n<li>Tests run really fast now.</li>\n<li>When you submit a pull request, you don’t have to wait two hours for the tests to run.</li>\n</ul>\n<p>This release also includes three new commands, along with dozens of command improvements and framework enhancements.</p>\n<ul>\n<li><code>wp config get</code> lists constants and globals defined in wp-config.php</li>\n<li><code>wp config path</code> gets the path to wp-config.php</li>\n<li><code>wp db size</code> gets the size of the database and its tables</li>\n</ul>\n<p>Version 1.2.0 had 43 contributors, a 95% increase in contributors from the previous release. One of the next priorities for maintainers is to improve the contribution workflow. Bachhuber said there are no plans at the moment to bring on additional paid co-maintainers, but they plan to start onboarding more volunteer committers. These are developers who are involved with the project on a regular basis but not necessarily daily or weekly. They have also created a <a href=\"https://make.wordpress.org/cli/good-first-issues/\" target=\"_blank\">Good First Issues page</a> for new contributors and have started working on a <a href=\"https://make.wordpress.org/cli/dash/\" target=\"_blank\">customized dashboard for committers</a>.</p>\n<h3>WP-CLI Has a New Logo</h3>\n<p>Bachhuber introduced the project&#8217;s new logo today, designed by Chris Wallace and his team at <a href=\"https://liftux.com/\" target=\"_blank\">Lift UX</a>. Having an official logo opens up the possibility for WP-CLI swag. Bachhuber said he worked with contributors to create a logo, because &#8220;people can develop stronger emotional affinity to brands with logos (myself included).&#8221; He is also interested in getting stickers created, particularly ones that glow in the dark, but has not yet found a producer. Bachhuber said he is hoping to have some preliminary WP-CLI swag for WordCamp Europe.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jun 2017 00:17:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: Pods 2.7 Beta Introduces Flexible Relationships, Rewrites Fields in JavaScript\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71009\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"https://wptavern.com/pods-2-7-beta-introduces-flexible-relationships-rewrites-fields-in-javascript\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2272:\"<p>Pods Framework has released two new versions. <a href=\"http://pods.io/2017/05/30/pods-2-6-9-maintenance-release/\">Pods 2.6.9</a> is a maintenance release that includes bug fixes for Pods Templates, Auto Templates, and Pods Shortcodes. Meanwhile, <a href=\"http://pods.io/2017/05/30/pods-2-7-beta/\">Pods 2.7 beta 1</a> introduces a new feature called Flexible Relationships.</p>\n<p>Flexible Relationships uses WordPress&#8217; media modal that allows users to add or edit records from within the parent record of a relationship. This feature will work on existing relationships once users upgrade to 2.7. Watch the following video to see Flexible Relationships in action.</p>\n<div class=\"embed-wrap\"></div>\n<p>In addition to providing Flexible Relationships, the fields were rewritten in JavaScript by Phil Lewis, Contributing Developer to Pods Framework.</p>\n<p>&#8220;Phil Lewis of our team rewrote our file upload and relationship fields in what we&#8217;re calling Dynamic Field Views which will allow us to convert all of our field types to be JavaScript powered,&#8221; <a href=\"https://scottkclark.com/\">Scott Kingsley Clark</a>, lead developer of <a href=\"http://pods.io/\">Pods Framework</a> said.</p>\n<p>&#8220;The JavaScripts frameworks behind it are Marionette + Backbone. We wrote it with React in mind so we can convert it over whenever React.js is included in core and things settle there&#8221;</p>\n<p>The development team is asking for as many users as possible to test Flexible Relationships on a staging or testing site so issues can be addressed before its release, tentatively scheduled for the middle of July. Those interested in testing can download the <a href=\"https://github.com/pods-framework/pods/archive/release/2.7.zip\">beta from Pods&#8217; GitHub repository</a>.</p>\n<p>Testers are encouraged to download the <a href=\"https://github.com/afragen/github-updater\">GitHub Updater</a> plugin, created by Andy Fragen, as it makes it easier to download updates from GitHub. If you participate in the testing process, be sure to add &#8216;2.7&#8217; to any feature, enhancement requests, or bugs that you find when <a href=\"https://github.com/pods-framework/pods/issues/new\">creating a new issue</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 31 May 2017 20:37:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: GitHub Introduces Temporary Interaction Limits to Promote Healthier Discussions\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=71072\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"https://wptavern.com/github-introduces-temporary-interaction-limits-to-promote-healthier-discussions\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5118:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2015/04/github-octocat.jpg?ssl=1\"><img /></a></p>\n<p>GitHub is continuing to make good on its promise to <a href=\"https://wptavern.com/github-responds-to-letter-from-open-source-project-maintainers\" target=\"_blank\">improve the platform for open source maintainers and communities</a> with its new <a href=\"https://github.com/blog/2370-temporary-interaction-limits\" target=\"_blank\">temporary interaction limits</a>. The feature was introduced this week as a way for project maintainers to manage participation in heated discussions.</p>\n<p>Public repositories, especially those for projects with millions of users, can occasionally have issues or pull requests that become overrun with comments from anyone who has an opinion. Repository owners can now set a 24-hour &#8220;cool down period&#8221; to limit interaction (commenting, creating pull requests, and opening issues) to existing users, prior contributors, and/or repository collaborators.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/05/temporary-interaction-limits.png?ssl=1\"><img /></a></p>\n<p>Temporary Interaction Limits can help mitigate the effects of &#8220;brigading,&#8221; <a href=\"https://news.ycombinator.com/item?id=14447705\" target=\"_blank\">as one Hacker News commenter called it</a> &#8211; when someone directs a large number of people to an issue from Twitter, Reddit, or other social channels in an attempt to influence the outcome of a discussion. Limiting the discussion to prior contributors or collaborators can help keep input focused around the ideas of those who are already invested in the project.</p>\n<p>Reactions to the new feature have been mostly positive, although some users don&#8217;t anticipate using it much since <a href=\"https://github.com/blog/2119-add-reactions-to-pull-requests-issues-and-comments\" target=\"_blank\">GitHub added emoji reactions to conversations</a> last year. In addition to keeping threads from becoming unreadable with numerous +1&#8217;s, emoji reactions as an option for expression should help limit interactions from those prone to &#8220;drive-by&#8221; commenting.</p>\n<p>A curated repository of &#8220;<a href=\"https://github.com/nikolas/github-drama\" target=\"_blank\">GitHub Drama</a>,&#8221; which includes projects like Bower, Docker, Django, and NodeJS, lists many instances wherein temporarily limiting interaction may have changed the overall tone of the discourse. However, some users questioned the feature&#8217;s usefulness in responses on Twitter and some see it as a way of purposely cutting outside voices out of the conversation.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">So many of us are curious: when would we use this? Locking down an entire repo to calm a single conversation is drastic overkill…</p>\n<p>&mdash; Nick Craver (@Nick_Craver) <a href=\"https://twitter.com/Nick_Craver/status/869661854917939202\">May 30, 2017</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Nothing settles a technical discussion faster than the in-group forcibly silencing the out-group</p>\n<p>&mdash; Lee Clemens (@LeeClemens) <a href=\"https://twitter.com/LeeClemens/status/869670471561875456\">May 30, 2017</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">I don\'t know about the value of this feature regarding open source collaboration, but I\'d love to have this capability in my email system</p>\n<p>&mdash; Brian Mitchell (@DrBrianMitchell) <a href=\"https://twitter.com/DrBrianMitchell/status/869726709007998977\">May 31, 2017</a></p></blockquote>\n<p></p>\n<p>In order for temporary interaction limiting to be useful to projects where locking down the whole repository would be too drastic of a measure, GitHub would need to extend it to include the ability to lock down individual issues and pull requests. Some users have also requested a convenient way for repository members to warn an individual without spamming the entire thread or to put specific users in a cool down period.</p>\n<p>&#8220;If it&#8217;s a legit heated discussion and you limit it, then you&#8217;re just [going] to come back in 24 hours to very long, impossible-to-follow responses,&#8221; Kris Siegel, Senior Engineer at PlayStation, <a href=\"https://news.ycombinator.com/item?id=14448871\" target=\"_blank\">commented</a> on the related Hacker News thread. &#8220;At least this has been my experience when people have left things to cool down them come back and need to respond to everything.&#8221;</p>\n<p>GitHub is aiming to promote healthier discussions with the new interaction limiting feature, but every project&#8217;s community is unique and maintainers may not be able to predict user reactions to locking down an entire repository. If the feature is turned on when a new user is attempting to create their first pull request, it may hinder future contribution.  Open source project maintainers should carefully consider the effects of silencing non-contributors when using the feature.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 31 May 2017 20:35:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"HeroPress: Building A WordPress Career in India\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1874\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"https://heropress.com/essays/building-wordpress-career-india/?utm_source=rss&utm_medium=rss&utm_campaign=building-wordpress-career-india\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10728:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/05/053117-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: Give your children the room to grow.\" /><p>6 years back, I’d have never thought I would be where I am right now. At that time, I was a 12-year-old wondering how softwares were made. Despite the fact that I was born in a middle-class Indian family, my parents never forced me to opt for something I wasn’t interested in. Unlike other middle-class Indian children, the bar of expectations wasn’t set that high and I think it turned out to be for the best.</p>\n<p>My parents always supported me and constantly motivated me to learn whatever I liked. Eventually, from wondering about how software was made, I started wondering same about websites. For some reason, I felt more interested in websites than software. For starters, I felt coding in HTML was easier than working with C/C++</p>\n<p>Now that I’ve bored you already, let’s get to know each other too. I am <a href=\"http://technobooz.com\" target=\"_blank\" rel=\"noopener noreferrer\">Suyogya Shukla</a>, a WordPress developer from Kanpur, India. I work with <a href=\"https://themeisle.com\" target=\"_blank\" rel=\"noopener noreferrer\">ThemeIsle</a> as a Support Ninja where I make sure our users are always happy with our products. Let’s go ahead now.</p>\n<h3>The Journey</h3>\n<p>At the age of 12; still in class 6th, I started to learn about web coding. I started with HTML and learned how to make a really basic webpage. After understanding the basic concepts I wanted to start making a website already. I went ahead and googled &#8211; “How to make a free website” and the webs.com&#8217;s listing lead the page. I immediately clicked on it and started playing around, until I realized that it was WYSIWYG editor and it wasn’t possible for me to customize it a lot (Not that I knew how to!)</p>\n<p>At this time I had no idea about domain names and hosting. I researched some more and was introduced to the process of putting your website online, but it cost money! I decided to make a small website locally and then show it to my dad hoping he’d be impressed and provide me with the money I needed to put it online. While learning HTML, I came across this cool language called  “CSS” which would apparently make a website look and work better.</p>\n<p>Next thing you know, I was all over w3schools.com and YouTube watching videos about CSS, playing with the examples and much more. It took me a good 2 weeks to understand the basic concepts. I could finally change fonts, play with colors and do a lot more! While I liked how I had more control when I coded my own website, I still missed the easy content management webs.com and other WYSIWYG tools offered. This had me thinking again. What free software can I use to have the same level of control over my website but is just as easy to use when it comes to content management? This, in turn, initiated another research and I was finally introduced to this awesome software which went by the name of “WordPress”!</p>\n<p>Over the years I would work on a lot of WordPress based websites and continue to learn more about it every day. I worked for various small design agencies, as a freelancer and a lot more until one fine day in 2016 when I saw a “hiring” notice on <a href=\"https://themeisle.com\" target=\"_blank\" rel=\"noopener noreferrer\">ThemeIsle&#8217;s</a> website and decided to give it a shot. After an initial trial period of some 2 weeks, I was hired. I worked part-time (three hours/day, to be exact) for a year because I had school. Two months back, I started working full time. I work with the support and development team (more involved in support as of now, but I eventually want to get into full-time development) where I continue to learn new things every day.</p>\n<h3>It’s a Real Career Option!</h3>\n<p>For everyone who thinks WordPress is just a blogging tool, you’re wrong! Sure, it’s a blogging tool but it is used for so much more. It’s a real career option with a lot of room for growth. Given you are passionate about WordPress and the technologies used in it, you’d be able to find a job easily.</p>\n<blockquote><p>The best thing about the WordPress ecosystem is the people. They’re just so nice!</p></blockquote>\n<p>WordPress ecosystem is indeed competitive like any other but in the best way possible. Even if you’re another company wanting to know how some other company manages things or what technologies they use, they won’t hesitate to tell you about it. Almost all of the WordPress enthusiasts go to WordCamps where they meet new people and share knowledge.</p>\n<p>Another good thing about choosing WordPress as a career? The flexibility. A large part of the people who work on WordPress, do it remotely. The company WordPress.com, Automattic, is a completely distributed team with people working from different parts of the world. Want even more reasons to choose WordPress? The earning potential. Companies in the WordPress ecosystem are known to pay generously and the best part? You get to work with the folks who are just as passionate about WordPress as you are.</p>\n<h3>Engineering isn’t the only way to go</h3>\n<p>This is for all the Indian parents who are pushing their children to join coachings for IIT and other examinations right now, without their children wanting to &#8211; DON’T. Engineering isn’t the only way one can get a job. Sure, there’s nothing wrong with it but forcing your children to do it because you think there’s no other way? That isn’t right.</p>\n<p>Introduce your children to WordPress, introduce them to the world of web programming and see if they like it. Why not promote them to do something they like than to burden them with the weight of engineering when they don’t like it?</p>\n<blockquote><p>For all I know if my parents had forced me into engineering I would’ve missed out on everything. Give your children the room to grow.</p></blockquote>\n<p>Make them learn new things, introduce them to WordPress and all other cool things ( not just tech related! ) and leave it up to them to choose a career path <img src=\"https://s.w.org/images/core/emoji/2.2.1/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" /></p>\n<h3>Working Remotely Is Fun</h3>\n<p>Let’s talk about working remotely now. It’s fun. You don’t have to wear a suit or any kind of uniform. You get to work in your PJs. Does it get any better than that? Oh wait, it does. You get to choose your working hours. You can decide to work 3hrs in morning and 3hrs at night or you can work 6hours at a stretch. Fellow night crawler? You can work at night. Apart from that, it gives you a lot of freedom. You can work from wherever you want. You can go to a beach and work. You can work while traveling, basically, you can decide to work from anywhere, anytime! It’s all up to you.</p>\n<p>Flexible working hours allow me to concentrate on learning new things on a personal level and maintain a healthy Work/ Life balance. But over time, you might get bored working from home. ( Not sure about you but it did happen with me! )</p>\n<blockquote><p>My two cents? Take some time out and go vacationing.</p></blockquote>\n<p>Join a co-working space and see if that helps. All in all, I love having the freedom to work from anywhere and the best part still remains that I can work while wearing my PJs.</p>\n<h3>What’s Next?</h3>\n<p>Let me put it this way; I love WordPress. I have been doing some UI/UX work for a while now and I liked it. I am planning to learn more about it while learning more about WordPress development in parallel. For now, I am starting a small WordPress studio, <a href=\"http://madewithwp.com\" target=\"_blank\" rel=\"noopener noreferrer\">Made With WP</a>, with my friends (and colleagues) &#8211; Hardeep and Rohit. <a href=\"https://heropress.com/essays/be-your-own-teacher/\">You might remember Hardeep talking about it in his essay</a>. It’s the same project. I am working on my first WordPress theme and hope to see it in the theme directory soon. I am pretty good with HTML, CSS and comfortable with JS and PHP and I plan to learn more about them.</p>\n<p>Apart from that, I am the co-organizer of <a href=\"https://2017.kanpur.wordcamp.org\" target=\"_blank\" rel=\"noopener noreferrer\">WordCamp Kanpur</a>. I have been to two WordCamps so far and run an active meetup in my hometown, Kanpur. I gave my 12th exams this year and I plan to study more about new things as much as I can. Also, I am 18 years old as I write this.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Building A WordPress Career in India\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Building%20A%20WordPress%20Career%20in%20India&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fbuilding-wordpress-career-india%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Building A WordPress Career in India\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fbuilding-wordpress-career-india%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fbuilding-wordpress-career-india%2F&title=Building+A+WordPress+Career+in+India\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Building A WordPress Career in India\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/building-wordpress-career-india/&media=https://heropress.com/wp-content/uploads/2017/05/053117-150x150.jpg&description=Building A WordPress Career in India\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Building A WordPress Career in India\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/building-wordpress-career-india/\" title=\"Building A WordPress Career in India\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/building-wordpress-career-india/\">Building A WordPress Career in India</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 31 May 2017 12:00:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Suyogya Shukla\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"WPTavern: WordPress Core JavaScript Framework Debate Heats Up, Contributors Narrow Discussion to React vs. Vue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70985\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:119:\"https://wptavern.com/wordpress-core-javascript-framework-debate-heats-up-contributors-narrow-discussion-to-react-vs-vue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10702:\"<a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/05/lego.jpg?ssl=1\"><img /></a>photo credit: oskay <a href=\"http://www.flickr.com/photos/17425845@N00/2156889157\">Small Parts</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>WordPress core contributors met this morning to continue the discussion on selecting a new JavaScript framework for use with new core features. The discussion on the Make/Core <a href=\"https://make.wordpress.org/core/2017/05/24/javascript-chat-summary-for-may-23rd/\" target=\"_blank\">post</a> intensified over the weekend with more Vue.js proponents commenting to add their thoughts.</p>\n<p>Adam Silverstein and Andrew Duthie facilitated this morning&#8217;s meeting and began by opening up the discussion to include other frameworks such as Preact, Angular, and Ember. However, the discussion quickly narrowed to React vs Vue.</p>\n<p>Silverstein encouraged participants to remember that the new framework is for use with new features such as the new editor and that they will continue to use Backbone when it is the right tool, as well as in existing JavaScript. He also emphasized that the discussion pertains to a framework for core and developers are free to use whatever framework they choose to build plugins or themes.</p>\n<h3>Vue.js Proponents Consider &#8220;Ease of Learning&#8221; an Important Factor in Selecting a New Framework</h3>\n<p>Ease of learning is not among the criteria contributors identified for selecting a new framework, but it is one of the major concerns for Vue.js proponents.</p>\n<p>&#8220;Vue can do everything that React can do and is much more approachable,&#8221; Justin Kopepasah said. &#8220;There is a huge adoption of Vue and growth does not show any signs of stopping. Some of the top open source frameworks have adopted Vue and it is used by the top three tech companies in China (including Alibaba). While I do agree that React is a good choice as well, it is not highly approachable by new developers and has Facebook behind it which can be very alarming for people in many ways (not just tech).&#8221;</p>\n<p>Justin Tadlock, a core contributor whose code and tutorials have assisted many developers learning WordPress, shared similar thoughts over the weekend on the Mare/Core post:</p>\n<blockquote><p>I’ve tried React on a few occasions. Even with over 10 years of programming experience, it was tough to grok for me. I can’t imagine trying to learn it as someone new to WP development.</p>\n<p>Vue is dead simple to start learning. I had a small app up and going in minutes. In a couple of hours, I was building some cool, form-related stuff without the docs.</p>\n<p>If it were entirely up to me, I’d push for WP to build its own JS framework that solves the problems specific to WordPress. But, if we’re going to choose an existing framework, go with Vue.</p></blockquote>\n<p>Matias Ventura, an Automattic engineer and contributor on both the <a href=\"https://github.com/Automattic/wp-calypso\" target=\"_blank\">Calypso</a> and <a href=\"https://github.com/WordPress/gutenberg/\" target=\"_blank\">Gutenberg</a> projects, is a proponent of WordPress adopting React. He contends that considering which is easier to learn is the wrong focus for determining what WordPress&#8217; future interfaces will need.</p>\n<p>&#8220;In my opinion, instead of &#8216;easier to get started,&#8217; we need to look at robust programming paradigms and an expressive approach to coding interfaces,&#8221; Ventura said. &#8220;This is what I fundamentally take from Matt’s &#8216;learn JavaScript deeply&#8217; &#8211; the corollary being that WordPress becomes a platform for teaching JavaScript to new programmers, and we need to take that seriously, not just as a convenience to us in the short term.&#8221;</p>\n<p>Ventura also noted that WordPress has historically not been successful in attracting JavaScript developers and the JS interfaces in core lack contributors when compared to the PHP side.</p>\n<p>&#8220;We have an opportunity to make WordPress development more appealing to a newer generation of developers that learned how to code through JavaScript,&#8221; Ventura said. He encouraged other participants to examine the kinds of interfaces that WordPress needs to modernize and select the best framework for handling them in core.</p>\n<p>&#8220;The &#8216;easier to get started&#8217; [argument] seems a bit fallacious to me,&#8221; Ventura said. &#8220;Easier to whom? At what cost to properly learning JavaScript? The demands of rich interfaces in web applications require a deeper understanding of the technologies used. That’s not something we can avoid. JavaScript cannot be seen as mere progressive enhancement anymore as it is the language in which modern interfaces are expressed.&#8221;</p>\n<h3>Contributors are Concerned about React being Backed by Facebook</h3>\n<p>At the moment, React is more established and more widely adopted than Vue, but contributors are concerned about the framework being backed and licensed by Facebook. In addition to concerns over the interpretation of React&#8217;s additional <a href=\"https://wptavern.com/automattic-will-continue-to-use-react-js-in-calypso-despite-patent-clause\" target=\"_blank\">patent grant</a>, the company has been the source of numerous controversies regarding censorship, data mining, and privacy, among other issues. Opponents don&#8217;t want to see WordPress hitch its wagon to Facebook by using React in core.</p>\n<p>&#8220;The adoption of React is much more than adding a library to WordPress: it is adding the culture, business practices, and code base led by a tech giant,&#8221; Justin Kopepasah <a href=\"https://make.wordpress.org/core/2017/05/24/javascript-chat-summary-for-may-23rd/#comment-32557\" target=\"_blank\">said</a>. &#8220;If we include React in Core, in a way we are asking users (from single site owners to enterprise) to accept Facebook has a key role in the future of WordPress. I have little doubt this will cause pause for some companies considering to adopt WordPress.&#8221;</p>\n<p>However, other contributors have concerns about Vue.js&#8217; longevity, because it&#8217;s so heavily dependent on its creator Evan You. You <a href=\"https://www.patreon.com/evanyou\" target=\"_blank\">funds his efforts on Patreon</a> but the project doesn&#8217;t have any major corporate backing.</p>\n<p>&#8220;I&#8217;m uncomfortable relying on a project run by a single person that could disappear,&#8221; React proponent and WP REST API co-lead Ryan McCue said. &#8220;Being run by a corporation with a stake in the game means long-term support and relative stability.&#8221; McCue also noted that React has a &#8220;a massive community of teaching and support out there for people learning.&#8221;</p>\n<h3>Many Feel WordPress Selecting React as the New JS Framework is a Foregone Conclusion</h3>\n<p>Despite all the discussions in meetings and on Make/Core posts, many onlookers and community members are convinced that WordPress choosing React is a foregone conclusion. At the beginning of last week&#8217;s discussion it seemed that most core contributors are in favor of React, but a strong contingent of Vue proponents have turned out to add comments to the <a href=\"https://make.wordpress.org/core/2017/05/24/javascript-chat-summary-for-may-23rd/\" target=\"_blank\">discussion</a>.</p>\n<p>Selecting React appears to be the only viable choice when the criteria from the beginning includes items like &#8220;proven in a WordPress context&#8221; and &#8220;alignment with Calypso.&#8221; Many have commented to say that the criteria is biased and they assume the decision was already made through the backchannels with a public discussion held for &#8220;optics.&#8221; Automattic engineer James Nylen <a href=\"https://github.com/WordPress/gutenberg/issues/876\" target=\"_blank\">commented</a> last week on an open ticket for the Gutenberg project, saying that &#8220;Per recent discussion in core Slack, WP core has basically decided to adopt React.&#8221;</p>\n<p>&#8220;If this was truly meant to be a community discussion, then why is it taking place now?&#8221; WordPress developer Christopher A. <a href=\"https://wptavern.com/wordpress-to-select-new-javascript-framework-for-use-in-core#comment-221446\" target=\"_blank\">commented</a> on our recent post that summarized the initial discussion. &#8220;Choosing a view framework should have happened before the first line of Gutenberg was written. It was known from the start that a view framework would be needed. It was Matt’s desire to get it off the ground as quickly as possible. The best way to accomplish this was to utilize Automattic developers who have experience with React.&#8221;</p>\n<p>WordPress is selecting a JavaScript framework at a time where frameworks are rapidly evolving, but contributors involved in the decision said they will preserve the ability for theme and plugin developers to use any framework they choose to build their products. No framework was selected during today&#8217;s meeting and Andrew Duthie said he expects the conversation will continue at WordCamp Europe&#8217;s contributor summit.</p>\n<p>&#8220;As to React vs Vue (vs Angular vs …), we’ve been discussing the arguments for and against each in the weekly chat, and we’re intentionally taking it slow,&#8221; Ryan McCue said. &#8220;The key criteria that we’ve picked come from what the project needs, and are not intended to bias the decision in a specific direction. Calypso and other projects are a strong signal towards React, but they’re not the ultimate argument (if they were, we wouldn’t even be discussing it).&#8221;</p>\n<p>McCue said he doesn&#8217;t see WordPress replacing the whole admin with Calypso in a way that doesn&#8217;t allow developers to use whatever they choose for their own extensions. The decision to adopt a JavaScript framework for core is more for making core developers&#8217; work easier. At this time, core developers working on new features have a greater knowledge of React than other frameworks.</p>\n<p>&#8220;At the end of the day, we need to make a decision on what to use in core, and that decision directly impacts the people working on core,&#8221; McCue said. &#8220;Picking one framework over another doesn’t mean the others are worse, it’s just us (as core contributors) trying to make our own development easier.&#8221;</p>\n<p>A summary of the discussion should be posted to the <a href=\"https://make.wordpress.org/core/\" target=\"_blank\">Make/Core blog</a> soon and the discussion on selecting a new JavaScript framework will continue in future meetings.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 30 May 2017 23:15:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"BuddyPress: Building Bridges between Students and Educators in Nepal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=266185\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://buddypress.org/2017/05/building-bridges-between-students-and-educators-in-nepal/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9319:\"<div><em>This is a guest post by Arjun Bhattarai (<a href=\"https://profiles.wordpress.org/aju29\">aju29</a>), Founder and Developer of <a href=\"http://studentsnepal.com/\">StudentsNepal.com</a>. He is currently working towards a Masters degree in Economics.</em></div>\n<p>Peer reviewed by <a class=\"bp-suggestions-mention\" href=\"https://buddypress.org/members/boonebgorges/\" rel=\"nofollow\">@boonebgorges</a></p>\n<p><img class=\"aligncenter size-full wp-image-266186\" src=\"https://buddypress.org/wp-content/uploads/1/2017/05/snhome1.jpg\" alt=\"StudentsNepal.com logged in\" width=\"1365\" height=\"609\" /></p>\n<p><a href=\"http://studentsnepal.com/\">StudentsNepal.com</a> is the first and largest community website for students of Nepal with 9,700 registered members and 50,000 subscribers. The site helps students find answers to popular courses and colleges by acting as a bridge between the students and educators/educational organizations.</p>\n<h2>Background</h2>\n<p>I started working on this side project in December 2014. I remembered I had very little information about courses and colleges I could choose from after finishing Higher Secondary level back in 2011. There were no websites that could readily help students to explore the various opportunities available in Nepal. There are still a lot of students in Nepal who have been brain-fed that studying abroad is the one and only option to be successful. My vision was to change this mindset among the young students of Nepal by informing them about the abundant opportunities and options available within the country.</p>\n<p>The goal for creating StudentsNepal is to increase communication among different students with different educational backgrounds while helping them to learn all sorts of information and get hold of educational resources. Communication and interaction are the core values of StudentsNepal and these are the features that help the platform stand out from rest of the educational websites. BuddyPress and bbPress have helped us to achieve these values in a cost effective and efficient way. The beauty of these plugins is that our members can create content and help to rank us higher with search engines.</p>\n<h2>Implementation</h2>\n<p>The investment to create StudentsNepal.com was very low, a fraction of my pocket money during my final years in college. It is now one of the top educational portals of Nepal. Since WordPress was so easy to master, my dev team and I were able to use most of our free time to create initial content and other valuable resources for our visitors &#8211; students, parents, and educators &#8211; rather than spending time/money coding from scratch or buying a proprietary platform.</p>\n<p>Before choosing BuddyPress, I researched open-source social network scripts and platforms. My shortlist included WordPress (BuddyPress), Joomla (JomSocial), and Drupal (social modules). It was clear to me, after reading a lot of support forum posts and articles, that the BuddyPress/WordPress combo was the way to move forward with my dream. I am really happy about this choice today. The other heavyweight plugins that I added were GravityForms, Sucuri, bbPress, and MyCred plus other smaller plugins for specific tasks.</p>\n<h2>Customizations &amp; Improvements</h2>\n<p><strong>1. Login and Registration Pages</strong><br />\nWe found out that the default login and registration pages made it difficult for members to log in and have kept site visitors from registering. We resolved the issues by installing the Gravity Forms plugin and adding log in integration via Facebook, Twitter, or Google+ as well as making the registration page more user-friendly.</p>\n<p><img class=\"aligncenter size-full wp-image-266188\" src=\"https://buddypress.org/wp-content/uploads/1/2017/05/studentsnepal-login.png\" alt=\"studentsnepal login screen\" width=\"1349\" height=\"673\" /></p>\n<p><strong>2. Newsletters</strong><br />\nI thought about adding a newsletter because I loved the way some of the blogs I subscribed to sent organized information and recent activities of the blog in a beautiful email format. I decided to add an optin form to start collecting names and emails 2 to 3 months after launching the site. During the first 6 months, only first names and emails were collected with the popup optin form. Later, I changed the optin forms to collect email addresses and phone numbers. I have been using the free package of mailmunch for optin forms (popups) and Amazon AWS for sending newsletters. The newsletter contains scholarship notices for different universities/colleges, student stories, youth events, and other useful academic information.</p>\n<p>The newsletters have become one of the most popular features for the community. We did a lot of testing for the positioning and timing of the popup to get the most sign ups. StudentsNepal had around 20,000 subscribers by the end of 2015. The number of subscribers started growing after I inserted the forms in all the subdomains. (news.studentsnepal.com, jobs.studentsnepal.com, quiz.studentsnepal.com, blog.studentsnepal.com). After 3 years, the site has 50,000+ subscribers.</p>\n<p>Currently, StudentsNepal sends 1 newsletter per week, and my dev team and I are planning to make it 2 newsletters per week. We had invited students and educators/institutions to contribute content for the newsletters and the response has been just great! Students, particularly, submit generously and regularly to benefit other members, subscribers, and online visitors.</p>\n<p>In addition, this project has also helped me connect with lots of awesome individuals and similar-minded startup owners.</p>\n<p><strong>3. Design and CSS tweaks</strong><br />\nOut of the box, BuddyPress has a plain and simple design and interfaces which can be customized easily. At the end of the day, the features and performance are what matters most to my users whether on mobile, tablet, or desktop. For me, due to extensibility and ease of customization, BuddyPress reigns as king when it comes to a free open source script for a social network.</p>\n<p><img class=\"aligncenter size-full wp-image-266198\" src=\"https://buddypress.org/wp-content/uploads/1/2017/05/Forums-Archive.png\" alt=\"Forums Archive\" width=\"1349\" height=\"1957\" /></p>\n<p><strong>4. Upgrading Servers</strong><br />\nStudentsNepal.com was on a shared hosting plan when I launched it in 2014. It took around 3 to 4 months to cross the benchmark of 500 visitors/day. After getting articles indexed in search engines and started getting higher ranks, StudentsNepal started getting a lot of visitors (especially from Google). Mid-2015 we upgraded to VPS hosting when the website’s articles and contents started getting listed on the 1st page of search engines and it started getting a couple of thousand visitors daily. Based on my experience, it’s a good decision to get a shared hosting plan while the site was starting out and then upgrade to more powerful hosting plan when data showed the increases in user engagement and participation.</p>\n<p>With a community of 9,700 registered members, 50k subscribers, and around 150k visitors/month, I am happy to say that our site runs smoothly with nary a downtime on all devices. If you install BuddyPress, you will need a bit more power on your server.</p>\n<p><strong>Fast Forward</strong></p>\n<p>Future plans for StudentsNepal.com include moving the Shopping and Jobs sections to separate domains and setting up a new site for online classes. I am testing Woocommerce, WP Job Manager, and Moodle for the other projects to expand our services to the community.</p>\n<p>If you are creating a site for any niche community and are not sure on which platform to choose, I definitely suggest using WordPress with BuddyPress. These have a lot of stable and robust add-on plugins to help you create awesome and feature-rich communities.</p>\n<p>StudentsNepal.com is the first website of its nature in Nepal and it has garnered a lot of media attention and praise. I received a lot of positive and encouraging messages from educators and students in Nepal for creating this platform. I’m just glad that the services provided by the site have been very helpful to so many Nepalese students as well to those who would like to study in Nepal.</p>\n<p>Thanks to WordPress and BuddyPress for making this site possible. If you want to learn more about the site or the other customizations implemented, please feel free to contact me. Also, I can help you promote your social network or other related websites with a guest post in the blog section of StudentsNepal.com <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f600.png\" alt=\"😀\" class=\"wp-smiley\" /></p>\n<div><img class=\"alignleft size-full wp-image-266191\" src=\"https://buddypress.org/wp-content/uploads/1/2017/05/arjun.jpg\" alt=\"Arjun Bhattarai\" width=\"150\" height=\"150\" /> <em><a href=\"https://profiles.wordpress.org/aju29\">Arjun Bhattarai</a> is a member of the Association of Chartered Certified Accountants (ACCA) and is currently working towards MA (Economics) at Tribhuwan University, Nepal. Apart from writing and playing with code, he loves swimming and watching sci-fi videos.<br />\nLinks: <a href=\"https://www.facebook.com/Ajzju\">Facebook</a>, <a href=\"https://www.linkedin.com/in/ajubhattarai\">Linkedin</a> </em></div>\n<p>&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 30 May 2017 19:18:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"@mercime\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Matt: A Delicious Compliment\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=47422\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://ma.tt/2017/05/a-delicious-compliment/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:780:\"<blockquote><p>Once a little boy sent me a charming card with a little drawing on it. I loved it. I answer all my children’s letters—sometimes very hastily—but this one I lingered over. I sent him a card and I drew a picture of a Wild Thing on it. I wrote, “Dear Jim: I loved your card.” Then I got a letter back from his mother and she said, “Jim loved your card so much he ate it.” That to me was one of the highest compliments I&#8217;ve ever received. He didn&#8217;t care that it was an original Maurice Sendak drawing or anything. He saw it, he loved it, he ate it.</p></blockquote>\n<p>From <span class=\"irc_pt\" dir=\"ltr\">Maurice Sendak, the author of <a href=\"https://en.wikipedia.org/wiki/Where_the_Wild_Things_Are\">Where the Wild Things Are</a>.</span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 29 May 2017 17:43:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Matt: WordPress 14\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=47405\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://ma.tt/2017/05/wordpress-14/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:868:\"<p><img /></p>\n<p>Today is 14 years from the <a href=\"https://wordpress.org/news/2003/05/wordpress-now-available/\">very first release</a> of WordPress. The interface I&#8217;m using to write this (Calypso) is completely unrecognizable from what WordPress looked and worked like even a few years ago. Fourteen years in, I&#8217;m waking up every day excited about what&#8217;s coming next for us. The progress of the editor and CLI so far this year is awesome, and I&#8217;m looking forward to that flowing into improvements for customization and the REST API. Thanks as always to <a href=\"https://mikelittle.org/\">Mike</a> for kicking off this crazy journey, all the people chipping in to make WordPress better, and <a href=\"https://konstantin.obenland.it/\">Konstantin</a> and <a href=\"https://ethitter.com/\">Erick</a> for surprising me with the cool cake above.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 28 May 2017 02:38:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: In Case You Missed It – Issue 20\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=70879&preview=true&preview_id=70879\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wptavern.com/in-case-you-missed-it-issue-20\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6987:\"<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2016/01/ICYMIFeaturedImage.png?ssl=1\" rel=\"attachment wp-att-50955\"><img /></a>photo credit: <a href=\"http://www.flickr.com/photos/112901923@N07/16153818039\">Night Moves</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-nc/2.0/\">(license)</a>\n<p>There’s a lot of great WordPress content published in the community but not all of it is featured on the Tavern. This post is an assortment of items related to WordPress that caught my eye but didn’t make it into a full post.</p>\n<h2>WordPress Turns 14 Years Old</h2>\n<p>WordPress turns 14 years old tomorrow. David Bisset <a href=\"http://davidbisset.com/wordpress-14-years/\">celebrates the occasion</a> and mentions four things he wants to see in the next year.</p>\n<h2>WordPress 4.8 Dev Notes</h2>\n<p>As the WordPress 4.8 release date draws near, component maintainers are publishing dev notes for the features they worked on. So far, the following dev notes have been published:</p>\n<ul>\n<li><a href=\"https://make.wordpress.org/core/2017/05/26/media-widgets-for-images-video-and-audio/\">Media Widgets for Images, Video, and Audio</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/26/tag-cloud-widget-changes-in-4-8/\">Changes to the Tag Cloud Widget in WordPress 4.8</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/23/addition-of-tinymce-to-the-text-widget/\">Addition of TinyMCE to the Text Widget</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/05/20/editor-api-changes-in-4-8/\">Editor API Changes in 4.8</a></li>\n</ul>\n<p>Keep an eye on <a href=\"https://make.wordpress.org/core/\">Make WordPress Core</a> for further dev notes.</p>\n<h2>HeroPress Announces Educational Scholarship Winners</h2>\n<p>HeroPress has <a href=\"https://heropress.com/winners-announced-wpshout-running-scholarship/\">announced</a> the winners of the WPShout Up and Running educational scholarships. Birgit Olzem, in Gerolstein, Germany, was one of the winners chosen.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Can\'t believe it, but I\'m one of the winners of the <a href=\"https://twitter.com/WPShout\">@WPShout</a> Up &amp; Running Scholarship. Many thanks to all &amp; congratulations to all winners <a href=\"https://t.co/Us5CrJN3Jg\">https://t.co/Us5CrJN3Jg</a></p>\n<p>&mdash; CoachBirgit <img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f4d1.png\" alt=\"📑\" class=\"wp-smiley\" />☯<img src=\"https://s.w.org/images/core/emoji/2.3/72x72/1f393.png\" alt=\"🎓\" class=\"wp-smiley\" /> (@CoachBirgit) <a href=\"https://twitter.com/CoachBirgit/status/867851526672351234\">May 25, 2017</a></p></blockquote>\n<p></p>\n<h2>A WordPress Plugin That Renames Excerpt to TL;DR</h2>\n<p>The other day, I was thinking about how the TL;DR (Too long, didn&#8217;t read) summary of articles is similar to the way Excerpts work in WordPress. I browsed the plugin directory to see if anyone had created a plugin that renamed Excerpts to TL;DR.</p>\n<p>I wasn&#8217;t surprised when I discovered <a href=\"https://wordpress.org/plugins/too-long-didnt-read/\">TL;DR</a> created by <a href=\"http://ozh.org/\">Ozh Richard</a>. It hasn&#8217;t been updated in more than two years so it won&#8217;t show up in casual searches. It simply renames Excerpt to TL;DR using a filter to replace a string with custom text.</p>\n<h2>Human Made Shares Handbook</h2>\n<p><a href=\"https://hmn.md/\">Human Made</a>, a WordPress development agency based in the UK, has <a href=\"https://hmn.md/2017/05/25/handbook/\">published</a> its <a href=\"https://handbook.hmn.md/\">handbook</a> that includes on boarding practices, health and safety policies, and their hiring process.</p>\n<p>While it&#8217;s not a perfect fit for every one, it provides an in-depth look at the principles the company values. The company provides a number of great employee benefits. Take their <a href=\"https://handbook.hmn.md/working-here/hr-policies/bereavement/\">bereavement policy</a> for example.</p>\n<h2>What&#8217;s in Matt&#8217;s Backpack?</h2>\n<p>Matt Mullenweg provided <a href=\"https://ma.tt/2017/05/whats-in-my-bag-2017/\">an update</a> on what he&#8217;s carrying around in his backpack. While it&#8217;s filled with technology, ear buds, and the like, the item that stands out to me is the fidget spinner.</p>\n<p>If you don&#8217;t know what a fidget spinner is, <a href=\"http://www.livescience.com/58963-how-fidget-spinners-work-physics.html\">this article</a> by Live Science is a good primer.</p>\n<h2>Organizing WordCamps and Developing the Finnish Community</h2>\n<p>A great article that describes the Finnish WordPress community and what transpired after switching the name of WordCamp Finland to WordCamp Helsinki.</p>\n<blockquote class=\"wp-embedded-content\"><p><a href=\"https://make.wordpress.org/community/2017/05/24/whats-in-a-name-organizing-wordcamps-and-developing-the-finnish-community/\">What&#8217;s in a name? Organizing WordCamps and developing the Finnish community</a></p></blockquote>\n<p></p>\n<h2>Five Things To Know about Video Headers</h2>\n<p>Deborah Edwards-Onoro, of Lireo Designs, <a href=\"https://www.lireo.com/5-things-video-headers-wordpress-4-7/\">shares</a> five things you should know about video headers, a feature that was introduced in WordPress 4.7.</p>\n<h2>Marketing Tips and Experiences</h2>\n<p>Scott Bolinger, <a href=\"http://scottbolinger.com/marketing-what-works-and-doesnt/\">shares</a> what has and hasn&#8217;t worked in his marketing efforts:</p>\n<p>&#8220;I’ve had my nose stuck in product code on and off for 3 years now, but recently I’ve decided to shift my focus to marketing. This is something I’ve done before, and it seems to come in cycles, depending on what my business needs.</p>\n<p>Over the years I’ve tried many different things related to marketing, most of them have fallen short. A few things have worked, I thought I’d share some of my journey up to this point.&#8221;</p>\n<h2>Women Who WordPress Wapuu!</h2>\n<p>In what is a traditional part of this series, I end each issue by featuring a Wapuu design. For those who don&#8217;t know, Wapuu is the <a href=\"http://wapuu.jp/2015/12/12/wapuu-origins/\">unofficial mascot</a> of the WordPress project.</p>\n<p>The Women Who WP Wapuu represents the <a href=\"https://womenwhowp.org/store/\">Women Who WP group</a>. The group is dedicated to inspiring, connecting, challenging, and educating women throughout the WordPress community, through referrals, networking, workshops and mentorship focused on professional development and WordPress.</p>\n<p>The Women Who WP Wapuu pin was a huge hit at WordCamp Chicago earlier this year. If you&#8217;d like to purchase one, <a href=\"https://wapu.us/product/women-wp-pin/\">Wapu.us has 11 available</a> for $6 each.</p>\n<img />Women Who WordPress Wapuu\n<p>That&#8217;s it for issue twenty. If you recently discovered a cool resource or post related to WordPress, please share it with us in the comments.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 26 May 2017 21:48:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: WordPress Removes HHVM from Testing Infrastructure\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wptavern.com/wordpress-removes-hhvm-from-testing-infrastructure\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3249:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2014/05/hhvmhack.png?ssl=1\"><img /></a></p>\n<p>Before the release of PHP 7 in 2015, many WordPress managed hosting companies looked to Facebook&#8217;s HHVM to provide better performance. Pagely, WP Engine, and SiteGround added HHVM hosting options in 2014 and early 2015. However, PHP 7 performance gains have been enough to preclude wider HHVM adoption.</p>\n<p>WordPress core developer John Blackbourn announced yesterday that the project has<a href=\"https://make.wordpress.org/core/2017/05/25/hhvm-no-longer-part-of-wordpress-cores-testing-infrastructure/\" target=\"_blank\"> removed HHVM support in the Travis test suite</a> after April 2017 stats showed a mere several dozen WordPress websites running on HHVM. WordPress never officially supported HHVM but Scott Taylor made <a href=\"https://core.trac.wordpress.org/ticket/27881\" target=\"_blank\">many improvements to core for better HHVM compatibility</a> three years ago. Blackbourn clarified on Slack that WordPress is not removing this support but rather will no longer include HHVM in its testing infrastructure.</p>\n<p>&#8220;Support for HHVM itself hasn&#8217;t been dropped, but support for testing WordPress on HHVM has been dropped,&#8221; Blackbourn said. &#8220;HHVM usage is so minuscule (literally in the dozens according to update stats) that we can&#8217;t warrant the time needed to ensure the test infrastructure works.&#8221;</p>\n<p>The change isn&#8217;t likely to affect too many developers, but it&#8217;s an important milestone that signifies how well PHP 7 has been performing for sites that have switched. Blackbourn suggests those running WordPress on HHVM should consider switching to PHP 7+, as it is &#8220;far more widely supported and tested, and offers all of the memory and performance benefits that HHVM pushed forward.&#8221;</p>\n<p>The open source MongoDB project also announced yesterday that it will <a href=\"https://derickrethans.nl/mongodb-hhvm.html\" target=\"_blank\">no longer be supporting its HHVM driver</a>, saying it no longer makes good use of contributors&#8217; engineering time.</p>\n<p>&#8220;At the start of 2015 we began work on an HHVM driver for MongoDB, as part of our project to renew our PHP driver,&#8221; Derick Rethans, MongoDB engineer and author of <a href=\"http://xdebug.org/\" target=\"_blank\">Xdebug</a>, said. &#8220;Back then, HHVM was in its ascendancy and outperforming PHP 5.6 two to one. With such a huge performance difference it was reasonable to assume that many users would be switching over&#8230;With PHP 7 released, we saw very little use of the HHVM driver for MongoDB.&#8221;</p>\n<p>These announcements may be the start of more open source projects giving HHVM compatibility a lower priority. On the <a href=\"https://core.trac.wordpress.org/ticket/40548\" target=\"_blank\">ticket</a> for removing HHVM from the test matrix on Travis, John Blackbourn thanked HHVM for its importance in helping move PHP forward.</p>\n<p>&#8220;The PHP world owes a lot to HHVM for helping it push it forward,&#8221; Blackbourn said. &#8220;Without HHVM, maybe we wouldn&#8217;t have seen such incredible performance gains in PHP 7.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 26 May 2017 19:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: Rainmaker Digital to Partner with Nimble Worldwide\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70828\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wptavern.com/rainmaker-digital-to-partner-with-nimble-worldwide\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3341:\"<p><a href=\"http://rainmakerdigital.com/\">Rainmaker Digital</a>, formerly known as Copyblogger Media, has <a href=\"http://www.copyblogger.com/rainmaker-services/\">entered into a letter of intent</a> to partner with <a href=\"http://www.nimbleworldwide.com/\">Nimble Worldwide</a>, a marketing agency based in Dallas, TX. Assets from both companies will be combined into a new entity with Rainmaker Digital being the majority owner. Brian Clark, CEO of Rainmaker Digital, says the partnership enables them to transform from a Software as a Service provider to Software and Services.</p>\n<p>&#8220;People need sophisticated marketing technology, yes — but they also need done-for-them services such as design, content, and lead generation strategy,&#8221; Clark said.</p>\n<p>&#8220;In that last year, we’ve explored several viable ways to do more for our customers and prospects as a hybrid technology and digital marketing service provider. After careful deliberation, we’ve come up with a path that allows us to expertly provide anything that a Rainmaker user needs.&#8221;</p>\n<p>This isn&#8217;t the first time both companies have worked together. Prior to <a href=\"http://rainmakerplatform.com/platform/tour/email/\">RainMail</a>, Rainmaker&#8217;s in-house email marketing service, the company used Nimble Worldwide as its email marketing provider. Although the partnership brings in a number of new employees under Rainmaker Digital, Clark admits that they had to let some employees go.</p>\n<p>&#8220;This deal provides instant access to an experienced team of digital marketing professionals and a network of talented contractors that ensures our service solutions are expertly crafted and delivered,&#8221; Clark said. &#8220;This grows the Rainmaker team significantly, without the pain and uncertainty of building an agency from scratch.&#8221;</p>\n<p>&#8220;The change in business model unfortunately left four of our existing employees without positions, along with the loss of some of our own contractors. That was certainly no fun, and our operations leadership preserved every job possible despite the significant reorganization.&#8221;</p>\n<p>Before the end of June, customers will no longer be able to purchase services à la carte. Instead, sales of the platform will be more hands on, bundled with services, and prices will significantly increase. Customers who start a free trial before the end of June will be able to use the platform at a cheaper rate and without the bundled service components.</p>\n<h2>Genesis Framework Remains a Priority</h2>\n<p>StudioPress, Synthesis, Copyblogger, Authority, and DCI are not part of the deal and remain separate entities. Clark says StudioPress sales are going strong and the Genesis Framework is still a priority.</p>\n<p>&#8220;Our Synthesis managed WordPress hosting line will be folded into the StudioPress brand at some point, which shows how much we value StudioPress going forward,&#8221; he said.</p>\n<p>&#8220;Genesis is still in the hands of Nathan Rice, and he&#8217;s moving it forward at a faster pace than in years past when he had to divide time to work on Rainmaker. Now that he&#8217;s free from that, I&#8217;m excited to see where he takes the framework, which will continue to be a part of Rainmaker as well.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 26 May 2017 17:24:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: WordPress to Select New JavaScript Framework for Use in Core\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70794\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"https://wptavern.com/wordpress-to-select-new-javascript-framework-for-use-in-core\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2892:\"<p>WordPress core contributors have started collaborating more around their JavaScript efforts this year with regular core-js meetings. One item on the most recent meeting&#8217;s agenda was <a href=\"https://make.wordpress.org/core/2017/05/24/javascript-chat-summary-for-may-23rd/\" target=\"_blank\">discussion on choosing a new JavaScript framework for use in core</a> as an alternative to Backbone.</p>\n<p>Contributors began by summarizing the criteria for evaluating framework options, includes factors like stability, longevity, maturity, adoption, accessibility, proven in a WordPress context, and extensibility, among others. Most of the discussion centered on the benefits and drawbacks of React vs Vue.</p>\n<p>The majority of those who participated in the meeting seemed to favor React, as it is already used with several major WordPress projects such as Calypso, Gutenberg, and Jetpack. WordPress&#8217; project lead, Matt Mullenweg, has publicly stated that Automattic is betting on React long-term. Mullenweg has also <a href=\"https://wptavern.com/matt-mullenweg-announces-tech-and-design-leads-for-new-focus-based-development-cycle\" target=\"_blank\">expressed a desire for Calypso, or a similar interface, to replace wp-admin</a> in the future. The company has been building its products on React for several years and is pot committed at this point when it comes to the framework.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/carlhancock\">@carlhancock</a> <a href=\"https://twitter.com/chriswallace\">@chriswallace</a> <a href=\"https://twitter.com/mattmedeiros\">@mattmedeiros</a> Fair, but React is what us, Facebook, and many others are betting on long-term.</p>\n<p>&mdash; Matt Mullenweg (@photomatt) <a href=\"https://twitter.com/photomatt/status/808698242863165440\">December 13, 2016</a></p></blockquote>\n<p></p>\n<p>WordPress officially adopting a JavaScript framework will likely have a ripple effect that will influence how many products in the ecosystem are built and/or re-written. Proponents of Vue.js find it easy to learn and extend. Those who are advocating for React also cite its extensibility, stability, and its proven use with popular WordPress products.</p>\n<p>Contributors present for the meeting agreed they would be hesitant to commit a new framework to core without using it in some way for a core feature. The decision has not yet been made. Anyone with experiences to share on implementing JS frameworks in the context of WordPress is invited to comment in the <a href=\"https://make.wordpress.org/core/2017/05/24/javascript-chat-summary-for-may-23rd/\" target=\"_blank\">discussion on the meeting notes</a> and join the next core-js meeting <a href=\"http://www.timeanddate.com/worldclock/fixedtime.html?iso=20170530T1300\" target=\"_blank\">Tuesday, May 30, 2017, 8:00 AM CDT</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 26 May 2017 02:49:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Dev Blog: WordPress 4.8 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4758\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2017/05/wordpress-4-8-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2352:\"<p>The release candidate for WordPress 4.8 is now available.</p>\n<p>RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.8 on <strong>Thursday, June 8</strong>, but we need <em>your</em> help to get there. If you haven’t tested 4.8 yet, now is the time!</p>\n<p>To test WordPress 4.8, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.8-RC1.zip\">download the release candidate here</a> (zip).</p>\n<p>We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log/trunk/?action=stop_on_copy&mode=stop_on_copy&rev=40840&stop_rev=40821\">a handful of changes</a> since releasing Beta 2 earlier this week. For more details about what’s new in version 4.8, check out the <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-1/\">Beta 1</a> and <a href=\"https://wordpress.org/news/2017/05/wordpress-4-8-beta-2/\">Beta 2</a> blog posts.</p>\n<p><strong>Think you’ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you’ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>Developers</strong>, please test your plugins and themes against WordPress 4.8 and update your plugin’s <em>Tested up to</em> version in the readme to 4.8. If you find compatibility problems please be sure to post to the support forums so we can figure those out before the final release – we work hard to avoid breaking things. An in-depth field guide to developer-focused changes is coming soon on the <a href=\"https://make.wordpress.org/core/\">core development blog</a>.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p>This release&#8217;s haiku is courtesy of <a href=\"https://profiles.wordpress.org/matveb/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>matveb</a>:</p>\n<p><em>Érrese uno</em><br />\n<em>Cien veces y más</em><br />\n<em>Erre ce dos</em></p>\n<p>Thanks for your continued help testing out the latest versions of WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 May 2017 23:04:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Mel Choyce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:11:\"\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"HeroPress: Winners Announced for the WPShout Up and Running Scholarship\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://heropress.com/?p=1864\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:157:\"https://heropress.com/winners-announced-wpshout-running-scholarship/?utm_source=rss&utm_medium=rss&utm_campaign=winners-announced-wpshout-running-scholarship\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3425:\"<img width=\"960\" height=\"639\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/04/ipad-uandr-1-1024x682.png\" class=\"attachment-large size-large wp-post-image\" alt=\"Two hands holding an ipad so we can see the screen.\" /><p>After long hard thinking, the winners of the WPShout <a href=\"https://upandrunningwp.com/\">Up and Running</a> Scholarship are announced!</p>\n<ul>\n<li><big>Elisabeth Klaar, Cambridge UK</big></li>\n<li><big>Mohamed Hassan, Colombo, Sri Lanka</big></li>\n<li><big>Bridget Mudzwiti, Harare, Zimbabwe</big></li>\n<li><big>David Smith, Edmonton, Canada</big></li>\n<li><big>Stephanie Meza, Bronx, NY, USA</big></li>\n<li><big>Amy Koester, Gainesville, FL, USA</big></li>\n<li><big>Birgit Olzem, Gerolstein, Germany</big></li>\n<li><big>Ekene Olatunji, Lagos, Nigeria</big></li>\n<li><big>Donum Theo, Yogyakarta, Indonesia</big></li>\n<li><big>Jennifer Obiekwugo, Lagos State, Nigeria</big></li>\n</ul>\n<p>The winners will be contacted by WPShout with instructions on how to claim their scholarship. Congratulations to those who won!</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Winners Announced for the WPShout Up and Running Scholarship\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Winners%20Announced%20for%20the%20WPShout%20Up%20and%20Running%20Scholarship&via=heropress&url=https%3A%2F%2Fheropress.com%2Fwinners-announced-wpshout-running-scholarship%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Winners Announced for the WPShout Up and Running Scholarship\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fwinners-announced-wpshout-running-scholarship%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fwinners-announced-wpshout-running-scholarship%2F&title=Winners+Announced+for+the+WPShout+Up+and+Running+Scholarship\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Winners Announced for the WPShout Up and Running Scholarship\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/winners-announced-wpshout-running-scholarship/&media=https://heropress.com/wp-content/uploads/2017/04/ipad-uandr-1-150x150.png&description=Winners Announced for the WPShout Up and Running Scholarship\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Winners Announced for the WPShout Up and Running Scholarship\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/winners-announced-wpshout-running-scholarship/\" title=\"Winners Announced for the WPShout Up and Running Scholarship\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/winners-announced-wpshout-running-scholarship/\">Winners Announced for the WPShout Up and Running Scholarship</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 May 2017 18:00:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: JSON Feed Creators Aim to Revitalize Interest in the Open Web with RSS Alternative\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70772\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"https://wptavern.com/json-feed-creators-aim-to-revitalize-interest-in-the-open-web-with-rss-alternative\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11876:\"<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/05/json-feed-logo.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://jsonfeed.org/\" target=\"_blank\">JSON Feed</a>, a project created by <a href=\"http://www.manton.org/\" target=\"_blank\">Manton Reece</a> and <a href=\"http://inessential.com/\" target=\"_blank\">Brent Simmons</a>, launched last week. It&#8217;s a syndication format similar to RSS and Atom but built with JSON.</p>\n<p>&#8220;The premise was simple: the time is right for a JSON-based approach to feeds,&#8221; Reece said. &#8220;We hope that JSON Feed is straightforward enough to be implemented quickly, and capable enough to push the next decade of blogging software forward. We love RSS too and tried to learn from its success.&#8221;</p>\n<p><a href=\"https://jsonfeed.org/version/1\" target=\"_blank\">Version 1</a> of the spec was published last week and the intro includes a very simple example. Publishers can further extend their feeds by creating custom objects.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/05/json-feed.png?ssl=1\"><img /></a></p>\n<p>The team has also developed a <a href=\"https://wordpress.org/plugins/jsonfeed/\" target=\"_blank\">JSON Feed plugin for WordPress</a>, which is now available in the official WordPress Plugin Directory. They are also working on a JSON Feed Parser for Swift.</p>\n<p>If you want to see some example JSON Feeds on the web, check out <a href=\"https://daringfireball.net/feeds/json\" target=\"_blank\">Daring Fireball</a>, <a href=\"http://www.allenpike.com/feed.json\" target=\"_blank\">Allen Pike</a>, and <a href=\"http://flyingmeat.com/blog/feed.json\" target=\"_blank\">Flying Meat</a>. Reece&#8217;s Micro.blog project also supports JSON Feed for its Twitter-like <a href=\"https://micro.blog/feeds/manton.json\" target=\"_blank\">timeline</a>.</p>\n<h3>JSON Feed Creators Want to Inspire More Developers to Create Apps for the Open Web</h3>\n<p>Reece and Simmons decided the time was right to build an updated syndication format, as more and more developers are refusing to work with XML.</p>\n<p>&#8220;I believe that developers (particularly Mac and iOS developers, the group I know best) are so loath to work with XML that they won’t even consider building software that needs an XML parser,&#8221; Simmons said. &#8220;Which says to me that JSON Feed is needed for the survival of syndication.&#8221;</p>\n<p>In an <a href=\"http://www.therunloop.com/4\" target=\"_blank\">interview</a> on the The Run Loop podcast, Simmons attributed the decline in open web development to developers&#8217; growing aversion for working with XML, which always has problems with character encoding. Many developers find JSON to be easier to use and less buggy.</p>\n<p>&#8220;It has kind of made me sad these past five or ten years where it seems like development for the open web has slowed down a lot, particularly when we talk about the intersection of the Mac desktop and the open web,&#8221; Simmons said. &#8220;There just isn&#8217;t that much going on. I realized that one of the reasons is that people really hate XML and will go out of their way to avoid it. If they see XML APIs or XML stuff they&#8217;re not interested. That&#8217;s yucky, old, weird, hard stuff. But everyone likes JSON, all the cool APIs are JSON, even the not cool APIs are JSON. Everyone uses JSON.&#8221;</p>\n<p>Simmons said he is hopeful that the existence of JSON Feed will inspire developers to build new things for the open web.</p>\n<p>&#8220;What I&#8217;m hoping to see is that particularly Mac and iOS developers will consider doing new and innovative stuff on the open web, rather than writing yet another Twitter client or something that does something with Facebook. I want to see apps that do something with data that is not stored in somebody&#8217;s silos. I&#8217;m sick of corporate ownership of our data and of what I look at.&#8221;</p>\n<p>It&#8217;s not surprising that Simmons decided to partner with Reece, who built <a href=\"https://micro.blog/\" target=\"_blank\">micro.blog</a> out of similar convictions regarding the open web. They worked together on the project since February and recruited a dozen different peers to review the specification before launching last week. Now that version 1 is published, its creators hope JSON Feed will make its way into other parts of the web and applications.</p>\n<p>&#8220;What I&#8217;m hoping is that this is part of a bigger thing,&#8221; Simmons said. &#8220;The idea is to revitalize interest in the open web, in blogging, in syndication, and all of that kind of stuff.&#8221;</p>\n<h3>Feed Readers are Beginning to Add Support for JSON Feed</h3>\n<p>Initial reactions to JSON Feed have been mixed. Many proponents wonder why it has taken so long for something like this to emerge, but critics ask why the web needs yet another syndication format. A few common criticisms on Hacker News that echo the sentiments of many who oppose the idea:</p>\n<p><em>&#8220;We don&#8217;t really need another syndication format that no reader is going to support or support well for years.&#8221;</em> &#8211; <a href=\"https://news.ycombinator.com/item?id=14361977\" target=\"_blank\">@oefrha</a></p>\n<p><em>&#8220;If you&#8217;re going to make a new feed format in 2017, I&#8217;m sorry but copying what came before it and throwing it into JSON just isn&#8217;t enough.&#8221;</em> &#8211; <a href=\"https://news.ycombinator.com/item?id=14362286\" target=\"_blank\">@russellbeattie</a></p>\n<p><em>&#8220;One has to wonder whether Simmons is just trying to revive the old RSS ecosystem. &#8220;What do developers like these days, JSON? Let&#8217;s do RSS in JSON!&#8221; &#8230; This does not help. The real challenge these days is to replicate the solutions Facebook and Twitter brought to feeds (bi-directionality and data-retention in particular) in a decentralized manner that could actually become popular. Simply replicating RSS in the data-format du jour is not going to achieve that.&#8221;</em> &#8211; <a href=\"https://news.ycombinator.com/item?id=14363784\" target=\"_blank\">@toyg</a></p>\n<p>Despite critics, feed readers are already starting to add support for JSON Feed. The good news for publishers is that they don&#8217;t have to abandon their RSS feeds. Publishers can add support for JSON Feed alongside their existing feeds.</p>\n<p>The new <a href=\"https://json-feed-viewer.herokuapp.com/\" target=\"_blank\">JSON Feed Viewer app</a> is built on top of JSON Feed. <a href=\"http://blog.newsblur.com/post/160982162270/newsblur-now-supports-the-new-json-feed-spec\" target=\"_blank\">NewsBlur announced support</a> for the spec this week, along with <a href=\"http://blog.inoreader.com/2017/05/announcing-json-feed-support.html\" target=\"_blank\">Inoreader</a>, <a href=\"https://betamagic.nl/blog.html\" target=\"_blank\">News Explorer</a>, and <a href=\"https://feedbin.com/blog/2017/05/22/feedbin-supports-json-feed/\" target=\"_blank\">Feedbin</a>.</p>\n<p>Ben Ubois, founder of Feedbin, addressed one of the most common criticisms that feed readers aren&#8217;t likely to add support for the new JSON Feed spec because of the prevalence of RSS:</p>\n<p>&#8220;One of the criticisms I’ve seen of JSON Feed is that there’s no incentive for feed readers to support JSON Feed,&#8221; Ubois said. &#8220;This is not true. One of the largest-by-volume support questions I get is along the lines of &#8216;Why does this random feed not work?&#8217; And, 95% of the time, it’s because the feed is broken in some subtle way. JSON Feed will help alleviate these problems, because it’s easier to get right.&#8221;</p>\n<p>JSON Feed also has a few additional features that existing formats don&#8217;t offer as easily. Simmons highlighted a few graphics-related features in his <a href=\"http://www.therunloop.com/4\" target=\"_blank\">interview</a> with The Run Loop podcast:</p>\n<blockquote><p>For instance, when you define an author, you can provide a URL of an avatar image. You can imagine someone doing kind of a Twitter-like view of a feed with avatars for different posts. It also has support for things like the URL of the featured image or banner image that you can specify for an article and your RSS reader can format it somewhat like it would look like if you had actually gone to the web page with the banner image in the background. It has a way to specify fav icons and a larger icon for your feed, which right now news readers have to guess what your favicon is or scrape the homepage looking for the metadata tag that says where it is. They have to make all these additional requests to find out some of the basic graphics about your feed or about the article and that stuff is all specified inside the JSON feed. People who actually use those get a much nicer interface on the reading side.</p></blockquote>\n<p>Dave Winer <a href=\"http://scripting.com/stories/2012/09/10/rssInJsonForReal.html\" target=\"_blank\">experimented with the idea of JSONified RSS in 2012</a>, but it didn&#8217;t catch on. His <a href=\"http://scripting.com/2017/05/21/reEvanWilliamsAndJsonFeed.html\" target=\"_blank\">reaction to the new JSON Feed spec</a> is &#8220;pretty neutral, kind of a shoulder shrug.&#8221;</p>\n<p>&#8220;If developers have a hard time using XML in their apps, if that&#8217;s the problem, why not attack it right there?&#8221; Winer said. &#8220;Work to make it easier. I work in Node and the browser, and in both places XML and JSON are equally easy to use. The same could be done for any environment. In fact in the browser, XML is integrated deeply into the programming model, because the web is made out of XML.&#8221;</p>\n<p>In contrast, John Gruber thinks it&#8217;s the right time for the project and didn&#8217;t hesitate to add a JSON feed for <a href=\"https://daringfireball.net/feeds/json\" target=\"_blank\">Daring Fireball</a>. He is eagerly supporting the JSON Feed project and is closely monitoring its adoption, publishing links to all the apps and feed readers that have already added support.</p>\n<p>&#8220;I think this is a great idea, and a good spec,&#8221; Gruber said. &#8220;I even like the style in which the spec is written: for real humans (much like the RSS spec). If you want to see a real-life example, Daring Fireball has a JSON Feed. I’ve got a good feeling about this project — the same sort of feeling I had about Markdown back in the day.&#8221;</p>\n<p>With the momentum from quick adoption by smaller news readers, JSON Feed has the potential to revive news syndication if some of the larger ones add support. Developers may even be more inspired to create new feed readers, given the ease of implementing the new spec.</p>\n<p>Manton Reece said that if JSON Feed had come along when blogging was at its peak, when there were fewer problems, he thinks there would have been less of a pressing feeling that the web needs a new syndication format.</p>\n<p>&#8220;I&#8217;m amazed with the traction it&#8217;s gotten,&#8221; Manton Reece said in a recent <a href=\"http://www.coreint.org/2017/05/episode-283-reset-all-the-things/\" target=\"_blank\">interview</a> on the Core Intuition podcast. &#8220;Of course some people will be negative about it and some people won&#8217;t like it. We certainly expected a lot of pushback on it. Everybody knows we need this, but it&#8217;s daunting. Who is going to try to push something like this when there are millions of RSS feeds? It feels like why even bother, it&#8217;s impossible. But things change over time and I think this is important enough and blogging is important enough that it&#8217;s worth making the investment now. Tomorrow the web is not going to be any different, but over time it might be a little different. Everybody knows that we need something like this but there hasn&#8217;t been something everybody could get behind until now.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 May 2017 17:51:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: WPWeekly Episode 274 – WordPress Commercials, Storefront, and the Customizer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=70802&preview=true&preview_id=70802\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"https://wptavern.com/wpweekly-episode-274-wordpress-commercials-storefront-and-the-customizer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2278:\"<p>In this episode, <a href=\"https://jjj.blog/\">John James Jacoby</a> joins me to discuss the news of the week. We give our take on the new WordPress.com commercials and whether or not they hit the mark. We share what&#8217;s new in Storefront 2.2.0 and the problems some people are facing trying to get visas to attend WordCamp Europe. Last but not least, we discussed the Customizer having a variable width in WordPress 4.8. Beginning with episode 275, Jacoby will be my co-host for WordPress Weekly.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wptavern.com/wordpress-coms-tv-commercials-are-confusing\">WordPress.com’s TV Commercials Are Confusing</a><br />\n<a href=\"https://wptavern.com/wordcamp-europe-attendees-are-being-denied-visas-because-conference-ticket-price-is-too-low\">WordCamp Europe Attendees Are Being Denied Visas Because Conference Ticket Price Is Too Low</a><br />\n<a href=\"https://wptavern.com/storefront-2-2-0-released-includes-design-refresh-and-major-improvements-to-new-user-experience\">Storefront 2.2.0 Released, Includes Design Refresh and Major Improvements to New User Experience</a><br />\n<a href=\"https://wptavern.com/wordpress-4-8-increases-maximum-width-of-the-customizer-sidebar-to-600-pixels\">WordPress 4.8 Increases Maximum Width of the Customizer Sidebar to 600 Pixels</a><br />\n<a href=\"https://wptavern.com/cape-town-to-host-4th-annual-wordpress-charity-hackathon-on-july-15\">Cape Town to Host 4th Annual WordPress Charity Hackathon on July 15</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, May 31st 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\" rel=\"noopener noreferrer\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #274:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 May 2017 01:43:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Profile of Anker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=47364\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://ma.tt/2017/05/profile-of-anker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:437:\"<p>As a computer accessory enthusiast, I&#8217;m excited <a href=\"https://www.theverge.com/2017/5/22/15673712/anker-battery-charger-amazon-empire-steven-yang-interview\">that Verge did an in-depth profile of Anker</a>, which makes some of the best chargers, cables, and batteries around. It also makes me more curious about the story behind <a href=\"https://www.aukey.com/\">Aukey</a> and <a href=\"http://www.jackery.com/\">Jackery</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 May 2017 15:08:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"HeroPress: My Life, Designed by WordPress!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1854\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"https://heropress.com/essays/life-designed-wordpress/?utm_source=rss&utm_medium=rss&utm_campaign=life-designed-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6989:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/05/052417-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: I dreamt of a community to help me; people who will encourage me.\" /><p>It has been a short time since I joined WordPress community and learnt a lot of things at the age of 12. It took me a day writing this essay as I wish I could write my whole mind in it.</p>\n<blockquote><p>“Start where you are. Use what you have. Do what you can. – Arthur Ashe”</p></blockquote>\n<h3>So, here’s the start I had:</h3>\n<p>From my childhood, I’ve been wondering about Software Technologies. I always wondered about the constructions of website, and a program. It was the time when my mother <a href=\"https://www.facebook.com/yogita.patil.18\" target=\"_blank\" rel=\"noopener noreferrer\">Yogita</a>, just introduced me Google, the God of websites! All the curiosity I had was strengthened when using Google.</p>\n<p>Do you know what shaped my career? A search string on Google which said ‘How to make a website’! Not much useful, but the slow start I had was everything I need. That was 2012. (Me, 8 yrs old) When I tried an online web designing tool named SimDif. Just then, I got to know Weebly. I made my first permanent website, <a href=\"http://mathsbuzzz.weebly.com/\" target=\"_blank\" rel=\"noopener noreferrer\">mathsbuzzz.weebly.com</a> and the curiosity went deeper.</p>\n<p>Now I thought of making a website myself, with no tool, with real programming! That was 2013. At that time, Microsoft Frontpage was nearly coming to an end of popularity. I embraced it. Though it couldn’t be called programming, but I liked it as I went one step further.</p>\n<p>I also learnt a bit of HTML from a book I had at home. It’s not even half of the story I’m telling. The time I was introduced to WordPress is much further. That’s 2016.</p>\n<h3>What in 2015?</h3>\n<p>I had a course of advanced HTML/CSS in 2015 where I got to know completely about Framing, Coding and Publishing a website. Then, I practiced it a lot and then thought about putting a step forward to PHP.</p>\n<h3>It’s 2016</h3>\n<p>Summer vacations were to get over and I had a course of PHP. There’s where I came to know about the REAL PROGRAMMING. I started making my first coded website and it was completely published in September 2015. It was my mother’s online store. And then, from November 2016, I made another website and completed the project in February 2016. That was my first blog, IQubex.com made with simple HTML/CSS and no PHP.</p>\n<p>I was actually equipped with HTML/CSS knowledge and was practicing PHP. But, I never got what I dreamt of. I dreamt of: “My exposure in Web Developing World. A community, which will help me in my needs. People, who will encourage me.”</p>\n<p>Dream became true.</p>\n<h3>When WordPress Came In My Life</h3>\n<p>Its still 2016, when striked an article in Newspaper about WordCamp Nashik 2016. My mother read it and thought that it would prove like a miracle for me. It was the start of October 2016. Nashik is my city and so it was always easy for me to attend WordCamp Nashik.</p>\n<p>It was for developers, bloggers and all the people who maintained their interest in Web Technologies. I knew that I too fit in that category.</p>\n<h3>Now came, 16th October 2016</h3>\n<p>We all know how cool experiences we get in a WordCamp. But this was the best for me as it was the first WordCamp of my life. From then, I migrated my blog to WordPress and got everything better. I saw how people program for WordPress and how big is the WordPress world.</p>\n<p>So, what did I miss? Nothing. I got a helping community. I got nice friends. I got people who are much more experienced and their knowledge which will help me throughout the life. What more? The best thing I received is Motivation.</p>\n<p>I used to write less on my blog as it was not equipped with PHP and was basic HTML/CSS. Due to that, I uploaded articles every now and then. But after the arrival of WordPress in my life, I wrote frequent articles, more beautifully, with more customization and with more interest. Then progressed my blog!</p>\n<h3>What next?</h3>\n<p>It was WordCamp Pune 2017 where I became the youngest speaker of WordCamp. I had an interview with <a href=\"https://www.twitter.com/rahul286\" target=\"_blank\" rel=\"noopener noreferrer\">Rahul Bansal</a> Sir. He met me at WordCamp Nashik. So, I was able to talk in front of people. This is how my confidence got a boost positively.</p>\n<p>Now I run more than 3 websites and constructing more. I also developed a plugin on WordPress. Learning about making theme. I’m also aiming to be a good developer in future. After all, there is a lot of time left. I’m 13 yrs old.</p>\n<p>So, simply saying, before WordPress I was unaware of what I have to do in future, and now I can see the complete scene of my future career. Thanks to WordPress and its Community.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: My Life, Designed by WordPress!\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=My%20Life%2C%20Designed%20by%20WordPress%21&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Flife-designed-wordpress%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: My Life, Designed by WordPress!\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Flife-designed-wordpress%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Flife-designed-wordpress%2F&title=My+Life%2C+Designed+by+WordPress%21\" rel=\"nofollow\" target=\"_blank\" title=\"Share: My Life, Designed by WordPress!\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/life-designed-wordpress/&media=https://heropress.com/wp-content/uploads/2017/05/052417-150x150.jpg&description=My Life, Designed by WordPress!\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: My Life, Designed by WordPress!\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/life-designed-wordpress/\" title=\"My Life, Designed by WordPress!\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/life-designed-wordpress/\">My Life, Designed by WordPress!</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 May 2017 11:00:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Kumar Abhirup\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: WordPress 4.8 Improves Accessibility on Admin Screens\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70701\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wptavern.com/wordpress-4-8-improves-accessibility-on-admin-screens\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2474:\"<p>In WordPress 4.3, the <a href=\"https://make.wordpress.org/accessibility/\">Accessibility Team</a> <a href=\"https://make.wordpress.org/core/2015/07/31/headings-in-admin-screens-change-in-wordpress-4-3/\">restored&nbsp;H1 headings</a> to&nbsp;the admin screens. This paved the way for the team to change the <a href=\"https://make.wordpress.org/core/2015/10/28/headings-hierarchy-changes-in-the-admin-screens/\">headings hierarchy</a>&nbsp;in WordPress 4.4. In WordPress 4.8, admin screens are more accessible&nbsp;thanks to <a href=\"https://make.wordpress.org/core/2017/05/17/cleaner-headings-in-the-admin-screens/\">organizing the header text</a> on pages.</p>\n<p>The headers on admin screens typically contain more than text. For example,&nbsp;the Add New button on the Posts and Pages admin screens is included within the Posts and Pages header text.</p>\n<p><img /></p>\n<p>This makes it difficult for assistive technologies to help users navigate different sections of a page. The changes in WordPress 4.8 turn the headings on admin screens into their own elements.</p>\n<p>Before WordPress 4.8 the HTML looked like this:</p>\n<p><code>&lt;h1&gt;<br />\n    Posts<br />\n    &lt;a href=\"... /post-new.php\" class=\"page-title-action\"&gt;Add New&lt;/a&gt;<br />\n&lt;/h1&gt;</code></p>\n<p>Now it looks like this:</p>\n<p><code>&lt;h1 class=\"wp-heading-inline\"&gt;Posts&lt;/h1&gt;<br />\n&lt;a href=\"... /post-new.php\" class=\"page-title-action\"&gt;Add New&lt;/a&gt;<br />\n&lt;hr class=\"wp-header-end\"&gt;</code></p>\n<p>Andrea Fercia, WordPress core committer and a member of the accessibility team, explains what theme and plugin authors need to know.</p>\n<p>&#8220;If your plugin or theme follows the previous WordPress pattern of adding extraneous content to the main heading, please update your plugin or theme to make the heading cleaner,&#8221; Fercia said.</p>\n<p>&#8220;All you need to do is move the extraneous content outside of the heading. WordPress 4.8 ships with new CSS rules to take care of the new markup structure and in most cases, no additional changes will be required.&#8221;</p>\n<p>These improvements are <a href=\"https://core.trac.wordpress.org/ticket/26601\">three years</a> in the making. After much discussion and being punted to future releases, Fercia says the Accessibility team decided to handle the changes in smaller commits versus one large patch. This provided the necessary momentum to get the changes in core.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 May 2017 04:33:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Cape Town to Host 4th Annual WordPress Charity Hackathon on July 15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=70558\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://wptavern.com/cape-town-to-host-4th-annual-wordpress-charity-hackathon-on-july-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3777:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/05/cape-town-charity-hackathon-2017.png?ssl=1\"><img /></a></p>\n<p>Cape Town will be hosting its <a href=\"https://doaction.org/event/cape-town-2017/\" target=\"_blank\">fourth annual do_action WordPress Charity Hackathon</a> on July 15 this year. The objective of the event is to build websites for 10 different non-profit organizations in one day, an ambitious endeavor that requires a mix of different web and marketing talents working in highly concentrated teams. Participants help non-profits kick start their websites so the organizations can focus on doing what they do best &#8211; helping the local community.</p>\n<p>Hugh Lashbrooke, who is leading the organization of the event again this year, said the team has secured a new venue that will be better suited to a hackathon. <a href=\"http://workshop17.co.za/\" target=\"_blank\">Workshop17</a>, a collaboration and meeting venue, will host the charity hackathon&#8217;s 70 participants (7 people per team). The event is currently half-full and is recruiting another 35 participants.</p>\n<p>&#8220;One thing the event has done for me, and others in the community, is open us up to the rest of what is happening in the city,&#8221; Lashbrooke said. &#8220;Our skills may seem pretty self-serving (building websites to make money), but they can be used for a lot more. Everyone who participates has so much fun on the day that I think they forget that it&#8217;s really work.&#8221;</p>\n<p>This year&#8217;s charities include the following organizations:</p>\n<ul>\n<li>Tygerberg Association for Persons with Physical Disabilities</li>\n<li>Kidz Adventure Camp</li>\n<li>Little Lambs Christian Day Care</li>\n<li>Iliso Care Society</li>\n<li>Daughters Of Destiny</li>\n<li>Durbanville Children&#8217;s Home</li>\n<li>The Homestead Projects for Street Children</li>\n<li>Usiko Stellenbosch</li>\n<li>Rotary Club of Constantia</li>\n<li>ASSITEJ South Africa</li>\n</ul>\n<p>The Cape Town WordPress community pioneered the concept of using WordPress to lift up local charities and this type of event has now spread to other areas of the world. As a member of the WordPress project&#8217;s Community Team, Lashbrooke has been working on making the do_action charity hackathons easily reproducible. It&#8217;s now part of the WordPress Community Program with <a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/do_action-charity-hackathon/\" target=\"_blank\">guidelines in the community events organizer handbook</a>.</p>\n<p>The new <a href=\"http://doaction.org\" target=\"_blank\">doaction.org</a> website lists the upcoming hackathons and takes care of all the manual admin work that Lashbrooke did for himself for the first couple of events. The functionality is built on top of his experience in running the events.</p>\n<p>&#8220;There has been a ton of interest in the event from communities around the world, and we&#8217;ve already seen successful events in Austin and Johannesburg,&#8221; Lashbrooke said. &#8220;More hackathons are scheduled for Pretoria, Beirut, and Montreal later this year. A few of the other cities that have shown interest and applied, but have not scheduled anything yet, are Fort Myers, Denver, New York City, and Ahmedabad, amongst others.&#8221;</p>\n<p>Bringing the do_action charity hackathons under the official WordPress community program allows the team to offer logistical and financial support to organizers in the same way they already support WordCamp and meetup organizers. They do not have an official mentorship program set up yet, as the event types is still new, but Lashbrook said the community team does what it can to help hackathon organizers get started.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 23 May 2017 19:52:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 15 Jun 2017 11:36:52 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 15 Jun 2017 11:15:10 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:16:\"content-encoding\";s:4:\"gzip\";}}s:5:\"build\";s:14:\"20130911010210\";}", "no");
INSERT INTO `act_options` VALUES("2155", "_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1497569817", "no");
INSERT INTO `act_options` VALUES("2156", "_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1497526617", "no");
INSERT INTO `act_options` VALUES("2157", "_transient_timeout_dash_v2_88ae138922fe95674369b1cb3d215a2b", "1497569817", "no");
INSERT INTO `act_options` VALUES("2158", "_transient_dash_v2_88ae138922fe95674369b1cb3d215a2b", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2017/06/evans/\'>WordPress 4.8 “Evans”</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://poststatus.com/entrepreneurial-journey-around-ecommerce-patrick-rauland-draft-podcast/\'>Post Status: An entrepreneurial journey around eCommerce, with Patrick Rauland — Draft Podcast</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/wpweekly-episode-277-wordpress-4-8-filing-good-bug-reports-and-wp-super-cache\'>WPTavern: WPWeekly Episode 277 – WordPress 4.8, Filing Good Bug Reports, and WP Super Cache</a></li><li><a class=\'rsswidget\' href=\'https://heropress.com/essays/trust-yourself/?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=trust-yourself\'>HeroPress: Trust Yourself</a></li></ul></div>", "no");
INSERT INTO `act_options` VALUES("2159", "_site_transient_timeout_theme_roots", "1497528445", "no");
INSERT INTO `act_options` VALUES("2160", "_site_transient_theme_roots", "a:2:{s:12:\"sydney-child\";s:7:\"/themes\";s:6:\"sydney\";s:7:\"/themes\";}", "no");
INSERT INTO `act_options` VALUES("2164", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1497526668;s:7:\"checked\";a:9:{s:25:\"booking/wpdev-booking.php\";s:3:\"7.2\";s:25:\"duplicator/duplicator.php\";s:5:\"1.2.8\";s:15:\"kirki/kirki.php\";s:5:\"2.3.8\";s:39:\"siteorigin-panels/siteorigin-panels.php\";s:5:\"2.5.6\";s:47:\"really-simple-captcha/really-simple-captcha.php\";s:3:\"2.0\";s:39:\"so-widgets-bundle/so-widgets-bundle.php\";s:5:\"1.9.2\";s:33:\"sydney-toolbox/sydney-toolbox.php\";s:4:\"1.01\";s:49:\"widgets-for-siteorigin/widgets-for-siteorigin.php\";s:5:\"1.3.3\";s:25:\"wp-members/wp-members.php\";s:7:\"3.1.8.1\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:8:{s:25:\"booking/wpdev-booking.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:21:\"w.org/plugins/booking\";s:4:\"slug\";s:7:\"booking\";s:6:\"plugin\";s:25:\"booking/wpdev-booking.php\";s:11:\"new_version\";s:3:\"7.2\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/booking/\";s:7:\"package\";s:50:\"https://downloads.wordpress.org/plugin/booking.zip\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:5:\"1.2.8\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.1.2.8.zip\";}s:15:\"kirki/kirki.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:19:\"w.org/plugins/kirki\";s:4:\"slug\";s:5:\"kirki\";s:6:\"plugin\";s:15:\"kirki/kirki.php\";s:11:\"new_version\";s:5:\"2.3.8\";s:3:\"url\";s:36:\"https://wordpress.org/plugins/kirki/\";s:7:\"package\";s:54:\"https://downloads.wordpress.org/plugin/kirki.2.3.8.zip\";}s:39:\"siteorigin-panels/siteorigin-panels.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:31:\"w.org/plugins/siteorigin-panels\";s:4:\"slug\";s:17:\"siteorigin-panels\";s:6:\"plugin\";s:39:\"siteorigin-panels/siteorigin-panels.php\";s:11:\"new_version\";s:5:\"2.5.6\";s:3:\"url\";s:48:\"https://wordpress.org/plugins/siteorigin-panels/\";s:7:\"package\";s:66:\"https://downloads.wordpress.org/plugin/siteorigin-panels.2.5.6.zip\";}s:47:\"really-simple-captcha/really-simple-captcha.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:35:\"w.org/plugins/really-simple-captcha\";s:4:\"slug\";s:21:\"really-simple-captcha\";s:6:\"plugin\";s:47:\"really-simple-captcha/really-simple-captcha.php\";s:11:\"new_version\";s:3:\"2.0\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/really-simple-captcha/\";s:7:\"package\";s:68:\"https://downloads.wordpress.org/plugin/really-simple-captcha.2.0.zip\";}s:39:\"so-widgets-bundle/so-widgets-bundle.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:31:\"w.org/plugins/so-widgets-bundle\";s:4:\"slug\";s:17:\"so-widgets-bundle\";s:6:\"plugin\";s:39:\"so-widgets-bundle/so-widgets-bundle.php\";s:11:\"new_version\";s:5:\"1.9.2\";s:3:\"url\";s:48:\"https://wordpress.org/plugins/so-widgets-bundle/\";s:7:\"package\";s:66:\"https://downloads.wordpress.org/plugin/so-widgets-bundle.1.9.2.zip\";}s:33:\"sydney-toolbox/sydney-toolbox.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:28:\"w.org/plugins/sydney-toolbox\";s:4:\"slug\";s:14:\"sydney-toolbox\";s:6:\"plugin\";s:33:\"sydney-toolbox/sydney-toolbox.php\";s:11:\"new_version\";s:4:\"1.01\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/sydney-toolbox/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/sydney-toolbox.1.01.zip\";}s:25:\"wp-members/wp-members.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:24:\"w.org/plugins/wp-members\";s:4:\"slug\";s:10:\"wp-members\";s:6:\"plugin\";s:25:\"wp-members/wp-members.php\";s:11:\"new_version\";s:7:\"3.1.8.1\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/wp-members/\";s:7:\"package\";s:53:\"https://downloads.wordpress.org/plugin/wp-members.zip\";}}}", "no");

/* INSERT TABLE DATA: act_postmeta */
INSERT INTO `act_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("8", "5", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("9", "5", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("10", "5", "_edit_lock", "1497450860:1");
INSERT INTO `act_postmeta` VALUES("11", "7", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("12", "7", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("13", "7", "_edit_lock", "1497522325:1");
INSERT INTO `act_postmeta` VALUES("14", "9", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("15", "9", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("16", "9", "_edit_lock", "1497527918:1");
INSERT INTO `act_postmeta` VALUES("17", "11", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("18", "11", "_yoast_wpseo_content_score", "60");
INSERT INTO `act_postmeta` VALUES("19", "11", "_edit_lock", "1497522166:1");
INSERT INTO `act_postmeta` VALUES("32", "2", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("33", "2", "_wp_trash_meta_time", "1496180466");
INSERT INTO `act_postmeta` VALUES("34", "2", "_wp_desired_post_slug", "sample-page");
INSERT INTO `act_postmeta` VALUES("41", "5", "_wp_page_template", "page-templates/page_fullwidth.php");
INSERT INTO `act_postmeta` VALUES("46", "22", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("47", "22", "_wp_trash_meta_time", "1496213913");
INSERT INTO `act_postmeta` VALUES("48", "23", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("49", "23", "_wp_trash_meta_time", "1496213958");
INSERT INTO `act_postmeta` VALUES("50", "24", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("51", "24", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("52", "24", "_menu_item_object_id", "11");
INSERT INTO `act_postmeta` VALUES("53", "24", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("54", "24", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("55", "24", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("56", "24", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("57", "24", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("59", "25", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("60", "25", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("61", "25", "_menu_item_object_id", "9");
INSERT INTO `act_postmeta` VALUES("62", "25", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("63", "25", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("64", "25", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("65", "25", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("66", "25", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("68", "26", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("69", "26", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("70", "26", "_menu_item_object_id", "7");
INSERT INTO `act_postmeta` VALUES("71", "26", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("72", "26", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("73", "26", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("74", "26", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("75", "26", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("77", "27", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("78", "27", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("79", "27", "_menu_item_object_id", "5");
INSERT INTO `act_postmeta` VALUES("80", "27", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("81", "27", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("82", "27", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("83", "27", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("84", "27", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("86", "28", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("87", "28", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("88", "28", "_menu_item_object_id", "11");
INSERT INTO `act_postmeta` VALUES("89", "28", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("90", "28", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("91", "28", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("92", "28", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("93", "28", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("95", "29", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("96", "29", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("97", "29", "_menu_item_object_id", "9");
INSERT INTO `act_postmeta` VALUES("98", "29", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("99", "29", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("100", "29", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("101", "29", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("102", "29", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("104", "30", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("105", "30", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("106", "30", "_menu_item_object_id", "7");
INSERT INTO `act_postmeta` VALUES("107", "30", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("108", "30", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("109", "30", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("110", "30", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("111", "30", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("113", "31", "_menu_item_type", "post_type");
INSERT INTO `act_postmeta` VALUES("114", "31", "_menu_item_menu_item_parent", "0");
INSERT INTO `act_postmeta` VALUES("115", "31", "_menu_item_object_id", "5");
INSERT INTO `act_postmeta` VALUES("116", "31", "_menu_item_object", "page");
INSERT INTO `act_postmeta` VALUES("117", "31", "_menu_item_target", "");
INSERT INTO `act_postmeta` VALUES("118", "31", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `act_postmeta` VALUES("119", "31", "_menu_item_xfn", "");
INSERT INTO `act_postmeta` VALUES("120", "31", "_menu_item_url", "");
INSERT INTO `act_postmeta` VALUES("122", "32", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("123", "32", "_wp_trash_meta_time", "1496354751");
INSERT INTO `act_postmeta` VALUES("127", "34", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("128", "34", "_wp_trash_meta_time", "1496354868");
INSERT INTO `act_postmeta` VALUES("129", "35", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("130", "35", "_wp_trash_meta_time", "1496354914");
INSERT INTO `act_postmeta` VALUES("131", "36", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("132", "36", "_wp_trash_meta_time", "1496355692");
INSERT INTO `act_postmeta` VALUES("142", "40", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("143", "40", "_wp_trash_meta_time", "1496356213");
INSERT INTO `act_postmeta` VALUES("144", "41", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("145", "41", "_wp_trash_meta_time", "1496356375");
INSERT INTO `act_postmeta` VALUES("146", "7", "_wp_page_template", "page-templates/page_fullwidth.php");
INSERT INTO `act_postmeta` VALUES("147", "9", "_wp_page_template", "page-templates/page_fullwidth.php");
INSERT INTO `act_postmeta` VALUES("148", "42", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("149", "42", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("150", "42", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("151", "42", "_edit_lock", "1496868679:1");
INSERT INTO `act_postmeta` VALUES("153", "44", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("154", "44", "_edit_lock", "1496357411:1");
INSERT INTO `act_postmeta` VALUES("156", "44", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("157", "44", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("158", "46", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("159", "46", "_edit_lock", "1496357478:1");
INSERT INTO `act_postmeta` VALUES("161", "46", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("162", "46", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("163", "48", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("164", "48", "_wp_trash_meta_time", "1496357668");
INSERT INTO `act_postmeta` VALUES("165", "49", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("166", "49", "_wp_trash_meta_time", "1496357769");
INSERT INTO `act_postmeta` VALUES("172", "51", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("173", "51", "_wp_trash_meta_time", "1496360393");
INSERT INTO `act_postmeta` VALUES("174", "52", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("175", "52", "_wp_trash_meta_time", "1496360474");
INSERT INTO `act_postmeta` VALUES("178", "55", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("179", "55", "_wp_trash_meta_time", "1496361038");
INSERT INTO `act_postmeta` VALUES("180", "5", "encrypted_lite_sidebar_layout", "right-sidebar");
INSERT INTO `act_postmeta` VALUES("183", "5", "spacious_page_layout", "no_sidebar_full_width");
INSERT INTO `act_postmeta` VALUES("188", "59", "_wp_attached_file", "2017/06/logo-absolute-comfort.png");
INSERT INTO `act_postmeta` VALUES("189", "59", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:552;s:6:\"height\";i:218;s:4:\"file\";s:33:\"2017/06/logo-absolute-comfort.png\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"logo-absolute-comfort-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"logo-absolute-comfort-300x118.png\";s:5:\"width\";i:300;s:6:\"height\";i:118;s:9:\"mime-type\";s:9:\"image/png\";}s:22:\"business-eye-blog-post\";a:4:{s:4:\"file\";s:33:\"logo-absolute-comfort-365x218.png\";s:5:\"width\";i:365;s:6:\"height\";i:218;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("190", "60", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("191", "60", "_wp_trash_meta_time", "1496787446");
INSERT INTO `act_postmeta` VALUES("192", "61", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("193", "61", "_wp_trash_meta_time", "1496787518");
INSERT INTO `act_postmeta` VALUES("194", "62", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("195", "62", "_wp_trash_meta_time", "1496787571");
INSERT INTO `act_postmeta` VALUES("196", "63", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("197", "63", "_wp_trash_meta_time", "1496788419");
INSERT INTO `act_postmeta` VALUES("198", "64", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("199", "64", "_wp_trash_meta_time", "1496788458");
INSERT INTO `act_postmeta` VALUES("200", "66", "_wp_attached_file", "2017/06/cropped-logo-absolute-comfort.png");
INSERT INTO `act_postmeta` VALUES("201", "66", "_wp_attachment_context", "custom-header");
INSERT INTO `act_postmeta` VALUES("202", "66", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:190;s:6:\"height\";i:70;s:4:\"file\";s:41:\"2017/06/cropped-logo-absolute-comfort.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:40:\"cropped-logo-absolute-comfort-150x70.png\";s:5:\"width\";i:150;s:6:\"height\";i:70;s:9:\"mime-type\";s:9:\"image/png\";}s:39:\"accesspress-basic-testimonial-thumbnail\";a:4:{s:4:\"file\";s:40:\"cropped-logo-absolute-comfort-125x70.png\";s:5:\"width\";i:125;s:6:\"height\";i:70;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("203", "66", "_wp_attachment_is_custom_header", "accesspress-basic-child");
INSERT INTO `act_postmeta` VALUES("204", "67", "_wp_attached_file", "2017/06/cropped-logo-absolute-comfort-1.png");
INSERT INTO `act_postmeta` VALUES("205", "67", "_wp_attachment_context", "custom-header");
INSERT INTO `act_postmeta` VALUES("206", "67", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:190;s:6:\"height\";i:74;s:4:\"file\";s:43:\"2017/06/cropped-logo-absolute-comfort-1.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:42:\"cropped-logo-absolute-comfort-1-150x74.png\";s:5:\"width\";i:150;s:6:\"height\";i:74;s:9:\"mime-type\";s:9:\"image/png\";}s:39:\"accesspress-basic-testimonial-thumbnail\";a:4:{s:4:\"file\";s:42:\"cropped-logo-absolute-comfort-1-125x74.png\";s:5:\"width\";i:125;s:6:\"height\";i:74;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("207", "67", "_wp_attachment_is_custom_header", "vogue");
INSERT INTO `act_postmeta` VALUES("208", "5", "apbasic_page_layout", "default_layout");
INSERT INTO `act_postmeta` VALUES("209", "42", "apbasic_page_layout", "default_layout");
INSERT INTO `act_postmeta` VALUES("214", "73", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("215", "73", "_wp_trash_meta_time", "1496869515");
INSERT INTO `act_postmeta` VALUES("217", "74", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("218", "74", "_wp_trash_meta_time", "1496869732");
INSERT INTO `act_postmeta` VALUES("219", "75", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("220", "75", "_wp_trash_meta_time", "1496873869");
INSERT INTO `act_postmeta` VALUES("221", "76", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("222", "76", "_wp_trash_meta_time", "1496873980");
INSERT INTO `act_postmeta` VALUES("223", "77", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("224", "77", "_edit_lock", "1496875078:1");
INSERT INTO `act_postmeta` VALUES("228", "77", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("229", "77", "_yoast_wpseo_primary_category", "4");
INSERT INTO `act_postmeta` VALUES("230", "79", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("231", "79", "_edit_lock", "1496875180:1");
INSERT INTO `act_postmeta` VALUES("235", "79", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("236", "79", "_yoast_wpseo_primary_category", "4");
INSERT INTO `act_postmeta` VALUES("237", "81", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("238", "81", "_edit_lock", "1496875732:1");
INSERT INTO `act_postmeta` VALUES("242", "81", "_yoast_wpseo_content_score", "60");
INSERT INTO `act_postmeta` VALUES("243", "81", "_yoast_wpseo_primary_category", "4");
INSERT INTO `act_postmeta` VALUES("244", "83", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("245", "83", "_wp_trash_meta_time", "1496875379");
INSERT INTO `act_postmeta` VALUES("246", "84", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("247", "84", "_wp_trash_meta_time", "1496875398");
INSERT INTO `act_postmeta` VALUES("248", "86", "_wp_page_template", "page-templates/page_front-page.php");
INSERT INTO `act_postmeta` VALUES("249", "86", "is_one-page-express_front_page", "1");
INSERT INTO `act_postmeta` VALUES("250", "88", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("251", "88", "_wp_trash_meta_time", "1496877297");
INSERT INTO `act_postmeta` VALUES("252", "88", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("253", "88", "_wp_trash_meta_time", "1496877299");
INSERT INTO `act_postmeta` VALUES("254", "91", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("255", "91", "_wp_trash_meta_time", "1496877359");
INSERT INTO `act_postmeta` VALUES("256", "92", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("257", "92", "_wp_trash_meta_time", "1496877360");
INSERT INTO `act_postmeta` VALUES("258", "94", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("259", "94", "_wp_trash_meta_time", "1496878185");
INSERT INTO `act_postmeta` VALUES("260", "94", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("261", "94", "_wp_trash_meta_time", "1496878186");
INSERT INTO `act_postmeta` VALUES("262", "95", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("263", "95", "_wp_trash_meta_time", "1496878298");
INSERT INTO `act_postmeta` VALUES("264", "95", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("265", "95", "_wp_trash_meta_time", "1496878298");
INSERT INTO `act_postmeta` VALUES("266", "86", "_edit_lock", "1496904442:1");
INSERT INTO `act_postmeta` VALUES("267", "86", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("268", "86", "_yoast_wpseo_content_score", "60");
INSERT INTO `act_postmeta` VALUES("271", "100", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("272", "100", "_wp_trash_meta_time", "1496904627");
INSERT INTO `act_postmeta` VALUES("273", "109", "active", "1");
INSERT INTO `act_postmeta` VALUES("274", "109", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("275", "109", "description", "Membership2 Core Membership");
INSERT INTO `act_postmeta` VALUES("276", "109", "disabled_gateways", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("277", "109", "id", "0");
INSERT INTO `act_postmeta` VALUES("278", "109", "is_free", "");
INSERT INTO `act_postmeta` VALUES("279", "109", "is_setup_completed", "");
INSERT INTO `act_postmeta` VALUES("280", "109", "name", "System Membership");
INSERT INTO `act_postmeta` VALUES("281", "109", "on_end_membership_id", "0");
INSERT INTO `act_postmeta` VALUES("282", "109", "pay_cycle_period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("283", "109", "pay_cycle_repetitions", "0");
INSERT INTO `act_postmeta` VALUES("284", "109", "payment_type", "permanent");
INSERT INTO `act_postmeta` VALUES("285", "109", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("286", "109", "period_date_end", "");
INSERT INTO `act_postmeta` VALUES("287", "109", "period_date_start", "");
INSERT INTO `act_postmeta` VALUES("288", "109", "price", "0");
INSERT INTO `act_postmeta` VALUES("289", "109", "private", "");
INSERT INTO `act_postmeta` VALUES("290", "109", "revision", "0");
INSERT INTO `act_postmeta` VALUES("291", "109", "rule_values", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("292", "109", "source", "");
INSERT INTO `act_postmeta` VALUES("293", "109", "source_id", "");
INSERT INTO `act_postmeta` VALUES("294", "109", "title", "System Membership");
INSERT INTO `act_postmeta` VALUES("295", "109", "trial_period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("296", "109", "trial_period_enabled", "");
INSERT INTO `act_postmeta` VALUES("297", "109", "trial_price", "0");
INSERT INTO `act_postmeta` VALUES("298", "109", "type", "base");
INSERT INTO `act_postmeta` VALUES("299", "109", "update_denied", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("300", "109", "update_replace", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("301", "110", "active", "1");
INSERT INTO `act_postmeta` VALUES("302", "110", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("303", "110", "description", "");
INSERT INTO `act_postmeta` VALUES("304", "110", "disabled_gateways", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("305", "110", "id", "0");
INSERT INTO `act_postmeta` VALUES("306", "110", "is_free", "1");
INSERT INTO `act_postmeta` VALUES("307", "110", "is_setup_completed", "");
INSERT INTO `act_postmeta` VALUES("308", "110", "name", "members");
INSERT INTO `act_postmeta` VALUES("309", "110", "on_end_membership_id", "0");
INSERT INTO `act_postmeta` VALUES("310", "110", "pay_cycle_period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("311", "110", "pay_cycle_repetitions", "0");
INSERT INTO `act_postmeta` VALUES("312", "110", "payment_type", "permanent");
INSERT INTO `act_postmeta` VALUES("313", "110", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("314", "110", "period_date_end", "");
INSERT INTO `act_postmeta` VALUES("315", "110", "period_date_start", "");
INSERT INTO `act_postmeta` VALUES("316", "110", "price", "0");
INSERT INTO `act_postmeta` VALUES("317", "110", "private", "");
INSERT INTO `act_postmeta` VALUES("318", "110", "revision", "0");
INSERT INTO `act_postmeta` VALUES("319", "110", "rule_values", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("320", "110", "source", "");
INSERT INTO `act_postmeta` VALUES("321", "110", "source_id", "");
INSERT INTO `act_postmeta` VALUES("322", "110", "title", "");
INSERT INTO `act_postmeta` VALUES("323", "110", "trial_period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("324", "110", "trial_period_enabled", "");
INSERT INTO `act_postmeta` VALUES("325", "110", "trial_price", "0");
INSERT INTO `act_postmeta` VALUES("326", "110", "type", "dripped");
INSERT INTO `act_postmeta` VALUES("327", "110", "update_denied", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("328", "110", "update_replace", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("377", "117", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("378", "117", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("379", "117", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("380", "117", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("381", "117", "description", "");
INSERT INTO `act_postmeta` VALUES("382", "117", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("383", "117", "id", "0");
INSERT INTO `act_postmeta` VALUES("384", "117", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("385", "117", "override", "");
INSERT INTO `act_postmeta` VALUES("386", "117", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("387", "117", "period_enabled", "");
INSERT INTO `act_postmeta` VALUES("388", "117", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("389", "117", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("390", "117", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("391", "117", "subject", "Confirmation of your membership at %blog-name%");
INSERT INTO `act_postmeta` VALUES("392", "117", "title", "");
INSERT INTO `act_postmeta` VALUES("393", "117", "type", "type_registration");
INSERT INTO `act_postmeta` VALUES("394", "117", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("395", "118", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("396", "118", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("397", "118", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("398", "118", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("399", "118", "description", "");
INSERT INTO `act_postmeta` VALUES("400", "118", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("401", "118", "id", "0");
INSERT INTO `act_postmeta` VALUES("402", "118", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("403", "118", "override", "");
INSERT INTO `act_postmeta` VALUES("404", "118", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("405", "118", "period_enabled", "");
INSERT INTO `act_postmeta` VALUES("406", "118", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("407", "118", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("408", "118", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("409", "118", "subject", "Your %ms-name% membership receipt");
INSERT INTO `act_postmeta` VALUES("410", "118", "title", "");
INSERT INTO `act_postmeta` VALUES("411", "118", "type", "type_invoice");
INSERT INTO `act_postmeta` VALUES("412", "118", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("413", "119", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("414", "119", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("415", "119", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("416", "119", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("417", "119", "description", "");
INSERT INTO `act_postmeta` VALUES("418", "119", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("419", "119", "id", "0");
INSERT INTO `act_postmeta` VALUES("420", "119", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("421", "119", "override", "");
INSERT INTO `act_postmeta` VALUES("422", "119", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("423", "119", "period_enabled", "");
INSERT INTO `act_postmeta` VALUES("424", "119", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("425", "119", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("426", "119", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("427", "119", "subject", "Your %ms-name% membership has ended");
INSERT INTO `act_postmeta` VALUES("428", "119", "title", "");
INSERT INTO `act_postmeta` VALUES("429", "119", "type", "type_finished");
INSERT INTO `act_postmeta` VALUES("430", "119", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("431", "120", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("432", "120", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("433", "120", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("434", "120", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("435", "120", "description", "");
INSERT INTO `act_postmeta` VALUES("436", "120", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("437", "120", "id", "0");
INSERT INTO `act_postmeta` VALUES("438", "120", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("439", "120", "override", "");
INSERT INTO `act_postmeta` VALUES("440", "120", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("441", "120", "period_enabled", "1");
INSERT INTO `act_postmeta` VALUES("442", "120", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("443", "120", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("444", "120", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("445", "120", "subject", "Your %ms-name% membership was canceled");
INSERT INTO `act_postmeta` VALUES("446", "120", "title", "");
INSERT INTO `act_postmeta` VALUES("447", "120", "type", "type_cancelled");
INSERT INTO `act_postmeta` VALUES("448", "120", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("449", "121", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("450", "121", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("451", "121", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("452", "121", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("453", "121", "description", "");
INSERT INTO `act_postmeta` VALUES("454", "121", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("455", "121", "id", "0");
INSERT INTO `act_postmeta` VALUES("456", "121", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("457", "121", "override", "");
INSERT INTO `act_postmeta` VALUES("458", "121", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("459", "121", "period_enabled", "");
INSERT INTO `act_postmeta` VALUES("460", "121", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("461", "121", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("462", "121", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("463", "121", "subject", "Your billing details have been changed.");
INSERT INTO `act_postmeta` VALUES("464", "121", "title", "");
INSERT INTO `act_postmeta` VALUES("465", "121", "type", "type_info_update");
INSERT INTO `act_postmeta` VALUES("466", "121", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("467", "122", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("468", "122", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("469", "122", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("470", "122", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("471", "122", "description", "");
INSERT INTO `act_postmeta` VALUES("472", "122", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("473", "122", "id", "0");
INSERT INTO `act_postmeta` VALUES("474", "122", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("475", "122", "override", "");
INSERT INTO `act_postmeta` VALUES("476", "122", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("477", "122", "period_enabled", "1");
INSERT INTO `act_postmeta` VALUES("478", "122", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("479", "122", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("480", "122", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("481", "122", "subject", "Your credit card is about to expire");
INSERT INTO `act_postmeta` VALUES("482", "122", "title", "");
INSERT INTO `act_postmeta` VALUES("483", "122", "type", "type_credit_card_expire");
INSERT INTO `act_postmeta` VALUES("484", "122", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("485", "123", "cc_email", NULL);
INSERT INTO `act_postmeta` VALUES("486", "123", "cc_enabled", NULL);
INSERT INTO `act_postmeta` VALUES("487", "123", "content_type", "text/html");
INSERT INTO `act_postmeta` VALUES("488", "123", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("489", "123", "description", "");
INSERT INTO `act_postmeta` VALUES("490", "123", "enabled", "1");
INSERT INTO `act_postmeta` VALUES("491", "123", "id", "0");
INSERT INTO `act_postmeta` VALUES("492", "123", "membership_id", "0");
INSERT INTO `act_postmeta` VALUES("493", "123", "override", "");
INSERT INTO `act_postmeta` VALUES("494", "123", "period", "a:2:{s:11:\"period_unit\";i:1;s:11:\"period_type\";s:4:\"days\";}");
INSERT INTO `act_postmeta` VALUES("495", "123", "period_enabled", "");
INSERT INTO `act_postmeta` VALUES("496", "123", "post_modified", "2017-06-08 12:05:26");
INSERT INTO `act_postmeta` VALUES("497", "123", "queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("498", "123", "sent_queue", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("499", "123", "subject", "Your membership payment has failed");
INSERT INTO `act_postmeta` VALUES("500", "123", "title", "");
INSERT INTO `act_postmeta` VALUES("501", "123", "type", "type_failed_payment");
INSERT INTO `act_postmeta` VALUES("502", "123", "user_id", "0");
INSERT INTO `act_postmeta` VALUES("503", "124", "amount", "0");
INSERT INTO `act_postmeta` VALUES("504", "124", "checkout_date", "2017-06-08 08:07:26");
INSERT INTO `act_postmeta` VALUES("505", "124", "checkout_ip", "::1");
INSERT INTO `act_postmeta` VALUES("506", "124", "coupon_id", "0");
INSERT INTO `act_postmeta` VALUES("507", "124", "currency", "USD");
INSERT INTO `act_postmeta` VALUES("508", "124", "custom_data", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("509", "124", "description", "Admin has no fees!");
INSERT INTO `act_postmeta` VALUES("510", "124", "discount", "0");
INSERT INTO `act_postmeta` VALUES("511", "124", "due_date", "2017-06-08");
INSERT INTO `act_postmeta` VALUES("512", "124", "external_id", "");
INSERT INTO `act_postmeta` VALUES("513", "124", "gateway_id", NULL);
INSERT INTO `act_postmeta` VALUES("514", "124", "id", "124");
INSERT INTO `act_postmeta` VALUES("515", "124", "invoice_date", "2017-06-08");
INSERT INTO `act_postmeta` VALUES("516", "124", "invoice_number", "1");
INSERT INTO `act_postmeta` VALUES("517", "124", "membership_id", "110");
INSERT INTO `act_postmeta` VALUES("518", "124", "ms_relationship_id", "0");
INSERT INTO `act_postmeta` VALUES("519", "124", "name", "Invoice for members - actjennifer");
INSERT INTO `act_postmeta` VALUES("520", "124", "notes", "a:0:{}");
INSERT INTO `act_postmeta` VALUES("521", "124", "pay_date", "");
INSERT INTO `act_postmeta` VALUES("522", "124", "post_modified", "2017-06-08 12:07:22");
INSERT INTO `act_postmeta` VALUES("523", "124", "price_date", "1496909242");
INSERT INTO `act_postmeta` VALUES("524", "124", "pro_rate", "0");
INSERT INTO `act_postmeta` VALUES("525", "124", "short_description", "Admin has no fees!");
INSERT INTO `act_postmeta` VALUES("526", "124", "source", "");
INSERT INTO `act_postmeta` VALUES("527", "124", "status", "new");
INSERT INTO `act_postmeta` VALUES("528", "124", "subtotal", "0");
INSERT INTO `act_postmeta` VALUES("529", "124", "tax_name", "");
INSERT INTO `act_postmeta` VALUES("530", "124", "tax_rate", "0");
INSERT INTO `act_postmeta` VALUES("531", "124", "title", "");
INSERT INTO `act_postmeta` VALUES("532", "124", "total", "0");
INSERT INTO `act_postmeta` VALUES("533", "124", "trial_ends", NULL);
INSERT INTO `act_postmeta` VALUES("534", "124", "trial_price", "0");
INSERT INTO `act_postmeta` VALUES("535", "124", "user_id", "1");
INSERT INTO `act_postmeta` VALUES("536", "124", "uses_trial", "");
INSERT INTO `act_postmeta` VALUES("539", "67", "_wp_attachment_custom_header_last_used_vogue", "1496913013");
INSERT INTO `act_postmeta` VALUES("540", "126", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("541", "126", "_wp_trash_meta_time", "1496913013");
INSERT INTO `act_postmeta` VALUES("542", "127", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("546", "127", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("547", "127", "_yoast_wpseo_primary_category", "4");
INSERT INTO `act_postmeta` VALUES("548", "127", "_edit_lock", "1496912936:1");
INSERT INTO `act_postmeta` VALUES("549", "129", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("552", "129", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("553", "129", "_yoast_wpseo_primary_category", "4");
INSERT INTO `act_postmeta` VALUES("554", "129", "_edit_lock", "1496914163:1");
INSERT INTO `act_postmeta` VALUES("556", "102", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("557", "102", "_wp_trash_meta_time", "1497003090");
INSERT INTO `act_postmeta` VALUES("558", "102", "_wp_desired_post_slug", "account");
INSERT INTO `act_postmeta` VALUES("559", "108", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("560", "108", "_wp_trash_meta_time", "1497003091");
INSERT INTO `act_postmeta` VALUES("561", "108", "_wp_desired_post_slug", "account-2");
INSERT INTO `act_postmeta` VALUES("562", "86", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("563", "86", "_wp_trash_meta_time", "1497003091");
INSERT INTO `act_postmeta` VALUES("564", "86", "_wp_desired_post_slug", "one-page-express");
INSERT INTO `act_postmeta` VALUES("565", "104", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("566", "104", "_wp_trash_meta_time", "1497003092");
INSERT INTO `act_postmeta` VALUES("567", "104", "_wp_desired_post_slug", "memberships");
INSERT INTO `act_postmeta` VALUES("568", "103", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("569", "103", "_wp_trash_meta_time", "1497003092");
INSERT INTO `act_postmeta` VALUES("570", "103", "_wp_desired_post_slug", "protected");
INSERT INTO `act_postmeta` VALUES("571", "105", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("572", "105", "_wp_trash_meta_time", "1497003092");
INSERT INTO `act_postmeta` VALUES("573", "105", "_wp_desired_post_slug", "protected-content");
INSERT INTO `act_postmeta` VALUES("574", "101", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("575", "101", "_wp_trash_meta_time", "1497003093");
INSERT INTO `act_postmeta` VALUES("576", "101", "_wp_desired_post_slug", "register");
INSERT INTO `act_postmeta` VALUES("577", "106", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("578", "106", "_wp_trash_meta_time", "1497003093");
INSERT INTO `act_postmeta` VALUES("579", "106", "_wp_desired_post_slug", "register-2");
INSERT INTO `act_postmeta` VALUES("580", "107", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("581", "107", "_wp_trash_meta_time", "1497003093");
INSERT INTO `act_postmeta` VALUES("582", "107", "_wp_desired_post_slug", "registration-complete");
INSERT INTO `act_postmeta` VALUES("587", "153", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("588", "153", "_wp_trash_meta_time", "1497046569");
INSERT INTO `act_postmeta` VALUES("589", "5", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:280:\"^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("590", "154", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:8:\"two_cols\";b:0;}i:1;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:29:\"P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("591", "155", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("592", "156", "_edit_lock", "1497127861:1");
INSERT INTO `act_postmeta` VALUES("593", "156", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("594", "156", "_yoast_wpseo_primary_category", "5");
INSERT INTO `act_postmeta` VALUES("595", "156", "wpcf-service-icon", "fa-taxi");
INSERT INTO `act_postmeta` VALUES("596", "156", "wpcf-service-link", "");
INSERT INTO `act_postmeta` VALUES("597", "156", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("598", "157", "_edit_lock", "1497127444:1");
INSERT INTO `act_postmeta` VALUES("599", "157", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("600", "157", "_yoast_wpseo_primary_category", "5");
INSERT INTO `act_postmeta` VALUES("601", "157", "wpcf-service-icon", "fa-check");
INSERT INTO `act_postmeta` VALUES("602", "157", "wpcf-service-link", "");
INSERT INTO `act_postmeta` VALUES("603", "157", "_yoast_wpseo_content_score", "30");
INSERT INTO `act_postmeta` VALUES("604", "158", "_edit_lock", "1497091247:1");
INSERT INTO `act_postmeta` VALUES("605", "158", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("606", "158", "_yoast_wpseo_primary_category", "5");
INSERT INTO `act_postmeta` VALUES("607", "158", "wpcf-service-icon", "fa-support");
INSERT INTO `act_postmeta` VALUES("608", "158", "wpcf-service-link", "");
INSERT INTO `act_postmeta` VALUES("609", "158", "_yoast_wpseo_content_score", "60");
INSERT INTO `act_postmeta` VALUES("611", "160", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("612", "160", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("613", "161", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("615", "162", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("616", "162", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("617", "163", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("618", "7", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5438:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\n\nOur vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"0efa3e7f-f836-4714-a3aa-1bd73aba7c93\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#2d2d2d\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("619", "165", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4932:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n&nbsp;\n\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n&nbsp;\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("620", "165", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4932:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n&nbsp;\n\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n&nbsp;\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("621", "166", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4932:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n&nbsp;\n\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n&nbsp;\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("622", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4932:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n&nbsp;\n\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n&nbsp;\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("623", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4932:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n&nbsp;\n\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n&nbsp;\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n&nbsp;\n\n&nbsp;\n\n&nbsp;\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("624", "167", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:78:\"Fast, Safe, Easy online booking. Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("625", "167", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:78:\"Fast, Safe, Easy online booking. Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("626", "168", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:78:\"Fast, Safe, Easy online booking. Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("632", "170", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("633", "170", "_wp_trash_meta_time", "1497048632");
INSERT INTO `act_postmeta` VALUES("634", "171", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("635", "171", "_wp_trash_meta_time", "1497048657");
INSERT INTO `act_postmeta` VALUES("636", "172", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("637", "172", "_wp_trash_meta_time", "1497048742");
INSERT INTO `act_postmeta` VALUES("638", "174", "_wp_attached_file", "2017/06/cropped-cropped-logo-absolute-comfort-1.png");
INSERT INTO `act_postmeta` VALUES("639", "174", "_wp_attachment_context", "site-icon");
INSERT INTO `act_postmeta` VALUES("640", "174", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:51:\"2017/06/cropped-cropped-logo-absolute-comfort-1.png\";s:5:\"sizes\";a:11:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"folio\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-512x400.png\";s:5:\"width\";i:512;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-512x400.png\";s:5:\"width\";i:512;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-230x230.png\";s:5:\"width\";i:230;s:6:\"height\";i:230;s:9:\"mime-type\";s:9:\"image/png\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-350x350.png\";s:5:\"width\";i:350;s:6:\"height\";i:350;s:9:\"mime-type\";s:9:\"image/png\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:51:\"cropped-cropped-logo-absolute-comfort-1-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:49:\"cropped-cropped-logo-absolute-comfort-1-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("641", "173", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("642", "173", "_wp_trash_meta_time", "1497048834");
INSERT INTO `act_postmeta` VALUES("643", "175", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("644", "175", "_wp_trash_meta_time", "1497048905");
INSERT INTO `act_postmeta` VALUES("645", "176", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("646", "176", "_wp_trash_meta_time", "1497049001");
INSERT INTO `act_postmeta` VALUES("650", "177", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("651", "177", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("652", "178", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("653", "179", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041737;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745958263;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("654", "179", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041737;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745958263;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("655", "180", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041737;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745958263;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("657", "181", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:13:\"Why Choose Us\";s:4:\"text\";s:258:\"Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\";s:4:\"list\";s:721:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\n\";s:10:\"button_url\";s:35:\"http://localhost/actfinal/about-us/\";s:11:\"button_text\";s:9:\"Read More\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f5d6cbfa-df06-4288-948a-3533994501eb\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("658", "181", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:13:\"Why Choose Us\";s:4:\"text\";s:258:\"Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\";s:4:\"list\";s:721:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\n\";s:10:\"button_url\";s:35:\"http://localhost/actfinal/about-us/\";s:11:\"button_text\";s:9:\"Read More\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f5d6cbfa-df06-4288-948a-3533994501eb\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("659", "182", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:13:\"Why Choose Us\";s:4:\"text\";s:258:\"Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\";s:4:\"list\";s:721:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\n\";s:10:\"button_url\";s:35:\"http://localhost/actfinal/about-us/\";s:11:\"button_text\";s:9:\"Read More\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f5d6cbfa-df06-4288-948a-3533994501eb\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("660", "183", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("661", "183", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("662", "184", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9a375d54-3a49-4543-971e-f0d180728437\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:10:\"What we do\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:5;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.37297913254041998;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.62702086745957997;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("671", "185", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("672", "185", "_wp_trash_meta_time", "1497050074");
INSERT INTO `act_postmeta` VALUES("673", "188", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:21:\"Call / Write us today\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("674", "188", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:21:\"Call / Write us today\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("675", "189", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:21:\"Call / Write us today\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("676", "190", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"577b0655-3038-4ac4-9c84-a755da142053\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:39:\"Safe, Easy, Fast, Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:21:\"Call / Write us today\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"5e978df6-7b0b-4f1a-989b-e2534d02913c\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("681", "191", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("682", "191", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"inline\";b:0;}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("683", "192", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("684", "193", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("685", "194", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("686", "194", "_wp_trash_meta_time", "1497050833");
INSERT INTO `act_postmeta` VALUES("687", "164", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("688", "164", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:4815:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("689", "195", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("690", "195", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("691", "196", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("692", "164", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("693", "164", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("694", "164", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("695", "164", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:3672:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate\n\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"020b45b1-d87c-40eb-b5a6-91581a08c7b4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:425:\"OUR MISSION\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations\n•	To add value by consistently providing reliable quality services to our customers\nOUR VISION\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\";s:4:\"list\";s:917:\"^ Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them\n^Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally\n^Community and Environment: we strive to help and improve the communities where we work and live\n^ Integrity: we act with honesty and integrity, not compromising the truth\n^ Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.\n^Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. \n^We respect all individuals and value their contributions.\n    Open communication: All team members are encouraged to openly share their opinions and views.\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"aeaeda9f-c88d-47e1-9aa7-830117db697c\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("696", "197", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Taxi / Cab Services\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"9e5856ec-9630-441f-a62e-b2d9f00817f6\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:7:{s:5:\"title\";s:14:\"Why Choose Us?\";s:4:\"text\";s:1:\"\n\";s:4:\"list\";s:720:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"744278db-985e-4fec-a0f2-89682b5667c3\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"223cd5a6-99da-4a7a-acb3-17fa936f574e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("697", "197", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Taxi / Cab Services\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"9e5856ec-9630-441f-a62e-b2d9f00817f6\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:7:{s:5:\"title\";s:14:\"Why Choose Us?\";s:4:\"text\";s:1:\"\n\";s:4:\"list\";s:720:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"744278db-985e-4fec-a0f2-89682b5667c3\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"223cd5a6-99da-4a7a-acb3-17fa936f574e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("698", "198", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Taxi / Cab Services\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"9e5856ec-9630-441f-a62e-b2d9f00817f6\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:14:\"Why Choose Us?\";s:4:\"text\";s:1:\"\n\";s:4:\"list\";s:720:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"744278db-985e-4fec-a0f2-89682b5667c3\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"223cd5a6-99da-4a7a-acb3-17fa936f574e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("699", "164", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Taxi / Cab Services\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"9e5856ec-9630-441f-a62e-b2d9f00817f6\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:14:\"Why Choose Us?\";s:4:\"text\";s:1:\"\n\";s:4:\"list\";s:720:\"^We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers\n^We refer our staff to recognized institutions for customer service training regularly\n^All our new employees must attend customer service training before commencing work\n^The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged\n^Most of our vehicles are new and in  good condition with functioning air conditioners\n^Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling\n^Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"744278db-985e-4fec-a0f2-89682b5667c3\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"223cd5a6-99da-4a7a-acb3-17fa936f574e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"0a82aac4-bf13-47e7-bbaf-d65b25d5e672\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("700", "199", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("701", "199", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("702", "200", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("703", "201", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("704", "201", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("705", "202", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:6:{s:5:\"title\";s:12:\"Contact Info\";s:7:\"address\";s:83:\"Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen\";s:5:\"phone\";s:32:\"+254797 119 418, +254789 122 834\";s:5:\"email\";s:30:\"Bookings@absolutecomfort.co.ke\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:19:\"Sydney_Contact_Info\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"b4bc0dec-a49e-4286-b8d5-6dc33b178ef5\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("707", "203", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:0:\"\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5ca1039-4ebe-463b-b661-960a5e9abab4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("708", "203", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:0:\"\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5ca1039-4ebe-463b-b661-960a5e9abab4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("709", "204", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:8:{s:5:\"title\";s:0:\"\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5ca1039-4ebe-463b-b661-960a5e9abab4\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("710", "205", "_edit_lock", "1497128538:1");
INSERT INTO `act_postmeta` VALUES("712", "206", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8511f500-b316-4f14-bd56-adffb6f7f8cd\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("713", "206", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8511f500-b316-4f14-bd56-adffb6f7f8cd\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("714", "207", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:17:{s:13:\"attachment_id\";i:59;s:3:\"url\";s:86:\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\";s:5:\"title\";s:0:\"\";s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:552;s:6:\"height\";i:218;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:4:\"none\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:21:\"WP_Widget_Media_Image\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8511f500-b316-4f14-bd56-adffb6f7f8cd\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:4;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("715", "208", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("716", "208", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("717", "209", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:0:\"\";s:9:\"skill_one\";s:0:\"\";s:13:\"skill_one_max\";i:0;s:9:\"skill_two\";s:0:\"\";s:13:\"skill_two_max\";i:0;s:11:\"skill_three\";s:0:\"\";s:15:\"skill_three_max\";i:0;s:10:\"skill_four\";s:0:\"\";s:14:\"skill_four_max\";i:0;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("718", "210", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("719", "210", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("720", "211", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"dfdaec81-dba0-4cb7-aa5e-5cde8b74725d\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("722", "212", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:8:\"Services\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"3b1e825a-59f5-4a13-9cba-22d4615ac1a5\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("723", "212", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:8:\"Services\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"3b1e825a-59f5-4a13-9cba-22d4615ac1a5\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("724", "213", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:8:{s:5:\"title\";s:8:\"Services\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:4:\"cols\";s:1:\"1\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_B\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"3b1e825a-59f5-4a13-9cba-22d4615ac1a5\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("725", "214", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("726", "214", "_wp_trash_meta_time", "1497131890");
INSERT INTO `act_postmeta` VALUES("727", "215", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("728", "215", "_wp_trash_meta_time", "1497132035");
INSERT INTO `act_postmeta` VALUES("729", "216", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("730", "216", "_wp_trash_meta_time", "1497132155");
INSERT INTO `act_postmeta` VALUES("731", "217", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("732", "217", "_wp_trash_meta_time", "1497132272");
INSERT INTO `act_postmeta` VALUES("733", "218", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("734", "218", "_wp_trash_meta_time", "1497132303");
INSERT INTO `act_postmeta` VALUES("735", "219", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("736", "219", "_wp_trash_meta_time", "1497135753");
INSERT INTO `act_postmeta` VALUES("737", "220", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("738", "220", "_wp_trash_meta_time", "1497135836");
INSERT INTO `act_postmeta` VALUES("742", "221", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:5:\"title\";s:0:\"\";s:8:\"fact_one\";s:17:\"cOMPETENT dRIVERS\";s:12:\"fact_one_max\";i:0;s:13:\"fact_one_icon\";s:0:\"\";s:8:\"fact_two\";s:0:\"\";s:12:\"fact_two_max\";i:0;s:13:\"fact_two_icon\";s:0:\"\";s:10:\"fact_three\";s:0:\"\";s:14:\"fact_three_max\";i:0;s:15:\"fact_three_icon\";s:0:\"\";s:9:\"fact_four\";s:0:\"\";s:13:\"fact_four_max\";i:0;s:14:\"fact_four_icon\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:12:\"Sydney_Facts\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"afe3ca8d-e4a5-40e0-9e5a-409f061280d8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("743", "221", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:5:\"title\";s:0:\"\";s:8:\"fact_one\";s:17:\"cOMPETENT dRIVERS\";s:12:\"fact_one_max\";i:0;s:13:\"fact_one_icon\";s:0:\"\";s:8:\"fact_two\";s:0:\"\";s:12:\"fact_two_max\";i:0;s:13:\"fact_two_icon\";s:0:\"\";s:10:\"fact_three\";s:0:\"\";s:14:\"fact_three_max\";i:0;s:15:\"fact_three_icon\";s:0:\"\";s:9:\"fact_four\";s:0:\"\";s:13:\"fact_four_max\";i:0;s:14:\"fact_four_icon\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:12:\"Sydney_Facts\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"afe3ca8d-e4a5-40e0-9e5a-409f061280d8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("744", "222", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:5:\"title\";s:0:\"\";s:8:\"fact_one\";s:17:\"cOMPETENT dRIVERS\";s:12:\"fact_one_max\";i:0;s:13:\"fact_one_icon\";s:0:\"\";s:8:\"fact_two\";s:0:\"\";s:12:\"fact_two_max\";i:0;s:13:\"fact_two_icon\";s:0:\"\";s:10:\"fact_three\";s:0:\"\";s:14:\"fact_three_max\";i:0;s:15:\"fact_three_icon\";s:0:\"\";s:9:\"fact_four\";s:0:\"\";s:13:\"fact_four_max\";i:0;s:14:\"fact_four_icon\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:12:\"Sydney_Facts\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"afe3ca8d-e4a5-40e0-9e5a-409f061280d8\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("746", "223", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:13:\"_widget_title\";s:0:\"\";s:5:\"texts\";s:68:\"We create great design\nWe create great websites\nWe create great code\";s:12:\"dynamic_bold\";s:1:\"1\";s:14:\"animation_type\";s:6:\"fadeIn\";s:9:\"font_size\";s:4:\"50px\";s:16:\"font_size_mobile\";s:4:\"30px\";s:5:\"color\";s:0:\"\";s:13:\"dynamic_color\";s:0:\"\";s:5:\"align\";s:6:\"center\";s:3:\"tag\";s:2:\"h2\";s:8:\"duration\";s:3:\"300\";s:5:\"delay\";s:1:\"5\";s:8:\"el_class\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:15:\"CL_Widget_Itext\";s:3:\"raw\";b:1;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"ab5aa026-2f93-43ab-aa70-06ac094f521e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("747", "223", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:13:\"_widget_title\";s:0:\"\";s:5:\"texts\";s:68:\"We create great design\nWe create great websites\nWe create great code\";s:12:\"dynamic_bold\";s:1:\"1\";s:14:\"animation_type\";s:6:\"fadeIn\";s:9:\"font_size\";s:4:\"50px\";s:16:\"font_size_mobile\";s:4:\"30px\";s:5:\"color\";s:0:\"\";s:13:\"dynamic_color\";s:0:\"\";s:5:\"align\";s:6:\"center\";s:3:\"tag\";s:2:\"h2\";s:8:\"duration\";s:3:\"300\";s:5:\"delay\";s:1:\"5\";s:8:\"el_class\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:15:\"CL_Widget_Itext\";s:3:\"raw\";b:1;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"ab5aa026-2f93-43ab-aa70-06ac094f521e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("748", "224", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:15:{s:13:\"_widget_title\";s:0:\"\";s:5:\"texts\";s:68:\"We create great design\nWe create great websites\nWe create great code\";s:12:\"dynamic_bold\";s:1:\"1\";s:14:\"animation_type\";s:6:\"fadeIn\";s:9:\"font_size\";s:4:\"50px\";s:16:\"font_size_mobile\";s:4:\"30px\";s:5:\"color\";s:0:\"\";s:13:\"dynamic_color\";s:0:\"\";s:5:\"align\";s:6:\"center\";s:3:\"tag\";s:2:\"h2\";s:8:\"duration\";s:3:\"300\";s:5:\"delay\";s:1:\"5\";s:8:\"el_class\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:15:\"CL_Widget_Itext\";s:3:\"raw\";b:1;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"ab5aa026-2f93-43ab-aa70-06ac094f521e\";s:5:\"style\";a:4:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("753", "227", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:15:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("754", "227", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:15:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("755", "228", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:15:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("759", "226", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("760", "226", "_wp_trash_meta_time", "1497220592");
INSERT INTO `act_postmeta` VALUES("763", "231", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("764", "232", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a7e5be\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("765", "233", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#a7e5be\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("766", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#a7e5be\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("767", "235", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("768", "235", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("769", "236", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("770", "148", "_edit_lock", "1497475505:1");
INSERT INTO `act_postmeta` VALUES("806", "241", "_wp_attached_file", "2017/06/act_1_plain.jpg");
INSERT INTO `act_postmeta` VALUES("807", "241", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_1_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_1_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_1_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_1_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_1_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_1_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_1_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_1_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_1_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_1_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_1_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("808", "242", "_wp_attached_file", "2017/06/act_2_plain.jpg");
INSERT INTO `act_postmeta` VALUES("809", "242", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_2_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_2_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_2_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_2_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_2_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_2_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_2_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_2_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_2_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_2_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_2_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("810", "243", "_wp_attached_file", "2017/06/act_3_plain.jpg");
INSERT INTO `act_postmeta` VALUES("811", "243", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_3_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_3_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_3_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_3_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_3_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_3_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_3_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_3_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_3_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_3_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_3_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("812", "244", "_wp_attached_file", "2017/06/act_4_plain.jpg");
INSERT INTO `act_postmeta` VALUES("813", "244", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_4_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_4_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_4_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_4_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_4_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_4_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_4_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_4_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_4_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_4_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_4_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("814", "245", "_wp_attached_file", "2017/06/act_5_plain.jpg");
INSERT INTO `act_postmeta` VALUES("815", "245", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_5_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_5_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_5_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_5_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_5_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_5_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_5_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_5_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_5_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_5_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_5_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("816", "246", "_wp_attached_file", "2017/06/act_6_plain.jpg");
INSERT INTO `act_postmeta` VALUES("817", "246", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_6_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_6_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_6_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_6_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_6_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_6_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_6_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_6_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_6_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_6_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_6_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("818", "247", "_wp_attached_file", "2017/06/act_7_plain.jpg");
INSERT INTO `act_postmeta` VALUES("819", "247", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_7_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_7_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_7_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_7_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_7_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_7_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_7_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_7_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_7_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_7_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_7_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("820", "248", "_wp_attached_file", "2017/06/act_8_plain.jpg");
INSERT INTO `act_postmeta` VALUES("821", "248", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_8_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_8_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_8_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_8_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_8_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_8_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_8_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_8_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_8_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_8_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_8_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("822", "249", "_wp_attached_file", "2017/06/act_9_plain.jpg");
INSERT INTO `act_postmeta` VALUES("823", "249", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:23:\"2017/06/act_9_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"act_9_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"act_9_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"act_9_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"act_9_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:23:\"act_9_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:23:\"act_9_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:23:\"act_9_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:23:\"act_9_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:23:\"act_9_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:23:\"act_9_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("824", "250", "_wp_attached_file", "2017/06/act_10_plain.jpg");
INSERT INTO `act_postmeta` VALUES("825", "250", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:24:\"2017/06/act_10_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"act_10_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"act_10_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"act_10_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"act_10_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:24:\"act_10_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:24:\"act_10_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:24:\"act_10_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:24:\"act_10_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:24:\"act_10_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:24:\"act_10_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("826", "251", "_wp_attached_file", "2017/06/act_11_plain.jpg");
INSERT INTO `act_postmeta` VALUES("827", "251", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:24:\"2017/06/act_11_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"act_11_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"act_11_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"act_11_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"act_11_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:24:\"act_11_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:24:\"act_11_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:24:\"act_11_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:24:\"act_11_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:24:\"act_11_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:24:\"act_11_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("828", "252", "_wp_attached_file", "2017/06/act_12_plain.jpg");
INSERT INTO `act_postmeta` VALUES("829", "252", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1300;s:4:\"file\";s:24:\"2017/06/act_12_plain.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"act_12_plain-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"act_12_plain-300x203.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:203;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"act_12_plain-768x520.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:520;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"act_12_plain-1024x693.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:693;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:24:\"act_12_plain-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:24:\"act_12_plain-830x562.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:562;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:24:\"act_12_plain-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:24:\"act_12_plain-230x156.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:156;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:24:\"act_12_plain-350x237.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:237;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:24:\"act_12_plain-480x325.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:325;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("830", "253", "_wp_attached_file", "2017/06/act_1_screened.jpg");
INSERT INTO `act_postmeta` VALUES("831", "253", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_1_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_1_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_1_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_1_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_1_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_1_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_1_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_1_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_1_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_1_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_1_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("832", "254", "_wp_attached_file", "2017/06/act_2_screened.jpg");
INSERT INTO `act_postmeta` VALUES("833", "254", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_2_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_2_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_2_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_2_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_2_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_2_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_2_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_2_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_2_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_2_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_2_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("834", "255", "_wp_attached_file", "2017/06/act_3_screened.jpg");
INSERT INTO `act_postmeta` VALUES("835", "255", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_3_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_3_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_3_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_3_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_3_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_3_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_3_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_3_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_3_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_3_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_3_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("836", "256", "_wp_attached_file", "2017/06/act_4_screened.jpg");
INSERT INTO `act_postmeta` VALUES("837", "256", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_4_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_4_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_4_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_4_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_4_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_4_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_4_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_4_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_4_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_4_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_4_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("838", "257", "_wp_attached_file", "2017/06/act_5_screened.jpg");
INSERT INTO `act_postmeta` VALUES("839", "257", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_5_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_5_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_5_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_5_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_5_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_5_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_5_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_5_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_5_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_5_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_5_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("840", "258", "_wp_attached_file", "2017/06/act_6_screened.jpg");
INSERT INTO `act_postmeta` VALUES("841", "258", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_6_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_6_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_6_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_6_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_6_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_6_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_6_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_6_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_6_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_6_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_6_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("842", "259", "_wp_attached_file", "2017/06/act_7_screened.jpg");
INSERT INTO `act_postmeta` VALUES("843", "259", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_7_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_7_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_7_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_7_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_7_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_7_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_7_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_7_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_7_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_7_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_7_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("844", "260", "_wp_attached_file", "2017/06/act_8_screened.jpg");
INSERT INTO `act_postmeta` VALUES("845", "260", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_8_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_8_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_8_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_8_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_8_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_8_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_8_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_8_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_8_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_8_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_8_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("846", "261", "_wp_attached_file", "2017/06/act_9_screened.jpg");
INSERT INTO `act_postmeta` VALUES("847", "261", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:26:\"2017/06/act_9_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"act_9_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"act_9_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:26:\"act_9_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"act_9_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:26:\"act_9_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:26:\"act_9_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:26:\"act_9_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:26:\"act_9_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:26:\"act_9_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:26:\"act_9_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("848", "262", "_wp_attached_file", "2017/06/act_10_screened.jpg");
INSERT INTO `act_postmeta` VALUES("849", "262", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:27:\"2017/06/act_10_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"act_10_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"act_10_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"act_10_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"act_10_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:27:\"act_10_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:27:\"act_10_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:27:\"act_10_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:27:\"act_10_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:27:\"act_10_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:27:\"act_10_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("850", "263", "_wp_attached_file", "2017/06/act_11_screened.jpg");
INSERT INTO `act_postmeta` VALUES("851", "263", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:27:\"2017/06/act_11_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"act_11_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"act_11_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"act_11_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"act_11_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:27:\"act_11_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:27:\"act_11_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:27:\"act_11_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:27:\"act_11_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:27:\"act_11_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:27:\"act_11_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("852", "264", "_wp_attached_file", "2017/06/act_12_screened.jpg");
INSERT INTO `act_postmeta` VALUES("853", "264", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1400;s:4:\"file\";s:27:\"2017/06/act_12_screened.jpg\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"act_12_screened-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"act_12_screened-300x219.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:219;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:27:\"act_12_screened-768x560.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:560;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"act_12_screened-1024x747.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:747;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"folio\";a:4:{s:4:\"file\";s:27:\"act_12_screened-600x400.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-large-thumb\";a:4:{s:4:\"file\";s:27:\"act_12_screened-830x605.jpg\";s:5:\"width\";i:830;s:6:\"height\";i:605;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:19:\"sydney-medium-thumb\";a:4:{s:4:\"file\";s:27:\"act_12_screened-550x400.jpg\";s:5:\"width\";i:550;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:27:\"act_12_screened-230x168.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:27:\"act_12_screened-350x255.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:255;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:27:\"act_12_screened-480x350.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("854", "259", "_wp_attachment_custom_header_last_used_sydney-child", "1497310753");
INSERT INTO `act_postmeta` VALUES("855", "259", "_wp_attachment_is_custom_header", "sydney-child");
INSERT INTO `act_postmeta` VALUES("856", "265", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("857", "265", "_wp_trash_meta_time", "1497310753");
INSERT INTO `act_postmeta` VALUES("858", "266", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("859", "266", "_wp_trash_meta_time", "1497311035");
INSERT INTO `act_postmeta` VALUES("860", "267", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("861", "267", "_wp_trash_meta_time", "1497311566");
INSERT INTO `act_postmeta` VALUES("862", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("863", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:8:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}i:1;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("864", "268", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("865", "268", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("866", "269", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("867", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("868", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:2:\"33\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("869", "270", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("870", "270", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("871", "271", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("872", "272", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("873", "272", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("874", "273", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("875", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:15:{s:5:\"image\";i:230;s:14:\"image_fallback\";s:10:\"http://230\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497223153629\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:10:\"full_width\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("876", "274", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("877", "274", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("878", "275", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("879", "234", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:10:\"new_window\";b:0;}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#e0e0e0\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#3898f7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("880", "276", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("881", "276", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("882", "277", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("883", "234", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:15:{s:5:\"image\";i:252;s:14:\"image_fallback\";s:10:\"http://252\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593f9c0c0c4eb\";s:19:\"_sow_form_timestamp\";s:13:\"1497340964769\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"a5858180-fcea-4351-8d75-07d1f917a8fb\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:15:{s:5:\"image\";i:249;s:14:\"image_fallback\";s:10:\"http://249\";s:4:\"size\";s:4:\"full\";s:5:\"align\";s:7:\"default\";s:5:\"title\";s:0:\"\";s:14:\"title_position\";s:6:\"hidden\";s:3:\"alt\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"bound\";b:1;s:10:\"full_width\";b:1;s:12:\"_sow_form_id\";s:13:\"593db688e1e19\";s:19:\"_sow_form_timestamp\";s:13:\"1497340990145\";s:19:\"eds_animation_class\";s:0:\"\";s:10:\"new_window\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:30:\"SiteOrigin_Widget_Image_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"89cf4db9-362f-4b78-bd46-9bd7b88e4754\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("884", "278", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("885", "278", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("886", "279", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("887", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";s:3:\"259\";s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("888", "280", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("889", "280", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("890", "281", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("891", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("892", "282", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("893", "282", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("894", "283", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("895", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Skills\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d3d3d3\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("896", "284", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("897", "284", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:8:\"two_cols\";b:0;}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("898", "285", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("899", "286", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("900", "286", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("901", "287", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("902", "288", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("903", "288", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("904", "289", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("905", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"247\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("906", "290", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("907", "290", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("908", "291", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("909", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("910", "292", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("911", "292", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("912", "293", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("919", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("920", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("921", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("922", "295", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("923", "295", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("924", "296", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("925", "297", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("926", "297", "_wp_trash_meta_time", "1497344723");
INSERT INTO `act_postmeta` VALUES("927", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#000000\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#81d742\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"249\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("928", "298", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("929", "298", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("930", "299", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#add365\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("931", "300", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("932", "300", "_wp_trash_meta_time", "1497344923");
INSERT INTO `act_postmeta` VALUES("933", "301", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("934", "301", "_wp_trash_meta_time", "1497344985");
INSERT INTO `act_postmeta` VALUES("935", "302", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("936", "302", "_wp_trash_meta_time", "1497345020");
INSERT INTO `act_postmeta` VALUES("937", "303", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("938", "303", "_wp_trash_meta_time", "1497345044");
INSERT INTO `act_postmeta` VALUES("945", "11", "_wp_page_template", "page-templates/page_fullwidth.php");
INSERT INTO `act_postmeta` VALUES("946", "11", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:4:{s:11:\"panels_data\";a:3:{s:7:\"widgets\";a:0:{}s:5:\"grids\";a:0:{}s:10:\"grid_cells\";a:0:{}}s:10:\"builder_id\";s:13:\"59411e888dcf6\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:32:\"SiteOrigin_Panels_Widgets_Layout\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"93aee4d2-7aff-41e8-9aeb-a9321934f920\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("947", "305", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("948", "305", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("949", "306", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("950", "307", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("951", "307", "_wp_trash_meta_time", "1497347273");
INSERT INTO `act_postmeta` VALUES("952", "308", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("953", "308", "_wp_trash_meta_time", "1497348281");
INSERT INTO `act_postmeta` VALUES("954", "309", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("955", "309", "_wp_trash_meta_time", "1497348949");
INSERT INTO `act_postmeta` VALUES("956", "310", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d8d174\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("957", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#d8d174\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("958", "311", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("959", "311", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("960", "312", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("961", "313", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("962", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#8cd790\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:36:\"Safe Easy Fast Secure Online Booking\";s:11:\"action_text\";s:46:\" Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:41:\"http://localhost/actfinal/online-booking/\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"3c97bcc4-df0d-423e-a06a-a930bfebed8f\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#77af9c\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("963", "314", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("964", "314", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("965", "315", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("966", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("967", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("968", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("969", "316", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("970", "316", "_wp_trash_meta_time", "1497353957");
INSERT INTO `act_postmeta` VALUES("971", "317", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("972", "317", "_wp_trash_meta_time", "1497424075");
INSERT INTO `act_postmeta` VALUES("973", "318", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("974", "318", "_wp_trash_meta_time", "1497424240");
INSERT INTO `act_postmeta` VALUES("975", "319", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("976", "319", "_wp_trash_meta_time", "1497424337");
INSERT INTO `act_postmeta` VALUES("977", "320", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("978", "320", "_wp_trash_meta_time", "1497424498");
INSERT INTO `act_postmeta` VALUES("979", "321", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("980", "321", "_wp_trash_meta_time", "1497424615");
INSERT INTO `act_postmeta` VALUES("981", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("982", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("983", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("984", "234", "panels_data", "a:3:{s:7:\"widgets\";a:4:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:3:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:4:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("985", "322", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("986", "322", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("987", "323", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("988", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("989", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("990", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"admin\";s:23:\"etjryekrykiryryjiuryikj\";s:3:\"box\";a:13:{s:5:\"media\";s:5:\"image\";s:5:\"image\";i:248;s:4:\"icon\";s:0:\"\";s:6:\"oembed\";s:0:\"\";s:5:\"title\";s:12:\"tuiujruruuut\";s:7:\"content\";s:10:\"fjfjfjhjfj\";s:3:\"btn\";s:9:\"gfjfjgjth\";s:7:\"btn-url\";s:0:\"\";s:6:\"btn-id\";s:0:\"\";s:9:\"btn-title\";s:0:\"\";s:11:\"btn-onclick\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"btn-window\";b:0;}s:7:\"styling\";a:24:{s:11:\"padding-top\";s:4:\"30px\";s:16:\"padding-top_unit\";s:2:\"px\";s:14:\"padding-bottom\";s:4:\"30px\";s:19:\"padding-bottom_unit\";s:2:\"px\";s:9:\"img-shape\";s:1:\"0\";s:8:\"icon-clr\";b:0;s:9:\"icon-size\";b:0;s:14:\"icon-size_unit\";s:2:\"px\";s:15:\"icon-border-clr\";b:0;s:10:\"icon-shape\";s:1:\"0\";s:5:\"title\";b:0;s:7:\"content\";b:0;s:8:\"btn-size\";s:7:\"default\";s:9:\"btn-theme\";s:7:\"classic\";s:7:\"btn-clr\";b:0;s:8:\"btn-base\";b:0;s:9:\"btn-hover\";b:1;s:9:\"btn-click\";b:1;s:11:\"btn-corners\";s:6:\"0.25em\";s:10:\"background\";b:0;s:24:\"so_field_container_state\";s:4:\"open\";s:11:\"icon-border\";b:0;s:10:\"title-font\";b:0;s:8:\"btn-font\";b:0;}s:12:\"_sow_form_id\";s:13:\"5940ed38926fb\";s:19:\"_sow_form_timestamp\";s:13:\"1497427360103\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:25:\"Inked_Media_Box_SO_Widget\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"64d07a94-5e3d-413c-abf9-09b89a2bce96\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("991", "324", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";b:1;s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("992", "324", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";b:1;s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("993", "325", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";b:1;s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("994", "326", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("995", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("996", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#cce8b4\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("997", "327", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("998", "327", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("999", "328", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1000", "329", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1001", "330", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#a0d67a\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1002", "331", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:331:\"^available hourly, daily, weekly and monthly basis\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1003", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:814:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em>\n\n<strong><em>OUR MISSION</em></strong>\n<ul>\n 	<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n 	<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<strong><em>OUR VISION</em></strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"19a4a350-ee39-418a-a76f-12d84aad9e28\";s:5:\"style\";a:3:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:14:\"column_padding\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1004", "332", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:1:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"fc186254-fb26-4453-9e94-cc95f0d8c128\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:247;s:14:\"image_fallback\";s:3:\"247\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"5940f599aa880\";s:19:\"_sow_form_timestamp\";s:13:\"1497432397453\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"357d2a5f-d7cf-49de-b751-534c1e521f46\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1005", "332", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:1:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"fc186254-fb26-4453-9e94-cc95f0d8c128\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:247;s:14:\"image_fallback\";s:3:\"247\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"5940f599aa880\";s:19:\"_sow_form_timestamp\";s:13:\"1497432397453\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"357d2a5f-d7cf-49de-b751-534c1e521f46\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1006", "333", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:1:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"fc186254-fb26-4453-9e94-cc95f0d8c128\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:247;s:14:\"image_fallback\";s:3:\"247\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"5940f599aa880\";s:19:\"_sow_form_timestamp\";s:13:\"1497432397453\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"357d2a5f-d7cf-49de-b751-534c1e521f46\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1007", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:1:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"fc186254-fb26-4453-9e94-cc95f0d8c128\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:247;s:14:\"image_fallback\";s:3:\"247\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"5940f599aa880\";s:19:\"_sow_form_timestamp\";s:13:\"1497432397453\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"357d2a5f-d7cf-49de-b751-534c1e521f46\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1008", "334", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5112:\"<p><img class=\"size-medium wp-image-174 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1-300x300.png\" alt=\"\" width=\"300\" height=\"300\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432661421\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1009", "334", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5112:\"<p><img class=\"size-medium wp-image-174 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1-300x300.png\" alt=\"\" width=\"300\" height=\"300\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432661421\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1010", "335", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5112:\"<p><img class=\"size-medium wp-image-174 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1-300x300.png\" alt=\"\" width=\"300\" height=\"300\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432661421\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1011", "336", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5085:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432743581\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1012", "336", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5085:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432743581\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1013", "337", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5085:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432743581\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1014", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:5085:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432743581\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1015", "338", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1016", "338", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1017", "339", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1018", "340", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1019", "341", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1020", "341", "_wp_trash_meta_time", "1497433662");
INSERT INTO `act_postmeta` VALUES("1021", "342", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1022", "342", "_wp_trash_meta_time", "1497434171");
INSERT INTO `act_postmeta` VALUES("1023", "343", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1024", "343", "_wp_trash_meta_time", "1497434336");
INSERT INTO `act_postmeta` VALUES("1025", "344", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1026", "344", "_wp_trash_meta_time", "1497434700");
INSERT INTO `act_postmeta` VALUES("1027", "345", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1028", "345", "_wp_trash_meta_time", "1497435471");
INSERT INTO `act_postmeta` VALUES("1029", "346", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:281:\"\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1030", "346", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:281:\"\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1031", "347", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:281:\"\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1032", "234", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:281:\"\n^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Action\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1033", "348", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:280:\"^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1034", "348", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:280:\"^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}s:6:\"inline\";b:0;}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1035", "349", "panels_data", "a:3:{s:7:\"widgets\";a:5:{i:0;a:9:{s:5:\"title\";s:29:\"Why you should travel with us\";s:6:\"number\";s:2:\"-1\";s:7:\"see_all\";s:0:\"\";s:12:\"see_all_text\";s:0:\"\";s:8:\"category\";s:0:\"\";s:15:\"content_excerpt\";s:11:\"fullcontent\";s:19:\"eds_animation_class\";s:0:\"\";s:8:\"two_cols\";b:0;s:11:\"panels_info\";a:7:{s:5:\"class\";s:22:\"Sydney_Services_Type_A\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5b9d35d4-bdb1-43e0-8da5-84c557a6d5a8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#abdb43\";s:14:\"headings_color\";s:7:\"#a2d729\";}}}i:1;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:796:\"<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"003df358-7b02-4ace-b584-ceb70bbdabfd\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#f6fedb\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}i:2;a:11:{s:5:\"title\";s:18:\"Unrivalled Service\";s:9:\"skill_one\";s:25:\"Competent Skilled Drivers\";s:13:\"skill_one_max\";i:100;s:9:\"skill_two\";s:14:\"Clean Vehicles\";s:13:\"skill_two_max\";i:100;s:11:\"skill_three\";s:16:\"Affordable Rates\";s:15:\"skill_three_max\";i:100;s:10:\"skill_four\";s:16:\"Customer Service\";s:14:\"skill_four_max\";i:100;s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:13:\"Sydney_Skills\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"e5a6cdca-5290-4fdb-9a97-608dd4e07157\";s:5:\"style\";a:7:{s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:7:{s:5:\"title\";s:4:\"Safe\";s:4:\"text\";s:25:\"Travel with Peace of mind\";s:4:\"list\";s:280:\"^All vehicles fitted with Two way radio for effective communication\n^Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"cf4977b5-bbd5-458a-bee6-1b15f283efb7\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:7:{s:5:\"title\";s:14:\"Online Booking\";s:11:\"action_text\";s:45:\"Reserve your ride at the comfort of your seat\";s:15:\"action_btn_link\";s:0:\"\";s:15:\"action_btn_text\";s:8:\"Book Now\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"inline\";b:0;s:11:\"panels_info\";a:6:{s:5:\"class\";s:13:\"Sydney_Action\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"579fd138-bb2b-446c-a613-66165f41902b\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#ffffff\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:10:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#ffffff\";s:16:\"background_image\";s:3:\"256\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a2d729\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#343a1a\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:5:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1036", "350", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666663;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333333337;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1037", "350", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666663;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333333337;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1038", "351", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666663;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333333337;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1040", "353", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";d:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1041", "353", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";d:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1042", "354", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";d:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1043", "355", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";s:3:\"245\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1044", "356", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#d1d1d1\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1045", "356", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#d1d1d1\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1046", "357", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#d1d1d1\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.66666666666666996;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.33333333333332998;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1047", "358", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.62065854758683237;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.37934145241316758;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1048", "358", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.62065854758683237;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.37934145241316758;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1049", "359", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.62065854758683237;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.37934145241316758;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1050", "360", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1051", "360", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1052", "361", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1054", "362", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:271:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070175439;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929824561;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1055", "362", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:271:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070175439;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929824561;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1056", "363", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:271:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070175439;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929824561;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1058", "364", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1059", "364", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1060", "365", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1061", "366", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:5:\"right\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1062", "366", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:5:\"right\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1063", "367", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:5:\"right\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1064", "368", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1065", "368", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1066", "369", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.65241228070174995;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.34758771929825;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1067", "370", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1068", "370", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1069", "371", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1070", "372", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1071", "372", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1072", "373", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:10:{s:10:\"map_center\";s:48:\"Silver Pool Office Suites Jabavu Lane Hurlingham\";s:15:\"api_key_section\";a:2:{s:7:\"api_key\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";}s:8:\"settings\";a:13:{s:8:\"map_type\";s:11:\"interactive\";s:5:\"width\";s:3:\"640\";s:6:\"height\";s:3:\"480\";s:15:\"destination_url\";s:0:\"\";s:4:\"zoom\";i:12;s:11:\"scroll_zoom\";b:1;s:9:\"draggable\";b:1;s:13:\"keep_centered\";b:1;s:14:\"fallback_image\";i:0;s:19:\"fallback_image_size\";s:4:\"full\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:18:\"disable_default_ui\";b:0;}s:7:\"markers\";a:7:{s:16:\"marker_at_center\";b:1;s:11:\"marker_icon\";i:0;s:12:\"info_display\";s:5:\"click\";s:13:\"info_multiple\";b:1;s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"markers_draggable\";b:0;s:16:\"marker_positions\";a:0:{}}s:6:\"styles\";a:5:{s:12:\"style_method\";s:6:\"normal\";s:15:\"styled_map_name\";s:0:\"\";s:19:\"raw_json_map_styles\";s:0:\"\";s:24:\"so_field_container_state\";s:6:\"closed\";s:17:\"custom_map_styles\";a:0:{}}s:10:\"directions\";a:8:{s:6:\"origin\";s:0:\"\";s:11:\"destination\";s:0:\"\";s:11:\"travel_mode\";s:7:\"driving\";s:24:\"so_field_container_state\";s:6:\"closed\";s:14:\"avoid_highways\";b:0;s:11:\"avoid_tolls\";b:0;s:9:\"waypoints\";a:0:{}s:18:\"optimize_waypoints\";b:0;}s:12:\"_sow_form_id\";s:13:\"5941118722c55\";s:19:\"_sow_form_timestamp\";s:13:\"1497436664229\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:34:\"SiteOrigin_Widget_GoogleMap_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"8f40d248-963b-48f8-b575-aeebb035e515\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1073", "374", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1074", "374", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1075", "375", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:42:\"[contact-form-7 id=\"304\" title=\"Untitled\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34e70d81-daba-4d2a-b169-0ab631551a82\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1076", "376", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1077", "376", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1078", "377", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:267:\"<strong>NAIROBI OFFICE</strong>\n\nAbsolute Comfort Travel\n\nSilver Pool Office Suites\n\nHurlingham – Jabavu Lane\n\nP O Box 24716 – 00502\n\nKaren\n\n<strong>TELEPHONE:</strong>\n\n+254797 119 418\n\n+254789 122 834\n\n<strong>EMAIL:</strong>\n\nBookings@absolutecomfort.co.ke\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"66e94b5a-b548-45d8-8417-bf932b71829a\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1079", "378", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:1:{s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:0:{}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1080", "379", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1081", "379", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1082", "380", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1083", "381", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1085", "382", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1086", "382", "_wp_trash_meta_time", "1497439511");
INSERT INTO `act_postmeta` VALUES("1087", "383", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1088", "383", "_wp_trash_meta_time", "1497439537");
INSERT INTO `act_postmeta` VALUES("1089", "384", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:26:\"We\'d love to hear from you\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"72239c1f-3777-434d-9d17-11d19f2eb3e8\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1090", "385", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:17:\"Send us a message\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"e5d9518d-acfa-4855-ad31-c7833862f1d5\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:111:\"^Absolute Comfort Travel\n^Silver Pool Office Suites\n^Hurlingham – Jabavu Lane\n^P O Box 24716 – 00502\n^Karen\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1109bd0d-47f4-409b-9343-0f85b630b382\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1091", "385", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:17:\"Send us a message\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"e5d9518d-acfa-4855-ad31-c7833862f1d5\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:7:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:111:\"^Absolute Comfort Travel\n^Silver Pool Office Suites\n^Hurlingham – Jabavu Lane\n^P O Box 24716 – 00502\n^Karen\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1109bd0d-47f4-409b-9343-0f85b630b382\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1092", "386", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:17:\"Send us a message\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"e5d9518d-acfa-4855-ad31-c7833862f1d5\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:7:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:111:\"^Absolute Comfort Travel\n^Silver Pool Office Suites\n^Hurlingham – Jabavu Lane\n^P O Box 24716 – 00502\n^Karen\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:11:\"Sydney_List\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1109bd0d-47f4-409b-9343-0f85b630b382\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1093", "387", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:17:\"Send us a message\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"e5d9518d-acfa-4855-ad31-c7833862f1d5\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:7:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:111:\"^Absolute Comfort Travel\n^Silver Pool Office Suites\n^Hurlingham – Jabavu Lane\n^P O Box 24716 – 00502\n^Karen\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1109bd0d-47f4-409b-9343-0f85b630b382\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1094", "384", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:17:\"Send us a message\";s:4:\"text\";s:48:\"[contact-form-7 id=\"294\" title=\"Contact form 1\"]\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"e5d9518d-acfa-4855-ad31-c7833862f1d5\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:7:{s:5:\"title\";s:19:\"Contact Information\";s:4:\"text\";s:0:\"\";s:4:\"list\";s:111:\"^Absolute Comfort Travel\n^Silver Pool Office Suites\n^Hurlingham – Jabavu Lane\n^P O Box 24716 – 00502\n^Karen\";s:10:\"button_url\";s:0:\"\";s:11:\"button_text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:11:\"Sydney_List\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1109bd0d-47f4-409b-9343-0f85b630b382\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1095", "388", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:4:{s:11:\"panels_data\";a:3:{s:7:\"widgets\";a:0:{}s:5:\"grids\";a:0:{}s:10:\"grid_cells\";a:0:{}}s:10:\"builder_id\";s:13:\"59411e884163c\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:32:\"SiteOrigin_Panels_Widgets_Layout\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"93aee4d2-7aff-41e8-9aeb-a9321934f920\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1096", "388", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:4:{s:11:\"panels_data\";a:3:{s:7:\"widgets\";a:0:{}s:5:\"grids\";a:0:{}s:10:\"grid_cells\";a:0:{}}s:10:\"builder_id\";s:13:\"59411e884163c\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:32:\"SiteOrigin_Panels_Widgets_Layout\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"93aee4d2-7aff-41e8-9aeb-a9321934f920\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1097", "389", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:4:{s:11:\"panels_data\";a:3:{s:7:\"widgets\";a:0:{}s:5:\"grids\";a:0:{}s:10:\"grid_cells\";a:0:{}}s:10:\"builder_id\";s:13:\"59411e888dcf6\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:32:\"SiteOrigin_Panels_Widgets_Layout\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"93aee4d2-7aff-41e8-9aeb-a9321934f920\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1098", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1099", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1100", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5053:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497432949901\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1101", "390", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1102", "390", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1103", "391", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1104", "392", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1105", "392", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1106", "393", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1107", "394", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1108", "394", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1109", "395", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1110", "164", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:993:\"<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440370426\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:5:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:10:\"background\";s:7:\"#bbd6ab\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1111", "396", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:995:\"<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440627340\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1112", "396", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:995:\"<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440627340\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1113", "397", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:995:\"<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440627340\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1114", "164", "panels_data", "a:3:{s:7:\"widgets\";a:7:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:995:\"<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594101c24e028\";s:19:\"_sow_form_timestamp\";s:13:\"1497440627340\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b9ce1650-8c3d-440c-b6bf-3d3a3e64850c\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"c802c53d-a806-4e82-8dab-a3389d08aba3\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:1;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:6;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:4;s:4:\"cell\";i:0;s:2:\"id\";i:6;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:5:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:4;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:7:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:6;a:4:{s:4:\"grid\";i:4;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1115", "398", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1116", "398", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1117", "399", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1118", "164", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1119", "164", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:777:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n&nbsp;\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1115:\"&nbsp;\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:807:\"&nbsp;\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1162:\"&nbsp;\n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1120", "400", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:773:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1111:\" \n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:803:\" \n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1158:\" \n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1121", "400", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:773:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1111:\" \n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:803:\" \n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1158:\" \n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1122", "401", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:773:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1111:\" \n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:803:\" \n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1158:\" \n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1123", "164", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:773:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1111:\" \n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:803:\" \n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1158:\" \n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1124", "164", "panels_data", "a:3:{s:7:\"widgets\";a:6:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:773:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n \";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"5fa8099f-db80-4464-9611-0811743c5ed8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1111:\" \n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"1c1f9f87-fe83-4be5-96b3-58ab81b53a54\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:5:{s:5:\"title\";s:14:\"WHY CHOOSE US?\";s:4:\"text\";s:803:\" \n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"f50bd472-dacb-473a-9b6a-31482b728f62\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:3;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:1158:\" \n\n<strong>TAXI / CAB</strong>\n\n<strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:0;s:2:\"id\";i:3;s:9:\"widget_id\";s:36:\"073e4e6b-fbd3-4612-90a6-9993833c6188\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:4;a:5:{s:5:\"title\";s:14:\"HUMAN RESOURCE\";s:4:\"text\";s:591:\"We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:2;s:4:\"cell\";i:1;s:2:\"id\";i:4;s:9:\"widget_id\";s:36:\"7438c619-8399-4ea0-82b9-6e9c56240e4e\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#ffffff\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#81d742\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:5;a:5:{s:5:\"title\";s:7:\"CHARGES\";s:4:\"text\";s:245:\"Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:3;s:4:\"cell\";i:0;s:2:\"id\";i:5;s:9:\"widget_id\";s:36:\"0aee5f34-8178-40a8-bb6b-7e7efbb6f648\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:6:\"center\";s:11:\"title_color\";s:7:\"#ffffff\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:4:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"252\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#bbd6ab\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:2;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";s:3:\"251\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:3;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#a1d680\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:6:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:3;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:4;a:4:{s:4:\"grid\";i:2;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:5;a:4:{s:4:\"grid\";i:3;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1125", "402", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1126", "402", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1127", "403", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1128", "404", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}s:10:\"cell_index\";i:0;}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1129", "405", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#9b9b9b\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1130", "405", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#9b9b9b\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1131", "406", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:4823:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n&nbsp;\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"11fee051-cc62-436d-adf2-2d7e5e1b16fc\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:5:\"color\";s:7:\"#9b9b9b\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1132", "407", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1133", "407", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1134", "408", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1135", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1136", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1137", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1138", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1139", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:5:\"solid\";s:5:\"color\";s:7:\"#EEEEEE\";s:9:\"thickness\";d:1;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447683414\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:7:\"fittext\";b:0;}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1140", "409", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";s:7:\"#81d742\";s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:6:\"groove\";s:5:\"color\";s:7:\"#81d742\";s:9:\"thickness\";d:3;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:7:\"fittext\";b:1;s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447801533\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:1:{s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1141", "409", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";s:7:\"#81d742\";s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:6:\"groove\";s:5:\"color\";s:7:\"#81d742\";s:9:\"thickness\";d:3;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:7:\"fittext\";b:1;s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447801533\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:2;a:1:{s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1142", "410", "panels_data", "a:3:{s:7:\"widgets\";a:3:{i:0;a:10:{s:8:\"headline\";a:15:{s:4:\"text\";s:8:\"About Us\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h1\";s:5:\"color\";b:0;s:11:\"hover_color\";s:7:\"#81d742\";s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;}s:12:\"sub_headline\";a:15:{s:4:\"text\";s:0:\"\";s:15:\"destination_url\";s:0:\"\";s:3:\"tag\";s:2:\"h3\";s:5:\"color\";b:0;s:11:\"hover_color\";b:0;s:4:\"font\";s:7:\"default\";s:9:\"font_size\";b:0;s:14:\"font_size_unit\";s:2:\"px\";s:5:\"align\";s:6:\"center\";s:11:\"line_height\";b:0;s:16:\"line_height_unit\";s:2:\"px\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:6:\"closed\";s:10:\"new_window\";b:0;}s:7:\"divider\";a:9:{s:5:\"style\";s:6:\"groove\";s:5:\"color\";s:7:\"#81d742\";s:9:\"thickness\";d:3;s:5:\"align\";s:6:\"center\";s:5:\"width\";s:3:\"80%\";s:10:\"width_unit\";s:1:\"%\";s:6:\"margin\";b:0;s:11:\"margin_unit\";s:2:\"px\";s:24:\"so_field_container_state\";s:4:\"open\";}s:5:\"order\";a:3:{i:0;s:8:\"headline\";i:1;s:7:\"divider\";i:2;s:12:\"sub_headline\";}s:7:\"fittext\";b:1;s:18:\"fittext_compressor\";d:0.84999999999999998;s:12:\"_sow_form_id\";s:13:\"59413cf2e3e39\";s:19:\"_sow_form_timestamp\";s:13:\"1497447801533\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:33:\"SiteOrigin_Widget_Headline_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"9f912b57-eb26-4dea-a3c3-9156ae91b97f\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:1;s:4:\"cell\";i:0;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:2;a:1:{s:11:\"panels_info\";a:7:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:1;s:4:\"cell\";i:1;s:2:\"id\";i:2;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:2:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}i:1;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:3:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:0;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}i:2;a:4:{s:4:\"grid\";i:1;s:5:\"index\";i:1;s:6:\"weight\";d:0.5;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1143", "411", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:6:{s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"frames\";a:0:{}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.43775372124492556;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.56224627875507438;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1144", "411", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:6:{s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"frames\";a:0:{}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.43775372124492556;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.56224627875507438;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1145", "412", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:6:{s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"frames\";a:0:{}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.43775372124492556;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.56224627875507438;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1146", "164", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:6:{s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:0:\"\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"frames\";a:0:{}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.43775372124492556;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.56224627875507438;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1147", "413", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#919191\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:6:{s:6:\"frames\";a:2:{i:0;a:9:{s:16:\"background_image\";i:252;s:25:\"background_image_fallback\";s:10:\"http://252\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}i:1;a:9:{s:16:\"background_image\";i:249;s:25:\"background_image_fallback\";s:10:\"http://249\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:13:\"1497448445829\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.55818673883626968;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.44181326116373043;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1148", "413", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#919191\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}i:1;a:6:{s:6:\"frames\";a:2:{i:0;a:9:{s:16:\"background_image\";i:252;s:25:\"background_image_fallback\";s:10:\"http://252\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}i:1;a:9:{s:16:\"background_image\";i:249;s:25:\"background_image_fallback\";s:10:\"http://249\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:13:\"1497448445829\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.55818673883626968;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.44181326116373043;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1149", "414", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#919191\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:6:{s:6:\"frames\";a:2:{i:0;a:9:{s:16:\"background_image\";i:252;s:25:\"background_image_fallback\";s:10:\"http://252\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}i:1;a:9:{s:16:\"background_image\";i:249;s:25:\"background_image_fallback\";s:10:\"http://249\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:13:\"1497448445829\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.55818673883626968;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.44181326116373043;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1150", "164", "panels_data", "a:3:{s:7:\"widgets\";a:2:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:1912:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b64357be-c243-4266-91fb-98013f5cb626\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#919191\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}i:1;a:6:{s:6:\"frames\";a:2:{i:0;a:9:{s:16:\"background_image\";i:252;s:25:\"background_image_fallback\";s:10:\"http://252\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}i:1;a:9:{s:16:\"background_image\";i:249;s:25:\"background_image_fallback\";s:10:\"http://249\";s:16:\"background_color\";b:0;s:21:\"background_image_type\";s:5:\"cover\";s:16:\"foreground_image\";i:0;s:25:\"foreground_image_fallback\";s:0:\"\";s:3:\"url\";s:0:\"\";s:17:\"background_videos\";a:0:{}s:10:\"new_window\";b:0;}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:8000;s:13:\"nav_color_hex\";s:7:\"#FFFFFF\";s:9:\"nav_style\";s:4:\"thin\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59413f9449068\";s:19:\"_sow_form_timestamp\";s:13:\"1497448445829\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Slider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:1;s:2:\"id\";i:1;s:9:\"widget_id\";s:36:\"34cc4618-76eb-47f5-9dd5-a7bf6708c64a\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:2;s:5:\"style\";a:6:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:2:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";d:0.55818673883626968;s:5:\"style\";a:0:{}}i:1;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:1;s:6:\"weight\";d:0.44181326116373043;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1151", "415", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1152", "415", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1153", "416", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1154", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";d:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";d:800;s:7:\"timeout\";d:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";d:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";d:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1155", "417", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";i:800;s:7:\"timeout\";i:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";i:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";i:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1156", "417", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";i:800;s:7:\"timeout\";i:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";i:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";i:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1157", "418", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";i:800;s:7:\"timeout\";i:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";i:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";i:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1158", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:7:{s:6:\"frames\";a:5:{i:0;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:769:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"8163ca8d-8299-4f52-b3c6-fb8ba3a0ae85\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:1;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:15:\"OUR CORE VALUES\";s:4:\"text\";s:1108:\"<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"f6c9c73b-566d-40de-bb26-f762fd420613\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:2;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:14:\"Why choose us?\";s:4:\"text\";s:800:\"<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"be4e6b75-8e24-461a-94eb-793bbafa8781\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:3;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:16:\"SERVICES OFFERED\";s:4:\"text\";s:2034:\"<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"b44169cf-2854-44ea-8711-e9b86153c090\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}i:4;a:2:{s:7:\"content\";a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:25:\"Superior Customer Service\";s:4:\"text\";s:620:\"Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"63d363a4-809e-4805-a58d-f09ec180031c\";s:5:\"style\";a:17:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"widget_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:14:\"mobile_padding\";s:0:\"\";s:10:\"background\";s:0:\"\";s:27:\"background_image_attachment\";s:1:\"0\";s:18:\"background_display\";s:4:\"tile\";s:17:\"content_alignment\";s:4:\"left\";s:12:\"border_color\";s:0:\"\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";s:10:\"font_color\";s:0:\"\";s:10:\"link_color\";s:0:\"\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:20:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:10:\"cell_class\";s:0:\"\";s:7:\"row_css\";s:0:\"\";s:10:\"mobile_css\";s:0:\"\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:7:\"padding\";s:0:\"\";s:13:\"bottom_margin\";s:0:\"\";s:6:\"gutter\";s:0:\"\";s:11:\"row_stretch\";s:0:\"\";s:18:\"collapse_behaviour\";s:0:\"\";s:14:\"collapse_order\";s:0:\"\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:14:\"mobile_padding\";s:0:\"\";s:13:\"bottom_border\";s:0:\"\";s:10:\"background\";s:0:\"\";s:5:\"color\";s:0:\"\";s:16:\"background_image\";s:1:\"0\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}s:10:\"background\";a:9:{s:5:\"image\";i:0;s:14:\"image_fallback\";s:0:\"\";s:10:\"image_type\";s:5:\"cover\";s:7:\"opacity\";i:100;s:5:\"color\";s:7:\"#333333\";s:3:\"url\";s:0:\"\";s:24:\"so_field_container_state\";s:4:\"open\";s:10:\"new_window\";b:0;s:6:\"videos\";a:0:{}}}}s:8:\"controls\";a:7:{s:5:\"speed\";i:800;s:7:\"timeout\";i:4000;s:13:\"nav_color_hex\";s:7:\"#81d742\";s:9:\"nav_style\";s:14:\"medium-rounded\";s:8:\"nav_size\";i:25;s:5:\"swipe\";b:1;s:24:\"so_field_container_state\";s:4:\"open\";}s:6:\"design\";a:18:{s:6:\"height\";b:0;s:11:\"height_unit\";s:2:\"px\";s:7:\"padding\";s:4:\"50px\";s:12:\"padding_unit\";s:2:\"px\";s:17:\"extra_top_padding\";s:3:\"0px\";s:22:\"extra_top_padding_unit\";s:2:\"px\";s:13:\"padding_sides\";s:4:\"20px\";s:18:\"padding_sides_unit\";s:2:\"px\";s:5:\"width\";s:6:\"1280px\";s:10:\"width_unit\";s:2:\"px\";s:13:\"heading_color\";s:7:\"#FFFFFF\";s:12:\"heading_size\";s:4:\"38px\";s:17:\"heading_size_unit\";s:2:\"px\";s:14:\"heading_shadow\";i:50;s:9:\"text_size\";s:4:\"16px\";s:14:\"text_size_unit\";s:2:\"px\";s:10:\"text_color\";s:7:\"#F6F6F6\";s:24:\"so_field_container_state\";s:4:\"open\";}s:12:\"_sow_form_id\";s:13:\"59414078e2fa6\";s:19:\"_sow_form_timestamp\";s:13:\"1497448911317\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:37:\"SiteOrigin_Widget_LayoutSlider_Widget\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"43c7c5c2-c7fe-4131-83e8-c099fb297506\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:9:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1159", "419", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:2077:\"<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594142ae8a8be\";s:19:\"_sow_form_timestamp\";s:13:\"1497449230845\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"cfd5fe3e-09ab-47ca-b3d7-b582a1cc2fd7\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1160", "419", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:2077:\"<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594142ae8a8be\";s:19:\"_sow_form_timestamp\";s:13:\"1497449230845\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"cfd5fe3e-09ab-47ca-b3d7-b582a1cc2fd7\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1161", "420", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:2077:\"<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594142ae8a8be\";s:19:\"_sow_form_timestamp\";s:13:\"1497449230845\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"cfd5fe3e-09ab-47ca-b3d7-b582a1cc2fd7\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1162", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:2077:\"<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"594142ae8a8be\";s:19:\"_sow_form_timestamp\";s:13:\"1497449230845\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"cfd5fe3e-09ab-47ca-b3d7-b582a1cc2fd7\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#b7b7b7\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1163", "421", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449546518\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1164", "421", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449546518\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1165", "422", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449546518\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1166", "423", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449546518\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#adadad\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1167", "424", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"447\" height=\"303\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449678925\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#adadad\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1168", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"447\" height=\"303\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449678925\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#adadad\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1169", "164", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5667:\"<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"447\" height=\"303\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\";s:20:\"text_selected_editor\";s:7:\"tinymce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414373b3a4e\";s:19:\"_sow_form_timestamp\";s:13:\"1497449678925\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"61597e5c-cfdc-4c12-ae41-39bc13ed22e8\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#adadad\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#81d742\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1170", "425", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5438:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\n\nOur vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"0efa3e7f-f836-4714-a3aa-1bd73aba7c93\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#2d2d2d\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1171", "425", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5438:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\n\nOur vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client.\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"0efa3e7f-f836-4714-a3aa-1bd73aba7c93\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#2d2d2d\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}s:6:\"filter\";s:7:\"content\";}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1172", "426", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:5:{s:5:\"title\";s:8:\"About Us\";s:4:\"text\";s:5438:\"Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi\n\n<strong>OUR MISSION</strong>\n<ul>\n 	<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n 	<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<strong>OUR VISION</strong>\n\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates\n\n<strong>OUR CORE VALUES</strong>\n<ol>\n 	<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n 	<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n 	<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n 	<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n 	<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n 	<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n 	<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<strong>WHY CHOOSE US?</strong>\n<ul>\n 	<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n 	<li>We refer our staff to recognized institutions for customer service training regularly</li>\n 	<li>All our new employees must attend customer service training before commencing work</li>\n 	<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n 	<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n 	<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n 	<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<strong>SERVICES OFFERED</strong>\n\n<strong>TAXI / CAB</strong>\n\nWe specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis\n\nOur commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up\n\nOur chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.\n\n<strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong>\n\nTwo way radio for effective communication\n\nVehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients\n\n<strong>CHARGES</strong>\n\nOur charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive\n\n<strong>HUMAN RESOURCE</strong>\n\nWe consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.\n\nEmployees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.\n\nOur vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence\n\nWe carry the day’s newspaper in the back of each car\n\nAll our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.\n\nWe carry an umbrella at the back of each car for our client’s use in rainy season\n\nWe promise to cooperate and ensure smooth and effective service delivery to the client.\";s:19:\"eds_animation_class\";s:0:\"\";s:6:\"filter\";s:7:\"content\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:14:\"WP_Widget_Text\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"0efa3e7f-f836-4714-a3aa-1bd73aba7c93\";s:5:\"style\";a:8:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:10:\"font_color\";s:7:\"#2d2d2d\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:7:{s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";s:0:\"\";s:16:\"background_image\";b:0;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1173", "44", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1174", "44", "_wp_trash_meta_time", "1497451189");
INSERT INTO `act_postmeta` VALUES("1175", "44", "_wp_desired_post_slug", "excellent-customer-service");
INSERT INTO `act_postmeta` VALUES("1176", "42", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1177", "42", "_wp_trash_meta_time", "1497451190");
INSERT INTO `act_postmeta` VALUES("1178", "42", "_wp_desired_post_slug", "superior-service");
INSERT INTO `act_postmeta` VALUES("1179", "46", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1180", "46", "_wp_trash_meta_time", "1497451190");
INSERT INTO `act_postmeta` VALUES("1181", "46", "_wp_desired_post_slug", "we-operate-247");
INSERT INTO `act_postmeta` VALUES("1182", "147", "_edit_lock", "1497470510:1");
INSERT INTO `act_postmeta` VALUES("1183", "147", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1184", "147", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1185", "147", "_yoast_wpseo_content_score", "90");
INSERT INTO `act_postmeta` VALUES("1186", "147", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:307:\"<p> </p><p> </p><p><a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img class=\"aligncenter\" title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p>\";s:20:\"text_selected_editor\";s:4:\"tmce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497470455422\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1187", "430", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:288:\"<p> </p><p> </p><p><a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p>\";s:20:\"text_selected_editor\";s:4:\"tmce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497452512199\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1188", "430", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:288:\"<p> </p><p> </p><p><a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p>\";s:20:\"text_selected_editor\";s:4:\"tmce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497452512199\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1189", "431", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:288:\"<p> </p><p> </p><p><a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p>\";s:20:\"text_selected_editor\";s:4:\"tmce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497452512199\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1199", "148", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1200", "148", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1201", "148", "_yoast_wpseo_content_score", "60");
INSERT INTO `act_postmeta` VALUES("1202", "434", "_wp_attached_file", "2017/06/logo.jpg");
INSERT INTO `act_postmeta` VALUES("1203", "434", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:200;s:4:\"file\";s:16:\"2017/06/logo.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"logo-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"logo-300x120.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:120;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"sydney-small-thumb\";a:4:{s:4:\"file\";s:15:\"logo-230x92.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:92;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sydney-service-thumb\";a:4:{s:4:\"file\";s:16:\"logo-350x140.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"sydney-mas-thumb\";a:4:{s:4:\"file\";s:16:\"logo-480x192.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:192;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:20:\"sow-carousel-default\";a:4:{s:4:\"file\";s:16:\"logo-272x182.jpg\";s:5:\"width\";i:272;s:6:\"height\";i:182;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `act_postmeta` VALUES("1204", "435", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1205", "435", "_wp_trash_meta_time", "1497461356");
INSERT INTO `act_postmeta` VALUES("1206", "436", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1207", "436", "_wp_trash_meta_time", "1497461895");
INSERT INTO `act_postmeta` VALUES("1208", "437", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1209", "437", "_wp_trash_meta_time", "1497463701");
INSERT INTO `act_postmeta` VALUES("1230", "441", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:277:\"&nbsp;\n\n&nbsp;\n\n<a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n&nbsp;\";s:20:\"text_selected_editor\";s:4:\"html\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497470248977\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1231", "441", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:277:\"&nbsp;\n\n&nbsp;\n\n<a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n&nbsp;\";s:20:\"text_selected_editor\";s:4:\"html\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497470248977\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1232", "442", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:277:\"&nbsp;\n\n&nbsp;\n\n<a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n&nbsp;\";s:20:\"text_selected_editor\";s:4:\"html\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497470248977\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1233", "443", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:8:{s:5:\"title\";s:87:\"Please take a minute to create an account with us for free and start booking your ride!\";s:4:\"text\";s:307:\"<p> </p><p> </p><p><a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img class=\"aligncenter\" title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p>\";s:20:\"text_selected_editor\";s:4:\"tmce\";s:5:\"autop\";b:1;s:12:\"_sow_form_id\";s:13:\"59414fc090bdf\";s:19:\"_sow_form_timestamp\";s:13:\"1497470455422\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:6:{s:5:\"class\";s:31:\"SiteOrigin_Widget_Editor_Widget\";s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"6ccc3f91-e272-427c-94cf-64ca177e7737\";s:5:\"style\";a:7:{s:27:\"background_image_attachment\";b:0;s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:0:{}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");
INSERT INTO `act_postmeta` VALUES("1234", "147", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1235", "147", "_wp_trash_meta_time", "1497475801");
INSERT INTO `act_postmeta` VALUES("1236", "147", "_wp_desired_post_slug", "membership-join");
INSERT INTO `act_postmeta` VALUES("1237", "148", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1238", "148", "_wp_trash_meta_time", "1497475802");
INSERT INTO `act_postmeta` VALUES("1239", "148", "_wp_desired_post_slug", "membership-registration");
INSERT INTO `act_postmeta` VALUES("1240", "149", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1241", "149", "_wp_trash_meta_time", "1497475802");
INSERT INTO `act_postmeta` VALUES("1242", "149", "_wp_desired_post_slug", "membership-login");
INSERT INTO `act_postmeta` VALUES("1243", "151", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1244", "151", "_wp_trash_meta_time", "1497475802");
INSERT INTO `act_postmeta` VALUES("1245", "151", "_wp_desired_post_slug", "password-reset");
INSERT INTO `act_postmeta` VALUES("1246", "150", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1247", "150", "_wp_trash_meta_time", "1497475802");
INSERT INTO `act_postmeta` VALUES("1248", "150", "_wp_desired_post_slug", "membership-profile");
INSERT INTO `act_postmeta` VALUES("1249", "447", "_edit_lock", "1497476829:1");
INSERT INTO `act_postmeta` VALUES("1250", "447", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1251", "447", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1252", "449", "_edit_lock", "1497476802:1");
INSERT INTO `act_postmeta` VALUES("1253", "449", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1254", "449", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1255", "452", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1256", "452", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1257", "452", "_edit_lock", "1497477025:1");
INSERT INTO `act_postmeta` VALUES("1260", "9", "_wpmem_block", "1");
INSERT INTO `act_postmeta` VALUES("1261", "447", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1262", "447", "_wp_trash_meta_time", "1497478948");
INSERT INTO `act_postmeta` VALUES("1263", "447", "_wp_desired_post_slug", "login-register");
INSERT INTO `act_postmeta` VALUES("1264", "449", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1265", "449", "_wp_trash_meta_time", "1497478949");
INSERT INTO `act_postmeta` VALUES("1266", "449", "_wp_desired_post_slug", "my-profile");
INSERT INTO `act_postmeta` VALUES("1267", "452", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1268", "452", "_wp_trash_meta_time", "1497478949");
INSERT INTO `act_postmeta` VALUES("1269", "452", "_wp_desired_post_slug", "register");
INSERT INTO `act_postmeta` VALUES("1284", "464", "_um_custom_fields", "a:6:{s:10:\"user_login\";a:15:{s:5:\"title\";s:8:\"Username\";s:7:\"metakey\";s:10:\"user_login\";s:4:\"type\";s:4:\"text\";s:5:\"label\";s:8:\"Username\";s:8:\"required\";i:1;s:6:\"public\";i:1;s:8:\"editable\";i:0;s:8:\"validate\";s:15:\"unique_username\";s:9:\"min_chars\";i:3;s:9:\"max_chars\";i:24;s:8:\"position\";s:1:\"1\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:10:\"user_email\";a:13:{s:5:\"title\";s:14:\"E-mail Address\";s:7:\"metakey\";s:10:\"user_email\";s:4:\"type\";s:4:\"text\";s:5:\"label\";s:14:\"E-mail Address\";s:8:\"required\";i:0;s:6:\"public\";i:1;s:8:\"editable\";i:1;s:8:\"validate\";s:12:\"unique_email\";s:8:\"position\";s:1:\"4\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:13:\"user_password\";a:16:{s:5:\"title\";s:8:\"Password\";s:7:\"metakey\";s:13:\"user_password\";s:4:\"type\";s:8:\"password\";s:5:\"label\";s:8:\"Password\";s:8:\"required\";i:1;s:6:\"public\";i:1;s:8:\"editable\";i:1;s:9:\"min_chars\";i:8;s:9:\"max_chars\";i:30;s:15:\"force_good_pass\";i:1;s:18:\"force_confirm_pass\";i:1;s:8:\"position\";s:1:\"5\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:10:\"first_name\";a:12:{s:5:\"title\";s:10:\"First Name\";s:7:\"metakey\";s:10:\"first_name\";s:4:\"type\";s:4:\"text\";s:5:\"label\";s:10:\"First Name\";s:8:\"required\";i:0;s:6:\"public\";i:1;s:8:\"editable\";i:1;s:8:\"position\";s:1:\"2\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:9:\"last_name\";a:12:{s:5:\"title\";s:9:\"Last Name\";s:7:\"metakey\";s:9:\"last_name\";s:4:\"type\";s:4:\"text\";s:5:\"label\";s:9:\"Last Name\";s:8:\"required\";i:0;s:6:\"public\";i:1;s:8:\"editable\";i:1;s:8:\"position\";s:1:\"3\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:9:\"_um_row_1\";a:4:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"1\";s:4:\"cols\";s:1:\"1\";}}");
INSERT INTO `act_postmeta` VALUES("1285", "464", "_um_mode", "register");
INSERT INTO `act_postmeta` VALUES("1286", "464", "_um_core", "register");
INSERT INTO `act_postmeta` VALUES("1287", "464", "_um_register_use_globals", "1");
INSERT INTO `act_postmeta` VALUES("1288", "465", "_um_custom_fields", "a:3:{s:8:\"username\";a:13:{s:5:\"title\";s:18:\"Username or E-mail\";s:7:\"metakey\";s:8:\"username\";s:4:\"type\";s:4:\"text\";s:5:\"label\";s:18:\"Username or E-mail\";s:8:\"required\";i:1;s:6:\"public\";i:1;s:8:\"editable\";i:0;s:8:\"validate\";s:24:\"unique_username_or_email\";s:8:\"position\";s:1:\"1\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:13:\"user_password\";a:16:{s:5:\"title\";s:8:\"Password\";s:7:\"metakey\";s:13:\"user_password\";s:4:\"type\";s:8:\"password\";s:5:\"label\";s:8:\"Password\";s:8:\"required\";i:1;s:6:\"public\";i:1;s:8:\"editable\";i:1;s:9:\"min_chars\";i:8;s:9:\"max_chars\";i:30;s:15:\"force_good_pass\";i:1;s:18:\"force_confirm_pass\";i:1;s:8:\"position\";s:1:\"2\";s:6:\"in_row\";s:9:\"_um_row_1\";s:10:\"in_sub_row\";s:1:\"0\";s:9:\"in_column\";s:1:\"1\";s:8:\"in_group\";s:0:\"\";}s:9:\"_um_row_1\";a:5:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"1\";s:4:\"cols\";s:1:\"1\";s:6:\"origin\";s:9:\"_um_row_1\";}}");
INSERT INTO `act_postmeta` VALUES("1289", "465", "_um_mode", "login");
INSERT INTO `act_postmeta` VALUES("1290", "465", "_um_core", "login");
INSERT INTO `act_postmeta` VALUES("1291", "465", "_um_login_use_globals", "1");
INSERT INTO `act_postmeta` VALUES("1292", "466", "_um_custom_fields", "a:1:{s:9:\"_um_row_1\";a:4:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"1\";s:4:\"cols\";s:1:\"1\";}}");
INSERT INTO `act_postmeta` VALUES("1293", "466", "_um_mode", "profile");
INSERT INTO `act_postmeta` VALUES("1294", "466", "_um_core", "profile");
INSERT INTO `act_postmeta` VALUES("1295", "466", "_um_profile_use_globals", "1");
INSERT INTO `act_postmeta` VALUES("1296", "467", "_um_template", "members");
INSERT INTO `act_postmeta` VALUES("1297", "467", "_um_mode", "directory");
INSERT INTO `act_postmeta` VALUES("1298", "467", "_um_has_profile_photo", "0");
INSERT INTO `act_postmeta` VALUES("1299", "467", "_um_has_cover_photo", "0");
INSERT INTO `act_postmeta` VALUES("1300", "467", "_um_show_social", "0");
INSERT INTO `act_postmeta` VALUES("1301", "467", "_um_show_userinfo", "0");
INSERT INTO `act_postmeta` VALUES("1302", "467", "_um_show_tagline", "0");
INSERT INTO `act_postmeta` VALUES("1303", "467", "_um_search", "0");
INSERT INTO `act_postmeta` VALUES("1304", "467", "_um_userinfo_animate", "1");
INSERT INTO `act_postmeta` VALUES("1305", "467", "_um_sortby", "user_registered_desc");
INSERT INTO `act_postmeta` VALUES("1306", "467", "_um_profile_photo", "1");
INSERT INTO `act_postmeta` VALUES("1307", "467", "_um_cover_photos", "1");
INSERT INTO `act_postmeta` VALUES("1308", "467", "_um_show_name", "1");
INSERT INTO `act_postmeta` VALUES("1309", "467", "_um_directory_header", "{total_users} Members");
INSERT INTO `act_postmeta` VALUES("1310", "467", "_um_directory_header_single", "{total_users} Member");
INSERT INTO `act_postmeta` VALUES("1311", "467", "_um_directory_no_users", "We are sorry. We cannot find any users who match your search criteria.");
INSERT INTO `act_postmeta` VALUES("1312", "467", "_um_profiles_per_page", "12");
INSERT INTO `act_postmeta` VALUES("1313", "467", "_um_profiles_per_page_mobile", "6");
INSERT INTO `act_postmeta` VALUES("1314", "467", "_um_core", "members");
INSERT INTO `act_postmeta` VALUES("1316", "468", "_um_core", "user");
INSERT INTO `act_postmeta` VALUES("1318", "470", "_um_core", "login");
INSERT INTO `act_postmeta` VALUES("1320", "472", "_um_core", "register");
INSERT INTO `act_postmeta` VALUES("1322", "474", "_um_core", "members");
INSERT INTO `act_postmeta` VALUES("1324", "476", "_um_core", "logout");
INSERT INTO `act_postmeta` VALUES("1326", "478", "_um_core", "account");
INSERT INTO `act_postmeta` VALUES("1328", "480", "_um_core", "password-reset");
INSERT INTO `act_postmeta` VALUES("1329", "482", "_um_core", "admin");
INSERT INTO `act_postmeta` VALUES("1330", "482", "_um_can_access_wpadmin", "1");
INSERT INTO `act_postmeta` VALUES("1331", "482", "_um_can_not_see_adminbar", "0");
INSERT INTO `act_postmeta` VALUES("1332", "482", "_um_can_edit_everyone", "1");
INSERT INTO `act_postmeta` VALUES("1333", "482", "_um_can_delete_everyone", "1");
INSERT INTO `act_postmeta` VALUES("1334", "482", "_um_can_edit_profile", "1");
INSERT INTO `act_postmeta` VALUES("1335", "482", "_um_can_delete_profile", "1");
INSERT INTO `act_postmeta` VALUES("1336", "482", "_um_can_view_all", "1");
INSERT INTO `act_postmeta` VALUES("1337", "482", "_um_can_make_private_profile", "1");
INSERT INTO `act_postmeta` VALUES("1338", "482", "_um_can_access_private_profile", "1");
INSERT INTO `act_postmeta` VALUES("1339", "482", "_um_default_homepage", "1");
INSERT INTO `act_postmeta` VALUES("1340", "482", "_um_status", "approved");
INSERT INTO `act_postmeta` VALUES("1341", "482", "_um_auto_approve_act", "redirect_profile");
INSERT INTO `act_postmeta` VALUES("1342", "482", "_um_after_login", "redirect_admin");
INSERT INTO `act_postmeta` VALUES("1343", "482", "_um_after_logout", "redirect_home");
INSERT INTO `act_postmeta` VALUES("1344", "483", "_um_core", "member");
INSERT INTO `act_postmeta` VALUES("1345", "483", "_um_can_access_wpadmin", "0");
INSERT INTO `act_postmeta` VALUES("1346", "483", "_um_can_not_see_adminbar", "1");
INSERT INTO `act_postmeta` VALUES("1347", "483", "_um_can_edit_everyone", "0");
INSERT INTO `act_postmeta` VALUES("1348", "483", "_um_can_delete_everyone", "0");
INSERT INTO `act_postmeta` VALUES("1349", "483", "_um_can_edit_profile", "1");
INSERT INTO `act_postmeta` VALUES("1350", "483", "_um_can_delete_profile", "1");
INSERT INTO `act_postmeta` VALUES("1351", "483", "_um_can_view_all", "0");
INSERT INTO `act_postmeta` VALUES("1352", "483", "_um_can_make_private_profile", "0");
INSERT INTO `act_postmeta` VALUES("1353", "483", "_um_can_access_private_profile", "0");
INSERT INTO `act_postmeta` VALUES("1354", "483", "_um_default_homepage", "1");
INSERT INTO `act_postmeta` VALUES("1355", "483", "_um_status", "pending");
INSERT INTO `act_postmeta` VALUES("1356", "483", "_um_auto_approve_act", "redirect_profile");
INSERT INTO `act_postmeta` VALUES("1357", "483", "_um_after_login", "redirect_profile");
INSERT INTO `act_postmeta` VALUES("1358", "483", "_um_after_logout", "redirect_home");
INSERT INTO `act_postmeta` VALUES("1359", "483", "_edit_lock", "1497510461:1");
INSERT INTO `act_postmeta` VALUES("1360", "483", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1361", "483", "_um_synced_role", "0");
INSERT INTO `act_postmeta` VALUES("1362", "483", "_um_redirect_homepage", "");
INSERT INTO `act_postmeta` VALUES("1363", "483", "_um_auto_approve_url", "");
INSERT INTO `act_postmeta` VALUES("1364", "483", "_um_login_email_activate", "0");
INSERT INTO `act_postmeta` VALUES("1365", "483", "_um_checkmail_action", "show_message");
INSERT INTO `act_postmeta` VALUES("1366", "483", "_um_checkmail_message", "Thank you for registering. Before you can login we need you to activate your account by clicking the activation link in the email we just sent you.");
INSERT INTO `act_postmeta` VALUES("1367", "483", "_um_checkmail_url", "");
INSERT INTO `act_postmeta` VALUES("1368", "483", "_um_url_email_activate", "");
INSERT INTO `act_postmeta` VALUES("1369", "483", "_um_pending_action", "show_message");
INSERT INTO `act_postmeta` VALUES("1370", "483", "_um_pending_message", "Thank you for applying for membership to our site. We will review your details and send you an email letting you know whether your application has been successful or not.");
INSERT INTO `act_postmeta` VALUES("1371", "483", "_um_pending_url", "");
INSERT INTO `act_postmeta` VALUES("1372", "483", "_um_login_redirect_url", "");
INSERT INTO `act_postmeta` VALUES("1373", "483", "_um_logout_redirect_url", "");
INSERT INTO `act_postmeta` VALUES("1374", "483", "_um_after_delete", "redirect_home");
INSERT INTO `act_postmeta` VALUES("1375", "483", "_um_delete_redirect_url", "");
INSERT INTO `act_postmeta` VALUES("1376", "465", "_edit_lock", "1497510495:1");
INSERT INTO `act_postmeta` VALUES("1377", "484", "_um_custom_fields", "a:1:{s:9:\"_um_row_1\";a:5:{s:4:\"type\";s:3:\"row\";s:2:\"id\";s:9:\"_um_row_1\";s:8:\"sub_rows\";s:1:\"2\";s:4:\"cols\";s:3:\"2:1\";s:6:\"origin\";s:9:\"_um_row_1\";}}");
INSERT INTO `act_postmeta` VALUES("1378", "484", "_edit_lock", "1497511738:1");
INSERT INTO `act_postmeta` VALUES("1379", "484", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1380", "9", "_um_custom_access_settings", "1");
INSERT INTO `act_postmeta` VALUES("1381", "9", "_um_accessible", "2");
INSERT INTO `act_postmeta` VALUES("1382", "9", "_um_access_redirect2", "");
INSERT INTO `act_postmeta` VALUES("1383", "9", "_um_access_roles", "a:3:{i:0;s:1:\"0\";i:1;s:6:\"member\";i:2;s:5:\"admin\";}");
INSERT INTO `act_postmeta` VALUES("1384", "9", "_um_access_redirect", "");
INSERT INTO `act_postmeta` VALUES("1385", "478", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1386", "478", "_wp_trash_meta_time", "1497512758");
INSERT INTO `act_postmeta` VALUES("1387", "478", "_wp_desired_post_slug", "account");
INSERT INTO `act_postmeta` VALUES("1388", "470", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1389", "470", "_wp_trash_meta_time", "1497512758");
INSERT INTO `act_postmeta` VALUES("1390", "470", "_wp_desired_post_slug", "login");
INSERT INTO `act_postmeta` VALUES("1391", "476", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1392", "476", "_wp_trash_meta_time", "1497512758");
INSERT INTO `act_postmeta` VALUES("1393", "476", "_wp_desired_post_slug", "logout");
INSERT INTO `act_postmeta` VALUES("1394", "474", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1395", "474", "_wp_trash_meta_time", "1497512759");
INSERT INTO `act_postmeta` VALUES("1396", "474", "_wp_desired_post_slug", "members");
INSERT INTO `act_postmeta` VALUES("1397", "480", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1398", "480", "_wp_trash_meta_time", "1497512759");
INSERT INTO `act_postmeta` VALUES("1399", "480", "_wp_desired_post_slug", "password-reset");
INSERT INTO `act_postmeta` VALUES("1400", "472", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1401", "472", "_wp_trash_meta_time", "1497512759");
INSERT INTO `act_postmeta` VALUES("1402", "472", "_wp_desired_post_slug", "register");
INSERT INTO `act_postmeta` VALUES("1403", "468", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1404", "468", "_wp_trash_meta_time", "1497512771");
INSERT INTO `act_postmeta` VALUES("1405", "468", "_wp_desired_post_slug", "user");
INSERT INTO `act_postmeta` VALUES("1425", "9", "pms-content-restrict-custom-redirect-url", "");
INSERT INTO `act_postmeta` VALUES("1426", "9", "pms-content-restrict-message-logged_out", "");
INSERT INTO `act_postmeta` VALUES("1427", "9", "pms-content-restrict-message-non_members", "");
INSERT INTO `act_postmeta` VALUES("1439", "9", "pms-content-restrict-user-status", "loggedin");
INSERT INTO `act_postmeta` VALUES("1461", "9", "pms-content-restrict-type", "message");
INSERT INTO `act_postmeta` VALUES("1462", "9", "pms-content-restrict-subscription-plan", "486");
INSERT INTO `act_postmeta` VALUES("1463", "9", "pms-content-restrict-subscription-plan", "487");
INSERT INTO `act_postmeta` VALUES("1464", "488", "_edit_lock", "1497514001:1");
INSERT INTO `act_postmeta` VALUES("1465", "488", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1466", "488", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1468", "488", "pms-content-restrict-custom-redirect-url", "");
INSERT INTO `act_postmeta` VALUES("1469", "488", "pms-content-restrict-message-logged_out", "");
INSERT INTO `act_postmeta` VALUES("1470", "488", "pms-content-restrict-message-non_members", "");
INSERT INTO `act_postmeta` VALUES("1487", "488", "pms-content-restrict-type", "default");
INSERT INTO `act_postmeta` VALUES("1488", "490", "_edit_lock", "1497520583:1");
INSERT INTO `act_postmeta` VALUES("1489", "490", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1490", "490", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1492", "490", "pms-content-restrict-custom-redirect-url", "");
INSERT INTO `act_postmeta` VALUES("1493", "490", "pms-content-restrict-message-logged_out", "");
INSERT INTO `act_postmeta` VALUES("1494", "490", "pms-content-restrict-message-non_members", "");
INSERT INTO `act_postmeta` VALUES("1511", "490", "pms-content-restrict-type", "default");
INSERT INTO `act_postmeta` VALUES("1512", "492", "_edit_lock", "1497516879:1");
INSERT INTO `act_postmeta` VALUES("1513", "492", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1514", "492", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1516", "492", "pms-content-restrict-custom-redirect-url", "");
INSERT INTO `act_postmeta` VALUES("1517", "492", "pms-content-restrict-message-logged_out", "");
INSERT INTO `act_postmeta` VALUES("1518", "492", "pms-content-restrict-message-non_members", "");
INSERT INTO `act_postmeta` VALUES("1535", "492", "pms-content-restrict-type", "default");
INSERT INTO `act_postmeta` VALUES("1536", "494", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1537", "494", "_wp_trash_meta_time", "1497514314");
INSERT INTO `act_postmeta` VALUES("1565", "490", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1566", "490", "_wp_trash_meta_time", "1497515821");
INSERT INTO `act_postmeta` VALUES("1567", "490", "_wp_desired_post_slug", "account");
INSERT INTO `act_postmeta` VALUES("1568", "492", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1569", "492", "_wp_trash_meta_time", "1497515821");
INSERT INTO `act_postmeta` VALUES("1570", "492", "_wp_desired_post_slug", "login");
INSERT INTO `act_postmeta` VALUES("1571", "488", "_wp_trash_meta_status", "publish");
INSERT INTO `act_postmeta` VALUES("1572", "488", "_wp_trash_meta_time", "1497515821");
INSERT INTO `act_postmeta` VALUES("1573", "488", "_wp_desired_post_slug", "register");
INSERT INTO `act_postmeta` VALUES("1590", "506", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1591", "506", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1592", "506", "_edit_lock", "1497521048:1");
INSERT INTO `act_postmeta` VALUES("1593", "508", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1594", "508", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1595", "508", "_edit_lock", "1497521066:1");
INSERT INTO `act_postmeta` VALUES("1596", "510", "_edit_last", "1");
INSERT INTO `act_postmeta` VALUES("1597", "510", "_wp_page_template", "default");
INSERT INTO `act_postmeta` VALUES("1598", "510", "_edit_lock", "1497521876:1");
INSERT INTO `act_postmeta` VALUES("1599", "11", "_wpmem_block", "0");
INSERT INTO `act_postmeta` VALUES("1600", "512", "panels_data", "a:3:{s:7:\"widgets\";a:1:{i:0;a:4:{s:11:\"panels_data\";a:3:{s:7:\"widgets\";a:0:{}s:5:\"grids\";a:0:{}s:10:\"grid_cells\";a:0:{}}s:10:\"builder_id\";s:13:\"59411e888dcf6\";s:19:\"eds_animation_class\";s:0:\"\";s:11:\"panels_info\";a:7:{s:5:\"class\";s:32:\"SiteOrigin_Panels_Widgets_Layout\";s:3:\"raw\";b:0;s:4:\"grid\";i:0;s:4:\"cell\";i:0;s:2:\"id\";i:0;s:9:\"widget_id\";s:36:\"93aee4d2-7aff-41e8-9aeb-a9321934f920\";s:5:\"style\";a:6:{s:18:\"background_display\";s:4:\"tile\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"title_color\";s:7:\"#443f3f\";s:14:\"headings_color\";s:7:\"#443f3f\";}}}}s:5:\"grids\";a:1:{i:0;a:2:{s:5:\"cells\";i:1;s:5:\"style\";a:8:{s:10:\"background\";s:7:\"#ffffff\";s:11:\"row_stretch\";s:4:\"full\";s:14:\"cell_alignment\";s:10:\"flex-start\";s:17:\"iw-visible-screen\";s:6:\"iw-all\";s:17:\"iw-visible-layout\";s:6:\"iw-all\";s:5:\"align\";b:1;s:7:\"overlay\";s:0:\"\";s:13:\"overlay_color\";s:7:\"#000000\";}}}s:10:\"grid_cells\";a:1:{i:0;a:4:{s:4:\"grid\";i:0;s:5:\"index\";i:0;s:6:\"weight\";i:1;s:5:\"style\";a:0:{}}}}");

/* INSERT TABLE DATA: act_posts */
INSERT INTO `act_posts` VALUES("1", "1", "2017-05-30 21:16:38", "2017-05-30 21:16:38", "Welcome to WordPress. This is your first post. Edit or delete it, then start writing!", "Hello world!", "", "publish", "open", "open", "", "hello-world", "", "", "2017-05-30 21:16:38", "2017-05-30 21:16:38", "", "0", "http://localhost/actfinal/?p=1", "0", "post", "", "1");
INSERT INTO `act_posts` VALUES("2", "1", "2017-05-30 21:16:38", "2017-05-30 21:16:38", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://localhost/actfinal/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "trash", "closed", "open", "", "sample-page__trashed", "", "", "2017-05-31 01:41:06", "2017-05-30 21:41:06", "", "0", "http://localhost/actfinal/?page_id=2", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("5", "1", "2017-05-30 21:25:05", "2017-05-30 21:25:05", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "publish", "closed", "closed", "", "home", "", "", "2017-06-14 14:30:08", "2017-06-14 10:30:08", "", "0", "http://localhost/actfinal/?page_id=5", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("6", "1", "2017-05-30 21:25:05", "2017-05-30 21:25:05", "", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-05-30 21:25:05", "2017-05-30 21:25:05", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("7", "1", "2017-05-30 21:25:28", "2017-05-30 21:25:28", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#2d2d2d&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n<p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "publish", "closed", "closed", "", "about-us", "", "", "2017-06-14 18:18:14", "2017-06-14 14:18:14", "", "0", "http://localhost/actfinal/?page_id=7", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("8", "1", "2017-05-30 21:25:28", "2017-05-30 21:25:28", "", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-05-30 21:25:28", "2017-05-30 21:25:28", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("9", "1", "2017-05-30 21:25:49", "2017-05-30 21:25:49", "[ea_bootstrap width=\"800px\" scroll_off=\"true\" layout_cols=\"2\"]", "Online Booking", "", "publish", "closed", "closed", "", "online-booking", "", "", "2017-06-15 15:24:07", "2017-06-15 11:24:07", "", "0", "http://localhost/actfinal/?page_id=9", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("10", "1", "2017-05-30 21:25:49", "2017-05-30 21:25:49", "", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-05-30 21:25:49", "2017-05-30 21:25:49", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("11", "1", "2017-05-30 21:26:08", "2017-05-30 21:26:08", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "publish", "closed", "closed", "", "contact-us", "", "", "2017-06-15 14:23:33", "2017-06-15 10:23:33", "", "0", "http://localhost/actfinal/?page_id=11", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("12", "1", "2017-05-30 21:26:08", "2017-05-30 21:26:08", "", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-05-30 21:26:08", "2017-05-30 21:26:08", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("19", "1", "2017-05-31 01:41:06", "2017-05-30 21:41:06", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://localhost/actfinal/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2017-05-31 01:41:06", "2017-05-30 21:41:06", "", "2", "http://localhost/actfinal/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("22", "1", "2017-05-31 10:58:33", "2017-05-31 06:58:33", "{\n    \"business-club::theme_options[global_layout]\": {\n        \"value\": \"no-sidebar\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "77e1232b-0fa9-44a4-bda2-5192fb3d58fc", "", "", "2017-05-31 10:58:33", "2017-05-31 06:58:33", "", "0", "http://localhost/actfinal/77e1232b-0fa9-44a4-bda2-5192fb3d58fc/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("23", "1", "2017-05-31 10:59:17", "2017-05-31 06:59:17", "{\n    \"business-club::theme_options[featured_slider_status]\": {\n        \"value\": \"home-page\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club::theme_options[featured_slider_number]\": {\n        \"value\": \"5\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "346a276e-c74b-4236-a23c-7794befa1930", "", "", "2017-05-31 10:59:17", "2017-05-31 06:59:17", "", "0", "http://localhost/actfinal/?p=23", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("24", "1", "2017-06-02 02:04:34", "2017-06-01 22:04:34", " ", "", "", "publish", "closed", "closed", "", "24", "", "", "2017-06-15 12:36:41", "2017-06-15 08:36:41", "", "0", "http://localhost/actfinal/?p=24", "4", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("25", "1", "2017-06-02 02:04:34", "2017-06-01 22:04:34", " ", "", "", "publish", "closed", "closed", "", "25", "", "", "2017-06-15 12:36:41", "2017-06-15 08:36:41", "", "0", "http://localhost/actfinal/?p=25", "3", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("26", "1", "2017-06-02 02:04:33", "2017-06-01 22:04:33", " ", "", "", "publish", "closed", "closed", "", "26", "", "", "2017-06-15 12:36:41", "2017-06-15 08:36:41", "", "0", "http://localhost/actfinal/?p=26", "2", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("27", "1", "2017-06-02 02:04:33", "2017-06-01 22:04:33", " ", "", "", "publish", "closed", "closed", "", "27", "", "", "2017-06-15 12:36:41", "2017-06-15 08:36:41", "", "0", "http://localhost/actfinal/?p=27", "1", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("28", "1", "2017-06-02 02:05:01", "2017-06-01 22:05:01", " ", "", "", "publish", "closed", "closed", "", "28", "", "", "2017-06-12 11:29:59", "2017-06-12 07:29:59", "", "0", "http://localhost/actfinal/?p=28", "4", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("29", "1", "2017-06-02 02:05:01", "2017-06-01 22:05:01", " ", "", "", "publish", "closed", "closed", "", "29", "", "", "2017-06-12 11:29:59", "2017-06-12 07:29:59", "", "0", "http://localhost/actfinal/?p=29", "3", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("30", "1", "2017-06-02 02:05:01", "2017-06-01 22:05:01", " ", "", "", "publish", "closed", "closed", "", "30", "", "", "2017-06-12 11:29:59", "2017-06-12 07:29:59", "", "0", "http://localhost/actfinal/?p=30", "2", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("31", "1", "2017-06-02 02:05:01", "2017-06-01 22:05:01", " ", "", "", "publish", "closed", "closed", "", "31", "", "", "2017-06-12 11:29:59", "2017-06-12 07:29:59", "", "0", "http://localhost/actfinal/?p=31", "1", "nav_menu_item", "", "0");
INSERT INTO `act_posts` VALUES("32", "1", "2017-06-02 02:05:51", "2017-06-01 22:05:51", "{\n    \"blogdescription\": {\n        \"value\": \"Your Comfort is our pride!\",\n        \"type\": \"option\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "843510f4-8341-42be-aa2d-3f35a26947ac", "", "", "2017-06-02 02:05:51", "2017-06-01 22:05:51", "", "0", "http://localhost/actfinal/843510f4-8341-42be-aa2d-3f35a26947ac/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("34", "1", "2017-06-02 02:07:48", "2017-06-01 22:07:48", "{\n    \"business-club-child::background_image\": {\n        \"value\": \"\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::background_position_x\": {\n        \"value\": \"center\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::background_position_y\": {\n        \"value\": \"center\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::theme_options[contact_number]\": {\n        \"value\": \"+254797 119 418 ,  +254789 122 834\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::theme_options[contact_email]\": {\n        \"value\": \"Bookings@absolutecomfort.co.ke\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "438fb1d3-628e-4288-896e-3a148658a20f", "", "", "2017-06-02 02:07:48", "2017-06-01 22:07:48", "", "0", "http://localhost/actfinal/?p=34", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("35", "1", "2017-06-02 02:08:34", "2017-06-01 22:08:34", "{\n    \"business-club-child::theme_options[global_layout]\": {\n        \"value\": \"three-columns\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "19d60f97-f1be-4cc5-bc39-d90f48f4535e", "", "", "2017-06-02 02:08:34", "2017-06-01 22:08:34", "", "0", "http://localhost/actfinal/19d60f97-f1be-4cc5-bc39-d90f48f4535e/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("36", "1", "2017-06-02 02:21:31", "2017-06-01 22:21:31", "{\n    \"business-club-child::theme_options[featured_slider_status]\": {\n        \"value\": \"home-page\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "fbc07280-c762-466d-9793-953e20230290", "", "", "2017-06-02 02:21:31", "2017-06-01 22:21:31", "", "0", "http://localhost/actfinal/fbc07280-c762-466d-9793-953e20230290/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("40", "1", "2017-06-02 02:30:12", "2017-06-01 22:30:12", "{\n    \"business-club-child::theme_options[featured_slider_page_1]\": {\n        \"value\": \"5\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::theme_options[featured_slider_page_2]\": {\n        \"value\": \"7\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::theme_options[featured_slider_page_3]\": {\n        \"value\": \"9\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-club-child::theme_options[featured_slider_read_more_text]\": {\n        \"value\": \"\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "0be1f873-f22f-474e-b28e-319f61071575", "", "", "2017-06-02 02:30:12", "2017-06-01 22:30:12", "", "0", "http://localhost/actfinal/0be1f873-f22f-474e-b28e-319f61071575/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("41", "1", "2017-06-02 02:32:55", "2017-06-01 22:32:55", "{\n    \"business-club-child::theme_options[global_layout]\": {\n        \"value\": \"no-sidebar\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "7f4e665f-775d-4e69-a9cc-8fa0726507db", "", "", "2017-06-02 02:32:55", "2017-06-01 22:32:55", "", "0", "http://localhost/actfinal/7f4e665f-775d-4e69-a9cc-8fa0726507db/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("42", "1", "2017-06-02 02:51:27", "2017-06-01 22:51:27", "Most of our vehicles are new and are kept in immaculate condition", "Superior Service", "", "trash", "closed", "closed", "", "superior-service__trashed", "", "", "2017-06-14 18:39:50", "2017-06-14 14:39:50", "", "0", "http://localhost/actfinal/?page_id=42", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("43", "1", "2017-06-02 02:51:27", "2017-06-01 22:51:27", "", "Superior Service", "", "inherit", "closed", "closed", "", "42-revision-v1", "", "", "2017-06-02 02:51:27", "2017-06-01 22:51:27", "", "42", "http://localhost/actfinal/42-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("44", "1", "2017-06-02 02:52:26", "2017-06-01 22:52:26", "", "Excellent Customer Service", "", "trash", "closed", "closed", "", "excellent-customer-service__trashed", "", "", "2017-06-14 18:39:50", "2017-06-14 14:39:50", "", "0", "http://localhost/actfinal/?page_id=44", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("45", "1", "2017-06-02 02:52:26", "2017-06-01 22:52:26", "", "Excellent Customer Service", "", "inherit", "closed", "closed", "", "44-revision-v1", "", "", "2017-06-02 02:52:26", "2017-06-01 22:52:26", "", "44", "http://localhost/actfinal/44-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("46", "1", "2017-06-02 02:53:34", "2017-06-01 22:53:34", "", "We operate 24/7", "", "trash", "closed", "closed", "", "we-operate-247__trashed", "", "", "2017-06-14 18:39:50", "2017-06-14 14:39:50", "", "0", "http://localhost/actfinal/?page_id=46", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("47", "1", "2017-06-02 02:53:34", "2017-06-01 22:53:34", "", "We operate 24/7", "", "inherit", "closed", "closed", "", "46-revision-v1", "", "", "2017-06-02 02:53:34", "2017-06-01 22:53:34", "", "46", "http://localhost/actfinal/46-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("48", "1", "2017-06-02 02:54:28", "2017-06-01 22:54:28", "{\n    \"thecompany-child::home_slider_page_one\": {\n        \"value\": \"42\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::home_slider_page_two\": {\n        \"value\": \"44\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::home_slider_page_three\": {\n        \"value\": \"46\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::slider_read_more\": {\n        \"value\": \"\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "e46b6bdd-a328-4bc2-8065-ef0c66f72067", "", "", "2017-06-02 02:54:28", "2017-06-01 22:54:28", "", "0", "http://localhost/actfinal/e46b6bdd-a328-4bc2-8065-ef0c66f72067/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("49", "1", "2017-06-02 02:56:09", "2017-06-01 22:56:09", "{\n    \"thecompany-child::header_textcolor\": {\n        \"value\": \"#81d742\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "b1c199dc-79fe-4025-91b2-5a000206f395", "", "", "2017-06-02 02:56:09", "2017-06-01 22:56:09", "", "0", "http://localhost/actfinal/b1c199dc-79fe-4025-91b2-5a000206f395/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("51", "1", "2017-06-02 03:39:53", "2017-06-01 23:39:53", "{\n    \"thecompany-child::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n            \"timestamp\": 1496360387581,\n            \"attachment_id\": 50,\n            \"width\": 1920,\n            \"height\": 500\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "e496a26e-96ac-451b-9d0b-313e3317c565", "", "", "2017-06-02 03:39:53", "2017-06-01 23:39:53", "", "0", "http://localhost/actfinal/e496a26e-96ac-451b-9d0b-313e3317c565/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("52", "1", "2017-06-02 03:41:14", "2017-06-01 23:41:14", "{\n    \"thecompany-child::thecompany_whychooseus_section_page1\": {\n        \"value\": \"7\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::thecompany_whychooseus_section_page2\": {\n        \"value\": \"44\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::thecompany_whychooseus_section_page3\": {\n        \"value\": \"9\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"thecompany-child::thecompany_whychooseus_section_page4\": {\n        \"value\": \"46\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "04cd1d53-c08d-4bf2-b102-e9863560590a", "", "", "2017-06-02 03:41:14", "2017-06-01 23:41:14", "", "0", "http://localhost/actfinal/04cd1d53-c08d-4bf2-b102-e9863560590a/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("55", "1", "2017-06-02 03:50:37", "2017-06-01 23:50:37", "{\n    \"company-elite::theme_options[featured_slider_status]\": {\n        \"value\": \"home-page\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"company-elite::theme_options[featured_slider_number]\": {\n        \"value\": \"4\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "cf5442d5-a7b9-44e6-9e43-b35474dfc9c0", "", "", "2017-06-02 03:50:37", "2017-06-01 23:50:37", "", "0", "http://localhost/actfinal/?p=55", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("59", "1", "2017-06-07 02:17:04", "2017-06-06 22:17:04", "", "logo absolute comfort", "", "inherit", "open", "closed", "", "logo-absolute-comfort", "", "", "2017-06-10 03:20:00", "2017-06-09 23:20:00", "", "5", "http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png", "0", "attachment", "image/png", "0");
INSERT INTO `act_posts` VALUES("60", "1", "2017-06-07 02:17:26", "2017-06-06 22:17:26", "{\n    \"business-eye::header_text\": {\n        \"value\": false,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::custom_logo\": {\n        \"value\": 59,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "6d6d0dfa-5167-4fd5-952e-58e5b775261c", "", "", "2017-06-07 02:17:26", "2017-06-06 22:17:26", "", "0", "http://localhost/actfinal/6d6d0dfa-5167-4fd5-952e-58e5b775261c/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("61", "1", "2017-06-07 02:18:37", "2017-06-06 22:18:37", "{\n    \"business-eye::business-eye-options[business-eye-feature-slider-enable]\": {\n        \"value\": true,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::business-eye-options[business-eye-fs-enable-arrow]\": {\n        \"value\": true,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::business-eye-options[business-eye-fs-pages-ids_1]\": {\n        \"value\": \"7\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::business-eye-options[business-eye-fs-pages-ids_2]\": {\n        \"value\": \"44\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::business-eye-options[business-eye-fs-pages-ids_3]\": {\n        \"value\": \"9\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "b1654eb2-a603-4e5f-8baf-adf4276c27de", "", "", "2017-06-07 02:18:37", "2017-06-06 22:18:37", "", "0", "http://localhost/actfinal/b1654eb2-a603-4e5f-8baf-adf4276c27de/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("62", "1", "2017-06-07 02:19:31", "2017-06-06 22:19:31", "{\n    \"business-eye::business-eye-options[business-eye-default-layout]\": {\n        \"value\": \"no-sidebar\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"business-eye::business-eye-options[business-eye-about-pages-ids_1]\": {\n        \"value\": \"7\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "8bb21ce9-736a-4e18-a677-e1766d959def", "", "", "2017-06-07 02:19:31", "2017-06-06 22:19:31", "", "0", "http://localhost/actfinal/8bb21ce9-736a-4e18-a677-e1766d959def/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("63", "1", "2017-06-07 02:33:39", "2017-06-06 22:33:39", "{\n    \"codepress-corporate::custom_logo\": {\n        \"value\": 59,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "5069abf9-795c-41ef-b09a-f52641faf2a1", "", "", "2017-06-07 02:33:39", "2017-06-06 22:33:39", "", "0", "http://localhost/actfinal/5069abf9-795c-41ef-b09a-f52641faf2a1/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("64", "1", "2017-06-07 02:34:18", "2017-06-06 22:34:18", "{\n    \"codepress-corporate::codepress_corporate_logo_optipn\": {\n        \"value\": \"header_logo_only\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "2bd7fc27-fd0f-4c61-98ab-201f9e16830a", "", "", "2017-06-07 02:34:18", "2017-06-06 22:34:18", "", "0", "http://localhost/actfinal/2bd7fc27-fd0f-4c61-98ab-201f9e16830a/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("66", "1", "2017-06-08 00:23:50", "2017-06-07 20:23:50", "", "cropped-logo-absolute-comfort.png", "", "inherit", "open", "closed", "", "cropped-logo-absolute-comfort-png", "", "", "2017-06-08 00:23:50", "2017-06-07 20:23:50", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort.png", "0", "attachment", "image/png", "0");
INSERT INTO `act_posts` VALUES("67", "1", "2017-06-08 00:36:44", "2017-06-07 20:36:44", "", "cropped-logo-absolute-comfort-1.png", "", "inherit", "closed", "closed", "", "logo-absolute-comfort-1-png", "", "", "2017-06-08 00:36:44", "2017-06-07 20:36:44", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `act_posts` VALUES("68", "1", "2017-06-08 00:50:22", "2017-06-07 20:50:22", "Most of our vehicles are new and are kpt in immaculate condition", "Superior Service", "", "inherit", "closed", "closed", "", "42-autosave-v1", "", "", "2017-06-08 00:50:22", "2017-06-07 20:50:22", "", "42", "http://localhost/actfinal/42-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("69", "1", "2017-06-08 00:53:29", "2017-06-07 20:53:29", "Most of our vehicles are new and are kept in immaculate condition", "Superior Service", "", "inherit", "closed", "closed", "", "42-revision-v1", "", "", "2017-06-08 00:53:29", "2017-06-07 20:53:29", "", "42", "http://localhost/actfinal/42-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("70", "1", "2017-06-08 00:56:34", "0000-00-00 00:00:00", "{\n    \"old_sidebars_widgets_data\": {\n        \"value\": {\n            \"wp_inactive_widgets\": [],\n            \"apbasic_right_sidebar\": [\n                \"search-2\",\n                \"recent-posts-2\",\n                \"recent-comments-2\",\n                \"archives-2\",\n                \"categories-2\",\n                \"meta-2\"\n            ],\n            \"apbasic_left_sidebar\": [],\n            \"apbasic_featured_section\": [],\n            \"apbasic_cta_section\": [],\n            \"icon_text_block_section\": [],\n            \"apbasic_toggle_section\": [],\n            \"apbasic_featured_page_section\": [],\n            \"apbasic_testimonial_section\": [],\n            \"apbasic_services_section\": [],\n            \"apbasic_header_text\": [],\n            \"apbasic_header_social_links\": [],\n            \"apbasic_footer_social_links\": [],\n            \"apbasic_footer_one\": [],\n            \"apbasic_footer_two\": [],\n            \"apbasic_footer_three\": [],\n            \"apbasic_footer_four\": []\n        },\n        \"type\": \"global_variable\",\n        \"user_id\": 1\n    }\n}", "", "", "auto-draft", "closed", "closed", "", "12b2d35e-91e7-4ac7-b9c2-61455202005c", "", "", "2017-06-08 00:56:34", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?p=70", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("73", "1", "2017-06-08 01:05:14", "2017-06-07 21:05:14", "{\n    \"catch-everest::custom_logo\": {\n        \"value\": 59,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"catch-everest::header_textcolor\": {\n        \"value\": \"blank\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "2d3ff413-0be5-4d4c-96d0-598212c58ec2", "", "", "2017-06-08 01:05:14", "2017-06-07 21:05:14", "", "0", "http://localhost/actfinal/2d3ff413-0be5-4d4c-96d0-598212c58ec2/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("74", "1", "2017-06-08 01:08:51", "2017-06-07 21:08:51", "{\n    \"catcheverest_options[disable_header_right_sidebar]\": {\n        \"value\": \"0\",\n        \"type\": \"option\",\n        \"user_id\": 1\n    },\n    \"catcheverest_options[sidebar_layout]\": {\n        \"value\": \"no-sidebar-full-width\",\n        \"type\": \"option\",\n        \"user_id\": 1\n    },\n    \"catch-everest::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"catch-everest::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n            \"timestamp\": 1496869716270,\n            \"attachment_id\": 50,\n            \"width\": 1920,\n            \"height\": 500\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "a0042fa8-ae92-4c83-a0a1-808f97c3c920", "", "", "2017-06-08 01:08:51", "2017-06-07 21:08:51", "", "0", "http://localhost/actfinal/?p=74", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("75", "1", "2017-06-08 02:17:48", "2017-06-07 22:17:48", "{\n    \"codepress-corporate-child::codepress_corporate_social_link_activate\": {\n        \"value\": false,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::codepress_corporate_top_contact_number\": {\n        \"value\": \"+254797 119 418, +254789 122 834\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::codepress_corporate_top_email\": {\n        \"value\": \"Bookings@absolutecomfort.co.ke\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "6d1f0771-6742-4207-a482-2108eb7680c1", "", "", "2017-06-08 02:17:48", "2017-06-07 22:17:48", "", "0", "http://localhost/actfinal/?p=75", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("76", "1", "2017-06-08 02:19:40", "2017-06-07 22:19:40", "{\n    \"codepress-corporate-child::codepress_corporate_archive_banner_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::codepress_corporate_page_banner_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::custom_logo\": {\n        \"value\": 67,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::codepress_corporate_logo_optipn\": {\n        \"value\": \"header_logo_only\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"codepress-corporate-child::codepress_corporate_activate_page_comment\": {\n        \"value\": false,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "22626ddd-eddc-4606-8e07-a60484bad8bc", "", "", "2017-06-08 02:19:40", "2017-06-07 22:19:40", "", "0", "http://localhost/actfinal/?p=76", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("77", "1", "2017-06-08 02:40:03", "2017-06-07 22:40:03", "Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment", "Superior Service", "", "publish", "open", "open", "", "superior-service", "", "", "2017-06-08 02:40:03", "2017-06-07 22:40:03", "", "0", "http://localhost/actfinal/?p=77", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("78", "1", "2017-06-08 02:40:03", "2017-06-07 22:40:03", "Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment", "Superior Service", "", "inherit", "closed", "closed", "", "77-revision-v1", "", "", "2017-06-08 02:40:03", "2017-06-07 22:40:03", "", "77", "http://localhost/actfinal/77-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("79", "1", "2017-06-08 02:41:01", "2017-06-07 22:41:01", "We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged", "Excellent customer service", "", "publish", "open", "open", "", "excellent-customer-service", "", "", "2017-06-08 02:41:01", "2017-06-07 22:41:01", "", "0", "http://localhost/actfinal/?p=79", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("80", "1", "2017-06-08 02:41:01", "2017-06-07 22:41:01", "We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged", "Excellent customer service", "", "inherit", "closed", "closed", "", "79-revision-v1", "", "", "2017-06-08 02:41:01", "2017-06-07 22:41:01", "", "79", "http://localhost/actfinal/79-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("81", "1", "2017-06-08 02:42:42", "2017-06-07 22:42:42", "Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too", "Available around the clock", "", "publish", "open", "open", "", "available-around-clock", "", "", "2017-06-08 02:42:42", "2017-06-07 22:42:42", "", "0", "http://localhost/actfinal/?p=81", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("82", "1", "2017-06-08 02:42:42", "2017-06-07 22:42:42", "Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too", "Available around the clock", "", "inherit", "closed", "closed", "", "81-revision-v1", "", "", "2017-06-08 02:42:42", "2017-06-07 22:42:42", "", "81", "http://localhost/actfinal/81-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("83", "1", "2017-06-08 02:42:58", "2017-06-07 22:42:58", "{\n    \"codepress_corporate_slider_category_setting\": {\n        \"value\": \"4\",\n        \"type\": \"option\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "4ba85887-4cb0-46ef-871b-3dd77c3f53f4", "", "", "2017-06-08 02:42:58", "2017-06-07 22:42:58", "", "0", "http://localhost/actfinal/4ba85887-4cb0-46ef-871b-3dd77c3f53f4/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("84", "1", "2017-06-08 02:43:18", "2017-06-07 22:43:18", "{\n    \"codepress-corporate-child::codepress_corporate_logo_optipn\": {\n        \"value\": \"show_both\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "37eed886-2ff4-474e-9416-e476a67d6b1b", "", "", "2017-06-08 02:43:18", "2017-06-07 22:43:18", "", "0", "http://localhost/actfinal/37eed886-2ff4-474e-9416-e476a67d6b1b/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("85", "1", "2017-06-08 03:02:27", "0000-00-00 00:00:00", "{\n    \"eleganto::home_layout\": {\n        \"value\": \"a:1:{i:0;s:12:\\\"blog_section\\\";}\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"eleganto::repeater_slider\": {\n        \"value\": \"%5B%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"eleganto::repeater_carousel\": {\n        \"value\": \"%5B%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"eleganto::repeater_testimonial\": {\n        \"value\": \"%5B%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "auto-draft", "closed", "closed", "", "d5db1b8a-0e59-4f49-9b1b-f8ee1ccc7491", "", "", "2017-06-08 03:02:27", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?p=85", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("86", "1", "2017-06-08 03:12:07", "2017-06-07 23:12:07", "<div id=\"overlapable-2\" class=\"features-coloured-icon-boxes-section\" style=\"background-color: #ffffff;\" data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" data-overlap=\"true\">\r\n<div class=\"gridContainer\">\r\n<div class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\">\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"about-1\" class=\"about-big-images-section\" style=\"background-color: #f6f6f6;\" data-label=\"About\" data-id=\"about-big-images-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"about-big-images-textrow\">\r\n<div class=\"about-big-images-textcol\" data-type=\"column\">\r\n<h5 class=\"\">LOREM IPSUM DOLOR</h5>\r\n<h3 class=\"\">Brand new WordPress theme <span class=\"span25\">with unlimited power</span> and customization possibilities</h3>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p>\r\n<a class=\"button blue big\" href=\"#\">GET STARTED NOW</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"about-big-images-bottomrow\">\r\n<div class=\"about-big-images-leftimgcol\"><img class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\" /></div>\r\n<div class=\"about-big-images-centerimgcol\"><img class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\" /></div>\r\n<div class=\"about-big-images-rightimgcol\"><img class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n<div id=\"content-3\" class=\"content-left-image-section\" style=\"background-color: #ffffff;\" data-label=\"Content\" data-id=\"content-image-left\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row\">\r\n<div class=\"content-left-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n<div class=\"content-left-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n<a class=\"button blue\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"content-4\" class=\"content-right-image-section\" style=\"background-color: #f6f6f6;\" data-label=\"Content\" data-id=\"content-image-right\">\r\n<div class=\"gridContainer\">\r\n<div class=\"content-right-image-gridcol\">\r\n<div class=\"content-right-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n<a class=\"button blue\" href=\"#\">Learn More</a>\r\n\r\n</div>\r\n<div class=\"content-right-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"cta-1\" class=\"cta-blue-section\" data-label=\"Call to action\" data-id=\"cta-blue-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"cta-blue-innerrow\">\r\n<div class=\"cta-blue-textcol\">\r\n<h2 class=\"cta-blue-text\"><b class=\"element2\">Join us.</b>It will only take a minute</h2>\r\n</div>\r\n<div class=\"cta-blue-btncol\"><a class=\"button transparent\" href=\"#\">GET STARTED</a></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"contact-2\" class=\"contact-section-formsection white-text\" data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row_224\">\r\n<div class=\"contact-textrow\">\r\n<div class=\"contact-textcol\">\r\n<h2 class=\"\">Say Hello</h2>\r\n<p class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\">[one_page_express_contact_form]</div>\r\n</div>\r\n</div>", "Front Page", "", "trash", "closed", "closed", "", "one-page-express__trashed", "", "", "2017-06-09 14:11:31", "2017-06-09 10:11:31", "", "0", "http://localhost/actfinal/one-page-express/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("87", "1", "2017-06-08 03:12:07", "2017-06-07 23:12:07", "", "Blog", "", "publish", "closed", "closed", "", "blog", "", "", "2017-06-08 03:12:07", "2017-06-07 23:12:07", "", "0", "http://localhost/actfinal/blog/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("88", "1", "2017-06-08 03:14:57", "2017-06-07 23:14:57", "{\n    \"one-page-express::one_page_express_header_background_type\": {\n        \"value\": \"slideshow\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::one_page_express_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:%2239%22%7D,%7B%22url%22:%2237%22%7D,%7B%22url%22:%2233%22%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::one_page_express_inner_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/home_page_header.jpg%22%7D,%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/jeremy-bishop-14593.jpg%22%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::page_content\": {\n        \"value\": \"<!--@@CPPAGEID[86]@@--><div  id=\\\"overlapable-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Overlapable\\\" data-id=\\\"stripped-coloured-icon-boxes\\\" class=\\\"features-coloured-icon-boxes-section\\\" data-overlap=\\\"true\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"features-coloured-icon-boxes-innerrow\\\" data-type=\\\"row\\\"><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-bolt\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-cloud\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-signal\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-pie-chart\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"about-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"About\\\" data-id=\\\"about-big-images-section\\\" class=\\\"about-big-images-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"about-big-images-textrow\\\"><div  class=\\\"about-big-images-textcol\\\" data-type=\\\"column\\\"><h5  class=\\\"\\\">LOREM IPSUM DOLOR</h5><h3  class=\\\"\\\">Brand new WordPress theme&nbsp;<span  href=\\\"#\\\" class=\\\"span25\\\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\\\"button blue big\\\" href=\\\"#\\\">GET STARTED NOW</a></div></div></div><div  class=\\\"about-big-images-bottomrow\\\"><div  class=\\\"about-big-images-leftimgcol\\\"><img  class=\\\"about-big-images-leftimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\\\"></div><div  class=\\\"about-big-images-centerimgcol\\\"><img  class=\\\"about-big-images-centerimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\\\"></div><div  class=\\\"about-big-images-rightimgcol\\\"><img  class=\\\"about-big-images-rightimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div></div></div><div  id=\\\"content-3\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-left\\\" class=\\\"content-left-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row\\\"><div  class=\\\"content-left-image-imgcol\\\" data-type=\\\"column\\\"><img  src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div><div  class=\\\"content-left-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"content-4\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-right\\\" class=\\\"content-right-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"content-right-image-gridcol\\\"><div  class=\\\"content-right-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">Learn More</a></div><div  class=\\\"content-right-image-imgcol\\\" data-type=\\\"column\\\"><img  reiki_companion_plugin=\\\"\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div></div></div></div><div  id=\\\"portfolio-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Portfolio\\\" data-id=\\\"portfolio-full-section\\\"><div  class=\\\"portfolio-full-section\\\" data-type=\\\"row\\\"><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">Check it out</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div></div></div><div  id=\\\"testimonials-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Testimonials\\\" data-id=\\\"testimonials-boxed-section\\\" class=\\\"testimonials-boxed-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"testimonials-boxed-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">What Our Clients Say</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p></div><div  class=\\\"testimonials-boxed-itemsrow\\\" data-type=\\\"row\\\"><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Anna Johnson</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Eric Black</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">John Collins</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div></div></div></div><div  id=\\\"cta-1\\\" data-label=\\\"Call to action\\\" data-id=\\\"cta-blue-section\\\" class=\\\"cta-blue-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"cta-blue-innerrow\\\"><div  class=\\\"cta-blue-textcol\\\"><h2  class=\\\"cta-blue-text\\\"><b  class=\\\"element2\\\">Join us.</b>It will only take a minute</h2></div><div  class=\\\"cta-blue-btncol\\\"><a  class=\\\"button transparent\\\" href=\\\"#\\\">GET STARTED</a></div></div></div></div><div  id=\\\"team-1\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Team\\\" data-id=\\\"team-colors-section\\\" class=\\\"team-colors-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"team-colors-textcol\\\"><h2 >Our Awesome Team</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p></div><div  class=\\\"team-colors-membersrow\\\" data-type=\\\"row\\\"><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\" height=\\\"175\\\"><h4  class=\\\"team-colors-membername\\\">Chip Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; CEO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Jane Brown</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; COO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Erika Black&nbsp;</h4><p  class=\\\"team-colors-memberposition\\\">Marketing Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h4  class=\\\"team-colors-membername\\\">George Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Creative Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div></div></div></div><div  id=\\\"numbers\\\" data-label=\\\"Numbers\\\" data-id=\\\"numbers-section\\\" data-bg=\\\"transparent\\\" class=\\\"numbers-section\\\" data-parallax-depth=\\\"20\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">230</h2><h3  class=\\\"numbers-titletext\\\">PROJECTS</h3></div><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">75340</h2><h3  class=\\\"numbers-titletext\\\">WORKED HOURS</h3></div><div  class=\\\"numbers-itemcol-last\\\"><h2  class=\\\"numbers-numbertext\\\">25</h2><h3  class=\\\"numbers-titletext\\\">EMPROYEES</h3></div></div></div><div  id=\\\"latest-posts\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Latest posts\\\" data-id=\\\"blog-section\\\" class=\\\"blog-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"blog-textrow\\\"><div  class=\\\"blog-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">Latest News</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p></div></div><div  class=\\\"blog-postsrow\\\" data-type=\\\"row\\\" data-dynamic-columns=\\\"one_page_express_latest_news_columns\\\" data-content-shortcode=\\\"one_page_express_latest_news\\\">[one_page_express_latest_news]</div><div  class=\\\"blog-textcol\\\"><a  class=\\\"button blue\\\" data-attr-shortcode=\\\"href:one_page_express_blog_link\\\" href=\\\"[one_page_express_blog_link]\\\" target=\\\"_self\\\">SEE ALL BLOG POSTS</a></div></div></div><div  id=\\\"contact-2\\\" data-label=\\\"Contact\\\" data-id=\\\"contact-section\\\" data-bg=\\\"transparent\\\" data-setting=\\\"one_page_express_contact_form_shortcode\\\" class=\\\"contact-section-formsection white-text\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row_224\\\"><div  class=\\\"contact-textrow\\\"><div  class=\\\"contact-textcol\\\"><h2  class=\\\"\\\">Say Hello</h2><p  class=\\\"white_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\\\"contact-formcol\\\" data-content-shortcode=\\\"one_page_express_contact_form\\\">[one_page_express_contact_form]</div></div></div>\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::one_page_express_header_overlay_opacity\": {\n        \"value\": \"0.4\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "8c29609f-7fe9-4d34-9330-a705aa44fc05", "", "", "2017-06-08 03:14:57", "2017-06-07 23:14:57", "", "0", "http://localhost/actfinal/?p=88", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("89", "1", "2017-06-08 03:14:57", "2017-06-07 23:14:57", "<div  id=\"overlapable-2\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" class=\"features-coloured-icon-boxes-section\" data-overlap=\"true\"><div  class=\"gridContainer\"><div  class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\"><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-bolt\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-cloud\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-signal\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-pie-chart\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div></div></div></div><div  id=\"about-1\" style=\"background-color:rgb(246, 246, 246)\" data-label=\"About\" data-id=\"about-big-images-section\" class=\"about-big-images-section\"><div  class=\"gridContainer\"><div  class=\"about-big-images-textrow\"><div  class=\"about-big-images-textcol\" data-type=\"column\"><h5  class=\"\">LOREM IPSUM DOLOR</h5><h3  class=\"\">Brand new WordPress theme&nbsp;<span  href=\"#\" class=\"span25\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\"button blue big\" href=\"#\">GET STARTED NOW</a></div></div></div><div  class=\"about-big-images-bottomrow\"><div  class=\"about-big-images-leftimgcol\"><img  class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\"></div><div  class=\"about-big-images-centerimgcol\"><img  class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\"></div><div  class=\"about-big-images-rightimgcol\"><img  class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"></div></div></div><div  id=\"content-3\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Content\" data-id=\"content-image-left\" class=\"content-left-image-section\"><div  class=\"gridContainer\"><div  class=\"row\"><div  class=\"content-left-image-imgcol\" data-type=\"column\"><img  src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" class=\"\"></div><div  class=\"content-left-image-textcol\" data-type=\"column\"><h2  class=\"\">This is one of the things<br >we do best&nbsp;</h2><p  class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\"button blue\" href=\"#\">LEARN MORE</a></div></div></div></div><div  id=\"content-4\" style=\"background-color:rgb(246, 246, 246)\" data-label=\"Content\" data-id=\"content-image-right\" class=\"content-right-image-section\"><div  class=\"gridContainer\"><div  class=\"content-right-image-gridcol\"><div  class=\"content-right-image-textcol\" data-type=\"column\"><h2  class=\"\">This is one of the things<br >we do best&nbsp;</h2><p  class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\"button blue\" href=\"#\">Learn More</a></div><div  class=\"content-right-image-imgcol\" data-type=\"column\"><img  reiki_companion_plugin=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" class=\"\"></div></div></div></div><div  id=\"portfolio-2\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Portfolio\" data-id=\"portfolio-full-section\"><div  class=\"portfolio-full-section\" data-type=\"row\"><div  class=\"portfolio-full-projectco cp4cols cp4cols-tablet\"><div  class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\"><div  class=\"ContentSwap103_content initial-image\"><img  class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\"></div><div  class=\"overlay\"></div><div  class=\"swap-inner\"><div  class=\"ContentSwap103-center\"><h4  class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a  class=\"button yellow\" href=\"#\">Check it out</a></div></div></div></div><div  class=\"portfolio-full-projectco cp4cols cp4cols-tablet\"><div  class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\" is-hovered=\"1\"><div  class=\"ContentSwap103_content initial-image\"><img  class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"></div><div  class=\"overlay\"></div><div  class=\"swap-inner\"><div  class=\"ContentSwap103-center\"><h4  class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a  class=\"button yellow\" href=\"#\">CHECK IT OUT</a></div></div></div></div><div  class=\"portfolio-full-projectco cp4cols cp4cols-tablet\"><div  class=\"contentswap-effect ContentSwap103\" hover-fx=\"ContentSwap103\" id=\"ContentSwap103\" is-hovered=\"1\"><div  class=\"ContentSwap103_content initial-image\"><img  class=\"portfolio-full-projectimg\" data-size=\"1200x800\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\"></div><div  class=\"overlay\"></div><div  class=\"swap-inner\"><div  class=\"ContentSwap103-center\"><h4  class=\"protfolio-full-itemtitle\">A COOL PROJECT</h4><a  class=\"button yellow\" href=\"#\">CHECK IT OUT</a></div></div></div></div></div></div><div  id=\"testimonials-1\" style=\"background-color:rgb(246, 246, 246)\" data-label=\"Testimonials\" data-id=\"testimonials-boxed-section\" class=\"testimonials-boxed-section\"><div  class=\"gridContainer\"><div  class=\"testimonials-boxed-textcol\" data-type=\"column\"><h2  class=\"\">What Our Clients Say</h2><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p></div><div  class=\"testimonials-boxed-itemsrow\" data-type=\"row\"><div  class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"><div  class=\"testimonials-boxed-itemcard\" data-type=\"column\"><h4  class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img  class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\"><h5  class=\"testimonials-boxed-itemname\">Anna Johnson</h5><h6  class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6></div></div><div  class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"><div  class=\"testimonials-boxed-itemcard\" data-type=\"column\"><h4  class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img  class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\"><h5  class=\"testimonials-boxed-itemname\">Eric Black</h5><h6  class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6></div></div><div  class=\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\"><div  class=\"testimonials-boxed-itemcard\" data-type=\"column\"><h4  class=\"testimonials-boxed-itemtext\">“Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.”</h4><img  class=\"testimonials-boxed-itemimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\"><h5  class=\"testimonials-boxed-itemname\">John Collins</h5><h6  class=\"testimonials-boxed-itempos\">CEO @ COOLAPP</h6></div></div></div></div></div><div  id=\"cta-1\" data-label=\"Call to action\" data-id=\"cta-blue-section\" class=\"cta-blue-section\"><div  class=\"gridContainer\"><div  class=\"cta-blue-innerrow\"><div  class=\"cta-blue-textcol\"><h2  class=\"cta-blue-text\"><b  class=\"element2\">Join us.</b>It will only take a minute</h2></div><div  class=\"cta-blue-btncol\"><a  class=\"button transparent\" href=\"#\">GET STARTED</a></div></div></div></div><div  id=\"team-1\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Team\" data-id=\"team-colors-section\" class=\"team-colors-section\"><div  class=\"gridContainer\"><div  class=\"team-colors-textcol\"><h2 >Our Awesome Team</h2><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p></div><div  class=\"team-colors-membersrow\" data-type=\"row\"><div  class=\"team-colors-membercol cp3cols cp6cols-tablet\"><div  class=\"team-colors-membercard\"><div  class=\"team-colors-background\"></div><div  class=\"team-colors-memberinfo\" data-type=\"column\"><img  class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\" height=\"175\"><h4  class=\"team-colors-membername\">Chip Mayer</h4><p  class=\"team-colors-memberposition\">Co-founder &amp; CEO</p><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\"team-colors-separator\"></div><div  class=\"team-colors-membericons\" data-type=\"group\"><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a></div></div></div><div  class=\"team-colors-membercol cp3cols cp6cols-tablet\"><div  class=\"team-colors-membercard\"><div  class=\"team-colors-background\"></div><div  class=\"team-colors-memberinfo\" data-type=\"column\"><img  class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\"><h4  class=\"team-colors-membername\">Jane Brown</h4><p  class=\"team-colors-memberposition\">Co-founder &amp; COO</p><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\"team-colors-separator\"></div><div  class=\"team-colors-membericons\" data-type=\"group\"><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a></div></div></div><div  class=\"team-colors-membercol cp3cols cp6cols-tablet\"><div  class=\"team-colors-membercard\"><div  class=\"team-colors-background\"></div><div  class=\"team-colors-memberinfo\" data-type=\"column\"><img  class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\"><h4  class=\"team-colors-membername\">Erika Black&nbsp;</h4><p  class=\"team-colors-memberposition\">Marketing Director</p><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\"team-colors-separator\"></div><div  class=\"team-colors-membericons\" data-type=\"group\"><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a></div></div></div><div  class=\"team-colors-membercol cp3cols cp6cols-tablet\"><div  class=\"team-colors-membercard\"><div  class=\"team-colors-background\"></div><div  class=\"team-colors-memberinfo\" data-type=\"column\"><img  class=\"team-colors-memberimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\"><h4  class=\"team-colors-membername\">George Mayer</h4><p  class=\"team-colors-memberposition\">Creative Director</p><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\"team-colors-separator\"></div><div  class=\"team-colors-membericons\" data-type=\"group\"><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"team-colors-icon fa fa-linkedin\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-twitter team-colors-icon\"></i></a><a  href=\"#\"><i  data-cp-fa=\"true\" class=\"fa fa-dribbble team-colors-icon\"></i></a></div></div></div></div></div></div><div  id=\"numbers\" data-label=\"Numbers\" data-id=\"numbers-section\" data-bg=\"transparent\" class=\"numbers-section\" data-parallax-depth=\"20\"><div  class=\"gridContainer\"><div  class=\"numbers-itemcol\"><h2  class=\"numbers-numbertext\">230</h2><h3  class=\"numbers-titletext\">PROJECTS</h3></div><div  class=\"numbers-itemcol\"><h2  class=\"numbers-numbertext\">75340</h2><h3  class=\"numbers-titletext\">WORKED HOURS</h3></div><div  class=\"numbers-itemcol-last\"><h2  class=\"numbers-numbertext\">25</h2><h3  class=\"numbers-titletext\">EMPROYEES</h3></div></div></div><div  id=\"latest-posts\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Latest posts\" data-id=\"blog-section\" class=\"blog-section\"><div  class=\"gridContainer\"><div  class=\"blog-textrow\"><div  class=\"blog-textcol\" data-type=\"column\"><h2  class=\"\">Latest News</h2><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p></div></div><div  class=\"blog-postsrow\" data-type=\"row\" data-dynamic-columns=\"one_page_express_latest_news_columns\" data-content-shortcode=\"one_page_express_latest_news\">[one_page_express_latest_news]</div><div  class=\"blog-textcol\"><a  class=\"button blue\" data-attr-shortcode=\"href:one_page_express_blog_link\" href=\"[one_page_express_blog_link]\" target=\"_self\">SEE ALL BLOG POSTS</a></div></div></div><div  id=\"contact-2\" data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\" class=\"contact-section-formsection white-text\"><div  class=\"gridContainer\"><div  class=\"row_224\"><div  class=\"contact-textrow\"><div  class=\"contact-textcol\"><h2  class=\"\">Say Hello</h2><p  class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\">[one_page_express_contact_form]</div></div></div>", "Front Page", "", "inherit", "closed", "closed", "", "86-revision-v1", "", "", "2017-06-08 03:14:57", "2017-06-07 23:14:57", "", "86", "http://localhost/actfinal/86-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("90", "1", "2017-06-08 03:15:02", "0000-00-00 00:00:00", "{\n    \"one-page-express::page_content\": {\n        \"value\": \"<!--@@CPPAGEID[86]@@--><div  id=\\\"overlapable-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Overlapable\\\" data-id=\\\"stripped-coloured-icon-boxes\\\" class=\\\"features-coloured-icon-boxes-section\\\" data-overlap=\\\"true\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"features-coloured-icon-boxes-innerrow\\\" data-type=\\\"row\\\"><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-bolt\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-cloud\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-signal\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-pie-chart\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"about-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"About\\\" data-id=\\\"about-big-images-section\\\" class=\\\"about-big-images-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"about-big-images-textrow\\\"><div  class=\\\"about-big-images-textcol\\\" data-type=\\\"column\\\"><h5  class=\\\"\\\">LOREM IPSUM DOLOR</h5><h3  class=\\\"\\\">Brand new WordPress theme&nbsp;<span  href=\\\"#\\\" class=\\\"span25\\\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\\\"button blue big\\\" href=\\\"#\\\">GET STARTED NOW</a></div></div></div><div  class=\\\"about-big-images-bottomrow\\\"><div  class=\\\"about-big-images-leftimgcol\\\"><img  class=\\\"about-big-images-leftimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\\\"></div><div  class=\\\"about-big-images-centerimgcol\\\"><img  class=\\\"about-big-images-centerimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\\\"></div><div  class=\\\"about-big-images-rightimgcol\\\"><img  class=\\\"about-big-images-rightimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div></div></div><div  id=\\\"content-3\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-left\\\" class=\\\"content-left-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row\\\"><div  class=\\\"content-left-image-imgcol\\\" data-type=\\\"column\\\"><img  src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div><div  class=\\\"content-left-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"content-4\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-right\\\" class=\\\"content-right-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"content-right-image-gridcol\\\"><div  class=\\\"content-right-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">Learn More</a></div><div  class=\\\"content-right-image-imgcol\\\" data-type=\\\"column\\\"><img  reiki_companion_plugin=\\\"\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div></div></div></div><div  id=\\\"portfolio-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Portfolio\\\" data-id=\\\"portfolio-full-section\\\"><div  class=\\\"portfolio-full-section\\\" data-type=\\\"row\\\"><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">Check it out</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div></div></div><div  id=\\\"testimonials-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Testimonials\\\" data-id=\\\"testimonials-boxed-section\\\" class=\\\"testimonials-boxed-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"testimonials-boxed-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">What Our Clients Say</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p></div><div  class=\\\"testimonials-boxed-itemsrow\\\" data-type=\\\"row\\\"><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Anna Johnson</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Eric Black</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">John Collins</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div></div></div></div><div  id=\\\"cta-1\\\" data-label=\\\"Call to action\\\" data-id=\\\"cta-blue-section\\\" class=\\\"cta-blue-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"cta-blue-innerrow\\\"><div  class=\\\"cta-blue-textcol\\\"><h2  class=\\\"cta-blue-text\\\"><b  class=\\\"element2\\\">Join us.</b>It will only take a minute</h2></div><div  class=\\\"cta-blue-btncol\\\"><a  class=\\\"button transparent\\\" href=\\\"#\\\">GET STARTED</a></div></div></div></div><div  id=\\\"team-1\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Team\\\" data-id=\\\"team-colors-section\\\" class=\\\"team-colors-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"team-colors-textcol\\\"><h2 >Our Awesome Team</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p></div><div  class=\\\"team-colors-membersrow\\\" data-type=\\\"row\\\"><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\" height=\\\"175\\\"><h4  class=\\\"team-colors-membername\\\">Chip Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; CEO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Jane Brown</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; COO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Erika Black&nbsp;</h4><p  class=\\\"team-colors-memberposition\\\">Marketing Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h4  class=\\\"team-colors-membername\\\">George Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Creative Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div></div></div></div><div  id=\\\"numbers\\\" data-label=\\\"Numbers\\\" data-id=\\\"numbers-section\\\" data-bg=\\\"transparent\\\" class=\\\"numbers-section\\\" data-parallax-depth=\\\"20\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">230</h2><h3  class=\\\"numbers-titletext\\\">PROJECTS</h3></div><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">75340</h2><h3  class=\\\"numbers-titletext\\\">WORKED HOURS</h3></div><div  class=\\\"numbers-itemcol-last\\\"><h2  class=\\\"numbers-numbertext\\\">25</h2><h3  class=\\\"numbers-titletext\\\">EMPROYEES</h3></div></div></div><div  id=\\\"latest-posts\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Latest posts\\\" data-id=\\\"blog-section\\\" class=\\\"blog-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"blog-textrow\\\"><div  class=\\\"blog-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">Latest News</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p></div></div><div  class=\\\"blog-postsrow\\\" data-type=\\\"row\\\" data-dynamic-columns=\\\"one_page_express_latest_news_columns\\\" data-content-shortcode=\\\"one_page_express_latest_news\\\">[one_page_express_latest_news]</div><div  class=\\\"blog-textcol\\\"><a  class=\\\"button blue\\\" data-attr-shortcode=\\\"href:one_page_express_blog_link\\\" href=\\\"[one_page_express_blog_link]\\\" target=\\\"_self\\\">SEE ALL BLOG POSTS</a></div></div></div><div  id=\\\"contact-2\\\" data-label=\\\"Contact\\\" data-id=\\\"contact-section\\\" data-bg=\\\"transparent\\\" data-setting=\\\"one_page_express_contact_form_shortcode\\\" class=\\\"contact-section-formsection white-text\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row_224\\\"><div  class=\\\"contact-textrow\\\"><div  class=\\\"contact-textcol\\\"><h2  class=\\\"\\\">Say Hello</h2><p  class=\\\"white_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\\\"contact-formcol\\\" data-content-shortcode=\\\"one_page_express_contact_form\\\">[one_page_express_contact_form]</div></div></div>\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "auto-draft", "closed", "closed", "", "f94b40bf-d161-4ea4-9f69-559177494bd0", "", "", "2017-06-08 03:15:02", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?p=90", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("91", "1", "2017-06-08 03:15:59", "2017-06-07 23:15:59", "[]", "", "", "trash", "closed", "closed", "", "8978fb15-699b-49bd-9352-1ae6dee946bd", "", "", "2017-06-08 03:15:59", "2017-06-07 23:15:59", "", "0", "http://localhost/actfinal/8978fb15-699b-49bd-9352-1ae6dee946bd/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("92", "1", "2017-06-08 03:16:00", "2017-06-07 23:16:00", "[]", "", "", "trash", "closed", "closed", "", "8978fb15-699b-49bd-9352-1ae6dee946bd-2", "", "", "2017-06-08 03:16:00", "2017-06-07 23:16:00", "", "0", "http://localhost/actfinal/8978fb15-699b-49bd-9352-1ae6dee946bd-2/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("93", "1", "2017-06-08 03:24:04", "0000-00-00 00:00:00", "{\n    \"one-page-express::one_page_express_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:39%7D,%7B%22url%22:37%7D,%7B%22url%22:33%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::one_page_express_inner_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/home_page_header.jpg%22%7D,%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/jeremy-bishop-14593.jpg%22%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::page_content\": {\n        \"value\": \"<!--@@CPPAGEID[86]@@--><div  id=\\\"overlapable-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Overlapable\\\" data-id=\\\"stripped-coloured-icon-boxes\\\" class=\\\"features-coloured-icon-boxes-section\\\" data-overlap=\\\"true\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"features-coloured-icon-boxes-innerrow\\\" data-type=\\\"row\\\" data-preview-empty=\\\"1\\\"></div></div></div><div  id=\\\"about-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"About\\\" data-id=\\\"about-big-images-section\\\" class=\\\"about-big-images-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"about-big-images-textrow\\\"><div  class=\\\"about-big-images-textcol\\\" data-type=\\\"column\\\"><h5  class=\\\"\\\">LOREM IPSUM DOLOR</h5><h3  class=\\\"\\\">Brand new WordPress theme&nbsp;<span  href=\\\"#\\\" class=\\\"span25\\\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\\\"button blue big\\\" href=\\\"#\\\">GET STARTED NOW</a></div></div></div><div  class=\\\"about-big-images-bottomrow\\\"><div  class=\\\"about-big-images-leftimgcol\\\"><img  class=\\\"about-big-images-leftimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\\\"></div><div  class=\\\"about-big-images-centerimgcol\\\"><img  class=\\\"about-big-images-centerimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\\\"></div><div  class=\\\"about-big-images-rightimgcol\\\"><img  class=\\\"about-big-images-rightimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div></div></div><div  id=\\\"content-3\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-left\\\" class=\\\"content-left-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row\\\"><div  class=\\\"content-left-image-imgcol\\\" data-type=\\\"column\\\"><img  src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div><div  class=\\\"content-left-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"content-4\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-right\\\" class=\\\"content-right-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"content-right-image-gridcol\\\"><div  class=\\\"content-right-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">Learn More</a></div><div  class=\\\"content-right-image-imgcol\\\" data-type=\\\"column\\\"><img  reiki_companion_plugin=\\\"\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div></div></div></div><div  id=\\\"portfolio-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Portfolio\\\" data-id=\\\"portfolio-full-section\\\"><div  class=\\\"portfolio-full-section\\\" data-type=\\\"row\\\"><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">Check it out</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div></div></div><div  id=\\\"testimonials-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Testimonials\\\" data-id=\\\"testimonials-boxed-section\\\" class=\\\"testimonials-boxed-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"testimonials-boxed-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">What Our Clients Say</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p></div><div  class=\\\"testimonials-boxed-itemsrow\\\" data-type=\\\"row\\\"><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Anna Johnson</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Eric Black</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">John Collins</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div></div></div></div><div  id=\\\"cta-1\\\" data-label=\\\"Call to action\\\" data-id=\\\"cta-blue-section\\\" class=\\\"cta-blue-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"cta-blue-innerrow\\\"><div  class=\\\"cta-blue-textcol\\\"><h2  class=\\\"cta-blue-text\\\"><b  class=\\\"element2\\\">Join us.</b>It will only take a minute</h2></div><div  class=\\\"cta-blue-btncol\\\"><a  class=\\\"button transparent\\\" href=\\\"#\\\">GET STARTED</a></div></div></div></div><div  id=\\\"team-1\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Team\\\" data-id=\\\"team-colors-section\\\" class=\\\"team-colors-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"team-colors-textcol\\\"><h2 >Our Awesome Team</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p></div><div  class=\\\"team-colors-membersrow\\\" data-type=\\\"row\\\"><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\" height=\\\"175\\\"><h4  class=\\\"team-colors-membername\\\">Chip Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; CEO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Jane Brown</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; COO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Erika Black&nbsp;</h4><p  class=\\\"team-colors-memberposition\\\">Marketing Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h4  class=\\\"team-colors-membername\\\">George Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Creative Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div></div></div></div><div  id=\\\"numbers\\\" data-label=\\\"Numbers\\\" data-id=\\\"numbers-section\\\" data-bg=\\\"transparent\\\" class=\\\"numbers-section\\\" data-parallax-depth=\\\"20\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">230</h2><h3  class=\\\"numbers-titletext\\\">PROJECTS</h3></div><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">75340</h2><h3  class=\\\"numbers-titletext\\\">WORKED HOURS</h3></div><div  class=\\\"numbers-itemcol-last\\\"><h2  class=\\\"numbers-numbertext\\\">25</h2><h3  class=\\\"numbers-titletext\\\">EMPROYEES</h3></div></div></div><div  id=\\\"latest-posts\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Latest posts\\\" data-id=\\\"blog-section\\\" class=\\\"blog-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"blog-textrow\\\"><div  class=\\\"blog-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">Latest News</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p></div></div><div  class=\\\"blog-postsrow\\\" data-type=\\\"row\\\" data-dynamic-columns=\\\"one_page_express_latest_news_columns\\\" data-content-shortcode=\\\"one_page_express_latest_news\\\">[one_page_express_latest_news]</div><div  class=\\\"blog-textcol\\\"><a  class=\\\"button blue\\\" data-attr-shortcode=\\\"href:one_page_express_blog_link\\\" href=\\\"[one_page_express_blog_link]\\\" target=\\\"_self\\\">SEE ALL BLOG POSTS</a></div></div></div><div  id=\\\"contact-2\\\" data-label=\\\"Contact\\\" data-id=\\\"contact-section\\\" data-bg=\\\"transparent\\\" data-setting=\\\"one_page_express_contact_form_shortcode\\\" class=\\\"contact-section-formsection white-text\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row_224\\\"><div  class=\\\"contact-textrow\\\"><div  class=\\\"contact-textcol\\\"><h2  class=\\\"\\\">Say Hello</h2><p  class=\\\"white_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\\\"contact-formcol\\\" data-content-shortcode=\\\"one_page_express_contact_form\\\">[one_page_express_contact_form]</div></div></div>\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "auto-draft", "closed", "closed", "", "0b1bbcb9-7a72-46c3-8927-a95f7231026a", "", "", "2017-06-08 03:24:04", "2017-06-07 23:24:04", "", "0", "http://localhost/actfinal/?p=93", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("94", "1", "2017-06-08 03:29:46", "2017-06-07 23:29:46", "{\n    \"one-page-express::one_page_express_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:39%7D,%7B%22url%22:37%7D,%7B%22url%22:33%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::one_page_express_inner_header_slideshow\": {\n        \"value\": \"%5B%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/home_page_header.jpg%22%7D,%7B%22url%22:%22http://localhost/actfinal/wp-content/themes/one-page-express/assets/images/jeremy-bishop-14593.jpg%22%7D%5D\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::custom_logo\": {\n        \"value\": 67,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"one-page-express::page_content\": {\n        \"value\": \"<!--@@CPPAGEID[86]@@--><div  id=\\\"overlapable-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Overlapable\\\" data-id=\\\"stripped-coloured-icon-boxes\\\" class=\\\"features-coloured-icon-boxes-section\\\" data-overlap=\\\"true\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"features-coloured-icon-boxes-innerrow\\\" data-type=\\\"row\\\"><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-bolt\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-cloud\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-signal\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-pie-chart\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"about-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"About\\\" data-id=\\\"about-big-images-section\\\" class=\\\"about-big-images-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"about-big-images-textrow\\\"><div  class=\\\"about-big-images-textcol\\\" data-type=\\\"column\\\"><h5  class=\\\"\\\">LOREM IPSUM DOLOR</h5><h3  class=\\\"\\\">Brand new WordPress theme&nbsp;<span  href=\\\"#\\\" class=\\\"span25\\\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\\\"button blue big\\\" href=\\\"#\\\">GET STARTED NOW</a></div></div></div><div  class=\\\"about-big-images-bottomrow\\\"><div  class=\\\"about-big-images-leftimgcol\\\"><img  class=\\\"about-big-images-leftimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\\\"></div><div  class=\\\"about-big-images-centerimgcol\\\"><img  class=\\\"about-big-images-centerimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\\\"></div><div  class=\\\"about-big-images-rightimgcol\\\"><img  class=\\\"about-big-images-rightimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div></div></div><div  id=\\\"content-3\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-left\\\" class=\\\"content-left-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row\\\"><div  class=\\\"content-left-image-imgcol\\\" data-type=\\\"column\\\"><img  src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div><div  class=\\\"content-left-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"content-4\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-right\\\" class=\\\"content-right-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"content-right-image-gridcol\\\"><div  class=\\\"content-right-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">Learn More</a></div><div  class=\\\"content-right-image-imgcol\\\" data-type=\\\"column\\\"><img  reiki_companion_plugin=\\\"\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div></div></div></div><div  id=\\\"portfolio-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Portfolio\\\" data-id=\\\"portfolio-full-section\\\"><div  class=\\\"portfolio-full-section\\\" data-type=\\\"row\\\"><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project3.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">Check it out</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div><div  class=\\\"portfolio-full-projectco cp4cols cp4cols-tablet\\\"><div  class=\\\"contentswap-effect ContentSwap103\\\" hover-fx=\\\"ContentSwap103\\\" id=\\\"ContentSwap103\\\" is-hovered=\\\"1\\\"><div  class=\\\"ContentSwap103_content initial-image\\\"><img  class=\\\"portfolio-full-projectimg\\\" data-size=\\\"1200x800\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project2.jpg\\\"></div><div  class=\\\"overlay\\\"></div><div  class=\\\"swap-inner\\\"><div  class=\\\"ContentSwap103-center\\\"><h4  class=\\\"protfolio-full-itemtitle\\\">A COOL PROJECT</h4><a  class=\\\"button yellow\\\" href=\\\"#\\\">CHECK IT OUT</a></div></div></div></div></div></div><div  id=\\\"testimonials-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Testimonials\\\" data-id=\\\"testimonials-boxed-section\\\" class=\\\"testimonials-boxed-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"testimonials-boxed-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">What Our Clients Say</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi.</p></div><div  class=\\\"testimonials-boxed-itemsrow\\\" data-type=\\\"row\\\"><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Anna Johnson</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">Eric Black</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div><div  class=\\\"testimonials-boxed-itemcol cp4cols cp6cols-tablet\\\"><div  class=\\\"testimonials-boxed-itemcard\\\" data-type=\\\"column\\\"><h4  class=\\\"testimonials-boxed-itemtext\\\">\\u201cLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.\\u201d</h4><img  class=\\\"testimonials-boxed-itemimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\"><h5  class=\\\"testimonials-boxed-itemname\\\">John Collins</h5><h6  class=\\\"testimonials-boxed-itempos\\\">CEO @ COOLAPP</h6></div></div></div></div></div><div  id=\\\"cta-1\\\" data-label=\\\"Call to action\\\" data-id=\\\"cta-blue-section\\\" class=\\\"cta-blue-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"cta-blue-innerrow\\\"><div  class=\\\"cta-blue-textcol\\\"><h2  class=\\\"cta-blue-text\\\"><b  class=\\\"element2\\\">Join us.</b>It will only take a minute</h2></div><div  class=\\\"cta-blue-btncol\\\"><a  class=\\\"button transparent\\\" href=\\\"#\\\">GET STARTED</a></div></div></div></div><div  id=\\\"team-1\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Team\\\" data-id=\\\"team-colors-section\\\" class=\\\"team-colors-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"team-colors-textcol\\\"><h2 >Our Awesome Team</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation.</p></div><div  class=\\\"team-colors-membersrow\\\" data-type=\\\"row\\\"><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face7.jpg\\\" height=\\\"175\\\"><h4  class=\\\"team-colors-membername\\\">Chip Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; CEO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face11.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Jane Brown</h4><p  class=\\\"team-colors-memberposition\\\">Co-founder &amp; COO</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face4.jpg\\\"><h4  class=\\\"team-colors-membername\\\">Erika Black&nbsp;</h4><p  class=\\\"team-colors-memberposition\\\">Marketing Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div><div  class=\\\"team-colors-membercol cp3cols cp6cols-tablet\\\"><div  class=\\\"team-colors-membercard\\\"><div  class=\\\"team-colors-background\\\"></div><div  class=\\\"team-colors-memberinfo\\\" data-type=\\\"column\\\"><img  class=\\\"team-colors-memberimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/face9.jpg\\\"><h4  class=\\\"team-colors-membername\\\">George Mayer</h4><p  class=\\\"team-colors-memberposition\\\">Creative Director</p><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt.</p><hr  class=\\\"team-colors-separator\\\"></div><div  class=\\\"team-colors-membericons\\\" data-type=\\\"group\\\"><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"team-colors-icon fa fa-linkedin\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-twitter team-colors-icon\\\"></i></a><a  href=\\\"#\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"fa fa-dribbble team-colors-icon\\\"></i></a></div></div></div></div></div></div><div  id=\\\"numbers\\\" data-label=\\\"Numbers\\\" data-id=\\\"numbers-section\\\" data-bg=\\\"transparent\\\" class=\\\"numbers-section\\\" data-parallax-depth=\\\"20\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">230</h2><h3  class=\\\"numbers-titletext\\\">PROJECTS</h3></div><div  class=\\\"numbers-itemcol\\\"><h2  class=\\\"numbers-numbertext\\\">75340</h2><h3  class=\\\"numbers-titletext\\\">WORKED HOURS</h3></div><div  class=\\\"numbers-itemcol-last\\\"><h2  class=\\\"numbers-numbertext\\\">25</h2><h3  class=\\\"numbers-titletext\\\">EMPROYEES</h3></div></div></div><div  id=\\\"latest-posts\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Latest posts\\\" data-id=\\\"blog-section\\\" class=\\\"blog-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"blog-textrow\\\"><div  class=\\\"blog-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">Latest News</h2><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p></div></div><div  class=\\\"blog-postsrow\\\" data-type=\\\"row\\\" data-dynamic-columns=\\\"one_page_express_latest_news_columns\\\" data-content-shortcode=\\\"one_page_express_latest_news\\\">[one_page_express_latest_news]</div><div  class=\\\"blog-textcol\\\"><a  class=\\\"button blue\\\" data-attr-shortcode=\\\"href:one_page_express_blog_link\\\" href=\\\"[one_page_express_blog_link]\\\" target=\\\"_self\\\">SEE ALL BLOG POSTS</a></div></div></div><div  id=\\\"contact-2\\\" data-label=\\\"Contact\\\" data-id=\\\"contact-section\\\" data-bg=\\\"transparent\\\" data-setting=\\\"one_page_express_contact_form_shortcode\\\" class=\\\"contact-section-formsection white-text\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row_224\\\"><div  class=\\\"contact-textrow\\\"><div  class=\\\"contact-textcol\\\"><h2  class=\\\"\\\">Say Hello</h2><p  class=\\\"white_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\\\"contact-formcol\\\" data-content-shortcode=\\\"one_page_express_contact_form\\\">[one_page_express_contact_form]</div></div></div>\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "56c9c91e-89b4-4787-8d3d-dc514e36a3d6", "", "", "2017-06-08 03:29:46", "2017-06-07 23:29:46", "", "0", "http://localhost/actfinal/?p=94", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("95", "1", "2017-06-08 03:31:37", "2017-06-07 23:31:37", "{\n    \"one-page-express::page_content\": {\n        \"value\": \"<!--@@CPPAGEID[86]@@--><div  id=\\\"overlapable-2\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Overlapable\\\" data-id=\\\"stripped-coloured-icon-boxes\\\" class=\\\"features-coloured-icon-boxes-section\\\" data-overlap=\\\"true\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"features-coloured-icon-boxes-innerrow\\\" data-type=\\\"row\\\"><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-bolt\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-cloud\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-signal\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div><div  class=\\\"features-coloured-icon-boxes-featurecol cp3cols\\\"><div  class=\\\"features-coloured-icon-boxes-iconcontainer\\\" data-content-item-container=\\\"true\\\"><i  data-cp-fa=\\\"true\\\" class=\\\"features-coloured-icon fa fa-pie-chart\\\"></i></div><h4  class=\\\"\\\">Responsive Design</h4><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\\\"features-coloured-button\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"about-1\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"About\\\" data-id=\\\"about-big-images-section\\\" class=\\\"about-big-images-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"about-big-images-textrow\\\"><div  class=\\\"about-big-images-textcol\\\" data-type=\\\"column\\\"><h5  class=\\\"\\\">LOREM IPSUM DOLOR</h5><h3  class=\\\"\\\">Brand new WordPress theme&nbsp;<span  href=\\\"#\\\" class=\\\"span25\\\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\\\"\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\\\"button blue big\\\" href=\\\"#\\\">GET STARTED NOW</a></div></div></div><div  class=\\\"about-big-images-bottomrow\\\"><div  class=\\\"about-big-images-leftimgcol\\\"><img  class=\\\"about-big-images-leftimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\\\"></div><div  class=\\\"about-big-images-centerimgcol\\\"><img  class=\\\"about-big-images-centerimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\\\"></div><div  class=\\\"about-big-images-rightimgcol\\\"><img  class=\\\"about-big-images-rightimg\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\"></div></div></div><div  id=\\\"content-3\\\" style=\\\"background-color:rgb(255, 255, 255)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-left\\\" class=\\\"content-left-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row\\\"><div  class=\\\"content-left-image-imgcol\\\" data-type=\\\"column\\\"><img  src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div><div  class=\\\"content-left-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">LEARN MORE</a></div></div></div></div><div  id=\\\"content-4\\\" style=\\\"background-color:rgb(246, 246, 246)\\\" data-label=\\\"Content\\\" data-id=\\\"content-image-right\\\" class=\\\"content-right-image-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"content-right-image-gridcol\\\"><div  class=\\\"content-right-image-textcol\\\" data-type=\\\"column\\\"><h2  class=\\\"\\\">This is one of the things<br >we do best&nbsp;</h2><p  class=\\\"large_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\\\"button blue\\\" href=\\\"#\\\">Learn More</a></div><div  class=\\\"content-right-image-imgcol\\\" data-type=\\\"column\\\"><img  reiki_companion_plugin=\\\"\\\" src=\\\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\\\" class=\\\"\\\"></div></div></div></div><div  id=\\\"cta-1\\\" data-label=\\\"Call to action\\\" data-id=\\\"cta-blue-section\\\" class=\\\"cta-blue-section\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"cta-blue-innerrow\\\"><div  class=\\\"cta-blue-textcol\\\"><h2  class=\\\"cta-blue-text\\\"><b  class=\\\"element2\\\">Join us.</b>It will only take a minute</h2></div><div  class=\\\"cta-blue-btncol\\\"><a  class=\\\"button transparent\\\" href=\\\"#\\\">GET STARTED</a></div></div></div></div><div  id=\\\"contact-2\\\" data-label=\\\"Contact\\\" data-id=\\\"contact-section\\\" data-bg=\\\"transparent\\\" data-setting=\\\"one_page_express_contact_form_shortcode\\\" class=\\\"contact-section-formsection white-text\\\"><div  class=\\\"gridContainer\\\"><div  class=\\\"row_224\\\"><div  class=\\\"contact-textrow\\\"><div  class=\\\"contact-textcol\\\"><h2  class=\\\"\\\">Say Hello</h2><p  class=\\\"white_text\\\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\\\"contact-formcol\\\" data-content-shortcode=\\\"one_page_express_contact_form\\\">[one_page_express_contact_form]</div></div></div>\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"nav_menu_item[-1902232390]\": {\n        \"value\": false,\n        \"type\": \"nav_menu_item\",\n        \"user_id\": 1\n    },\n    \"nav_menu_item[-257791111]\": {\n        \"value\": false,\n        \"type\": \"nav_menu_item\",\n        \"user_id\": 1\n    },\n    \"nav_menu_item[-2082108488]\": {\n        \"value\": false,\n        \"type\": \"nav_menu_item\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "214713b0-2cbe-4a22-8681-9a4b15f19621", "", "", "2017-06-08 03:31:37", "2017-06-07 23:31:37", "", "0", "http://localhost/actfinal/?p=95", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("96", "1", "2017-06-08 03:31:37", "2017-06-07 23:31:37", "<div  id=\"overlapable-2\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" class=\"features-coloured-icon-boxes-section\" data-overlap=\"true\"><div  class=\"gridContainer\"><div  class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\"><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-bolt\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-cloud\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-signal\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div><div  class=\"features-coloured-icon-boxes-featurecol cp3cols\"><div  class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"><i  data-cp-fa=\"true\" class=\"features-coloured-icon fa fa-pie-chart\"></i></div><h4  class=\"\">Responsive Design</h4><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.&nbsp;</p><a  class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div></div></div></div><div  id=\"about-1\" style=\"background-color:rgb(246, 246, 246)\" data-label=\"About\" data-id=\"about-big-images-section\" class=\"about-big-images-section\"><div  class=\"gridContainer\"><div  class=\"about-big-images-textrow\"><div  class=\"about-big-images-textcol\" data-type=\"column\"><h5  class=\"\">LOREM IPSUM DOLOR</h5><h3  class=\"\">Brand new WordPress theme&nbsp;<span  href=\"#\" class=\"span25\">with unlimited power</span>&nbsp;and customization possibilities</h3><p  class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p><a  class=\"button blue big\" href=\"#\">GET STARTED NOW</a></div></div></div><div  class=\"about-big-images-bottomrow\"><div  class=\"about-big-images-leftimgcol\"><img  class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\"></div><div  class=\"about-big-images-centerimgcol\"><img  class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\"></div><div  class=\"about-big-images-rightimgcol\"><img  class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\"></div></div></div><div  id=\"content-3\" style=\"background-color:rgb(255, 255, 255)\" data-label=\"Content\" data-id=\"content-image-left\" class=\"content-left-image-section\"><div  class=\"gridContainer\"><div  class=\"row\"><div  class=\"content-left-image-imgcol\" data-type=\"column\"><img  src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" class=\"\"></div><div  class=\"content-left-image-textcol\" data-type=\"column\"><h2  class=\"\">This is one of the things<br >we do best&nbsp;</h2><p  class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\"button blue\" href=\"#\">LEARN MORE</a></div></div></div></div><div  id=\"content-4\" style=\"background-color:rgb(246, 246, 246)\" data-label=\"Content\" data-id=\"content-image-right\" class=\"content-right-image-section\"><div  class=\"gridContainer\"><div  class=\"content-right-image-gridcol\"><div  class=\"content-right-image-textcol\" data-type=\"column\"><h2  class=\"\">This is one of the things<br >we do best&nbsp;</h2><p  class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p><a  class=\"button blue\" href=\"#\">Learn More</a></div><div  class=\"content-right-image-imgcol\" data-type=\"column\"><img  reiki_companion_plugin=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" class=\"\"></div></div></div></div><div  id=\"cta-1\" data-label=\"Call to action\" data-id=\"cta-blue-section\" class=\"cta-blue-section\"><div  class=\"gridContainer\"><div  class=\"cta-blue-innerrow\"><div  class=\"cta-blue-textcol\"><h2  class=\"cta-blue-text\"><b  class=\"element2\">Join us.</b>It will only take a minute</h2></div><div  class=\"cta-blue-btncol\"><a  class=\"button transparent\" href=\"#\">GET STARTED</a></div></div></div></div><div  id=\"contact-2\" data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\" class=\"contact-section-formsection white-text\"><div  class=\"gridContainer\"><div  class=\"row_224\"><div  class=\"contact-textrow\"><div  class=\"contact-textcol\"><h2  class=\"\">Say Hello</h2><p  class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p></div></div></div><div  class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\">[one_page_express_contact_form]</div></div></div>", "Front Page", "", "inherit", "closed", "closed", "", "86-revision-v1", "", "", "2017-06-08 03:31:37", "2017-06-07 23:31:37", "", "86", "http://localhost/actfinal/86-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("97", "1", "2017-06-08 10:41:57", "2017-06-08 06:41:57", "<div id=\"overlapable-2\" class=\"features-coloured-icon-boxes-section\" style=\"background-color: #ffffff;\" data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" data-overlap=\"true\">\r\n<div class=\"gridContainer\">\r\n<div class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\">\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"about-1\" class=\"about-big-images-section\" style=\"background-color: #f6f6f6;\" data-label=\"About\" data-id=\"about-big-images-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"about-big-images-textrow\">\r\n<div class=\"about-big-images-textcol\" data-type=\"column\">\r\n<h5 class=\"\">LOREM IPSUM DOLOR</h5>\r\n<h3 class=\"\">Brand new WordPress theme <span class=\"span25\">with unlimited power</span> and customization possibilities</h3>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p>\r\n\r\n<a class=\"button blue big\" href=\"#\">GET STARTED NOW</a></div>\r\n</div>\r\n</div>\r\n<div class=\"about-big-images-bottomrow\">\r\n<div class=\"about-big-images-leftimgcol\"><img class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\" /></div>\r\n<div class=\"about-big-images-centerimgcol\"><img class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\" /></div>\r\n<div class=\"about-big-images-rightimgcol\"><img class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n<div id=\"content-3\" class=\"content-left-image-section\" style=\"background-color: #ffffff;\" data-label=\"Content\" data-id=\"content-image-left\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row\">\r\n<div class=\"content-left-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n<div class=\"content-left-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n\r\n<a class=\"button blue\" href=\"#\">LEARN MORE</a></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"content-4\" class=\"content-right-image-section\" style=\"background-color: #f6f6f6;\" data-label=\"Content\" data-id=\"content-image-right\">\r\n<div class=\"gridContainer\">\r\n<div class=\"content-right-image-gridcol\">\r\n<div class=\"content-right-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n\r\n<a class=\"button blue\" href=\"#\">Learn More</a></div>\r\n<div class=\"content-right-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"cta-1\" class=\"cta-blue-section\" data-label=\"Call to action\" data-id=\"cta-blue-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"cta-blue-innerrow\">\r\n<div class=\"cta-blue-textcol\">\r\n<h2 class=\"cta-blue-text\"><b class=\"element2\">Join us.</b>It will only take a minute</h2>\r\n</div>\r\n<div class=\"cta-blue-btncol\"><a class=\"button transparent\" href=\"#\">GET STARTED</a></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"contact-2\" class=\"contact-section-formsection white-text\" data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row_224\">\r\n<div class=\"contact-textrow\">\r\n<div class=\"contact-textcol\">\r\n<h2 class=\"\">Say Hello</h2>\r\n<p class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\">[one_page_express_contact_form]</div>\r\n</div>\r\n</div>", "Front Page", "", "inherit", "closed", "closed", "", "86-revision-v1", "", "", "2017-06-08 10:41:57", "2017-06-08 06:41:57", "", "86", "http://localhost/actfinal/86-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("99", "1", "2017-06-08 10:49:37", "2017-06-08 06:49:37", "<div id=\"overlapable-2\" class=\"features-coloured-icon-boxes-section\" style=\"background-color: #ffffff;\" data-label=\"Overlapable\" data-id=\"stripped-coloured-icon-boxes\" data-overlap=\"true\">\r\n<div class=\"gridContainer\">\r\n<div class=\"features-coloured-icon-boxes-innerrow\" data-type=\"row\">\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n<div class=\"features-coloured-icon-boxes-featurecol cp3cols\">\r\n<div class=\"features-coloured-icon-boxes-iconcontainer\" data-content-item-container=\"true\"></div>\r\n<h4 class=\"\">Responsive Design</h4>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n<a class=\"features-coloured-button\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"about-1\" class=\"about-big-images-section\" style=\"background-color: #f6f6f6;\" data-label=\"About\" data-id=\"about-big-images-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"about-big-images-textrow\">\r\n<div class=\"about-big-images-textcol\" data-type=\"column\">\r\n<h5 class=\"\">LOREM IPSUM DOLOR</h5>\r\n<h3 class=\"\">Brand new WordPress theme <span class=\"span25\">with unlimited power</span> and customization possibilities</h3>\r\n<p class=\"\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud.</p>\r\n<a class=\"button blue big\" href=\"#\">GET STARTED NOW</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"about-big-images-bottomrow\">\r\n<div class=\"about-big-images-leftimgcol\"><img class=\"about-big-images-leftimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/nordwood-themes-180852.jpg\" /></div>\r\n<div class=\"about-big-images-centerimgcol\"><img class=\"about-big-images-centerimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/ir5likvfqc4-william-iven-1920x1275.jpg\" /></div>\r\n<div class=\"about-big-images-rightimgcol\"><img class=\"about-big-images-rightimg\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n<div id=\"content-3\" class=\"content-left-image-section\" style=\"background-color: #ffffff;\" data-label=\"Content\" data-id=\"content-image-left\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row\">\r\n<div class=\"content-left-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n<div class=\"content-left-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n<a class=\"button blue\" href=\"#\">LEARN MORE</a>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"content-4\" class=\"content-right-image-section\" style=\"background-color: #f6f6f6;\" data-label=\"Content\" data-id=\"content-image-right\">\r\n<div class=\"gridContainer\">\r\n<div class=\"content-right-image-gridcol\">\r\n<div class=\"content-right-image-textcol\" data-type=\"column\">\r\n<h2 class=\"\">This is one of the things\r\nwe do best</h2>\r\n<p class=\"large_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>\r\n<a class=\"button blue\" href=\"#\">Learn More</a>\r\n\r\n</div>\r\n<div class=\"content-right-image-imgcol\" data-type=\"column\"><img class=\"\" src=\"http://localhost/actfinal/wp-content/plugins/one-page-express-companion/theme-data/one-page-express/sections/images/project1.jpg\" /></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"cta-1\" class=\"cta-blue-section\" data-label=\"Call to action\" data-id=\"cta-blue-section\">\r\n<div class=\"gridContainer\">\r\n<div class=\"cta-blue-innerrow\">\r\n<div class=\"cta-blue-textcol\">\r\n<h2 class=\"cta-blue-text\"><b class=\"element2\">Join us.</b>It will only take a minute</h2>\r\n</div>\r\n<div class=\"cta-blue-btncol\"><a class=\"button transparent\" href=\"#\">GET STARTED</a></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div id=\"contact-2\" class=\"contact-section-formsection white-text\" data-label=\"Contact\" data-id=\"contact-section\" data-bg=\"transparent\" data-setting=\"one_page_express_contact_form_shortcode\">\r\n<div class=\"gridContainer\">\r\n<div class=\"row_224\">\r\n<div class=\"contact-textrow\">\r\n<div class=\"contact-textcol\">\r\n<h2 class=\"\">Say Hello</h2>\r\n<p class=\"white_text\">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\r\n\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"contact-formcol\" data-content-shortcode=\"one_page_express_contact_form\">[one_page_express_contact_form]</div>\r\n</div>\r\n</div>", "Front Page", "", "inherit", "closed", "closed", "", "86-revision-v1", "", "", "2017-06-08 10:49:37", "2017-06-08 06:49:37", "", "86", "http://localhost/actfinal/86-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("100", "1", "2017-06-08 10:50:27", "2017-06-08 06:50:27", "{\n    \"page_on_front\": {\n        \"value\": \"5\",\n        \"type\": \"option\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "a5089c2a-8486-403c-b81d-9c0c7054077b", "", "", "2017-06-08 10:50:27", "2017-06-08 06:50:27", "", "0", "http://localhost/actfinal/a5089c2a-8486-403c-b81d-9c0c7054077b/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("101", "1", "2017-06-08 12:03:29", "2017-06-08 08:03:29", "", "Register", "", "trash", "closed", "closed", "", "register__trashed", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "0", "http://localhost/actfinal/register/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("102", "1", "2017-06-08 12:03:29", "2017-06-08 08:03:29", "", "Account", "", "trash", "closed", "closed", "", "account__trashed", "", "", "2017-06-09 14:11:30", "2017-06-09 10:11:30", "", "0", "http://localhost/actfinal/account/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("103", "1", "2017-06-08 12:03:29", "2017-06-08 08:03:29", "<p>The content you are trying to access is only available to members. Sorry.</p>", "Protected Content", "", "trash", "closed", "closed", "", "protected__trashed", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "0", "http://localhost/actfinal/protected/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("104", "1", "2017-06-08 12:04:01", "2017-06-08 08:04:01", "[ms-note type=\"info\"]We have the following subscriptions available for our site. You can renew, cancel or upgrade your subscriptions by using the forms below.[/ms-note]\n[ms-membership-signup]", "Membership List", "", "trash", "closed", "closed", "", "memberships__trashed", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "0", "http://localhost/actfinal/memberships/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("105", "1", "2017-06-08 12:04:01", "2017-06-08 08:04:01", "[ms-protection-message]", "Protected Content", "", "trash", "closed", "closed", "", "protected-content__trashed", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "0", "http://localhost/actfinal/protected-content/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("106", "1", "2017-06-08 12:04:01", "2017-06-08 08:04:01", "[ms-note type=\"info\"]We have the following subscriptions available for our site. To join, simply click on the Sign Up button and then complete the registration details.[/ms-note]\n[ms-membership-signup]", "Registration", "", "trash", "closed", "closed", "", "register-2__trashed", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "0", "http://localhost/actfinal/register-2/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("107", "1", "2017-06-08 12:04:01", "2017-06-08 08:04:01", "[ms-note type=\"info\"]Your request to join the membership was successfully received!<br/>The Payment Gateway could take a couple of minutes to process and return the payment status.[/ms-note]\n[ms-membership-account-link]", "Thank-You Page", "", "trash", "closed", "closed", "", "registration-complete__trashed", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "0", "http://localhost/actfinal/registration-complete/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("108", "1", "2017-06-08 12:04:01", "2017-06-08 08:04:01", "[ms-membership-account]<hr />\n[ms-membership-logout]", "Account", "", "trash", "closed", "closed", "", "account-2__trashed", "", "", "2017-06-09 14:11:31", "2017-06-09 10:11:31", "", "0", "http://localhost/actfinal/account-2/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("109", "0", "2017-06-08 12:04:05", "2017-06-08 08:04:05", "Membership2 Core Membership", "system-membership", "Membership2 Core Membership", "publish", "closed", "closed", "", "system-membership", "", "", "2017-06-08 12:04:05", "2017-06-08 08:04:05", "", "0", "http://localhost/actfinal/ms_membership/system-membership/", "0", "ms_membership", "", "0");
INSERT INTO `act_posts` VALUES("110", "0", "2017-06-08 12:05:26", "2017-06-08 08:05:26", "", "members", "", "publish", "closed", "closed", "", "members", "", "", "2017-06-08 12:05:26", "2017-06-08 08:05:26", "", "0", "http://localhost/actfinal/ms_membership/members/", "1", "ms_membership", "", "0");
INSERT INTO `act_posts` VALUES("117", "0", "2017-06-08 12:05:31", "2017-06-08 08:05:31", "<h2>Hi %username%,</h2><br /><br />Thank you! Your <strong>%ms-name%</strong> Membership at %blog-name% is now activated!<br /><br />You can review and edit your membership details here: %ms-account-page-url%<br /><br />Here is the most recent payment information for your subscription:<br /><br />%ms-invoice%", "", "<h2>Hi %username%,</h2><br /><br />Thank you! Your <strong>%ms-name%</strong> Membership at %blog-name% is now activated!<br /><br />You can review and edit your membership details here: %ms-account-page-url%<br /><br />Here is the most recent payment information for your subscription:<br /><br />%ms-invoice%", "private", "closed", "closed", "", "117", "", "", "2017-06-08 12:05:31", "2017-06-08 08:05:31", "", "0", "http://localhost/actfinal/ms_communication/117/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("118", "0", "2017-06-08 12:05:31", "2017-06-08 08:05:31", "<h2>Hi %username%,</h2><br /><br />We\'ve received your payment for your %ms-name% membership at %blog-name%. Thanks!<br /><br />Here are your latest payment details:<br /><br />%ms-invoice%", "", "<h2>Hi %username%,</h2><br /><br />We\'ve received your payment for your %ms-name% membership at %blog-name%. Thanks!<br /><br />Here are your latest payment details:<br /><br />%ms-invoice%", "private", "closed", "closed", "", "118", "", "", "2017-06-08 12:05:31", "2017-06-08 08:05:31", "", "0", "http://localhost/actfinal/ms_communication/118/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("119", "0", "2017-06-08 12:05:32", "2017-06-08 08:05:32", "<h2>Hi %username%,</h2><br /><br />Your %ms-name% membership at %blog-name% has ended on %ms-expiry-date%.<br /><br />You can renew your membership here: %ms-account-page-url%", "", "<h2>Hi %username%,</h2><br /><br />Your %ms-name% membership at %blog-name% has ended on %ms-expiry-date%.<br /><br />You can renew your membership here: %ms-account-page-url%", "private", "closed", "closed", "", "119", "", "", "2017-06-08 12:05:32", "2017-06-08 08:05:32", "", "0", "http://localhost/actfinal/ms_communication/119/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("120", "0", "2017-06-08 12:05:33", "2017-06-08 08:05:33", "<h2>Hi %username%,</h2><br /><br />Your %ms-name% membership at %blog-name% was successfully cancelled.<br /><br />Should you change your mind, you can renew your membership here: %ms-account-page-url%<br /><br />Here are your latest payment details:<br /><br />%ms-invoice%", "", "<h2>Hi %username%,</h2><br /><br />Your %ms-name% membership at %blog-name% was successfully cancelled.<br /><br />Should you change your mind, you can renew your membership here: %ms-account-page-url%<br /><br />Here are your latest payment details:<br /><br />%ms-invoice%", "private", "closed", "closed", "", "120", "", "", "2017-06-08 12:05:33", "2017-06-08 08:05:33", "", "0", "http://localhost/actfinal/ms_communication/120/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("121", "0", "2017-06-08 12:05:33", "2017-06-08 08:05:33", "<h2>Hi %username%,</h2><br /><br />This is to confirm that your billing information has been changed.<br /><br />You can review your account details here: %ms-account-page-url%", "", "<h2>Hi %username%,</h2><br /><br />This is to confirm that your billing information has been changed.<br /><br />You can review your account details here: %ms-account-page-url%", "private", "closed", "closed", "", "121", "", "", "2017-06-08 12:05:33", "2017-06-08 08:05:33", "", "0", "http://localhost/actfinal/ms_communication/121/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("122", "0", "2017-06-08 12:05:34", "2017-06-08 08:05:34", "<h2>Hi %username%,</h2><br /><br />This is a reminder that your credit card is about to expire.<br /><br />To continue your %ms-name% membership at %blog-name%, please update your card details before your next payment is due here: %ms-account-page-url%", "", "<h2>Hi %username%,</h2><br /><br />This is a reminder that your credit card is about to expire.<br /><br />To continue your %ms-name% membership at %blog-name%, please update your card details before your next payment is due here: %ms-account-page-url%", "private", "closed", "closed", "", "122", "", "", "2017-06-08 12:05:34", "2017-06-08 08:05:34", "", "0", "http://localhost/actfinal/ms_communication/122/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("123", "0", "2017-06-08 12:05:35", "2017-06-08 08:05:35", "<h2>Hi %username%,</h2><br /><br />Unfortunately, your recurring payment for your %ms-name% membership at %blog-name% has failed.<br /><br />To continue as a member, please review and edit your billing information as necessary in your account here: %ms-account-page-url%<br /><br />Here is your latest invoice which is due now:<br /><br />%ms-invoice%", "", "<h2>Hi %username%,</h2><br /><br />Unfortunately, your recurring payment for your %ms-name% membership at %blog-name% has failed.<br /><br />To continue as a member, please review and edit your billing information as necessary in your account here: %ms-account-page-url%<br /><br />Here is your latest invoice which is due now:<br /><br />%ms-invoice%", "private", "closed", "closed", "", "123", "", "", "2017-06-08 12:05:35", "2017-06-08 08:05:35", "", "0", "http://localhost/actfinal/ms_communication/123/", "0", "ms_communication", "", "0");
INSERT INTO `act_posts` VALUES("124", "1", "2017-06-08 12:07:22", "2017-06-08 08:07:22", "Admin has no fees!", "invoice-for-members-actjennifer", "Admin has no fees!", "private", "closed", "closed", "", "invoice-for-members-actjennifer", "", "", "2017-06-08 12:07:26", "2017-06-08 08:07:26", "", "0", "http://localhost/actfinal/ms_invoice/invoice-for-members-actjennifer/", "0", "ms_invoice", "", "0");
INSERT INTO `act_posts` VALUES("126", "1", "2017-06-08 13:10:13", "2017-06-08 09:10:13", "{\n    \"vogue::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"vogue::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n            \"timestamp\": 1496912966608,\n            \"attachment_id\": 67,\n            \"width\": 190,\n            \"height\": 74\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "5eb3c0b7-acfc-4574-b4ef-9b323d07a027", "", "", "2017-06-08 13:10:13", "2017-06-08 09:10:13", "", "0", "http://localhost/actfinal/?p=126", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("127", "1", "2017-06-08 13:11:06", "2017-06-08 09:11:06", "", "sample post 1", "", "publish", "open", "open", "", "sample-post-1", "", "", "2017-06-08 13:11:06", "2017-06-08 09:11:06", "", "0", "http://localhost/actfinal/?p=127", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("128", "1", "2017-06-08 13:11:06", "2017-06-08 09:11:06", "", "sample post 1", "", "inherit", "closed", "closed", "", "127-revision-v1", "", "", "2017-06-08 13:11:06", "2017-06-08 09:11:06", "", "127", "http://localhost/actfinal/127-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("129", "1", "2017-06-08 13:11:34", "2017-06-08 09:11:34", "", "sample post 2", "", "publish", "open", "open", "", "sample-post-2", "", "", "2017-06-08 13:12:09", "2017-06-08 09:12:09", "", "0", "http://localhost/actfinal/?p=129", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("130", "1", "2017-06-08 13:11:34", "2017-06-08 09:11:34", "", "sample post 2", "", "inherit", "closed", "closed", "", "129-revision-v1", "", "", "2017-06-08 13:11:34", "2017-06-08 09:11:34", "", "129", "http://localhost/actfinal/129-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("132", "1", "2017-06-08 13:55:08", "2017-06-08 09:55:08", "[wpmem_form login redirect_to=\"http://mysite.com/my-page/\"]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-08 13:55:08", "2017-06-08 09:55:08", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("133", "1", "2017-06-08 13:58:06", "2017-06-08 09:58:06", "[booking nummonths=6 startmonth=\'2017-6\'][wpmem_form login redirect_to=\"http://mysite.com/my-page/\"]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-08 13:58:06", "2017-06-08 09:58:06", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("134", "1", "2017-06-08 14:00:32", "2017-06-08 10:00:32", "[wpmem_logged_out]\r\nThis displays when logged out\r\n[/wpmem_logged_out]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-08 14:00:32", "2017-06-08 10:00:32", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("135", "1", "2017-06-08 14:09:29", "2017-06-08 10:09:29", "[booking]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-08 14:09:29", "2017-06-08 10:09:29", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("136", "1", "2017-06-08 17:41:13", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2017-06-08 17:41:13", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?post_type=services&p=136", "0", "services", "", "0");
INSERT INTO `act_posts` VALUES("137", "1", "2017-06-09 14:11:30", "2017-06-09 10:11:30", "", "Account", "", "inherit", "closed", "closed", "", "102-revision-v1", "", "", "2017-06-09 14:11:30", "2017-06-09 10:11:30", "", "102", "http://localhost/actfinal/102-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("138", "1", "2017-06-09 14:11:31", "2017-06-09 10:11:31", "[ms-membership-account]<hr />\n[ms-membership-logout]", "Account", "", "inherit", "closed", "closed", "", "108-revision-v1", "", "", "2017-06-09 14:11:31", "2017-06-09 10:11:31", "", "108", "http://localhost/actfinal/108-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("139", "1", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "[ms-note type=\"info\"]We have the following subscriptions available for our site. You can renew, cancel or upgrade your subscriptions by using the forms below.[/ms-note]\n[ms-membership-signup]", "Membership List", "", "inherit", "closed", "closed", "", "104-revision-v1", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "104", "http://localhost/actfinal/104-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("140", "1", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "<p>The content you are trying to access is only available to members. Sorry.</p>", "Protected Content", "", "inherit", "closed", "closed", "", "103-revision-v1", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "103", "http://localhost/actfinal/103-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("141", "1", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "[ms-protection-message]", "Protected Content", "", "inherit", "closed", "closed", "", "105-revision-v1", "", "", "2017-06-09 14:11:32", "2017-06-09 10:11:32", "", "105", "http://localhost/actfinal/105-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("142", "1", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "Register", "", "inherit", "closed", "closed", "", "101-revision-v1", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "101", "http://localhost/actfinal/101-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("143", "1", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "[ms-note type=\"info\"]We have the following subscriptions available for our site. To join, simply click on the Sign Up button and then complete the registration details.[/ms-note]\n[ms-membership-signup]", "Registration", "", "inherit", "closed", "closed", "", "106-revision-v1", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "106", "http://localhost/actfinal/106-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("144", "1", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "[ms-note type=\"info\"]Your request to join the membership was successfully received!<br/>The Payment Gateway could take a couple of minutes to process and return the payment status.[/ms-note]\n[ms-membership-account-link]", "Thank-You Page", "", "inherit", "closed", "closed", "", "107-revision-v1", "", "", "2017-06-09 14:11:33", "2017-06-09 10:11:33", "", "107", "http://localhost/actfinal/107-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("147", "1", "2017-06-09 15:09:16", "2017-06-09 11:09:16", "<div id=\"pl-147\"  class=\"panel-layout\" ><div id=\"pg-147-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-147-0\" ><div id=\"pgc-147-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-147-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-147-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p> </p><p> </p><p><a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img class=\"aligncenter\" title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p></div>\n</div></div></div></div></div></div></div>", "Join Us", "", "trash", "closed", "closed", "", "membership-join__trashed", "", "", "2017-06-15 01:30:01", "2017-06-14 21:30:01", "", "0", "http://localhost/actfinal/membership-join/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("148", "1", "2017-06-09 15:09:16", "2017-06-09 11:09:16", "[swpm_registration_form]", "Registration", "", "trash", "closed", "closed", "", "membership-registration__trashed", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "147", "http://localhost/actfinal/membership-join/membership-registration/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("149", "1", "2017-06-09 15:09:16", "2017-06-09 11:09:16", "[swpm_login_form]", "Member Login", "", "trash", "closed", "closed", "", "membership-login__trashed", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "0", "http://localhost/actfinal/membership-login/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("150", "1", "2017-06-09 15:09:16", "2017-06-09 11:09:16", "[swpm_profile_form]", "Profile", "", "trash", "closed", "closed", "", "membership-profile__trashed", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "149", "http://localhost/actfinal/membership-login/membership-profile/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("151", "1", "2017-06-09 15:09:16", "2017-06-09 11:09:16", "[swpm_reset_form]", "Password Reset", "", "trash", "closed", "closed", "", "password-reset__trashed", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "149", "http://localhost/actfinal/membership-login/password-reset/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("152", "1", "2017-06-09 15:12:59", "2017-06-09 11:12:59", "", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-09 15:12:59", "2017-06-09 11:12:59", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("153", "1", "2017-06-10 02:16:09", "2017-06-09 22:16:09", "{\n    \"sydney-child::slider_image_1\": {\n        \"value\": \"http://localhost/actfinal/wp-content/themes/sydney/images/1.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "5deb27bb-5934-4372-b704-4aad64220879", "", "", "2017-06-10 02:16:09", "2017-06-09 22:16:09", "", "0", "http://localhost/actfinal/5deb27bb-5934-4372-b704-4aad64220879/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("154", "1", "2017-06-10 02:20:18", "2017-06-09 22:20:18", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;o&#107;ing&#115;&#64;a&#98;so&#108;u&#116;&#101;&#99;omfo&#114;&#116;.c&#111;.ke\">&#66;&#111;o&#107;ing&#115;&#64;a&#98;so&#108;u&#116;&#101;&#99;omfo&#114;&#116;.c&#111;.ke</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:20:18", "2017-06-09 22:20:18", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("155", "1", "2017-06-10 02:22:07", "2017-06-09 22:22:07", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;&#111;&#107;i&#110;&#103;s&#64;&#97;&#98;&#115;ol&#117;&#116;e&#99;&#111;&#109;&#102;&#111;rt.&#99;o&#46;&#107;&#101;\">&#66;&#111;&#111;&#107;i&#110;&#103;s&#64;&#97;&#98;&#115;ol&#117;&#116;e&#99;&#111;&#109;&#102;&#111;rt.&#99;o&#46;&#107;&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:22:07", "2017-06-09 22:22:07", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("156", "1", "2017-06-10 02:24:34", "2017-06-09 22:24:34", "Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment", "Superior service", "", "publish", "closed", "closed", "", "superior-service", "", "", "2017-06-11 00:47:14", "2017-06-10 20:47:14", "", "0", "http://localhost/actfinal/?post_type=services&#038;p=156", "0", "services", "", "0");
INSERT INTO `act_posts` VALUES("157", "1", "2017-06-10 02:25:50", "2017-06-09 22:25:50", "We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged", "Excellent customer service", "", "publish", "closed", "closed", "", "excellent-customer-service", "", "", "2017-06-11 00:46:19", "2017-06-10 20:46:19", "", "0", "http://localhost/actfinal/?post_type=services&#038;p=157", "0", "services", "", "0");
INSERT INTO `act_posts` VALUES("158", "1", "2017-06-10 02:26:25", "2017-06-09 22:26:25", "Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too", "Available around the clock", "", "publish", "closed", "closed", "", "available-around-clock", "", "", "2017-06-10 14:38:27", "2017-06-10 10:38:27", "", "0", "http://localhost/actfinal/?post_type=services&#038;p=158", "0", "services", "", "0");
INSERT INTO `act_posts` VALUES("160", "1", "2017-06-10 02:38:54", "2017-06-09 22:38:54", "<div id=\"pl-160\"  class=\"panel-layout\" ><div id=\"pg-160-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-160-0\" ><div id=\"pgc-160-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-160-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-160-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-160-1\" ><div id=\"pgc-160-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-160-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-160-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-160-2\" ><div id=\"pgc-160-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-160-2-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:Booki&#110;g&#115;&#64;&#97;bs&#111;&#108;u&#116;&#101;com&#102;&#111;rt&#46;&#99;&#111;.&#107;e\">Booki&#110;g&#115;&#64;&#97;bs&#111;&#108;u&#116;&#101;com&#102;&#111;rt&#46;&#99;&#111;.&#107;e</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:38:54", "2017-06-09 22:38:54", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("161", "1", "2017-06-10 02:38:55", "2017-06-09 22:38:55", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-160-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-160-2-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:Booki&#110;g&#115;&#64;&#97;bs&#111;&#108;u&#116;&#101;com&#102;&#111;rt&#46;&#99;&#111;.&#107;e\">Booki&#110;g&#115;&#64;&#97;bs&#111;&#108;u&#116;&#101;com&#102;&#111;rt&#46;&#99;&#111;.&#107;e</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:38:55", "2017-06-09 22:38:55", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("162", "1", "2017-06-10 02:41:08", "2017-06-09 22:41:08", "<div id=\"pl-162\"  class=\"panel-layout\" ><div id=\"pg-162-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-162-0\" ><div id=\"pgc-162-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-162-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-162-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-162-1\" ><div id=\"pgc-162-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-162-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-162-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-162-2\" ><div id=\"pgc-162-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-162-2-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;okin&#103;s&#64;a&#98;&#115;&#111;&#108;&#117;t&#101;com&#102;&#111;&#114;t&#46;co&#46;ke\">&#66;&#111;okin&#103;s&#64;a&#98;&#115;&#111;&#108;&#117;t&#101;com&#102;&#111;&#114;t&#46;co&#46;ke</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:41:08", "2017-06-09 22:41:08", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("163", "1", "2017-06-10 02:41:09", "2017-06-09 22:41:09", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-162-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-162-2-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;okin&#103;s&#64;a&#98;&#115;&#111;&#108;&#117;t&#101;com&#102;&#111;&#114;t&#46;co&#46;ke\">&#66;&#111;okin&#103;s&#64;a&#98;&#115;&#111;&#108;&#117;t&#101;com&#102;&#111;&#114;t&#46;co&#46;ke</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 02:41:09", "2017-06-09 22:41:09", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("164", "1", "2017-06-14 18:17:50", "2017-06-14 14:17:50", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n<p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-autosave-v1", "", "", "2017-06-14 18:17:50", "2017-06-14 14:17:50", "", "7", "http://localhost/actfinal/7-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("165", "1", "2017-06-10 02:44:13", "2017-06-09 22:44:13", "<div id=\"pl-165\"  class=\"panel-layout\" ><div id=\"pg-165-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-165-0\" ><div id=\"pgc-165-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-165-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p>&nbsp;</p>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p>&nbsp;</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 02:44:13", "2017-06-09 22:44:13", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("166", "1", "2017-06-10 02:44:13", "2017-06-09 22:44:13", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p>&nbsp;</p>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p>&nbsp;</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 02:44:13", "2017-06-09 22:44:13", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("167", "1", "2017-06-10 02:48:32", "2017-06-09 22:48:32", "<div id=\"pl-167\"  class=\"panel-layout\" ><div id=\"pg-167-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-167-0\" ><div id=\"pgc-167-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-167-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-167-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-167-1\" ><div id=\"pgc-167-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-167-1-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Fast, Safe, Easy online booking. Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 02:48:33", "2017-06-09 22:48:33", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("168", "1", "2017-06-10 02:48:33", "2017-06-09 22:48:33", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-167-1-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Fast, Safe, Easy online booking. Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 02:48:33", "2017-06-09 22:48:33", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("170", "1", "2017-06-10 02:50:31", "2017-06-09 22:50:31", "{\n    \"sydney-child::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com-1.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com-1.jpg\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-taxi-1209542_com-1.jpg\",\n            \"timestamp\": 1497048610082,\n            \"attachment_id\": 169,\n            \"width\": 1920,\n            \"height\": 599\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::header_height\": {\n        \"value\": \"350\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "79543407-4638-46bf-9032-0fb15f18994c", "", "", "2017-06-10 02:50:31", "2017-06-09 22:50:31", "", "0", "http://localhost/actfinal/79543407-4638-46bf-9032-0fb15f18994c/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("171", "1", "2017-06-10 02:50:57", "2017-06-09 22:50:57", "{\n    \"sydney-child::menu_style\": {\n        \"value\": \"centered\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "1a956ee8-08a8-42ab-887d-c6c293a7a3f4", "", "", "2017-06-10 02:50:57", "2017-06-09 22:50:57", "", "0", "http://localhost/actfinal/1a956ee8-08a8-42ab-887d-c6c293a7a3f4/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("172", "1", "2017-06-10 02:52:22", "2017-06-09 22:52:22", "{\n    \"sydney-child::header_height\": {\n        \"value\": \"300\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "8eb59c1f-9dd4-41b5-9aff-7f269af4a449", "", "", "2017-06-10 02:52:22", "2017-06-09 22:52:22", "", "0", "http://localhost/actfinal/8eb59c1f-9dd4-41b5-9aff-7f269af4a449/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("173", "1", "2017-06-10 02:53:53", "2017-06-09 22:53:53", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"site_icon\": {\n        \"value\": 174,\n        \"type\": \"option\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "53ec0286-2708-491a-9086-52201a05433d", "", "", "2017-06-10 02:53:53", "2017-06-09 22:53:53", "", "0", "http://localhost/actfinal/?p=173", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("174", "1", "2017-06-10 02:53:39", "2017-06-09 22:53:39", "http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1.png", "cropped-cropped-logo-absolute-comfort-1.png", "", "inherit", "open", "closed", "", "cropped-cropped-logo-absolute-comfort-1-png", "", "", "2017-06-14 13:28:59", "2017-06-14 09:28:59", "", "7", "http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `act_posts` VALUES("175", "1", "2017-06-10 02:55:05", "2017-06-09 22:55:05", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "d941da21-33a9-4c34-a184-4eb197860285", "", "", "2017-06-10 02:55:05", "2017-06-09 22:55:05", "", "0", "http://localhost/actfinal/?p=175", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("176", "1", "2017-06-10 02:56:40", "2017-06-09 22:56:40", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "4b1f600d-e980-464a-93ac-dc0a38995d31", "", "", "2017-06-10 02:56:40", "2017-06-09 22:56:40", "", "0", "http://localhost/actfinal/4b1f600d-e980-464a-93ac-dc0a38995d31/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("177", "1", "2017-06-10 03:01:17", "2017-06-09 23:01:17", "<div id=\"pl-177\"  class=\"panel-layout\" ><div id=\"pg-177-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-177-0\" ><div id=\"pgc-177-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-177-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-177-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-177-1\" ><div id=\"pgc-177-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-177-1-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:01:17", "2017-06-09 23:01:17", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("178", "1", "2017-06-10 03:01:18", "2017-06-09 23:01:18", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-177-1-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:01:18", "2017-06-09 23:01:18", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("179", "1", "2017-06-10 03:01:29", "2017-06-09 23:01:29", "<div id=\"pl-179\"  class=\"panel-layout\" ><div id=\"pg-179-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-179-0\" ><div id=\"pgc-179-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-179-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-179-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-179-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-179-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-179-1\" ><div id=\"pgc-179-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-179-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-179-2\" ><div id=\"pgc-179-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-179-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-179-3\" ><div id=\"pgc-179-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;oking&#115;&#64;a&#98;&#115;&#111;&#108;u&#116;ecom&#102;or&#116;&#46;c&#111;&#46;&#107;e\">&#66;&#111;oking&#115;&#64;a&#98;&#115;&#111;&#108;u&#116;ecom&#102;or&#116;&#46;c&#111;&#46;&#107;e</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:01:30", "2017-06-09 23:01:30", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("180", "1", "2017-06-10 03:01:31", "2017-06-09 23:01:31", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-5-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-5-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-179-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;oking&#115;&#64;a&#98;&#115;&#111;&#108;u&#116;ecom&#102;or&#116;&#46;c&#111;&#46;&#107;e\">&#66;&#111;oking&#115;&#64;a&#98;&#115;&#111;&#108;u&#116;ecom&#102;or&#116;&#46;c&#111;&#46;&#107;e</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:01:31", "2017-06-09 23:01:31", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("181", "1", "2017-06-10 03:06:29", "2017-06-09 23:06:29", "<div id=\"pl-181\"  class=\"panel-layout\" ><div id=\"pg-181-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-181-0\" ><div id=\"pgc-181-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-181-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-181-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-181-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-181-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-181-1\" ><div id=\"pgc-181-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-1-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Why Choose Us</h3>\n		<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n		<ul class=\'roll-list\'><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in  good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul>\n					<a class=\"roll-button border\" href=\"http://localhost/actfinal/about-us/\">Read More</a>\n				\n		</div></div></div></div><div id=\"pg-181-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-181-2\" ><div id=\"pgc-181-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-2-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-181-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-181-3\" ><div id=\"pgc-181-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-181-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-181-4\" ><div id=\"pgc-181-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-4-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;ok&#105;&#110;g&#115;&#64;&#97;&#98;sol&#117;&#116;&#101;&#99;o&#109;&#102;&#111;&#114;t.&#99;o.k&#101;\">&#66;&#111;ok&#105;&#110;g&#115;&#64;&#97;&#98;sol&#117;&#116;&#101;&#99;o&#109;&#102;&#111;&#114;t.&#99;o.k&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:06:30", "2017-06-09 23:06:30", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("182", "1", "2017-06-10 03:06:30", "2017-06-09 23:06:30", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-5-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-5-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Why Choose Us</h3>\n		<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n		<ul class=\'roll-list\'><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in  good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul>\n					<a class=\"roll-button border\" href=\"http://localhost/actfinal/about-us/\">Read More</a>\n				\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-2-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-4\" ><div id=\"pgc-5-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-181-4-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;ok&#105;&#110;g&#115;&#64;&#97;&#98;sol&#117;&#116;&#101;&#99;o&#109;&#102;&#111;&#114;t.&#99;o.k&#101;\">&#66;&#111;ok&#105;&#110;g&#115;&#64;&#97;&#98;sol&#117;&#116;&#101;&#99;o&#109;&#102;&#111;&#114;t.&#99;o.k&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:06:30", "2017-06-09 23:06:30", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("183", "1", "2017-06-10 03:08:42", "2017-06-09 23:08:42", "<div id=\"pl-183\"  class=\"panel-layout\" ><div id=\"pg-183-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-183-0\" ><div id=\"pgc-183-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-183-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-183-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-183-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-183-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-183-1\" ><div id=\"pgc-183-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-183-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-183-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-183-2\" ><div id=\"pgc-183-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-183-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-183-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-183-3\" ><div id=\"pgc-183-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-183-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;&#111;k&#105;&#110;&#103;s&#64;&#97;&#98;&#115;olut&#101;&#99;om&#102;&#111;r&#116;.co&#46;&#107;&#101;\">&#66;&#111;&#111;k&#105;&#110;&#103;s&#64;&#97;&#98;&#115;olut&#101;&#99;om&#102;&#111;r&#116;.co&#46;&#107;&#101;</a></div></div></div><div id=\"pgc-183-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-183-3-1-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:08:42", "2017-06-09 23:08:42", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("184", "1", "2017-06-10 03:08:43", "2017-06-09 23:08:43", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.37297913254042\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div><div id=\"pgc-5-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.62702086745958\" ><div id=\"panel-5-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">What we do</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-183-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-183-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-183-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;&#111;&#111;k&#105;&#110;&#103;s&#64;&#97;&#98;&#115;olut&#101;&#99;om&#102;&#111;r&#116;.co&#46;&#107;&#101;\">&#66;&#111;&#111;k&#105;&#110;&#103;s&#64;&#97;&#98;&#115;olut&#101;&#99;om&#102;&#111;r&#116;.co&#46;&#107;&#101;</a></div></div></div><div id=\"pgc-5-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-3-1-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:08:43", "2017-06-09 23:08:43", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("185", "1", "2017-06-10 03:14:34", "2017-06-09 23:14:34", "{\n    \"sydney-child::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-car-407165_com.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-car-407165_com.jpg\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-car-407165_com.jpg\",\n            \"timestamp\": 1497050064566,\n            \"attachment_id\": 187,\n            \"width\": 1920,\n            \"height\": 1307\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "0eda2c6b-0010-4b26-a627-fc13d3e04a13", "", "", "2017-06-10 03:14:34", "2017-06-09 23:14:34", "", "0", "http://localhost/actfinal/?p=185", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("188", "1", "2017-06-10 03:17:54", "2017-06-09 23:17:54", "<div id=\"pl-188\"  class=\"panel-layout\" ><div id=\"pg-188-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-188-0\" ><div id=\"pgc-188-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-188-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-188-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-188-1\" ><div id=\"pgc-188-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-188-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-188-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-188-2\" ><div id=\"pgc-188-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-188-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-188-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-188-3\" ><div id=\"pgc-188-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-188-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;ook&#105;&#110;gs&#64;&#97;&#98;&#115;&#111;lu&#116;&#101;c&#111;m&#102;&#111;&#114;&#116;&#46;c&#111;.k&#101;\">&#66;ook&#105;&#110;gs&#64;&#97;&#98;&#115;&#111;lu&#116;&#101;c&#111;m&#102;&#111;&#114;&#116;&#46;c&#111;.k&#101;</a></div></div></div><div id=\"pgc-188-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-188-3-1-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Call / Write us today</h3><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:17:54", "2017-06-09 23:17:54", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("189", "1", "2017-06-10 03:17:55", "2017-06-09 23:17:55", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-188-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-188-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-188-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;ook&#105;&#110;gs&#64;&#97;&#98;&#115;&#111;lu&#116;&#101;c&#111;m&#102;&#111;&#114;&#116;&#46;c&#111;.k&#101;\">&#66;ook&#105;&#110;gs&#64;&#97;&#98;&#115;&#111;lu&#116;&#101;c&#111;m&#102;&#111;&#114;&#116;&#46;c&#111;.k&#101;</a></div></div></div><div id=\"pgc-5-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-3-1-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Call / Write us today</h3><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:17:55", "2017-06-09 23:17:55", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("190", "1", "2017-06-10 03:18:11", "2017-06-09 23:18:11", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe, Easy, Fast, Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:&#66;o&#111;ki&#110;&#103;&#115;&#64;a&#98;&#115;o&#108;ut&#101;&#99;om&#102;or&#116;&#46;&#99;&#111;.&#107;e\">&#66;o&#111;ki&#110;&#103;&#115;&#64;a&#98;&#115;o&#108;ut&#101;&#99;om&#102;or&#116;&#46;&#99;&#111;.&#107;e</a></div></div></div><div id=\"pgc-5-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-3-1-0\" class=\"so-panel widget widget_media_image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Call / Write us today</h3><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:18:11", "2017-06-09 23:18:11", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("191", "1", "2017-06-10 03:24:34", "2017-06-09 23:24:34", "<div id=\"pl-191\"  class=\"panel-layout\" ><div id=\"pg-191-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-191-0\" ><div id=\"pgc-191-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-191-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-191-1\" ><div id=\"pgc-191-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-191-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-191-2\" ><div id=\"pgc-191-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-191-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-191-3\" ><div id=\"pgc-191-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:B&#111;o&#107;i&#110;g&#115;&#64;&#97;&#98;sol&#117;tec&#111;m&#102;&#111;rt&#46;co&#46;&#107;&#101;\">B&#111;o&#107;i&#110;g&#115;&#64;&#97;&#98;sol&#117;tec&#111;m&#102;&#111;rt&#46;co&#46;&#107;&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:24:35", "2017-06-09 23:24:35", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("192", "1", "2017-06-10 03:24:36", "2017-06-09 23:24:36", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-1-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-191-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:B&#111;o&#107;i&#110;g&#115;&#64;&#97;&#98;sol&#117;tec&#111;m&#102;&#111;rt&#46;co&#46;&#107;&#101;\">B&#111;o&#107;i&#110;g&#115;&#64;&#97;&#98;sol&#117;tec&#111;m&#102;&#111;rt&#46;co&#46;&#107;&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-10 03:24:36", "2017-06-09 23:24:36", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("193", "1", "2017-06-10 03:26:09", "2017-06-09 23:26:09", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:26:09", "2017-06-09 23:26:09", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("194", "1", "2017-06-10 03:27:13", "2017-06-09 23:27:13", "{\n    \"sydney-child::menu_style\": {\n        \"value\": \"inline\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "bb5d5da4-9552-404f-8a31-76f9239c442c", "", "", "2017-06-10 03:27:13", "2017-06-09 23:27:13", "", "0", "http://localhost/actfinal/?p=194", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("195", "1", "2017-06-10 03:39:01", "2017-06-09 23:39:01", "<div id=\"pl-195\"  class=\"panel-layout\" ><div id=\"pg-195-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-195-0\" ><div id=\"pgc-195-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-195-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate</p>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-195-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-195-1\" ><div id=\"pgc-195-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-195-1-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\n		<p>OUR MISSION<br />\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations<br />\n•	To add value by consistently providing reliable quality services to our customers<br />\nOUR VISION<br />\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n		<ul class=\'roll-list\'><li> Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li>Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li>Community and Environment: we strive to help and improve the communities where we work and live</li><li> Integrity: we act with honesty and integrity, not compromising the truth</li><li> Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.</li><li>Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. </li><li>We respect all individuals and value their contributions.</li></ul>\n    Open communication: All team members are encouraged to openly share their opinions and views.				\n		</div></div></div></div><div id=\"pg-195-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-195-2\" ><div id=\"pgc-195-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-195-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:39:02", "2017-06-09 23:39:02", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("196", "1", "2017-06-10 03:39:02", "2017-06-09 23:39:02", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rate</p>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\n		<p>OUR MISSION<br />\n•	To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations<br />\n•	To add value by consistently providing reliable quality services to our customers<br />\nOUR VISION<br />\nTo be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n		<ul class=\'roll-list\'><li> Customer Service Excellence: We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li>Team Work: Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li>Community and Environment: we strive to help and improve the communities where we work and live</li><li> Integrity: we act with honesty and integrity, not compromising the truth</li><li> Passion for results: we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high ^quality products and services.</li><li>Respect: we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. </li><li>We respect all individuals and value their contributions.</li></ul>\n    Open communication: All team members are encouraged to openly share their opinions and views.				\n		</div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-2\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-195-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:39:02", "2017-06-09 23:39:02", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("197", "1", "2017-06-10 03:47:25", "2017-06-09 23:47:25", "<div id=\"pl-197\"  class=\"panel-layout\" ><div id=\"pg-197-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-197-0\" ><div id=\"pgc-197-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-197-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em></p>\n<p><strong><em>OUR MISSION</em></strong></p>\n<ul>\n<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<p><strong><em>OUR VISION</em></strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div><div id=\"pg-197-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-197-1\" ><div id=\"pgc-197-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-197-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Taxi / Cab Services</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-197-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-197-2\" ><div id=\"pgc-197-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-197-2-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Why Choose Us?</h3>\n				<ul class=\'roll-list\'><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in  good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul>				\n		</div></div><div id=\"pgc-197-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-197-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div><div id=\"pg-197-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-197-3\" ><div id=\"pgc-197-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-197-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:47:25", "2017-06-09 23:47:25", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("198", "1", "2017-06-10 03:47:25", "2017-06-09 23:47:25", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em></p>\n<p><strong><em>OUR MISSION</em></strong></p>\n<ul>\n<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<p><strong><em>OUR VISION</em></strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Taxi / Cab Services</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-2\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Why Choose Us?</h3>\n				<ul class=\'roll-list\'><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in  good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul>				\n		</div></div><div id=\"pgc-7-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-3\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-197-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:47:25", "2017-06-09 23:47:25", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("199", "1", "2017-06-10 03:54:05", "2017-06-09 23:54:05", "<div id=\"pl-199\"  class=\"panel-layout\" ><div id=\"pg-199-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-199-0\" ><div id=\"pgc-199-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-199-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em></p>\n<p><strong><em>OUR MISSION</em></strong></p>\n<ul>\n<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<p><strong><em>OUR VISION</em></strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:54:05", "2017-06-09 23:54:05", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("200", "1", "2017-06-10 03:54:06", "2017-06-09 23:54:06", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office <em>is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</em></p>\n<p><strong><em>OUR MISSION</em></strong></p>\n<ul>\n<li><em>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</em></li>\n<li><em>To add value by consistently providing reliable quality services to our customers</em></li>\n</ul>\n<p><strong><em>OUR VISION</em></strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-10 03:54:06", "2017-06-09 23:54:06", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("201", "1", "2017-06-11 00:43:46", "2017-06-10 20:43:46", "<div id=\"pl-201\"  class=\"panel-layout\" ><div id=\"pg-201-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-201-0\" ><div id=\"pgc-201-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-201-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-201-1\" ><div id=\"pgc-201-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-201-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-201-2\" ><div id=\"pgc-201-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-201-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-201-3\" ><div id=\"pgc-201-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:B&#111;&#111;&#107;&#105;&#110;gs&#64;ab&#115;&#111;lute&#99;o&#109;&#102;&#111;&#114;t&#46;c&#111;.&#107;&#101;\">B&#111;&#111;&#107;&#105;&#110;gs&#64;ab&#115;&#111;lute&#99;o&#109;&#102;&#111;&#114;t&#46;c&#111;.&#107;&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 00:43:47", "2017-06-10 20:43:47", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("202", "1", "2017-06-11 00:43:48", "2017-06-10 20:43:48", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-201-3-0-0\" class=\"so-panel widget widget_sydney_contact_info sydney_contact_info_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Contact Info</h3><div class=\"contact-address\"><span><i class=\"fa fa-home\"></i></span>Absolute Comfort Travel - Silver Pool Office Suites - P O Box 24716 – 00502 Karen</div><div class=\"contact-phone\"><span><i class=\"fa fa-phone\"></i></span>+254797 119 418, +254789 122 834</div><div class=\"contact-email\"><span><i class=\"fa fa-envelope\"></i></span><a href=\"mailto:B&#111;&#111;&#107;&#105;&#110;gs&#64;ab&#115;&#111;lute&#99;o&#109;&#102;&#111;&#114;t&#46;c&#111;.&#107;&#101;\">B&#111;&#111;&#107;&#105;&#110;gs&#64;ab&#115;&#111;lute&#99;o&#109;&#102;&#111;&#114;t&#46;c&#111;.&#107;&#101;</a></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 00:43:48", "2017-06-10 20:43:48", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("203", "1", "2017-06-11 01:01:10", "2017-06-10 21:01:10", "<div id=\"pl-203\"  class=\"panel-layout\" ><div id=\"pg-203-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-203-0\" ><div id=\"pgc-203-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-203-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-203-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-203-1\" ><div id=\"pgc-203-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-203-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-203-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-203-2\" ><div id=\"pgc-203-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-203-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-203-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-203-3\" ><div id=\"pgc-203-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-203-3-0-0\" class=\"so-panel widget widget_sydney_services_type_b sydney_services_b_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			\r\n				<div class=\"roll-icon-list\">\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n									</div>	\r\n\r\n								\r\n	</div></div><div id=\"pgc-203-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-203-3-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:01:10", "2017-06-10 21:01:10", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("204", "1", "2017-06-11 01:01:11", "2017-06-10 21:01:11", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-203-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-203-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-203-3-0-0\" class=\"so-panel widget widget_sydney_services_type_b sydney_services_b_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			\r\n				<div class=\"roll-icon-list\">\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n									</div>	\r\n\r\n								\r\n	</div></div><div id=\"pgc-5-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-203-3-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:01:11", "2017-06-10 21:01:11", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("205", "1", "2017-06-11 01:01:30", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2017-06-11 01:01:30", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?post_type=services&p=205", "0", "services", "", "0");
INSERT INTO `act_posts` VALUES("206", "1", "2017-06-11 01:04:28", "2017-06-10 21:04:28", "<div id=\"pl-206\"  class=\"panel-layout\" ><div id=\"pg-206-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-206-0\" ><div id=\"pgc-206-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-206-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-206-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-206-1\" ><div id=\"pgc-206-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-206-1-0-0\" class=\"so-panel widget widget_media_image panel-first-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div><div id=\"panel-206-1-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-206-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-206-2\" ><div id=\"pgc-206-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-206-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-206-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-206-3\" ><div id=\"pgc-206-3-0\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"0.5\" ></div><div id=\"pgc-206-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-206-3-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:04:28", "2017-06-10 21:04:28", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("207", "1", "2017-06-11 01:04:29", "2017-06-10 21:04:29", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-206-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_media_image panel-first-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><img width=\"300\" height=\"118\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png\" class=\"image wp-image-59  attachment-medium size-medium\" alt=\"\" style=\"max-width: 100%; height: auto;\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort-300x118.png 300w, http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png 552w\" sizes=\"(max-width: 300px) 100vw, 300px\" /></div><div id=\"panel-5-1-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-206-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"0.5\" ></div><div id=\"pgc-5-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-206-3-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:04:29", "2017-06-10 21:04:29", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("208", "1", "2017-06-11 01:05:43", "2017-06-10 21:05:43", "<div id=\"pl-208\"  class=\"panel-layout\" ><div id=\"pg-208-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-208-0\" ><div id=\"pgc-208-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-208-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-208-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-208-1\" ><div id=\"pgc-208-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-208-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-208-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-208-2\" ><div id=\"pgc-208-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-208-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-208-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-208-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:05:44", "2017-06-10 21:05:44", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("209", "1", "2017-06-11 01:05:44", "2017-06-10 21:05:44", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-208-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-208-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-208-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n		   \r\n		 \r\n		 \r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:05:44", "2017-06-10 21:05:44", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("210", "1", "2017-06-11 01:12:29", "2017-06-10 21:12:29", "<div id=\"pl-210\"  class=\"panel-layout\" ><div id=\"pg-210-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-210-0\" ><div id=\"pgc-210-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-210-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-210-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-210-1\" ><div id=\"pgc-210-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-210-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-210-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-210-2\" ><div id=\"pgc-210-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-210-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-210-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-210-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:12:29", "2017-06-10 21:12:29", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("211", "1", "2017-06-11 01:12:29", "2017-06-10 21:12:29", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-210-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-210-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-210-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:12:29", "2017-06-10 21:12:29", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("212", "1", "2017-06-11 01:38:46", "2017-06-10 21:38:46", "<div id=\"pl-212\"  class=\"panel-layout\" ><div id=\"pg-212-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-212-0\" ><div id=\"pgc-212-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-212-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-212-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-212-1\" ><div id=\"pgc-212-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-212-1-0-0\" class=\"so-panel widget widget_sydney_services_type_b sydney_services_b_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Services</h3>\r\n				<div class=\"roll-icon-list\">\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n									</div>	\r\n\r\n								\r\n	</div></div></div></div><div id=\"pg-212-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-212-2\" ><div id=\"pgc-212-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-212-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-212-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-212-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:38:47", "2017-06-10 21:38:47", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("213", "1", "2017-06-11 01:38:47", "2017-06-10 21:38:47", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-212-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-212-1-0-0\" class=\"so-panel widget widget_sydney_services_type_b sydney_services_b_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Services</h3>\r\n				<div class=\"roll-icon-list\">\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																							<div class=\"service clearfix \">\r\n							<div class=\"list-item\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n									</div>	\r\n\r\n								\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-212-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-212-2-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 01:38:47", "2017-06-10 21:38:47", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("214", "1", "2017-06-11 01:58:10", "2017-06-10 21:58:10", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#6a5acd\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::site_title_color\": {\n        \"value\": \"#9acd32\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "98f19bd5-474e-4591-aa6a-2747870713cd", "", "", "2017-06-11 01:58:10", "2017-06-10 21:58:10", "", "0", "http://localhost/actfinal/?p=214", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("215", "1", "2017-06-11 02:00:35", "2017-06-10 22:00:35", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#9acd32\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::sidebar_background\": {\n        \"value\": \"#6a5acd\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::footer_widgets_background\": {\n        \"value\": \"#6a5acd\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::footer_widgets_color\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#6a5acd\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "0f186037-dbb3-4c17-80e5-6363842c1803", "", "", "2017-06-11 02:00:35", "2017-06-10 22:00:35", "", "0", "http://localhost/actfinal/?p=215", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("216", "1", "2017-06-11 02:02:35", "2017-06-10 22:02:35", "{\n    \"sydney-child::sidebar_background\": {\n        \"value\": \"#e5e5e5\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "af26009d-079d-4664-879b-fb243def2fbf", "", "", "2017-06-11 02:02:35", "2017-06-10 22:02:35", "", "0", "http://localhost/actfinal/af26009d-079d-4664-879b-fb243def2fbf/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("217", "1", "2017-06-11 02:04:32", "2017-06-10 22:04:32", "{\n    \"sydney-child::footer_widgets_background\": {\n        \"value\": \"#252525\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::footer_widgets_color\": {\n        \"value\": \"#767676\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#9acd32\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "e42028d9-9ca7-4dcd-8675-761a56cf8086", "", "", "2017-06-11 02:04:32", "2017-06-10 22:04:32", "", "0", "http://localhost/actfinal/?p=217", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("218", "1", "2017-06-11 02:05:03", "2017-06-10 22:05:03", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#9acd32\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "b6d99461-e4ed-442f-af1f-b3a57bc2df54", "", "", "2017-06-11 02:05:03", "2017-06-10 22:05:03", "", "0", "http://localhost/actfinal/b6d99461-e4ed-442f-af1f-b3a57bc2df54/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("219", "1", "2017-06-11 03:02:32", "2017-06-10 23:02:32", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#8470ff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "fc493731-b530-4ec6-a620-546e762eba4c", "", "", "2017-06-11 03:02:32", "2017-06-10 23:02:32", "", "0", "http://localhost/actfinal/?p=219", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("220", "1", "2017-06-11 03:03:56", "2017-06-10 23:03:56", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#6959cd\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "f62bce57-50e3-473e-8df6-b4a26e356943", "", "", "2017-06-11 03:03:56", "2017-06-10 23:03:56", "", "0", "http://localhost/actfinal/f62bce57-50e3-473e-8df6-b4a26e356943/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("221", "1", "2017-06-11 03:11:17", "2017-06-10 23:11:17", "<div id=\"pl-221\"  class=\"panel-layout\" ><div id=\"pg-221-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-221-0\" ><div id=\"pgc-221-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-221-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-221-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-221-1\" ><div id=\"pgc-221-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-221-1-0-0\" class=\"so-panel widget widget_sydney_facts sydney_facts_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n				<div class=\"col-md-3 col-sm-3\">\r\n			<div class=\"roll-counter\">\r\n				<i class=\"fa \"></i>\r\n				<div class=\"name-count\">cOMPETENT dRIVERS</div>\r\n				<div class=\"numb-count\" data-to=\"0\" data-speed=\"2000\" data-waypoint-active=\"yes\">0</div>\r\n			</div>\r\n		</div>\r\n								\r\n	</div></div><div id=\"pgc-221-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-221-1-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div><div id=\"pg-221-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-221-2\" ><div id=\"pgc-221-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-221-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 03:11:17", "2017-06-10 23:11:17", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("222", "1", "2017-06-11 03:11:18", "2017-06-10 23:11:18", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-221-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-221-1-0-0\" class=\"so-panel widget widget_sydney_facts sydney_facts_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		\r\n				<div class=\"col-md-3 col-sm-3\">\r\n			<div class=\"roll-counter\">\r\n				<i class=\"fa \"></i>\r\n				<div class=\"name-count\">cOMPETENT dRIVERS</div>\r\n				<div class=\"numb-count\" data-to=\"0\" data-speed=\"2000\" data-waypoint-active=\"yes\">0</div>\r\n			</div>\r\n		</div>\r\n								\r\n	</div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-221-1-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-221-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 03:11:18", "2017-06-10 23:11:18", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("223", "1", "2017-06-11 03:14:35", "2017-06-10 23:14:35", "<div id=\"pl-223\"  class=\"panel-layout\" ><div id=\"pg-223-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-223-0\" ><div id=\"pgc-223-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-223-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-223-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-223-1\" ><div id=\"pgc-223-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-223-1-0-0\" class=\"so-panel widget widget_cl-itext widget-cl-itext panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h2 class=\"cl-itext type_fadeIn align_center dynamic_bold cl_custom_css_1\" style=\"font-size:50px;\" onclick=\'return {\"duration\":300,\"delay\":5000}\'>We create great <span class=\"cl-itext-part changesat_0 changesat_1 changesat_2 dynamic\" onclick=\'return [\"design\",\"websites\",\"code\"]\'>design</span></h2><style type=\"text/css\">@media only screen and (max-width: 599px) {.cl_custom_css_1 { font-size: 30px !important; }}</style></div></div><div id=\"pgc-223-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-223-1-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div><div id=\"pg-223-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-223-2\" ><div id=\"pgc-223-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-223-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 03:14:35", "2017-06-10 23:14:35", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("224", "1", "2017-06-11 03:14:36", "2017-06-10 23:14:36", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-0\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-223-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n									<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n									<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n									<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n								</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_cl-itext widget-cl-itext panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h2 class=\"cl-itext type_fadeIn align_center dynamic_bold cl_custom_css_2\" style=\"font-size:50px;\" onclick=\'return {\"duration\":300,\"delay\":5000}\'>We create great <span class=\"cl-itext-part changesat_0 changesat_1 changesat_2 dynamic\" onclick=\'return [\"design\",\"websites\",\"code\"]\'>design</span></h2><style type=\"text/css\">@media only screen and (max-width: 599px) {.cl_custom_css_2 { font-size: 30px !important; }}</style></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-223-1-1-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;column_padding&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-223-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-11 03:14:36", "2017-06-10 23:14:36", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("226", "1", "2017-06-12 02:36:31", "2017-06-11 22:36:31", "{\n    \"sydney-child::slider_button_text\": {\n        \"value\": \"Book Now\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_1\": {\n        \"value\": \"We Do airport Transfers\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_image_1\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_4.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "1e253847-35d8-493f-977d-1eefaa6f8d44", "", "", "2017-06-12 02:36:31", "2017-06-11 22:36:31", "", "0", "http://localhost/actfinal/?p=226", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("227", "1", "2017-06-12 01:31:58", "2017-06-11 21:31:58", "<div id=\"pl-227\"  class=\"panel-layout\" ><div id=\"pg-227-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-227-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-227-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-227-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-227-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-227-1\" ><div id=\"pgc-227-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-227-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div><div id=\"pgc-227-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-227-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-227-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img title=\"Superior service\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-227-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-227-2\" ><div id=\"pgc-227-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-227-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 01:32:00", "2017-06-11 21:32:00", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("228", "1", "2017-06-12 01:32:00", "2017-06-11 21:32:00", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img title=\"Superior service\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 01:32:00", "2017-06-11 21:32:00", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("231", "1", "2017-06-12 03:19:22", "2017-06-11 23:19:22", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 03:19:22", "2017-06-11 23:19:22", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("232", "1", "2017-06-12 03:21:11", "2017-06-11 23:21:11", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a7e5be&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 03:21:11", "2017-06-11 23:21:11", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("233", "1", "2017-06-12 03:21:22", "2017-06-11 23:21:22", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a7e5be&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 03:21:22", "2017-06-11 23:21:22", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("234", "1", "2017-06-14 14:28:37", "2017-06-14 10:28:37", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\n																													<div class=\"service col-md-4\">\n													<div class=\"roll-icon-box\">\n											\n									<div class=\"icon\">\n																					<i class=\"fa fa-support\"></i>																			</div>\n																<div class=\"content\">\n									<h3>\n																					Available around the clock																			</h3>\n																	\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\n							</div>\n						</div>\n																													<div class=\"service col-md-4\">\n													<div class=\"roll-icon-box\">\n											\n									<div class=\"icon\">\n																					<i class=\"fa fa-check\"></i>																			</div>\n																<div class=\"content\">\n									<h3>\n																					Excellent customer service																			</h3>\n																	\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\n							</div>\n						</div>\n																													<div class=\"service col-md-4\">\n													<div class=\"roll-icon-box\">\n											\n									<div class=\"icon\">\n																					<i class=\"fa fa-taxi\"></i>																			</div>\n																<div class=\"content\">\n									<h3>\n																					Superior service																			</h3>\n																	\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\n							</div>\n						</div>\n					\n								\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\n				<div class=\"roll-progress\">\n 			<div class=\"name\">Competent Skilled Drivers</div>\n			<div class=\"perc\">100%</div>\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\n				<div class=\"progress-animate\"></div>\n			</div>\n		</div>\n		   \n				<div class=\"roll-progress\">\n 			<div class=\"name\">Clean Vehicles</div>\n			<div class=\"perc\">100%</div>\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\n				<div class=\"progress-animate\"></div>\n			</div>\n		</div>\n		 \n				<div class=\"roll-progress\">\n 			<div class=\"name\">Affordable Rates</div>\n			<div class=\"perc\">100%</div>\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\n				<div class=\"progress-animate\"></div>\n			</div>\n		</div>\n		 \n				<div class=\"roll-progress\">\n 			<div class=\"name\">Customer Service</div>\n			<div class=\"perc\">100%</div>\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\n				<div class=\"progress-animate\"></div>\n			</div>\n		</div>\n		 \n\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\n			<div class=\"promo-wrap\">\n								<div class=\"promo-content\">\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\n				</div>\n								<div class=\"promo-controls\">\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\n				</div>\n			</div>\n        </div>\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-autosave-v1", "", "", "2017-06-14 14:28:37", "2017-06-14 10:28:37", "", "5", "http://localhost/actfinal/5-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("235", "1", "2017-06-12 03:24:13", "2017-06-11 23:24:13", "<div id=\"pl-235\"  class=\"panel-layout\" ><div id=\"pg-235-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-235-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-235-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-235-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-235-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-235-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-235-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-235-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-235-1-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-235-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-235-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-235-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-235-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-235-2\" ><div id=\"pgc-235-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-235-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 03:24:13", "2017-06-11 23:24:13", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("236", "1", "2017-06-12 03:24:14", "2017-06-11 23:24:14", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/taxi-1209542_com.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/05/act_7.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/05/act_7-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-2\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-12 03:24:14", "2017-06-11 23:24:14", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("241", "1", "2017-06-13 03:34:30", "2017-06-12 23:34:30", "", "act_1_plain", "", "inherit", "open", "closed", "", "act_1_plain", "", "", "2017-06-13 03:34:30", "2017-06-12 23:34:30", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_1_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("242", "1", "2017-06-13 03:34:35", "2017-06-12 23:34:35", "", "act_2_plain", "", "inherit", "open", "closed", "", "act_2_plain", "", "", "2017-06-13 03:34:35", "2017-06-12 23:34:35", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_2_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("243", "1", "2017-06-13 03:34:39", "2017-06-12 23:34:39", "", "act_3_plain", "", "inherit", "open", "closed", "", "act_3_plain", "", "", "2017-06-13 03:34:39", "2017-06-12 23:34:39", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_3_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("244", "1", "2017-06-13 03:34:44", "2017-06-12 23:34:44", "", "act_4_plain", "", "inherit", "open", "closed", "", "act_4_plain", "", "", "2017-06-13 03:34:44", "2017-06-12 23:34:44", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_4_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("245", "1", "2017-06-13 03:34:48", "2017-06-12 23:34:48", "", "act_5_plain", "", "inherit", "open", "closed", "", "act_5_plain", "", "", "2017-06-13 03:34:48", "2017-06-12 23:34:48", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("246", "1", "2017-06-13 03:34:52", "2017-06-12 23:34:52", "", "act_6_plain", "", "inherit", "open", "closed", "", "act_6_plain", "", "", "2017-06-13 03:34:52", "2017-06-12 23:34:52", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_6_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("247", "1", "2017-06-13 03:34:57", "2017-06-12 23:34:57", "", "act_7_plain", "", "inherit", "open", "closed", "", "act_7_plain", "", "", "2017-06-13 03:34:57", "2017-06-12 23:34:57", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("248", "1", "2017-06-13 03:35:01", "2017-06-12 23:35:01", "", "act_8_plain", "", "inherit", "open", "closed", "", "act_8_plain", "", "", "2017-06-13 03:35:01", "2017-06-12 23:35:01", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("249", "1", "2017-06-13 03:35:05", "2017-06-12 23:35:05", "", "act_9_plain", "", "inherit", "open", "closed", "", "act_9_plain", "", "", "2017-06-13 03:35:05", "2017-06-12 23:35:05", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("250", "1", "2017-06-13 03:35:10", "2017-06-12 23:35:10", "", "act_10_plain", "", "inherit", "open", "closed", "", "act_10_plain", "", "", "2017-06-13 03:35:10", "2017-06-12 23:35:10", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_10_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("251", "1", "2017-06-13 03:35:14", "2017-06-12 23:35:14", "", "act_11_plain", "", "inherit", "open", "closed", "", "act_11_plain", "", "", "2017-06-13 03:35:14", "2017-06-12 23:35:14", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("252", "1", "2017-06-13 03:35:18", "2017-06-12 23:35:18", "", "act_12_plain", "", "inherit", "open", "closed", "", "act_12_plain", "", "", "2017-06-14 13:32:19", "2017-06-14 09:32:19", "", "7", "http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("253", "1", "2017-06-13 03:35:43", "2017-06-12 23:35:43", "", "act_1_screened", "", "inherit", "open", "closed", "", "act_1_screened", "", "", "2017-06-13 03:35:43", "2017-06-12 23:35:43", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_1_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("254", "1", "2017-06-13 03:35:48", "2017-06-12 23:35:48", "", "act_2_screened", "", "inherit", "open", "closed", "", "act_2_screened", "", "", "2017-06-13 03:35:48", "2017-06-12 23:35:48", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_2_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("255", "1", "2017-06-13 03:35:52", "2017-06-12 23:35:52", "", "act_3_screened", "", "inherit", "open", "closed", "", "act_3_screened", "", "", "2017-06-13 03:35:52", "2017-06-12 23:35:52", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_3_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("256", "1", "2017-06-13 03:35:56", "2017-06-12 23:35:56", "", "act_4_screened", "", "inherit", "open", "closed", "", "act_4_screened", "", "", "2017-06-13 03:35:56", "2017-06-12 23:35:56", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("257", "1", "2017-06-13 03:36:01", "2017-06-12 23:36:01", "", "act_5_screened", "", "inherit", "open", "closed", "", "act_5_screened", "", "", "2017-06-13 03:36:01", "2017-06-12 23:36:01", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_5_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("258", "1", "2017-06-13 03:36:05", "2017-06-12 23:36:05", "", "act_6_screened", "", "inherit", "open", "closed", "", "act_6_screened", "", "", "2017-06-13 03:36:05", "2017-06-12 23:36:05", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_6_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("259", "1", "2017-06-13 03:36:11", "2017-06-12 23:36:11", "", "act_7_screened", "", "inherit", "open", "closed", "", "act_7_screened", "", "", "2017-06-13 03:36:11", "2017-06-12 23:36:11", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("260", "1", "2017-06-13 03:36:16", "2017-06-12 23:36:16", "", "act_8_screened", "", "inherit", "open", "closed", "", "act_8_screened", "", "", "2017-06-13 03:36:16", "2017-06-12 23:36:16", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_8_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("261", "1", "2017-06-13 03:36:20", "2017-06-12 23:36:20", "", "act_9_screened", "", "inherit", "open", "closed", "", "act_9_screened", "", "", "2017-06-13 03:36:20", "2017-06-12 23:36:20", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_9_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("262", "1", "2017-06-13 03:36:24", "2017-06-12 23:36:24", "", "act_10_screened", "", "inherit", "open", "closed", "", "act_10_screened", "", "", "2017-06-13 03:36:24", "2017-06-12 23:36:24", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_10_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("263", "1", "2017-06-13 03:36:29", "2017-06-12 23:36:29", "", "act_11_screened", "", "inherit", "open", "closed", "", "act_11_screened", "", "", "2017-06-13 03:36:29", "2017-06-12 23:36:29", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_11_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("264", "1", "2017-06-13 03:36:33", "2017-06-12 23:36:33", "", "act_12_screened", "", "inherit", "open", "closed", "", "act_12_screened", "", "", "2017-06-13 03:36:33", "2017-06-12 23:36:33", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/act_12_screened.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("265", "1", "2017-06-13 03:39:13", "2017-06-12 23:39:13", "{\n    \"sydney-child::header_image\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\",\n            \"thumbnail_url\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_7_screened.jpg\",\n            \"timestamp\": 1497310736930,\n            \"attachment_id\": 259,\n            \"width\": 1920,\n            \"height\": 1400\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "7f33472b-4dad-430c-9b51-a8765cb03e4d", "", "", "2017-06-13 03:39:13", "2017-06-12 23:39:13", "", "0", "http://localhost/actfinal/?p=265", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("266", "1", "2017-06-13 03:43:55", "2017-06-12 23:43:55", "{\n    \"sydney-child::slider_image_1\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_5_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_image_2\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_image_3\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_image_4\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_3_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_image_5\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_2_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "0c5dccbc-caa4-4d65-aa85-8a83d2c22866", "", "", "2017-06-13 03:43:55", "2017-06-12 23:43:55", "", "0", "http://localhost/actfinal/?p=266", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("267", "1", "2017-06-13 03:52:46", "2017-06-12 23:52:46", "{\n    \"sydney-child::slider_image_1\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/act_11_screened.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "606d0582-5240-417d-9207-30584adf1076", "", "", "2017-06-13 03:52:46", "2017-06-12 23:52:46", "", "0", "http://localhost/actfinal/?p=267", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("268", "1", "2017-06-13 03:57:15", "2017-06-12 23:57:15", "<div id=\"pl-268\"  class=\"panel-layout\" ><div id=\"pg-268-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-268-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-268-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-268-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-268-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-268-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-268-1\" ><div id=\"pgc-268-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-268-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-268-1-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-268-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-268-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-268-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-268-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-268-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-268-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-268-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-268-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-268-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-268-3\" ><div id=\"pgc-268-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-268-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 03:57:16", "2017-06-12 23:57:16", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("269", "1", "2017-06-13 03:57:17", "2017-06-12 23:57:17", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;33&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-1\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 03:57:17", "2017-06-12 23:57:17", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("270", "1", "2017-06-13 11:47:48", "2017-06-13 07:47:48", "<div id=\"pl-270\"  class=\"panel-layout\" ><div id=\"pg-270-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-270-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-270-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-270-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-270-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-270-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-270-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-270-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-270-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-270-1-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-270-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-270-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-270-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-270-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-270-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-270-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-270-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-270-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-270-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-270-3\" ><div id=\"pgc-270-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-270-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 11:47:49", "2017-06-13 07:47:49", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("271", "1", "2017-06-13 11:47:49", "2017-06-13 07:47:49", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 11:47:49", "2017-06-13 07:47:49", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("272", "1", "2017-06-13 11:49:45", "2017-06-13 07:49:45", "<div id=\"pl-272\"  class=\"panel-layout\" ><div id=\"pg-272-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-272-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-272-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-272-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-272-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-272-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-272-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-272-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-272-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-272-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-272-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-272-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-272-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-272-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-272-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-272-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-272-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-272-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-272-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-272-3\" ><div id=\"pgc-272-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-272-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 11:49:45", "2017-06-13 07:49:45", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("273", "1", "2017-06-13 11:49:46", "2017-06-13 07:49:46", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-813df796d9b1\">\n\n<div class=\"sow-image-container\">\n	<img 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;}\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 11:49:46", "2017-06-13 07:49:46", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("274", "1", "2017-06-13 12:04:02", "2017-06-13 08:04:02", "<div id=\"pl-274\"  class=\"panel-layout\" ><div id=\"pg-274-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-274-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-274-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-274-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-274-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-274-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-274-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-274-1-0-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-1-0-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div><div id=\"pgc-274-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-274-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-1-1-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-274-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-274-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-274-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-274-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-274-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-274-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-274-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-274-3\" ><div id=\"pgc-274-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-274-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-274-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:04:02", "2017-06-13 08:04:02", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("275", "1", "2017-06-13 12:04:03", "2017-06-13 08:04:03", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#e0e0e0&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#3898f7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:04:03", "2017-06-13 08:04:03", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("276", "1", "2017-06-13 12:06:53", "2017-06-13 08:06:53", "<div id=\"pl-276\"  class=\"panel-layout\" ><div id=\"pg-276-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-276-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-276-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-276-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-276-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-276-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-276-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-276-1-0-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-1-0-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div><div id=\"pgc-276-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-276-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-1-1-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-276-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-276-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-276-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-276-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-276-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-276-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-276-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-276-3\" ><div id=\"pgc-276-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-276-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-276-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:06:54", "2017-06-13 08:06:54", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("277", "1", "2017-06-13 12:06:54", "2017-06-13 08:06:54", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div><div id=\"pgc-5-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-1-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_sow-image panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><div class=\"so-widget-sow-image so-widget-sow-image-default-2b1fadbace82\">\n\n<div class=\"sow-image-container\">\n	<img src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" width=\"1920\" height=\"1300\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" 		class=\"so-widget-image\"/>\n</div>\n\n</div></div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:06:54", "2017-06-13 08:06:54", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("278", "1", "2017-06-13 12:09:20", "2017-06-13 08:09:20", "<div id=\"pl-278\"  class=\"panel-layout\" ><div id=\"pg-278-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-278-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-278-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-278-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-278-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-278-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-278-1\" style=\"text-align: center;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-278-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-278-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-278-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-278-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-278-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-278-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-278-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-278-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-278-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-278-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-278-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-278-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-278-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:09:20", "2017-06-13 08:09:20", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("279", "1", "2017-06-13 12:09:21", "2017-06-13 08:09:21", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:&quot;259&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:09:21", "2017-06-13 08:09:21", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("280", "1", "2017-06-13 12:11:15", "2017-06-13 08:11:15", "<div id=\"pl-280\"  class=\"panel-layout\" ><div id=\"pg-280-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-280-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-280-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-280-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-280-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-280-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-280-1\" style=\"text-align: center;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-280-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-280-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-280-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-280-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-280-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-280-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-280-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-280-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-280-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-280-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-280-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-280-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-280-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:11:15", "2017-06-13 08:11:15", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("281", "1", "2017-06-13 12:11:15", "2017-06-13 08:11:15", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:11:15", "2017-06-13 08:11:15", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("282", "1", "2017-06-13 12:16:09", "2017-06-13 08:16:09", "<div id=\"pl-282\"  class=\"panel-layout\" ><div id=\"pg-282-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-282-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-282-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-282-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-282-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-282-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-282-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-282-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-282-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-282-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-282-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-282-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-282-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-282-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-282-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-282-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-282-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-282-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-282-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-282-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:16:09", "2017-06-13 08:16:09", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("283", "1", "2017-06-13 12:16:10", "2017-06-13 08:16:10", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d3d3d3&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:16:10", "2017-06-13 08:16:10", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("284", "1", "2017-06-13 12:19:04", "2017-06-13 08:19:04", "<div id=\"pl-284\"  class=\"panel-layout\" ><div id=\"pg-284-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-284-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-284-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-284-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-284-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-284-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-284-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-284-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-284-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-284-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-284-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-284-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-284-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-284-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-284-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-284-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-284-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-284-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-284-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-284-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:19:05", "2017-06-13 08:19:05", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("285", "1", "2017-06-13 12:19:05", "2017-06-13 08:19:05", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:19:05", "2017-06-13 08:19:05", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("286", "1", "2017-06-13 12:23:34", "2017-06-13 08:23:34", "<div id=\"pl-286\"  class=\"panel-layout\" ><div id=\"pg-286-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-286-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-286-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-286-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-286-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-286-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-286-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-286-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-286-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-286-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-286-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-286-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-286-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-286-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-286-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-286-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-286-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-286-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-286-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-286-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:23:34", "2017-06-13 08:23:34", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("287", "1", "2017-06-13 12:23:35", "2017-06-13 08:23:35", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:23:35", "2017-06-13 08:23:35", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("288", "1", "2017-06-13 12:25:54", "2017-06-13 08:25:54", "<div id=\"pl-288\"  class=\"panel-layout\" ><div id=\"pg-288-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-288-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-288-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-288-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-288-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-288-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-288-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-288-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-288-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-288-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-288-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-288-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-288-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-288-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-288-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-288-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-288-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-288-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-288-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-288-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:25:55", "2017-06-13 08:25:55", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("289", "1", "2017-06-13 12:25:55", "2017-06-13 08:25:55", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;247&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:25:55", "2017-06-13 08:25:55", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("290", "1", "2017-06-13 12:28:20", "2017-06-13 08:28:20", "<div id=\"pl-290\"  class=\"panel-layout\" ><div id=\"pg-290-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-290-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-290-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-290-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-290-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-290-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-290-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-290-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-290-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-290-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-290-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-290-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-290-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-290-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-290-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-290-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-290-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-290-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-290-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-290-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:28:20", "2017-06-13 08:28:20", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("291", "1", "2017-06-13 12:28:21", "2017-06-13 08:28:21", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:28:21", "2017-06-13 08:28:21", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("292", "1", "2017-06-13 12:30:14", "2017-06-13 08:30:14", "<div id=\"pl-292\"  class=\"panel-layout\" ><div id=\"pg-292-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-292-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-292-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-292-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-292-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-292-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-292-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-292-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-292-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-292-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-292-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-292-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-292-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-292-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-292-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-292-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-292-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-292-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-292-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-292-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:30:15", "2017-06-13 08:30:15", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("293", "1", "2017-06-13 12:30:15", "2017-06-13 08:30:15", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:30:15", "2017-06-13 08:30:15", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("295", "1", "2017-06-13 12:40:38", "2017-06-13 08:40:38", "<div id=\"pl-295\"  class=\"panel-layout\" ><div id=\"pg-295-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-295-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-295-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-295-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-295-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-295-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-295-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-295-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-295-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-295-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-295-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-295-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-295-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-295-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-295-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-295-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-295-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-295-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-295-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-295-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-295-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-295-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-295-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:40:39", "2017-06-13 08:40:39", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("296", "1", "2017-06-13 12:40:40", "2017-06-13 08:40:40", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#000000&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#000000\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#81d742&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;249&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 12:40:40", "2017-06-13 08:40:40", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("297", "1", "2017-06-13 13:05:23", "0000-00-00 00:00:00", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#8cd790\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::site_title_color\": {\n        \"value\": \"#d7fff1\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::body_text_color\": {\n        \"value\": \"#d7fff1\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#d7fff1\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_text\": {\n        \"value\": \"#d7fff1\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "455bb0dd-82ab-48af-8723-b3491a5cc2d3", "", "", "2017-06-13 13:05:23", "2017-06-13 09:05:23", "", "0", "http://localhost/actfinal/?p=297", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("298", "1", "2017-06-13 13:07:11", "2017-06-13 09:07:11", "<div id=\"pl-298\"  class=\"panel-layout\" ><div id=\"pg-298-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-298-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-298-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-298-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-298-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-298-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-298-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-298-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-298-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-298-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-298-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-298-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-298-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-298-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-298-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-298-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-298-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-298-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-298-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-298-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-298-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-298-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-298-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 13:07:12", "2017-06-13 09:07:12", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("299", "1", "2017-06-13 13:07:12", "2017-06-13 09:07:12", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#add365&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 13:07:12", "2017-06-13 09:07:12", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("300", "1", "2017-06-13 13:08:42", "2017-06-13 09:08:42", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#285943\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::body_text_color\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "4e91b4e5-2698-4f37-9b00-ba1568301668", "", "", "2017-06-13 13:08:42", "2017-06-13 09:08:42", "", "0", "http://localhost/actfinal/4e91b4e5-2698-4f37-9b00-ba1568301668/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("301", "1", "2017-06-13 13:09:45", "2017-06-13 09:09:45", "{\n    \"sydney-child::site_title_color\": {\n        \"value\": \"#8cd790\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#8cd790\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "5e74051e-71a0-4091-9a0f-0cf9064f43ee", "", "", "2017-06-13 13:09:45", "2017-06-13 09:09:45", "", "0", "http://localhost/actfinal/?p=301", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("302", "1", "2017-06-13 13:10:20", "2017-06-13 09:10:20", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#77af9c\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "45a3ae06-0137-4af5-a8ed-fa9e362d706e", "", "", "2017-06-13 13:10:20", "2017-06-13 09:10:20", "", "0", "http://localhost/actfinal/45a3ae06-0137-4af5-a8ed-fa9e362d706e/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("303", "1", "2017-06-13 13:10:44", "2017-06-13 09:10:44", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "a940b7ec-2bb4-40b1-80f6-448c1ddd26af", "", "", "2017-06-13 13:10:44", "2017-06-13 09:10:44", "", "0", "http://localhost/actfinal/a940b7ec-2bb4-40b1-80f6-448c1ddd26af/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("305", "1", "2017-06-13 13:35:22", "2017-06-13 09:35:22", "<div id=\"pl-305\"  class=\"panel-layout\" ><div id=\"pg-305-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-305-0\" ><div id=\"pgc-305-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-305-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-305-0-0-0\" >			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-13 13:35:22", "2017-06-13 09:35:22", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("306", "1", "2017-06-13 13:35:22", "2017-06-13 09:35:22", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-0\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" >			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-13 13:35:22", "2017-06-13 09:35:22", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("307", "1", "2017-06-13 13:47:53", "2017-06-13 09:47:53", "{\n    \"sydney-child::wrapper_top_padding\": {\n        \"value\": \"0\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::wrapper_bottom_padding\": {\n        \"value\": \"0\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "89ed82a9-1ebb-4bd8-a472-94bac08b8b4a", "", "", "2017-06-13 13:47:53", "2017-06-13 09:47:53", "", "0", "http://localhost/actfinal/89ed82a9-1ebb-4bd8-a472-94bac08b8b4a/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("308", "1", "2017-06-13 14:04:41", "2017-06-13 10:04:41", "{\n    \"sydney-child::site_title_color\": {\n        \"value\": \"#70f8ba\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#70f8ba\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::primary_color\": {\n        \"value\": \"#57467b\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::sidebar_background\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_text\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "823dd601-ac4b-4596-8000-929cc5613615", "", "", "2017-06-13 14:04:41", "2017-06-13 10:04:41", "", "0", "http://localhost/actfinal/?p=308", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("309", "1", "2017-06-13 14:15:49", "2017-06-13 10:15:49", "{\n    \"sydney-child::primary_color\": {\n        \"value\": \"#a2d729\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "f50ded03-c045-4126-925a-f3d2a2daabf9", "", "", "2017-06-13 14:15:49", "2017-06-13 10:15:49", "", "0", "http://localhost/actfinal/?p=309", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("310", "1", "2017-06-13 14:29:51", "2017-06-13 10:29:51", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d8d174&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:29:51", "2017-06-13 10:29:51", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("311", "1", "2017-06-13 14:32:27", "2017-06-13 10:32:27", "<div id=\"pl-311\"  class=\"panel-layout\" ><div id=\"pg-311-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-311-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-311-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-311-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-311-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-311-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-311-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-311-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-311-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-311-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-311-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-311-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-311-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-311-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-311-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-311-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-311-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-311-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-311-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-311-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-311-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-311-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-311-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:32:28", "2017-06-13 10:32:28", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("312", "1", "2017-06-13 14:32:28", "2017-06-13 10:32:28", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:32:28", "2017-06-13 10:32:28", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("313", "1", "2017-06-13 14:34:46", "2017-06-13 10:34:46", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#8cd790&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#8cd790\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#77af9c&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Safe Easy Fast Secure Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\"> Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"http://localhost/actfinal/online-booking/\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:34:46", "2017-06-13 10:34:46", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("314", "1", "2017-06-13 14:58:56", "2017-06-13 10:58:56", "<div id=\"pl-314\"  class=\"panel-layout\" ><div id=\"pg-314-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-314-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-314-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-314-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-314-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-314-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-314-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-314-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-314-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-314-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-314-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-314-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-314-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-314-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-314-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-314-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-314-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-314-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:58:57", "2017-06-13 10:58:57", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("315", "1", "2017-06-13 14:58:57", "2017-06-13 10:58:57", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-13 14:58:57", "2017-06-13 10:58:57", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("316", "1", "2017-06-13 15:39:16", "2017-06-13 11:39:16", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#7cb4b8\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "10760d4a-1784-4619-8cf8-958f5481c047", "", "", "2017-06-13 15:39:16", "2017-06-13 11:39:16", "", "0", "http://localhost/actfinal/?p=316", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("317", "1", "2017-06-14 11:07:55", "2017-06-14 07:07:55", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#d65050\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::site_title_color\": {\n        \"value\": \"#343a1a\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::top_items_color\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "6d05eefc-7167-4de6-a171-313932696eb9", "", "", "2017-06-14 11:07:55", "2017-06-14 07:07:55", "", "0", "http://localhost/actfinal/?p=317", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("318", "1", "2017-06-14 11:10:39", "2017-06-14 07:10:39", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-logo-absolute-comfort-1.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::hide_overlay\": {\n        \"value\": true,\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "9f8d6a69-edb2-4c8d-a0e4-fa3b6d2576a9", "", "", "2017-06-14 11:10:39", "2017-06-14 07:10:39", "", "0", "http://localhost/actfinal/?p=318", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("319", "1", "2017-06-14 11:12:16", "2017-06-14 07:12:16", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "550e1b63-ac6a-44ca-bbaa-5c1ae25a3fbd", "", "", "2017-06-14 11:12:16", "2017-06-14 07:12:16", "", "0", "http://localhost/actfinal/550e1b63-ac6a-44ca-bbaa-5c1ae25a3fbd/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("320", "1", "2017-06-14 11:14:58", "2017-06-14 07:14:58", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/logo-absolute-comfort.png\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "997bd139-7dd8-4e15-9026-5fb9b297cc8f", "", "", "2017-06-14 11:14:58", "2017-06-14 07:14:58", "", "0", "http://localhost/actfinal/997bd139-7dd8-4e15-9026-5fb9b297cc8f/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("321", "1", "2017-06-14 11:16:55", "2017-06-14 07:16:55", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#a2d729\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "05864b04-4e13-489d-b913-07477baf14cb", "", "", "2017-06-14 11:16:55", "2017-06-14 07:16:55", "", "0", "http://localhost/actfinal/05864b04-4e13-489d-b913-07477baf14cb/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("322", "1", "2017-06-14 12:02:44", "2017-06-14 08:02:44", "<div id=\"pl-322\"  class=\"panel-layout\" ><div id=\"pg-322-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-322-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-322-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-322-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-322-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-322-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-322-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-322-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-322-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-322-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-322-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-322-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-322-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-322-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-322-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-322-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-322-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-322-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-322-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-322-3\" ><div id=\"pgc-322-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-322-3-0-0\" class=\"so-panel widget widget_ink-media-box panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-322-3-0-0\" ><div class=\"so-widget-ink-media-box so-widget-ink-media-box-media-box-27a433805e95\">\n<div class=\"iw-so-media-box\">\n\n	<div class=\"iw-so-media-box-media\">\n\n					<center><img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" /></center>\n		\n	</div>\n\n	<div class=\"iw-so-media-box-text\">\n\n					<h3 class=\"iw-so-media-box-title iw-text-center\">tuiujruruuut</h3>\n							<p class=\"iw-so-media-box-content iw-text-center\">fjfjfjhjfj</p>\n		\n	</div>\n\n	<div class=\"iw-so-media-box-button\">\n\n					<div class=\"iw-so-media-box-btn-base iw-text-center\">\n				<a class=\"iw-so-media-box-btn iw-so-media-box-btn-hover iw-so-media-box-btn-click\" >\n					gfjfjgjth				</a>\n			</div>\n		\n	</div>\n\n</div>\n</div></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:02:46", "2017-06-14 08:02:46", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("323", "1", "2017-06-14 12:02:47", "2017-06-14 08:02:47", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_ink-media-box panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><div class=\"so-widget-ink-media-box so-widget-ink-media-box-media-box-27a433805e95\">\n<div class=\"iw-so-media-box\">\n\n	<div class=\"iw-so-media-box-media\">\n\n					<center><img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_8_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" /></center>\n		\n	</div>\n\n	<div class=\"iw-so-media-box-text\">\n\n					<h3 class=\"iw-so-media-box-title iw-text-center\">tuiujruruuut</h3>\n							<p class=\"iw-so-media-box-content iw-text-center\">fjfjfjhjfj</p>\n		\n	</div>\n\n	<div class=\"iw-so-media-box-button\">\n\n					<div class=\"iw-so-media-box-btn-base iw-text-center\">\n				<a class=\"iw-so-media-box-btn iw-so-media-box-btn-hover iw-so-media-box-btn-click\" >\n					gfjfjgjth				</a>\n			</div>\n		\n	</div>\n\n</div>\n</div></div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:02:47", "2017-06-14 08:02:47", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("324", "1", "2017-06-14 12:23:47", "2017-06-14 08:23:47", "<div id=\"pl-324\"  class=\"panel-layout\" ><div id=\"pg-324-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-324-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-324-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-324-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-324-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-324-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-324-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-324-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-324-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-324-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-324-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-324-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-324-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-324-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-324-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-324-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-324-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-324-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-324-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:true,&quot;overlay_color&quot;:&quot;#cce8b4&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay-color=\"#cce8b4\" class=\"panel-row-style panel-row-style-for-324-3\" ><div id=\"pgc-324-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-324-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-324-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:23:48", "2017-06-14 08:23:48", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("325", "1", "2017-06-14 12:23:48", "2017-06-14 08:23:48", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:true,&quot;overlay_color&quot;:&quot;#cce8b4&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay-color=\"#cce8b4\" class=\"panel-row-style panel-row-style-for-5-3\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:23:48", "2017-06-14 08:23:48", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("326", "1", "2017-06-14 12:25:45", "2017-06-14 08:25:45", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#cce8b4&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#cce8b4\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:25:45", "2017-06-14 08:25:45", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("327", "1", "2017-06-14 12:30:35", "2017-06-14 08:30:35", "<div id=\"pl-327\"  class=\"panel-layout\" ><div id=\"pg-327-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-327-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-327-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-327-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-327-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-327-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-327-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-327-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-327-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-327-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-327-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-327-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-327-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-327-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-327-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-327-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-327-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-327-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-327-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-327-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-327-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-327-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-327-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:30:36", "2017-06-14 08:30:36", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("328", "1", "2017-06-14 12:30:36", "2017-06-14 08:30:36", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:30:36", "2017-06-14 08:30:36", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("329", "1", "2017-06-14 12:31:50", "2017-06-14 08:31:50", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:31:50", "2017-06-14 08:31:50", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("330", "1", "2017-06-14 12:33:01", "2017-06-14 08:33:01", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#a0d67a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#a0d67a\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:33:01", "2017-06-14 08:33:01", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("331", "1", "2017-06-14 12:33:44", "2017-06-14 08:33:44", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" >\n				<ul class=\'roll-list\'><li>available hourly, daily, weekly and monthly basis</li><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 12:33:44", "2017-06-14 08:33:44", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("332", "1", "2017-06-14 13:27:12", "2017-06-14 09:27:12", "<div id=\"pl-332\"  class=\"panel-layout\" ><div id=\"pg-332-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-332-0\" ><div id=\"pgc-332-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-332-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-332-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-055245cd0700\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-color: #333333;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg)\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-we9316db5\"  class=\"panel-layout\" ><div id=\"pg-we9316db5-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-we9316db5-0\" ><div id=\"pgc-we9316db5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-we9316db5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-we9316db5-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:27:17", "2017-06-14 09:27:17", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("333", "1", "2017-06-14 13:27:18", "2017-06-14 09:27:18", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-055245cd0700\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-color: #333333;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_7_plain.jpg)\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-we9316db5\"  class=\"panel-layout\" ><div id=\"pg-we9316db5-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-we9316db5-0\" ><div id=\"pgc-we9316db5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-we9316db5-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-we9316db5-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:27:18", "2017-06-14 09:27:18", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("334", "1", "2017-06-14 13:31:09", "2017-06-14 09:31:09", "<div id=\"pl-334\"  class=\"panel-layout\" ><div id=\"pg-334-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-334-0\" ><div id=\"pgc-334-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-334-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-334-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\">\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-174 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1-300x300.png\" alt=\"\" width=\"300\" height=\"300\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:31:09", "2017-06-14 09:31:09", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("335", "1", "2017-06-14 13:31:10", "2017-06-14 09:31:10", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\">\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-174 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/cropped-cropped-logo-absolute-comfort-1-300x300.png\" alt=\"\" width=\"300\" height=\"300\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:31:10", "2017-06-14 09:31:10", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("336", "1", "2017-06-14 13:32:29", "2017-06-14 09:32:29", "<div id=\"pl-336\"  class=\"panel-layout\" ><div id=\"pg-336-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-336-0\" ><div id=\"pgc-336-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-336-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-336-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\">\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:32:30", "2017-06-14 09:32:30", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("337", "1", "2017-06-14 13:32:30", "2017-06-14 09:32:30", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\">\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p><strong>ABOUT US</strong></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:32:30", "2017-06-14 09:32:30", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("338", "1", "2017-06-14 13:36:51", "2017-06-14 09:36:51", "<div id=\"pl-338\"  class=\"panel-layout\" ><div id=\"pg-338-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-338-0\" ><div id=\"pgc-338-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-338-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-338-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:36:51", "2017-06-14 09:36:51", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("339", "1", "2017-06-14 13:36:52", "2017-06-14 09:36:52", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:36:52", "2017-06-14 09:36:52", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("340", "1", "2017-06-14 13:37:53", "2017-06-14 09:37:53", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p><p><strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 13:37:53", "2017-06-14 09:37:53", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("341", "1", "2017-06-14 13:47:41", "2017-06-14 09:47:41", "{\n    \"sydney-child::menu_items_hover\": {\n        \"value\": \"#a2d729\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::menu_bg_color\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "d0403528-9333-4122-88b7-402c274f8547", "", "", "2017-06-14 13:47:41", "2017-06-14 09:47:41", "", "0", "http://localhost/actfinal/?p=341", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("342", "1", "2017-06-14 13:56:11", "2017-06-14 09:56:11", "{\n    \"sydney-child::menu_bg_color\": {\n        \"value\": \"#000000\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "1d1d406e-d3af-45a4-b610-da7db7089485", "", "", "2017-06-14 13:56:11", "2017-06-14 09:56:11", "", "0", "http://localhost/actfinal/1d1d406e-d3af-45a4-b610-da7db7089485/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("343", "1", "2017-06-14 13:58:55", "2017-06-14 09:58:55", "{\n    \"sydney-child::slider_title_1\": {\n        \"value\": \"We cater to all your travel needs\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_1\": {\n        \"value\": \"We specialize in airport transfers, inter-office transfers and outstation services\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "192547b3-2dd4-4380-a203-78511f334dce", "", "", "2017-06-14 13:58:55", "2017-06-14 09:58:55", "", "0", "http://localhost/actfinal/?p=343", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("344", "1", "2017-06-14 14:05:00", "2017-06-14 10:05:00", "{\n    \"sydney-child::slider_text\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "5170fd11-9799-4e1b-9b6d-27dd27c84f76", "", "", "2017-06-14 14:05:00", "2017-06-14 10:05:00", "", "0", "http://localhost/actfinal/5170fd11-9799-4e1b-9b6d-27dd27c84f76/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("345", "1", "2017-06-14 14:17:46", "2017-06-14 10:17:46", "{\n    \"sydney-child::slider_title_2\": {\n        \"value\": \"Safe\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_2\": {\n        \"value\": \"Our chauffeurs are well trained in safe defensive driving\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_3\": {\n        \"value\": \"Travel with peace of mind\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_3\": {\n        \"value\": \"Two way radio for effective communication Vehicle tracking and monitoring devices\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_4\": {\n        \"value\": \"Comfortable\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_4\": {\n        \"value\": \"New, clean Air conditioned vehicles\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_5\": {\n        \"value\": \"Affordable\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_5\": {\n        \"value\": \"Our prices are very competitive\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "615150ac-5865-4c9b-934d-72b70f8e27dd", "", "", "2017-06-14 14:17:46", "2017-06-14 10:17:46", "", "0", "http://localhost/actfinal/?p=345", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("346", "1", "2017-06-14 14:24:11", "2017-06-14 10:24:11", "<div id=\"pl-346\"  class=\"panel-layout\" ><div id=\"pg-346-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-346-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-346-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-346-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-346-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-346-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-346-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-346-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-346-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-346-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-346-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-346-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-346-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-346-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-346-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-346-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-346-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-346-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		\n<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-346-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-346-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-346-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-346-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-346-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 14:24:12", "2017-06-14 10:24:12", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("347", "1", "2017-06-14 14:24:13", "2017-06-14 10:24:13", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		\n<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 14:24:13", "2017-06-14 10:24:13", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("348", "1", "2017-06-14 14:30:06", "2017-06-14 10:30:06", "<div id=\"pl-348\"  class=\"panel-layout\" ><div id=\"pg-348-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-348-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-348-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-348-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-348-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-348-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-348-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-348-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-348-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-348-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-348-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-348-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-348-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-348-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-348-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-348-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-348-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-348-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-348-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-348-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-348-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-348-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-348-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 14:30:07", "2017-06-14 10:30:07", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("349", "1", "2017-06-14 14:30:08", "2017-06-14 10:30:08", "<div id=\"pl-5\"  class=\"panel-layout\" ><div id=\"pg-5-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#ffffff&quot;,&quot;background_image&quot;:&quot;256&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-0\" style=\"color: #ffffff;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_4_screened.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hascolor=\"hascolor\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-0-0-0\" class=\"so-panel widget widget_sydney_services_type_a sydney_services_widget panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#abdb43&quot;,&quot;headings_color&quot;:&quot;#a2d729&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#abdb43\" data-headings-color=\"#a2d729\" class=\"panel-widget-style panel-widget-style-for-5-0-0-0\" >			<h3 class=\"widget-title\">Why you should travel with us</h3>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-support\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Available around the clock																			</h3>\r\n																	\r\n										<p>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-check\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Excellent customer service																			</h3>\r\n																	\r\n										<p>We offer unrivaled customer service to our clients. All our drivers, dispatch team are taken through regular mandatory customer service training from recognized institutions. Our staff are also trained on how to cater for clients with special needs / physically challenged</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n																													<div class=\"service col-md-4\">\r\n													<div class=\"roll-icon-box\">\r\n											\r\n									<div class=\"icon\">\r\n																					<i class=\"fa fa-taxi\"></i>																			</div>\r\n																<div class=\"content\">\r\n									<h3>\r\n																					Superior service																			</h3>\r\n																	\r\n										<p>Most of our Vehicles are new and kept in immaculate condition. , are temperature controlled for your comfort and provide you with a silent tranquil environment</p>\n																	</div><!--.info-->	\r\n							</div>\r\n						</div>\r\n					\r\n								\r\n	</div></div></div></div></div><div id=\"pg-5-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a2d729&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#343a1a&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-1\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#343a1a\" ><div id=\"pgc-5-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#f6fedb&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#f6fedb\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-1-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-5-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-0-0\" class=\"so-panel widget widget_sydney_skills sydney_skills_widget panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-0-0\" >\r\n		<h3 class=\"widget-title\">Unrivalled Service</h3>\r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Competent Skilled Drivers</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		   \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Clean Vehicles</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Affordable Rates</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n				<div class=\"roll-progress\">\r\n 			<div class=\"name\">Customer Service</div>\r\n			<div class=\"perc\">100%</div>\r\n            <div class=\"progress-bar\" data-percent=\"100\" data-waypoint-active=\"yes\">\r\n				<div class=\"progress-animate\"></div>\r\n			</div>\r\n		</div>\r\n		 \r\n\r\n	</div></div></div><div id=\"pgc-5-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-5-2-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-5-2-1-0\" ><h3 class=\"widget-title\">Safe</h3>\n		<p>Travel with Peace of mind</p>\n		<ul class=\'roll-list\'><li>All vehicles fitted with Two way radio for effective communication</li><li>Our Vehicles are also fitted with Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</li></ul>				\n		</div></div></div></div></div><div id=\"pg-5-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-5-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-5-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-5-3-0-0\" class=\"so-panel widget widget_sydney_action sydney_action_widget panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#ffffff&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#ffffff\" class=\"panel-widget-style panel-widget-style-for-5-3-0-0\" ><h3 class=\"widget-title\">Online Booking</h3>        <div class=\"roll-promobox \">\r\n			<div class=\"promo-wrap\">\r\n								<div class=\"promo-content\">\r\n					<h3 class=\"title\">Reserve your ride at the comfort of your seat</h3>\r\n				</div>\r\n								<div class=\"promo-controls\">\r\n					<a href=\"\" class=\"roll-button border\">Book Now</a>\r\n				</div>\r\n			</div>\r\n        </div>\r\n	</div></div></div></div></div></div>", "Home", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2017-06-14 14:30:08", "2017-06-14 10:30:08", "", "5", "http://localhost/actfinal/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("350", "1", "2017-06-14 14:34:35", "2017-06-14 10:34:35", "<div id=\"pl-350\"  class=\"panel-layout\" ><div id=\"pg-350-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-350-0\" ><div id=\"pgc-350-0-0\"  class=\"panel-grid-cell panel-grid-cell-mobile-last\"  data-weight=\"0.66666666666667\" ><div id=\"panel-350-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-350-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-350-0-1\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"0.33333333333333\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:34:35", "2017-06-14 10:34:35", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("351", "1", "2017-06-14 14:34:36", "2017-06-14 10:34:36", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-0\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell panel-grid-cell-mobile-last\"  data-weight=\"0.66666666666667\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"0.33333333333333\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:34:36", "2017-06-14 10:34:36", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("353", "1", "2017-06-14 14:37:47", "2017-06-14 10:37:47", "<div id=\"pl-353\"  class=\"panel-layout\" ><div id=\"pg-353-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-353-0\" ><div id=\"pgc-353-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.66666666666667\" ><div id=\"panel-353-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-353-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-353-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.33333333333333\" ><div id=\"panel-353-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-353-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:37:48", "2017-06-14 10:37:48", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("354", "1", "2017-06-14 14:37:49", "2017-06-14 10:37:49", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-0\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.66666666666667\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.33333333333333\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:37:49", "2017-06-14 10:37:49", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("355", "1", "2017-06-14 14:40:19", "2017-06-14 10:40:19", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:&quot;245&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"text-align: center;background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_5_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-0\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.66666666666667\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.33333333333333\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:40:19", "2017-06-14 10:40:19", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("356", "1", "2017-06-14 14:41:40", "2017-06-14 10:41:40", "<div id=\"pl-356\"  class=\"panel-layout\" ><div id=\"pg-356-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d1d1d1&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-356-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-356-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.66666666666667\" ><div id=\"panel-356-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-356-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-356-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.33333333333333\" ><div id=\"panel-356-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-356-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:41:40", "2017-06-14 10:41:40", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("357", "1", "2017-06-14 14:41:41", "2017-06-14 10:41:41", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#d1d1d1&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.66666666666667\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.33333333333333\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:41:41", "2017-06-14 10:41:41", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("358", "1", "2017-06-14 14:42:54", "2017-06-14 10:42:54", "<div id=\"pl-358\"  class=\"panel-layout\" ><div id=\"pg-358-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-358-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-358-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.62065854758683\" ><div id=\"panel-358-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-358-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-358-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.37934145241317\" ><div id=\"panel-358-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-358-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:42:55", "2017-06-14 10:42:55", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("359", "1", "2017-06-14 14:42:55", "2017-06-14 10:42:55", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.62065854758683\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.37934145241317\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:42:55", "2017-06-14 10:42:55", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("360", "1", "2017-06-14 14:44:14", "2017-06-14 10:44:14", "<div id=\"pl-360\"  class=\"panel-layout\" ><div id=\"pg-360-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-360-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-360-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-360-0-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-360-0-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div><div id=\"panel-360-0-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-360-0-0-1\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-360-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-360-1\" ><div id=\"pgc-360-1-0\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:44:15", "2017-06-14 10:44:15", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("361", "1", "2017-06-14 14:44:15", "2017-06-14 10:44:15", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div><div id=\"panel-11-0-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-1\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:44:15", "2017-06-14 10:44:15", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("362", "1", "2017-06-14 14:46:14", "2017-06-14 10:46:14", "<div id=\"pl-362\"  class=\"panel-layout\" ><div id=\"pg-362-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-362-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-362-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-362-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-362-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-362-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-362-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-362-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p>&nbsp;</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-362-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-362-1\" ><div id=\"pgc-362-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-362-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-362-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:46:14", "2017-06-14 10:46:14", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("363", "1", "2017-06-14 14:46:15", "2017-06-14 10:46:15", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p>&nbsp;</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:46:15", "2017-06-14 10:46:15", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("364", "1", "2017-06-14 14:48:29", "2017-06-14 10:48:29", "<div id=\"pl-364\"  class=\"panel-layout\" ><div id=\"pg-364-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-364-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-364-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-364-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-364-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-364-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-364-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-364-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-364-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-364-1\" ><div id=\"pgc-364-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-364-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-364-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:48:30", "2017-06-14 10:48:30", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("365", "1", "2017-06-14 14:48:30", "2017-06-14 10:48:30", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:48:30", "2017-06-14 10:48:30", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("366", "1", "2017-06-14 14:50:03", "2017-06-14 10:50:03", "<div id=\"pl-366\"  class=\"panel-layout\" ><div id=\"pg-366-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-366-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-366-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-366-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-366-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-366-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-366-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;right&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: right;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-366-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-366-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-366-1\" ><div id=\"pgc-366-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-366-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-366-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:50:04", "2017-06-14 10:50:04", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("367", "1", "2017-06-14 14:50:04", "2017-06-14 10:50:04", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;right&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: right;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 14:50:04", "2017-06-14 10:50:04", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("368", "1", "2017-06-14 15:10:51", "2017-06-14 11:10:51", "<div id=\"pl-368\"  class=\"panel-layout\" ><div id=\"pg-368-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-368-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-368-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-368-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-368-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-368-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-368-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-368-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-368-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-368-1\" ><div id=\"pgc-368-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-368-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-368-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:10:51", "2017-06-14 11:10:51", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("369", "1", "2017-06-14 15:10:52", "2017-06-14 11:10:52", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.65241228070175\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.34758771929825\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:10:52", "2017-06-14 11:10:52", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("370", "1", "2017-06-14 15:11:55", "2017-06-14 11:11:55", "<div id=\"pl-370\"  class=\"panel-layout\" ><div id=\"pg-370-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-370-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-370-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-370-0-0-0\" class=\"so-panel widget widget_text panel-first-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-370-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div><div id=\"panel-370-0-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-370-0-0-1\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-370-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-370-1\" ><div id=\"pgc-370-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-370-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-370-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:11:55", "2017-06-14 11:11:55", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("371", "1", "2017-06-14 15:11:55", "2017-06-14 11:11:55", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div><div id=\"panel-11-0-0-1\" class=\"so-panel widget widget_text panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-1\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:11:55", "2017-06-14 11:11:55", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("372", "1", "2017-06-14 15:12:40", "2017-06-14 11:12:40", "<div id=\"pl-372\"  class=\"panel-layout\" ><div id=\"pg-372-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-372-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-372-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-372-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-372-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div><div id=\"pgc-372-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-372-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-372-0-1-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-372-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-372-1\" ><div id=\"pgc-372-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-372-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-372-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:12:40", "2017-06-14 11:12:40", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("373", "1", "2017-06-14 15:12:41", "2017-06-14 11:12:41", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div><div id=\"pg-11-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-11-1\" ><div id=\"pgc-11-1-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-1-0-0\" class=\"so-panel widget widget_sow-google-map panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-1-0-0\" ><div class=\"so-widget-sow-google-map so-widget-sow-google-map-base\">\n<div class=\"sow-google-map-canvas\"\n     style=\"height:480px;\"\n     id=\"map-canvas-d29f29d4d9a38cd2e3a42cc143840419\"\n     data-options=\"{&quot;address&quot;:&quot;Silver Pool Office Suites Jabavu Lane Hurlingham&quot;,&quot;zoom&quot;:12,&quot;scrollZoom&quot;:true,&quot;draggable&quot;:true,&quot;disableUi&quot;:false,&quot;keepCentered&quot;:true,&quot;markerIcon&quot;:&quot;&quot;,&quot;markersDraggable&quot;:false,&quot;markerAtCenter&quot;:true,&quot;markerInfoDisplay&quot;:&quot;click&quot;,&quot;markerInfoMultiple&quot;:true,&quot;markerPositions&quot;:&quot;&quot;,&quot;mapName&quot;:&quot;&quot;,&quot;mapStyles&quot;:&quot;&quot;,&quot;directions&quot;:&quot;&quot;,&quot;apiKey&quot;:&quot;&quot;}\"\n     data-fallback-image=\"{&quot;img&quot;:&quot;&quot;}\"></div>\n</div></div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:12:41", "2017-06-14 11:12:41", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("374", "1", "2017-06-14 15:13:21", "2017-06-14 11:13:21", "<div id=\"pl-374\"  class=\"panel-layout\" ><div id=\"pg-374-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-374-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-374-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-374-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-374-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div><div id=\"pgc-374-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-374-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-374-0-1-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:13:22", "2017-06-14 11:13:22", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("375", "1", "2017-06-14 15:13:22", "2017-06-14 11:13:22", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f304-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f304-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"304\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f304-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"981208c026\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Whats on your mind?<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send message\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:13:22", "2017-06-14 11:13:22", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("376", "1", "2017-06-14 15:17:40", "2017-06-14 11:17:40", "<div id=\"pl-376\"  class=\"panel-layout\" ><div id=\"pg-376-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-376-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-376-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-376-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-376-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:17:40", "2017-06-14 11:17:40", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("377", "1", "2017-06-14 15:17:41", "2017-06-14 11:17:41", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Contact Information</h3>			<div class=\"textwidget\"><p><strong>NAIROBI OFFICE</strong></p>\n<p>Absolute Comfort Travel</p>\n<p>Silver Pool Office Suites</p>\n<p>Hurlingham – Jabavu Lane</p>\n<p>P O Box 24716 – 00502</p>\n<p>Karen</p>\n<p><strong>TELEPHONE:</strong></p>\n<p>+254797 119 418</p>\n<p>+254789 122 834</p>\n<p><strong>EMAIL:</strong></p>\n<p>Bookings@absolutecomfort.co.ke</p>\n<p> </p>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:17:41", "2017-06-14 11:17:41", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("378", "1", "2017-06-14 15:18:36", "2017-06-14 11:18:36", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:18:36", "2017-06-14 11:18:36", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("379", "1", "2017-06-14 15:20:12", "2017-06-14 11:20:12", "<div id=\"pl-379\"  class=\"panel-layout\" ><div id=\"pg-379-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-379-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-379-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-379-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-379-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:20:12", "2017-06-14 11:20:12", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("380", "1", "2017-06-14 15:20:13", "2017-06-14 11:20:13", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:20:13", "2017-06-14 11:20:13", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("381", "1", "2017-06-14 15:24:07", "2017-06-14 11:24:07", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">We&#8217;d love to hear from you</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:24:07", "2017-06-14 11:24:07", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("382", "1", "2017-06-14 15:25:11", "2017-06-14 11:25:11", "{\n    \"sydney-child::sidebar_background\": {\n        \"value\": \"#b8d6a4\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "557606f0-0e02-4920-bd7b-91f5dead775f", "", "", "2017-06-14 15:25:11", "2017-06-14 11:25:11", "", "0", "http://localhost/actfinal/557606f0-0e02-4920-bd7b-91f5dead775f/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("383", "1", "2017-06-14 15:25:36", "2017-06-14 11:25:36", "{\n    \"sydney-child::sidebar_background\": {\n        \"value\": \"#ffffff\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "9576861f-287e-4ae8-a9d9-1b666f1efd81", "", "", "2017-06-14 15:25:36", "2017-06-14 11:25:36", "", "0", "http://localhost/actfinal/9576861f-287e-4ae8-a9d9-1b666f1efd81/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("384", "1", "2017-06-14 15:30:58", "2017-06-14 11:30:58", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell panel-grid-cell-mobile-last\"  data-weight=\"0.5\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Send us a message</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/admin-ajax.php?_panelsnonce=f225a720ef#wpcf7-f294-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell panel-grid-cell-empty\"  data-weight=\"0.5\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-autosave-v1", "", "", "2017-06-14 15:30:58", "2017-06-14 11:30:58", "", "11", "http://localhost/actfinal/11-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("385", "1", "2017-06-14 15:29:20", "2017-06-14 11:29:20", "<div id=\"pl-385\"  class=\"panel-layout\" ><div id=\"pg-385-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-385-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-385-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-385-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-385-0-0-0\" ><h3 class=\"widget-title\">Send us a message</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-385-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-385-0-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-385-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>\n				<ul class=\'roll-list\'><li>Absolute Comfort Travel</li><li>Silver Pool Office Suites</li><li>Hurlingham – Jabavu Lane</li><li>P O Box 24716 – 00502</li><li>Karen</li></ul>				\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:29:20", "2017-06-14 11:29:20", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("386", "1", "2017-06-14 15:29:21", "2017-06-14 11:29:21", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Send us a message</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o2\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o2\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o2\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>\n				<ul class=\'roll-list\'><li>Absolute Comfort Travel</li><li>Silver Pool Office Suites</li><li>Hurlingham – Jabavu Lane</li><li>P O Box 24716 – 00502</li><li>Karen</li></ul>				\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:29:21", "2017-06-14 11:29:21", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("387", "1", "2017-06-14 15:29:35", "2017-06-14 11:29:35", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-0-0\" ><h3 class=\"widget-title\">Send us a message</h3>			<div class=\"textwidget\"><div role=\"form\" class=\"wpcf7\" id=\"wpcf7-f294-o1\" lang=\"en-US\" dir=\"ltr\">\n<div class=\"screen-reader-response\"></div>\n<form action=\"/actfinal/wp-admin/post.php#wpcf7-f294-o1\" method=\"post\" class=\"wpcf7-form\" novalidate=\"novalidate\">\n<div style=\"display: none;\">\n<input type=\"hidden\" name=\"_wpcf7\" value=\"294\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_version\" value=\"4.8\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_locale\" value=\"en_US\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_unit_tag\" value=\"wpcf7-f294-o1\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_container_post\" value=\"0\" /><br />\n<input type=\"hidden\" name=\"_wpcf7_nonce\" value=\"6f3bee7365\" />\n</div>\n<p><label> Your Name (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-name\"><input type=\"text\" name=\"your-name\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-validates-as-required\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Email (required)<br />\n    <span class=\"wpcf7-form-control-wrap your-email\"><input type=\"email\" name=\"your-email\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text wpcf7-email wpcf7-validates-as-required wpcf7-validates-as-email\" aria-required=\"true\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Subject<br />\n    <span class=\"wpcf7-form-control-wrap your-subject\"><input type=\"text\" name=\"your-subject\" value=\"\" size=\"40\" class=\"wpcf7-form-control wpcf7-text\" aria-invalid=\"false\" /></span> </label></p>\n<p><label> Your Message<br />\n    <span class=\"wpcf7-form-control-wrap your-message\"><textarea name=\"your-message\" cols=\"40\" rows=\"10\" class=\"wpcf7-form-control wpcf7-textarea\" aria-invalid=\"false\"></textarea></span> </label></p>\n<p><input type=\"submit\" value=\"Send\" class=\"wpcf7-form-control wpcf7-submit\" /></p>\n<div class=\"wpcf7-response-output wpcf7-display-none\"></div>\n</form>\n</div>\n</div>\n		</div></div></div><div id=\"pgc-11-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-11-0-1-0\" class=\"so-panel widget widget_list panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-11-0-1-0\" ><h3 class=\"widget-title\">Contact Information</h3>\n				<ul class=\'roll-list\'><li>Absolute Comfort Travel</li><li>Silver Pool Office Suites</li><li>Hurlingham – Jabavu Lane</li><li>P O Box 24716 – 00502</li><li>Karen</li></ul>				\n		</div></div></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:29:35", "2017-06-14 11:29:35", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("388", "1", "2017-06-14 15:31:19", "2017-06-14 11:31:19", "<div id=\"pl-388\"  class=\"panel-layout\" ><div id=\"pg-388-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-388-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-388-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:31:20", "2017-06-14 11:31:20", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("389", "1", "2017-06-14 15:31:20", "2017-06-14 11:31:20", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-14 15:31:20", "2017-06-14 11:31:20", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("390", "1", "2017-06-14 15:40:36", "2017-06-14 11:40:36", "<div id=\"pl-390\"  class=\"panel-layout\" ><div id=\"pg-390-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-390-0\" ><div id=\"pgc-390-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-390-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-390-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-390-1\" ><div id=\"pgc-390-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-390-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-390-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-390-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-390-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-390-2\" ><div id=\"pgc-390-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-390-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-390-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-390-3\" ><div id=\"pgc-390-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-390-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-390-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-390-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-390-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-390-4\" ><div id=\"pgc-390-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-390-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-390-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:40:37", "2017-06-14 11:40:37", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("391", "1", "2017-06-14 15:40:38", "2017-06-14 11:40:38", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-2\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-3\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-4\" ><div id=\"pgc-7-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:40:38", "2017-06-14 11:40:38", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("392", "1", "2017-06-14 15:42:01", "2017-06-14 11:42:01", "<div id=\"pl-392\"  class=\"panel-layout\" ><div id=\"pg-392-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-392-0\" ><div id=\"pgc-392-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-392-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-392-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-392-1\" ><div id=\"pgc-392-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-392-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-392-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-392-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-392-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-392-2\" ><div id=\"pgc-392-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-392-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-392-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-392-3\" ><div id=\"pgc-392-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-392-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-392-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-392-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-392-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-392-4\" ><div id=\"pgc-392-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-392-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-392-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:42:02", "2017-06-14 11:42:02", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("393", "1", "2017-06-14 15:42:02", "2017-06-14 11:42:02", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-2\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-3\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-4\" ><div id=\"pgc-7-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:42:02", "2017-06-14 11:42:02", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("394", "1", "2017-06-14 15:42:36", "2017-06-14 11:42:36", "<div id=\"pl-394\"  class=\"panel-layout\" ><div id=\"pg-394-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-394-0\" ><div id=\"pgc-394-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-394-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-394-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-394-1\" ><div id=\"pgc-394-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-394-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-394-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-394-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-394-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-394-2\" ><div id=\"pgc-394-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-394-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-394-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-394-3\" ><div id=\"pgc-394-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-394-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-394-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-394-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-394-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-394-4\" ><div id=\"pgc-394-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-394-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-394-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:42:37", "2017-06-14 11:42:37", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("395", "1", "2017-06-14 15:42:37", "2017-06-14 11:42:37", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-2\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-3\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-4\" ><div id=\"pgc-7-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:42:37", "2017-06-14 11:42:37", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("396", "1", "2017-06-14 15:45:24", "2017-06-14 11:45:24", "<div id=\"pl-396\"  class=\"panel-layout\" ><div id=\"pg-396-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-396-0\" ><div id=\"pgc-396-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-396-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-396-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-396-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-396-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-396-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-396-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-396-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-396-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-396-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-396-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-396-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-396-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-396-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-396-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-396-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-396-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-396-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-396-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-396-4\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-396-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-396-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-396-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:45:24", "2017-06-14 11:45:24", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("397", "1", "2017-06-14 15:45:25", "2017-06-14 11:45:25", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\"size-medium wp-image-252 aligncenter\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"300\" height=\"203\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p> </p><p> </p><p> </p><p> </p></div>\n</div></div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-2\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" >			<div class=\"textwidget\"></div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-3\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-3-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-3-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-4\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-4\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-4-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-4-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"6\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-4-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:45:25", "2017-06-14 11:45:25", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("398", "1", "2017-06-14 15:49:26", "2017-06-14 11:49:26", "<div id=\"pl-398\"  class=\"panel-layout\" ><div id=\"pg-398-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-398-0\" ><div id=\"pgc-398-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-398-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p>&nbsp;</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-398-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-398-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-398-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-398-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-398-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-398-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-398-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-398-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-398-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-398-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-2-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-398-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-398-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-2-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-398-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-398-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-398-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-398-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-398-3-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:49:27", "2017-06-14 11:49:27", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("399", "1", "2017-06-14 15:49:28", "2017-06-14 11:49:28", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p>&nbsp;</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p>&nbsp;</p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:49:28", "2017-06-14 11:49:28", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("400", "1", "2017-06-14 15:53:16", "2017-06-14 11:53:16", "<div id=\"pl-400\"  class=\"panel-layout\" ><div id=\"pg-400-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-400-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-400-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-400-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-400-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-400-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-400-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-400-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p> </p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-400-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-400-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p> </p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-400-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-400-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-400-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-400-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-2-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p> </p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-400-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-400-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-2-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-400-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-400-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-400-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-400-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-400-3-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:53:17", "2017-06-14 11:53:17", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("401", "1", "2017-06-14 15:53:18", "2017-06-14 11:53:18", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;252&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p> </p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#bbd6ab&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-1\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><p> </p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><h3 class=\"widget-title\">WHY CHOOSE US?</h3>			<div class=\"textwidget\"><p> </p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-2\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;251&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-2\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_11_plain.jpg);padding: 100px 0; \" data-stretch-type=\"full\" data-hasbg=\"hasbg\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-2-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"3\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p> </p>\n<p><strong>TAXI / CAB</strong></p>\n<p><strong> </strong>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n</div>\n		</div></div></div><div id=\"pgc-7-2-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-2-1-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"4\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#ffffff&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#81d742&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#81d742\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-2-1-0\" ><h3 class=\"widget-title\">HUMAN RESOURCE</h3>			<div class=\"textwidget\"><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div><div id=\"pg-7-3\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#a1d680&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-3\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-3-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-3-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"5\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;center&quot;,&quot;title_color&quot;:&quot;#ffffff&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: center;\" data-title-color=\"#ffffff\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-3-0-0\" ><h3 class=\"widget-title\">CHARGES</h3>			<div class=\"textwidget\"><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 15:53:18", "2017-06-14 11:53:18", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("402", "1", "2017-06-14 17:38:08", "2017-06-14 13:38:08", "<div id=\"pl-402\"  class=\"panel-layout\" ><div id=\"pg-402-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-402-0\" ><div id=\"pgc-402-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-402-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-402-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:38:08", "2017-06-14 13:38:08", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("403", "1", "2017-06-14 17:38:09", "2017-06-14 13:38:09", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:38:09", "2017-06-14 13:38:09", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("404", "1", "2017-06-14 17:39:04", "2017-06-14 13:39:04", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:39:04", "2017-06-14 13:39:04", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("405", "1", "2017-06-14 17:40:00", "2017-06-14 13:40:00", "<div id=\"pl-405\"  class=\"panel-layout\" ><div id=\"pg-405-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#9b9b9b&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"color: #9b9b9b;padding: 100px 0; \" data-hascolor=\"hascolor\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-405-0\" ><div id=\"pgc-405-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-405-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-405-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:40:01", "2017-06-14 13:40:01", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("406", "1", "2017-06-14 17:40:01", "2017-06-14 13:40:01", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;color&quot;:&quot;#9b9b9b&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"color: #9b9b9b;padding: 100px 0; \" data-hascolor=\"hascolor\" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p>&nbsp;</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:40:01", "2017-06-14 13:40:01", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("407", "1", "2017-06-14 17:41:26", "2017-06-14 13:41:26", "<div id=\"pl-407\"  class=\"panel-layout\" ><div id=\"pg-407-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-407-0\" ><div id=\"pgc-407-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-407-0-0-0\" class=\"so-panel widget widget_sow-headline panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-407-0-0-0\" ><div class=\"so-widget-sow-headline so-widget-sow-headline-default-8d8ed0dedf8a\"><div class=\"sow-headline-container \">\n	<h1 class=\'sow-headline\'>About Us</h1>					<div class=\"decoration\">\n						<div class=\"decoration-inside\"></div>\n					</div>\n					</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:41:26", "2017-06-14 13:41:26", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("408", "1", "2017-06-14 17:41:27", "2017-06-14 13:41:27", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-headline panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-headline so-widget-sow-headline-default-8d8ed0dedf8a\"><div class=\"sow-headline-container \">\n	<h1 class=\'sow-headline\'>About Us</h1>					<div class=\"decoration\">\n						<div class=\"decoration-inside\"></div>\n					</div>\n					</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:41:27", "2017-06-14 13:41:27", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("409", "1", "2017-06-14 17:51:36", "2017-06-14 13:51:36", "<div id=\"pl-409\"  class=\"panel-layout\" ><div id=\"pg-409-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-409-0\" ><div id=\"pgc-409-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-409-0-0-0\" class=\"so-panel widget widget_sow-headline panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-409-0-0-0\" ><div class=\"so-widget-sow-headline so-widget-sow-headline-default-5ac7b198b4a5 so-widget-fittext-wrapper\" data-fit-text-compressor=\"0.85\"><div class=\"sow-headline-container \">\n	<h1 class=\'sow-headline\'>About Us</h1>					<div class=\"decoration\">\n						<div class=\"decoration-inside\"></div>\n					</div>\n					</div></div></div></div></div></div></div><div id=\"pg-409-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-409-1\" ><div id=\"pgc-409-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-409-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-409-1-0-0\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-409-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-409-1-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-409-1-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-af840588f36c\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\"></ul>				<ol class=\"sow-slider-pagination\">\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:51:37", "2017-06-14 13:51:37", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("410", "1", "2017-06-14 17:51:38", "2017-06-14 13:51:38", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-headline panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-headline so-widget-sow-headline-default-5ac7b198b4a5 so-widget-fittext-wrapper\" data-fit-text-compressor=\"0.85\"><div class=\"sow-headline-container \">\n	<h1 class=\'sow-headline\'>About Us</h1>					<div class=\"decoration\">\n						<div class=\"decoration-inside\"></div>\n					</div>\n					</div></div></div></div></div></div></div><div id=\"pg-7-1\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-1\" ><div id=\"pgc-7-1-0\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-0-0\" >			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-1-1\"  class=\"panel-grid-cell\"  data-weight=\"0.5\" ><div id=\"panel-7-1-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"2\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-1-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-af840588f36c\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\"></ul>				<ol class=\"sow-slider-pagination\">\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:51:38", "2017-06-14 13:51:38", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("411", "1", "2017-06-14 17:52:47", "2017-06-14 13:52:47", "<div id=\"pl-411\"  class=\"panel-layout\" ><div id=\"pg-411-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-411-0\" ><div id=\"pgc-411-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.43775372124493\" ><div id=\"panel-411-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-411-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-411-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.56224627875507\" ><div id=\"panel-411-0-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-411-0-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-abf3e628296a\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\"></ul>				<ol class=\"sow-slider-pagination\">\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:52:47", "2017-06-14 13:52:47", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("412", "1", "2017-06-14 17:52:48", "2017-06-14 13:52:48", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.43775372124493\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.56224627875507\" ><div id=\"panel-7-0-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-abf3e628296a\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\"></ul>				<ol class=\"sow-slider-pagination\">\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:52:48", "2017-06-14 13:52:48", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("413", "1", "2017-06-14 17:54:30", "2017-06-14 13:54:30", "<div id=\"pl-413\"  class=\"panel-layout\" ><div id=\"pg-413-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-413-0\" ><div id=\"pgc-413-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.55818673883627\" ><div id=\"panel-413-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#919191&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-413-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-413-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.44181326116373\" ><div id=\"panel-413-0-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-413-0-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-abf3e628296a\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg)\" >\n			<img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" />		</li>\n				<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg)\" >\n			<img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" />		</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:54:31", "2017-06-14 13:54:31", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("414", "1", "2017-06-14 17:54:31", "2017-06-14 13:54:31", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"0.55818673883627\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#919191&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div><div id=\"pgc-7-0-1\"  class=\"panel-grid-cell\"  data-weight=\"0.44181326116373\" ><div id=\"panel-7-0-1-0\" class=\"so-panel widget widget_sow-slider panel-first-child panel-last-child\" data-index=\"1\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-1-0\" ><div class=\"so-widget-sow-slider so-widget-sow-slider-default-abf3e628296a\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:8000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg)\" >\n			<img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" />		</li>\n				<li class=\"sow-slider-image  sow-slider-image-cover\" style=\"background-image: url(http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg)\" >\n			<img width=\"1920\" height=\"1300\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg\" class=\"attachment-full size-full\" alt=\"\" srcset=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain.jpg 1920w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-300x203.jpg 300w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-768x520.jpg 768w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-1024x693.jpg 1024w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-830x562.jpg 830w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-230x156.jpg 230w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-350x237.jpg 350w, http://localhost/actfinal/wp-content/uploads/2017/06/act_9_plain-480x325.jpg 480w\" sizes=\"(max-width: 1920px) 100vw, 1920px\" />		</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-thin-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-thin-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 17:54:31", "2017-06-14 13:54:31", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("415", "1", "2017-06-14 18:02:01", "2017-06-14 14:02:01", "<div id=\"pl-415\"  class=\"panel-layout\" ><div id=\"pg-415-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-415-0\" ><div id=\"pgc-415-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-415-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-415-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-cf04e457d23b\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:4000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w824af98a\"  class=\"panel-layout\" ><div id=\"pg-w824af98a-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w824af98a-0\" ><div id=\"pgc-w824af98a-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w824af98a-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w824af98a-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wcf35b5e1\"  class=\"panel-layout\" ><div id=\"pg-wcf35b5e1-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wcf35b5e1-0\" ><div id=\"pgc-wcf35b5e1-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wcf35b5e1-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wcf35b5e1-0-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w2486fe6d\"  class=\"panel-layout\" ><div id=\"pg-w2486fe6d-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w2486fe6d-0\" ><div id=\"pgc-w2486fe6d-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w2486fe6d-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w2486fe6d-0-0-0\" ><h3 class=\"widget-title\">Why choose us?</h3>			<div class=\"textwidget\"><ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w324be3b8\"  class=\"panel-layout\" ><div id=\"pg-w324be3b8-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w324be3b8-0\" ><div id=\"pgc-w324be3b8-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w324be3b8-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w324be3b8-0-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wa27b6152\"  class=\"panel-layout\" ><div id=\"pg-wa27b6152-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wa27b6152-0\" ><div id=\"pgc-wa27b6152-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wa27b6152-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wa27b6152-0-0-0\" ><h3 class=\"widget-title\">Superior Customer Service</h3>			<div class=\"textwidget\"><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n											<li><a href=\"#\" data-goto=\"2\">3</a></li>\n											<li><a href=\"#\" data-goto=\"3\">4</a></li>\n											<li><a href=\"#\" data-goto=\"4\">5</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-medium-rounded-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-medium-rounded-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:02:02", "2017-06-14 14:02:02", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("416", "1", "2017-06-14 18:02:03", "2017-06-14 14:02:03", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-cf04e457d23b\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:4000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w824af98a\"  class=\"panel-layout\" ><div id=\"pg-w824af98a-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w824af98a-0\" ><div id=\"pgc-w824af98a-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w824af98a-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w824af98a-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wcf35b5e1\"  class=\"panel-layout\" ><div id=\"pg-wcf35b5e1-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wcf35b5e1-0\" ><div id=\"pgc-wcf35b5e1-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wcf35b5e1-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wcf35b5e1-0-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w2486fe6d\"  class=\"panel-layout\" ><div id=\"pg-w2486fe6d-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w2486fe6d-0\" ><div id=\"pgc-w2486fe6d-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w2486fe6d-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w2486fe6d-0-0-0\" ><h3 class=\"widget-title\">Why choose us?</h3>			<div class=\"textwidget\"><ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w324be3b8\"  class=\"panel-layout\" ><div id=\"pg-w324be3b8-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w324be3b8-0\" ><div id=\"pgc-w324be3b8-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w324be3b8-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w324be3b8-0-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wa27b6152\"  class=\"panel-layout\" ><div id=\"pg-wa27b6152-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wa27b6152-0\" ><div id=\"pgc-wa27b6152-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wa27b6152-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wa27b6152-0-0-0\" ><h3 class=\"widget-title\">Superior Customer Service</h3>			<div class=\"textwidget\"><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n											<li><a href=\"#\" data-goto=\"2\">3</a></li>\n											<li><a href=\"#\" data-goto=\"3\">4</a></li>\n											<li><a href=\"#\" data-goto=\"4\">5</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-medium-rounded-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-medium-rounded-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:02:03", "2017-06-14 14:02:03", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("417", "1", "2017-06-14 18:04:28", "2017-06-14 14:04:28", "<div id=\"pl-417\"  class=\"panel-layout\" ><div id=\"pg-417-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#b7b7b7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-417-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-417-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-417-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-417-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-cf04e457d23b\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:4000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w824af98a\"  class=\"panel-layout\" ><div id=\"pg-w824af98a-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w824af98a-0\" ><div id=\"pgc-w824af98a-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w824af98a-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w824af98a-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wcf35b5e1\"  class=\"panel-layout\" ><div id=\"pg-wcf35b5e1-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wcf35b5e1-0\" ><div id=\"pgc-wcf35b5e1-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wcf35b5e1-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wcf35b5e1-0-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w2486fe6d\"  class=\"panel-layout\" ><div id=\"pg-w2486fe6d-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w2486fe6d-0\" ><div id=\"pgc-w2486fe6d-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w2486fe6d-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w2486fe6d-0-0-0\" ><h3 class=\"widget-title\">Why choose us?</h3>			<div class=\"textwidget\"><ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w324be3b8\"  class=\"panel-layout\" ><div id=\"pg-w324be3b8-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w324be3b8-0\" ><div id=\"pgc-w324be3b8-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w324be3b8-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w324be3b8-0-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wa27b6152\"  class=\"panel-layout\" ><div id=\"pg-wa27b6152-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wa27b6152-0\" ><div id=\"pgc-wa27b6152-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wa27b6152-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wa27b6152-0-0-0\" ><h3 class=\"widget-title\">Superior Customer Service</h3>			<div class=\"textwidget\"><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n											<li><a href=\"#\" data-goto=\"2\">3</a></li>\n											<li><a href=\"#\" data-goto=\"3\">4</a></li>\n											<li><a href=\"#\" data-goto=\"4\">5</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-medium-rounded-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-medium-rounded-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:04:29", "2017-06-14 14:04:29", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("418", "1", "2017-06-14 18:04:29", "2017-06-14 14:04:29", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#b7b7b7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-layout-slider panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-layout-slider so-widget-sow-layout-slider-default-cf04e457d23b\"><div class=\"sow-slider-base \" style=\"display: none\"><ul class=\"sow-slider-images\" data-settings=\"{&quot;pagination&quot;:true,&quot;speed&quot;:800,&quot;timeout&quot;:4000,&quot;swipe&quot;:true}\">		<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w824af98a\"  class=\"panel-layout\" ><div id=\"pg-w824af98a-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w824af98a-0\" ><div id=\"pgc-w824af98a-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w824af98a-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w824af98a-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wcf35b5e1\"  class=\"panel-layout\" ><div id=\"pg-wcf35b5e1-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wcf35b5e1-0\" ><div id=\"pgc-wcf35b5e1-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wcf35b5e1-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wcf35b5e1-0-0-0\" ><h3 class=\"widget-title\">OUR CORE VALUES</h3>			<div class=\"textwidget\"><ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w2486fe6d\"  class=\"panel-layout\" ><div id=\"pg-w2486fe6d-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w2486fe6d-0\" ><div id=\"pgc-w2486fe6d-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w2486fe6d-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w2486fe6d-0-0-0\" ><h3 class=\"widget-title\">Why choose us?</h3>			<div class=\"textwidget\"><ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-w324be3b8\"  class=\"panel-layout\" ><div id=\"pg-w324be3b8-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-w324be3b8-0\" ><div id=\"pgc-w324be3b8-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-w324be3b8-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-w324be3b8-0-0-0\" ><h3 class=\"widget-title\">SERVICES OFFERED</h3>			<div class=\"textwidget\"><p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n				<li class=\"sow-slider-image\" style=\"background-color: #333333\" >\n					<div class=\"sow-slider-image-container\">\n			<div class=\"sow-slider-image-wrapper\">\n				<div id=\"pl-wa27b6152\"  class=\"panel-layout\" ><div id=\"pg-wa27b6152-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;cell_class&quot;:&quot;&quot;,&quot;row_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;bottom_margin&quot;:&quot;&quot;,&quot;gutter&quot;:&quot;&quot;,&quot;row_stretch&quot;:&quot;&quot;,&quot;collapse_behaviour&quot;:&quot;&quot;,&quot;collapse_order&quot;:&quot;&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;bottom_border&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;color&quot;:&quot;&quot;,&quot;background_image&quot;:&quot;0&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-wa27b6152-0\" ><div id=\"pgc-wa27b6152-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-wa27b6152-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;id&quot;:&quot;&quot;,&quot;class&quot;:&quot;&quot;,&quot;widget_css&quot;:&quot;&quot;,&quot;mobile_css&quot;:&quot;&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;padding&quot;:&quot;&quot;,&quot;mobile_padding&quot;:&quot;&quot;,&quot;background&quot;:&quot;&quot;,&quot;background_image_attachment&quot;:&quot;0&quot;,&quot;background_display&quot;:&quot;tile&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;border_color&quot;:&quot;&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;,&quot;font_color&quot;:&quot;&quot;,&quot;link_color&quot;:&quot;&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-wa27b6152-0-0-0\" ><h3 class=\"widget-title\">Superior Customer Service</h3>			<div class=\"textwidget\"><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client</p>\n</div>\n		</div></div></div></div></div></div>			</div>\n		</div>\n				</li>\n		</ul>				<ol class=\"sow-slider-pagination\">\n											<li><a href=\"#\" data-goto=\"0\">1</a></li>\n											<li><a href=\"#\" data-goto=\"1\">2</a></li>\n											<li><a href=\"#\" data-goto=\"2\">3</a></li>\n											<li><a href=\"#\" data-goto=\"3\">4</a></li>\n											<li><a href=\"#\" data-goto=\"4\">5</a></li>\n									</ol>\n\n				<div class=\"sow-slide-nav sow-slide-nav-next\">\n					<a href=\"#\" data-goto=\"next\" data-action=\"next\">\n						<em class=\"sow-sld-icon-medium-rounded-right\"></em>\n					</a>\n				</div>\n\n				<div class=\"sow-slide-nav sow-slide-nav-prev\">\n					<a href=\"#\" data-goto=\"previous\" data-action=\"prev\">\n						<em class=\"sow-sld-icon-medium-rounded-left\"></em>\n					</a>\n				</div>\n				</div></div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:04:29", "2017-06-14 14:04:29", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("419", "1", "2017-06-14 18:07:22", "2017-06-14 14:07:22", "<div id=\"pl-419\"  class=\"panel-layout\" ><div id=\"pg-419-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#b7b7b7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-419-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-419-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-419-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-419-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:07:22", "2017-06-14 14:07:22", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("420", "1", "2017-06-14 18:07:22", "2017-06-14 14:07:22", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#b7b7b7&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as</p><p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"330\" height=\"223\" /></p><p>cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><ol><li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li><li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li><li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li><li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li><li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li><li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li><li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li></ol></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:07:22", "2017-06-14 14:07:22", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("421", "1", "2017-06-14 18:12:38", "2017-06-14 14:12:38", "<div id=\"pl-421\"  class=\"panel-layout\" ><div id=\"pg-421-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-421-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-421-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-421-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-421-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:12:38", "2017-06-14 14:12:38", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("422", "1", "2017-06-14 18:12:38", "2017-06-14 14:12:38", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:12:38", "2017-06-14 14:12:38", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("423", "1", "2017-06-14 18:13:46", "2017-06-14 14:13:46", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#adadad&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"318\" height=\"215\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:13:46", "2017-06-14 14:13:46", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("424", "1", "2017-06-14 18:14:53", "2017-06-14 14:14:53", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-7-0\" style=\"padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#adadad&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#81d742&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#81d742\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">About Us</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p><img class=\" wp-image-252 alignleft\" src=\"http://localhost/actfinal/wp-content/uploads/2017/06/act_12_plain-300x203.jpg\" alt=\"\" width=\"447\" height=\"303\" /></p><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p><p><strong>OUR MISSION</strong></p><ul><li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li><li>To add value by consistently providing reliable quality services to our customers</li></ul><p><strong>OUR VISION</strong></p><p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p><p><strong>OUR CORE VALUES</strong></p><p><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</p><p><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</p><p><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</p><p><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</p><p><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</p><p><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</p><p><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</p><p> </p><p> </p><p><strong>WHY CHOOSE US?</strong></p><ul><li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li><li>We refer our staff to recognized institutions for customer service training regularly</li><li>All our new employees must attend customer service training before commencing work</li><li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li><li>Most of our vehicles are new and in good condition with functioning air conditioners</li><li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li><li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li></ul><p> </p><p><strong>SERVICES OFFERED</strong></p><p><strong>TAXI / CAB</strong></p><p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p><p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p><p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p><p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p><p>Two way radio for effective communication</p><p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients<strong>CHARGES</strong></p><p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p><p><strong>HUMAN RESOURCE</strong></p><p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p><p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders</p><p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p><p>We carry the day’s newspaper in the back of each car</p><p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p><p>We carry an umbrella at the back of each car for our client’s use in rainy season</p><p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p></div>\n</div></div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:14:53", "2017-06-14 14:14:53", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("425", "1", "2017-06-14 18:18:13", "2017-06-14 14:18:13", "<div id=\"pl-425\"  class=\"panel-layout\" ><div id=\"pg-425-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-425-0\" ><div id=\"pgc-425-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-425-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#2d2d2d&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-425-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n<p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:18:14", "2017-06-14 14:18:14", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("426", "1", "2017-06-14 18:18:14", "2017-06-14 14:18:14", "<div id=\"pl-7\"  class=\"panel-layout\" ><div id=\"pg-7-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:&quot;&quot;,&quot;background_image&quot;:false,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" data-overlay-color=\"#000000\" class=\"panel-row-style panel-row-style-for-7-0\" ><div id=\"pgc-7-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-7-0-0-0\" class=\"so-panel widget widget_text panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;font_color&quot;:&quot;#2d2d2d&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-7-0-0-0\" ><h3 class=\"widget-title\">About Us</h3>			<div class=\"textwidget\"><p>Absolute Comfort Travel is a privately owned company established in 2016 in Nairobi. It is aimed at providing excellent car hire as well as cab services to companies as well as private individuals. Our office is located at Hurlingham, Silverpool Office Suite – Jabavu Lane, Nairobi</p>\n<p><strong>OUR MISSION</strong></p>\n<ul>\n<li>To create and deliver exceptional travel experiences for our customers by meeting and exceeding their expectations</li>\n<li>To add value by consistently providing reliable quality services to our customers</li>\n</ul>\n<p><strong>OUR VISION</strong></p>\n<p>To be recognized as the most respected and preferred partner in Kenya Travel Industry. We hope to achieve this by excelling in customer service and providing superior services at competitive rates</p>\n<p><strong>OUR CORE VALUES</strong></p>\n<ol>\n<li><strong>Customer Service Excellence:</strong> We are dedicated to satisfying customer needs and honoring commitments that we have made to them</li>\n<li><strong>Team Work:</strong> Our team is supportive of each other’s efforts, loyal to one another and care for each other both personally and professionally</li>\n<li><strong>Community and Environment:</strong> we strive to help and improve the communities where we work and live</li>\n<li><strong>Integrity:</strong> we act with honesty and integrity, not compromising the truth</li>\n<li><strong>Passion for results:</strong> we show pride, enthusiasm and dedication in everything that we do. We are committed to selling and delivering high quality products and services.</li>\n<li><strong>Respect:</strong> we treat our team members, customers, partners and suppliers with mutual respect and sensitivity recognizing the importance of diversity. We respect all individuals and value their contributions.</li>\n<li><strong>Open communication:</strong> All team members are encouraged to openly share their opinions and views.</li>\n</ol>\n<p><strong>WHY CHOOSE US?</strong></p>\n<ul>\n<li>We’re a young and fast growing company with a fleet of vehicles owned and leased, driven by competent and disciplined drivers</li>\n<li>We refer our staff to recognized institutions for customer service training regularly</li>\n<li>All our new employees must attend customer service training before commencing work</li>\n<li>The drivers and our dispatch team have also undergone special training on how to handle clients who are physically challenged</li>\n<li>Most of our vehicles are new and in good condition with functioning air conditioners</li>\n<li>Our drivers and dispatchers work in shifts to ensure that they are fresh and sober for quality customer handling</li>\n<li>Our office operates 24/7 to ensure efficient service delivery and to handle emergencies too</li>\n</ul>\n<p><strong>SERVICES OFFERED</strong></p>\n<p><strong>TAXI / CAB</strong></p>\n<p>We specialize in airport transfers, inter-office transfers and outstation services. Absolute Comfort Travel cab services are available in an hourly, daily, weekly and monthly basis</p>\n<p>Our commitment is to maintain the highest standard of safety for our customers at all times. Our sophisticated control room is able to take bookings in advance. This means that bookings are sometimes made in advance or sometimes just minutes prior to pick up</p>\n<p>Our chauffeurs are well trained in safe defensive driving. We are highly concerned with their hygiene and that of the vehicles. These vehicles are kept in immaculate condition, and are temperature controlled for your comfort. Moreover, the client has a choice of music, radio Station or silence characterized by a tranquil environment.</p>\n<p><strong>To enhance customer’s safety, excellent and timely services, the cars are fitted with:</strong></p>\n<p>Two way radio for effective communication</p>\n<p>Vehicle tracking and monitoring devices. These enable us to monitor and manage the fleet from the control room at our offices to ensure the safety and convenience of our clients</p>\n<p><strong>CHARGES</strong></p>\n<p>Our charges / tariffs are customized depending on the client’s needs. We Kindly request you to provide or contact us with the areas of your travel zones, we will discuss and provide you with our rates. We believe you will find them competitive</p>\n<p><strong>HUMAN RESOURCE</strong></p>\n<p>We consider our staff to be the most important asset in the company. The high morale of our staff bears testimony to a personnel policy that intrinsically joins the company’s growth to the career and personal development on individual staff. In-house as well as external training is encouraged and fully company supported.</p>\n<p>Employees integrity code of conduct and professional ethics are ingrained not only in our staff recruitment and engagements process but forms part and parcel of our everyday operations both within the company and in our engagement with other business stake holders.</p>\n<p>Our vehicles are kept in immaculate condition, are temperature controlled for your comfort and provide you with a silent tranquil environment. The client has a choice of music, radio station or silence</p>\n<p>We carry the day’s newspaper in the back of each car</p>\n<p>All our taxis come with 10in one car phone chargers covering most of the popular phone brands jus to ensure our clients don’t miss out on that important call as shown in the image below.</p>\n<p>We carry an umbrella at the back of each car for our client’s use in rainy season</p>\n<p>We promise to cooperate and ensure smooth and effective service delivery to the client.</p>\n</div>\n		</div></div></div></div></div></div>", "About us", "", "inherit", "closed", "closed", "", "7-revision-v1", "", "", "2017-06-14 18:18:14", "2017-06-14 14:18:14", "", "7", "http://localhost/actfinal/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("427", "1", "2017-06-14 19:02:02", "2017-06-14 15:02:02", "<div id=\"pl-147\"  class=\"panel-layout\" ><div id=\"pg-147-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-147-0\" ><div id=\"pgc-147-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-147-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\">\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	&nbsp;\n\nPlease take a minute to create an account with us for free and start booking your ride!\n\n<a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n\n&nbsp;</div>\n</div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-autosave-v1", "", "", "2017-06-14 19:02:02", "2017-06-14 15:02:02", "", "147", "http://localhost/actfinal/147-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("428", "1", "2017-06-14 18:46:53", "2017-06-14 14:46:53", "<p style=\"color: red; font-weight: bold;\">This page and the content has been automatically generated for you to give you a basic idea of how a \"Join Us\" page should look like. You can customize this page however you like it by editing this page from your WordPress page editor.</p>\r\n<p style=\"font-weight: bold;\">If you end up changing the URL of this page then make sure to update the URL value in the settings menu of the plugin.</p>\r\n<strong>Free Membership</strong>\r\n\r\nYou get unlimited access to free membership content\r\n\r\n<em><strong>Price: Free!</strong></em>\r\n\r\nLink the following image to go to the Registration Page if you want your visitors to be able to create a free membership account\r\n\r\n<a href=\" http://localhost/actfinal/membership-join/membership-registration/\">Create Your Free Account</a>\r\n<img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" />\r\n\r\n<strong>You can register for a Free Membership or pay for one of the following membership options</strong>\r\n\r\n[ ==&gt; Insert Payment Button For Your Paid Membership Levels Here &lt;== ]", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 18:46:53", "2017-06-14 14:46:53", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("429", "1", "2017-06-14 19:00:25", "2017-06-14 15:00:25", "&nbsp;\r\n\r\nPlease take a minute to create an account with us for free and start booking your ride!\r\n\r\n<a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\r\n\r\n\r\n&nbsp;", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 19:00:25", "2017-06-14 15:00:25", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("430", "1", "2017-06-14 19:02:16", "2017-06-14 15:02:16", "<div id=\"pl-430\"  class=\"panel-layout\" ><div id=\"pg-430-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-430-0\" ><div id=\"pgc-430-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-430-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-430-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p> </p><p> </p><p><a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p></div>\n</div></div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 19:02:16", "2017-06-14 15:02:16", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("431", "1", "2017-06-14 19:02:16", "2017-06-14 15:02:16", "<div id=\"pl-147\"  class=\"panel-layout\" ><div id=\"pg-147-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-147-0\" ><div id=\"pgc-147-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-147-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-147-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p> </p><p> </p><p><a href=\" http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p></div>\n</div></div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 19:02:16", "2017-06-14 15:02:16", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("433", "1", "2017-06-14 19:12:35", "2017-06-14 15:12:35", "[swpm_registration_form]", "Registration", "", "inherit", "closed", "closed", "", "148-revision-v1", "", "", "2017-06-14 19:12:35", "2017-06-14 15:12:35", "", "148", "http://localhost/actfinal/148-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("434", "1", "2017-06-14 21:28:18", "2017-06-14 17:28:18", "", "logo", "", "inherit", "open", "closed", "", "logo", "", "", "2017-06-14 21:28:18", "2017-06-14 17:28:18", "", "0", "http://localhost/actfinal/wp-content/uploads/2017/06/logo.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `act_posts` VALUES("435", "1", "2017-06-14 21:29:15", "2017-06-14 17:29:15", "{\n    \"sydney-child::site_logo\": {\n        \"value\": \"http://localhost/actfinal/wp-content/uploads/2017/06/logo.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "bb1eca1a-e276-420f-adc6-0d9d7fdb83f4", "", "", "2017-06-14 21:29:15", "2017-06-14 17:29:15", "", "0", "http://localhost/actfinal/bb1eca1a-e276-420f-adc6-0d9d7fdb83f4/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("436", "1", "2017-06-14 21:38:15", "2017-06-14 17:38:15", "{\n    \"sydney-child::slider_title_2\": {\n        \"value\": \"Travel with peace of mind\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_2\": {\n        \"value\": \"Two way radio for effective communication Vehicle tracking and monitoring devices\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_3\": {\n        \"value\": \"Comfort\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_3\": {\n        \"value\": \"We have new, clean Air conditioned vehicles\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_4\": {\n        \"value\": \"Safe\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_4\": {\n        \"value\": \"Our chauffeurs are well trained in safe defensive driving\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_title_5\": {\n        \"value\": \"Affordable\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::slider_subtitle_5\": {\n        \"value\": \"Our prices are very competitive\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "efbc68e0-eb2f-49d3-b862-cb224db80513", "", "", "2017-06-14 21:38:15", "2017-06-14 17:38:15", "", "0", "http://localhost/actfinal/?p=436", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("437", "1", "2017-06-14 22:08:20", "2017-06-14 18:08:20", "{\n    \"sydney-child::wrapper_top_padding\": {\n        \"value\": \"-15\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    },\n    \"sydney-child::wrapper_bottom_padding\": {\n        \"value\": \"-15\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "c78d8283-62ee-4168-9c88-dacdd1526316", "", "", "2017-06-14 22:08:20", "2017-06-14 18:08:20", "", "0", "http://localhost/actfinal/c78d8283-62ee-4168-9c88-dacdd1526316/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("441", "1", "2017-06-14 23:57:40", "2017-06-14 19:57:40", "<div id=\"pl-441\"  class=\"panel-layout\" ><div id=\"pg-441-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-441-0\" ><div id=\"pgc-441-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-441-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-441-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	&nbsp;\n\n&nbsp;\n\n<a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n&nbsp;</div>\n</div></div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 23:57:41", "2017-06-14 19:57:41", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("442", "1", "2017-06-14 23:57:41", "2017-06-14 19:57:41", "<div id=\"pl-147\"  class=\"panel-layout\" ><div id=\"pg-147-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-147-0\" ><div id=\"pgc-147-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-147-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-147-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	&nbsp;\n\n&nbsp;\n\n<a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a>\n\n&nbsp;</div>\n</div></div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-14 23:57:41", "2017-06-14 19:57:41", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("443", "1", "2017-06-15 00:01:00", "2017-06-14 20:01:00", "<div id=\"pl-147\"  class=\"panel-layout\" ><div id=\"pg-147-0\"  class=\"panel-grid panel-has-style\" ><div style=\"padding: 100px 0; \" data-overlay=\"true\" class=\"panel-row-style panel-row-style-for-147-0\" ><div id=\"pgc-147-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ><div id=\"panel-147-0-0-0\" class=\"so-panel widget widget_sow-editor panel-first-child panel-last-child\" data-index=\"0\" data-style=\"{&quot;background_image_attachment&quot;:false,&quot;background_display&quot;:&quot;tile&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;content_alignment&quot;:&quot;left&quot;,&quot;title_color&quot;:&quot;#443f3f&quot;,&quot;headings_color&quot;:&quot;#443f3f&quot;}\" ><div style=\"text-align: left;\" data-title-color=\"#443f3f\" data-headings-color=\"#443f3f\" class=\"panel-widget-style panel-widget-style-for-147-0-0-0\" ><div class=\"so-widget-sow-editor so-widget-sow-editor-base\"><h3 class=\"widget-title\">Please take a minute to create an account with us for free and start booking your ride!</h3>\n<div class=\"siteorigin-widget-tinymce textwidget\">\n	<p> </p><p> </p><p><a href=\"http://localhost/actfinal/membership-join/membership-registration/\"><img class=\"aligncenter\" title=\"Join Now\" src=\"http://localhost/actfinal/wp-content/plugins/simple-membership/images/join-now-button-image.gif\" alt=\"Join Now Button\" width=\"277\" height=\"82\" /></a></p><p> </p></div>\n</div></div></div></div></div></div></div>", "Join Us", "", "inherit", "closed", "closed", "", "147-revision-v1", "", "", "2017-06-15 00:01:00", "2017-06-14 20:01:00", "", "147", "http://localhost/actfinal/147-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("444", "1", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "[swpm_login_form]", "Member Login", "", "inherit", "closed", "closed", "", "149-revision-v1", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "149", "http://localhost/actfinal/149-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("445", "1", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "[swpm_reset_form]", "Password Reset", "", "inherit", "closed", "closed", "", "151-revision-v1", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "151", "http://localhost/actfinal/151-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("446", "1", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "[swpm_profile_form]", "Profile", "", "inherit", "closed", "closed", "", "150-revision-v1", "", "", "2017-06-15 01:30:02", "2017-06-14 21:30:02", "", "150", "http://localhost/actfinal/150-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("447", "1", "2017-06-15 01:48:11", "2017-06-14 21:48:11", "", "Login", "", "trash", "closed", "closed", "", "login-register__trashed", "", "", "2017-06-15 02:22:28", "2017-06-14 22:22:28", "", "0", "http://localhost/actfinal/?page_id=447", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("448", "1", "2017-06-15 01:48:12", "2017-06-14 21:48:12", "", "Login / Register", "", "inherit", "closed", "closed", "", "447-revision-v1", "", "", "2017-06-15 01:48:12", "2017-06-14 21:48:12", "", "447", "http://localhost/actfinal/447-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("449", "1", "2017-06-15 01:48:48", "2017-06-14 21:48:48", "", "My Profile", "", "trash", "closed", "closed", "", "my-profile__trashed", "", "", "2017-06-15 02:22:29", "2017-06-14 22:22:29", "", "0", "http://localhost/actfinal/?page_id=449", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("450", "1", "2017-06-15 01:48:48", "2017-06-14 21:48:48", "", "My Profile", "", "inherit", "closed", "closed", "", "449-revision-v1", "", "", "2017-06-15 01:48:48", "2017-06-14 21:48:48", "", "449", "http://localhost/actfinal/449-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("451", "1", "2017-06-15 01:49:24", "2017-06-14 21:49:24", "", "Login", "", "inherit", "closed", "closed", "", "447-revision-v1", "", "", "2017-06-15 01:49:24", "2017-06-14 21:49:24", "", "447", "http://localhost/actfinal/447-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("452", "1", "2017-06-15 01:49:40", "2017-06-14 21:49:40", "", "Register", "", "trash", "closed", "closed", "", "register__trashed-2", "", "", "2017-06-15 02:22:29", "2017-06-14 22:22:29", "", "0", "http://localhost/actfinal/?page_id=452", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("453", "1", "2017-06-15 01:49:41", "2017-06-14 21:49:41", "", "Register", "", "inherit", "closed", "closed", "", "452-revision-v1", "", "", "2017-06-15 01:49:41", "2017-06-14 21:49:41", "", "452", "http://localhost/actfinal/452-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("459", "1", "2017-06-15 03:14:08", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2017-06-15 03:14:08", "0000-00-00 00:00:00", "", "0", "http://localhost/actfinal/?p=459", "0", "post", "", "0");
INSERT INTO `act_posts` VALUES("462", "1", "2017-06-15 10:54:25", "2017-06-15 06:54:25", "[client-portal]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-15 10:54:25", "2017-06-15 06:54:25", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("464", "1", "2017-06-15 11:00:39", "2017-06-15 07:00:39", "", "Default Registration", "", "publish", "closed", "closed", "", "default-registration", "", "", "2017-06-15 11:00:39", "2017-06-15 07:00:39", "", "0", "http://localhost/actfinal/um_form/default-registration/", "0", "um_form", "", "0");
INSERT INTO `act_posts` VALUES("465", "1", "2017-06-15 11:00:39", "2017-06-15 07:00:39", "", "Default Login", "", "publish", "closed", "closed", "", "default-login", "", "", "2017-06-15 11:00:39", "2017-06-15 07:00:39", "", "0", "http://localhost/actfinal/um_form/default-login/", "0", "um_form", "", "0");
INSERT INTO `act_posts` VALUES("466", "1", "2017-06-15 11:00:40", "2017-06-15 07:00:40", "", "Default Profile", "", "publish", "closed", "closed", "", "default-profile", "", "", "2017-06-15 11:00:40", "2017-06-15 07:00:40", "", "0", "http://localhost/actfinal/um_form/default-profile/", "0", "um_form", "", "0");
INSERT INTO `act_posts` VALUES("467", "1", "2017-06-15 11:00:40", "2017-06-15 07:00:40", "", "Members", "", "publish", "closed", "closed", "", "members", "", "", "2017-06-15 11:00:40", "2017-06-15 07:00:40", "", "0", "http://localhost/actfinal/um_directory/members/", "0", "um_directory", "", "0");
INSERT INTO `act_posts` VALUES("468", "1", "2017-06-15 11:00:41", "2017-06-15 07:00:41", "[ultimatemember form_id=466]", "User", "", "trash", "closed", "closed", "", "user__trashed", "", "", "2017-06-15 11:46:11", "2017-06-15 07:46:11", "", "0", "http://localhost/actfinal/user/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("469", "1", "2017-06-15 11:00:42", "2017-06-15 07:00:42", "[ultimatemember form_id=466]", "User", "", "inherit", "closed", "closed", "", "468-revision-v1", "", "", "2017-06-15 11:00:42", "2017-06-15 07:00:42", "", "468", "http://localhost/actfinal/468-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("470", "1", "2017-06-15 11:00:42", "2017-06-15 07:00:42", "[ultimatemember form_id=465]", "Login", "", "trash", "closed", "closed", "", "login__trashed", "", "", "2017-06-15 11:45:58", "2017-06-15 07:45:58", "", "0", "http://localhost/actfinal/login/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("471", "1", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "[ultimatemember form_id=465]", "Login", "", "inherit", "closed", "closed", "", "470-revision-v1", "", "", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "", "470", "http://localhost/actfinal/470-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("472", "1", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "[ultimatemember form_id=464]", "Register", "", "trash", "closed", "closed", "", "register__trashed-3", "", "", "2017-06-15 11:45:59", "2017-06-15 07:45:59", "", "0", "http://localhost/actfinal/register/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("473", "1", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "[ultimatemember form_id=464]", "Register", "", "inherit", "closed", "closed", "", "472-revision-v1", "", "", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "", "472", "http://localhost/actfinal/472-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("474", "1", "2017-06-15 11:00:43", "2017-06-15 07:00:43", "[ultimatemember form_id=467]", "Members", "", "trash", "closed", "closed", "", "members__trashed", "", "", "2017-06-15 11:45:59", "2017-06-15 07:45:59", "", "0", "http://localhost/actfinal/members/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("475", "1", "2017-06-15 11:00:44", "2017-06-15 07:00:44", "[ultimatemember form_id=467]", "Members", "", "inherit", "closed", "closed", "", "474-revision-v1", "", "", "2017-06-15 11:00:44", "2017-06-15 07:00:44", "", "474", "http://localhost/actfinal/474-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("476", "1", "2017-06-15 11:00:44", "2017-06-15 07:00:44", "", "Logout", "", "trash", "closed", "closed", "", "logout__trashed", "", "", "2017-06-15 11:45:59", "2017-06-15 07:45:59", "", "0", "http://localhost/actfinal/logout/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("477", "1", "2017-06-15 11:00:44", "2017-06-15 07:00:44", "", "Logout", "", "inherit", "closed", "closed", "", "476-revision-v1", "", "", "2017-06-15 11:00:44", "2017-06-15 07:00:44", "", "476", "http://localhost/actfinal/476-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("478", "1", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "[ultimatemember_account]", "Account", "", "trash", "closed", "closed", "", "account__trashed-2", "", "", "2017-06-15 11:45:58", "2017-06-15 07:45:58", "", "0", "http://localhost/actfinal/account/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("479", "1", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "[ultimatemember_account]", "Account", "", "inherit", "closed", "closed", "", "478-revision-v1", "", "", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "", "478", "http://localhost/actfinal/478-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("480", "1", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "[ultimatemember_password]", "Password Reset", "", "trash", "closed", "closed", "", "password-reset__trashed", "", "", "2017-06-15 11:45:59", "2017-06-15 07:45:59", "", "0", "http://localhost/actfinal/password-reset/", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("481", "1", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "[ultimatemember_password]", "Password Reset", "", "inherit", "closed", "closed", "", "480-revision-v1", "", "", "2017-06-15 11:00:45", "2017-06-15 07:00:45", "", "480", "http://localhost/actfinal/480-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("482", "1", "2017-06-15 11:00:47", "2017-06-15 07:00:47", "", "Admin", "", "publish", "closed", "closed", "", "admin", "", "", "2017-06-15 11:00:47", "2017-06-15 07:00:47", "", "0", "http://localhost/actfinal/um_role/admin/", "0", "um_role", "", "0");
INSERT INTO `act_posts` VALUES("483", "1", "2017-06-15 11:00:47", "2017-06-15 07:00:47", "", "Member", "", "publish", "closed", "closed", "", "member", "", "", "2017-06-15 11:09:53", "2017-06-15 07:09:53", "", "0", "http://localhost/actfinal/um_role/member/", "0", "um_role", "", "0");
INSERT INTO `act_posts` VALUES("484", "1", "2017-06-15 11:11:13", "0000-00-00 00:00:00", "", "User Registration", "", "draft", "closed", "closed", "", "", "", "", "2017-06-15 11:11:13", "2017-06-15 07:11:13", "", "0", "http://localhost/actfinal/?post_type=um_form&#038;p=484", "0", "um_form", "", "0");
INSERT INTO `act_posts` VALUES("485", "1", "2017-06-15 11:30:08", "2017-06-15 07:30:08", "", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-15 11:30:08", "2017-06-15 07:30:08", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("488", "1", "2017-06-15 12:05:49", "2017-06-15 08:05:49", "[pms-register]", "Register", "", "trash", "closed", "closed", "", "register__trashed-4", "", "", "2017-06-15 12:37:01", "2017-06-15 08:37:01", "", "0", "http://localhost/actfinal/?page_id=488", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("489", "1", "2017-06-15 12:05:49", "2017-06-15 08:05:49", "[pms-register]", "Register", "", "inherit", "closed", "closed", "", "488-revision-v1", "", "", "2017-06-15 12:05:49", "2017-06-15 08:05:49", "", "488", "http://localhost/actfinal/488-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("490", "1", "2017-06-15 12:07:10", "2017-06-15 08:07:10", "[pms-account]", "Account", "", "trash", "closed", "closed", "", "account__trashed-3", "", "", "2017-06-15 12:37:01", "2017-06-15 08:37:01", "", "0", "http://localhost/actfinal/?page_id=490", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("491", "1", "2017-06-15 12:07:10", "2017-06-15 08:07:10", "[pms-account]", "Account", "", "inherit", "closed", "closed", "", "490-revision-v1", "", "", "2017-06-15 12:07:10", "2017-06-15 08:07:10", "", "490", "http://localhost/actfinal/490-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("492", "1", "2017-06-15 12:10:22", "2017-06-15 08:10:22", "[pms-login]", "Login", "", "trash", "closed", "closed", "", "login__trashed-2", "", "", "2017-06-15 12:37:01", "2017-06-15 08:37:01", "", "0", "http://localhost/actfinal/?page_id=492", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("493", "1", "2017-06-15 12:10:22", "2017-06-15 08:10:22", "[pms-login]", "Login", "", "inherit", "closed", "closed", "", "492-revision-v1", "", "", "2017-06-15 12:10:22", "2017-06-15 08:10:22", "", "492", "http://localhost/actfinal/492-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("494", "1", "2017-06-15 12:11:54", "2017-06-15 08:11:54", "{\n    \"sydney-child::body_text_color\": {\n        \"value\": \"#565656\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1\n    }\n}", "", "", "trash", "closed", "closed", "", "d2a6c959-c49e-49eb-b102-8007ad9def90", "", "", "2017-06-15 12:11:54", "2017-06-15 08:11:54", "", "0", "http://localhost/actfinal/d2a6c959-c49e-49eb-b102-8007ad9def90/", "0", "customize_changeset", "", "0");
INSERT INTO `act_posts` VALUES("506", "1", "2017-06-15 14:06:20", "2017-06-15 10:06:20", "", "Login", "", "publish", "closed", "closed", "", "login", "", "", "2017-06-15 14:06:20", "2017-06-15 10:06:20", "", "0", "http://localhost/actfinal/?page_id=506", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("507", "1", "2017-06-15 14:06:20", "2017-06-15 10:06:20", "", "Login", "", "inherit", "closed", "closed", "", "506-revision-v1", "", "", "2017-06-15 14:06:20", "2017-06-15 10:06:20", "", "506", "http://localhost/actfinal/506-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("508", "1", "2017-06-15 14:06:40", "2017-06-15 10:06:40", "", "Register", "", "publish", "closed", "closed", "", "register", "", "", "2017-06-15 14:06:40", "2017-06-15 10:06:40", "", "0", "http://localhost/actfinal/?page_id=508", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("509", "1", "2017-06-15 14:06:40", "2017-06-15 10:06:40", "", "Register", "", "inherit", "closed", "closed", "", "508-revision-v1", "", "", "2017-06-15 14:06:40", "2017-06-15 10:06:40", "", "508", "http://localhost/actfinal/508-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("510", "1", "2017-06-15 14:06:58", "2017-06-15 10:06:58", "", "Profile", "", "publish", "closed", "closed", "", "profile", "", "", "2017-06-15 14:06:58", "2017-06-15 10:06:58", "", "0", "http://localhost/actfinal/?page_id=510", "0", "page", "", "0");
INSERT INTO `act_posts` VALUES("511", "1", "2017-06-15 14:06:58", "2017-06-15 10:06:58", "", "Profile", "", "inherit", "closed", "closed", "", "510-revision-v1", "", "", "2017-06-15 14:06:58", "2017-06-15 10:06:58", "", "510", "http://localhost/actfinal/510-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("512", "1", "2017-06-15 14:23:06", "2017-06-15 10:23:06", "<div id=\"pl-11\"  class=\"panel-layout\" ><div id=\"pg-11-0\"  class=\"panel-grid panel-has-style\"  data-style=\"{&quot;background&quot;:&quot;#ffffff&quot;,&quot;row_stretch&quot;:&quot;full&quot;,&quot;cell_alignment&quot;:&quot;flex-start&quot;,&quot;iw-visible-screen&quot;:&quot;iw-all&quot;,&quot;iw-visible-layout&quot;:&quot;iw-all&quot;,&quot;align&quot;:true,&quot;overlay&quot;:&quot;&quot;,&quot;overlay_color&quot;:&quot;#000000&quot;}\" ><div class=\"siteorigin-panels-stretch panel-row-style panel-row-style-for-11-0\" style=\"text-align: center;padding: 100px 0; \" data-stretch-type=\"full\" data-overlay=\"true\" data-overlay-color=\"#000000\" ><div id=\"pgc-11-0-0\"  class=\"panel-grid-cell\"  data-weight=\"1\" ></div></div></div></div>", "Contact Us", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2017-06-15 14:23:06", "2017-06-15 10:23:06", "", "11", "http://localhost/actfinal/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `act_posts` VALUES("513", "1", "2017-06-15 15:24:07", "2017-06-15 11:24:07", "[ea_bootstrap width=\"800px\" scroll_off=\"true\" layout_cols=\"2\"]", "Online Booking", "", "inherit", "closed", "closed", "", "9-revision-v1", "", "", "2017-06-15 15:24:07", "2017-06-15 11:24:07", "", "9", "http://localhost/actfinal/9-revision-v1/", "0", "revision", "", "0");

/* INSERT TABLE DATA: act_rc_currencies */
INSERT INTO `act_rc_currencies` VALUES("1", "Pound Sterling", "GBP", "", "&pound;", "2", "0.61940000", "2017-06-08 10:25:47", "2017-06-08 10:25:47", "1", "0");
INSERT INTO `act_rc_currencies` VALUES("2", "US Dollar", "USD", "$", "", "2", "1.00000000", "2017-06-08 10:25:47", "2017-06-08 10:25:47", "1", "0");
INSERT INTO `act_rc_currencies` VALUES("3", "Euro", "EUR", "", "&euro;", "2", "0.70320000", "2017-06-08 10:25:47", "2017-06-08 10:25:47", "1", "0");

/* INSERT TABLE DATA: act_swpm_membership_tbl */
INSERT INTO `act_swpm_membership_tbl` VALUES("1", "Content Protection", "administrator", "15", "0", "0", NULL, NULL, "N;", "a:1:{i:0;i:9;}", "N;", "N;", "N;", "a:0:{}", NULL, NULL, "0", "");
INSERT INTO `act_swpm_membership_tbl` VALUES("2", "individual", "subscriber", "63", "", "0", NULL, NULL, "N;", "a:1:{i:0;i:9;}", "N;", "N;", "N;", "N;", NULL, NULL, "0", "");
INSERT INTO `act_swpm_membership_tbl` VALUES("3", "Corporate", "subscriber", "0", "", "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "0", "");

/* INSERT TABLE DATA: act_term_relationships */
INSERT INTO `act_term_relationships` VALUES("1", "1", "0");
INSERT INTO `act_term_relationships` VALUES("24", "2", "0");
INSERT INTO `act_term_relationships` VALUES("25", "2", "0");
INSERT INTO `act_term_relationships` VALUES("26", "2", "0");
INSERT INTO `act_term_relationships` VALUES("27", "2", "0");
INSERT INTO `act_term_relationships` VALUES("28", "3", "0");
INSERT INTO `act_term_relationships` VALUES("29", "3", "0");
INSERT INTO `act_term_relationships` VALUES("30", "3", "0");
INSERT INTO `act_term_relationships` VALUES("31", "3", "0");
INSERT INTO `act_term_relationships` VALUES("77", "4", "0");
INSERT INTO `act_term_relationships` VALUES("79", "4", "0");
INSERT INTO `act_term_relationships` VALUES("81", "4", "0");
INSERT INTO `act_term_relationships` VALUES("127", "4", "0");
INSERT INTO `act_term_relationships` VALUES("129", "4", "0");
INSERT INTO `act_term_relationships` VALUES("156", "5", "0");
INSERT INTO `act_term_relationships` VALUES("157", "5", "0");
INSERT INTO `act_term_relationships` VALUES("158", "5", "0");
INSERT INTO `act_term_relationships` VALUES("468", "1", "0");
INSERT INTO `act_term_relationships` VALUES("470", "1", "0");
INSERT INTO `act_term_relationships` VALUES("472", "1", "0");
INSERT INTO `act_term_relationships` VALUES("474", "1", "0");
INSERT INTO `act_term_relationships` VALUES("476", "1", "0");
INSERT INTO `act_term_relationships` VALUES("478", "1", "0");
INSERT INTO `act_term_relationships` VALUES("480", "1", "0");

/* INSERT TABLE DATA: act_term_taxonomy */
INSERT INTO `act_term_taxonomy` VALUES("1", "1", "category", "", "0", "2");
INSERT INTO `act_term_taxonomy` VALUES("2", "2", "nav_menu", "", "0", "4");
INSERT INTO `act_term_taxonomy` VALUES("3", "3", "nav_menu", "", "0", "4");
INSERT INTO `act_term_taxonomy` VALUES("4", "4", "category", "", "0", "5");
INSERT INTO `act_term_taxonomy` VALUES("5", "5", "category", "", "0", "3");

/* INSERT TABLE DATA: act_terms */
INSERT INTO `act_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `act_terms` VALUES("2", "primary", "primary", "0");
INSERT INTO `act_terms` VALUES("3", "footer", "footer", "0");
INSERT INTO `act_terms` VALUES("4", "slider", "slider", "0");
INSERT INTO `act_terms` VALUES("5", "services", "services", "0");

/* INSERT TABLE DATA: act_usermeta */
INSERT INTO `act_usermeta` VALUES("1", "1", "nickname", "actjennifer");
INSERT INTO `act_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `act_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `act_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `act_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `act_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `act_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `act_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `act_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `act_usermeta` VALUES("10", "1", "locale", "");
INSERT INTO `act_usermeta` VALUES("11", "1", "act_capabilities", "a:14:{s:13:\"administrator\";b:1;s:15:\"membershipadmin\";b:1;s:24:\"membershipadmindashboard\";b:1;s:22:\"membershipadminmembers\";b:1;s:21:\"membershipadminlevels\";b:1;s:28:\"membershipadminsubscriptions\";b:1;s:22:\"membershipadmincoupons\";b:1;s:24:\"membershipadminpurchases\";b:1;s:29:\"membershipadmincommunications\";b:1;s:21:\"membershipadmingroups\";b:1;s:20:\"membershipadminpings\";b:1;s:23:\"membershipadmingateways\";b:1;s:22:\"membershipadminoptions\";b:1;s:32:\"membershipadminupdatepermissions\";b:1;}");
INSERT INTO `act_usermeta` VALUES("12", "1", "act_user_level", "10");
INSERT INTO `act_usermeta` VALUES("13", "1", "dismissed_wp_pointers", "");
INSERT INTO `act_usermeta` VALUES("14", "1", "show_welcome_panel", "1");
INSERT INTO `act_usermeta` VALUES("16", "1", "act_dashboard_quick_press_last_post_id", "459");
INSERT INTO `act_usermeta` VALUES("17", "1", "itsec_user_activity_last_seen", "1497475188");
INSERT INTO `act_usermeta` VALUES("19", "1", "_yoast_wpseo_profile_updated", "1497137663");
INSERT INTO `act_usermeta` VALUES("20", "1", "managenav-menuscolumnshidden", "a:5:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";i:4;s:15:\"title-attribute\";}");
INSERT INTO `act_usermeta` VALUES("21", "1", "metaboxhidden_nav-menus", "a:1:{i:0;s:12:\"add-post_tag\";}");
INSERT INTO `act_usermeta` VALUES("22", "1", "nav_menu_recently_edited", "2");
INSERT INTO `act_usermeta` VALUES("23", "1", "act_user-settings", "libraryContent=browse&editor=html");
INSERT INTO `act_usermeta` VALUES("24", "1", "act_user-settings-time", "1497514521");
INSERT INTO `act_usermeta` VALUES("25", "1", "active", "1");
INSERT INTO `act_usermeta` VALUES("26", "1", "membership_permissions_updated", "yes");
INSERT INTO `act_usermeta` VALUES("27", "1", "googleplus", "");
INSERT INTO `act_usermeta` VALUES("28", "1", "twitter", "");
INSERT INTO `act_usermeta` VALUES("29", "1", "facebook", "");
INSERT INTO `act_usermeta` VALUES("30", "1", "ms_custom_data", "a:0:{}");
INSERT INTO `act_usermeta` VALUES("31", "1", "ms_email", "absolutecomfortkenya@gmail.com");
INSERT INTO `act_usermeta` VALUES("32", "1", "ms_first_name", "");
INSERT INTO `act_usermeta` VALUES("33", "1", "ms_gateway_profiles", "a:0:{}");
INSERT INTO `act_usermeta` VALUES("34", "1", "ms_id", "1");
INSERT INTO `act_usermeta` VALUES("35", "1", "ms_is_member", "1");
INSERT INTO `act_usermeta` VALUES("36", "1", "ms_last_name", "");
INSERT INTO `act_usermeta` VALUES("37", "1", "ms_name", "actjennifer");
INSERT INTO `act_usermeta` VALUES("38", "1", "ms_subscriptions", "a:0:{}");
INSERT INTO `act_usermeta` VALUES("39", "1", "ms_username", "actjennifer");
INSERT INTO `act_usermeta` VALUES("40", "1", "session_tokens", "a:2:{s:64:\"10945c1209f8c72d3eee05941ee90a7698ee06409780f387c5ecd8c498424cd3\";a:4:{s:10:\"expiration\";i:1498125384;s:2:\"ip\";s:3:\"::1\";s:2:\"ua\";s:65:\"Mozilla/5.0 (Windows NT 6.1; rv:53.0) Gecko/20100101 Firefox/53.0\";s:5:\"login\";i:1496915784;}s:64:\"6845c04220a2aad1d74ecd8298feb0bc7524e7304fe265ae9d4cf45853c0f87b\";a:4:{s:10:\"expiration\";i:1498554099;s:2:\"ip\";s:3:\"::1\";s:2:\"ua\";s:102:\"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36\";s:5:\"login\";i:1497344499;}}");
INSERT INTO `act_usermeta` VALUES("41", "2", "nickname", "xyz@mail.com");
INSERT INTO `act_usermeta` VALUES("42", "2", "first_name", "");
INSERT INTO `act_usermeta` VALUES("43", "2", "last_name", "");
INSERT INTO `act_usermeta` VALUES("44", "2", "description", "");
INSERT INTO `act_usermeta` VALUES("45", "2", "rich_editing", "true");
INSERT INTO `act_usermeta` VALUES("46", "2", "comment_shortcuts", "false");
INSERT INTO `act_usermeta` VALUES("47", "2", "admin_color", "fresh");
INSERT INTO `act_usermeta` VALUES("48", "2", "use_ssl", "0");
INSERT INTO `act_usermeta` VALUES("49", "2", "show_admin_bar_front", "true");
INSERT INTO `act_usermeta` VALUES("50", "2", "locale", "");
INSERT INTO `act_usermeta` VALUES("51", "2", "act_capabilities", "a:1:{s:10:\"subscriber\";b:1;}");
INSERT INTO `act_usermeta` VALUES("52", "2", "act_user_level", "0");
INSERT INTO `act_usermeta` VALUES("53", "2", "_yoast_wpseo_profile_updated", "1496998249");
INSERT INTO `act_usermeta` VALUES("54", "2", "dismissed_wp_pointers", "");
INSERT INTO `act_usermeta` VALUES("55", "1", "community-events-location", "a:1:{s:2:\"ip\";s:2:\"::\";}");
INSERT INTO `act_usermeta` VALUES("56", "1", "so_panels_directory_enabled", "1");
INSERT INTO `act_usermeta` VALUES("57", "1", "act_media_library_mode", "grid");
INSERT INTO `act_usermeta` VALUES("58", "1", "itsec-settings-view", "grid");
INSERT INTO `act_usermeta` VALUES("59", "1", "account_status", "approved");
INSERT INTO `act_usermeta` VALUES("60", "1", "role", "admin");
INSERT INTO `act_usermeta` VALUES("61", "2", "account_status", "approved");
INSERT INTO `act_usermeta` VALUES("62", "2", "role", "member");
INSERT INTO `act_usermeta` VALUES("63", "1", "closedpostboxes_um_role", "a:1:{i:0;s:19:\"um-admin-form-login\";}");
INSERT INTO `act_usermeta` VALUES("64", "1", "metaboxhidden_um_role", "a:1:{i:0;s:7:\"slugdiv\";}");
INSERT INTO `act_usermeta` VALUES("65", "1", "um_account_secure_fields", "a:0:{}");

/* INSERT TABLE DATA: act_users */
INSERT INTO `act_users` VALUES("1", "actjennifer", "$P$B3stafisQpvJxU1TKmK7K9sovuIkle1", "actjennifer", "absolutecomfortkenya@gmail.com", "", "2017-05-30 21:16:38", "", "0", "actjennifer");
INSERT INTO `act_users` VALUES("2", "xyz@mail.com", "$P$B7URUvvIDT1QYoDkvXLzaBkdaISf4Z1", "xyzmail-com", "xyz@mail.com", "", "2017-06-09 08:50:48", "", "0", "xyz@mail.com");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2017-06-15 12:07:55*/
/* DUPLICATOR_MYSQLDUMP_EOF */
